//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//
define(function (require, exports, module) {
	'use strict';

	require('ft/util/environment').applicationName = 'TaskPaper';
	
	require('ft/taxonomy/taskpapertaxonomy');

	var Extensions = require('ft/core/extensions').Extensions,
		Taxonomies = require('ft/core/taxonomies'),
		taxonomy = Taxonomies.taxonomy({}, 'taskpaper');

	require('ft/modes/todo/todomode')(
		function(node) {
			return node.type() === 'task';
		},
		function (tree) {
			return tree.createNode('Archive:');
		}
	);

	require('./app').app(taxonomy, '');

	Extensions.addCommand({
		name: 'today',
		description: 'Toggle @today tag for selected lines.',
		performCommand: function (editor) {
			editor.toggleTag('today');
		}
	});
});