//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//
define(function (require, exports, module) {
    'use strict';

	require('ft/util/environment').applicationName = 'WriteRoom';

	require('ft/extensions/wordcount');
	require('ft/extensions/typewriter');
	require('ft/taxonomy/markdown');	
	require('ft/taxonomy/markdowntaxonomy');
	require('ft/taxonomy/helpers/headingfoldhelper');

	var writeRoomStyles = require('components/text/text!./writeroom.less'),
		Extensions = require('ft/core/extensions').Extensions,
		Taxonomies = require('ft/core/taxonomies'),
		taxonomy = Taxonomies.taxonomy({
			foldingtext: false,
			multimarkdown: true,
			gitmarkdown: true,
			criticMarkup: true
		}, 'markdown');

	require('./app').app(taxonomy, writeRoomStyles);
});