//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//
define(function (require, exports, module) {
    'use strict';

	require('ft/util/environment').applicationName = 'FoldingText';

	require('ft/extensions/wordcount');
	require('ft/extensions/typewriter');
	require('ft/extensions/showlistbullets');
	//require('ft/extensions/showoutlineview');
	require('ft/taxonomy/markdown');
	require('ft/taxonomy/markdowntaxonomy');
	require('ft/taxonomy/helpers/headingfoldhelper');

	require('ft/extensions/showlistbullets')(
		function(node) {
			return node.type() === 'unordered' && node.modeContext() !== 'todo';
		}
	);


	require('ft/modes/todo/todomode');
	require('ft/modes/clock/clockmode');
	require('ft/modes/timer/timermode');

	var foldingTextStyles = require('components/text/text!./foldingtext.less'),
		Extensions = require('ft/core/extensions').Extensions,
		Taxonomies = require('ft/core/taxonomies'),
		taxonomy = Taxonomies.taxonomy({
			foldingtext: true,
			multimarkdown: true,
			gitmarkdown: true,
			criticMarkup: true
		}, 'markdown');

	require('./app').app(taxonomy, foldingTextStyles);
});