define(function (require, exports, module) {
	'use strict';

	var Extensions = require('ft/core/extensions').Extensions;

	Extensions.addCommand({
		name: 'encode URI',
		description: 'Encode the selected URI.',
		performCommand: function (editor, options) {
			var text = editor.selectedText(),
				encodedText = encodeURI(text);
			editor.replaceSelection(encodedText, 'around');
		}
	});

	Extensions.addCommand({
		name: 'decode URI',
		description: 'Decode the selected URI.',
		performCommand: function (editor, options) {
			var text = editor.selectedText(),
				decodedText = decodeURI(text);
			editor.replaceSelection(decodedText, 'around');
		}
	});

	Extensions.addCommand({
		name: 'encode URI component',
		description: 'Encode the selected URI component.',
		performCommand: function (editor, options) {
			var text = editor.selectedText(),
				encodedText = encodeURIComponent(text);
			editor.replaceSelection(encodedText, 'around');
		}
	});

	Extensions.addCommand({
		name: 'decode URI component',
		description: 'Decode the selected URI component.',
		performCommand: function (editor, options) {
			var text = editor.selectedText(),
				decodedText = decodeURIComponent(text);
			editor.replaceSelection(decodedText, 'around');
		}
	});
});