define(function (require, exports, module) {
	'use strict';

	require('ft/extensions/moveparagraph');

	var Extensions = require('ft/core/extensions').Extensions,
		Folding = require('ft/extensions/folding');

	function smartInsertTab(editor) {
		var tree = editor.tree(),
			selectedRange = editor.selectedRange(),
			selectionCollapsed = selectedRange.isCollapsed(),
			node = selectedRange.startNode,
			lead = node.tree.taxonomy.matchLeadForNode(node)[0];

		if (editor.performCommand('replaceTextSnippet')) {
			return;
		}

		if (!selectionCollapsed || selectedRange.startOffset <= lead.length) {
			editor.performCommand('moveParagraphsRight');
		} else {
			editor.replaceSelection('\t', 'end', '+input');
		}
	}

	Extensions.addCommand({
		name: 'smartInsertTab',
		performCommand: smartInsertTab
	});
});