define(function (require, exports, module) {
	'use strict';

	var Extensions = require('ft/core/extensions').Extensions;

	//
	// Not added to source right now
	// 
	
	function updateLinguisticTagger(location, replacedText, insertedText) {
		if (window.nativeViewController) {
			console.log('location: ' + location);
			console.log('length: ' + replacedText.length);
			console.log('insertedText: ' + insertedText);
			console.log('replacedText: ' + replacedText);
			window.nativeViewController.javascriptReplaceTextInRange_location_cat_(insertedText, location, replacedText.length);
		}
	}

	Extensions.addInit(function (editor) {
		updateLinguisticTagger(0, '', editor.textContent());
	});

	Extensions.addTreeChanged(function (editor, e) {
		var deltas = e.deltas,
			deletasLength = deltas.length;
		for (var i = 0; i < deletasLength; i++) {
			var eachDelta = deltas[i];
			if (eachDelta.textChanged()) {
				updateLinguisticTagger(eachDelta.location, eachDelta.replacedText, eachDelta.insertedText);
			}
		}
	});

	Extensions.add('com.foldingtext.editor.methods', {
		sentanceRangeForRange: function (range) {
			if (window.nativeViewController) {
				var rangeTupleJSON = window.nativeViewController.javascriptSentanceRangeForRange_length_(range.location(), range.length());
				if (rangeTupleJSON) {
					var rangeTuple = JSON.parse(rangeTupleJSON);
					return this.tree().createRangeFromLocation(rangeTuple.location, rangeTuple.length);
				}
			}
			return range.copy();
		}
	});	
});