define(function (require, exports, module) {
	'use strict';

	var printTemplate = require('components/text/text!./print.html.template'),
		Extensions = require('ft/core/extensions').Extensions,
		Theme = require('ft/editor/theme'),
		dom = require('ft/util/dom');

	function getHTMLForPrintImplementation(editor) {
		var originalMargin = editor.option('viewportMargin'),
			originalPadBottom = editor.option('padBottom'),
			tree = editor.tree(),
			styleText,
			bodyText;

		tree.ensureClassified();
		styleText = Theme.readCSS();
		editor.cm().setOption('viewportMargin', Infinity);
		editor.setOption('padBottom', false);
		bodyText = editor.cm().getWrapperElement().outerHTML;
		editor.cm().setOption('viewportMargin', originalMargin);
		editor.setOption('padBottom', originalPadBottom);

		var html = printTemplate;
		html = html.replace('STYLE', styleText);
		html = html.replace('BODY', bodyText);
		return html;
	}

	/*Extensions.addCommand({
		name: 'print',
		performCommand: function (editor) {
			// Make sure that HTMLForPrint is called with no codemirror operations in place so that when
			// viewportMargin is set the DOM immediatly updates, instead of waiting for the end of the
			// event loop.
			window.setTimeout(function () {
				var html = getHTMLForPrintImplementation(editor);
				if (window.nativeViewController) {
					window.nativeViewController.javascriptPrintHTML_(html);
				}
			}, 0);
		}
	});*/

	Extensions.addInit(function (editor) {
		window.getHTMLForPrint = function getHTMLForPrint() {
			return getHTMLForPrintImplementation(editor);
		};
		/*editor.addKeyMap({
			'Cmd-P' : 'print'
		});*/
	});
});