define(function (require, exports, module) {
	'use strict';

	require('ft/util/parallel');

	var Extensions = require('ft/core/extensions').Extensions,
		element;

	function updateDisplay(editor) {
		if (editor.option('showOutlineView')) {
			if (!element) {
				element = document.createElement('ul');
				element.className = 'outlineView';
				document.body.appendChild(element);
			}

			element.innerHTML = '';

			var headings = editor.tree().evaluateNodePath('//heading'),
				length = headings.length;

			for (var i = 0; i < length; i++) {
				var eachElement = document.createElement('li'),
					eachHeading = headings[i];
				eachElement.id = 'outlineView-' + eachElement.id;
				eachElement.style.marginLeft = (eachHeading.typeIndentLevel() * 2) + 'ch';
				eachElement.textContent = eachHeading.text();
				element.appendChild(eachElement);

				// single clikc on item should unfocus and go to that view
				// double clikc on item should focus.
			}
		} else if (element) {
			element.parentNode.removeChild(element);
			element = null;
		}
	}



	/*jshint multistr:true */
/*	Extensions.add('com.foldingtext.editor.styles',
		'.outlineView {\
			padding: 0;\
			max-width: 200px;\
			list-style-type: none;\
			position: fixed;\
			top: 1ch;\
			left: 1ch;\
			color: mix(@textColor, @paperColor, 35%);\
			overflow: hidden;\
			li {\
				.truncate(24ch);\
				.interactive-interface-element;\
			}\
		}'
	);*/
	/*jshint multistr:false */

	Extensions.addInit(function (editor) {
		updateDisplay(editor);
	});

	Extensions.addTreeChanged(function (editor, e) {
		updateDisplay(editor);
	});

	Extensions.add('com.foldingtext.editor.options', {
		name: 'showOutlineView',
		defaultValue: true,
		onChange: function (editor, oldValue, newValue) {
			updateDisplay(editor);
		}
	});
});