define(function (require, exports, module) {
	'use strict';

	var Extensions = require('ft/core/extensions').Extensions;

	function onChanges(cm, changes) {
		if (cm.getSelection().length === 0) {
			for (var i = 0; i < changes.length; i++) {
				var each = changes[i];
				if (each.origin === '+input' || each.origin === '+delete') {					
					cm.getOption('ftEditor').performCommand('centerSelectionInVisibleArea');
					return;
				}
			}
		}
	}

	Extensions.add('com.foldingtext.editor.options', {
		name: 'typewriterMode',
		defaultValue: false,
		onChange: function (editor, oldValue, newValue) {
			var cm = editor.cm();
			if (!newValue) { cm.off('changes', onChanges); }
			if (newValue) { cm.on('changes', onChanges); }
			editor.invalidateRestorableState();
		}
	});

	Extensions.addCommand({
		name: 'toggleTypewriterMode',
		validate: function (editor, options) {
			options.interfaceItemState = editor.option('typewriterMode');
			return true;
		},
		performCommand: function (editor) {
			editor.setOption('typewriterMode', !editor.option('typewriterMode'));
		}
	});
});