define(function (require, exports, module) {
	'use strict';

	var Extensions = require('ft/core/extensions').Extensions;

	Extensions.addCommand({
		name: 'undo',
		validate: function (editor, menuItem) {
			return editor.cm().doc.getHistory().done.length > 0;
		},
		performCommand: function (editor) {
			editor.cm().undo();
		}
	});

	Extensions.addCommand({
		name: 'undoSelection',
		validate: function (editor, menuItem) {
			return editor.cm().doc.getHistory().done.length > 0;
		},
		performCommand: function (editor) {
			editor.cm().undoSelection();
		}
	});

	Extensions.addCommand({
		name: 'redo',
		validate: function (editor, menuItem) {
			return editor.cm().doc.getHistory().undone.length > 0;
		},
		performCommand: function (editor) {
			editor.cm().redo();
		}
	});

	Extensions.addCommand({
		name: 'redoSelection',
		validate: function (editor, menuItem) {
			return editor.cm().doc.getHistory().undone.length > 0;
		},
		performCommand: function (editor) {
			editor.cm().redoSelection();
		}
	});

	Extensions.addCommand({
		name: 'clearUndoHistory',
		performCommand: function (editor) {
			return editor.cm().clearHistory();
		}
	});
});