// Load this mode for a simple visual test to make sure that modes
// are working and updating properly. Nodes in test1 context will have
// a red background, modes in test2 context will have a green background.
define(function (require, exports, module) {
	'use strict';

	var Extensions = require('ft/core/extensions').Extensions;

	Extensions.addMode({
		name: 'test1'
	});

	Extensions.addMode({
		name: 'test2'
	});

	Extensions.add('com.foldingtext.taxonomy.classifier', {
		classify: function (text, state, previousState) {
			var modeStack = state.modeStack;
			if (modeStack) {
				var modeRecord = modeStack.lastObject();
				if (modeRecord && modeRecord.mode === 'test1') {
					if (text.text().length > 0) {
						text.addAttributeInRange('testsyntax', 'boo', 0, 1);
					}
				}
			}
		},
		attributesToClear: ['testsyntax']
	});
});