//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//

/**
 * @module ft/system/pasteboard
 */
define(function (require, exports, module) {
	'use strict';

	/**
	 * Pasteboard allows you to read and write from the default system
	 * pasteboard.
	 *
	 * @private
	 * @constructor
	 * @alias module:ft/system/pasteboard.Pasteboard*/
	var Pasteboard = function Pasteboard() {
	};

	/**
	 * Write a string to the system pasteboard.
	 *
	 * @param {String}
	 */
	Pasteboard.writeString = function writeString(string) {
		if (window.nativeViewController) {
			/*jshint camelcase: false */
			window.nativeViewController.javascriptWriteStringToPasteboard_(string);
			/*jshint camelcase: true */
		}
	};

	/**
	 * Read a string from the system pasteboard.
	 *
	 * @returns {String}
	 */
	Pasteboard.readString = function readString() {
		if (window.nativeViewController) {
			/*jshint camelcase: false */
			var result = window.nativeViewController.javascriptReadStringFromPasteboard();
			/*jshint camelcase: true */
			return result;
		}
		return '';
	};

	exports.Pasteboard = Pasteboard;
});