//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//
define(function (require, exports, module) {
	'use strict';

	require('ft/extensions/nodepath');

	var Extensions = require('ft/core/extensions').Extensions;

	function mouseDown(editor, e) {
		var target = editor.targetsAt(e.clientX, e.clientY),
			attributes = target.attributes,
			node = target.node;

		if (node.type() === 'heading' && attributes.lead) {
			return true;
		}
		return false;
	}

	function mouseUp(editor, e) {
		if (e.button === 2 || (e.button === 0 && e.ctrlKey)) {
			return false;
		}

		var targets = editor.targetsAt(e.clientX, e.clientY),
			attributes = targets.attributes,
			lineCh = targets.lineCh,
			node = targets.node,
			cmdKey = e.metaKey,
			target;

		if (node.type() === 'heading' && attributes.lead) {
			if (!cmdKey) {
				if (editor.isCollapsed(node)) {
					editor.expandNode(node);
				} else {
					editor.collapseNode(node);
				}
			} else {
				editor.focusNode(node);
			}
			return true;
		}

		return false;
	}

	Extensions.add('com.foldingtext.editor.mouse', {
		mouseDown: mouseDown,
		mouseUp: mouseUp
	});
});