//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//
define(function (require, exports, module) {
	'use strict';

	function parseTrailingSpace(text, state, previousState) {
		var length = text.textLength(),
			i = length - 1,
			ch = text.textCharAt(i);

		if (ch !== ' ' || text.textCharAt(i - 1) !== ' ') {
			return;
		}

		while (ch === ' ') {
			i--;
			ch = text.textCharAt(i);
		}

		if (i !== (length - 1)) {
			text.addAttributeInRange('linebreak-causing-whitespace', ' ', length - 1, 1);
			text.sliceText(0, i + 1);
		}
	}

	return {
		parseTrailingSpace: parseTrailingSpace,
		attributesToClear: ['linebreak-causing-whitespace']
	};
});
