define(function (require, exports, module) {
	'use strict';

	var getFile = function (url, onDone, onFail) {
		if (!url) { return; }
		var xhr = httpRequest();
		if (!xhr) { return; }
		var requestType = 'GET';
		xhr.onload = function () {
			if (xhr.readyState === 4) {
				if (xhr.status === 200) {
					onDone(xhr.responseText);
				} else {
					onFail();
				}
			}
		};

		xhr.open('GET', url);
		xhr.send();
	};

	var httpRequest = function () {
		var httpRequest;
		if (window.XMLHttpRequest) {
			httpRequest = new XMLHttpRequest();
		} else if (window.ActiveXObject) {
			try {
				httpRequest = new window.ActiveXObject('Msxml2.XMLHTTP');
			} catch (e) {
				try {
					httpRequest = new window.ActiveXObject('Microsoft.XMLHTTP');
				} catch (e) { }
			}
		}

		if (!httpRequest) {
			console.warning('Ajax is unsupported on this browser');
		}

		return httpRequest;
	};

	return {
		getFile: getFile
	};

});
