define(function (require, exports, module) {
	'use strict';

	exports.arrayOfValues = function arrayOfValues(object) {
		var a = [];
		for (var key in object) {
            if (object.hasOwnProperty(key)) {
				a.push(object[key]);
			}
		}
		return a;
	};

	exports.arrayOfKeys = function arrayOfKeys(object) {
		var a = [];
		for (var key in object) {
            if (object.hasOwnProperty(key)) {
				a.push(key);
			}
		}
		return a;
	};

	exports.shallowClone = function shallowClone(object) {
		if (!object) {
			return null;
		}

		var copy = {},
			attr;

        for (attr in object) {
            if (object.hasOwnProperty(attr)) {
				copy[attr] = object[attr];
            }
        }
        return copy;
    };

	exports.copyObject = function shallowClone(object, target) {
		if (!target) {
			target = {};
		}
		for (var prop in object) {
			if (object.hasOwnProperty(prop)) {
				target[prop] = object[prop];
			}
		}
		return target;
    };

	exports.shallowEquals = function shallowEquals(a, b) {
		if (a === b) {
			return true;
		}

		if (!a || !b) {
			return false;
		}

		var aCount = 0;
		var key;
		for (key in a) {
			if (a.hasOwnProperty(key)) {
				if (a[key] !== b[key]) {
					return false;
				}
				aCount++;
			}
		}
		var bCount = 0;
		for (key in b) {
			if (b.hasOwnProperty(key)) {
				bCount++;
			}
		}

		return aCount === bCount;
	};
});