define(function (require, exports, module) {
	'use strict';

	exports.QueryParameter = function QueryParameter(name, defaultValue, href) {
		name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
		var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');

		if (!href) {
			href = window.location.href;
			var frameElement = window.frameElement;
			if (frameElement) {
				href = frameElement.src;
			}
		}

		var results = regex.exec(href);
		if (results === null) {
			return defaultValue;
		} else {
			return decodeURIComponent(results[1].split('+').join(' '));
		}
	};
});