requirejs.config({
	baseUrl: './',
	skipDirOptimize: true,
	optimizeCss: 'none',
	//optimize: 'none',
	useStrict: false, // if "true" BREAKS Safari when build is optimized https://github.com/jrburke/requirejs/issues/627
	dir: '../dist',
	paths: {
        tests: '../tests'
    },
	onBuildWrite : function (name, path, contents) {
		'use strict';
		contents = contents.replace(/Environment\.debug/g, 'false');
		return contents;
	},
	modules: [

		//
		// Common "codemirror", "core" and "editor" build layers.
		//

		{
			name: './codemirror'
		},

		{
			name: './core',
			include: [
				'./ft/core/tree',
				'./ft/core/taxonomies',
				'./ft/core/taxonomy',
				'./ft/taxonomy/outlinetaxonomy',
				'./ft/taxonomy/markdowntaxonomy',
				'./ft/taxonomy/taskpapertaxonomy'
			],
			exclude: [
				'./codemirror'
			]
		},

		{
			name: './editor',
			include: [
				'./ft/editor/editor'
			],
			exclude: [
				'./core',
				'./codemirror'
			]
		},

		//
		// App specific build layers, excluding the common ones
		//

		{
			name: './foldingtext',
			include: ['apps/foldingtextmain'],
			exclude: [
				'./core',
				'./editor',
				'./codemirror'
			]
		},

		{
			name: './taskpaper',
			include: ['apps/taskpapermain'],
			exclude: [
				'./core',
				'./editor',
				'./codemirror'
			]
		},

		{
			name: './writeroom',
			include: ['apps/writeroommain'],
			exclude: [
				'./core',
				'./editor',
				'./codemirror'
			]
		}
	]
});