define(function (require) {
	'use strict';

	var Outline = require('ft/taxonomy/outlinetaxonomy').Outline,
		Node = require('ft/core/node').Node,
		Tree = require('ft/core/tree').Tree;

	describe('Tree Changed Event', function () {

/*
	one
		two
			three
			four
		five
			six
*/

		var treeText = 'one\n\ttwo\n\t\tthree\n\t\tfour\n\tfive\n\t\tsix',
			one, two, three, four, five, six,
			tree, classifier;

		beforeEach(function () {
			tree = new Tree(treeText, 'outline');
			classifier = tree.classifier;
			classifier.classify(Infinity);
			one = tree.root.firstChild;
			two = one.nextLineNode();
			three = two.nextLineNode();
			four = three.nextLineNode();
			five = four.nextLineNode();
			six = five.nextLineNode();
		});

		afterEach(function () {
			tree.cleanupForCollection();
		});

	});
});