define(function (require) {
	'use strict';

	describe('Complete', function () {
		require('ft/extensions/complete');

		var Editor = require('ft/editor/editor').Editor,
			editor, tree;

		beforeEach(function () {
			editor = new Editor('');
		});

		afterEach(function () {
			editor.removeAndCleanupForCollection();
		});

		it('should have empty prefix range in empty editor', function () {
			var prefixRange = editor.prefixWordRangeForComplete();
			expect(prefixRange.location()).toEqual(0);
			expect(prefixRange.length()).toEqual(0);
		});

		it('should have empty prefix range at start of editor', function () {
			editor.setTextContent('one');
			editor.setSelectedLineCh({line: 0, ch: 0});
			var prefixRange = editor.prefixWordRangeForComplete();
			expect(prefixRange.textInRange()).toEqual('');
		});

		it('should extend prefix range from selection start back to start of previous word', function () {
			editor.setTextContent('one');
			editor.setSelectedLineCh({line: 0, ch: 3});
			expect(editor.prefixWordRangeForComplete().textInRange()).toEqual('one');

			editor.setSelectedLineCh({line: 0, ch: 2});
			expect(editor.prefixWordRangeForComplete().textInRange()).toEqual('on');
		});
	});
});