define(function (require) {
    'use strict';

	require('codemirror');

	var domready = require('components/requirejs-domready/domReady');

	domready(function () {
		var queryParameter = require('ft/util/queryparameter').QueryParameter,
			pluginMains = queryParameter('pluginMains', '').split(':'),
			pluginSpecs = queryParameter('pluginSpecs', '').split(':'),
			specsAndDependencies = [
				'./ft/core/attributedstring.spec',
				'./ft/core/classifier.spec',
				'./ft/core/node.spec',
				'./ft/core/nodepath.spec',
				'./ft/core/range.spec',
				'./ft/core/taxonomy.spec',
				'./ft/core/tree.spec',
				'./ft/core/treechangedevent.spec',

				'./ft/editor/editor.spec',

				'./ft/extensions/complete.spec',
				'./ft/extensions/current.spec',
				'./ft/extensions/cutcopypaste.spec',
				'./ft/extensions/export.spec',
				'./ft/extensions/focus.spec',
				'./ft/extensions/folding.spec',
				'./ft/extensions/foldingnodes.spec',
				'./ft/extensions/formatting.spec',
				'./ft/extensions/indent.spec',
				'./ft/extensions/layout.spec',
				'./ft/extensions/movebranch.spec',
				'./ft/extensions/moveparagraph.spec',
				'./ft/extensions/opml.spec',
				'./ft/extensions/panel.spec',
				'./ft/extensions/selection.spec',
				'./ft/extensions/smartnewline.spec',
				'./ft/extensions/snippets.spec',
				'./ft/extensions/textchecking.spec',

				'./ft/taxonomy/foldingtexttaxonomy.spec',
				'./ft/taxonomy/gitmarkdowntaxonomy.spec',
				'./ft/taxonomy/markdowntaxonomy.spec',
				'./ft/taxonomy/multimarkdowntaxonomy.spec',
				'./ft/taxonomy/outlinetaxonomy.spec',
				'./ft/taxonomy/taskpapertaxonomy.spec',

				'./ft/util/array.spec'
			];

		specsAndDependencies = pluginMains.concat(specsAndDependencies);
		specsAndDependencies = specsAndDependencies.concat(pluginSpecs);

		require(specsAndDependencies, function () {
			jasmine.getEnv().execute();
		});
	});
});