// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

/***
    |''Name''|tiddlywiki.js|
    |''Description''|Enables TiddlyWikiy syntax highlighting using CodeMirror|
    |''Author''|PMario|
    |''Version''|0.1.7|
    |''Status''|''stable''|
    |''Source''|[[GitHub|https://github.com/pmario/CodeMirror2/blob/tw-syntax/mode/tiddlywiki]]|
    |''Documentation''|http://codemirror.tiddlyspace.com/|
    |''License''|[[MIT License|http://www.opensource.org/licenses/mit-license.php]]|
    |''CoreVersion''|2.5.0|
    |''Requires''|codemirror.js|
    |''Keywords''|syntax highlighting color code mirror codemirror|
    ! Info
    CoreVersion parameter is needed for TiddlyWiki only!
***/

/**
 * @license RequireJS text 2.0.12 Copyright (c) 2010-2014, The Dojo Foundation All Rights Reserved.
 * Available via the MIT or new BSD license.
 * see: http://github.com/requirejs/text for details
 */

//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//

(function(e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else{if(typeof define=="function"&&define.amd)return define("components/codemirror/lib/codemirror",[],e);this.CodeMirror=e()}})(function(){function S(e,t){if(!(this instanceof S))return new S(e,t);this.options=t=t||{},_o(Zr,t,!1),B(t);var n=t.value;typeof n=="string"&&(n=new Ns(n,t.mode)),this.doc=n;var s=this.display=new x(e,n);s.wrapper.CodeMirror=this,_(this),O(this),t.lineWrapping&&(this.display.wrapper.className+=" CodeMirror-wrap"),t.autofocus&&!d&&Wn(this),this.state={keyMaps:[],overlays:[],modeGen:0,overwrite:!1,focused:!1,suppressEdits:!1,pasteIncoming:!1,cutIncoming:!1,draggingText:!1,highlight:new So},r&&i<11&&setTimeout(Do(zn,this,!0),20),$n(this),Yo();var o=this;kn(this,function(){o.curOp.forceUpdate=!0,As(o,n),t.autofocus&&!d||Xo()==s.input?setTimeout(Do(xr,o),20):Tr(o);for(var e in ei)ei.hasOwnProperty(e)&&ei[e](o,t[e],ni);for(var r=0;r<oi.length;++r)oi[r](o)})}function x(e,t){var n=this,o=n.input=qo("textarea",null,null,"position: absolute; padding: 0; width: 1px; height: 1em; outline: none");s?o.style.width="1000px":o.setAttribute("wrap","off"),p&&(o.style.border="1px solid black"),o.setAttribute("autocorrect","off"),o.setAttribute("autocapitalize","off"),o.setAttribute("spellcheck","false"),n.inputDiv=qo("div",[o],null,"overflow: hidden; position: relative; width: 3px; height: 0px;"),n.scrollbarH=qo("div",[qo("div",null,null,"height: 100%; min-height: 1px")],"CodeMirror-hscrollbar"),n.scrollbarV=qo("div",[qo("div",null,null,"min-width: 1px")],"CodeMirror-vscrollbar"),n.scrollbarFiller=qo("div",null,"CodeMirror-scrollbar-filler"),n.gutterFiller=qo("div",null,"CodeMirror-gutter-filler"),n.lineDiv=qo("div",null,"CodeMirror-code"),n.selectionDiv=qo("div",null,null,"position: relative; z-index: 1"),n.cursorDiv=qo("div",null,"CodeMirror-cursors"),n.measure=qo("div",null,"CodeMirror-measure"),n.lineMeasure=qo("div",null,"CodeMirror-measure"),n.lineSpace=qo("div",[n.measure,n.lineMeasure,n.selectionDiv,n.cursorDiv,n.lineDiv],null,"position: relative; outline: none"),n.mover=qo("div",[qo("div",[n.lineSpace],"CodeMirror-lines")],null,"position: relative"),n.sizer=qo("div",[n.mover],"CodeMirror-sizer"),n.heightForcer=qo("div",null,null,"position: absolute; height: "+go+"px; width: 1px;"),n.gutters=qo("div",null,"CodeMirror-gutters"),n.lineGutter=null,n.scroller=qo("div",[n.sizer,n.heightForcer,n.gutters],"CodeMirror-scroll"),n.scroller.setAttribute("tabIndex","-1"),n.wrapper=qo("div",[n.inputDiv,n.scrollbarH,n.scrollbarV,n.scrollbarFiller,n.gutterFiller,n.scroller],"CodeMirror"),r&&i<8&&(n.gutters.style.zIndex=-1,n.scroller.style.paddingRight=0),p&&(o.style.width="0px"),s||(n.scroller.draggable=!0),l&&(n.inputDiv.style.height="1px",n.inputDiv.style.position="absolute"),r&&i<8&&(n.scrollbarH.style.minHeight=n.scrollbarV.style.minWidth="18px"),e.appendChild?e.appendChild(n.wrapper):e(n.wrapper),n.viewFrom=n.viewTo=t.first,n.view=[],n.externalMeasured=null,n.viewOffset=0,n.lastSizeC=0,n.updateLineNumbers=null,n.lineNumWidth=n.lineNumInnerWidth=n.lineNumChars=null,n.prevInput="",n.alignWidgets=!1,n.pollingFast=!1,n.poll=new So,n.cachedCharWidth=n.cachedSpaceWidth=n.cachedTextHeight=n.cachedPaddingH=null,n.inaccurateSelection=!1,n.maxLine=null,n.maxLineLength=0,n.maxLineChanged=!1,n.wheelDX=n.wheelDY=n.wheelStartX=n.wheelStartY=null,n.shift=!1,n.selForContextMenu=null}function T(e){e.doc.mode=S.getMode(e.options,e.doc.modeOption),N(e)}function N(e){e.doc.iter(function(e){e.stateAfter&&(e.stateAfter=null),e.styles&&(e.styles=null)}),e.doc.frontier=e.doc.first,Wt(e,100),e.state.modeGen++,e.curOp&&Dn(e)}function C(e){e.options.lineWrapping?(Jo(e.display.wrapper,"CodeMirror-wrap"),e.display.sizer.style.minWidth=""):($o(e.display.wrapper,"CodeMirror-wrap"),H(e)),L(e),Dn(e),fn(e),setTimeout(function(){I(e)},100)}function k(e){var t=En(e.display),n=e.options.lineWrapping,r=n&&Math.max(5,e.display.scroller.clientWidth/Sn(e.display)-3);return function(i){if(Ji(e.doc,i))return 0;var s=0;if(i.widgets)for(var o=0;o<i.widgets.length;o++)i.widgets[o].height&&(s+=i.widgets[o].height);return n?s+(Math.ceil(i.text.length/r)||1)*t:s+t}}function L(e){var t=e.doc,n=k(e);t.iter(function(e){var t=n(e);t!=e.height&&Ds(e,t)})}function A(e){var t=ci[e.options.keyMap],n=t.style;e.display.wrapper.className=e.display.wrapper.className.replace(/\s*cm-keymap-\S+/g,"")+(n?" cm-keymap-"+n:"")}function O(e){e.display.wrapper.className=e.display.wrapper.className.replace(/\s*cm-s-\S+/g,"")+e.options.theme.replace(/(^|\s)\s*/g," cm-s-"),fn(e)}function M(e){_(e),Dn(e),setTimeout(function(){R(e)},20)}function _(e){var t=e.display.gutters,n=e.options.gutters;Uo(t);for(var r=0;r<n.length;++r){var i=n[r],s=t.appendChild(qo("div",null,"CodeMirror-gutter "+i));i=="CodeMirror-linenumbers"&&(e.display.lineGutter=s,s.style.width=(e.display.lineNumWidth||1)+"px")}t.style.display=r?"":"none",D(e)}function D(e){var t=e.display.gutters.offsetWidth;e.display.sizer.style.marginLeft=t+"px",e.display.scrollbarH.style.left=e.options.fixedGutter?t+"px":0}function P(e){if(e.height==0)return 0;var t=e.text.length,n,r=e;while(n=Ri(r)){var i=n.find(0,!0);r=i.from.line,t+=i.from.ch-i.to.ch}r=e;while(n=Ui(r)){var i=n.find(0,!0);t-=r.text.length-i.from.ch,r=i.to.line,t+=r.text.length-i.to.ch}return t}function H(e){var t=e.display,n=e.doc;t.maxLine=Os(n,n.first),t.maxLineLength=P(t.maxLine),t.maxLineChanged=!0,n.iter(function(e){var n=P(e);n>t.maxLineLength&&(t.maxLineLength=n,t.maxLine=e)})}function B(e){var t=Ao(e.gutters,"CodeMirror-linenumbers");t==-1&&e.lineNumbers?e.gutters=e.gutters.concat(["CodeMirror-linenumbers"]):t>-1&&!e.lineNumbers&&(e.gutters=e.gutters.slice(0),e.gutters.splice(t,1))}function j(e){return e.display.scroller.clientHeight-e.display.wrapper.clientHeight<go-3}function F(e){var t=e.display.scroller;return{clientHeight:t.clientHeight,barHeight:e.display.scrollbarV.clientHeight,scrollWidth:t.scrollWidth,clientWidth:t.clientWidth,hScrollbarTakesSpace:j(e),barWidth:e.display.scrollbarH.clientWidth,docHeight:Math.round(e.doc.height+Kt(e.display))}}function I(e,t){t||(t=F(e));var n=e.display,r=nu(n.measure),i=t.docHeight+go,s=t.scrollWidth>t.clientWidth;s&&t.scrollWidth<=t.clientWidth+1&&r>0&&!t.hScrollbarTakesSpace&&(s=!1);var o=i>t.clientHeight;o?(n.scrollbarV.style.display="block",n.scrollbarV.style.bottom=s?r+"px":"0",n.scrollbarV.firstChild.style.height=Math.max(0,i-t.clientHeight+(t.barHeight||n.scrollbarV.clientHeight))+"px"):(n.scrollbarV.style.display="",n.scrollbarV.firstChild.style.height="0"),s?(n.scrollbarH.style.display="block",n.scrollbarH.style.right=o?r+"px":"0",n.scrollbarH.firstChild.style.width=t.scrollWidth-t.clientWidth+(t.barWidth||n.scrollbarH.clientWidth)+"px"):(n.scrollbarH.style.display="",n.scrollbarH.firstChild.style.width="0"),s&&o?(n.scrollbarFiller.style.display="block",n.scrollbarFiller.style.height=n.scrollbarFiller.style.width=r+"px"):n.scrollbarFiller.style.display="",s&&e.options.coverGutterNextToScrollbar&&e.options.fixedGutter?(n.gutterFiller.style.display="block",n.gutterFiller.style.height=r+"px",n.gutterFiller.style.width=n.gutters.offsetWidth+"px"):n.gutterFiller.style.display="";if(!e.state.checkedOverlayScrollbar&&t.clientHeight>0){if(r===0){var u=v&&!c?"12px":"18px";n.scrollbarV.style.minWidth=n.scrollbarH.style.minHeight=u;var a=function(t){ro(t)!=n.scrollbarV&&ro(t)!=n.scrollbarH&&Ln(e,Gn)(t)};so(n.scrollbarV,"mousedown",a),so(n.scrollbarH,"mousedown",a)}e.state.checkedOverlayScrollbar=!0}}function q(e,t,n){var r=n&&n.top!=null?Math.max(0,n.top):e.scroller.scrollTop;r=Math.floor(r-Jt(e));var i=n&&n.bottom!=null?n.bottom:r+e.wrapper.clientHeight,s=Hs(t,r),o=Hs(t,i);if(n&&n.ensure){var u=n.ensure.from.line,a=n.ensure.to.line;if(u<s)return{from:u,to:Hs(t,Bs(Os(t,u))+e.wrapper.clientHeight)};if(Math.min(a,t.lastLine())>=o)return{from:Hs(t,Bs(Os(t,a))-e.wrapper.clientHeight),to:a}}return{from:s,to:Math.max(o,s+1)}}function R(e){var t=e.display,n=t.view;if(!t.alignWidgets&&(!t.gutters.firstChild||!e.options.fixedGutter))return;var r=W(t)-t.scroller.scrollLeft+e.doc.scrollLeft,i=t.gutters.offsetWidth,s=r+"px";for(var o=0;o<n.length;o++)if(!n[o].hidden){e.options.fixedGutter&&n[o].gutter&&(n[o].gutter.style.left=s);var u=n[o].alignable;if(u)for(var a=0;a<u.length;a++)u[a].style.left=s}e.options.fixedGutter&&(t.gutters.style.left=r+i+"px")}function U(e){if(!e.options.lineNumbers)return!1;var t=e.doc,n=z(e.options,t.first+t.size-1),r=e.display;if(n.length!=r.lineNumChars){var i=r.measure.appendChild(qo("div",[qo("div",n)],"CodeMirror-linenumber CodeMirror-gutter-elt")),s=i.firstChild.offsetWidth,o=i.offsetWidth-s;return r.lineGutter.style.width="",r.lineNumInnerWidth=Math.max(s,r.lineGutter.offsetWidth-o),r.lineNumWidth=r.lineNumInnerWidth+o,r.lineNumChars=r.lineNumInnerWidth?n.length:-1,r.lineGutter.style.width=r.lineNumWidth+"px",D(e),!0}return!1}function z(e,t){return String(e.lineNumberFormatter(t+e.firstLineNumber))}function W(e){return e.scroller.getBoundingClientRect().left-e.sizer.getBoundingClientRect().left}function X(e,t,n){var r=e.display.viewFrom,i=e.display.viewTo,o,u=q(e.display,e.doc,t),a=e.display.positionLineWidgets=[];for(var f=!0;;f=!1){var l=e.display.scroller.clientWidth;if(!V(e,u,n))break;o=!0,e.display.maxLineChanged&&!e.options.lineWrapping&&$(e);var c=F(e);qt(e),J(e,c),I(e,c),s&&e.options.lineWrapping&&K(e,c),s&&c.scrollWidth>c.clientWidth&&c.scrollWidth<c.clientWidth+1&&!j(e)&&I(e);if(f&&e.options.lineWrapping&&l!=e.display.scroller.clientWidth){n=!0;continue}n=!1,t&&t.top!=null&&(t={top:Math.min(c.docHeight-go-c.clientHeight,t.top)}),u=q(e.display,e.doc,t);if(u.from>=e.display.viewFrom&&u.to<=e.display.viewTo)break}var h=[],p;for(var d=0;d<a.length;d++)p=a[d].widget.node.parentNode,h.push({widgetWrapper:p,position:a[d].widget.positionWidget(p.offsetWidth,p.offsetHeight)});for(var d=0;d<h.length;d++){var v=h[d].position;p=h[d].widgetWrapper,v.top&&(p.style.top=v.top),v.bottom&&(p.style.bottom=v.bottom),v.left&&(p.style.left=v.left),v.right&&(p.style.right=v.right),v.marginLeft&&(p.style.marginLeft=v.marginLeft),v.marginRight&&(p.style.marginRight=v.marginRight)}return e.display.positionLineWidgets=null,e.display.updateLineNumbers=null,o&&(lo(e,"update",e),(e.display.viewFrom!=r||e.display.viewTo!=i)&&lo(e,"viewportChange",e,e.display.viewFrom,e.display.viewTo)),o}function V(e,t,n){var r=e.display,i=e.doc;if(!r.wrapper.offsetWidth){Hn(e);return}if(!n&&t.from>=r.viewFrom&&t.to<=r.viewTo&&In(e)==0)return;U(e)&&Hn(e);var s=Z(e),o=i.first+i.size,u=Math.max(t.from-e.options.viewportMargin,i.first),a=Math.min(o,t.to+e.options.viewportMargin);r.viewFrom<u&&u-r.viewFrom<20&&(u=Math.max(i.first,r.viewFrom)),r.viewTo>a&&r.viewTo-a<20&&(a=Math.min(o,r.viewTo)),E&&(u=Vi(e.doc,u),a=$i(e.doc,a));var f=u!=r.viewFrom||a!=r.viewTo||r.lastSizeC!=r.wrapper.clientHeight;Fn(e,u,a),r.viewOffset=Bs(Os(e.doc,r.viewFrom)),e.display.mover.style.top=r.viewOffset+"px";var l=In(e);if(!f&&l==0&&!n)return;var c=Xo();return l>4&&(r.lineDiv.style.display="none"),et(e,r.updateLineNumbers,s),l>4&&(r.lineDiv.style.display=""),c&&Xo()!=c&&c.offsetHeight&&c.focus(),Uo(r.cursorDiv),Uo(r.selectionDiv),f&&(r.lastSizeC=r.wrapper.clientHeight,Wt(e,400)),G(e),!0}function $(e){var t=e.display,n=en(e,t.maxLine,t.maxLine.text.length).left;t.maxLineChanged=!1;var r=Math.max(0,n+3),i=Math.max(0,t.sizer.offsetLeft+r+go-t.scroller.clientWidth);t.sizer.style.minWidth=r+"px",i<e.doc.scrollLeft&&fr(e,Math.min(t.scroller.scrollLeft,i),!0)}function J(e,t){e.display.sizer.style.minHeight=e.display.heightForcer.style.top=t.docHeight+"px",e.display.gutters.style.height=Math.max(t.docHeight,t.clientHeight-go)+"px"}function K(e,t){e.display.sizer.offsetWidth+e.display.gutters.offsetWidth<e.display.scroller.clientWidth-1&&(e.display.sizer.style.minHeight=e.display.heightForcer.style.top="0px",e.display.gutters.style.height=t.docHeight+"px")}function Q(e,t,n){var r=e.display,i=t.line.height-n;n<2&&(n=En(r));if(i>.001||i<-0.001){Ds(t.line,n),Y(t.line);if(t.rest)for(var s=0;s<t.rest.length;s++)Y(t.rest[s])}}function G(e){var t=e.display,n=t.lineDiv.offsetTop,r=0,i;for(var s=0;s<t.view.length;s++){var o=t.view[s];if(o.hidden)continue;var u=o.node.offsetTop,a=o.node.offsetHeight,f=u+a,l=u-n;l&&Q(e,i,i.line.height+l),Q(e,o,a),n=f,r=a,i=o}}function Y(e){if(e.widgets)for(var t=0;t<e.widgets.length;++t){var n=e.widgets[t];n.overlay?n.height=0:n.height=n.node.offsetHeight}}function Z(e){var t=e.display,n={},r={};for(var i=t.gutters.firstChild,s=0;i;i=i.nextSibling,++s)n[e.options.gutters[s]]=i.offsetLeft,r[e.options.gutters[s]]=i.offsetWidth;return{fixedPos:W(t),gutterTotalWidth:t.gutters.offsetWidth,gutterLeft:n,gutterWidth:r,wrapperWidth:t.wrapper.clientWidth}}function et(e,t,n){function a(t){var n=t.nextSibling;return s&&v&&e.display.currentWheelTarget==t?t.style.display="none":t.parentNode.removeChild(t),n}var r=e.display,i=e.options.lineNumbers,o=r.lineDiv,u=o.firstChild,f=r.view,l=r.viewFrom;for(var c=0;c<f.length;c++){var h=f[c];if(!h.hidden)if(!h.node){var p=ft(e,h,l,n);o.insertBefore(p,u)}else{while(u!=h.node)u=a(u);var d=i&&t!=null&&t<=l&&h.lineNumber;h.changes&&(Ao(h.changes,"gutter")>-1&&(d=!1),tt(e,h,l,n)),d&&(Uo(h.lineNumber),h.lineNumber.appendChild(document.createTextNode(z(e.options,l)))),u=h.node.nextSibling}l+=h.size}while(u)u=a(u)}function tt(e,t,n,r){for(var i=0;i<t.changes.length;i++){var s=t.changes[i];s=="text"?st(e,t):s=="gutter"?ut(e,t,n,r):s=="class"?ot(t):s=="widget"&&at(e,t,r)}t.changes=null}function nt(e){return e.node==e.text&&(e.node=qo("div",null,null,"position: relative"),e.text.parentNode&&e.text.parentNode.replaceChild(e.node,e.text),e.node.appendChild(e.text),r&&i<8&&(e.node.style.zIndex=2)),e.node}function rt(e){var t=e.bgClass?e.bgClass+" "+(e.line.bgClass||""):e.line.bgClass;t&&(t+=" CodeMirror-linebackground");if(e.background)t?e.background.className=t:(e.background.parentNode.removeChild(e.background),e.background=null);else if(t){var n=nt(e);e.background=n.insertBefore(qo("div",null,t),n.firstChild)}}function it(e,t){var n=e.display.externalMeasured;return n&&n.line==t.line?(e.display.externalMeasured=null,t.measure=n.measure,n.built):ps(e,t)}function st(e,t){var n=t.text.className,r=it(e,t);t.text==t.node&&(t.node=r.pre),t.text.parentNode.replaceChild(r.pre,t.text),t.text=r.pre,r.wrapClass!=t.wrapClass||r.bgClass!=t.bgClass||r.textClass!=t.textClass?(t.wrapClass=r.wrapClass,t.bgClass=r.bgClass,t.textClass=r.textClass,ot(t)):n&&(t.text.className=n)}function ot(e){rt(e);var t=e.wrapClass?e.wrapClass+" "+(e.line.wrapClass||""):e.line.wrapClass;t?nt(e).className=t:e.node!=e.text&&(e.node.className="");var n=e.textClass?e.textClass+" "+(e.line.textClass||""):e.line.textClass;e.text.className=n||""}function ut(e,t,n,r){t.gutter&&(t.node.removeChild(t.gutter),t.gutter=null);var i=t.line.gutterMarkers;if(e.options.lineNumbers||i){var s=nt(t),o=t.gutter=s.insertBefore(qo("div",null,"CodeMirror-gutter-wrapper","position: absolute; left: "+(e.options.fixedGutter?r.fixedPos:-r.gutterTotalWidth)+"px"),t.text);e.options.lineNumbers&&(!i||!i["CodeMirror-linenumbers"])&&(t.lineNumber=o.appendChild(qo("div",z(e.options,n),"CodeMirror-linenumber CodeMirror-gutter-elt","left: "+r.gutterLeft["CodeMirror-linenumbers"]+"px; width: "+e.display.lineNumInnerWidth+"px")));if(i)for(var u=0;u<e.options.gutters.length;++u){var a=e.options.gutters[u],f=i.hasOwnProperty(a)&&i[a];f&&o.appendChild(qo("div",[f],"CodeMirror-gutter-elt","left: "+r.gutterLeft[a]+"px; width: "+r.gutterWidth[a]+"px"))}}}function at(e,t,n){t.alignable&&(t.alignable=null);for(var r=t.node.firstChild,i;r;r=i){var i=r.nextSibling;r.className=="CodeMirror-linewidget"&&t.node.removeChild(r)}lt(e,t,n)}function ft(e,t,n,r){var i=it(e,t);return t.text=t.node=i.pre,i.wrapClass&&(t.wrapClass=i.wrapClass),i.bgClass&&(t.bgClass=i.bgClass),i.textClass&&(t.textClass=i.textClass),ot(t),ut(e,t,n,r),lt(e,t,r),t.node}function lt(e,t,n){ct(e,t.line,t,n,!0,!1);if(t.rest)for(var r=0;r<t.rest.length;r++)ct(e,t.rest[r],t,n,!1,!0)}function ct(e,t,n,r,i,s){if(!t.widgets)return;var o=nt(n);for(var u=0,a=t.widgets;u<a.length;++u){var f=a[u];if(s&&!f.showIfHidden)continue;var l=qo("div",[f.node],"CodeMirror-linewidget");f.handleMouseEvents||(l.ignoreEvents=!0),ht(e,f,l,n,r),i&&f.above?o.insertBefore(l,n.gutter||n.text):f.overlay?o.insertBefore(l,n.text):o.appendChild(l),lo(f,"redraw")}}function ht(e,t,n,r,i){if(t.noHScroll){(r.alignable||(r.alignable=[])).push(n);var s=i.wrapperWidth;n.style.left=i.fixedPos+"px",t.coverGutter||(s-=i.gutterTotalWidth,n.style.paddingLeft=i.gutterTotalWidth+"px"),n.style.width=s+"px"}t.coverGutter&&(n.style.zIndex=5,n.style.position="relative",t.noHScroll||(n.style.marginLeft=-i.gutterTotalWidth+"px")),t.overlay&&(n.style.position="absolute"),t.positionWidget&&e.display.positionLineWidgets&&e.display.positionLineWidgets.push({widget:t,node:n})}function vt(e){return pt(e.line,e.ch)}function mt(e,t){return dt(e,t)<0?t:e}function gt(e,t){return dt(e,t)<0?e:t}function yt(e,t){this.ranges=e,this.primIndex=t}function bt(e,t){this.anchor=e,this.head=t}function wt(e,t){var n=e[t];e.sort(function(e,t){return dt(e.from(),t.from())}),t=Ao(e,n);for(var r=1;r<e.length;r++){var i=e[r],s=e[r-1];if(dt(s.to(),i.from())>=0){var o=gt(s.from(),i.from()),u=mt(s.to(),i.to()),a=s.empty()?i.from()==i.head:s.from()==s.head;r<=t&&--t,e.splice(--r,2,new bt(a?u:o,a?o:u))}}return new yt(e,t)}function Et(e,t){return new yt([new bt(e,t||e)],0)}function St(e,t){return Math.max(e.first,Math.min(t,e.first+e.size-1))}function xt(e,t){if(t.line<e.first)return pt(e.first,0);var n=e.first+e.size-1;return t.line>n?pt(n,Os(e,n).text.length):Tt(t,Os(e,t.line).text.length)}function Tt(e,t){var n=e.ch;return n==null||n>t?pt(e.line,t):n<0?pt(e.line,0):e}function Nt(e,t){return t>=e.first&&t<e.first+e.size}function Ct(e,t){for(var n=[],r=0;r<t.length;r++)n[r]=xt(e,t[r]);return n}function kt(e,t,n,r){if(e.cm&&e.cm.display.shift||e.extend){var i=t.anchor;if(r){var s=dt(n,i)<0;s!=dt(r,i)<0?(i=n,n=r):s!=dt(n,r)<0&&(n=r)}return new bt(i,n)}return new bt(r||n,n)}function Lt(e,t,n,r){Pt(e,new yt([kt(e,e.sel.primary(),t,n)],0),r)}function At(e,t,n){for(var r=[],i=0;i<e.sel.ranges.length;i++)r[i]=kt(e,e.sel.ranges[i],t[i],null);var s=wt(r,e.sel.primIndex);Pt(e,s,n)}function Ot(e,t,n,r){var i=e.sel.ranges.slice(0);i[t]=n,Pt(e,wt(i,e.sel.primIndex),r)}function Mt(e,t,n,r){Pt(e,Et(t,n),r)}function _t(e,t){var n={ranges:t.ranges,update:function(t){this.ranges=[];for(var n=0;n<t.length;n++)this.ranges[n]=new bt(xt(e,t[n].anchor),xt(e,t[n].head))}};return uo(e,"beforeSelectionChange",e,n),e.cm&&uo(e.cm,"beforeSelectionChange",e.cm,n),n.ranges!=t.ranges?wt(n.ranges,n.ranges.length-1):t}function Dt(e,t,n){var r=e.history.done,i=ko(r);i&&i.ranges?(r[r.length-1]=t,Ht(e,t,n)):Pt(e,t,n)}function Pt(e,t,n){Ht(e,t,n),Ws(e,e.sel,e.cm?e.cm.curOp.id:NaN,n)}function Ht(e,t,n){if(vo(e,"beforeSelectionChange")||e.cm&&vo(e.cm,"beforeSelectionChange"))t=_t(e,t);var r=n&&n.bias||(dt(t.primary().head,e.sel.primary().head)<0?-1:1);Bt(e,Ft(e,t,r,!0)),(!n||n.scroll!==!1)&&e.cm&&Xr(e.cm)}function Bt(e,t){if(t.equals(e.sel))return;e.sel=t,e.cm&&(e.cm.curOp.updateInput=e.cm.curOp.selectionChanged=!0,po(e.cm)),lo(e,"cursorActivity",e)}function jt(e){Bt(e,Ft(e,e.sel,null,!1),bo)}function Ft(e,t,n,r){var i;for(var s=0;s<t.ranges.length;s++){var o=t.ranges[s],u=It(e,o.anchor,n,r),a=It(e,o.head,n,r);if(i||u!=o.anchor||a!=o.head)i||(i=t.ranges.slice(0,s)),i[s]=new bt(u,a)}return i?wt(i,t.primIndex):t}function It(e,t,n,r){var i=!1,s=t,o=n||1;e.cantEdit=!1;e:for(;;){var u=Os(e,s.line);if(u.markedSpans)for(var a=0;a<u.markedSpans.length;++a){var f=u.markedSpans[a],l=f.marker;if((f.from==null||(l.inclusiveLeft?f.from<=s.ch:f.from<s.ch))&&(f.to==null||(l.inclusiveRight?f.to>=s.ch:f.to>s.ch))){if(r){uo(l,"beforeCursorEnter");if(l.explicitlyCleared){if(!u.markedSpans)break;--a;continue}}if(!l.atomic)continue;var c=l.find(o<0?-1:1);if(dt(c,s)==0){c.ch+=o,c.ch<0?c.line>e.first?c=xt(e,pt(c.line-1)):c=null:c.ch>u.text.length&&(c.line<e.first+e.size-1?c=pt(c.line+1,0):c=null);if(!c){if(i)return r?(e.cantEdit=!0,pt(e.first,0)):It(e,t,n,!0);i=!0,c=t,o=-o}}s=c;continue e}}return s}}function qt(e){var t=e.display,n=e.doc,r=document.createDocumentFragment(),i=document.createDocumentFragment();for(var s=0;s<n.sel.ranges.length;s++){var o=n.sel.ranges[s],u=o.empty();(u||e.options.showCursorWhenSelecting)&&Rt(e,o,r),u||Ut(e,o,i)}if(e.options.moveInputWithCursor){var a=vn(e,n.sel.primary().head,"div"),f=t.wrapper.getBoundingClientRect(),l=t.lineDiv.getBoundingClientRect(),c=Math.max(0,Math.min(t.wrapper.clientHeight-10,a.top+l.top-f.top)),h=Math.max(0,Math.min(t.wrapper.clientWidth-10,a.left+l.left-f.left));t.inputDiv.style.top=c+"px",t.inputDiv.style.left=h+"px"}zo(t.cursorDiv,r),zo(t.selectionDiv,i)}function Rt(e,t,n){var r=vn(e,t.head,"div",null,null,!e.options.singleCursorHeightPerLine),i=n.appendChild(qo("div"," ","CodeMirror-cursor"));i.style.left=r.left+"px",i.style.top=r.top+"px",i.style.height=Math.max(0,r.bottom-r.top)*e.options.cursorHeight+"px";if(r.other){var s=n.appendChild(qo("div"," ","CodeMirror-cursor CodeMirror-secondarycursor"));s.style.display="",s.style.left=r.other.left+"px",s.style.top=r.other.top+"px",s.style.height=(r.other.bottom-r.other.top)*.85+"px"}}function Ut(e,t,n){function f(e,t,n,r){t<0&&(t=0),t=Math.round(t),r=Math.round(r),s.appendChild(qo("div",null,"CodeMirror-selected","position: absolute; left: "+e+"px; top: "+t+"px; width: "+(n==null?a-e:n)+"px; height: "+(r-t)+"px"))}function l(t,n,r){function h(n,r){return dn(e,pt(t,n),"div",s,r)}var s=Os(i,t),o=s.text.length,l,c;return cu(js(s),n||0,r==null?o:r,function(e,t,i){var s=h(e,"left"),p,d,v;if(e==t)p=s,d=v=s.left;else{p=h(t-1,"right");if(i=="rtl"){var m=s;s=p,p=m}d=s.left,v=p.right}n==null&&e==0&&(d=u),p.top-s.top>3&&(f(d,s.top,null,s.bottom),d=u,s.bottom<p.top&&f(d,s.bottom,null,p.top)),r==null&&t==o&&(v=a);if(!l||s.top<l.top||s.top==l.top&&s.left<l.left)l=s;if(!c||p.bottom>c.bottom||p.bottom==c.bottom&&p.right>c.right)c=p;d<u+1&&(d=u),f(d,p.top,v-d,p.bottom)}),{start:l,end:c}}var r=e.display,i=e.doc,s=document.createDocumentFragment(),o=Qt(e.display),u=o.left,a=r.lineSpace.offsetWidth-o.right,c=t.from(),h=t.to();if(c.line==h.line)l(c.line,c.ch,h.ch);else{var p=Os(i,c.line),d=Os(i,h.line),v=Wi(p)==Wi(d),m=l(c.line,c.ch,v?p.text.length+1:null).end,g=v?0:null,y=h.ch,b;g===null&&y===0?b=dn(e,pt(h.line,h.ch),"div"):(b=l(h.line,g,h.ch).start,v&&(m.top<b.top-2?(f(m.right,m.top,null,m.bottom),f(u,b.top,b.left,b.bottom)):f(m.right,m.top,b.left-m.right,m.bottom))),m.bottom<b.top&&f(u,m.bottom,null,b.top)}n.appendChild(s)}function zt(e){if(!e.state.focused)return;var t=e.display;clearInterval(t.blinker);var n=!0;t.cursorDiv.style.visibility="",e.options.cursorBlinkRate>0?t.blinker=setInterval(function(){t.cursorDiv.style.visibility=(n=!n)?"":"hidden"},e.options.cursorBlinkRate):e.options.cursorBlinkRate<0&&(t.cursorDiv.style.visibility="hidden")}function Wt(e,t){e.doc.mode.startState&&e.doc.frontier<e.display.viewTo&&e.state.highlight.set(t,Do(Xt,e))}function Xt(e){var t=e.doc;t.frontier<t.first&&(t.frontier=t.first);if(t.frontier>=e.display.viewTo)return;var n=+(new Date)+e.options.workTime,r=ai(t.mode,$t(e,t.frontier));kn(e,function(){t.iter(t.frontier,Math.min(t.first+t.size,e.display.viewTo+500),function(i){if(t.frontier>=e.display.viewFrom){var s=i.styles,o=us(e,i,r,!0);i.styles=o.styles,o.classes?i.styleClasses=o.classes:i.styleClasses&&(i.styleClasses=null);var u=!s||s.length!=i.styles.length;for(var a=0;!u&&a<s.length;++a)u=s[a]!=i.styles[a];u&&Pn(e,t.frontier,"text"),i.stateAfter=ai(t.mode,r)}else fs(e,i.text,r),i.stateAfter=t.frontier%5==0?ai(t.mode,r):null;++t.frontier;if(+(new Date)>n)return Wt(e,e.options.workDelay),!0})})}function Vt(e,t,n){var r,i,s=e.doc,o=n?-1:t-(e.doc.mode.innerMode?1e3:100);for(var u=t;u>o;--u){if(u<=s.first)return s.first;var a=Os(s,u-1);if(a.stateAfter&&(!n||u<=s.frontier))return u;var f=xo(a.text,null,e.options.tabSize);if(i==null||r>f)i=u-1,r=f}return i}function $t(e,t,n){var r=e.doc,i=e.display;if(!r.mode.startState)return!0;var s=Vt(e,t,n),o=s>r.first&&Os(r,s-1).stateAfter;return o?o=ai(r.mode,o):o=fi(r.mode),r.iter(s,t,function(n){fs(e,n.text,o);var u=s==t-1||s%5==0||s>=i.viewFrom&&s<i.viewTo;n.stateAfter=u?ai(r.mode,o):null,++s}),n&&(r.frontier=s),o}function Jt(e){return e.lineSpace.offsetTop}function Kt(e){return e.mover.offsetHeight-e.lineSpace.offsetHeight}function Qt(e){if(e.cachedPaddingH)return e.cachedPaddingH;var t=zo(e.measure,qo("pre","x")),n=window.getComputedStyle?window.getComputedStyle(t):t.currentStyle,r={left:parseInt(n.paddingLeft),right:parseInt(n.paddingRight)};return!isNaN(r.left)&&!isNaN(r.right)&&(e.cachedPaddingH=r),r}function Gt(e,t,n){var r=e.options.lineWrapping,i=r&&e.display.scroller.clientWidth;if(!t.measure.heights||r&&t.measure.width!=i){var s=t.measure.heights=[];if(r){t.measure.width=i;var o=t.text.firstChild.getClientRects();for(var u=0;u<o.length-1;u++){var a=o[u],f=o[u+1];Math.abs(a.bottom-f.bottom)>2&&s.push((a.bottom+f.top)/2-n.top)}}s.push(n.bottom-n.top)}}function Yt(e,t,n){if(e.line==t)return{map:e.measure.map,cache:e.measure.cache};for(var r=0;r<e.rest.length;r++)if(e.rest[r]==t)return{map:e.measure.maps[r],cache:e.measure.caches[r]};for(var r=0;r<e.rest.length;r++)if(Ps(e.rest[r])>n)return{map:e.measure.maps[r],cache:e.measure.caches[r],before:!0}}function Zt(e,t){t=Wi(t);var n=Ps(t),r=e.display.externalMeasured=new Mn(e.doc,t,n);r.lineN=n;var i=r.built=ps(e,r);return r.text=i.pre,zo(e.display.lineMeasure,i.pre),r}function en(e,t,n,r){return rn(e,nn(e,t),n,r)}function tn(e,t){if(t>=e.display.viewFrom&&t<e.display.viewTo)return e.display.view[Bn(e,t)];var n=e.display.externalMeasured;if(n&&t>=n.lineN&&t<n.lineN+n.size)return n}function nn(e,t){var n=Ps(t),r=tn(e,n);r&&!r.text?r=null:r&&r.changes&&tt(e,r,n,Z(e)),r||(r=Zt(e,t));var i=Yt(r,t,n);return{line:t,view:r,rect:null,map:i.map,cache:i.cache,before:i.before,hasHeights:!1}}function rn(e,t,n,r,i){t.before&&(n=-1);var s=n+(r||""),o;return t.cache.hasOwnProperty(s)?o=t.cache[s]:(t.rect||(t.rect=t.view.text.getBoundingClientRect()),t.hasHeights||(Gt(e,t.view,t.rect),t.hasHeights=!0),o=on(e,t,n,r),o.bogus||(t.cache[s]=o)),{left:o.left,right:o.right,top:i?o.rtop:o.top,bottom:i?o.rbottom:o.bottom}}function on(e,t,n,s){var o=t.map,u,a,f,l;for(var c=0;c<o.length;c+=3){var h=o[c],p=o[c+1];if(n<h)a=0,f=1,l="left";else if(n<p)a=n-h,f=a+1;else if(c==o.length-3||n==p&&o[c+3]>n)f=p-h,a=f-1,n>=p&&(l="right");if(a!=null){u=o[c+2],h==p&&s==(u.insertLeft?"left":"right")&&(l=s);if(s=="left"&&a==0)while(c&&o[c-2]==o[c-3]&&o[c-1].insertLeft)u=o[(c-=3)+2],l="left";if(s=="right"&&a==p-h)while(c<o.length-3&&o[c+3]==o[c+4]&&!o[c+5].insertLeft)u=o[(c+=3)+2],l="right";break}}var d;if(u.nodeType==3){while(a&&Io(t.line.text.charAt(h+a)))--a;while(h+f<p&&Io(t.line.text.charAt(h+f)))++f;if(r&&i<9&&a==0&&f==p-h)d=u.parentNode.getBoundingClientRect();else if(r&&e.options.lineWrapping){var v=Ro(u,a,f).getClientRects();v.length?d=v[s=="right"?v.length-1:0]:d=sn}else{d=Ro(u,a,f).getBoundingClientRect()||sn;if(d.width===0){var v=Ro(u,a,f).getClientRects();v.length?d=v[s=="right"?v.length-1:0]:d=sn}}}else{a>0&&(l=s="right");var v;e.options.lineWrapping&&(v=u.getClientRects()).length>1?d=v[s=="right"?v.length-1:0]:d=u.getBoundingClientRect()}if(r&&i<9&&!a&&(!d||!d.left&&!d.right)){var m=u.parentNode.getClientRects()[0];m?d={left:m.left,right:m.left+Sn(e.display),top:m.top,bottom:m.bottom}:d=sn}var g=d.top-t.rect.top,y=d.bottom-t.rect.top,b=(g+y)/2,w=t.view.measure.heights;for(var c=0;c<w.length-1;c++)if(b<w[c])break;var E=c?w[c-1]:0,S=w[c],x={left:(l=="right"?d.right:d.left)-t.rect.left,right:(l=="left"?d.left:d.right)-t.rect.left,top:E,bottom:S};!d.left&&!d.right&&(x.bogus=!0),e.options.singleCursorHeightPerLine||(x.rtop=g,x.rbottom=y);var T=t.view.text.offsetLeft;return T&&(x.left+=T,x.right+=T),x}function un(e){if(e.measure){e.measure.cache={},e.measure.heights=null;if(e.rest)for(var t=0;t<e.rest.length;t++)e.measure.caches[t]={}}}function an(e){e.display.externalMeasure=null,Uo(e.display.lineMeasure);for(var t=0;t<e.display.view.length;t++)un(e.display.view[t])}function fn(e){an(e),e.display.cachedCharWidth=e.display.cachedSpaceWidth=e.display.cachedTextHeight=e.display.cachedPaddingH=null,e.options.lineWrapping||(e.display.maxLineChanged=!0),e.display.lineNumChars=null}function ln(){return window.pageXOffset||(document.documentElement||document.body).scrollLeft}function cn(){return window.pageYOffset||(document.documentElement||document.body).scrollTop}function hn(e,t,n,r){if(t.widgets)for(var i=0;i<t.widgets.length;++i)if(t.widgets[i].above){var s=Yi(t.widgets[i]);n.top+=s,n.bottom+=s}if(r=="line")return n;r||(r="local");var o=Bs(t);r=="local"?o+=Jt(e.display):o-=e.display.viewOffset;if(r=="page"||r=="window"){var u=e.display.lineSpace.getBoundingClientRect();o+=u.top+(r=="window"?0:cn());var a=u.left+(r=="window"?0:ln());n.left+=a,n.right+=a}return n.top+=o,n.bottom+=o,n}function pn(e,t,n){if(n=="div")return t;var r=t.left,i=t.top;if(n=="page")r-=ln(),i-=cn();else if(n=="local"||!n){var s=e.display.sizer.getBoundingClientRect();r+=s.left,i+=s.top}var o=e.display.lineSpace.getBoundingClientRect();return{left:r-o.left,top:i-o.top}}function dn(e,t,n,r,i){return r||(r=Os(e.doc,t.line)),hn(e,r,en(e,r,t.ch,i),n)}function vn(e,t,n,r,i,s){function o(t,o){var u=rn(e,i,t,o?"right":"left",s);return o?u.left=u.right:u.right=u.left,hn(e,r,u,n)}function u(e,t){var n=a[t],r=n.level%2;return e==hu(n)&&t&&n.level<a[t-1].level?(n=a[--t],e=pu(n)-(n.level%2?0:1),r=!0):e==pu(n)&&t<a.length-1&&n.level<a[t+1].level&&(n=a[++t],e=hu(n)-n.level%2,r=!1),r&&e==n.to&&e>n.from?o(e-1):o(e,r)}r=r||Os(e.doc,t.line),i||(i=nn(e,r));var a=js(r),f=t.ch;if(!a)return o(f);var l=wu(a,f),c=u(f,l);return bu!=null&&(c.other=u(f,bu)),c}function mn(e,t){var n=0,t=xt(e.doc,t);e.options.lineWrapping||(n=Sn(e.display)*t.ch);var r=Os(e.doc,t.line),i=Bs(r)+Jt(e.display);return{left:n,right:n,top:i,bottom:i+r.height}}function gn(e,t,n,r){var i=pt(e,t);return i.xRel=r,n&&(i.outside=!0),i}function yn(e,t,n){var r=e.doc;n+=e.display.viewOffset;if(n<0)return gn(r.first,0,!0,-1);var i=Hs(r,n),s=r.first+r.size-1;if(i>s)return gn(r.first+r.size-1,Os(r,s).text.length,!0,1);t<0&&(t=0);var o=Os(r,i);for(;;){var u=bn(e,o,i,t,n),a=Ui(o),f=a&&a.find(0,!0);if(!a||!(u.ch>f.from.ch||u.ch==f.from.ch&&u.xRel>0))return u;i=Ps(o=f.to.line)}}function bn(e,t,n,r,i){function f(r){var i=vn(e,pt(n,r),"line",t,a);return o=!0,s>i.bottom?i.left-u:s<i.top?i.left+u:(o=!1,i.left)}var s=i-Bs(t),o=!1,u=2*e.display.wrapper.clientWidth,a=nn(e,t),l=js(t),c=t.text.length,h=du(t),p=vu(t),d=f(h),v=o,m=f(p),g=o;if(r>m)return gn(n,p,g,1);for(;;){if(l?p==h||p==Su(t,h,1):p-h<=1){var y=r<d||r-d<=m-r?h:p,b=r-(y==h?d:m);while(Io(t.text.charAt(y)))++y;var w=gn(n,y,y==h?v:g,b<-1?-1:b>1?1:0);return w}var E=Math.ceil(c/2),S=h+E;if(l){S=h;for(var x=0;x<E;++x)S=Su(t,S,1)}var T=f(S);if(T>r){p=S,m=T;if(g=o)m+=1e3;c=E}else h=S,d=T,v=o,c-=E}}function En(e){if(e.cachedTextHeight!=null)return e.cachedTextHeight;if(wn==null){wn=qo("pre");for(var t=0;t<49;++t)wn.appendChild(document.createTextNode("x")),wn.appendChild(qo("br"));wn.appendChild(document.createTextNode("x"))}zo(e.measure,wn);var n=wn.offsetHeight/50;return n>3&&(e.cachedTextHeight=n),Uo(e.measure),n||1}function Sn(e){if(e.cachedCharWidth!=null)return e.cachedCharWidth;var t=qo("span","xxxxxxxxxx"),n=qo("pre",[t]);zo(e.measure,n);var r=t.getBoundingClientRect(),i=(r.right-r.left)/10;return i>2&&(e.cachedCharWidth=i),i||10}function xn(e){if(e.cachedSpaceWidth!=null)return e.cachedSpaceWidth;var t=qo("span","          "),n=qo("pre",[t]);zo(e.measure,n);var r=t.getBoundingClientRect(),i=(r.right-r.left)/10;return i>2&&(e.cachedSpaceWidth=i),i||10}function Nn(e){e.curOp={viewChanged:!1,startHeight:e.doc.height,forceUpdate:!1,updateInput:null,typing:!1,changeObjs:null,cursorActivityHandlers:null,selectionChanged:!1,updateMaxLine:!1,scrollLeft:null,scrollTop:null,scrollToPos:null,id:++Tn},fo++||(ao=[])}function Cn(e){uo(e,"willEndOperation",e);var t=e.curOp,n=e.doc,r=e.display;e.curOp=null,t.updateMaxLine&&H(e);if(t.viewChanged||t.forceUpdate||t.scrollTop!=null||t.scrollToPos&&(t.scrollToPos.from.line<r.viewFrom||t.scrollToPos.to.line>=r.viewTo)||r.maxLineChanged&&e.options.lineWrapping){var i=X(e,{top:t.scrollTop,ensure:t.scrollToPos},t.forceUpdate);e.display.scroller.offsetHeight&&(e.doc.scrollTop=e.display.scroller.scrollTop)}!i&&t.selectionChanged&&qt(e),!i&&t.startHeight!=e.doc.height&&I(e),r.wheelStartX!=null&&(t.scrollTop!=null||t.scrollLeft!=null||t.scrollToPos)&&(r.wheelStartX=r.wheelStartY=null);if(t.scrollTop!=null&&r.scroller.scrollTop!=t.scrollTop){var s=Math.max(0,Math.min(r.scroller.scrollHeight-r.scroller.clientHeight,t.scrollTop));r.scroller.scrollTop=r.scrollbarV.scrollTop=n.scrollTop=s}if(t.scrollLeft!=null&&r.scroller.scrollLeft!=t.scrollLeft){var o=Math.max(0,Math.min(r.scroller.scrollWidth-r.scroller.clientWidth,t.scrollLeft));r.scroller.scrollLeft=r.scrollbarH.scrollLeft=n.scrollLeft=o,R(e)}if(t.scrollToPos){var u=Rr(e,xt(e.doc,t.scrollToPos.from),xt(e.doc,t.scrollToPos.to),t.scrollToPos.topMargin,t.scrollToPos.bottomMargin);t.scrollToPos.isCursor&&e.state.focused&&qr(e,u)}t.selectionChanged&&zt(e),e.state.focused&&t.updateInput&&zn(e,t.typing);var a=t.maybeHiddenMarkers,f=t.maybeUnhiddenMarkers;if(a)for(var l=0;l<a.length;++l)a[l].lines.length||uo(a[l],"hide");if(f)for(var l=0;l<f.length;++l)f[l].lines.length&&uo(f[l],"unhide");var c;--fo||(c=ao,ao=null),t.changeObjs&&uo(e,"changes",e,t.changeObjs);if(c)for(var l=0;l<c.length;++l)c[l]();if(t.cursorActivityHandlers)for(var l=0;l<t.cursorActivityHandlers.length;l++)t.cursorActivityHandlers[l](e)}function kn(e,t){if(e.curOp)return t();Nn(e);try{return t()}finally{Cn(e)}}function Ln(e,t){return function(){if(e.curOp)return t.apply(e,arguments);Nn(e);try{return t.apply(e,arguments)}finally{Cn(e)}}}function An(e){return function(){if(this.curOp)return e.apply(this,arguments);Nn(this);try{return e.apply(this,arguments)}finally{Cn(this)}}}function On(e){return function(){var t=this.cm;if(!t||t.curOp)return e.apply(this,arguments);Nn(t);try{return e.apply(this,arguments)}finally{Cn(t)}}}function Mn(e,t,n){this.line=t,this.rest=Xi(t),this.size=this.rest?Ps(ko(this.rest))-n+1:1,this.node=this.text=null,this.hidden=Ji(e,t)}function _n(e,t,n){var r=[],i;for(var s=t;s<n;s=i){var o=new Mn(e.doc,Os(e.doc,s),s);i=s+o.size,r.push(o)}return r}function Dn(e,t,n,r){t==null&&(t=e.doc.first),n==null&&(n=e.doc.first+e.doc.size),r||(r=0);var i=e.display;r&&n<i.viewTo&&(i.updateLineNumbers==null||i.updateLineNumbers>t)&&(i.updateLineNumbers=t),e.curOp.viewChanged=!0;if(t>=i.viewTo)E&&Vi(e.doc,t)<i.viewTo&&Hn(e);else if(n<=i.viewFrom)E&&$i(e.doc,n+r)>i.viewFrom?Hn(e):(i.viewFrom+=r,i.viewTo+=r);else if(t<=i.viewFrom&&n>=i.viewTo)Hn(e);else if(t<=i.viewFrom){var s=jn(e,n,n+r,1);s?(i.view=i.view.slice(s.index),i.viewFrom=s.lineN,i.viewTo+=r):Hn(e)}else if(n>=i.viewTo){var s=jn(e,t,t,-1);s?(i.view=i.view.slice(0,s.index),i.viewTo=s.lineN):Hn(e)}else{var o=jn(e,t,t,-1),u=jn(e,n,n+r,1);o&&u?(i.view=i.view.slice(0,o.index).concat(_n(e,o.lineN,u.lineN)).concat(i.view.slice(u.index)),i.viewTo+=r):Hn(e)}var a=i.externalMeasured;a&&(n<a.lineN?a.lineN+=r:t<a.lineN+a.size&&(i.externalMeasured=null))}function Pn(e,t,n){e.curOp.viewChanged=!0;var r=e.display,i=e.display.externalMeasured;i&&t>=i.lineN&&t<i.lineN+i.size&&(r.externalMeasured=null);if(t<r.viewFrom||t>=r.viewTo)return;var s=r.view[Bn(e,t)];if(s.node==null)return;var o=s.changes||(s.changes=[]);Ao(o,n)==-1&&o.push(n)}function Hn(e){e.display.viewFrom=e.display.viewTo=e.doc.first,e.display.view=[],e.display.viewOffset=0}function Bn(e,t){if(t>=e.display.viewTo)return null;t-=e.display.viewFrom;if(t<0)return null;var n=e.display.view;for(var r=0;r<n.length;r++){t-=n[r].size;if(t<0)return r}}function jn(e,t,n,r){var i=Bn(e,t),s,o=e.display.view;if(!E||n==e.doc.first+e.doc.size)return{index:i,lineN:n};for(var u=0,a=e.display.viewFrom;u<i;u++)a+=o[u].size;if(a!=t){if(r>0){if(i==o.length-1)return null;s=a+o[i].size-t,i++}else s=a-t;t+=s,n+=s}while(Vi(e.doc,n)!=n){if(i==(r<0?0:o.length-1))return null;n+=r*o[i-(r<0?1:0)].size,i+=r}return{index:i,lineN:n}}function Fn(e,t,n){var r=e.display,i=r.view;i.length==0||t>=r.viewTo||n<=r.viewFrom?(r.view=_n(e,t,n),r.viewFrom=t):(r.viewFrom>t?r.view=_n(e,t,r.viewFrom).concat(r.view):r.viewFrom<t&&(r.view=r.view.slice(Bn(e,t))),r.viewFrom=t,r.viewTo<n?r.view=r.view.concat(_n(e,r.viewTo,n)):r.viewTo>n&&(r.view=r.view.slice(0,Bn(e,n)))),r.viewTo=n}function In(e){var t=e.display.view,n=0;for(var r=0;r<t.length;r++){var i=t[r];!i.hidden&&(!i.node||i.changes)&&++n}return n}function qn(e){if(e.display.pollingFast)return;e.display.poll.set(e.options.pollInterval,function(){Un(e),e.state.focused&&qn(e)})}function Rn(e){function n(){var r=Un(e);!r&&!t?(t=!0,e.display.poll.set(60,n)):(e.display.pollingFast=!1,qn(e))}var t=!1;e.display.pollingFast=!0,e.display.poll.set(20,n)}function Un(e){var t=e.display.input,n=e.display.prevInput,s=e.doc;if(!e.state.focused||au(t)&&!n||Vn(e)||e.options.disableInput)return!1;e.state.pasteIncoming&&e.state.fakedLastChar&&(t.value=t.value.substring(0,t.value.length-1),e.state.fakedLastChar=!1);var o=t.value;if(o==n&&!e.somethingSelected())return!1;if(r&&i>=9&&e.display.inputHasSelection===o)return zn(e),!1;var u=!e.curOp;u&&Nn(e),e.display.shift=!1,o.charCodeAt(0)==8203&&s.sel==e.display.selForContextMenu&&!n&&(n="​");var a=0,f=Math.min(n.length,o.length);while(a<f&&n.charCodeAt(a)==o.charCodeAt(a))++a;var l=o.slice(a),c=uu(l),h=e.state.pasteIncoming&&c.length>1&&s.sel.ranges.length==c.length;for(var p=s.sel.ranges.length-1;p>=0;p--){var d=s.sel.ranges[p],v=d.from(),m=d.to();a<n.length?v=pt(v.line,v.ch-(n.length-a)):e.state.overwrite&&d.empty()&&!e.state.pasteIncoming&&(m=pt(m.line,Math.min(Os(s,m.line).text.length,m.ch+ko(c).length)));var g=e.curOp.updateInput,y={from:v,to:m,text:h?[c[p]]:c,origin:e.state.pasteIncoming?"paste":e.state.cutIncoming?"cut":"+input"};Dr(e.doc,y),lo(e,"inputRead",e,y);if(l&&!e.state.pasteIncoming&&e.options.electricChars&&e.options.smartIndent&&d.head.ch<100&&(!p||s.sel.ranges[p-1].head.line!=d.head.line)){var b=e.getModeAt(d.head);if(b.electricChars){for(var w=0;w<b.electricChars.length;w++)if(l.indexOf(b.electricChars.charAt(w))>-1){$r(e,d.head.line,"smart");break}}else if(b.electricInput){var E=kr(y);b.electricInput.test(Os(s,E.line).text.slice(0,E.ch))&&$r(e,d.head.line,"smart")}}}return Xr(e),e.curOp.updateInput=g,e.curOp.typing=!0,o.length>1e3||o.indexOf("\n")>-1?t.value=e.display.prevInput="":e.display.prevInput=o,u&&Cn(e),e.state.pasteIncoming=e.state.cutIncoming=!1,!0}function zn(e,t){var n,s,o=e.doc;if(e.somethingSelected()){e.display.prevInput="";var u=o.sel.primary();n=fu&&(u.to().line-u.from().line>100||(s=e.getSelection()).length>1e3);var a=n?"-":s||e.getSelection();e.display.input.value=a,e.state.focused&&Lo(e.display.input),r&&i>=9&&(e.display.inputHasSelection=a)}else t||(e.display.prevInput=e.display.input.value="",r&&i>=9&&(e.display.inputHasSelection=null));e.display.inaccurateSelection=n}function Wn(e){e.options.readOnly!="nocursor"&&(!d||Xo()!=e.display.input)&&e.display.input.focus()}function Xn(e){e.state.focused||(Wn(e),xr(e))}function Vn(e){return e.options.readOnly||e.doc.cantEdit}function $n(e){function n(){e.state.focused&&setTimeout(Do(Wn,e),0)}function o(t){ho(e,t)||no(t)}function u(n){if(ho(e,n)||Kn(t,n))return;if(e.somethingSelected())t.inaccurateSelection&&(t.prevInput="",t.inaccurateSelection=!1,t.input.value=e.getSelection(),Lo(t.input));else{var r="",i=[];for(var s=0;s<e.doc.sel.ranges.length;s++){var o=e.doc.sel.ranges[s].head.line,u={anchor:pt(o,0),head:pt(o+1,0)};i.push(u),r+=e.getRange(u.anchor,u.head)}n.type=="cut"?e.setSelections(i,null,bo):(t.prevInput="",t.input.value=r,Lo(t.input))}n.type=="cut"&&(e.state.cutIncoming=!0)}var t=e.display;so(t.scroller,"mousedown",Ln(e,Gn)),r&&i<11?so(t.scroller,"dblclick",Ln(e,function(t){if(ho(e,t))return;var n=Qn(e,t);if(!n||ir(e,t)||Kn(e.display,t))return;Zs(t);var r=Yr(e,n);Lt(e.doc,r.anchor,r.head)})):so(t.scroller,"dblclick",function(t){ho(e,t)||Zs(t)}),so(t.lineSpace,"selectstart",function(e){Kn(t,e)||Zs(e)}),b||so(t.scroller,"contextmenu",function(t){Nr(e,t)}),so(t.scroller,"scroll",function(){t.scroller.clientHeight&&(ar(e,t.scroller.scrollTop),fr(e,t.scroller.scrollLeft,!0),uo(e,"scroll",e))}),so(t.scrollbarV,"scroll",function(){t.scroller.clientHeight&&ar(e,t.scrollbarV.scrollTop)}),so(t.scrollbarH,"scroll",function(){t.scroller.clientHeight&&fr(e,t.scrollbarH.scrollLeft)}),so(t.scroller,"mousewheel",function(t){hr(e,t)}),so(t.scroller,"DOMMouseScroll",function(t){hr(e,t)}),so(t.scrollbarH,"mousedown",n),so(t.scrollbarV,"mousedown",n),so(t.wrapper,"scroll",function(){t.wrapper.scrollTop=t.wrapper.scrollLeft=0}),so(t.input,"keyup",Ln(e,Er)),so(t.input,"input",function(){r&&i>=9&&e.display.inputHasSelection&&(e.display.inputHasSelection=null),Rn(e)}),so(t.input,"keydown",Ln(e,br)),so(t.input,"keypress",Ln(e,Sr)),so(t.input,"focus",Do(xr,e)),so(t.input,"blur",Do(Tr,e)),e.options.dragDrop&&(so(t.scroller,"dragstart",function(t){ur(e,t)}),so(t.scroller,"drag",o),so(t.scroller,"dragend",o),so(t.scroller,"dragenter",o),so(t.scroller,"dragover",o),so(t.scroller,"dragleave",o),so(t.scroller,"drop",Ln(e,or))),so(t.scroller,"paste",function(n){if(ho(e,n)||Kn(t,n))return;e.state.pasteIncoming=!0,Wn(e),Rn(e)}),so(t.input,"paste",function(n){if(ho(e,n)||Kn(t,n))return;if(s&&!e.state.fakedLastChar&&!(new Date-e.state.lastMiddleDown<200)){var r=t.input.selectionStart,i=t.input.selectionEnd;t.input.value+="$",t.input.selectionStart=r,t.input.selectionEnd=i,e.state.fakedLastChar=!0}e.state.pasteIncoming=!0,Rn(e)}),so(t.input,"cut",u),so(t.input,"copy",u),l&&so(t.sizer,"mouseup",function(){Xo()==t.input&&t.input.blur(),Wn(e)})}function Jn(e){var t=e.display;t.cachedCharWidth=t.cachedTextHeight=t.cachedPaddingH=null,e.setSize()}function Kn(e,t){for(var n=ro(t);n!=e.wrapper;n=n.parentNode)if(!n||n.ignoreEvents||n.parentNode==e.sizer&&n!=e.mover)return!0}function Qn(e,t,n,r){var i=e.display;if(!n){var s=ro(t);if(s==i.scrollbarH||s==i.scrollbarV||s==i.scrollbarFiller||s==i.gutterFiller)return null}var o,u,a=i.lineSpace.getBoundingClientRect();try{o=t.clientX-a.left,u=t.clientY-a.top}catch(t){return null}var f=yn(e,o,u),l;if(r&&f.xRel==1&&(l=Os(e.doc,f.line).text).length==f.ch){var c=xo(l,l.length,e.options.tabSize)-l.length;f=pt(f.line,Math.max(0,Math.round((o-Qt(e.display).left)/Sn(e.display))-c))}return f}function Gn(e){if(ho(this,e))return;var t=this,n=t.display;n.shift=e.shiftKey;if(Kn(n,e)){s||(n.scroller.draggable=!1,setTimeout(function(){n.scroller.draggable=!0},100));return}if(ir(t,e))return;var r=Qn(t,e);window.focus();switch(io(e)){case 1:r?er(t,e,r):ro(e)==n.scroller&&Zs(e);break;case 2:s&&(t.state.lastMiddleDown=+(new Date)),r&&Lt(t.doc,r),setTimeout(Do(Wn,t),20),Zs(e);break;case 3:b&&Nr(t,e)}}function er(e,t,n){setTimeout(Do(Xn,e),0);var r=+(new Date),i;Zn&&Zn.time>r-400&&dt(Zn.pos,n)==0?i="triple":Yn&&Yn.time>r-400&&dt(Yn.pos,n)==0?(i="double",Zn={time:r,pos:n}):(i="single",Yn={time:r,pos:n});var s=e.doc.sel,o=v?t.metaKey:t.ctrlKey;e.options.dragDrop&&eu&&!Vn(e)&&i=="single"&&s.contains(n)>-1&&s.somethingSelected()?tr(e,t,n,o):nr(e,t,n,i,o)}function tr(e,t,n,o){var u=e.display,a=Ln(e,function(f){s&&(u.scroller.draggable=!1),e.state.draggingText=!1,oo(document,"mouseup",a),oo(u.scroller,"drop",a),Math.abs(t.clientX-f.clientX)+Math.abs(t.clientY-f.clientY)<10&&(Zs(f),o||Lt(e.doc,n),Wn(e),r&&i==9&&setTimeout(function(){document.body.focus(),Wn(e)},20))});s&&(u.scroller.draggable=!0),e.state.draggingText=a,u.scroller.dragDrop&&u.scroller.dragDrop(),so(document,"mouseup",a),so(u.scroller,"drop",a)}function nr(e,t,n,r,i){function p(t){if(dt(h,t)==0)return;h=t;if(r=="rect"){var i=[],s=e.options.tabSize,l=xo(Os(o,n.line).text,n.ch,s),c=xo(Os(o,t.line).text,t.ch,s),p=Math.min(l,c),d=Math.max(l,c);for(var v=Math.min(n.line,t.line),m=Math.min(e.lastLine(),Math.max(n.line,t.line));v<=m;v++){var g=Os(o,v).text,y=To(g,p,s);p==d?i.push(new bt(pt(v,y),pt(v,y))):g.length>y&&i.push(new bt(pt(v,y),pt(v,To(g,d,s))))}i.length||i.push(new bt(n,n)),Pt(o,wt(f.ranges.slice(0,a).concat(i),a),{origin:"*mouse",scroll:!1}),e.scrollIntoView(t)}else{var b=u,w=b.anchor,E=t;if(r!="single"){if(r=="double")var S=Yr(e,t);else var S=new bt(pt(t.line,0),xt(o,pt(t.line+1,0)));dt(S.anchor,w)>0?(E=S.head,w=gt(b.from(),S.anchor)):(E=S.anchor,w=mt(b.to(),S.head))}var i=f.ranges.slice(0);i[a]=new bt(xt(o,w),E),Pt(o,wt(i,a),wo)}}function m(t){var n=++v,i=Qn(e,t,!0,r=="rect");if(!i)return;if(dt(i,h)!=0){Xn(e),p(i);var u=q(s,o);(i.line>=u.to||i.line<u.from)&&setTimeout(Ln(e,function(){v==n&&m(t)}),150)}else{var a=t.clientY<d.top?-20:t.clientY>d.bottom?20:0;a&&setTimeout(Ln(e,function(){if(v!=n)return;s.scroller.scrollTop+=a,m(t)}),50)}}function g(t){v=Infinity,Zs(t),Wn(e),oo(document,"mousemove",y),oo(document,"mouseup",b),o.history.lastSelOrigin=null}var s=e.display,o=e.doc;Zs(t);var u,a,f=o.sel;i&&!t.shiftKey?(a=o.sel.contains(n),a>-1?u=o.sel.ranges[a]:u=new bt(n,n)):u=o.sel.primary();if(t.altKey)r="rect",i||(u=new bt(n,n)),n=Qn(e,t,!0,!0),a=-1;else if(r=="double"){var l=Yr(e,n);e.display.shift||o.extend?u=kt(o,u,l.anchor,l.head):u=l}else if(r=="triple"){var c=new bt(pt(n.line,0),xt(o,pt(n.line+1,0)));e.display.shift||o.extend?u=kt(o,u,c.anchor,c.head):u=c}else u=kt(o,u,n);i?a>-1?Ot(o,a,u,wo):(a=o.sel.ranges.length,Pt(o,wt(o.sel.ranges.concat([u]),a),{scroll:!1,origin:"*mouse"})):(a=0,Pt(o,new yt([u],0),wo),f=o.sel);var h=n,d=s.wrapper.getBoundingClientRect(),v=0,y=Ln(e,function(e){io(e)?m(e):g(e)}),b=Ln(e,g);so(document,"mousemove",y),so(document,"mouseup",b)}function rr(e,t,n,r,i){try{var s=t.clientX,o=t.clientY}catch(t){return!1}if(s>=Math.floor(e.display.gutters.getBoundingClientRect().right))return!1;r&&Zs(t);var u=e.display,a=u.lineDiv.getBoundingClientRect();if(o>a.bottom||!vo(e,n))return to(t);o-=a.top-u.viewOffset;for(var f=0;f<e.options.gutters.length;++f){var l=u.gutters.childNodes[f];if(l&&l.getBoundingClientRect().right>=s){var c=Hs(e.doc,o),h=e.options.gutters[f];return i(e,n,e,c,h,t),to(t)}}}function ir(e,t){return rr(e,t,"gutterClick",!0,lo)}function or(e){var t=this;if(ho(t,e)||Kn(t.display,e))return;Zs(e),r&&(sr=+(new Date));var n=Qn(t,e,!0),i=e.dataTransfer.files;if(!n||Vn(t))return;var s=null;t.options.textForDropEvent&&(s=t.options.textForDropEvent(e));if(s===null&&i&&i.length&&window.FileReader&&window.File){var o=i.length,u=Array(o),a=0,f=function(e,r){var i=new FileReader;i.onload=Ln(t,function(){u[r]=i.result;if(++a==o){n=xt(t.doc,n);var e={from:n,to:n,text:uu(u.join("\n")),origin:"+paste"};Dr(t.doc,e),Dt(t.doc,Et(n,kr(e)))}}),i.readAsText(e)};for(var l=0;l<o;++l)f(i[l],l)}else{if(t.state.draggingText&&t.doc.sel.contains(n)>-1){t.state.draggingText(e),setTimeout(Do(Wn,t),20);return}try{var u=s?s:e.dataTransfer.getData("Text");if(u){if(t.state.draggingText&&(v?!e.metaKey:!e.ctrlKey))var c=t.listSelections();Ht(t.doc,Et(n,n));if(!s&&c)for(var l=0;l<c.length;++l)Ir(t.doc,"",c[l].anchor,c[l].head,"drag");t.replaceSelection(u,"around","+paste"),Wn(t)}}catch(e){}}}function ur(e,t){if(r&&(!e.state.draggingText||+(new Date)-sr<100)){no(t);return}if(ho(e,t)||Kn(e.display,t))return;t.dataTransfer.setData("Text",e.getSelection());if(t.dataTransfer.setDragImage&&!f){var n=qo("img",null,null,"position: fixed; left: 0; top: 0;");n.src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==",a&&(n.width=n.height=1,e.display.wrapper.appendChild(n),n._top=n.offsetTop),t.dataTransfer.setDragImage(n,0,0),a&&n.parentNode.removeChild(n)}}function ar(t,n){if(Math.abs(t.doc.scrollTop-n)<2)return;t.doc.scrollTop=n,e||X(t,{top:n}),t.display.scroller.scrollTop!=n&&(t.display.scroller.scrollTop=n),t.display.scrollbarV.scrollTop!=n&&(t.display.scrollbarV.scrollTop=n),e&&X(t),Wt(t,100)}function fr(e,t,n){if(n?t==e.doc.scrollLeft:Math.abs(e.doc.scrollLeft-t)<2)return;t=Math.min(t,e.display.scroller.scrollWidth-e.display.scroller.clientWidth),e.doc.scrollLeft=t,R(e),e.display.scroller.scrollLeft!=t&&(e.display.scroller.scrollLeft=t),e.display.scrollbarH.scrollLeft!=t&&(e.display.scrollbarH.scrollLeft=t)}function hr(t,n){var r=n.wheelDeltaX,i=n.wheelDeltaY;r==null&&n.detail&&n.axis==n.HORIZONTAL_AXIS&&(r=n.detail),i==null&&n.detail&&n.axis==n.VERTICAL_AXIS?i=n.detail:i==null&&(i=n.wheelDelta);var o=t.display,u=o.scroller;if(!(r&&u.scrollWidth>u.clientWidth||i&&u.scrollHeight>u.clientHeight))return;if(i&&v&&s)e:for(var f=n.target,l=o.view;f!=u;f=f.parentNode)for(var c=0;c<l.length;c++)if(l[c].node==f){t.display.currentWheelTarget=f;break e}if(r&&!e&&!a&&cr!=null){i&&ar(t,Math.max(0,Math.min(u.scrollTop+i*cr,u.scrollHeight-u.clientHeight))),fr(t,Math.max(0,Math.min(u.scrollLeft+r*cr,u.scrollWidth-u.clientWidth))),Zs(n),o.wheelStartX=null;return}if(i&&cr!=null){var h=i*cr,p=t.doc.scrollTop,d=p+o.wrapper.clientHeight;h<0?p=Math.max(0,p+h-50):d=Math.min(t.doc.height,d+h+50),X(t,{top:p,bottom:d})}lr<20&&(o.wheelStartX==null?(o.wheelStartX=u.scrollLeft,o.wheelStartY=u.scrollTop,o.wheelDX=r,o.wheelDY=i,setTimeout(function(){if(o.wheelStartX==null)return;var e=u.scrollLeft-o.wheelStartX,t=u.scrollTop-o.wheelStartY,n=t&&o.wheelDY&&t/o.wheelDY||e&&o.wheelDX&&e/o.wheelDX;o.wheelStartX=o.wheelStartY=null;if(!n)return;cr=(cr*lr+n)/(lr+1),++lr},200)):(o.wheelDX+=r,o.wheelDY+=i))}function pr(e,t,n){if(typeof t=="string"){t=li[t];if(!t)return!1}e.display.pollingFast&&Un(e)&&(e.display.pollingFast=!1);var r=e.display.shift,i=!1;try{Vn(e)&&(e.state.suppressEdits=!0),n&&(e.display.shift=!1),i=t(e)!=yo}finally{e.display.shift=r,e.state.suppressEdits=!1}return i}function dr(e){var t=e.state.keyMaps.slice(0);return e.options.extraKeys&&t.push(e.options.extraKeys),t.push(e.options.keyMap),t}function mr(e,t){var n=hi(e.options.keyMap),r=n.auto;clearTimeout(vr),r&&!di(t)&&(vr=setTimeout(function(){hi(e.options.keyMap)==n&&(e.options.keyMap=r.call?r.call(null,e):r,A(e))},50));var i=vi(t,!0),s=!1;if(!i)return!1;var o=dr(e);return t.shiftKey?s=pi("Shift-"+i,o,function(t){return pr(e,t,!0)})||pi(i,o,function(t){if(typeof t=="string"?/^go[A-Z]/.test(t):t.motion)return pr(e,t)}):s=pi(i,o,function(t){return pr(e,t)}),s&&(Zs(t),zt(e),lo(e,"keyHandled",e,i,t)),s}function gr(e,t,n){var r=pi("'"+n+"'",dr(e),function(t){return pr(e,t,!0)});return r&&(Zs(t),zt(e),lo(e,"keyHandled",e,"'"+n+"'",t)),r}function br(e){var t=this;Xn(t);if(ho(t,e))return;r&&i<11&&e.keyCode==27&&(e.returnValue=!1);var n=e.keyCode;t.display.shift=n==16||e.shiftKey;var s=mr(t,e);a&&(yr=s?n:null,!s&&n==88&&!fu&&(v?e.metaKey:e.ctrlKey)&&t.replaceSelection("",null,"cut")),n==18&&!/\bCodeMirror-crosshair\b/.test(t.display.lineDiv.className)&&wr(t)}function wr(e){function n(e){if(e.keyCode==18||!e.altKey)$o(t,"CodeMirror-crosshair"),oo(document,"keyup",n),oo(document,"mouseover",n)}var t=e.display.lineDiv;Jo(t,"CodeMirror-crosshair"),so(document,"keyup",n),so(document,"mouseover",n)}function Er(e){if(ho(this,e))return;e.keyCode==16&&(this.doc.sel.shift=!1)}function Sr(e){var t=this;if(ho(t,e)||e.ctrlKey||v&&e.metaKey)return;var n=e.keyCode,s=e.charCode;if(a&&n==yr){yr=null,Zs(e);return}if((a&&(!e.which||e.which<10)||l)&&mr(t,e))return;var o=String.fromCharCode(s==null?n:s);if(gr(t,e,o))return;r&&i>=9&&(t.display.inputHasSelection=null),Rn(t)}function xr(e){if(e.options.readOnly=="nocursor")return;e.state.focused||(uo(e,"focus",e),e.state.focused=!0,Jo(e.display.wrapper,"CodeMirror-focused"),!e.curOp&&e.display.selForContextMenu!=e.doc.sel&&(zn(e),s&&setTimeout(Do(zn,e,!0),0))),qn(e),zt(e)}function Tr(e){e.state.focused&&(uo(e,"blur",e),e.state.focused=!1,$o(e.display.wrapper,"CodeMirror-focused")),clearInterval(e.display.blinker),setTimeout(function(){e.state.focused||(e.display.shift=!1)},150)}function Nr(e,t){function l(){if(n.input.selectionStart!=null){var t=e.somethingSelected(),r=n.input.value="​"+(t?n.input.value:"");n.prevInput=t?"":"​",n.input.selectionStart=1,n.input.selectionEnd=r.length,n.selForContextMenu=e.doc.sel}}function c(){n.inputDiv.style.position="relative",n.input.style.cssText=f,r&&i<9&&(n.scrollbarV.scrollTop=n.scroller.scrollTop=o),qn(e);if(n.input.selectionStart!=null){(!r||r&&i<9)&&l();var t=0,s=function(){n.selForContextMenu==e.doc.sel&&n.input.selectionStart==0?Ln(e,li.selectAll)(e):t++<10?n.detectingSelectAll=setTimeout(s,500):zn(e)};n.detectingSelectAll=setTimeout(s,200)}}if(ho(e,t,"contextmenu"))return;var n=e.display;if(Kn(n,t)||Cr(e,t))return;var s=Qn(e,t),o=n.scroller.scrollTop;if(!s||a)return;var u=e.options.resetSelectionOnContextMenu;u&&(!e.doc.sel.somethingSelected()||e.doc.sel.contains(s)==-1)&&Ln(e,Pt)(e.doc,new yt([Yr(e,s)],0),bo);var f=n.input.style.cssText;n.inputDiv.style.position="absolute",n.input.style.cssText="position: fixed; width: 30px; height: 30px; top: "+(t.clientY-5)+"px; left: "+(t.clientX-5)+"px; z-index: 1000; background: "+(r?"rgba(255, 255, 255, .05)":"transparent")+"; outline: none; border-width: 0; outline: none; overflow: hidden; opacity: .05; filter: alpha(opacity=5);",Wn(e),zn(e),e.somethingSelected()||(n.input.value=n.prevInput=" "),n.selForContextMenu=e.doc.sel,clearTimeout(n.detectingSelectAll),r&&i>=9&&l();if(b){no(t);var h=function(){oo(window,"mouseup",h),setTimeout(c,20)};so(window,"mouseup",h)}else setTimeout(c,50)}function Cr(e,t){return vo(e,"gutterContextMenu")?rr(e,t,"gutterContextMenu",!1,uo):!1}function Lr(e,t){if(dt(e,t.from)<0)return e;if(dt(e,t.to)<=0)return kr(t);var n=e.line+t.text.length-(t.to.line-t.from.line)-1,r=e.ch;return e.line==t.to.line&&(r+=kr(t).ch-t.to.ch),pt(n,r)}function Ar(e,t){var n=[];for(var r=0;r<e.sel.ranges.length;r++){var i=e.sel.ranges[r];n.push(new bt(Lr(i.anchor,t),Lr(i.head,t)))}return wt(n,e.sel.primIndex)}function Or(e,t,n){return e.line==t.line?pt(n.line,e.ch-t.ch+n.ch):pt(n.line+(e.line-t.line),e.ch)}function Mr(e,t,n){var r=[],i=pt(e.first,0),s=i;for(var o=0;o<t.length;o++){var u=t[o],a=Or(u.from,i,s),f=Or(kr(u),i,s);i=u.to,s=f;if(n=="around"){var l=e.sel.ranges[o],c=dt(l.head,l.anchor)<0;r[o]=new bt(c?f:a,c?a:f)}else r[o]=new bt(a,a)}return new yt(r,e.sel.primIndex)}function _r(e,t,n){var r={canceled:!1,from:t.from,to:t.to,text:t.text,origin:t.origin,cancel:function(){this.canceled=!0}};return n&&(r.update=function(t,n,r,i){t&&(this.from=xt(e,t)),n&&(this.to=xt(e,n)),r&&(this.text=r),i!==undefined&&(this.origin=i)}),uo(e,"beforeChange",e,r),e.cm&&uo(e.cm,"beforeChange",e.cm,r),r.canceled?null:{from:r.from,to:r.to,text:r.text,origin:r.origin}}function Dr(e,t,n){if(e.cm){if(!e.cm.curOp)return Ln(e.cm,Dr)(e,t,n);if(e.cm.state.suppressEdits)return}if(vo(e,"beforeChange")||e.cm&&vo(e.cm,"beforeChange")){t=_r(e,t,!0);if(!t)return}var r=w&&!n&&Pi(e,t.from,t.to);if(r)for(var i=r.length-1;i>=0;--i)Pr(e,{from:r[i].from,to:r[i].to,text:i?[""]:t.text});else Pr(e,t)}function Pr(e,t){if(t.text.length==1&&t.text[0]==""&&dt(t.from,t.to)==0)return;var n=Ar(e,t);Us(e,t,n,e.cm?e.cm.curOp.id:NaN),jr(e,t,n,Mi(e,t));var r=[];Ls(e,function(e,n){!n&&Ao(r,e.history)==-1&&(Ys(e.history,t),r.push(e.history)),jr(e,t,null,Mi(e,t))})}function Hr(e,t,n){if(e.cm&&e.cm.state.suppressEdits)return;var r=e.history,i,s=e.sel,o=t=="undo"?r.done:r.undone,u=t=="undo"?r.undone:r.done;for(var a=0;a<o.length;a++){i=o[a];if(n?i.ranges&&!i.equals(e.sel):!i.ranges)break}if(a==o.length)return;r.lastOrigin=r.lastSelOrigin=null;for(;;){i=o.pop();if(!i.ranges)break;Xs(i,u);if(n&&!i.equals(e.sel)){Pt(e,i,{clearRedo:!1});return}s=i}var f=[];Xs(s,u),u.push({changes:f,generation:r.generation}),r.generation=i.generation||++r.maxGeneration;var l=vo(e,"beforeChange")||e.cm&&vo(e.cm,"beforeChange");for(var a=i.changes.length-1;a>=0;--a){var c=i.changes[a];c.origin=t;if(l&&!_r(e,c,!1)){o.length=0;return}f.push(Is(e,c));var h=a?Ar(e,c,null):ko(o);jr(e,c,h,Di(e,c)),!a&&e.cm&&e.cm.scrollIntoView(c);var p=[];Ls(e,function(e,t){!t&&Ao(p,e.history)==-1&&(Ys(e.history,c),p.push(e.history)),jr(e,c,null,Di(e,c))})}}function Br(e,t){if(t==0)return;e.first+=t,e.sel=new yt(Oo(e.sel.ranges,function(e){return new bt(pt(e.anchor.line+t,e.anchor.ch),pt(e.head.line+t,e.head.ch))}),e.sel.primIndex);if(e.cm){Dn(e.cm,e.first,e.first-t,t);for(var n=e.cm.display,r=n.viewFrom;r<n.viewTo;r++)Pn(e.cm,r,"gutter")}}function jr(e,t,n,r){if(e.cm&&!e.cm.curOp)return Ln(e.cm,jr)(e,t,n,r);if(t.to.line<e.first){Br(e,t.text.length-1-(t.to.line-t.from.line));return}if(t.from.line>e.lastLine())return;if(t.from.line<e.first){var i=t.text.length-1-(e.first-t.from.line);Br(e,i),t={from:pt(e.first,0),to:pt(t.to.line+i,t.to.ch),text:[ko(t.text)],origin:t.origin}}var s=e.lastLine();t.to.line>s&&(t={from:t.from,to:pt(s,Os(e,s).text.length),text:[t.text[0]],origin:t.origin}),t.removed=Ms(e,t.from,t.to),n||(n=Ar(e,t,null)),e.cm?Fr(e.cm,t,r):Es(e,t,r),Ht(e,n,bo),e.cm&&vo(e.cm,"justChanged")&&uo(e.cm,"justChanged",e.cm,t)}function Fr(e,t,n){var r=e.doc,i=e.display,s=t.from,o=t.to,u=!1,a=s.line;e.options.lineWrapping||(a=Ps(Wi(Os(r,s.line))),r.iter(a,o.line+1,function(e){if(e==i.maxLine)return u=!0,!0})),r.sel.contains(t.from,t.to)>-1&&po(e),Es(r,t,n,k(e)),e.options.lineWrapping||(r.iter(a,s.line+t.text.length,function(e){var t=P(e);t>i.maxLineLength&&(i.maxLine=e,i.maxLineLength=t,i.maxLineChanged=!0,u=!1)}),u&&(e.curOp.updateMaxLine=!0)),r.frontier=Math.min(r.frontier,s.line),Wt(e,400);var f=t.text.length-(o.line-s.line)-1;s.line==o.line&&t.text.length==1&&!ws(e.doc,t)?Pn(e,s.line,"text"):Dn(e,s.line,o.line+1,f);var l=vo(e,"changes"),c=vo(e,"change");if(c||l){var h={from:s,to:o,text:t.text,removed:t.removed,origin:t.origin};c&&lo(e,"change",e,h),l&&(e.curOp.changeObjs||(e.curOp.changeObjs=[])).push(h)}e.display.selForContextMenu=null}function Ir(e,t,n,r,i){r||(r=n);if(dt(r,n)<0){var s=r;r=n,n=s}typeof t=="string"&&(t=uu(t)),Dr(e,{from:n,to:r,text:t,origin:i})}function qr(e,t){var n=e.display,r=n.sizer.getBoundingClientRect(),i=null;t.top+r.top<0?i=!0:t.bottom+r.top>(window.innerHeight||document.documentElement.clientHeight)&&(i=!1);if(i!=null&&!h){var s=qo("div","​",null,"position: absolute; top: "+(t.top-n.viewOffset-Jt(e.display))+"px; height: "+(t.bottom-t.top+go)+"px; left: "+t.left+"px; width: 2px;");e.display.lineSpace.appendChild(s),s.scrollIntoView(i),e.display.lineSpace.removeChild(s)}}function Rr(e,t,n,r,i){r==null&&(r=0),i==null&&(i=0);for(;;){var s=!1,o=vn(e,t),u=!n||n==t?o:vn(e,n),a=zr(e,Math.min(o.left,u.left),Math.min(o.top,u.top)-r,Math.max(o.left,u.left),Math.max(o.bottom,u.bottom)+i),f=e.doc.scrollTop,l=e.doc.scrollLeft;a.scrollTop!=null&&(ar(e,a.scrollTop),Math.abs(e.doc.scrollTop-f)>1&&(s=!0)),a.scrollLeft!=null&&(fr(e,a.scrollLeft),Math.abs(e.doc.scrollLeft-l)>1&&(s=!0));if(!s)return o}}function Ur(e,t,n,r,i){var s=zr(e,t,n,r,i);s.scrollTop!=null&&ar(e,s.scrollTop),s.scrollLeft!=null&&fr(e,s.scrollLeft)}function zr(e,t,n,r,i){var s=e.display,o=En(e.display);n<0&&(n=0);var u=e.curOp&&e.curOp.scrollTop!=null?e.curOp.scrollTop:s.scroller.scrollTop,a=s.scroller.clientHeight-go,f={},l=e.doc.height+Kt(s),c=n<o,h=i>l-o;if(n<u)f.scrollTop=c?0:n;else if(i>u+a){var p=Math.min(n,(h?l:i)-a);p!=u&&(f.scrollTop=p)}var d=e.curOp&&e.curOp.scrollLeft!=null?e.curOp.scrollLeft:s.scroller.scrollLeft,v=s.scroller.clientWidth-go;t+=s.gutters.offsetWidth,r+=s.gutters.offsetWidth;var m=s.gutters.offsetWidth,g=t<m+10;return t<d+m||g?(g&&(t=0),f.scrollLeft=Math.max(0,t-10-m)):r>v+d-3&&(f.scrollLeft=r+10-v),f}function Wr(e,t,n){(t!=null||n!=null)&&Vr(e),t!=null&&(e.curOp.scrollLeft=(e.curOp.scrollLeft==null?e.doc.scrollLeft:e.curOp.scrollLeft)+t),n!=null&&(e.curOp.scrollTop=(e.curOp.scrollTop==null?e.doc.scrollTop:e.curOp.scrollTop)+n)}function Xr(e){Vr(e);var t=e.getCursor(),n=t,r=t;e.options.lineWrapping||(n=t.ch?pt(t.line,t.ch-1):t,r=pt(t.line,t.ch+1)),e.curOp.scrollToPos={from:n,to:r,margin:e.options.cursorScrollMargin,isCursor:!0}}function Vr(e){var t=e.curOp.scrollToPos;if(t){e.curOp.scrollToPos=null;var n=mn(e,t.from),r=mn(e,t.to),i=zr(e,Math.min(n.left,r.left),Math.min(n.top,r.top)-t.topMargin,Math.max(n.right,r.right),Math.max(n.bottom,r.bottom)+t.bottomMargin);e.scrollTo(i.scrollLeft,i.scrollTop)}}function $r(e,t,n,r){var i=e.doc,s;n==null&&(n="add"),n=="smart"&&(e.doc.mode.indent?s=$t(e,t):n="prev");var o=e.options.tabSize,u=Os(i,t),a=xo(u.text,null,o);u.stateAfter&&(u.stateAfter=null);var f=u.text.match(/^\s*/)[0],l;if(!r&&!/\S/.test(u.text))l=0,n="not";else if(n=="smart"){l=e.doc.mode.indent(s,u.text.slice(f.length),u.text);if(l==yo){if(!r)return;n="prev"}}n=="prev"?t>i.first?l=xo(Os(i,t-1).text,null,o):l=0:n=="add"?l=a+e.options.indentUnit:n=="subtract"?l=a-e.options.indentUnit:typeof n=="number"&&(l=a+n),l=Math.max(0,l);var c="",h=0;if(e.options.indentWithTabs)for(var p=Math.floor(l/o);p;--p)h+=o,c+="	";h<l&&(c+=Co(l-h));if(c!=f)Ir(e.doc,c,pt(t,0),pt(t,f.length),"+input");else for(var p=0;p<i.sel.ranges.length;p++){var d=i.sel.ranges[p];if(d.head.line==t&&d.head.ch<f.length){var h=pt(t,f.length);Ot(i,p,new bt(h,h));break}}u.stateAfter=null}function Jr(e,t,n,r){var i=t,s=t;return typeof t=="number"?s=Os(e,St(e,t)):i=Ps(t),i==null?null:(r(s,i)&&e.cm&&Pn(e.cm,i,n),s)}function Kr(e,t){var n=e.doc.sel.ranges,r=[];for(var i=0;i<n.length;i++){var s=t(n[i]);while(r.length&&dt(s.from,ko(r).to)<=0){var o=r.pop();if(dt(o.from,s.from)<0){s.from=o.from;break}}r.push(s)}kn(e,function(){for(var t=r.length-1;t>=0;t--)Ir(e.doc,"",r[t].from,r[t].to,"+delete");Xr(e)})}function Qr(e,t,n,r,i){function l(){var t=s+n;return t<e.first||t>=e.first+e.size?f=!1:(s=t,a=Os(e,t))}function c(e){var t=(i?Su:xu)(a,o,n,!0);if(t==null){if(!!e||!l())return f=!1;i?o=(n<0?vu:du)(a):o=n<0?a.text.length:0}else o=t;return!0}var s=t.line,o=t.ch,u=n,a=Os(e,s),f=!0;if(r=="char")c();else if(r=="column")c(!0);else if(r=="word"||r=="group"){var h=null,p=r=="group",d=e.cm&&e.cm.getHelper(t,"wordChars");for(var v=!0;;v=!1){if(n<0&&!c(!v))break;var m=a.text.charAt(o)||"\n",g=Bo(m,d)?"w":p&&m=="\n"?"n":!p||/\s/.test(m)?null:"p";p&&!v&&!g&&(g="s");if(h&&h!=g){n<0&&(n=1,c());break}g&&(h=g);if(n>0&&!c(!v))break}}var y=It(e,pt(s,o),u,!0);return f||(y.hitSide=!0),y}function Gr(e,t,n,r){var i=e.doc,s=t.left,o;if(r=="page"){var u=Math.min(e.display.wrapper.clientHeight,window.innerHeight||document.documentElement.clientHeight);o=t.top+n*(u-(n<0?1.5:.5)*En(e.display))}else r=="line"&&(o=n>0?t.bottom+3:t.top-3);for(;;){var a=yn(e,s,o);if(!a.outside)break;if(n<0?o<=0:o>=i.height){a.hitSide=!0;break}o+=n*5}return a}function Yr(e,t){var n=e.doc,r=Os(n,t.line).text,i=t.ch,s=t.ch;if(r){var o=e.getHelper(t,"wordChars");(t.xRel<0||s==r.length)&&i?--i:++s;var u=r.charAt(i),a=Bo(u,o)?function(e){return Bo(e,o)}:/\s/.test(u)?function(e){return/\s/.test(e)}:function(e){return!/\s/.test(e)&&!Bo(e)};while(i>0&&a(r.charAt(i-1)))--i;while(s<r.length&&a(r.charAt(s)))++s}return new bt(pt(t.line,i),pt(t.line,s))}function ti(e,t,n,r){S.defaults[e]=t,n&&(ei[e]=r?function(e,t,r){r!=ni&&n(e,t,r)}:n)}function hi(e){return typeof e=="string"?ci[e]:e}function bi(e,t,n,r,i){if(r&&r.shared)return Ei(e,t,n,r,i);if(e.cm&&!e.cm.curOp)return Ln(e.cm,bi)(e,t,n,r,i);var s=new gi(e,i),o=dt(t,n);r&&_o(r,s,!1);if(o>0||o==0&&s.clearWhenEmpty!==!1)return s;s.replacedWith&&(s.collapsed=!0,s.widgetNode=qo("span",[s.replacedWith],"CodeMirror-widget"),r.handleMouseEvents||(s.widgetNode.ignoreEvents=!0),r.insertLeft&&(s.widgetNode.insertLeft=!0));if(s.collapsed){if(zi(e,t.line,t,n,s)||t.line!=n.line&&zi(e,n.line,t,n,s))throw new Error("Inserting collapsed marker partially overlapping an existing one");E=!0}s.addToHistory&&Us(e,{from:t,to:n,origin:"markText"},e.sel,NaN);var u=t.line,a=e.cm,f;e.iter(u,n.line+1,function(e){a&&s.collapsed&&!a.options.lineWrapping&&Wi(e)==a.display.maxLine&&(f=!0),s.collapsed&&u!=t.line&&Ds(e,0),Li(e,new Ni(s,u==t.line?t.ch:null,u==n.line?n.ch:null)),++u}),s.collapsed&&e.iter(t.line,n.line+1,function(t){Ji(e,t)&&Ds(t,0)}),s.clearOnEnter&&so(s,"beforeCursorEnter",function(){s.clear()}),s.readOnly&&(w=!0,(e.history.done.length||e.history.undone.length)&&e.clearHistory()),s.collapsed&&(s.id=++yi,s.atomic=!0);if(a){f&&(a.curOp.updateMaxLine=!0);if(s.collapsed)Dn(a,t.line,n.line+1);else if(s.className||s.title||s.startStyle||s.endStyle)for(var l=t.line;l<=n.line;l++)Pn(a,l,"text");s.atomic&&jt(a.doc),lo(a,"markerAdded",a,s)}return s}function Ei(e,t,n,r,i){r=_o(r),r.shared=!1;var s=[bi(e,t,n,r,i)],o=s[0],u=r.widgetNode;return Ls(e,function(e){u&&(r.widgetNode=u.cloneNode(!0)),s.push(bi(e,xt(e,t),xt(e,n),r,i));for(var a=0;a<e.linked.length;++a)if(e.linked[a].isParent)return;o=ko(s)}),new wi(s,o)}function Si(e){return e.findMarks(pt(e.first,0),e.clipPos(pt(e.lastLine())),function(e){return e.parent})}function xi(e,t){for(var n=0;n<t.length;n++){var r=t[n],i=r.find(),s=e.clipPos(i.from),o=e.clipPos(i.to);if(dt(s,o)){var u=bi(e,s,o,r.primary,r.primary.type);r.markers.push(u),u.parent=r}}}function Ti(e){for(var t=0;t<e.length;t++){var n=e[t],r=[n.primary.doc];Ls(n.primary.doc,function(e){r.push(e)});for(var i=0;i<n.markers.length;i++){var s=n.markers[i];Ao(r,s.doc)==-1&&(s.parent=null,n.markers.splice(i--,1))}}}function Ni(e,t,n){this.marker=e,this.from=t,this.to=n}function Ci(e,t){if(e)for(var n=0;n<e.length;++n){var r=e[n];if(r.marker==t)return r}}function ki(e,t){for(var n,r=0;r<e.length;++r)e[r]!=t&&(n||(n=[])).push(e[r]);return n}function Li(e,t){e.markedSpans=e.markedSpans?e.markedSpans.concat([t]):[t],t.marker.attachLine(e)}function Ai(e,t,n){if(e)for(var r=0,i;r<e.length;++r){var s=e[r],o=s.marker,u=s.from==null||(o.inclusiveLeft?s.from<=t:s.from<t);if(u||s.from==t&&o.type=="bookmark"&&(!n||!s.marker.insertLeft)){var a=s.to==null||(o.inclusiveRight?s.to>=t:s.to>t);(i||(i=[])).push(new Ni(o,s.from,a?null:s.to))}}return i}function Oi(e,t,n){if(e)for(var r=0,i;r<e.length;++r){var s=e[r],o=s.marker,u=s.to==null||(o.inclusiveRight?s.to>=t:s.to>t);if(u||s.from==t&&o.type=="bookmark"&&(!n||s.marker.insertLeft)){var a=s.from==null||(o.inclusiveLeft?s.from<=t:s.from<t);(i||(i=[])).push(new Ni(o,a?null:s.from-t,s.to==null?null:s.to-t))}}return i}function Mi(e,t){var n=Nt(e,t.from.line)&&Os(e,t.from.line).markedSpans,r=Nt(e,t.to.line)&&Os(e,t.to.line).markedSpans;if(!n&&!r)return null;var i=t.from.ch,s=t.to.ch,o=dt(t.from,t.to)==0,u=Ai(n,i,o),a=Oi(r,s,o),f=t.text.length==1,l=ko(t.text).length+(f?i:0);if(u)for(var c=0;c<u.length;++c){var h=u[c];if(h.to==null){var p=Ci(a,h.marker);p?f&&(h.to=p.to==null?null:p.to+l):h.to=i}}if(a)for(var c=0;c<a.length;++c){var h=a[c];h.to!=null&&(h.to+=l);if(h.from==null){var p=Ci(u,h.marker);p||(h.from=l,f&&(u||(u=[])).push(h))}else h.from+=l,f&&(u||(u=[])).push(h)}u&&(u=_i(u)),a&&a!=u&&(a=_i(a));var d=[u];if(!f){var v=t.text.length-2,m;if(v>0&&u)for(var c=0;c<u.length;++c)u[c].to==null&&(m||(m=[])).push(new Ni(u[c].marker,null,null));for(var c=0;c<v;++c)d.push(m);d.push(a)}return d}function _i(e){for(var t=0;t<e.length;++t){var n=e[t];n.from!=null&&n.from==n.to&&n.marker.clearWhenEmpty!==!1&&e.splice(t--,1)}return e.length?e:null}function Di(e,t){var n=Js(e,t),r=Mi(e,t);if(!n)return r;if(!r)return n;for(var i=0;i<n.length;++i){var s=n[i],o=r[i];if(s&&o)e:for(var u=0;u<o.length;++u){var a=o[u];for(var f=0;f<s.length;++f)if(s[f].marker==a.marker)continue e;s.push(a)}else o&&(n[i]=o)}return n}function Pi(e,t,n){var r=null;e.iter(t.line,n.line+1,function(e){if(e.markedSpans)for(var t=0;t<e.markedSpans.length;++t){var n=e.markedSpans[t].marker;n.readOnly&&(!r||Ao(r,n)==-1)&&(r||(r=[])).push(n)}});if(!r)return null;var i=[{from:t,to:n}];for(var s=0;s<r.length;++s){var o=r[s],u=o.find(0);for(var a=0;a<i.length;++a){var f=i[a];if(dt(f.to,u.from)<0||dt(f.from,u.to)>0)continue;var l=[a,1],c=dt(f.from,u.from),h=dt(f.to,u.to);(c<0||!o.inclusiveLeft&&!c)&&l.push({from:f.from,to:u.from}),(h>0||!o.inclusiveRight&&!h)&&l.push({from:u.to,to:f.to}),i.splice.apply(i,l),a+=l.length-1}}return i}function Hi(e){var t=e.markedSpans;if(!t)return;for(var n=0;n<t.length;++n)t[n].marker.detachLine(e);e.markedSpans=null}function Bi(e,t){if(!t)return;for(var n=0;n<t.length;++n)t[n].marker.attachLine(e);e.markedSpans=t}function ji(e){return e.inclusiveLeft?-1:0}function Fi(e){return e.inclusiveRight?1:0}function Ii(e,t){var n=e.lines.length-t.lines.length;if(n!=0)return n;var r=e.find(),i=t.find(),s=dt(r.from,i.from)||ji(e)-ji(t);if(s)return-s;var o=dt(r.to,i.to)||Fi(e)-Fi(t);return o?o:t.id-e.id}function qi(e,t){var n=E&&e.markedSpans,r;if(n)for(var i,s=0;s<n.length;++s)i=n[s],i.marker.collapsed&&(t?i.from:i.to)==null&&(!r||Ii(r,i.marker)<0)&&(r=i.marker);return r}function Ri(e){return qi(e,!0)}function Ui(e){return qi(e,!1)}function zi(e,t,n,r,i){var s=Os(e,t),o=E&&s.markedSpans;if(o)for(var u=0;u<o.length;++u){var a=o[u];if(!a.marker.collapsed)continue;var f=a.marker.find(0),l=dt(f.from,n)||ji(a.marker)-ji(i),c=dt(f.to,r)||Fi(a.marker)-Fi(i);if(l>=0&&c<=0||l<=0&&c>=0)continue;if(l<=0&&(dt(f.to,n)||Fi(a.marker)-ji(i))>0||l>=0&&(dt(f.from,r)||ji(a.marker)-Fi(i))<0)return!0}}function Wi(e){var t;while(t=Ri(e))e=t.find(-1,!0).line;return e}function Xi(e){var t,n;while(t=Ui(e))e=t.find(1,!0).line,(n||(n=[])).push(e);return n}function Vi(e,t){var n=Os(e,t),r=Wi(n);return n==r?t:Ps(r)}function $i(e,t){if(t>e.lastLine())return t;var n=Os(e,t),r;if(!Ji(e,n))return t;while(r=Ui(n))n=r.find(1,!0).line;return Ps(n)+1}function Ji(e,t){var n=E&&t.markedSpans;if(n)for(var r,i=0;i<n.length;++i){r=n[i];if(!r.marker.collapsed)continue;if(r.from==null)return!0;if(r.marker.widgetNode)continue;if(r.from==0&&r.marker.inclusiveLeft&&Ki(e,t,r))return!0}}function Ki(e,t,n){if(n.to==null){var r=n.marker.find(1,!0);return Ki(e,r.line,Ci(r.line.markedSpans,n.marker))}if(n.marker.inclusiveRight&&n.to==t.text.length)return!0;for(var i,s=0;s<t.markedSpans.length;++s){i=t.markedSpans[s];if(i.marker.collapsed&&!i.marker.widgetNode&&i.from==n.to&&(i.to==null||i.to!=n.from)&&(i.marker.inclusiveLeft||n.marker.inclusiveRight)&&Ki(e,t,i))return!0}}function Gi(e,t,n){Bs(t)<(e.curOp&&e.curOp.scrollTop||e.doc.scrollTop)&&Wr(e,null,n)}function Yi(e){return e.height!=null?e.height:e.overlay?e.height=0:(Wo(document.body,e.node)||zo(e.cm.display.measure,qo("div",[e.node],null,"position: relative")),e.height=e.node.offsetHeight)}function Zi(e,t,n,r){var i=new Qi(e,n,r);return i.noHScroll&&(e.display.alignWidgets=!0),Jr(e.doc,t,"widget",function(t){var n=t.widgets||(t.widgets=[]);i.insertAt==null?n.push(i):n.splice(Math.min(n.length-1,Math.max(0,i.insertAt)),0,i),i.line=t;if(!Ji(e.doc,t)){var r=Bs(t)<e.doc.scrollTop;Ds(t,t.height+Yi(i)),r&&Wr(e,null,i.height),e.curOp.forceUpdate=!0}return!0}),i}function ts(e,t,n,r){e.text=t,e.stateAfter&&(e.stateAfter=null),e.styles&&(e.styles=null),e.order!=null&&(e.order=null),Hi(e),Bi(e,n);var i=r?r(e):1;i!=e.height&&Ds(e,i)}function ns(e){e.parent=null,Hi(e)}function rs(e,t){if(e)for(;;){var n=e.match(/(?:^|\s+)line-(background-)?(\S+)/);if(!n)break;e=e.slice(0,n.index)+e.slice(n.index+n[0].length);var r=n[1]?"bgClass":"textClass";t[r]==null?t[r]=n[2]:(new RegExp("(?:^|s)"+n[2]+"(?:$|s)")).test(t[r])||(t[r]+=" "+n[2])}return e}function is(e,t){if(e.blankLine)return e.blankLine(t);if(!e.innerMode)return;var n=S.innerMode(e,t);if(n.mode.blankLine)return n.mode.blankLine(n.state)}function ss(e,t,n){for(var r=0;r<10;r++){var i=e.token(t,n);if(t.pos>t.start)return i}throw new Error("Mode "+e.name+" failed to advance stream.")}function os(e,t,n,r,i,s,o){var u=n.flattenSpans;u==null&&(u=e.options.flattenSpans);var a=0,f=null,l=new mi(t,e.options.tabSize),c;t==""&&rs(is(n,r),s);while(!l.eol()){l.pos>e.options.maxHighlightLength?(u=!1,o&&fs(e,t,r,l.pos),l.pos=t.length,c=null):c=rs(ss(n,l,r),s);if(e.options.addModeClass){var h=S.innerMode(n,r).mode.name;h&&(c="m-"+(c?h+" "+c:h))}if(!u||f!=c)a<l.start&&i(l.start,f),a=l.start,f=c;l.start=l.pos}while(a<l.pos){var p=Math.min(l.pos,a+5e4);i(p,f),a=p}}function us(e,t,n,r){var i=[e.state.modeGen],s={},o=e.getOption("externalMode");if(o){var u=o(e,t);i=i.concat(u)}else os(e,t.text,e.doc.mode,n,function(e,t){i.push(e,t)},s,r);for(var a=0;a<e.state.overlays.length;++a){var f=e.state.overlays[a],l=1,c=0;os(e,t.text,f.mode,!0,function(e,t){var n=l;while(c<e){var r=i[l];r>e&&i.splice(l,1,e,i[l+1],r),l+=2,c=Math.min(e,r)}if(!t)return;if(f.opaque)i.splice(n,l-n,e,"cm-overlay "+t),l=n+2;else for(;n<l;n+=2){var s=i[n+1];i[n+1]=(s?s+" ":"")+"cm-overlay "+t}},s)}return{styles:i,classes:s.bgClass||s.textClass?s:null}}function as(e,t){if(!t.styles||t.styles[0]!=e.state.modeGen){var n=us(e,t,t.stateAfter=$t(e,Ps(t)));t.styles=n.styles,n.classes?t.styleClasses=n.classes:t.styleClasses&&(t.styleClasses=null)}return t.styles}function fs(e,t,n,r){var i=e.doc.mode,s=new mi(t,e.options.tabSize);s.start=s.pos=r||0,t==""&&is(i,n);while(!s.eol()&&s.pos<=e.options.maxHighlightLength)ss(i,s,n),s.start=s.pos}function hs(e,t){if(!e||/^\s*$/.test(e))return null;var n=t.addModeClass?cs:ls;return n[e]||(n[e]=e.replace(/\S+/g,"cm-$&"))}function ps(e,t){var n=qo("span",null,null,s?"padding-right: .1px":null),i={pre:qo("pre",[n]),content:n,col:0,pos:0,cm:e};t.measure={};for(var o=0;o<=(t.rest?t.rest.length:0);o++){var u=o?t.rest[o-1]:t.line,a;i.pos=0,i.addToken=vs,(r||s)&&e.getOption("lineWrapping")&&(i.addToken=ms(i.addToken)),ou(e.display.measure)&&(a=js(u))&&(i.addToken=gs(i.addToken,a)),i.map=[],bs(u,i,as(e,u)),u.styleClasses&&(u.styleClasses.bgClass&&(i.bgClass=Ko(u.styleClasses.bgClass,i.bgClass||"")),u.styleClasses.textClass&&(i.textClass=Ko(u.styleClasses.textClass,i.textClass||""))),i.map.length==0&&i.map.push(0,0,i.content.appendChild(iu(e.display.measure))),o==0?(t.measure.map=i.map,t.measure.cache={}):((t.measure.maps||(t.measure.maps=[])).push(i.map),(t.measure.caches||(t.measure.caches=[])).push({}))}return uo(e,"renderLine",e,t.line,i.pre,i,t.measure),i.pre.className&&(i.textClass=Ko(i.pre.className,i.textClass||"")),i}function ds(e){var t=qo("span","•","cm-invalidchar");return t.title="\\u"+e.charCodeAt(0).toString(16),t}function vs(e,t,n,s,o,u){if(!t)return;var a=e.cm.options.specialChars,f=!1;if(!a.test(t)){e.col+=t.length;var l=document.createTextNode(t);e.map.push(e.pos,e.pos+t.length,l),r&&i<9&&(f=!0),e.pos+=t.length}else{var l=document.createDocumentFragment(),c=0;for(;;){a.lastIndex=c;var h=a.exec(t),p=h?h.index-c:t.length-c;if(p){var d=document.createTextNode(t.slice(c,c+p));r&&i<9?l.appendChild(qo("span",[d])):l.appendChild(d),e.map.push(e.pos,e.pos+p,d),e.col+=p,e.pos+=p}if(!h)break;c+=p+1;if(h[0]=="	"){var v=e.cm.options.tabSize,m=v-e.col%v,d=l.appendChild(qo("span",Co(m),"cm-tab"));e.col+=m}else{var d=e.cm.options.specialCharPlaceholder(h[0]);r&&i<9?l.appendChild(qo("span",[d])):l.appendChild(d),e.col+=1}e.map.push(e.pos,e.pos+1,d),e.pos++}}if(n||s||o||f){var g=n||"";s&&(g+=s),o&&(g+=o);var y=qo("span",[l],g);return u&&(y.title=u),e.content.appendChild(y)}e.content.appendChild(l)}function ms(e){function t(e){var t=" ";for(var n=0;n<e.length-2;++n)t+=n%2?" ":" ";return t+=" ",t}return function(n,r,i,s,o,u){e(n,r.replace(/ {3,}/g,t),i,s,o,u)}}function gs(e,t){return function(n,r,i,s,o,u){i=i?i+" cm-force-border":"cm-force-border";var a=n.pos,f=a+r.length;for(;;){for(var l=0;l<t.length;l++){var c=t[l];if(c.to>a&&c.from<=a)break}if(c.to>=f)return e(n,r,i,s,o,u);e(n,r.slice(0,c.to-a),i,s,null,u),s=null,r=r.slice(c.to-a),a=c.to}}}function ys(e,t,n,r){var i=!r&&n.widgetNode;i&&(e.map.push(e.pos,e.pos+t,i),e.content.appendChild(i)),e.pos+=t}function bs(e,t,n){var r=e.markedSpans,i=e.text,s=0;if(!r){for(var o=1;o<n.length;o+=2)t.addToken(t,i.slice(s,s=n[o]),hs(n[o+1],t.cm.options));return}var u=i.length,a=0,o=1,f="",l,c=0,h,p,d,v,m;for(;;){if(c==a){h=p=d=v="",m=null,c=Infinity;var g=[];for(var y=0;y<r.length;++y){var b=r[y],w=b.marker;b.from<=a&&(b.to==null||b.to>a)?(b.to!=null&&c>b.to&&(c=b.to,p=""),w.className&&(h+=" "+w.className),w.startStyle&&b.from==a&&(d+=" "+w.startStyle),w.endStyle&&b.to==c&&(p+=" "+w.endStyle),w.title&&!v&&(v=w.title),w.collapsed&&(!m||Ii(m.marker,w)<0)&&(m=b)):b.from>a&&c>b.from&&(c=b.from),w.type=="bookmark"&&b.from==a&&w.widgetNode&&g.push(w)}if(m&&(m.from||0)==a){ys(t,(m.to==null?u+1:m.to)-a,m.marker,m.from==null);if(m.to==null)return}if(!m&&g.length)for(var y=0;y<g.length;++y)ys(t,0,g[y])}if(a>=u)break;var E=Math.min(u,c);for(;;){if(f){var S=a+f.length;if(!m){var x=S>E?f.slice(0,E-a):f;t.addToken(t,x,l?l+h:h,d,a+x.length==c?p:"",v)}if(S>=E){f=f.slice(E-a),a=E;break}a=S,d=""}f=i.slice(s,s=n[o++]),l=hs(n[o++],t.cm.options)}}}function ws(e,t){return t.from.ch==0&&t.to.ch==0&&ko(t.text)==""&&(!e.cm||e.cm.options.wholeLineUpdateBefore)}function Es(e,t,n,r){function i(e){return n?n[e]:null}function s(e,n,i){ts(e,n,i,r),lo(e,"change",e,t)}var o=t.from,u=t.to,a=t.text,f=Os(e,o.line),l=Os(e,u.line),c=ko(a),h=i(a.length-1),p=u.line-o.line;if(ws(e,t)){for(var d=0,v=[];d<a.length-1;++d)v.push(new es(a[d],i(d),r));s(l,l.text,h),p&&e.remove(o.line,p),v.length&&e.insert(o.line,v)}else if(f==l)if(a.length==1)s(f,f.text.slice(0,o.ch)+c+f.text.slice(u.ch),h);else{for(var v=[],d=1;d<a.length-1;++d)v.push(new es(a[d],i(d),r));v.push(new es(c+f.text.slice(u.ch),h,r)),s(f,f.text.slice(0,o.ch)+a[0],i(0)),e.insert(o.line+1,v)}else if(a.length==1)s(f,f.text.slice(0,o.ch)+a[0]+l.text.slice(u.ch),i(0)),e.remove(o.line+1,p);else{s(f,f.text.slice(0,o.ch)+a[0],i(0)),s(l,c+l.text.slice(u.ch),h);for(var d=1,v=[];d<a.length-1;++d)v.push(new es(a[d],i(d),r));p>1&&e.remove(o.line+1,p-1),e.insert(o.line+1,v)}lo(e,"change",e,t)}function Ss(e){this.lines=e,this.parent=null;for(var t=0,n=0;t<e.length;++t)e[t].parent=this,n+=e[t].height;this.height=n}function xs(e){this.children=e;var t=0,n=0;for(var r=0;r<e.length;++r){var i=e[r];t+=i.chunkSize(),n+=i.height,i.parent=this}this.size=t,this.height=n,this.parent=null}function Ls(e,t,n){function r(e,i,s){if(e.linked)for(var o=0;o<e.linked.length;++o){var u=e.linked[o];if(u.doc==i)continue;var a=s&&u.sharedHist;if(n&&!a)continue;t(u.doc,a),r(u.doc,e,a)}}r(e,null,!0)}function As(e,t){if(t.cm)throw new Error("This document is already in use.");e.doc=t,t.cm=e,L(e),T(e),e.options.lineWrapping||H(e),e.options.mode=t.modeOption,Dn(e)}function Os(e,t){t-=e.first;if(t<0||t>=e.size)throw new Error("There is no line "+(t+e.first)+" in the document.");for(var n=e;!n.lines;)for(var r=0;;++r){var i=n.children[r],s=i.chunkSize();if(t<s){n=i;break}t-=s}return n.lines[t]}function Ms(e,t,n){var r=[],i=t.line;return e.iter(t.line,n.line+1,function(e){var s=e.text;i==n.line&&(s=s.slice(0,n.ch)),i==t.line&&(s=s.slice(t.ch)),r.push(s),++i}),r}function _s(e,t,n){var r=[];return e.iter(t,n,function(e){r.push(e.text)}),r}function Ds(e,t){var n=t-e.height;if(n)for(var r=e;r;r=r.parent)r.height+=n}function Ps(e){if(e.parent==null)return null;var t=e.parent,n=Ao(t.lines,e);for(var r=t.parent;r;t=r,r=r.parent)for(var i=0;;++i){if(r.children[i]==t)break;n+=r.children[i].chunkSize()}return n+t.first}function Hs(e,t){var n=e.first;e:do{for(var r=0;r<e.children.length;++r){var i=e.children[r],s=i.height;if(t<s){e=i;continue e}t-=s,n+=i.chunkSize()}return n}while(!e.lines);for(var r=0;r<e.lines.length;++r){var o=e.lines[r],u=o.height;if(t<u)break;t-=u}return n+r}function Bs(e){e=Wi(e);var t=0,n=e.parent;for(var r=0;r<n.lines.length;++r){var i=n.lines[r];if(i==e)break;t+=i.height}for(var s=n.parent;s;n=s,s=n.parent)for(var r=0;r<s.children.length;++r){var o=s.children[r];if(o==n)break;t+=o.height}return t}function js(e){var t=e.order;return t==null&&(t=e.order=Tu(e.text)),t}function Fs(e){this.done=[],this.undone=[],this.undoDepth=Infinity,this.lastModTime=this.lastSelTime=0,this.lastOp=null,this.lastOrigin=this.lastSelOrigin=null,this.generation=this.maxGeneration=e||1}function Is(e,t){var n={from:vt(t.from),to:kr(t),text:Ms(e,t.from,t.to)};return Vs(e,n,t.from.line,t.to.line+1),Ls(e,function(e){Vs(e,n,t.from.line,t.to.line+1)},!0),n}function qs(e){while(e.length){var t=ko(e);if(!t.ranges)break;e.pop()}}function Rs(e,t){if(t)return qs(e.done),ko(e.done);if(e.done.length&&!ko(e.done).ranges)return ko(e.done);if(e.done.length>1&&!e.done[e.done.length-2].ranges)return e.done.pop(),ko(e.done)}function Us(e,t,n,r){var i=e.history;i.undone.length=0;var s=+(new Date),o;if((i.lastOp==r||i.lastOrigin==t.origin&&t.origin&&(t.origin.charAt(0)=="+"&&e.cm&&i.lastModTime>s-e.cm.options.historyEventDelay||t.origin.charAt(0)=="*"))&&(o=Rs(i,i.lastOp==r))){var u=ko(o.changes);dt(t.from,t.to)==0&&dt(t.from,u.to)==0?u.to=kr(t):o.changes.push(Is(e,t))}else{var a=ko(i.done);(!a||!a.ranges)&&Xs(e.sel,i.done),o={changes:[Is(e,t)],generation:i.generation},i.done.push(o);while(i.done.length>i.undoDepth)i.done.shift(),i.done[0].ranges||i.done.shift()}i.done.push(n),i.generation=++i.maxGeneration,i.lastModTime=i.lastSelTime=s,i.lastOp=r,i.lastOrigin=i.lastSelOrigin=t.origin,u||uo(e,"historyAdded")}function zs(e,t,n,r){var i=t.charAt(0);return i=="*"||i=="+"&&n.ranges.length==r.ranges.length&&n.somethingSelected()==r.somethingSelected()&&new Date-e.history.lastSelTime<=(e.cm?e.cm.options.historyEventDelay:500)}function Ws(e,t,n,r){var i=e.history,s=r&&r.origin;n==i.lastOp||s&&i.lastSelOrigin==s&&(i.lastModTime==i.lastSelTime&&i.lastOrigin==s||zs(e,s,ko(i.done),t))?i.done[i.done.length-1]=t:Xs(t,i.done),i.lastSelTime=+(new Date),i.lastSelOrigin=s,i.lastOp=n,r&&r.clearRedo!==!1&&qs(i.undone)}function Xs(e,t){var n=ko(t);n&&n.ranges&&n.equals(e)||t.push(e)}function Vs(e,t,n,r){var i=t["spans_"+e.id],s=0;e.iter(Math.max(e.first,n),Math.min(e.first+e.size,r),function(n){n.markedSpans&&((i||(i=t["spans_"+e.id]={}))[s]=n.markedSpans),++s})}function $s(e){if(!e)return null;for(var t=0,n;t<e.length;++t)e[t].marker.explicitlyCleared?n||(n=e.slice(0,t)):n&&n.push(e[t]);return n?n.length?n:null:e}function Js(e,t){var n=t["spans_"+e.id];if(!n)return null;for(var r=0,i=[];r<t.text.length;++r)i.push($s(n[r]));return i}function Ks(e,t,n){for(var r=0,i=[];r<e.length;++r){var s=e[r];if(s.ranges){i.push(n?yt.prototype.deepCopy.call(s):s);continue}var o=s.changes,u=[];i.push({changes:u});for(var a=0;a<o.length;++a){var f=o[a],l;u.push({from:f.from,to:f.to,text:f.text});if(t)for(var c in f)(l=c.match(/^spans_(\d+)$/))&&Ao(t,Number(l[1]))>-1&&(ko(u)[c]=f[c],delete f[c])}}return i}function Qs(e,t,n,r){n<e.line?e.line+=r:t<e.line&&(e.line=t,e.ch=0)}function Gs(e,t,n,r){for(var i=0;i<e.length;++i){var s=e[i],o=!0;if(s.ranges){s.copied||(s=e[i]=s.deepCopy(),s.copied=!0);for(var u=0;u<s.ranges.length;u++)Qs(s.ranges[u].anchor,t,n,r),Qs(s.ranges[u].head,t,n,r);continue}for(var u=0;u<s.changes.length;++u){var a=s.changes[u];if(n<a.from.line)a.from=pt(a.from.line+r,a.from.ch),a.to=pt(a.to.line+r,a.to.ch);else if(t<=a.to.line){o=!1;break}}o||(e.splice(0,i+1),i=0)}}function Ys(e,t){var n=t.from.line,r=t.to.line,i=t.text.length-(r-n)-1;Gs(e.done,n,r,i),Gs(e.undone,n,r,i)}function to(e){return e.defaultPrevented!=null?e.defaultPrevented:e.returnValue==0}function ro(e){return e.target||e.srcElement}function io(e){var t=e.which;return t==null&&(e.button&1?t=1:e.button&2?t=3:e.button&4&&(t=2)),v&&e.ctrlKey&&t==1&&(t=3),t}function lo(e,t){function i(e){return function(){e.apply(null,r)}}var n=e._handlers&&e._handlers[t];if(!n)return;var r=Array.prototype.slice.call(arguments,2);ao||(++fo,ao=[],setTimeout(co,0));for(var s=0;s<n.length;++s)ao.push(i(n[s]))}function co(){--fo;var e=ao;ao=null;for(var t=0;t<e.length;++t)e[t]()}function ho(e,t,n){return uo(e,n||t.type,e,t),to(t)||t.codemirrorIgnore}function po(e){var t=e._handlers&&e._handlers.cursorActivity;if(!t)return;var n=e.curOp.cursorActivityHandlers||(e.curOp.cursorActivityHandlers=[]);for(var r=0;r<t.length;++r)Ao(n,t[r])==-1&&n.push(t[r])}function vo(e,t){var n=e._handlers&&e._handlers[t];return n&&n.length>0}function mo(e){e.prototype.on=function(e,t){so(this,e,t)},e.prototype.off=function(e,t){oo(this,e,t)}}function So(){this.id=null}function To(e,t,n){for(var r=0,i=0;;){var s=e.indexOf("	",r);s==-1&&(s=e.length);var o=s-r;if(s==e.length||i+o>=t)return r+Math.min(o,t-i);i+=s-r,i+=n-i%n,r=s+1;if(i>=t)return r}}function Co(e){while(No.length<=e)No.push(ko(No)+" ");return No[e]}function ko(e){return e[e.length-1]}function Ao(e,t){for(var n=0;n<e.length;++n)if(e[n]==t)return n;return-1}function Oo(e,t){var n=[];for(var r=0;r<e.length;r++)n[r]=t(e[r],r);return n}function Mo(e,t){var n;if(Object.create)n=Object.create(e);else{var r=function(){};r.prototype=e,n=new r}return t&&_o(t,n),n}function _o(e,t,n){t||(t={});for(var r in e)e.hasOwnProperty(r)&&(n!==!1||!t.hasOwnProperty(r))&&(t[r]=e[r]);return t}function Do(e){var t=Array.prototype.slice.call(arguments,1);return function(){return e.apply(null,t)}}function Bo(e,t){return t?t.source.indexOf("\\w")>-1&&Ho(e)?!0:t.test(e):Ho(e)}function jo(e){for(var t in e)if(e.hasOwnProperty(t)&&e[t])return!1;return!0}function Io(e){return e.charCodeAt(0)>=768&&Fo.test(e)}function qo(e,t,n,r){var i=document.createElement(e);n&&(i.className=n),r&&(i.style.cssText=r);if(typeof t=="string")i.appendChild(document.createTextNode(t));else if(t)for(var s=0;s<t.length;++s)i.appendChild(t[s]);return i}function Uo(e){for(var t=e.childNodes.length;t>0;--t)e.removeChild(e.firstChild);return e}function zo(e,t){return Uo(e).appendChild(t)}function Wo(e,t){if(e.contains)return e.contains(t);while(t=t.parentNode)if(t==e)return!0}function Xo(){return document.activeElement}function Vo(e){return new RegExp("\\b"+e+"\\b\\s*")}function $o(e,t){var n=Vo(t);n.test(e.className)&&(e.className=e.className.replace(n,""))}function Jo(e,t){Vo(t).test(e.className)||(e.className+=" "+t)}function Ko(e,t){var n=e.split(" ");for(var r=0;r<n.length;r++)n[r]&&!Vo(n[r]).test(t)&&(t+=" "+n[r]);return t}function Qo(e){if(!document.body.getElementsByClassName)return;var t=document.body.getElementsByClassName("CodeMirror");for(var n=0;n<t.length;n++){var r=t[n].CodeMirror;r&&e(r)}}function Yo(){if(Go)return;Zo(),Go=!0}function Zo(){var e;so(window,"resize",function(){e==null&&(e=setTimeout(function(){e=null,tu=null,Qo(Jn)},100))}),so(window,"blur",function(){Qo(Tr)})}function nu(e){if(tu!=null)return tu;var t=qo("div",null,null,"width: 50px; height: 50px; overflow-x: scroll");return zo(e,t),t.offsetWidth&&(tu=t.offsetHeight-t.clientHeight),tu||0}function iu(e){if(ru==null){var t=qo("span","​");zo(e,qo("span",[t,document.createTextNode("x")])),e.firstChild.offsetHeight!=0&&(ru=t.offsetWidth<=1&&t.offsetHeight>2&&r&&i<8)}return ru?qo("span","​"):qo("span"," ",null,"display: inline-block; width: 1px; margin-right: -1px")}function ou(e){if(su!=null)return su;var t=zo(e,document.createTextNode("AخA")),n=Ro(t,0,1).getBoundingClientRect();if(n.left==n.right)return!1;var r=Ro(t,1,2).getBoundingClientRect();return su=r.right-n.right<3}function cu(e,t,n,r){if(!e)return r(t,n,"ltr");var i=!1;for(var s=0;s<e.length;++s){var o=e[s];if(o.from<n&&o.to>t||t==n&&o.to==t)r(Math.max(o.from,t),Math.min(o.to,n),o.level==1?"rtl":"ltr"),i=!0}i||r(t,n,"ltr")}function hu(e){return e.level%2?e.to:e.from}function pu(e){return e.level%2?e.from:e.to}function du(e){var t=js(e);return t?hu(t[0]):0}function vu(e){var t=js(e);return t?pu(ko(t)):e.text.length}function mu(e,t){var n=Os(e.doc,t),r=Wi(n);r!=n&&(t=Ps(r));var i=js(r),s=i?i[0].level%2?vu(r):du(r):0;return pt(t,s)}function gu(e,t){var n,r=Os(e.doc,t);while(n=Ui(r))r=n.find(1,!0).line,t=null;var i=js(r),s=i?i[0].level%2?du(r):vu(r):r.text.length;return pt(t==null?Ps(r):t,s)}function yu(e,t,n){var r=e[0].level;return t==r?!0:n==r?!1:t<n}function wu(e,t){bu=null;for(var n=0,r;n<e.length;++n){var i=e[n];if(i.from<t&&i.to>t)return n;if(i.from==t||i.to==t){if(r!=null)return yu(e,i.level,e[r].level)?(i.from!=i.to&&(bu=r),n):(i.from!=i.to&&(bu=n),r);r=n}}return r}function Eu(e,t,n,r){if(!r)return t+n;do t+=n;while(t>0&&Io(e.text.charAt(t)));return t}function Su(e,t,n,r){var i=js(e);if(!i)return xu(e,t,n,r);var s=wu(i,t),o=i[s],u=Eu(e,t,o.level%2?-n:n,r);for(;;){if(u>o.from&&u<o.to)return u;if(u==o.from||u==o.to)return wu(i,u)==s?u:(o=i[s+=n],n>0==o.level%2?o.to:o.from);o=i[s+=n];if(!o)return null;n>0==o.level%2?u=Eu(e,o.to,-1,r):u=Eu(e,o.from,1,r)}}function xu(e,t,n,r){var i=t+n;if(r)while(i>0&&Io(e.text.charAt(i)))i+=n;return i<0||i>e.text.length?null:i}var e=/gecko\/\d/i.test(navigator.userAgent),t=/MSIE \d/.test(navigator.userAgent),n=/Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent),r=t||n,i=r&&(t?document.documentMode||6:n[1]),s=/WebKit\//.test(navigator.userAgent),o=s&&/Qt\/\d+\.\d+/.test(navigator.userAgent),u=/Chrome\//.test(navigator.userAgent),a=/Opera\//.test(navigator.userAgent),f=/Apple Computer/.test(navigator.vendor),l=/KHTML\//.test(navigator.userAgent),c=/Mac OS X 1\d\D([8-9]|\d\d)\D/.test(navigator.userAgent),h=/PhantomJS/.test(navigator.userAgent),p=/AppleWebKit/.test(navigator.userAgent)&&/Mobile\/\w+/.test(navigator.userAgent),d=p||/Android|webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(navigator.userAgent),v=p||/Mac/.test(navigator.platform),m=/win/i.test(navigator.platform),g=a&&navigator.userAgent.match(/Version\/(\d*\.\d*)/);g&&(g=Number(g[1])),g&&g>=15&&(a=!1,s=!0);var y=v&&(o||a&&(g==null||g<12.11)),b=e||r&&i>=9,w=!1,E=!1;S.mobile=d,S.mac=v,S.windows=m;var pt=S.Pos=function(e,t){if(!(this instanceof pt))return new pt(e,t);this.line=e,this.ch=t},dt=S.cmpPos=function(e,t){return e.line-t.line||e.ch-t.ch};yt.prototype={primary:function(){return this.ranges[this.primIndex]},equals:function(e){if(e==this)return!0;if(e.primIndex!=this.primIndex||e.ranges.length!=this.ranges.length)return!1;for(var t=0;t<this.ranges.length;t++){var n=this.ranges[t],r=e.ranges[t];if(dt(n.anchor,r.anchor)!=0||dt(n.head,r.head)!=0)return!1}return!0},deepCopy:function(){for(var e=[],t=0;t<this.ranges.length;t++)e[t]=new bt(vt(this.ranges[t].anchor),vt(this.ranges[t].head));return new yt(e,this.primIndex)},somethingSelected:function(){for(var e=0;e<this.ranges.length;e++)if(!this.ranges[e].empty())return!0;return!1},contains:function(e,t){t||(t=e);for(var n=0;n<this.ranges.length;n++){var r=this.ranges[n];if(dt(t,r.from())>=0&&dt(e,r.to())<=0)return n}return-1}},bt.prototype={from:function(){return gt(this.anchor,this.head)},to:function(){return mt(this.anchor,this.head)},empty:function(){return this.head.line==this.anchor.line&&this.head.ch==this.anchor.ch}};var sn={left:0,right:0,top:0,bottom:0},wn,Tn=0,Yn,Zn,sr=0,lr=0,cr=null;r?cr=-0.53:e?cr=15:u?cr=-0.7:f&&(cr=-1/3);var vr,yr=null,kr=S.changeEnd=function(e){return e.text?pt(e.from.line+e.text.length-1,ko(e.text).length+(e.text.length==1?e.from.ch:0)):e.to};S.prototype={constructor:S,focus:function(){window.focus(),Wn(this),Rn(this)},setOption:function(e,t){var n=this.options,r=n[e];if(n[e]==t&&e!="mode")return;n[e]=t,ei.hasOwnProperty(e)&&Ln(this,ei[e])(this,t,r)},getOption:function(e){return this.options[e]},getDoc:function(){return this.doc},addKeyMap:function(e,t){this.state.keyMaps[t?"push":"unshift"](e)},removeKeyMap:function(e){var t=this.state.keyMaps;for(var n=0;n<t.length;++n)if(t[n]==e||typeof t[n]!="string"&&t[n].name==e)return t.splice(n,1),!0},addOverlay:An(function(e,t){var n=e.token?e:S.getMode(this.options,e);if(n.startState)throw new Error("Overlays may not be stateful.");this.state.overlays.push({mode:n,modeSpec:e,opaque:t&&t.opaque}),this.state.modeGen++,Dn(this)}),removeOverlay:An(function(e){var t=this.state.overlays;for(var n=0;n<t.length;++n){var r=t[n].modeSpec;if(r==e||typeof e=="string"&&r.name==e){t.splice(n,1),this.state.modeGen++,Dn(this);return}}}),indentLine:An(function(e,t,n){typeof t!="string"&&typeof t!="number"&&(t==null?t=this.options.smartIndent?"smart":"prev":t=t?"add":"subtract"),Nt(this.doc,e)&&$r(this,e,t,n)}),indentSelection:An(function(e){var t=this.doc.sel.ranges,n=-1;for(var r=0;r<t.length;r++){var i=t[r];if(!i.empty()){var s=Math.max(n,i.from().line),o=i.to();n=Math.min(this.lastLine(),o.line-(o.ch?0:1))+1;for(var u=s;u<n;++u)$r(this,u,e)}else i.head.line>n&&($r(this,i.head.line,e,!0),n=i.head.line,r==this.doc.sel.primIndex&&Xr(this))}}),getTokenAt:function(e,t){var n=this.doc;e=xt(n,e);var r=$t(this,e.line,t),i=this.doc.mode,s=Os(n,e.line),o=new mi(s.text,this.options.tabSize);while(o.pos<e.ch&&!o.eol()){o.start=o.pos;var u=ss(i,o,r)}return{start:o.start,end:o.pos,string:o.current(),type:u||null,state:r}},getTokenTypeAt:function(e){e=xt(this.doc,e);var t=as(this,Os(this.doc,e.line)),n=0,r=(t.length-1)/2,i=e.ch,s;if(i==0)s=t[2];else for(;;){var o=n+r>>1;if((o?t[o*2-1]:0)>=i)r=o;else{if(!(t[o*2+1]<i)){s=t[o*2+2];break}n=o+1}}var u=s?s.indexOf("cm-overlay "):-1;return u<0?s:u==0?null:s.slice(0,u-1)},getModeAt:function(e){var t=this.doc.mode;return t.innerMode?S.innerMode(t,this.getTokenAt(e).state).mode:t},getHelper:function(e,t){return this.getHelpers(e,t)[0]},getHelpers:function(e,t){var n=[];if(!ui.hasOwnProperty(t))return ui;var r=ui[t],i=this.getModeAt(e);if(typeof i[t]=="string")r[i[t]]&&n.push(r[i[t]]);else if(i[t])for(var s=0;s<i[t].length;s++){var o=r[i[t][s]];o&&n.push(o)}else i.helperType&&r[i.helperType]?n.push(r[i.helperType]):r[i.name]&&n.push(r[i.name]);for(var s=0;s<r._global.length;s++){var u=r._global[s];u.pred(i,this)&&Ao(n,u.val)==-1&&n.push(u.val)}return n},getStateAfter:function(e,t){var n=this.doc;return e=St(n,e==null?n.first+n.size-1:e),$t(this,e+1,t)},cursorCoords:function(e,t){var n,r=this.doc.sel.primary();return e==null?n=r.head:typeof e=="object"?n=xt(this.doc,e):n=e?r.from():r.to(),vn(this,n,t||"page")},charCoords:function(e,t){return dn(this,xt(this.doc,e),t||"page")},coordsChar:function(e,t){return e=pn(this,e,t||"page"),yn(this,e.left,e.top)},lineAtHeight:function(e,t){return e=pn(this,{top:e,left:0},t||"page").top,Hs(this.doc,e+this.display.viewOffset)},heightAtLine:function(e,t){var n=!1,r=this.doc.first+this.doc.size-1;e<this.doc.first?e=this.doc.first:e>r&&(e=r,n=!0);var i=Os(this.doc,e);return hn(this,i,{top:0,left:0},t||"page").top+(n?this.doc.height-Bs(i):0)},defaultTextHeight:function(){return En(this.display)},defaultCharWidth:function(){return Sn(this.display)},defaultSpaceWidth:function(){return xn(this.display)},setGutterMarker:An(function(e,t,n){return Jr(this.doc,e,"gutter",function(e){var r=e.gutterMarkers||(e.gutterMarkers={});return r[t]=n,!n&&jo(r)&&(e.gutterMarkers=null),!0})}),clearGutter:An(function(e){var t=this,n=t.doc,r=n.first;n.iter(function(n){n.gutterMarkers&&n.gutterMarkers[e]&&(n.gutterMarkers[e]=null,Pn(t,r,"gutter"),jo(n.gutterMarkers)&&(n.gutterMarkers=null)),++r})}),addLineWidget:An(function(e,t,n){return Zi(this,e,t,n)}),removeLineWidget:function(e){e.clear()},lineInfo:function(e){if(typeof e=="number"){if(!Nt(this.doc,e))return null;var t=e;e=Os(this.doc,e);if(!e)return null}else{var t=Ps(e);if(t==null)return null}return{line:t,handle:e,text:e.text,gutterMarkers:e.gutterMarkers,textClass:e.textClass,bgClass:e.bgClass,wrapClass:e.wrapClass,widgets:e.widgets}},getViewport:function(){return{from:this.display.viewFrom,to:this.display.viewTo}},addWidget:function(e,t,n,r,i){var s=this.display;e=vn(this,xt(this.doc,e));var o=e.bottom,u=e.left;t.style.position="absolute",s.sizer.appendChild(t);if(r=="over")o=e.top;else if(r=="above"||r=="near"){var a=Math.max(s.wrapper.clientHeight,this.doc.height),f=Math.max(s.sizer.clientWidth,s.lineSpace.clientWidth);(r=="above"||e.bottom+t.offsetHeight>a)&&e.top>t.offsetHeight?o=e.top-t.offsetHeight:e.bottom+t.offsetHeight<=a&&(o=e.bottom),u+t.offsetWidth>f&&(u=f-t.offsetWidth)}t.style.top=o+"px",t.style.left=t.style.right="",i=="right"?(u=s.sizer.clientWidth-t.offsetWidth,t.style.right="0px"):(i=="left"?u=0:i=="middle"&&(u=(s.sizer.clientWidth-t.offsetWidth)/2),t.style.left=u+"px"),n&&Ur(this,u,o,u+t.offsetWidth,o+t.offsetHeight)},triggerOnKeyDown:An(br),triggerOnKeyPress:An(Sr),triggerOnKeyUp:An(Er),execCommand:function(e){if(li.hasOwnProperty(e))return li[e](this)},findPosH:function(e,t,n,r){var i=1;t<0&&(i=-1,t=-t);for(var s=0,o=xt(this.doc,e);s<t;++s){o=Qr(this.doc,o,i,n,r);if(o.hitSide)break}return o},moveH:An(function(e,t){var n=this;n.extendSelectionsBy(function(r){return n.display.shift||n.doc.extend||r.empty()?Qr(n.doc,r.head,e,t,n.options.rtlMoveVisually):e<0?r.from():r.to()},Eo)}),deleteH:An(function(e,t){var n=this.doc.sel,r=this.doc;n.somethingSelected()?r.replaceSelection("",null,"+delete"):Kr(this,function(n){var i=Qr(r,n.head,e,t,!1);return e<0?{from:i,to:n.head}:{from:n.head,to:i}})}),findPosV:function(e,t,n,r){var i=1,s=r;t<0&&(i=-1,t=-t);for(var o=0,u=xt(this.doc,e);o<t;++o){var a=vn(this,u,"div");s==null?s=a.left:a.left=s,u=Gr(this,a,i,n);if(u.hitSide)break}return u},moveV:An(function(e,t){var n=this,r=this.doc,i=[],s=!n.display.shift&&!r.extend&&r.sel.somethingSelected();r.extendSelectionsBy(function(o){if(s)return e<0?o.from():o.to();var u=vn(n,o.head,"div");o.goalColumn!=null&&(u.left=o.goalColumn),i.push(u.left);var a=Gr(n,u,e,t);return t=="page"&&o==r.sel.primary()&&Wr(n,null,dn(n,a,"div").top-u.top),a},Eo);if(i.length)for(var o=0;o<r.sel.ranges.length;o++)r.sel.ranges[o].goalColumn=i[o]}),toggleOverwrite:function(e){if(e!=null&&e==this.state.overwrite)return;(this.state.overwrite=!this.state.overwrite)?Jo(this.display.cursorDiv,"CodeMirror-overwrite"):$o(this.display.cursorDiv,"CodeMirror-overwrite"),uo(this,"overwriteToggle",this,this.state.overwrite)},hasFocus:function(){return Xo()==this.display.input},scrollTo:An(function(e,t){(e!=null||t!=null)&&Vr(this),e!=null&&(this.curOp.scrollLeft=e),t!=null&&(this.curOp.scrollTop=t)}),getScrollInfo:function(){var e=this.display.scroller,t=go;return{left:e.scrollLeft,top:e.scrollTop,height:e.scrollHeight-t,width:e.scrollWidth-t,clientHeight:e.clientHeight-t,clientWidth:e.clientWidth-t}},scrollIntoView:An(function(e,t,n){e==null?(e={from:this.doc.sel.primary().head,to:null},t==null&&(t=this.options.cursorScrollMargin)):typeof e=="number"?e={from:pt(e,0),to:null}:e.from==null&&(e={from:e,to:null}),e.to||(e.to=e.from),e.topMargin=t||0,e.bottomMargin=n===undefined?e.topMargin:n;if(e.from.line!=null)Vr(this),this.curOp.scrollToPos=e;else{var r=zr(this,Math.min(e.from.left,e.to.left),Math.min(e.from.top,e.to.top)-e.topMargin,Math.max(e.from.right,e.to.right),Math.max(e.from.bottom,e.to.bottom)+e.bottomMargin);this.scrollTo(r.scrollLeft,r.scrollTop)}}),setSize:An(function(e,t){function r(e){return typeof e=="number"||/^\d+$/.test(String(e))?e+"px":e}var n=this;e!=null&&(n.display.wrapper.style.width=r(e)),t!=null&&(n.display.wrapper.style.height=r(t)),n.options.lineWrapping&&an(this);var i=n.display.viewFrom;n.doc.iter(i,n.display.viewTo,function(e){if(e.widgets)for(var t=0;t<e.widgets.length;t++)if(e.widgets[t].noHScroll){Pn(n,i,"widget");break}++i}),n.curOp.forceUpdate=!0,uo(n,"refresh",this)}),operation:function(e){return kn(this,e)},refresh:An(function(){var e=this.display.cachedTextHeight;Dn(this),this.curOp.forceUpdate=!0,fn(this),this.scrollTo(this.doc.scrollLeft,this.doc.scrollTop),D(this),(e==null||Math.abs(e-En(this.display))>.5)&&L(this),uo(this,"refresh",this)}),regLineChange:function(e,t){Pn(this,e,t)},lineHandleIsHidden:function(e){return Ji(this,e)},swapDoc:An(function(e){var t=this.doc;return t.cm=null,As(this,e),fn(this),zn(this),this.scrollTo(e.scrollLeft,e.scrollTop),lo(this,"swapDoc",this,t),t}),getInputField:function(){return this.display.input},getWrapperElement:function(){return this.display.wrapper},getScrollerElement:function(){return this.display.scroller},getGutterElement:function(){return this.display.gutters}},mo(S);var Zr=S.defaults={},ei=S.optionHandlers={},ni=S.Init={toString:function(){return"CodeMirror.Init"}};ti("value","",function(e,t){e.setValue(t)},!0),ti("mode",null,function(e,t){e.doc.modeOption=t,T(e)},!0),ti("indentUnit",2,T,!0),ti("indentWithTabs",!1),ti("smartIndent",!0),ti("tabSize",4,function(e){N(e),fn(e),Dn(e)},!0),ti("specialChars",/[\t\u0000-\u0019\u00ad\u200b\u2028\u2029\ufeff]/g,function(e,t){e.options.specialChars=new RegExp(t.source+(t.test("	")?"":"|	"),"g"),e.refresh()},!0),ti("specialCharPlaceholder",ds,function(e){e.refresh()},!0),ti("electricChars",!0),ti("rtlMoveVisually",!m),ti("wholeLineUpdateBefore",!0),ti("theme","default",function(e){O(e),M(e)},!0),ti("keyMap","default",A),ti("extraKeys",null),ti("lineWrapping",!1,C,!0),ti("gutters",[],function(e){B(e.options),M(e)},!0),ti("fixedGutter",!0,function(e,t){e.display.gutters.style.left=t?W(e.display)+"px":"0",e.refresh()},!0),ti("coverGutterNextToScrollbar",!1,I,!0),ti("lineNumbers",!1,function(e){B(e.options),M(e)},!0),ti("firstLineNumber",1,M,!0),ti("lineNumberFormatter",function(e){return e},M,!0),ti("showCursorWhenSelecting",!1,qt,!0),ti("resetSelectionOnContextMenu",!0),ti("readOnly",!1,function(e,t){t=="nocursor"?(Tr(e),e.display.input.blur(),e.display.disabled=!0):(e.display.disabled=!1,t||zn(e))}),ti("disableInput",!1,function(e,t){t||zn(e)},!0),ti("dragDrop",!0),ti("cursorBlinkRate",530),ti("cursorScrollMargin",0),ti("cursorHeight",1,qt,!0),ti("singleCursorHeightPerLine",!0,qt,!0),ti("workTime",100),ti("workDelay",100),ti("flattenSpans",!0,N,!0),ti("addModeClass",!1,N,!0),ti("pollInterval",100),ti("undoDepth",200,function(e,t){e.doc.history.undoDepth=t}),ti("historyEventDelay",500),ti("viewportMargin",10,function(e){e.refresh()},!0),ti("maxHighlightLength",1e4,N,!0),ti("moveInputWithCursor",!0,function(e,t){t||(e.display.inputDiv.style.top=e.display.inputDiv.style.left=0)}),ti("tabindex",null,function(e,t){e.display.input.tabIndex=t||""}),ti("autofocus",null);var ri=S.modes={},ii=S.mimeModes={};S.defineMode=function(e,t){!S.defaults.mode&&e!="null"&&(S.defaults.mode=e);if(arguments.length>2){t.dependencies=[];for(var n=2;n<arguments.length;++n)t.dependencies.push(arguments[n])}ri[e]=t},S.defineMIME=function(e,t){ii[e]=t},S.resolveMode=function(e){if(typeof e=="string"&&ii.hasOwnProperty(e))e=ii[e];else if(e&&typeof e.name=="string"&&ii.hasOwnProperty(e.name)){var t=ii[e.name];typeof t=="string"&&(t={name:t}),e=Mo(t,e),e.name=t.name}else if(typeof e=="string"&&/^[\w\-]+\/[\w\-]+\+xml$/.test(e))return S.resolveMode("application/xml");return typeof e=="string"?{name:e}:e||{name:"null"}},S.getMode=function(e,t){var t=S.resolveMode(t),n=ri[t.name];if(!n)return S.getMode(e,"text/plain");var r=n(e,t);if(si.hasOwnProperty(t.name)){var i=si[t.name];for(var s in i){if(!i.hasOwnProperty(s))continue;r.hasOwnProperty(s)&&(r["_"+s]=r[s]),r[s]=i[s]}}r.name=t.name,t.helperType&&(r.helperType=t.helperType);if(t.modeProps)for(var s in t.modeProps)r[s]=t.modeProps[s];return r},S.defineMode("null",function(){return{token:function(e){e.skipToEnd()}}}),S.defineMIME("text/plain","null");var si=S.modeExtensions={};S.extendMode=function(e,t){var n=si.hasOwnProperty(e)?si[e]:si[e]={};_o(t,n)},S.defineExtension=function(e,t){S.prototype[e]=t},S.defineDocExtension=function(e,t){Ns.prototype[e]=t},S.defineOption=ti;var oi=[];S.defineInitHook=function(e){oi.push(e)};var ui=S.helpers={};S.registerHelper=function(e,t,n){ui.hasOwnProperty(e)||(ui[e]=S[e]={_global:[]}),ui[e][t]=n},S.registerGlobalHelper=function(e,t,n,r){S.registerHelper(e,t,r),ui[e]._global.push({pred:n,val:r})};var ai=S.copyState=function(e,t){if(t===!0)return t;if(e.copyState)return e.copyState(t);var n={};for(var r in t){var i=t[r];i instanceof Array&&(i=i.concat([])),n[r]=i}return n},fi=S.startState=function(e,t,n){return e.startState?e.startState(t,n):!0};S.innerMode=function(e,t){while(e.innerMode){var n=e.innerMode(t);if(!n||n.mode==e)break;t=n.state,e=n.mode}return n||{mode:e,state:t}};var li=S.commands={selectAll:function(e){e.setSelection(pt(e.firstLine(),0),pt(e.lastLine()),bo)},singleSelection:function(e){e.setSelection(e.getCursor("anchor"),e.getCursor("head"),bo)},killLine:function(e){Kr(e,function(t){if(t.empty()){var n=Os(e.doc,t.head.line).text.length;return t.head.ch==n&&t.head.line<e.lastLine()?{from:t.head,to:pt(t.head.line+1,0)}:{from:t.head,to:pt(t.head.line,n)}}return{from:t.from(),to:t.to()}})},deleteLine:function(e){Kr(e,function(t){return{from:pt(t.from().line,0),to:xt(e.doc,pt(t.to().line+1,0))}})},delLineLeft:function(e){Kr(e,function(e){return{from:pt(e.from().line,0),to:e.from()}})},undo:function(e){e.undo()},redo:function(e){e.redo()},undoSelection:function(e){e.undoSelection()},redoSelection:function(e){e.redoSelection()},goDocStart:function(e){e.extendSelection(pt(e.firstLine(),0))},goDocEnd:function(e){e.extendSelection(pt(e.lastLine()))},goLineStart:function(e){e.extendSelectionsBy(function(t){return mu(e,t.head.line)},Eo)},goLineStartSmart:function(e){e.extendSelectionsBy(function(t){var n=mu(e,t.head.line),r=e.getLineHandle(n.line),i=js(r);if(!i||i[0].level==0){var s=Math.max(0,r.text.search(/\S/)),o=t.head.line==n.line&&t.head.ch<=s&&t.head.ch;return pt(n.line,o?0:s)}return n},Eo)},goLineEnd:function(e){e.extendSelectionsBy(function(t){return gu(e,t.head.line)},Eo)},goLineRight:function(e){e.extendSelectionsBy(function(t){var n=e.charCoords(t.head,"div").top+5;return e.coordsChar({left:e.display.lineDiv.offsetWidth+100,top:n},"div")},Eo)},goLineLeft:function(e){e.extendSelectionsBy(function(t){var n=e.charCoords(t.head,"div").top+5;return e.coordsChar({left:0,top:n},"div")},Eo)},goLineUp:function(e){e.moveV(-1,"line")},goLineDown:function(e){e.moveV(1,"line")},goPageUp:function(e){e.moveV(-1,"page")},goPageDown:function(e){e.moveV(1,"page")},goCharLeft:function(e){e.moveH(-1,"char")},goCharRight:function(e){e.moveH(1,"char")},goColumnLeft:function(e){e.moveH(-1,"column")},goColumnRight:function(e){e.moveH(1,"column")},goWordLeft:function(e){e.moveH(-1,"word")},goGroupRight:function(e){e.moveH(1,"group")},goGroupLeft:function(e){e.moveH(-1,"group")},goWordRight:function(e){e.moveH(1,"word")},delCharBefore:function(e){e.deleteH(-1,"char")},delCharAfter:function(e){e.deleteH(1,"char")},delWordBefore:function(e){e.deleteH(-1,"word")},delWordAfter:function(e){e.deleteH(1,"word")},delGroupBefore:function(e){e.deleteH(-1,"group")},delGroupAfter:function(e){e.deleteH(1,"group")},indentAuto:function(e){e.indentSelection("smart")},indentMore:function(e){e.indentSelection("add")},indentLess:function(e){e.indentSelection("subtract")},insertTab:function(e){e.replaceSelection("	")},insertSoftTab:function(e){var t=[],n=e.listSelections(),r=e.options.tabSize;for(var i=0;i<n.length;i++){var s=n[i].from(),o=xo(e.getLine(s.line),s.ch,r);t.push((new Array(r-o%r+1)).join(" "))}e.replaceSelections(t)},defaultTab:function(e){e.somethingSelected()?e.indentSelection("add"):e.execCommand("insertTab")},transposeChars:function(e){kn(e,function(){var t=e.listSelections(),n=[];for(var r=0;r<t.length;r++){var i=t[r].head,s=Os(e.doc,i.line).text;if(s){i.ch==s.length&&(i=new pt(i.line,i.ch-1));if(i.ch>0)i=new pt(i.line,i.ch+1),e.replaceRange(s.charAt(i.ch-1)+s.charAt(i.ch-2),pt(i.line,i.ch-2),i,"+transpose");else if(i.line>e.doc.first){var o=Os(e.doc,i.line-1).text;o&&e.replaceRange(s.charAt(0)+"\n"+o.charAt(o.length-1),pt(i.line-1,o.length-1),pt(i.line,1),"+transpose")}}n.push(new bt(i,i))}e.setSelections(n)})},newlineAndIndent:function(e){kn(e,function(){var t=e.listSelections().length;for(var n=0;n<t;n++){var r=e.listSelections()[n];e.replaceRange("\n",r.anchor,r.head,"+input"),e.indentLine(r.from().line+1,null,!0),Xr(e)}})},toggleOverwrite:function(e){e.toggleOverwrite()}},ci=S.keyMap={};ci.basic={Left:"goCharLeft",Right:"goCharRight",Up:"goLineUp",Down:"goLineDown",End:"goLineEnd",Home:"goLineStartSmart",PageUp:"goPageUp",PageDown:"goPageDown",Delete:"delCharAfter",Backspace:"delCharBefore","Shift-Backspace":"delCharBefore",Tab:"defaultTab","Shift-Tab":"indentAuto",Enter:"newlineAndIndent",Insert:"toggleOverwrite",Esc:"singleSelection"},ci.pcDefault={"Ctrl-A":"selectAll","Ctrl-D":"deleteLine","Ctrl-Z":"undo","Shift-Ctrl-Z":"redo","Ctrl-Y":"redo","Ctrl-Home":"goDocStart","Ctrl-Up":"goDocStart","Ctrl-End":"goDocEnd","Ctrl-Down":"goDocEnd","Ctrl-Left":"goGroupLeft","Ctrl-Right":"goGroupRight","Alt-Left":"goLineStart","Alt-Right":"goLineEnd","Ctrl-Backspace":"delGroupBefore","Ctrl-Delete":"delGroupAfter","Ctrl-S":"save","Ctrl-F":"find","Ctrl-G":"findNext","Shift-Ctrl-G":"findPrev","Shift-Ctrl-F":"replace","Shift-Ctrl-R":"replaceAll","Ctrl-[":"indentLess","Ctrl-]":"indentMore","Ctrl-U":"undoSelection","Shift-Ctrl-U":"redoSelection","Alt-U":"redoSelection",fallthrough:"basic"},ci.macDefault={"Cmd-A":"selectAll","Cmd-D":"deleteLine","Cmd-Z":"undo","Shift-Cmd-Z":"redo","Cmd-Y":"redo","Cmd-Up":"goDocStart","Cmd-End":"goDocEnd","Cmd-Down":"goDocEnd","Alt-Left":"goGroupLeft","Alt-Right":"goGroupRight","Cmd-Left":"goLineStart","Cmd-Right":"goLineEnd","Alt-Backspace":"delGroupBefore","Ctrl-Alt-Backspace":"delGroupAfter","Alt-Delete":"delGroupAfter","Cmd-S":"save","Cmd-F":"find","Cmd-G":"findNext","Shift-Cmd-G":"findPrev","Cmd-Alt-F":"replace","Shift-Cmd-Alt-F":"replaceAll","Cmd-[":"indentLess","Cmd-]":"indentMore","Cmd-Backspace":"delLineLeft","Cmd-U":"undoSelection","Shift-Cmd-U":"redoSelection",fallthrough:["basic","emacsy"]},ci.emacsy={"Ctrl-F":"goCharRight","Ctrl-B":"goCharLeft","Ctrl-P":"goLineUp","Ctrl-N":"goLineDown","Alt-F":"goWordRight","Alt-B":"goWordLeft","Ctrl-A":"goLineStart","Ctrl-E":"goLineEnd","Ctrl-V":"goPageDown","Shift-Ctrl-V":"goPageUp","Ctrl-D":"delCharAfter","Ctrl-H":"delCharBefore","Alt-D":"delWordAfter","Alt-Backspace":"delWordBefore","Ctrl-K":"killLine","Ctrl-T":"transposeChars"},ci["default"]=v?ci.macDefault:ci.pcDefault;var pi=S.lookupKey=function(e,t,n){function r(t){t=hi(t);var i=t[e];if(i===!1)return"stop";if(i!=null&&n(i))return!0;if(t.nofallthrough)return"stop";var s=t.fallthrough;if(s==null)return!1;if(Object.prototype.toString.call(s)!="[object Array]")return r(s);for(var o=0;o<s.length;++o){var u=r(s[o]);if(u)return u}return!1}for(var i=0;i<t.length;++i){var s=r(t[i]);if(s)return s!="stop"}},di=S.isModifierKey=function(e){var t=lu[e.keyCode];return t=="Ctrl"||t=="Alt"||t=="Shift"||t=="Mod"},vi=S.keyName=function(e,t){if(a&&e.keyCode==34&&e["char"])return!1;var n=lu[e.keyCode];if(n==null||e.altGraphKey)return!1;e.altKey&&(n="Alt-"+n);if(y?e.metaKey:e.ctrlKey)n="Ctrl-"+n;if(y?e.ctrlKey:e.metaKey)n="Cmd-"+n;return!t&&e.shiftKey&&(n="Shift-"+n),n};S.fromTextArea=function(e,t){function r(){e.value=a.getValue()}t||(t={}),t.value=e.value,!t.tabindex&&e.tabindex&&(t.tabindex=e.tabindex),!t.placeholder&&e.placeholder&&(t.placeholder=e.placeholder);if(t.autofocus==null){var n=Xo();t.autofocus=n==e||e.getAttribute("autofocus")!=null&&n==document.body}if(e.form){so(e.form,"submit",r);if(!t.leaveSubmitMethodAlone){var i=e.form,s=i.submit;try{var o=i.submit=function(){r(),i.submit=s,i.submit(),i.submit=o}}catch(u){}}}e.style.display="none";var a=S(function(t){e.parentNode.insertBefore(t,e.nextSibling)},t);return a.save=r,a.getTextArea=function(){return e},a.toTextArea=function(){r(),e.parentNode.removeChild(a.getWrapperElement()),e.style.display="",e.form&&(oo(e.form,"submit",r),typeof e.form.submit=="function"&&(e.form.submit=s))},a};var mi=S.StringStream=function(e,t){this.pos=this.start=0,this.string=e,this.tabSize=t||8,this.lastColumnPos=this.lastColumnValue=0,this.lineStart=0};mi.prototype={eol:function(){return this.pos>=this.string.length},sol:function(){return this.pos==this.lineStart},peek:function(){return this.string.charAt(this.pos)||undefined},next:function(){if(this.pos<this.string.length)return this.string.charAt(this.pos++)},eat:function(e){var t=this.string.charAt(this.pos);if(typeof e=="string")var n=t==e;else var n=t&&(e.test?e.test(t):e(t));if(n)return++this.pos,t},eatWhile:function(e){var t=this.pos;while(this.eat(e));return this.pos>t},eatSpace:function(){var e=this.pos;while(/[\s\u00a0]/.test(this.string.charAt(this.pos)))++this.pos;return this.pos>e},skipToEnd:function(){this.pos=this.string.length},skipTo:function(e){var t=this.string.indexOf(e,this.pos);if(t>-1)return this.pos=t,!0},backUp:function(e){this.pos-=e},column:function(){return this.lastColumnPos<this.start&&(this.lastColumnValue=xo(this.string,this.start,this.tabSize,this.lastColumnPos,this.lastColumnValue),this.lastColumnPos=this.start),this.lastColumnValue-(this.lineStart?xo(this.string,this.lineStart,this.tabSize):0)},indentation:function(){return xo(this.string,null,this.tabSize)-(this.lineStart?xo(this.string,this.lineStart,this.tabSize):0)},match:function(e,t,n){if(typeof e!="string"){var s=this.string.slice(this.pos).match(e);return s&&s.index>0?null:(s&&t!==!1&&(this.pos+=s[0].length),s)}var r=function(e){return n?e.toLowerCase():e},i=this.string.substr(this.pos,e.length);if(r(i)==r(e))return t!==!1&&(this.pos+=e.length),!0},current:function(){return this.string.slice(this.start,this.pos)},hideFirstChars:function(e,t){this.lineStart+=e;try{return t()}finally{this.lineStart-=e}}};var gi=S.TextMarker=function(e,t){this.lines=[],this.type=t,this.doc=e};mo(gi),gi.prototype.clear=function(){if(this.explicitlyCleared)return;var e=this.doc.cm,t=e&&!e.curOp;t&&Nn(e);if(vo(this,"clear")){var n=this.find();n&&lo(this,"clear",n.from,n.to)}var r=null,i=null;for(var s=0;s<this.lines.length;++s){var o=this.lines[s],u=Ci(o.markedSpans,this);e&&!this.collapsed?Pn(e,Ps(o),"text"):e&&(u.to!=null&&(i=Ps(o)),u.from!=null&&(r=Ps(o))),o.markedSpans=ki(o.markedSpans,u),u.from==null&&this.collapsed&&!Ji(this.doc,o)&&e&&Ds(o,En(e.display))}if(e&&this.collapsed&&!e.options.lineWrapping)for(var s=0;s<this.lines.length;++s){var a=Wi(this.lines[s]),f=P(a);f>e.display.maxLineLength&&(e.display.maxLine=a,e.display.maxLineLength=f,e.display.maxLineChanged=!0)}r!=null&&e&&this.collapsed&&Dn(e,r,i+1),this.lines.length=0,this.explicitlyCleared=!0,this.atomic&&this.doc.cantEdit&&(this.doc.cantEdit=!1,e&&jt(e.doc)),e&&lo(e,"markerCleared",e,this),t&&Cn(e),this.parent&&this.parent.clear()},gi.prototype.find=function(e,t){e==null&&this.type=="bookmark"&&(e=1);var n,r;for(var i=0;i<this.lines.length;++i){var s=this.lines[i],o=Ci(s.markedSpans,this);if(o.from!=null){n=pt(t?s:Ps(s),o.from);if(e==-1)return n}if(o.to!=null){r=pt(t?s:Ps(s),o.to);if(e==1)return r}}return n&&{from:n,to:r}},gi.prototype.changed=function(){var e=this.find(-1,!0),t=this,n=this.doc.cm;if(!e||!n)return;kn(n,function(){var r=e.line,i=Ps(e.line),s=tn(n,i);s&&(un(s),n.curOp.selectionChanged=n.curOp.forceUpdate=!0),n.curOp.updateMaxLine=!0;if(!Ji(t.doc,r)&&t.height!=null){var o=t.height;t.height=null;var u=Yi(t)-o;u&&Ds(r,r.height+u)}})},gi.prototype.attachLine=function(e){if(!this.lines.length&&this.doc.cm){var t=this.doc.cm.curOp;(!t.maybeHiddenMarkers||Ao(t.maybeHiddenMarkers,this)==-1)&&(t.maybeUnhiddenMarkers||(t.maybeUnhiddenMarkers=[])).push(this)}this.lines.push(e)},gi.prototype.detachLine=function(e){this.lines.splice(Ao(this.lines,e),1);if(!this.lines.length&&this.doc.cm){var t=this.doc.cm.curOp;(t.maybeHiddenMarkers||(t.maybeHiddenMarkers=[])).push(this)}};var yi=0,wi=S.SharedTextMarker=function(e,t){this.markers=e,this.primary=t;for(var n=0;n<e.length;++n)e[n].parent=this};mo(wi),wi.prototype.clear=function(){if(this.explicitlyCleared)return;this.explicitlyCleared=!0;for(var e=0;e<this.markers.length;++e)this.markers[e].clear();lo(this,"clear")},wi.prototype.find=function(e,t){return this.primary.find(e,t)};var Qi=S.LineWidget=function(e,t,n){if(n)for(var r in n)n.hasOwnProperty(r)&&(this[r]=n[r]);this.cm=e,this.node=t};mo(Qi),Qi.prototype.clear=function(){var e=this.cm,t=this.line.widgets,n=this.line,r=Ps(n);if(r==null||!t)return;for(var i=0;i<t.length;++i)t[i]==this&&t.splice(i--,1);t.length||(n.widgets=null);var s=Yi(this);kn(e,function(){Gi(e,n,-s),Pn(e,r,"widget"),Ds(n,Math.max(0,n.height-s))})},Qi.prototype.changed=function(){var e=this.height,t=this.cm,n=this.line;this.height=null;var r=Yi(this)-e;if(!r)return;kn(t,function(){t.curOp.forceUpdate=!0,Gi(t,n,r),Ds(n,n.height+r)})};var es=S.Line=function(e,t,n){this.text=e,Bi(this,t),this.height=n?n(this):1};mo(es),es.prototype.lineNo=function(){return Ps(this)};var ls={},cs={};Ss.prototype={chunkSize:function(){return this.lines.length},removeInner:function(e,t){for(var n=e,r=e+t;n<r;++n){var i=this.lines[n];this.height-=i.height,ns(i),lo(i,"delete")}this.lines.splice(e,t)},collapse:function(e){e.push.apply(e,this.lines)},insertInner:function(e,t,n){this.height+=n,this.lines=this.lines.slice(0,e).concat(t).concat(this.lines.slice(e));for(var r=0;r<t.length;++r)t[r].parent=this},iterN:function(e,t,n){for(var r=e+t;e<r;++e)if(n(this.lines[e]))return!0}},xs.prototype={chunkSize:function(){return this.size},removeInner:function(e,t){this.size-=t;for(var n=0;n<this.children.length;++n){var r=this.children[n],i=r.chunkSize();if(e<i){var s=Math.min(t,i-e),o=r.height;r.removeInner(e,s),this.height-=o-r.height,i==s&&(this.children.splice(n--,1),r.parent=null);if((t-=s)==0)break;e=0}else e-=i}if(this.size-t<25&&(this.children.length>1||!(this.children[0]instanceof Ss))){var u=[];this.collapse(u),this.children=[new Ss(u)],this.children[0].parent=this}},collapse:function(e){for(var t=0;t<this.children.length;++t)this.children[t].collapse(e)},insertInner:function(e,t,n){this.size+=t.length,this.height+=n;for(var r=0;r<this.children.length;++r){var i=this.children[r],s=i.chunkSize();if(e<=s){i.insertInner(e,t,n);if(i.lines&&i.lines.length>50){while(i.lines.length>50){var o=i.lines.splice(i.lines.length-25,25),u=new Ss(o);i.height-=u.height,this.children.splice(r+1,0,u),u.parent=this}this.maybeSpill()}break}e-=s}},maybeSpill:function(){if(this.children.length<=10)return;var e=this;do{var t=e.children.splice(e.children.length-5,5),n=new xs(t);if(!e.parent){var r=new xs(e.children);r.parent=e,e.children=[r,n],e=r}else{e.size-=n.size,e.height-=n.height;var i=Ao(e.parent.children,e);e.parent.children.splice(i+1,0,n)}n.parent=e.parent}while(e.children.length>10);e.parent.maybeSpill()},iterN:function(e,t,n){for(var r=0;r<this.children.length;++r){var i=this.children[r],s=i.chunkSize();if(e<s){var o=Math.min(t,s-e);if(i.iterN(e,o,n))return!0;if((t-=o)==0)break;e=0}else e-=s}}};var Ts=0,Ns=S.Doc=function(e,t,n){if(!(this instanceof Ns))return new Ns(e,t,n);n==null&&(n=0),xs.call(this,[new Ss([new es("",null)])]),this.first=n,this.scrollTop=this.scrollLeft=0,this.cantEdit=!1,this.cleanGeneration=1,this.frontier=n;var r=pt(n,0);this.sel=Et(r),this.history=new Fs(null),this.id=++Ts,this.modeOption=t,typeof e=="string"&&(e=uu(e)),Es(this,{from:r,to:r,text:e}),Pt(this,Et(r),bo)};Ns.prototype=Mo(xs.prototype,{constructor:Ns,iter:function(e,t,n){n?this.iterN(e-this.first,t-e,n):this.iterN(this.first,this.first+this.size,e)},insert:function(e,t){var n=0;for(var r=0;r<t.length;++r)n+=t[r].height;this.insertInner(e-this.first,t,n)},remove:function(e,t){this.removeInner(e-this.first,t)},getValue:function(e){var t=_s(this,this.first,this.first+this.size);return e===!1?t:t.join(e||"\n")},setValue:On(function(e){var t=pt(this.first,0),n=this.first+this.size-1;Dr(this,{from:t,to:pt(n,Os(this,n).text.length),text:uu(e),origin:"setValue"},!0),Pt(this,Et(t))}),replaceRange:function(e,t,n,r){t=xt(this,t),n=n?xt(this,n):t,Ir(this,e,t,n,r)},getRange:function(e,t,n){var r=Ms(this,xt(this,e),xt(this,t));return n===!1?r:r.join(n||"\n")},getLine:function(e){var t=this.getLineHandle(e);return t&&t.text},getLineHandle:function(e){if(Nt(this,e))return Os(this,e)},getLineNumber:function(e){return Ps(e)},getLineHandleVisualStart:function(e){return typeof e=="number"&&(e=Os(this,e)),Wi(e)},lineCount:function(){return this.size},firstLine:function(){return this.first},lastLine:function(){return this.first+this.size-1},clipPos:function(e){return xt(this,e)},getCursor:function(e){var t=this.sel.primary(),n;return e==null||e=="head"?n=t.head:e=="anchor"?n=t.anchor:e=="end"||e=="to"||e===!1?n=t.to():n=t.from(),n},listSelections:function(){return this.sel.ranges},somethingSelected:function(){return this.sel.somethingSelected()},setCursor:On(function(e,t,n){Mt(this,xt(this,typeof e=="number"?pt(e,t||0):e),null,n)}),setSelection:On(function(e,t,n){Mt(this,xt(this,e),xt(this,t||e),n)}),extendSelection:On(function(e,t,n){Lt(this,xt(this,e),t&&xt(this,t),n)}),extendSelections:On(function(e,t){At(this,Ct(this,e,t))}),extendSelectionsBy:On(function(e,t){At(this,Oo(this.sel.ranges,e),t)}),setSelections:On(function(e,t,n){if(!e.length)return;for(var r=0,i=[];r<e.length;r++)i[r]=new bt(xt(this,e[r].anchor),xt(this,e[r].head));t==null&&(t=Math.min(e.length-1,this.sel.primIndex)),Pt(this,wt(i,t),n)}),addSelection:On(function(e,t,n){var r=this.sel.ranges.slice(0);r.push(new bt(xt(this,e),xt(this,t||e))),Pt(this,wt(r,r.length-1),n)}),getSelection:function(e){var t=this.sel.ranges,n;for(var r=0;r<t.length;r++){var i=Ms(this,t[r].from(),t[r].to());n=n?n.concat(i):i}return e===!1?n:n.join(e||"\n")},getSelections:function(e){var t=[],n=this.sel.ranges;for(var r=0;r<n.length;r++){var i=Ms(this,n[r].from(),n[r].to());e!==!1&&(i=i.join(e||"\n")),t[r]=i}return t},replaceSelection:function(e,t,n){var r=[];for(var i=0;i<this.sel.ranges.length;i++)r[i]=e;this.replaceSelections(r,t,n||"+input")},replaceSelections:On(function(e,t,n){var r=[],i=this.sel;for(var s=0;s<i.ranges.length;s++){var o=i.ranges[s];r[s]={from:o.from(),to:o.to(),text:uu(e[s]),origin:n}}var u=t&&t!="end"&&Mr(this,r,t);for(var s=r.length-1;s>=0;s--)Dr(this,r[s]);u?Dt(this,u):this.cm&&Xr(this.cm)}),undo:On(function(){Hr(this,"undo")}),redo:On(function(){Hr(this,"redo")}),undoSelection:On(function(){Hr(this,"undo",!0)}),redoSelection:On(function(){Hr(this,"redo",!0)}),setExtending:function(e){this.extend=e},getExtending:function(){return this.extend},historySize:function(){var e=this.history,t=0,n=0;for(var r=0;r<e.done.length;r++)e.done[r].ranges||++t;for(var r=0;r<e.undone.length;r++)e.undone[r].ranges||++n;return{undo:t,redo:n}},clearHistory:function(){this.history=new Fs(this.history.maxGeneration)},markClean:function(){this.cleanGeneration=this.changeGeneration(!0)},changeGeneration:function(e){return e&&(this.history.lastOp=this.history.lastOrigin=null),this.history.generation},isClean:function(e){return this.history.generation==(e||this.cleanGeneration)},getHistory:function(){return{done:Ks(this.history.done),undone:Ks(this.history.undone)}},setHistory:function(e){var t=this.history=new Fs(this.history.maxGeneration);t.done=Ks(e.done.slice(0),null,!0),t.undone=Ks(e.undone.slice(0),null,!0)},addLineClass:On(function(e,t,n){return Jr(this,e,"class",function(e){var r=t=="text"?"textClass":t=="background"?"bgClass":"wrapClass";if(!e[r])e[r]=n;else{if((new RegExp("(?:^|\\s)"+n+"(?:$|\\s)")).test(e[r]))return!1;e[r]+=" "+n}return!0})}),removeLineClass:On(function(e,t,n){return Jr(this,e,"class",function(e){var r=t=="text"?"textClass":t=="background"?"bgClass":"wrapClass",i=e[r];if(!i)return!1;if(n==null)e[r]=null;else{var s=i.match(new RegExp("(?:^|\\s+)"+n+"(?:$|\\s+)"));if(!s)return!1;var o=s.index+s[0].length;e[r]=i.slice(0,s.index)+(!s.index||o==i.length?"":" ")+i.slice(o)||null}return!0})}),markText:function(e,t,n){return bi(this,xt(this,e),xt(this,t),n,"range")},setBookmark:function(e,t){var n={replacedWith:t&&(t.nodeType==null?t.widget:t),insertLeft:t&&t.insertLeft,clearWhenEmpty:!1,shared:t&&t.shared};return e=xt(this,e),bi(this,e,e,n,"bookmark")},findMarksAt:function(e){e=xt(this,e);var t=[],n=Os(this,e.line).markedSpans;if(n)for(var r=0;r<n.length;++r){var i=n[r];(i.from==null||i.from<=e.ch)&&(i.to==null||i.to>=e.ch)&&t.push(i.marker.parent||i.marker)}return t},findMarks:function(e,t,n){e=xt(this,e),t=xt(this,t);var r=[],i=e.line;return this.iter(e.line,t.line+1,function(s){var o=s.markedSpans;if(o)for(var u=0;u<o.length;u++){var a=o[u];!(i==e.line&&e.ch>a.to||a.from==null&&i!=e.line||i==t.line&&a.from>t.ch)&&(!n||n(a.marker))&&r.push(a.marker.parent||a.marker)}++i}),r},findMarksInRange:function(e,t){t||(t=e),e=xt(this,e),t=xt(this,t);var n=[],r=e.line;return this.iter(e.line,t.line+1,function(i){var s=i.markedSpans;if(s)for(var o=0;o<s.length;++o){var u=s[o],a=!1,f=!1;t.line===r?a=u.from==null||u.from<=t.ch:a=!0,e.line===r?f=u.to==null||u.to>=e.ch:f=!0;if(a&&f){var l=u.marker.parent||u.marker;n.indexOf(l)===-1&&n.push(l)}}r++}),n},getAllMarks:function(){var e=[];return this.iter(function(t){var n=t.markedSpans;if(n)for(var r=0;r<n.length;++r)n[r].from!=null&&e.push(n[r].marker)}),e},posFromIndex:function(e){var t,n=this.first;return this.iter(function(r){var i=r.text.length+1;if(i>e)return t=e,!0;e-=i,++n}),xt(this,pt(n,t))},indexFromPos:function(e){e=xt(this,e);var t=e.ch;return e.line<this.first||e.ch<0?0:(this.iter(this.first,e.line,function(e){t+=e.text.length+1}),t)},copy:function(e){var t=new Ns(_s(this,this.first,this.first+this.size),this.modeOption,this.first);return t.scrollTop=this.scrollTop,t.scrollLeft=this.scrollLeft,t.sel=this.sel,t.extend=!1,e&&(t.history.undoDepth=this.history.undoDepth,t.setHistory(this.getHistory())),t},linkedDoc:function(e){e||(e={});var t=this.first,n=this.first+this.size;e.from!=null&&e.from>t&&(t=e.from),e.to!=null&&e.to<n&&(n=e.to);var r=new Ns(_s(this,t,n),e.mode||this.modeOption,t);return e.sharedHist&&(r.history=this.history),(this.linked||(this.linked=[])).push({doc:r,sharedHist:e.sharedHist}),r.linked=[{doc:this,isParent:!0,sharedHist:e.sharedHist}],xi(r,Si(this)),r},unlinkDoc:function(e){e instanceof S&&(e=e.doc);if(this.linked)for(var t=0;t<this.linked.length;++t){var n=this.linked[t];if(n.doc!=e)continue;this.linked.splice(t,1),e.unlinkDoc(this),Ti(Si(this));break}if(e.history==this.history){var r=[e.id];Ls(e,function(e){r.push(e.id)},!0),e.history=new Fs(null),e.history.done=Ks(this.history.done,r),e.history.undone=Ks(this.history.undone,r)}},iterLinkedDocs:function(e){Ls(this,e)},getMode:function(){return this.mode},getEditor:function(){return this.cm}}),Ns.prototype.eachLine=Ns.prototype.iter;var Cs="iter insert remove copy getEditor".split(" ");for(var ks in Ns.prototype)Ns.prototype.hasOwnProperty(ks)&&Ao(Cs,ks)<0&&(S.prototype[ks]=function(e){return function(){return e.apply(this.doc,arguments)}}(Ns.prototype[ks]));mo(Ns);var Zs=S.e_preventDefault=function(e){e.preventDefault?e.preventDefault():e.returnValue=!1},eo=S.e_stopPropagation=function(e){e.stopPropagation?e.stopPropagation():e.cancelBubble=!0},no=S.e_stop=function(e){Zs(e),eo(e)},so=S.on=function(e,t,n){if(e.addEventListener)e.addEventListener(t,n,!1);else if(e.attachEvent)e.attachEvent("on"+t,n);else{var r=e._handlers||(e._handlers={}),i=r[t]||(r[t]=[]);i.push(n)}},oo=S.off=function(e,t,n){if(e.removeEventListener)e.removeEventListener(t,n,!1);else if(e.detachEvent)e.detachEvent("on"+t,n);else{var r=e._handlers&&e._handlers[t];if(!r)return;for(var i=0;i<r.length;++i)if(r[i]==n){r.splice(i,1);break}}},uo=S.signal=function(e,t){var n=e._handlers&&e._handlers[t];if(!n)return;var r=Array.prototype.slice.call(arguments,2);for(var i=0;i<n.length;++i)n[i].apply(null,r)},ao,fo=0,go=30,yo=S.Pass={toString:function(){return"CodeMirror.Pass"}},bo={scroll:!1},wo={origin:"*mouse"},Eo={origin:"+move"};So.prototype.set=function(e,t){clearTimeout(this.id),this.id=setTimeout(t,e)};var xo=S.countColumn=function(e,t,n,r,i){t==null&&(t=e.search(/[^\s\u00a0]/),t==-1&&(t=e.length));for(var s=r||0,o=i||0;;){var u=e.indexOf("	",s);if(u<0||u>=t)return o+(t-s);o+=u-s,o+=n-o%n,s=u+1}},No=[""],Lo=function(e){e.select()};p?Lo=function(e){e.selectionStart=0,e.selectionEnd=e.value.length}:r&&(Lo=function(e){try{e.select()}catch(t){}}),[].indexOf&&(Ao=function(e,t){return e.indexOf(t)}),[].map&&(Oo=function(e,t){return e.map(t)});var Po=/[\u00df\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/,Ho=S.isWordChar=function(e){return/\w/.test(e)||e>""&&(e.toUpperCase()!=e.toLowerCase()||Po.test(e))},Fo=/[\u0300-\u036f\u0483-\u0489\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u065e\u0670\u06d6-\u06dc\u06de-\u06e4\u06e7\u06e8\u06ea-\u06ed\u0711\u0730-\u074a\u07a6-\u07b0\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0900-\u0902\u093c\u0941-\u0948\u094d\u0951-\u0955\u0962\u0963\u0981\u09bc\u09be\u09c1-\u09c4\u09cd\u09d7\u09e2\u09e3\u0a01\u0a02\u0a3c\u0a41\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a70\u0a71\u0a75\u0a81\u0a82\u0abc\u0ac1-\u0ac5\u0ac7\u0ac8\u0acd\u0ae2\u0ae3\u0b01\u0b3c\u0b3e\u0b3f\u0b41-\u0b44\u0b4d\u0b56\u0b57\u0b62\u0b63\u0b82\u0bbe\u0bc0\u0bcd\u0bd7\u0c3e-\u0c40\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0cbc\u0cbf\u0cc2\u0cc6\u0ccc\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0d3e\u0d41-\u0d44\u0d4d\u0d57\u0d62\u0d63\u0dca\u0dcf\u0dd2-\u0dd4\u0dd6\u0ddf\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0f18\u0f19\u0f35\u0f37\u0f39\u0f71-\u0f7e\u0f80-\u0f84\u0f86\u0f87\u0f90-\u0f97\u0f99-\u0fbc\u0fc6\u102d-\u1030\u1032-\u1037\u1039\u103a\u103d\u103e\u1058\u1059\u105e-\u1060\u1071-\u1074\u1082\u1085\u1086\u108d\u109d\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b7-\u17bd\u17c6\u17c9-\u17d3\u17dd\u180b-\u180d\u18a9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193b\u1a17\u1a18\u1a56\u1a58-\u1a5e\u1a60\u1a62\u1a65-\u1a6c\u1a73-\u1a7c\u1a7f\u1b00-\u1b03\u1b34\u1b36-\u1b3a\u1b3c\u1b42\u1b6b-\u1b73\u1b80\u1b81\u1ba2-\u1ba5\u1ba8\u1ba9\u1c2c-\u1c33\u1c36\u1c37\u1cd0-\u1cd2\u1cd4-\u1ce0\u1ce2-\u1ce8\u1ced\u1dc0-\u1de6\u1dfd-\u1dff\u200c\u200d\u20d0-\u20f0\u2cef-\u2cf1\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua66f-\ua672\ua67c\ua67d\ua6f0\ua6f1\ua802\ua806\ua80b\ua825\ua826\ua8c4\ua8e0-\ua8f1\ua926-\ua92d\ua947-\ua951\ua980-\ua982\ua9b3\ua9b6-\ua9b9\ua9bc\uaa29-\uaa2e\uaa31\uaa32\uaa35\uaa36\uaa43\uaa4c\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uabe5\uabe8\uabed\udc00-\udfff\ufb1e\ufe00-\ufe0f\ufe20-\ufe26\uff9e\uff9f]/,Ro;document.createRange?Ro=function(e,t,n){var r=document.createRange();return r.setEnd(e,n),r.setStart(e,t),r}:Ro=function(e,t,n){var r=document.body.createTextRange();return r.moveToElementText(e.parentNode),r.collapse(!0),r.moveEnd("character",n),r.moveStart("character",t),r},r&&i<11&&(Xo=function(){try{return document.activeElement}catch(e){return document.body}});var Go=!1,eu=function(){if(r&&i<9)return!1;var e=qo("div");return"draggable"in e||"dragDrop"in e}(),tu,ru,su,uu=S.splitLines="\n\nb".split(/\n/).length!=3?function(e){var t=0,n=[],r=e.length;while(t<=r){var i=e.indexOf("\n",t);i==-1&&(i=e.length);var s=e.slice(t,e.charAt(i-1)=="\r"?i-1:i),o=s.indexOf("\r");o!=-1?(n.push(s.slice(0,o)),t+=o+1):(n.push(s),t=i+1)}return n}:function(e){return e.split(/\r\n?|\n/)},au=window.getSelection?function(e){try{return e.selectionStart!=e.selectionEnd}catch(t){return!1}}:function(e){try{var t=e.ownerDocument.selection.createRange()}catch(n){}return!t||t.parentElement()!=e?!1:t.compareEndPoints("StartToEnd",t)!=0},fu=function(){var e=qo("div");return"oncopy"in e?!0:(e.setAttribute("oncopy","return;"),typeof e.oncopy=="function")}(),lu={3:"Enter",8:"Backspace",9:"Tab",13:"Enter",16:"Shift",17:"Ctrl",18:"Alt",19:"Pause",20:"CapsLock",27:"Esc",32:"Space",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"Left",38:"Up",39:"Right",40:"Down",44:"PrintScrn",45:"Insert",46:"Delete",59:";",61:"=",91:"Mod",92:"Mod",93:"Mod",107:"=",109:"-",127:"Delete",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'",63232:"Up",63233:"Down",63234:"Left",63235:"Right",63272:"Delete",63273:"Home",63275:"End",63276:"PageUp",63277:"PageDown",63302:"Insert"};S.keyNames=lu,function(){for(var e=0;e<10;e++)lu[e+48]=lu[e+96]=String(e);for(var e=65;e<=90;e++)lu[e]=String.fromCharCode(e);for(var e=1;e<=12;e++)lu[e+111]=lu[e+63235]="F"+e}();var bu,Tu=function(){function n(n){return n<=247?e.charAt(n):1424<=n&&n<=1524?"R":1536<=n&&n<=1773?t.charAt(n-1536):1774<=n&&n<=2220?"r":8192<=n&&n<=8203?"w":n==8204?"b":"L"}function f(e,t,n){this.level=e,this.from=t,this.to=n}var e="bbbbbbbbbtstwsbbbbbbbbbbbbbbssstwNN%%%NNNNNN,N,N1111111111NNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNbbbbbbsbbbbbbbbbbbbbbbbbbbbbbbbbb,N%%%%NNNNLNNNNN%%11NLNNN1LNNNNNLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLN",t="rrrrrrrrrrrr,rNNmmmmmmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmrrrrrrrnnnnnnnnnn%nnrrrmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmmmmmmNmmmm",r=/[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/,i=/[stwN]/,s=/[LRr]/,o=/[Lb1n]/,u=/[1n]/,a="L";return function(e){if(!r.test(e))return!1;var t=e.length,l=[];for(var c=0,h;c<t;++c)l.push(h=n(e.charCodeAt(c)));for(var c=0,p=a;c<t;++c){var h=l[c];h=="m"?l[c]=p:p=h}for(var c=0,d=a;c<t;++c){var h=l[c];h=="1"&&d=="r"?l[c]="n":s.test(h)&&(d=h,h=="r"&&(l[c]="R"))}for(var c=1,p=l[0];c<t-1;++c){var h=l[c];h=="+"&&p=="1"&&l[c+1]=="1"?l[c]="1":h==","&&p==l[c+1]&&(p=="1"||p=="n")&&(l[c]=p),p=h}for(var c=0;c<t;++c){var h=l[c];if(h==",")l[c]="N";else if(h=="%"){for(var v=c+1;v<t&&l[v]=="%";++v);var m=c&&l[c-1]=="!"||v<t&&l[v]=="1"?"1":"N";for(var g=c;g<v;++g)l[g]=m;c=v-1}}for(var c=0,d=a;c<t;++c){var h=l[c];d=="L"&&h=="1"?l[c]="L":s.test(h)&&(d=h)}for(var c=0;c<t;++c)if(i.test(l[c])){for(var v=c+1;v<t&&i.test(l[v]);++v);var y=(c?l[c-1]:a)=="L",b=(v<t?l[v]:a)=="L",m=y||b?"L":"R";for(var g=c;g<v;++g)l[g]=m;c=v-1}var w=[],E;for(var c=0;c<t;)if(o.test(l[c])){var S=c;for(++c;c<t&&o.test(l[c]);++c);w.push(new f(0,S,c))}else{var x=c,T=w.length;for(++c;c<t&&l[c]!="L";++c);for(var g=x;g<c;)if(u.test(l[g])){x<g&&w.splice(T,0,new f(1,x,g));var N=g;for(++g;g<c&&u.test(l[g]);++g);w.splice(T,0,new f(2,N,g)),x=g}else++g;x<c&&w.splice(T,0,new f(1,x,c))}return w[0].level==1&&(E=e.match(/^\s+/))&&(w[0].from=E[0].length,w.unshift(new f(0,0,E[0].length))),ko(w).level==1&&(E=e.match(/\s+$/))&&(ko(w).to-=E[0].length,w.push(new f(0,t-E[0].length,t))),w[0].level!=ko(w).level&&w.push(new f(w[0].level,t,t)),w}}();return S.version="4.2.1",S}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/dialog/dialog",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e,t,n){var r=e.getWrapperElement(),i;return i=r.appendChild(document.createElement("div")),n?i.className="CodeMirror-dialog CodeMirror-dialog-bottom":i.className="CodeMirror-dialog CodeMirror-dialog-top",typeof t=="string"?i.innerHTML=t:i.appendChild(t),i}function n(e,t){e.state.currentNotificationClose&&e.state.currentNotificationClose(),e.state.currentNotificationClose=t}e.defineExtension("openDialog",function(r,i,s){function f(e){if(typeof e=="string")l.value=e;else{if(u)return;u=!0,o.parentNode.removeChild(o)}}n(this,null);var o=t(this,r,s&&s.bottom),u=!1,a=this,l=o.getElementsByTagName("input")[0],c;if(l)s&&s.value&&(l.value=s.value),e.on(l,"keydown",function(t){if(s&&s.onKeyDown&&s.onKeyDown(t,l.value,f))return;if(t.keyCode==13||t.keyCode==27)l.blur(),e.e_stop(t),f(),a.focus(),t.keyCode==13&&i(l.value)}),s&&s.onKeyUp&&e.on(l,"keyup",function(e){s.onKeyUp(e,l.value,f)}),s&&s.value&&(l.value=s.value),l.focus(),e.on(l,"blur",f);else if(c=o.getElementsByTagName("button")[0])e.on(c,"click",function(){f(),a.focus()}),c.focus(),e.on(c,"blur",f);return f}),e.defineExtension("openConfirm",function(r,i,s){function c(){if(a)return;a=!0,o.parentNode.removeChild(o),f.focus()}n(this,null);var o=t(this,r,s&&s.bottom),u=o.getElementsByTagName("button"),a=!1,f=this,l=1;u[0].focus();for(var h=0;h<u.length;++h){var p=u[h];(function(t){e.on(p,"click",function(n){e.e_preventDefault(n),c(),t&&t(f)})})(i[h]),e.on(p,"blur",function(){--l,setTimeout(function(){l<=0&&c()},200)}),e.on(p,"focus",function(){++l})}}),e.defineExtension("openNotification",function(r,i){function f(){if(u)return;u=!0,clearTimeout(a),s.parentNode.removeChild(s)}n(this,f);var s=t(this,r,i&&i.bottom),o=i&&(i.duration===undefined?5e3:i.duration),u=!1,a;e.on(s,"click",function(t){e.e_preventDefault(t),f()}),o&&(a=setTimeout(f,i.duration))})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/display/rulers",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e){for(var t=e.display.lineSpace.childNodes.length-1;t>=0;t--){var n=e.display.lineSpace.childNodes[t];/(^|\s)CodeMirror-ruler($|\s)/.test(n.className)&&n.parentNode.removeChild(n)}}function n(t){var n=t.getOption("rulers"),r=t.defaultCharWidth(),i=t.charCoords(e.Pos(t.firstLine(),0),"div").left,s=t.display.scroller.offsetHeight+30;for(var o=0;o<n.length;o++){var u=document.createElement("div");u.className="CodeMirror-ruler";var a,f=null,l=n[o];typeof l=="number"?a=l:(a=l.column,l.className&&(u.className+=" "+l.className),l.color&&(u.style.borderColor=l.color),l.lineStyle&&(u.style.borderLeftStyle=l.lineStyle),l.width&&(u.style.borderLeftWidth=l.width),f=n[o].className),u.style.left=i+a*r+"px",u.style.top="-50px",u.style.bottom="-20px",u.style.minHeight=s+"px",t.display.lineSpace.insertBefore(u,t.display.cursorDiv)}}function r(e){t(e),n(e)}e.defineOption("rulers",!1,function(i,s,o){o&&o!=e.Init&&(t(i),i.off("refresh",r)),s&&s.length&&(n(i),i.on("refresh",r))})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/selection/active-line",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function r(e){for(var r=0;r<e.state.activeLines.length;r++)e.removeLineClass(e.state.activeLines[r],"wrap",t),e.removeLineClass(e.state.activeLines[r],"background",n)}function i(e,t){if(e.length!=t.length)return!1;for(var n=0;n<e.length;n++)if(e[n]!=t[n])return!1;return!0}function s(e,s){var o=[];for(var u=0;u<s.length;u++){var a=s[u];if(!a.empty())continue;var f=e.getLineHandleVisualStart(a.head.line);o[o.length-1]!=f&&o.push(f)}if(i(e.state.activeLines,o))return;e.operation(function(){r(e);for(var i=0;i<o.length;i++)e.addLineClass(o[i],"wrap",t),e.addLineClass(o[i],"background",n);e.state.activeLines=o})}function o(e,t){s(e,t.ranges)}var t="CodeMirror-activeline",n="CodeMirror-activeline-background";e.defineOption("styleActiveLine",!1,function(t,n,i){var u=i&&i!=e.Init;n&&!u?(t.state.activeLines=[],s(t,t.listSelections()),t.on("beforeSelectionChange",o)):!n&&u&&(t.off("beforeSelectionChange",o),r(t),delete t.state.activeLines)})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/search/match-highlighter",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function i(e){typeof e=="object"&&(this.minChars=e.minChars,this.style=e.style,this.showToken=e.showToken,this.delay=e.delay),this.style==null&&(this.style=n),this.minChars==null&&(this.minChars=t),this.delay==null&&(this.delay=r),this.overlay=this.timeout=null}function s(e){var t=e.state.matchHighlighter;clearTimeout(t.timeout),t.timeout=setTimeout(function(){o(e)},t.delay)}function o(e){e.operation(function(){var t=e.state.matchHighlighter;t.overlay&&(e.removeOverlay(t.overlay),t.overlay=null);if(!e.somethingSelected()&&t.showToken){var n=t.showToken===!0?/[\w$]/:t.showToken,r=e.getCursor(),i=e.getLine(r.line),s=r.ch,o=s;while(s&&n.test(i.charAt(s-1)))--s;while(o<i.length&&n.test(i.charAt(o)))++o;s<o&&e.addOverlay(t.overlay=a(i.slice(s,o),n,t.style));return}var u=e.getCursor("from"),f=e.getCursor("to");if(u.line!=f.line)return;var l=e.getRange(u,f).replace(/^\s+|\s+$/g,"");l.length>=t.minChars&&e.addOverlay(t.overlay=a(l,!1,t.style))})}function u(e,t){return(!e.start||!t.test(e.string.charAt(e.start-1)))&&(e.pos==e.string.length||!t.test(e.string.charAt(e.pos)))}function a(e,t,n){return{token:function(r){if(r.match(e)&&(!t||u(r,t)))return n;r.next(),r.skipTo(e.charAt(0))||r.skipToEnd()}}}var t=2,n="matchhighlight",r=100;e.defineOption("highlightSelectionMatches",!1,function(t,n,r){if(r&&r!=e.Init){var u=t.state.matchHighlighter.overlay;u&&t.removeOverlay(u),clearTimeout(t.state.matchHighlighter.timeout),t.state.matchHighlighter=null,t.off("cursorActivity",s)}n&&(t.state.matchHighlighter=new i(n),o(t),t.on("cursorActivity",s))})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/search/searchcursor",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function n(e,n,i,s){this.atOccurrence=!1,this.doc=e,s==null&&typeof n=="string"&&(s=!1),i=i?e.clipPos(i):t(0,0),this.pos={from:i,to:i};if(typeof n!="string")n.global||(n=new RegExp(n.source,n.ignoreCase?"ig":"g")),this.matches=function(r,i){if(r){n.lastIndex=0;var s=e.getLine(i.line).slice(0,i.ch),o=0,u,a;for(;;){n.lastIndex=o;var f=n.exec(s);if(!f)break;u=f,a=u.index,o=u.index+(u[0].length||1);if(o==s.length)break}var l=u&&u[0].length||0;l||(a==0&&s.length==0?u=undefined:a!=e.getLine(i.line).length&&l++)}else{n.lastIndex=i.ch;var s=e.getLine(i.line),u=n.exec(s),l=u&&u[0].length||0,a=u&&u.index;a+l!=s.length&&!l&&(l=1)}if(u&&l)return{from:t(i.line,a),to:t(i.line,a+l),match:u}};else{var o=n;s&&(n=n.toLowerCase());var u=s?function(e){return e.toLowerCase()}:function(e){return e},a=n.split("\n");if(a.length==1)n.length?this.matches=function(i,s){if(i){var a=e.getLine(s.line).slice(0,s.ch),f=u(a),l=f.lastIndexOf(n);if(l>-1)return l=r(a,f,l),{from:t(s.line,l),to:t(s.line,l+o.length)}}else{var a=e.getLine(s.line).slice(s.ch),f=u(a),l=f.indexOf(n);if(l>-1)return l=r(a,f,l)+s.ch,{from:t(s.line,l),to:t(s.line,l+o.length)}}}:this.matches=function(){};else{var f=o.split("\n");this.matches=function(n,r){var i=a.length-1;if(n){if(r.line-(a.length-1)<e.firstLine())return;if(u(e.getLine(r.line).slice(0,f[i].length))!=a[a.length-1])return;var s=t(r.line,f[i].length);for(var o=r.line-1,l=i-1;l>=1;--l,--o)if(a[l]!=u(e.getLine(o)))return;var c=e.getLine(o),h=c.length-f[0].length;if(u(c.slice(h))!=a[0])return;return{from:t(o,h),to:s}}if(r.line+(a.length-1)>e.lastLine())return;var c=e.getLine(r.line),h=c.length-f[0].length;if(u(c.slice(h))!=a[0])return;var p=t(r.line,h);for(var o=r.line+1,l=1;l<i;++l,++o)if(a[l]!=u(e.getLine(o)))return;if(e.getLine(o).slice(0,f[i].length)!=a[i])return;return{from:p,to:t(o,f[i].length)}}}}}function r(e,t,n){if(e.length==t.length)return n;for(var r=Math.min(n,e.length);;){var i=e.slice(0,r).toLowerCase().length;if(i<n)++r;else{if(!(i>n))return r;--r}}}var t=e.Pos;n.prototype={findNext:function(){return this.find(!1)},findPrevious:function(){return this.find(!0)},find:function(e){function i(e){var r=t(e,0);return n.pos={from:r,to:r},n.atOccurrence=!1,!1}var n=this,r=this.doc.clipPos(e?this.pos.from:this.pos.to);for(;;){if(this.pos=this.matches(e,r))return this.atOccurrence=!0,this.pos.match||!0;if(e){if(!r.line)return i(0);r=t(r.line-1,this.doc.getLine(r.line-1).length)}else{var s=this.doc.lineCount();if(r.line==s-1)return i(s);r=t(r.line+1,0)}}},from:function(){if(this.atOccurrence)return this.pos.from},to:function(){if(this.atOccurrence)return this.pos.to},replace:function(n){if(!this.atOccurrence)return;var r=e.splitLines(n);this.doc.replaceRange(r,this.pos.from,this.pos.to),this.pos.to=t(this.pos.from.line+r.length-1,r[r.length-1].length+(r.length==1?this.pos.from.ch:0))}},e.defineExtension("getSearchCursor",function(e,t,r){return new n(this.doc,e,t,r)}),e.defineDocExtension("getSearchCursor",function(e,t,r){return new n(this,e,t,r)}),e.defineExtension("selectMatches",function(t,n){var r=[],i,s=this.getSearchCursor(t,this.getCursor("from"),n);while(i=s.findNext()){if(e.cmpPos(s.to(),this.getCursor("to"))>0)break;r.push({anchor:s.from(),head:s.to()})}r.length&&this.setSelections(r,0)})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("./searchcursor"),require("../dialog/dialog")):typeof define=="function"&&define.amd?define("components/codemirror/addon/search/search",["../../lib/codemirror","./searchcursor","../dialog/dialog"],e):e(CodeMirror)}(function(e){function t(e,t){return typeof e=="string"?e=new RegExp(e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&"),t?"gi":"g"):e.global||(e=new RegExp(e.source,e.ignoreCase?"gi":"g")),{token:function(t){e.lastIndex=t.pos;var n=e.exec(t.string);if(n&&n.index==t.pos)return t.pos+=n[0].length,"searching";n?t.pos=n.index:t.skipToEnd()}}}function n(){this.posFrom=this.posTo=this.query=null,this.overlay=null}function r(e){return e.state.search||(e.state.search=new n)}function i(e){return typeof e=="string"&&e==e.toLowerCase()}function s(e,t,n){return e.getSearchCursor(t,n,i(t))}function o(e,t,n,r,i){e.openDialog?e.openDialog(t,i,{value:r}):i(prompt(n,r))}function u(e,t,n,r){e.openConfirm?e.openConfirm(t,r):confirm(n)&&r[0]()}function a(e){var t=e.match(/^\/(.*)\/([a-z]*)$/);return t?(e=new RegExp(t[1],t[2].indexOf("i")==-1?"":"i"),e.test("")&&(e=/x^/)):e==""&&(e=/x^/),e}function l(e,n){var s=r(e);if(s.query)return c(e,n);o(e,f,"Search for:",e.getSelection(),function(r){e.operation(function(){if(!r||s.query)return;s.query=a(r),e.removeOverlay(s.overlay,i(s.query)),s.overlay=t(s.query,i(s.query)),e.addOverlay(s.overlay),s.posFrom=s.posTo=e.getCursor(),c(e,n)})})}function c(t,n){t.operation(function(){var i=r(t),o=s(t,i.query,n?i.posFrom:i.posTo);if(!o.find(n)){o=s(t,i.query,n?e.Pos(t.lastLine()):e.Pos(t.firstLine(),0));if(!o.find(n))return}t.setSelection(o.from(),o.to()),t.scrollIntoView({from:o.from(),to:o.to()}),i.posFrom=o.from(),i.posTo=o.to()})}function h(e){e.operation(function(){var t=r(e);if(!t.query)return;t.query=null,e.removeOverlay(t.overlay)})}function m(e,t){o(e,p,"Replace:",e.getSelection(),function(n){if(!n)return;n=a(n),o(e,d,"Replace with:","",function(r){if(t)e.operation(function(){for(var t=s(e,n);t.findNext();)if(typeof n!="string"){var i=e.getRange(t.from(),t.to()).match(n);t.replace(r.replace(/\$(\d)/g,function(e,t){return i[t]}))}else t.replace(r)});else{h(e);var i=s(e,n,e.getCursor()),o=function(){var t=i.from(),r;if(!(r=i.findNext())){i=s(e,n);if(!(r=i.findNext())||t&&i.from().line==t.line&&i.from().ch==t.ch)return}e.setSelection(i.from(),i.to()),e.scrollIntoView({from:i.from(),to:i.to()}),u(e,v,"Replace?",[function(){a(r)},o])},a=function(e){i.replace(typeof n=="string"?r:r.replace(/\$(\d)/g,function(t,n){return e[n]})),o()};o()}})})}var f='Search: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',p='Replace: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',d='With: <input type="text" style="width: 10em"/>',v="Replace? <button>Yes</button> <button>No</button> <button>Stop</button>";e.commands.find=function(e){h(e),l(e)},e.commands.findNext=l,e.commands.findPrev=function(e){l(e,!0)},e.commands.clearSearch=h,e.commands.replace=m,e.commands.replaceAll=function(e){m(e,!0)}}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/keymap/emacs",["../lib/codemirror"],e):e(CodeMirror)}(function(e){function n(e,t){return e.line==t.line&&e.ch==t.ch}function i(e){r.push(e),r.length>50&&r.shift()}function s(e){if(!r.length)return i(e);r[r.length-1]+=e}function o(e){return r[r.length-(e?Math.min(e,1):1)]||""}function u(){return r.length>1&&r.pop(),o()}function f(e,t,r,o,u){u==null&&(u=e.getRange(t,r)),o&&a&&a.cm==e&&n(t,a.pos)&&e.isClean(a.gen)?s(u):i(u),e.replaceRange("",t,r,"+delete"),o?a={cm:e,pos:t,gen:e.changeGeneration()}:a=null}function l(e,t,n){return e.findPosH(t,n,"char",!0)}function c(e,t,n){return e.findPosH(t,n,"word",!0)}function h(e,t,n){return e.findPosV(t,n,"line",e.doc.sel.goalColumn)}function p(e,t,n){return e.findPosV(t,n,"page",e.doc.sel.goalColumn)}function d(e,n,r){var i=n.line,s=e.getLine(i),o=/\S/.test(r<0?s.slice(0,n.ch):s.slice(n.ch)),u=e.firstLine(),a=e.lastLine();for(;;){i+=r;if(i<u||i>a)return e.clipPos(t(i-r,r<0?0:null));s=e.getLine(i);var f=/\S/.test(s);if(f)o=!0;else if(o)return t(i,0)}}function v(e,n,r){var i=n.line,s=n.ch,o=e.getLine(n.line),u=!1;for(;;){var a=o.charAt(s+(r<0?-1:0));if(!a){if(i==(r<0?e.firstLine():e.lastLine()))return t(i,s);o=e.getLine(i+r);if(!/\S/.test(o))return t(i,s);i+=r,s=r<0?o.length:0;continue}if(u&&/[!?.]/.test(a))return t(i,s+(r>0?1:0));u||(u=/\w/.test(a)),s+=r}}function m(e,r,i){var s;if(e.findMatchingBracket&&(s=e.findMatchingBracket(r,!0))&&s.match&&(s.forward?1:-1)==i)return i>0?t(s.to.line,s.to.ch+1):s.to;for(var o=!0;;o=!1){var u=e.getTokenAt(r),a=t(r.line,i<0?u.start:u.end);if(!(o&&i>0&&u.end==r.ch||!/\w/.test(u.string)))return a;var f=e.findPosH(a,i,"char");if(n(a,f))return r;r=f}}function g(e,t){var n=e.state.emacsPrefix;return n?(N(e),n=="-"?-1:Number(n)):t?null:1}function y(e){var t=typeof e=="string"?function(t){t.execCommand(e)}:e;return function(e){var n=g(e);t(e);for(var r=1;r<n;++r)t(e)}}function b(e,t,r){var i=e.getCursor(),s=g(e);s<0&&(r=-r,s=-s);for(var o=0;o<s;++o){var u=t(e,i,r);if(n(u,i))break;i=u}return i}function w(e,t){var n=function(n){n.extendSelection(b(n,e,t))};return n.motion=!0,n}function E(e,t,n){f(e,e.getCursor(),b(e,t,n),!0)}function S(e,t){if(e.state.emacsPrefix){t!="-"&&(e.state.emacsPrefix+=t);return}e.state.emacsPrefix=t,e.on("keyHandled",T),e.on("inputRead",C)}function T(e,t){!e.state.emacsPrefixMap&&!x.hasOwnProperty(t)&&N(e)}function N(e){e.state.emacsPrefix=null,e.off("keyHandled",T),e.off("inputRead",C)}function C(e,t){var n=g(e);if(n>1&&t.origin=="+input"){var r=t.text.join("\n"),i="";for(var s=1;s<n;++s)i+=r;e.replaceSelection(i)}}function k(e){e.state.emacsPrefixMap=!0,e.addKeyMap(B),e.on("keyHandled",L),e.on("inputRead",L)}function L(e,t){if(!(typeof t!="string"||!/^\d$/.test(t)&&t!="Ctrl-U"))return;e.removeKeyMap(B),e.state.emacsPrefixMap=!1,e.off("keyHandled",L),e.off("inputRead",L)}function A(e){e.setCursor(e.getCursor()),e.setExtending(!e.getExtending()),e.on("change",function(){e.setExtending(!1)})}function O(e){e.setExtending(!1),e.setCursor(e.getCursor())}function M(e,t,n){e.openDialog?e.openDialog(t+': <input type="text" style="width: 10em"/>',n,{bottom:!0}):n(prompt(t,""))}function _(e,t){var n=e.getCursor(),r=e.findPosH(n,1,"word");e.replaceRange(t(e.getRange(n,r)),n,r),e.setCursor(r)}function D(e){var n=e.getCursor(),r=n.line,i=n.ch,s=[];while(r>=e.firstLine()){var o=e.getLine(r);for(var u=i==null?o.length:i;u>0;){var i=o.charAt(--u);if(i==")")s.push("(");else if(i=="]")s.push("[");else if(i=="}")s.push("{");else if(/[\(\{\[]/.test(i)&&(!s.length||s.pop()!=i))return e.extendSelection(t(r,u))}--r,i=null}}function P(e){e.execCommand("clearSearch"),O(e)}function j(e){B[e]=function(t){S(t,e)},H["Ctrl-"+e]=function(t){S(t,e)},x["Ctrl-"+e]=!0}var t=e.Pos,r=[],a=null,x={"Alt-G":!0,"Ctrl-X":!0,"Ctrl-Q":!0,"Ctrl-U":!0},H=e.keyMap.emacs={"Ctrl-W":function(e){f(e,e.getCursor("start"),e.getCursor("end"))},"Ctrl-K":y(function(e){var n=e.getCursor(),r=e.clipPos(t(n.line)),i=e.getRange(n,r);/\S/.test(i)||(i+="\n",r=t(n.line+1,0)),f(e,n,r,!0,i)}),"Alt-W":function(e){i(e.getSelection()),O(e)},"Ctrl-Y":function(e){var t=e.getCursor();e.replaceRange(o(g(e)),t,t,"paste"),e.setSelection(t,e.getCursor())},"Alt-Y":function(e){e.replaceSelection(u(),"around","paste")},"Ctrl-Space":A,"Ctrl-Shift-2":A,"Ctrl-F":w(l,1),"Ctrl-B":w(l,-1),Right:w(l,1),Left:w(l,-1),"Ctrl-D":function(e){E(e,l,1)},Delete:function(e){E(e,l,1)},"Ctrl-H":function(e){E(e,l,-1)},Backspace:function(e){E(e,l,-1)},"Alt-F":w(c,1),"Alt-B":w(c,-1),"Alt-D":function(e){E(e,c,1)},"Alt-Backspace":function(e){E(e,c,-1)},"Ctrl-N":w(h,1),"Ctrl-P":w(h,-1),Down:w(h,1),Up:w(h,-1),"Ctrl-A":"goLineStart","Ctrl-E":"goLineEnd",End:"goLineEnd",Home:"goLineStart","Alt-V":w(p,-1),"Ctrl-V":w(p,1),PageUp:w(p,-1),PageDown:w(p,1),"Ctrl-Up":w(d,-1),"Ctrl-Down":w(d,1),"Alt-A":w(v,-1),"Alt-E":w(v,1),"Alt-K":function(e){E(e,v,1)},"Ctrl-Alt-K":function(e){E(e,m,1)},"Ctrl-Alt-Backspace":function(e){E(e,m,-1)},"Ctrl-Alt-F":w(m,1),"Ctrl-Alt-B":w(m,-1),"Shift-Ctrl-Alt-2":function(e){e.setSelection(b(e,m,1),e.getCursor())},"Ctrl-Alt-T":function(e){var t=m(e,e.getCursor(),-1),n=m(e,t,1),r=m(e,n,1),i=m(e,r,-1);e.replaceRange(e.getRange(i,r)+e.getRange(n,i)+e.getRange(t,n),t,r)},"Ctrl-Alt-U":y(D),"Alt-Space":function(e){var n=e.getCursor(),r=n.ch,i=n.ch,s=e.getLine(n.line);while(r&&/\s/.test(s.charAt(r-1)))--r;while(i<s.length&&/\s/.test(s.charAt(i)))++i;e.replaceRange(" ",t(n.line,r),t(n.line,i))},"Ctrl-O":y(function(e){e.replaceSelection("\n","start")}),"Ctrl-T":y(function(e){e.execCommand("transposeChars")}),"Alt-C":y(function(e){_(e,function(e){var t=e.search(/\w/);return t==-1?e:e.slice(0,t)+e.charAt(t).toUpperCase()+e.slice(t+1).toLowerCase()})}),"Alt-U":y(function(e){_(e,function(e){return e.toUpperCase()})}),"Alt-L":y(function(e){_(e,function(e){return e.toLowerCase()})}),"Alt-;":"toggleComment","Ctrl-/":y("undo"),"Shift-Ctrl--":y("undo"),"Ctrl-Z":y("undo"),"Cmd-Z":y("undo"),"Shift-Alt-,":"goDocStart","Shift-Alt-.":"goDocEnd","Ctrl-S":"findNext","Ctrl-R":"findPrev","Ctrl-G":P,"Shift-Alt-5":"replace","Alt-/":"autocomplete","Ctrl-J":"newlineAndIndent",Enter:!1,Tab:"indentAuto","Alt-G":function(e){e.setOption("keyMap","emacs-Alt-G")},"Ctrl-X":function(e){e.setOption("keyMap","emacs-Ctrl-X")},"Ctrl-Q":function(e){e.setOption("keyMap","emacs-Ctrl-Q")},"Ctrl-U":k};e.keyMap["emacs-Ctrl-X"]={Tab:function(e){e.indentSelection(g(e,!0)||e.getOption("indentUnit"))},"Ctrl-X":function(e){e.setSelection(e.getCursor("head"),e.getCursor("anchor"))},"Ctrl-S":"save","Ctrl-W":"save",S:"saveAll",F:"open",U:y("undo"),K:"close",Delete:function(e){f(e,e.getCursor(),v(e,e.getCursor(),1),!0)},auto:"emacs",nofallthrough:!0,disableInput:!0},e.keyMap["emacs-Alt-G"]={G:function(e){var t=g(e,!0);if(t!=null&&t>0)return e.setCursor(t-1);M(e,"Goto line",function(t){var n;t&&!isNaN(n=Number(t))&&n==n|0&&n>0&&e.setCursor(n-1)})},auto:"emacs",nofallthrough:!0,disableInput:!0},e.keyMap["emacs-Ctrl-Q"]={Tab:y("insertTab"),auto:"emacs",nofallthrough:!0};var B={"Ctrl-G":N};for(var F=0;F<10;++F)j(String(F));j("-")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/edit/matchbrackets",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function i(e,t,i,o){var u=e.getLineHandle(t.line),a=t.ch-1,f=a>=0&&r[u.text.charAt(a)]||r[u.text.charAt(++a)];if(!f)return null;var l=f.charAt(1)==">"?1:-1;if(i&&l>0!=(a==t.ch))return null;var c=e.getTokenTypeAt(n(t.line,a+1)),h=s(e,n(t.line,a+(l>0?1:0)),l,c||null,o);return h==null?null:{from:n(t.line,a),to:h&&h.pos,match:h&&h.ch==f.charAt(0),forward:l>0}}function s(e,t,i,s,o){var u=o&&o.maxScanLineLength||1e4,a=o&&o.maxScanLines||1e3,f=[],l=o&&o.bracketRegex?o.bracketRegex:/[(){}[\]]/,c=i>0?Math.min(t.line+a,e.lastLine()+1):Math.max(e.firstLine()-1,t.line-a);for(var h=t.line;h!=c;h+=i){var p=e.getLine(h);if(!p)continue;var d=i>0?0:p.length-1,v=i>0?p.length:-1;if(p.length>u)continue;h==t.line&&(d=t.ch-(i<0?1:0));for(;d!=v;d+=i){var m=p.charAt(d);if(l.test(m)&&(s===undefined||e.getTokenTypeAt(n(h,d+1))==s)){var g=r[m];if(g.charAt(1)==">"==i>0)f.push(m);else{if(!f.length)return{pos:n(h,d),ch:m};f.pop()}}}}return h-i==(i>0?e.lastLine():e.firstLine())?!1:null}function o(e,r,s){var o=e.state.matchBrackets.maxHighlightLineLength||1e3,u=[],a=e.listSelections();for(var f=0;f<a.length;f++){var l=a[f].empty()&&i(e,a[f].head,!1,s);if(l&&e.getLine(l.from.line).length<=o){var c=l.match?"CodeMirror-matchingbracket":"CodeMirror-nonmatchingbracket";u.push(e.markText(l.from,n(l.from.line,l.from.ch+1),{className:c})),l.to&&e.getLine(l.to.line).length<=o&&u.push(e.markText(l.to,n(l.to.line,l.to.ch+1),{className:c}))}}if(u.length){t&&e.state.focused&&e.display.input.focus();var h=function(){e.operation(function(){for(var e=0;e<u.length;e++)u[e].clear()})};if(!r)return h;setTimeout(h,800)}}function a(e){e.operation(function(){u&&(u(),u=null),u=o(e,!1,e.state.matchBrackets)})}var t=/MSIE \d/.test(navigator.userAgent)&&(document.documentMode==null||document.documentMode<8),n=e.Pos,r={"(":")>",")":"(<","[":"]>","]":"[<","{":"}>","}":"{<"},u=null;e.defineOption("matchBrackets",!1,function(t,n,r){r&&r!=e.Init&&t.off("cursorActivity",a),n&&(t.state.matchBrackets=typeof n=="object"?n:{},t.on("cursorActivity",a))}),e.defineExtension("matchBrackets",function(){o(this,!0)}),e.defineExtension("findMatchingBracket",function(e,t,n){return i(this,e,t,n)}),e.defineExtension("scanForBracket",function(e,t,n,r){return s(this,e,t,n,r)})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../lib/codemirror"),require("../addon/search/searchcursor"),require("../addon/edit/matchbrackets")):typeof define=="function"&&define.amd?define("components/codemirror/keymap/sublime",["../lib/codemirror","../addon/search/searchcursor","../addon/edit/matchbrackets"],e):e(CodeMirror)}(function(e){function s(t,n,i){if(i<0&&n.ch==0)return t.clipPos(r(n.line-1));var s=t.getLine(n.line);if(i>0&&n.ch>=s.length)return t.clipPos(r(n.line+1,0));var o="start",u;for(var a=n.ch,f=i<0?0:s.length,l=0;a!=f;a+=i,l++){var c=s.charAt(i<0?a-1:a),h=c!="_"&&e.isWordChar(c)?"w":"o";h=="w"&&c.toUpperCase()==c&&(h="W");if(o=="start")h!="o"&&(o="in",u=h);else if(o=="in"&&u!=h){u=="w"&&h=="W"&&i<0&&a--;if(u=="W"&&h=="w"&&i>0){u="w";continue}break}}return r(n.line,a)}function o(e,t){e.extendSelectionsBy(function(n){return e.display.shift||e.doc.extend||n.empty()?s(e.doc,n.head,t):t<0?n.from():n.to()})}function u(e,t){e.operation(function(){var n=e.listSelections().length,i=[],s=-1;for(var o=0;o<n;o++){var u=e.listSelections()[o].head;if(u.line<=s)continue;var a=r(u.line+(t?0:1),0);e.replaceRange("\n",a,null,"+insertLine"),e.indentLine(a.line,null,!0),i.push({head:a,anchor:a}),s=u.line+1}e.setSelections(i)})}function a(t,n){var i=n.ch,s=i,o=t.getLine(n.line);while(i&&e.isWordChar(o.charAt(i-1)))--i;while(s<o.length&&e.isWordChar(o.charAt(s)))++s;return{from:r(n.line,i),to:r(n.line,s),word:o.slice(i,s)}}function l(e){var t=e.getCursor(),n=e.scanForBracket(t,-1);if(!n)return;for(;;){var i=e.scanForBracket(t,1);if(!i)return;if(i.ch==f.charAt(f.indexOf(n.ch)+1))return e.setSelection(r(n.pos.line,n.pos.ch+1),i.pos,!1),!0;t=r(i.pos.line,i.pos.ch+1)}}function c(e,t){var n=e.listSelections(),i=[],s;for(var o=0;o<n.length;o++){var u=n[o];if(u.empty())continue;var a=u.from().line,f=u.to().line;while(o<n.length-1&&n[o+1].from().line==f)f=u[++o].to().line;i.push(a,f)}i.length?s=!0:i.push(e.firstLine(),e.lastLine()),e.operation(function(){var n=[];for(var o=0;o<i.length;o+=2){var u=i[o],a=i[o+1],f=r(u,0),l=r(a),c=e.getRange(f,l,!1);t?c.sort():c.sort(function(e,t){var n=e.toUpperCase(),r=t.toUpperCase();return n!=r&&(e=n,t=r),e<t?-1:e==t?0:1}),e.replaceRange(c,f,l),s&&n.push({anchor:f,head:l})}s&&e.setSelections(n,0)})}function p(t,n){t.operation(function(){var r=t.listSelections(),i=[],s=[];for(var o=0;o<r.length;o++){var u=r[o];u.empty()?(i.push(o),s.push("")):s.push(n(t.getRange(u.from(),u.to())))}t.replaceSelections(s,"around","case");for(var o=i.length-1,f;o>=0;o--){var u=r[i[o]];if(f&&e.cmpPos(u.head,f)>0)continue;var l=a(t,u.head);f=l.from,t.replaceRange(n(l.word),l.from,l.to)}})}function d(t,n){var i=t.getCursor("from"),s=t.getCursor("to");if(e.cmpPos(i,s)==0){var o=a(t,i);if(!o.word)return;i=o.from,s=o.to}var u=t.getRange(i,s),f=t.getSearchCursor(u,n?s:i);(n?f.findNext():f.findPrevious())?t.setSelection(f.from(),f.to()):(f=t.getSearchCursor(u,n?r(t.firstLine(),0):t.clipPos(r(t.lastLine()))),(n?f.findNext():f.findPrevious())?t.setSelection(f.from(),f.to()):o&&t.setSelection(i,s))}var t=e.keyMap.sublime={fallthrough:"default"},n=e.commands,r=e.Pos,i=e.keyMap["default"]==e.keyMap.pcDefault?"Ctrl-":"Cmd-";n[t["Alt-Left"]="goSubwordLeft"]=function(e){o(e,-1)},n[t["Alt-Right"]="goSubwordRight"]=function(e){o(e,1)},n[t[i+"Up"]="scrollLineUp"]=function(e){var t=e.getScrollInfo();if(!e.somethingSelected()){var n=e.lineAtHeight(t.top+t.clientHeight,"local");e.getCursor().line>=n&&e.execCommand("goLineUp")}e.scrollTo(null,t.top-e.defaultTextHeight())},n[t[i+"Down"]="scrollLineDown"]=function(e){var t=e.getScrollInfo();if(!e.somethingSelected()){var n=e.lineAtHeight(t.top,"local")+1;e.getCursor().line<=n&&e.execCommand("goLineDown")}e.scrollTo(null,t.top+e.defaultTextHeight())},n[t["Shift-"+i+"L"]="splitSelectionByLine"]=function(e){var t=e.listSelections(),n=[];for(var i=0;i<t.length;i++){var s=t[i].from(),o=t[i].to();for(var u=s.line;u<=o.line;++u)o.line>s.line&&u==o.line&&o.ch==0||n.push({anchor:u==s.line?s:r(u,0),head:u==o.line?o:r(u)})}e.setSelections(n,0)},t["Shift-Tab"]="indentLess",n[t.Esc="singleSelectionTop"]=function(e){var t=e.listSelections()[0];e.setSelection(t.anchor,t.head,{scroll:!1})},n[t[i+"L"]="selectLine"]=function(e){var t=e.listSelections(),n=[];for(var i=0;i<t.length;i++){var s=t[i];n.push({anchor:r(s.from().line,0),head:r(s.to().line+1,0)})}e.setSelections(n)},t["Shift-"+i+"K"]="deleteLine",n[t[i+"Enter"]="insertLineAfter"]=function(e){u(e,!1)},n[t["Shift-"+i+"Enter"]="insertLineBefore"]=function(e){u(e,!0)},n[t[i+"D"]="selectNextOccurrence"]=function(t){var n=t.getCursor("from"),i=t.getCursor("to"),s=t.state.sublimeFindFullWord==t.doc.sel;if(e.cmpPos(n,i)==0){var o=a(t,n);if(!o.word)return;t.setSelection(o.from,o.to),s=!0}else{var u=t.getRange(n,i),f=s?new RegExp("\\b"+u+"\\b"):u,l=t.getSearchCursor(f,i);l.findNext()?t.addSelection(l.from(),l.to()):(l=t.getSearchCursor(f,r(t.firstLine(),0)),l.findNext()&&t.addSelection(l.from(),l.to()))}s&&(t.state.sublimeFindFullWord=t.doc.sel)};var f="(){}[]";n[t["Shift-"+i+"Space"]="selectScope"]=function(e){l(e)||e.execCommand("selectAll")},n[t["Shift-"+i+"M"]="selectBetweenBrackets"]=function(t){if(!l(t))return e.Pass},n[t[i+"M"]="goToBracket"]=function(t){t.extendSelectionsBy(function(n){var i=t.scanForBracket(n.head,1);if(i&&e.cmpPos(i.pos,n.head)!=0)return i.pos;var s=t.scanForBracket(n.head,-1);return s&&r(s.pos.line,s.pos.ch+1)||n.head})},n[t["Shift-"+i+"Up"]="swapLineUp"]=function(e){var t=e.listSelections(),n=[],i=e.firstLine()-1,s=[];for(var o=0;o<t.length;o++){var u=t[o],a=u.from().line-1,f=u.to().line;s.push({anchor:r(u.anchor.line-1,u.anchor.ch),head:r(u.head.line-1,u.head.ch)}),u.to().ch==0&&!u.empty()&&--f,a>i?n.push(a,f):n.length&&(n[n.length-1]=f),i=f}e.operation(function(){for(var t=0;t<n.length;t+=2){var i=n[t],o=n[t+1],u=e.getLine(i);e.replaceRange("",r(i,0),r(i+1,0),"+swapLine"),o>e.lastLine()?e.replaceRange("\n"+u,r(e.lastLine()),null,"+swapLine"):e.replaceRange(u+"\n",r(o,0),null,"+swapLine")}e.setSelections(s),e.scrollIntoView()})},n[t["Shift-"+i+"Down"]="swapLineDown"]=function(e){var t=e.listSelections(),n=[],i=e.lastLine()+1;for(var s=t.length-1;s>=0;s--){var o=t[s],u=o.to().line+1,a=o.from().line;o.to().ch==0&&!o.empty()&&u--,u<i?n.push(u,a):n.length&&(n[n.length-1]=a),i=a}e.operation(function(){for(var t=n.length-2;t>=0;t-=2){var i=n[t],s=n[t+1],o=e.getLine(i);i==e.lastLine()?e.replaceRange("",r(i-1),r(i),"+swapLine"):e.replaceRange("",r(i,0),r(i+1,0),"+swapLine"),e.replaceRange(o+"\n",r(s,0),null,"+swapLine")}e.scrollIntoView()})},t[i+"/"]="toggleComment",n[t[i+"J"]="joinLines"]=function(e){var t=e.listSelections(),n=[];for(var i=0;i<t.length;i++){var s=t[i],o=s.from(),u=o.line,a=s.to().line;while(i<t.length-1&&t[i+1].from().line==a)a=t[++i].to().line;n.push({start:u,end:a,anchor:!s.empty()&&o})}e.operation(function(){var t=0,i=[];for(var s=0;s<n.length;s++){var o=n[s],u=o.anchor&&r(o.anchor.line-t,o.anchor.ch),a;for(var f=o.start;f<=o.end;f++){var l=f-t;f==o.end&&(a=r(l,e.getLine(l).length+1)),l<e.lastLine()&&(e.replaceRange(" ",r(l),r(l+1,/^\s*/.exec(e.getLine(l+1))[0].length)),++t)}i.push({anchor:u||a,head:a})}e.setSelections(i,0)})},n[t["Shift-"+i+"D"]="duplicateLine"]=function(e){e.operation(function(){var t=e.listSelections().length;for(var n=0;n<t;n++){var i=e.listSelections()[n];i.empty()?e.replaceRange(e.getLine(i.head.line)+"\n",r(i.head.line,0)):e.replaceRange(e.getRange(i.from(),i.to()),i.from())}e.scrollIntoView()})},t[i+"T"]="transposeChars",n[t.F9="sortLines"]=function(e){c(e,!0)},n[t[i+"F9"]="sortLinesInsensitive"]=function(e){c(e,!1)},n[t.F2="nextBookmark"]=function(e){var t=e.state.sublimeBookmarks;if(t)while(t.length){var n=t.shift(),r=n.find();if(r)return t.push(n),e.setSelection(r.from,r.to)}},n[t["Shift-F2"]="prevBookmark"]=function(e){var t=e.state.sublimeBookmarks;if(t)while(t.length){t.unshift(t.pop());var n=t[t.length-1].find();if(!!n)return e.setSelection(n.from,n.to);t.pop()}},n[t[i+"F2"]="toggleBookmark"]=function(e){var t=e.listSelections(),n=e.state.sublimeBookmarks||(e.state.sublimeBookmarks=[]);for(var r=0;r<t.length;r++){var i=t[r].from(),s=t[r].to(),o=e.findMarks(i,s);for(var u=0;u<o.length;u++)if(o[u].sublimeBookmark){o[u].clear();for(var a=0;a<n.length;a++)n[a]==o[u]&&n.splice(a--,1);break}u==o.length&&n.push(e.markText(i,s,{sublimeBookmark:!0,clearWhenEmpty:!1}))}},n[t["Shift-"+i+"F2"]="clearBookmarks"]=function(e){var t=e.state.sublimeBookmarks;if(t)for(var n=0;n<t.length;n++)t[n].clear();t.length=0},n[t["Alt-F2"]="selectBookmarks"]=function(e){var t=e.state.sublimeBookmarks,n=[];if(t)for(var r=0;r<t.length;r++){var i=t[r].find();i?n.push({anchor:i.from,head:i.to}):t.splice(r--,0)}n.length&&e.setSelections(n,0)},t["Alt-Q"]="wrapLines";var h=e.keyMap["sublime-Ctrl-K"]={auto:"sublime",nofallthrough:!0};t[i+"K"]=function(e){e.setOption("keyMap","sublime-Ctrl-K")},h[i+"Backspace"]="delLineLeft",n[h[i+"K"]="delLineRight"]=function(e){e.operation(function(){var t=e.listSelections();for(var n=t.length-1;n>=0;n--)e.replaceRange("",t[n].anchor,r(t[n].to().line),"+delete");e.scrollIntoView()})},n[h[i+"U"]="upcaseAtCursor"]=function(e){p(e,function(e){return e.toUpperCase()})},n[h[i+"L"]="downcaseAtCursor"]=function(e){p(e,function(e){return e.toLowerCase()})},n[h[i+"Space"]="setSublimeMark"]=function(e){e.state.sublimeMark&&e.state.sublimeMark.clear(),e.state.sublimeMark=e.setBookmark(e.getCursor())},n[h[i+"A"]="selectToSublimeMark"]=function(e){var t=e.state.sublimeMark&&e.state.sublimeMark.find();t&&e.setSelection(e.getCursor(),t)},n[h[i+"W"]="deleteToSublimeMark"]=function(t){var n=t.state.sublimeMark&&t.state.sublimeMark.find();if(n){var r=t.getCursor(),i=n;if(e.cmpPos(r,i)>0){var s=i;i=r,r=s}t.state.sublimeKilled=t.getRange(r,i),t.replaceRange("",r,i)}},n[h[i+"X"]="swapWithSublimeMark"]=function(e){var t=e.state.sublimeMark&&e.state.sublimeMark.find();t&&(e.state.sublimeMark.clear(),e.state.sublimeMark=e.setBookmark(e.getCursor()),e.setCursor(t))},n[h[i+"Y"]="sublimeYank"]=function(e){e.state.sublimeKilled!=null&&e.replaceSelection(e.state.sublimeKilled,null,"paste")},h[i+"G"]="clearBookmarks",n[h[i+"C"]="showInCenter"]=function(e){var t=e.cursorCoords(null,"local");e.scrollTo(null,(t.top+t.bottom)/2-e.getScrollInfo().clientHeight/2)},n[t["Shift-Alt-Up"]="selectLinesUpward"]=function(e){e.operation(function(){var t=e.listSelections();for(var n=0;n<t.length;n++){var i=t[n];i.head.line>e.firstLine()&&e.addSelection(r(i.head.line-1,i.head.ch))}})},n[t["Shift-Alt-Down"]="selectLinesDownward"]=function(e){e.operation(function(){var t=e.listSelections();for(var n=0;n<t.length;n++){var i=t[n];i.head.line<e.lastLine()&&e.addSelection(r(i.head.line+1,i.head.ch))}})},n[t[i+"F3"]="findUnder"]=function(e){d(e,!0)},n[t["Shift-"+i+"F3"]="findUnderPrevious"]=function(e){d(e,!1)},t["Shift-"+i+"["]="fold",t["Shift-"+i+"]"]="unfold",h[i+"0"]=h[i+"j"]="unfoldAll",t[i+"I"]="findIncremental",t["Shift-"+i+"I"]="findIncrementalReverse",t[i+"H"]="replace",t.F3="findNext",t["Shift-F3"]="findPrev"}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../lib/codemirror"),require("../addon/search/searchcursor"),require("../addon/dialog/dialog"),require("../addon/edit/matchbrackets.js")):typeof define=="function"&&define.amd?define("components/codemirror/keymap/vim",["../lib/codemirror","../addon/search/searchcursor","../addon/dialog/dialog","../addon/edit/matchbrackets"],e):e(CodeMirror)}(function(e){var t=[{keys:["<Left>"],type:"keyToKey",toKeys:["h"]},{keys:["<Right>"],type:"keyToKey",toKeys:["l"]},{keys:["<Up>"],type:"keyToKey",toKeys:["k"]},{keys:["<Down>"],type:"keyToKey",toKeys:["j"]},{keys:["<Space>"],type:"keyToKey",toKeys:["l"]},{keys:["<BS>"],type:"keyToKey",toKeys:["h"]},{keys:["<C-Space>"],type:"keyToKey",toKeys:["W"]},{keys:["<C-BS>"],type:"keyToKey",toKeys:["B"]},{keys:["<S-Space>"],type:"keyToKey",toKeys:["w"]},{keys:["<S-BS>"],type:"keyToKey",toKeys:["b"]},{keys:["<C-n>"],type:"keyToKey",toKeys:["j"]},{keys:["<C-p>"],type:"keyToKey",toKeys:["k"]},{keys:["<C-[>"],type:"keyToKey",toKeys:["<Esc>"]},{keys:["<C-c>"],type:"keyToKey",toKeys:["<Esc>"]},{keys:["s"],type:"keyToKey",toKeys:["c","l"],context:"normal"},{keys:["s"],type:"keyToKey",toKeys:["x","i"],context:"visual"},{keys:["S"],type:"keyToKey",toKeys:["c","c"],context:"normal"},{keys:["S"],type:"keyToKey",toKeys:["d","c","c"],context:"visual"},{keys:["<Home>"],type:"keyToKey",toKeys:["0"]},{keys:["<End>"],type:"keyToKey",toKeys:["$"]},{keys:["<PageUp>"],type:"keyToKey",toKeys:["<C-b>"]},{keys:["<PageDown>"],type:"keyToKey",toKeys:["<C-f>"]},{keys:["<CR>"],type:"keyToKey",toKeys:["j","^"],context:"normal"},{keys:["H"],type:"motion",motion:"moveToTopLine",motionArgs:{linewise:!0,toJumplist:!0}},{keys:["M"],type:"motion",motion:"moveToMiddleLine",motionArgs:{linewise:!0,toJumplist:!0}},{keys:["L"],type:"motion",motion:"moveToBottomLine",motionArgs:{linewise:!0,toJumplist:!0}},{keys:["h"],type:"motion",motion:"moveByCharacters",motionArgs:{forward:!1}},{keys:["l"],type:"motion",motion:"moveByCharacters",motionArgs:{forward:!0}},{keys:["j"],type:"motion",motion:"moveByLines",motionArgs:{forward:!0,linewise:!0}},{keys:["k"],type:"motion",motion:"moveByLines",motionArgs:{forward:!1,linewise:!0}},{keys:["g","j"],type:"motion",motion:"moveByDisplayLines",motionArgs:{forward:!0}},{keys:["g","k"],type:"motion",motion:"moveByDisplayLines",motionArgs:{forward:!1}},{keys:["w"],type:"motion",motion:"moveByWords",motionArgs:{forward:!0,wordEnd:!1}},{keys:["W"],type:"motion",motion:"moveByWords",motionArgs:{forward:!0,wordEnd:!1,bigWord:!0}},{keys:["e"],type:"motion",motion:"moveByWords",motionArgs:{forward:!0,wordEnd:!0,inclusive:!0}},{keys:["E"],type:"motion",motion:"moveByWords",motionArgs:{forward:!0,wordEnd:!0,bigWord:!0,inclusive:!0}},{keys:["b"],type:"motion",motion:"moveByWords",motionArgs:{forward:!1,wordEnd:!1}},{keys:["B"],type:"motion",motion:"moveByWords",motionArgs:{forward:!1,wordEnd:!1,bigWord:!0}},{keys:["g","e"],type:"motion",motion:"moveByWords",motionArgs:{forward:!1,wordEnd:!0,inclusive:!0}},{keys:["g","E"],type:"motion",motion:"moveByWords",motionArgs:{forward:!1,wordEnd:!0,bigWord:!0,inclusive:!0}},{keys:["{"],type:"motion",motion:"moveByParagraph",motionArgs:{forward:!1,toJumplist:!0}},{keys:["}"],type:"motion",motion:"moveByParagraph",motionArgs:{forward:!0,toJumplist:!0}},{keys:["<C-f>"],type:"motion",motion:"moveByPage",motionArgs:{forward:!0}},{keys:["<C-b>"],type:"motion",motion:"moveByPage",motionArgs:{forward:!1}},{keys:["<C-d>"],type:"motion",motion:"moveByScroll",motionArgs:{forward:!0,explicitRepeat:!0}},{keys:["<C-u>"],type:"motion",motion:"moveByScroll",motionArgs:{forward:!1,explicitRepeat:!0}},{keys:["g","g"],type:"motion",motion:"moveToLineOrEdgeOfDocument",motionArgs:{forward:!1,explicitRepeat:!0,linewise:!0,toJumplist:!0}},{keys:["G"],type:"motion",motion:"moveToLineOrEdgeOfDocument",motionArgs:{forward:!0,explicitRepeat:!0,linewise:!0,toJumplist:!0}},{keys:["0"],type:"motion",motion:"moveToStartOfLine"},{keys:["^"],type:"motion",motion:"moveToFirstNonWhiteSpaceCharacter"},{keys:["+"],type:"motion",motion:"moveByLines",motionArgs:{forward:!0,toFirstChar:!0}},{keys:["-"],type:"motion",motion:"moveByLines",motionArgs:{forward:!1,toFirstChar:!0}},{keys:["_"],type:"motion",motion:"moveByLines",motionArgs:{forward:!0,toFirstChar:!0,repeatOffset:-1}},{keys:["$"],type:"motion",motion:"moveToEol",motionArgs:{inclusive:!0}},{keys:["%"],type:"motion",motion:"moveToMatchedSymbol",motionArgs:{inclusive:!0,toJumplist:!0}},{keys:["f","character"],type:"motion",motion:"moveToCharacter",motionArgs:{forward:!0,inclusive:!0}},{keys:["F","character"],type:"motion",motion:"moveToCharacter",motionArgs:{forward:!1}},{keys:["t","character"],type:"motion",motion:"moveTillCharacter",motionArgs:{forward:!0,inclusive:!0}},{keys:["T","character"],type:"motion",motion:"moveTillCharacter",motionArgs:{forward:!1}},{keys:[";"],type:"motion",motion:"repeatLastCharacterSearch",motionArgs:{forward:!0}},{keys:[","],type:"motion",motion:"repeatLastCharacterSearch",motionArgs:{forward:!1}},{keys:["'","character"],type:"motion",motion:"goToMark",motionArgs:{toJumplist:!0,linewise:!0}},{keys:["`","character"],type:"motion",motion:"goToMark",motionArgs:{toJumplist:!0}},{keys:["]","`"],type:"motion",motion:"jumpToMark",motionArgs:{forward:!0}},{keys:["[","`"],type:"motion",motion:"jumpToMark",motionArgs:{forward:!1}},{keys:["]","'"],type:"motion",motion:"jumpToMark",motionArgs:{forward:!0,linewise:!0}},{keys:["[","'"],type:"motion",motion:"jumpToMark",motionArgs:{forward:!1,linewise:!0}},{keys:["]","p"],type:"action",action:"paste",isEdit:!0,actionArgs:{after:!0,isEdit:!0,matchIndent:!0}},{keys:["[","p"],type:"action",action:"paste",isEdit:!0,actionArgs:{after:!1,isEdit:!0,matchIndent:!0}},{keys:["]","character"],type:"motion",motion:"moveToSymbol",motionArgs:{forward:!0,toJumplist:!0}},{keys:["[","character"],type:"motion",motion:"moveToSymbol",motionArgs:{forward:!1,toJumplist:!0}},{keys:["|"],type:"motion",motion:"moveToColumn",motionArgs:{}},{keys:["o"],type:"motion",motion:"moveToOtherHighlightedEnd",motionArgs:{},context:"visual"},{keys:["d"],type:"operator",operator:"delete"},{keys:["y"],type:"operator",operator:"yank"},{keys:["c"],type:"operator",operator:"change"},{keys:[">"],type:"operator",operator:"indent",operatorArgs:{indentRight:!0}},{keys:["<"],type:"operator",operator:"indent",operatorArgs:{indentRight:!1}},{keys:["g","~"],type:"operator",operator:"swapcase"},{keys:["n"],type:"motion",motion:"findNext",motionArgs:{forward:!0,toJumplist:!0}},{keys:["N"],type:"motion",motion:"findNext",motionArgs:{forward:!1,toJumplist:!0}},{keys:["x"],type:"operatorMotion",operator:"delete",motion:"moveByCharacters",motionArgs:{forward:!0},operatorMotionArgs:{visualLine:!1}},{keys:["X"],type:"operatorMotion",operator:"delete",motion:"moveByCharacters",motionArgs:{forward:!1},operatorMotionArgs:{visualLine:!0}},{keys:["D"],type:"operatorMotion",operator:"delete",motion:"moveToEol",motionArgs:{inclusive:!0},operatorMotionArgs:{visualLine:!0}},{keys:["Y"],type:"operatorMotion",operator:"yank",motion:"moveToEol",motionArgs:{inclusive:!0},operatorMotionArgs:{visualLine:!0}},{keys:["C"],type:"operatorMotion",operator:"change",motion:"moveToEol",motionArgs:{inclusive:!0},operatorMotionArgs:{visualLine:!0}},{keys:["~"],type:"operatorMotion",operator:"swapcase",operatorArgs:{shouldMoveCursor:!0},motion:"moveByCharacters",motionArgs:{forward:!0}},{keys:["<C-i>"],type:"action",action:"jumpListWalk",actionArgs:{forward:!0}},{keys:["<C-o>"],type:"action",action:"jumpListWalk",actionArgs:{forward:!1}},{keys:["<C-e>"],type:"action",action:"scroll",actionArgs:{forward:!0,linewise:!0}},{keys:["<C-y>"],type:"action",action:"scroll",actionArgs:{forward:!1,linewise:!0}},{keys:["a"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{insertAt:"charAfter"}},{keys:["A"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{insertAt:"eol"}},{keys:["A"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{insertAt:"endOfSelectedArea"},context:"visual"},{keys:["i"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{insertAt:"inplace"}},{keys:["I"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{insertAt:"firstNonBlank"}},{keys:["o"],type:"action",action:"newLineAndEnterInsertMode",isEdit:!0,interlaceInsertRepeat:!0,actionArgs:{after:!0}},{keys:["O"],type:"action",action:"newLineAndEnterInsertMode",isEdit:!0,interlaceInsertRepeat:!0,actionArgs:{after:!1}},{keys:["v"],type:"action",action:"toggleVisualMode"},{keys:["V"],type:"action",action:"toggleVisualMode",actionArgs:{linewise:!0}},{keys:["g","v"],type:"action",action:"reselectLastSelection"},{keys:["J"],type:"action",action:"joinLines",isEdit:!0},{keys:["p"],type:"action",action:"paste",isEdit:!0,actionArgs:{after:!0,isEdit:!0}},{keys:["P"],type:"action",action:"paste",isEdit:!0,actionArgs:{after:!1,isEdit:!0}},{keys:["r","character"],type:"action",action:"replace",isEdit:!0},{keys:["@","character"],type:"action",action:"replayMacro"},{keys:["q","character"],type:"action",action:"enterMacroRecordMode"},{keys:["R"],type:"action",action:"enterInsertMode",isEdit:!0,actionArgs:{replace:!0}},{keys:["u"],type:"action",action:"undo"},{keys:["u"],type:"action",action:"changeCase",actionArgs:{toLower:!0},context:"visual",isEdit:!0},{keys:["U"],type:"action",action:"changeCase",actionArgs:{toLower:!1},context:"visual",isEdit:!0},{keys:["<C-r>"],type:"action",action:"redo"},{keys:["m","character"],type:"action",action:"setMark"},{keys:['"',"character"],type:"action",action:"setRegister"},{keys:["z","z"],type:"action",action:"scrollToCursor",actionArgs:{position:"center"}},{keys:["z","."],type:"action",action:"scrollToCursor",actionArgs:{position:"center"},motion:"moveToFirstNonWhiteSpaceCharacter"},{keys:["z","t"],type:"action",action:"scrollToCursor",actionArgs:{position:"top"}},{keys:["z","<CR>"],type:"action",action:"scrollToCursor",actionArgs:{position:"top"},motion:"moveToFirstNonWhiteSpaceCharacter"},{keys:["z","-"],type:"action",action:"scrollToCursor",actionArgs:{position:"bottom"}},{keys:["z","b"],type:"action",action:"scrollToCursor",actionArgs:{position:"bottom"},motion:"moveToFirstNonWhiteSpaceCharacter"},{keys:["."],type:"action",action:"repeatLastEdit"},{keys:["<C-a>"],type:"action",action:"incrementNumberToken",isEdit:!0,actionArgs:{increase:!0,backtrack:!1}},{keys:["<C-x>"],type:"action",action:"incrementNumberToken",isEdit:!0,actionArgs:{increase:!1,backtrack:!1}},{keys:["a","character"],type:"motion",motion:"textObjectManipulation"},{keys:["i","character"],type:"motion",motion:"textObjectManipulation",motionArgs:{textObjectInner:!0}},{keys:["/"],type:"search",searchArgs:{forward:!0,querySrc:"prompt",toJumplist:!0}},{keys:["?"],type:"search",searchArgs:{forward:!1,querySrc:"prompt",toJumplist:!0}},{keys:["*"],type:"search",searchArgs:{forward:!0,querySrc:"wordUnderCursor",wholeWordOnly:!0,toJumplist:!0}},{keys:["#"],type:"search",searchArgs:{forward:!1,querySrc:"wordUnderCursor",wholeWordOnly:!0,toJumplist:!0}},{keys:["g","*"],type:"search",searchArgs:{forward:!0,querySrc:"wordUnderCursor",toJumplist:!0}},{keys:["g","#"],type:"search",searchArgs:{forward:!1,querySrc:"wordUnderCursor",toJumplist:!0}},{keys:[":"],type:"ex"}],n=e.Pos,r=function(){function i(e,t){var r=e.state.vim;if(r.insertMode||r.exMode)return;var i=t.ranges[0].head,s=t.ranges[0].anchor;if(i.ch&&i.ch==e.doc.getLine(i.line).length){var o=n(i.line,i.ch-1);t.update([{anchor:Q(i,s)?o:s,head:o}])}}function s(e){var t=e.state.vim;return t.onPasteFn||(t.onPasteFn=function(){t.insertMode||(e.setCursor(V(e.getCursor(),0,1)),z.enterInsertMode(e,{},t))}),t.onPasteFn}function f(e,t){var n=[];for(var r=e;r<e+t;r++)n.push(String.fromCharCode(r));return n}function g(e,t){return t>=e.firstLine()&&t<=e.lastLine()}function y(e){return/^[a-z]$/.test(e)}function b(e){return"()[]{}".indexOf(e)!=-1}function w(e){return o.test(e)}function E(e){return/^[A-Z]$/.test(e)}function S(e){return/^\s*$/.test(e)}function x(e,t){for(var n=0;n<t.length;n++)if(t[n]==e)return!0;return!1}function N(e,t,n){if(t===undefined)throw Error("defaultValue is required");n||(n="string"),T[e]={type:n,defaultValue:t},C(e,t)}function C(e,t){var n=T[e];if(!n)throw Error("Unknown option: "+e);if(n.type=="boolean"){if(t&&t!==!0)throw Error("Invalid argument: "+e+"="+t);t!==!1&&(t=!0)}n.value=n.type=="boolean"?!!t:t}function k(e){var t=T[e];if(!t)throw Error("Unknown option: "+e);return t.value}function O(){this.latestRegister=undefined,this.isPlaying=!1,this.isRecording=!1,this.replaySearchQueries=[],this.onRecordingDone=undefined,this.lastInsertModeChanges=A()}function M(e){return e.state.vim||(e.state.vim={inputState:new H,lastEditInputState:undefined,lastEditActionCommand:undefined,lastHPos:-1,lastHSPos:-1,lastMotion:null,marks:{},insertMode:!1,insertModeRepeat:undefined,visualMode:!1,visualLine:!1,lastSelection:null,lastPastedText:null}),e.state.vim}function D(){_={searchQuery:null,searchIsReversed:!1,lastSubstituteReplacePart:undefined,jumpList:L(),macroModeState:new O,lastChararacterSearch:{increment:0,forward:!0,selectedCharacter:""},registerController:new F({}),searchHistoryController:new I({}),exCommandHistoryController:new I({})};for(var e in T){var t=T[e];t.value=t.defaultValue}}function H(){this.prefixRepeat=[],this.motionRepeat=[],this.operator=null,this.operatorArgs=null,this.motion=null,this.motionArgs=null,this.keyBuffer=[],this.registerName=null}function B(t,n){t.state.vim.inputState=new H,e.signal(t,"vim-command-done",n)}function j(e,t){this.clear(),this.keyBuffer=[e||""],this.insertModeChanges=[],this.searchQueries=[],this.linewise=!!t}function F(e){this.registers=e,this.unnamedRegister=e['"']=new j,e["."]=new j,e[":"]=new j,e["/"]=new j}function I(){this.historyBuffer=[],this.iterator,this.initialPrefix=null}function W(e,t,r){var i=Math.min(Math.max(e.firstLine(),t.line),e.lastLine()),s=Z(e,i)-1;s=r?s+1:s;var o=Math.min(Math.max(0,t.ch),s);return n(i,o)}function X(e){var t={};for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);return t}function V(e,t,r){return n(e.line+t,e.ch+r)}function $(e,t){for(var n=0;n<e.length;n++)if(e[n]!=t[n]&&t[n]!="character")return!1;return!0}function J(e,t,n){return function(){for(var r=0;r<n;r++)t(e)}}function K(e){return n(e.line,e.ch)}function Q(e,t){return e.ch==t.ch&&e.line==t.line}function G(e,t){return e.line<t.line?!0:e.line==t.line&&e.ch<t.ch?!0:!1}function Y(e,t,n){var r=G(e,t),i=G(t,n);return r&&i}function Z(e,t){return e.getLine(t).length}function et(e){return e.split("").reverse().join("")}function tt(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function nt(e){return e.replace(/([.?*+$\[\]\/\\(){}|\-])/g,"\\$1")}function rt(e,t){var r=e.getCursor("anchor"),i=e.getCursor("head"),s=t.lastSelection;if(!t.visualMode){var o=t.lastSelection.curStartMark.find(),u=t.lastSelection.curEndMark.find(),a=u.line-o.line,f=a?u.ch:u.ch-o.ch;i={line:i.line+a,ch:a?i.ch:f+i.ch};if(s.visualLine)return[{line:r.line,ch:0},{line:i.line,ch:Z(e,i.line)}]}else{if(G(i,r)){var l=r;r=i,i=l}else i=e.clipPos(n(i.line,i.ch+1));st(e)}return[r,i]}function it(e,t){var n=t.marks["<"].find()||e.getCursor("anchor"),r=t.marks[">"].find()||e.getCursor("head");t.lastPastedText&&(r=e.posFromIndex(e.indexFromPos(n)+t.lastPastedText.length-1),t.lastPastedText=null),t.lastSelection={curStartMark:e.setBookmark(n),curEndMark:e.setBookmark(r),visualMode:t.visualMode,visualLine:t.visualLine},G(r,n)&&(t.lastSelection.curStartMark=e.setBookmark(r),t.lastSelection.curEndMark=e.setBookmark(n))}function st(t){t.off("mousedown",st);var n=t.state.vim,r=t.getCursor("anchor"),i=t.getCursor("head");it(t,n),n.visualMode=!1,n.visualLine=!1,Q(r,i)||t.setCursor(W(t,i)),e.signal(t,"vim-mode-change",{mode:"normal"})}function ot(e,t,n){var r=e.getRange(t,n);if(/\n\s*$/.test(r)){var i=r.split("\n");i.pop();var s;for(var s=i.pop();i.length>0&&s&&S(s);s=i.pop())n.line--,n.ch=0;s?(n.line--,n.ch=Z(e,n.line)):n.ch=0}}function ut(e,t,n){t.ch=0,n.ch=0,n.line++}function at(e){if(!e)return 0;var t=e.search(/\S/);return t==-1?e.length:t}function ft(e,t,r,i,s){var o=e.getCursor(),u=e.getLine(o.line),a=o.ch,f=u.substring(a),l;s?l=f.search(/\w/):l=f.search(/\S/);if(l==-1)return null;a+=l,f=u.substring(a);var c=u.substring(0,a),h;i?h=/^\S+/:/\w/.test(u.charAt(a))?h=/^\w+/:h=/^[^\w\s]+/;var p=h.exec(f),d=a,v=a+p[0].length,m=et(c),g=h.exec(m);g&&(d-=g[0].length);if(t){var y=u.substring(v),b=y.match(/^\s*/)[0].length;if(b>0)v+=b;else{var w=m.length-d,E=m.substring(w),S=E.match(/^\s*/)[0].length;d-=S}}return{start:n(o.line,d),end:n(o.line,v)}}function lt(e,t,n){Q(t,n)||_.jumpList.add(e,t,n)}function ct(e,t){_.lastChararacterSearch.increment=e,_.lastChararacterSearch.forward=t.forward,_.lastChararacterSearch.selectedCharacter=t.selectedCharacter}function dt(e,t,r,i){var s=K(e.getCursor()),o=r?1:-1,u=r?e.lineCount():-1,a=s.ch,f=s.line,l=e.getLine(f),c={lineText:l,nextCh:l.charAt(a),lastCh:null,index:a,symb:i,reverseSymb:(r?{")":"(","}":"{"}:{"(":")","{":"}"})[i],forward:r,depth:0,curMoveThrough:!1},h=ht[i];if(!h)return s;var p=pt[h].init,d=pt[h].isComplete;p&&p(c);while(f!==u&&t){c.index+=o,c.nextCh=c.lineText.charAt(c.index);if(!c.nextCh){f+=o,c.lineText=e.getLine(f)||"";if(o>0)c.index=0;else{var v=c.lineText.length;c.index=v>0?v-1:0}c.nextCh=c.lineText.charAt(c.index)}d(c)&&(s.line=f,s.ch=c.index,t--)}return c.nextCh||c.curMoveThrough?n(f,c.index):s}function vt(e,t,n,r,i){var s=t.line,o=t.ch,f=e.getLine(s),l=n?1:-1,c=r?a:u;if(i&&f==""){s+=l,f=e.getLine(s);if(!g(e,s))return null;o=n?0:f.length}for(;;){if(i&&f=="")return{from:0,to:0,line:s};var h=l>0?f.length:-1,p=h,d=h;while(o!=h){var v=!1;for(var m=0;m<c.length&&!v;++m)if(c[m].test(f.charAt(o))){p=o;while(o!=h&&c[m].test(f.charAt(o)))o+=l;d=o,v=p!=d;if(p==t.ch&&s==t.line&&d==p+l)continue;return{from:Math.min(p,d+1),to:Math.max(p,d),line:s}}v||(o+=l)}s+=l;if(!g(e,s))return null;f=e.getLine(s),o=l>0?0:f.length}throw new Error("The impossible happened.")}function mt(e,t,r,i,s){var o=e.getCursor(),u=K(o),a=[];(r&&!i||!r&&i)&&t++;var f=!r||!i;for(var l=0;l<t;l++){var c=vt(e,o,r,s,f);if(!c){var h=Z(e,e.lastLine());a.push(r?{line:e.lastLine(),from:h,to:h}:{line:0,from:0,to:0});break}a.push(c),o=n(c.line,r?c.to-1:c.from)}var p=a.length!=t,d=a[0],v=a.pop();return r&&!i?(!p&&(d.from!=u.ch||d.line!=u.line)&&(v=a.pop()),n(v.line,v.from)):r&&i?n(v.line,v.to-1):!r&&i?(!p&&(d.to!=u.ch||d.line!=u.line)&&(v=a.pop()),n(v.line,v.to)):n(v.line,v.from)}function gt(e,t,r,i){var s=e.getCursor(),o=s.ch,u;for(var a=0;a<t;a++){var f=e.getLine(s.line);u=wt(o,f,i,r,!0);if(u==-1)return null;o=u}return n(e.getCursor().line,u)}function yt(e,t){var r=e.getCursor().line;return W(e,n(r,t-1))}function bt(e,t,n,r){if(!x(n,v))return;t.marks[n]&&t.marks[n].clear(),t.marks[n]=e.setBookmark(r)}function wt(e,t,n,r,i){var s;return r?(s=t.indexOf(n,e+1),s!=-1&&!i&&(s-=1)):(s=t.lastIndexOf(n,e-1),s!=-1&&!i&&(s+=1)),s}function Et(e,t,r){var i=e.getCursor(),s,o,u={"(":/[()]/,")":/[()]/,"[":/[[\]]/,"]":/[[\]]/,"{":/[{}]/,"}":/[{}]/}[t],a={"(":"(",")":"(","[":"[","]":"[","{":"{","}":"{"}[t],f=e.getLine(i.line).charAt(i.ch),l=f===a?1:0;s=e.scanForBracket(n(i.line,i.ch+l),-1,null,{bracketRegex:u}),o=e.scanForBracket(n(i.line,i.ch+l),1,null,{bracketRegex:u});if(!s||!o)return{start:i,end:i};s=s.pos,o=o.pos;if(s.line==o.line&&s.ch>o.ch||s.line>o.line){var c=s;s=o,o=c}return r?o.ch+=1:s.ch+=1,{start:s,end:o}}function St(e,t,r){var i=K(e.getCursor()),s=e.getLine(i.line),o=s.split(""),u,a,f,l,c=o.indexOf(t);i.ch<c?i.ch=c:c<i.ch&&o[i.ch]==t&&(a=i.ch,--i.ch);if(o[i.ch]==t&&!a)u=i.ch+1;else for(f=i.ch;f>-1&&!u;f--)o[f]==t&&(u=f+1);if(u&&!a)for(f=u,l=o.length;f<l&&!a;f++)o[f]==t&&(a=f);return!u||!a?{start:i,end:i}:(r&&(--u,++a),{start:n(i.line,u),end:n(i.line,a)})}function xt(){}function Tt(e){var t=e.state.vim;return t.searchState_||(t.searchState_=new xt)}function Nt(e,t,n,r,i){e.openDialog?e.openDialog(t,r,{bottom:!0,value:i.value,onKeyDown:i.onKeyDown,onKeyUp:i.onKeyUp}):r(prompt(n,""))}function Ct(e){var t=kt(e)||[];if(!t.length)return[];var n=[];if(t[0]!==0)return;for(var r=0;r<t.length;r++)typeof t[r]=="number"&&n.push(e.substring(t[r]+1,t[r+1]));return n}function kt(e){var t=!1,n=[];for(var r=0;r<e.length;r++){var i=e.charAt(r);!t&&i=="/"&&n.push(r),t=!t&&i=="\\"}return n}function Lt(e){var t="|(){",n="}",r=!1,i=[];for(var s=-1;s<e.length;s++){var o=e.charAt(s)||"",u=e.charAt(s+1)||"",a=u&&t.indexOf(u)!=-1;r?((o!=="\\"||!a)&&i.push(o),r=!1):o==="\\"?(r=!0,u&&n.indexOf(u)!=-1&&(a=!0),(!a||u==="\\")&&i.push(o)):(i.push(o),a&&u!=="\\"&&i.push("\\"))}return i.join("")}function At(e){var t=!1,n=[];for(var r=-1;r<e.length;r++){var i=e.charAt(r)||"",s=e.charAt(r+1)||"";t?(n.push(i),t=!1):i==="\\"?(t=!0,w(s)||s==="$"?n.push("$"):s!=="/"&&s!=="\\"&&n.push("\\")):(i==="$"&&n.push("$"),n.push(i),s==="/"&&n.push("\\"))}return n.join("")}function Ot(t){var n=new e.StringStream(t),r=[];while(!n.eol()){while(n.peek()&&n.peek()!="\\")r.push(n.next());n.match("\\/",!0)?r.push("/"):n.match("\\\\",!0)?r.push("\\"):r.push(n.next())}return r.join("")}function Mt(e,t,n){var r=_.registerController.getRegister("/");r.setText(e);if(e instanceof RegExp)return e;var i=kt(e),s,o;if(!i.length)s=e;else{s=e.substring(0,i[0]);var u=e.substring(i[0]);o=u.indexOf("i")!=-1}if(!s)return null;k("pcre")||(s=Lt(s)),n&&(t=/^[^A-Z]*$/.test(s));var a=new RegExp(s,t||o?"i":undefined);return a}function _t(e,t){e.openNotification?e.openNotification('<span style="color: red">'+t+"</span>",{bottom:!0,duration:5e3}):alert(t)}function Dt(e,t){var n="";return e&&(n+='<span style="font-family: monospace">'+e+"</span>"),n+='<input type="text"/> <span style="color: #888">',t&&(n+='<span style="color: #888">',n+=t,n+="</span>"),n}function Ht(e,t){var n=(t.prefix||"")+" "+(t.desc||""),r=Dt(t.prefix,t.desc);Nt(e,r,n,t.onClose,t)}function Bt(e,t){if(e instanceof RegExp&&t instanceof RegExp){var n=["global","multiline","ignoreCase","source"];for(var r=0;r<n.length;r++){var i=n[r];if(e[i]!==t[i])return!1}return!0}return!1}function jt(e,t,n,r){if(!t)return;var i=Tt(e),s=Mt(t,!!n,!!r);if(!s)return;return It(e,s),Bt(s,i.getQuery())?s:(i.setQuery(s),s)}function Ft(e){if(e.source.charAt(0)=="^")var t=!0;return{token:function(n){if(t&&!n.sol()){n.skipToEnd();return}var r=n.match(e,!1);if(r){if(r[0].length==0)return n.next(),"searching";if(!n.sol()){n.backUp(1);if(!e.exec(n.next()+r[0]))return n.next(),null}return n.match(e),"searching"}while(!n.eol()){n.next();if(n.match(e,!1))break}},query:e}}function It(e,t){var n=Tt(e).getOverlay();if(!n||t!=n.query)n&&e.removeOverlay(n),n=Ft(t),e.addOverlay(n),Tt(e).setOverlay(n)}function qt(e,t,r,i){return i===undefined&&(i=1),e.operation(function(){var s=e.getCursor(),o=e.getSearchCursor(r,s);for(var u=0;u<i;u++){var a=o.find(t);u==0&&a&&Q(o.from(),s)&&(a=o.find(t));if(!a){o=e.getSearchCursor(r,t?n(e.lastLine()):n(e.firstLine(),0));if(!o.find(t))return}}return o.from()})}function Rt(e){e.removeOverlay(Tt(e).getOverlay()),Tt(e).setOverlay(null)}function Ut(e,t,n){return typeof e!="number"&&(e=e.line),t instanceof Array?x(e,t):n?e>=t&&e<=n:e==t}function zt(e){var t=e.getScrollInfo(),n=6,r=10,i=e.coordsChar({left:0,top:n+t.top},"local"),s=t.clientHeight-r+t.top,o=e.coordsChar({left:0,top:s},"local");return{top:i.line,bottom:o.line}}function Xt(e){var t,n,r=[];while(e){n=/<\w+-.+?>|<\w+>|./.exec(e);if(n===null)break;t=n[0],e=e.substring(n.index+t.length),r.push(t)}return r}function Jt(t,n,r,i,s,o,u){function l(){t.operation(function(){while(!a)c(),h();p()})}function c(){var e=t.getRange(s.from(),s.to()),n=e.replace(o,u);s.replace(n)}function h(){var e=s.findNext();e?Ut(s.from(),r,i)?(t.scrollIntoView(s.from(),30),t.setSelection(s.from(),s.to()),f=s.from(),a=!1):a=!0:a=!0}function p(e){e&&e(),t.focus();if(f){t.setCursor(f);var n=t.state.vim;n.exMode=!1,n.lastHPos=n.lastHSPos=f.ch}}function d(n,r,i){e.e_stop(n);var s=e.keyName(n);switch(s){case"Y":c(),h();break;case"N":h();break;case"A":t.operation(l);break;case"L":c();case"Q":case"Esc":case"Ctrl-C":case"Ctrl-[":p(i)}a&&p(i)}t.state.vim.exMode=!0;var a=!1,f=s.from();h();if(a){_t(t,"No matches for "+o.source);return}if(!n){l();return}Ht(t,{prefix:"replace with <strong>"+u+"</strong> (y/n/a/q/l)",onKeyDown:d})}function Kt(){function t(e,t){var n=e;E(n)&&t=="Ctrl"&&(n=n.toLowerCase()),t&&(n=t.charAt(0)+"-"+n);var r={Enter:"CR",Backspace:"BS",Delete:"Del"}[n];return n=r?r:n,n=n.length>1?"<"+n+">":n,n}function n(t){return function(n){e.signal(n,"vim-keypress",t),e.Vim.handleKey(n,t)}}function i(e,i){for(var s=0;s<e.length;s++){var o=e[s];!i&&o.length==1&&(o="'"+o+"'");var u=t(e[s],i),a=i?i+"-"+o:o;r[a]=n(u)}}var r={nofallthrough:!0,style:"fat-cursor"};return i(l),i(c),i(l,"Ctrl"),i(p),i(p,"Ctrl"),i(h),i(h,"Ctrl"),i(d),i(d,"Ctrl"),r}function Qt(t){var n=t.state.vim,r=_.macroModeState,i=_.registerController.getRegister("."),s=r.isPlaying;s||(t.off("change",tn),e.off(t.getInputField(),"keydown",sn)),!s&&n.insertModeRepeat>1&&(on(t,n,n.insertModeRepeat-1,!0),n.lastEditInputState.repeatOverride=n.insertModeRepeat),delete n.insertModeRepeat,n.insertMode=!1,t.setCursor(t.getCursor().line,t.getCursor().ch-1),t.setOption("keyMap","vim"),t.setOption("disableInput",!0),t.toggleOverwrite(!1),i.setText(r.lastInsertModeChanges.changes.join("")),e.signal(t,"vim-mode-change",{mode:"normal"}),r.isRecording&&Zt(r)}function Gt(t,n,r,i){var s=_.registerController.getRegister(i),o=s.keyBuffer,u=0;r.isPlaying=!0,r.replaySearchQueries=s.searchQueries.slice(0);for(var a=0;a<o.length;a++){var f=o[a],l,c;while(f){l=/<\w+-.+?>|<\w+>|./.exec(f),c=l[0],f=f.substring(l.index+c.length),e.Vim.handleKey(t,c);if(n.insertMode){var h=s.insertModeChanges[u++].changes;_.macroModeState.lastInsertModeChanges.changes=h,un(t,h,1),Qt(t)}}}r.isPlaying=!1}function Yt(e,t){if(e.isPlaying)return;var n=e.latestRegister,r=_.registerController.getRegister(n);r&&r.pushText(t)}function Zt(e){if(e.isPlaying)return;var t=e.latestRegister,n=_.registerController.getRegister(t);n&&n.pushInsertModeChanges(e.lastInsertModeChanges)}function en(e,t){if(e.isPlaying)return;var n=e.latestRegister,r=_.registerController.getRegister(n);r&&r.pushSearchQuery(t)}function tn(e,t){var n=_.macroModeState,r=n.lastInsertModeChanges;if(!n.isPlaying)while(t){r.expectCursorActivityForChange=!0;if(t.origin=="+input"||t.origin=="paste"||t.origin===undefined){var i=t.text.join("\n");r.changes.push(i)}t=t.next}}function nn(e){var t=e.state.vim;if(t.insertMode){var n=_.macroModeState;if(n.isPlaying)return;var r=n.lastInsertModeChanges;r.expectCursorActivityForChange?r.expectCursorActivityForChange=!1:r.changes=[]}else e.doc.history.lastSelOrigin=="*mouse"&&(t.lastHPos=e.doc.getCursor().ch)}function rn(e){this.keyName=e}function sn(t){function s(){return r.changes.push(new rn(i)),!0}var n=_.macroModeState,r=n.lastInsertModeChanges,i=e.keyName(t);(i.indexOf("Delete")!=-1||i.indexOf("Backspace")!=-1)&&e.lookupKey(i,["vim-insert"],s)}function on(e,t,n,r){function u(){s?q.processAction(e,t,t.lastEditActionCommand):q.evalInput(e,t)}function a(n){if(i.lastInsertModeChanges.changes.length>0){n=t.lastEditActionCommand?n:1;var r=i.lastInsertModeChanges;i.lastInsertModeChanges={},un(e,r.changes,n),i.lastInsertModeChanges=r}}var i=_.macroModeState;i.isPlaying=!0;var s=!!t.lastEditActionCommand,o=t.inputState;t.inputState=t.lastEditInputState;if(s&&t.lastEditActionCommand.interlaceInsertRepeat)for(var f=0;f<n;f++)u(),a(1);else r||u(),a(n);t.inputState=o,t.insertMode&&!r&&Qt(e),i.isPlaying=!1}function un(t,n,r){function i(n){return typeof n=="string"?e.commands[n](t):n(t),!0}for(var s=0;s<r;s++)for(var o=0;o<n.length;o++){var u=n[o];if(u instanceof rn)e.lookupKey(u.keyName,["vim-insert"],i);else{var a=t.getCursor();t.replaceRange(u,a,a)}}}e.defineOption("vimMode",!1,function(t,n){n?(t.setOption("keyMap","vim"),t.setOption("disableInput",!0),e.signal(t,"vim-mode-change",{mode:"normal"}),t.on("beforeSelectionChange",i),t.on("cursorActivity",nn),M(t),e.on(t.getInputField(),"paste",s(t))):t.state.vim&&(t.setOption("keyMap","default"),t.setOption("disableInput",!1),t.off("beforeSelectionChange",i),t.off("cursorActivity",nn),e.off(t.getInputField(),"paste",s(t)),t.state.vim=null)});var o=/[\d]/,u=[/\w/,/[^\w\s]/],a=[/\S/],l=f(65,26),c=f(97,26),h=f(48,10),p="~`!@#$%^&*()_-+=[{}]\\|/?.,<>:;\"'".split(""),d=["Left","Right","Up","Down","Space","Backspace","Esc","Home","End","PageUp","PageDown","Enter"],v=[].concat(l,c,h,["<",">"]),m=[].concat(l,c,h,["-",'"',".",":","/"]),T={},L=function(){function s(s,o,u){function l(n){var r=++t%e,o=i[r];o&&o.clear(),i[r]=s.setBookmark(n)}var a=t%e,f=i[a];if(f){var c=f.find();c&&!Q(c,o)&&l(o)}else l(o);l(u),n=t,r=t-e+1,r<0&&(r=0)}function o(s,o){t+=o,t>n?t=n:t<r&&(t=r);var u=i[(e+t)%e];if(u&&!u.find()){var a=o>0?1:-1,f,l=s.getCursor();do{t+=a,u=i[(e+t)%e];if(u&&(f=u.find())&&!Q(l,f))break}while(t<n&&t>r)}return u}var e=100,t=-1,n=0,r=0,i=new Array(e);return{cachedCursor:undefined,add:s,move:o}},A=function(e){return e?{changes:e.changes,expectCursorActivityForChange:e.expectCursorActivityForChange}:{changes:[],expectCursorActivityForChange:!1}};O.prototype={exitMacroRecordMode:function(){var e=_.macroModeState;e.onRecordingDone(),e.onRecordingDone=undefined,e.isRecording=!1},enterMacroRecordMode:function(e,t){var n=_.registerController.getRegister(t);n&&(n.clear(),this.latestRegister=t,this.onRecordingDone=e.openDialog("(recording)["+t+"]",null,{bottom:!0}),this.isRecording=!0)}};var _,P={buildKeyMap:function(){},getRegisterController:function(){return _.registerController},resetVimGlobalState_:D,getVimGlobalState_:function(){return _},maybeInitVimState_:M,InsertModeKey:rn,map:function(e,t,n){$t.map(e,t,n)},setOption:C,getOption:k,defineOption:N,defineEx:function(e,t,n){if(e.indexOf(t)!==0)throw new Error('(Vim.defineEx) "'+t+'" is not a prefix of "'+e+'", command not registered');Vt[e]=n,$t.commandMap_[t]={name:e,shortName:t,type:"api"}},handleKey:function(n,r){var i,s=M(n),o=_.macroModeState;if(o.isRecording&&r=="q"){o.exitMacroRecordMode(),B(n);return}if(r=="<Esc>"){B(n),s.visualMode&&st(n);return}!s.visualMode&&!Q(n.getCursor("head"),n.getCursor("anchor"))&&(s.visualMode=!0,s.visualLine=!1,e.signal(n,"vim-mode-change",{mode:"visual"}),n.on("mousedown",st));if(r!="0"||r=="0"&&s.inputState.getRepeat()===0)i=q.matchCommand(r,t,s);if(!i){w(r)&&s.inputState.pushRepeatDigit(r),o.isRecording&&Yt(o,r);return}if(i.type=="keyToKey")for(var u=0;u<i.toKeys.length;u++)this.handleKey(n,i.toKeys[u]);else o.isRecording&&Yt(o,r),q.processCommand(n,s,i)},handleEx:function(e,t){$t.processCommand(e,t)}};H.prototype.pushRepeatDigit=function(e){this.operator?this.motionRepeat=this.motionRepeat.concat(e):this.prefixRepeat=this.prefixRepeat.concat(e)},H.prototype.getRepeat=function(){var e=0;if(this.prefixRepeat.length>0||this.motionRepeat.length>0)e=1,this.prefixRepeat.length>0&&(e*=parseInt(this.prefixRepeat.join(""),10)),this.motionRepeat.length>0&&(e*=parseInt(this.motionRepeat.join(""),10));return e},j.prototype={setText:function(e,t){this.keyBuffer=[e||""],this.linewise=!!t},pushText:function(e,t){t&&(this.linewise||this.keyBuffer.push("\n"),this.linewise=!0),this.keyBuffer.push(e)},pushInsertModeChanges:function(e){this.insertModeChanges.push(A(e))},pushSearchQuery:function(e){this.searchQueries.push(e)},clear:function(){this.keyBuffer=[],this.insertModeChanges=[],this.searchQueries=[],this.linewise=!1},toString:function(){return this.keyBuffer.join("")}},F.prototype={pushText:function(e,t,n,r){r&&n.charAt(0)=="\n"&&(n=n.slice(1)+"\n"),r&&n.charAt(n.length-1)!=="\n"&&(n+="\n");var i=this.isValidRegister(e)?this.getRegister(e):null;if(!i){switch(t){case"yank":this.registers[0]=new j(n,r);break;case"delete":case"change":n.indexOf("\n")==-1?this.registers["-"]=new j(n,r):(this.shiftNumericRegisters_(),this.registers[1]=new j(n,r))}this.unnamedRegister.setText(n,r);return}var s=E(e);s?i.pushText(n,r):i.setText(n,r),this.unnamedRegister.setText(i.toString(),r)},getRegister:function(e){return this.isValidRegister(e)?(e=e.toLowerCase(),this.registers[e]||(this.registers[e]=new j),this.registers[e]):this.unnamedRegister},isValidRegister:function(e){return e&&x(e,m)},shiftNumericRegisters_:function(){for(var e=9;e>=2;e--)this.registers[e]=this.getRegister(""+(e-1))}},I.prototype={nextMatch:function(e,t){var n=this.historyBuffer,r=t?-1:1;this.initialPrefix===null&&(this.initialPrefix=e);for(var i=this.iterator+r;t?i>=0:i<n.length;i+=r){var s=n[i];for(var o=0;o<=s.length;o++)if(this.initialPrefix==s.substring(0,o))return this.iterator=i,s}if(i>=n.length)return this.iterator=n.length,this.initialPrefix;if(i<0)return e},pushInput:function(e){var t=this.historyBuffer.indexOf(e);t>-1&&this.historyBuffer.splice(t,1),e.length&&this.historyBuffer.push(e)},reset:function(){this.initialPrefix=null,this.iterator=this.historyBuffer.length}};var q={matchCommand:function(e,t,n){function f(t){return i.length<t.keys.length?(r.keyBuffer.push(e),null):(t.keys[i.length-1]=="character"&&(r.selectedCharacter=o),r.keyBuffer=[],t)}var r=n.inputState,i=r.keyBuffer.concat(e),s=[],o;for(var u=0;u<t.length;u++){var a=t[u];if($(i,a.keys)){if(r.operator&&a.type=="action")continue;if(a.keys[i.length-1]=="character"){o=i[i.length-1];if(o.length>1)switch(o){case"<CR>":o="\n";break;case"<Space>":o=" ";break;default:continue}}s.push(a)}}if(!s.length)return r.keyBuffer=[],null;if(s.length==1)return f(s[0]);var l=n.visualMode?"visual":"normal",c;for(var u=0;u<s.length;u++){var h=s[u];if(h.context==l){c=h;break}!c&&!h.context&&(c=h)}return f(c)},processCommand:function(e,t,n){t.inputState.repeatOverride=n.repeatOverride;switch(n.type){case"motion":this.processMotion(e,t,n);break;case"operator":this.processOperator(e,t,n);break;case"operatorMotion":this.processOperatorMotion(e,t,n);break;case"action":this.processAction(e,t,n);break;case"search":this.processSearch(e,t,n);break;case"ex":case"keyToEx":this.processEx(e,t,n);break;default:}},processMotion:function(e,t,n){t.inputState.motion=n.motion,t.inputState.motionArgs=X(n.motionArgs),this.evalInput(e,t)},processOperator:function(e,t,n){var r=t.inputState;if(r.operator){if(r.operator==n.operator){r.motion="expandToLine",r.motionArgs={linewise:!0},this.evalInput(e,t);return}B(e)}r.operator=n.operator,r.operatorArgs=X(n.operatorArgs),t.visualMode&&this.evalInput(e,t)},processOperatorMotion:function(e,t,n){var r=t.visualMode,i=X(n.operatorMotionArgs);i&&r&&i.visualLine&&(t.visualLine=!0),this.processOperator(e,t,n),r||this.processMotion(e,t,n)},processAction:function(e,t,n){var r=t.inputState,i=r.getRepeat(),s=!!i,o=X(n.actionArgs)||{};r.selectedCharacter&&(o.selectedCharacter=r.selectedCharacter),n.operator&&this.processOperator(e,t,n),n.motion&&this.processMotion(e,t,n),(n.motion||n.operator)&&this.evalInput(e,t),o.repeat=i||1,o.repeatIsExplicit=s,o.registerName=r.registerName,B(e),t.lastMotion=null,n.isEdit&&this.recordLastEdit(t,r,n),z[n.action](e,o,t)},processSearch:function(t,n,r){function f(e,i,s){_.searchHistoryController.pushInput(e),_.searchHistoryController.reset();try{jt(t,e,i,s)}catch(o){_t(t,"Invalid regex: "+e);return}q.processMotion(t,n,{type:"motion",motion:"findNext",motionArgs:{forward:!0,toJumplist:r.searchArgs.toJumplist}})}function l(e){t.scrollTo(a.left,a.top),f(e,!0,!0);var n=_.macroModeState;n.isRecording&&en(n,e)}function c(n,r,s){var o=e.keyName(n),u;o=="Up"||o=="Down"?(u=o=="Up"?!0:!1,r=_.searchHistoryController.nextMatch(r,u)||"",s(r)):o!="Left"&&o!="Right"&&o!="Ctrl"&&o!="Alt"&&o!="Shift"&&_.searchHistoryController.reset();var f;try{f=jt(t,r,!0,!0)}catch(n){}f?t.scrollIntoView(qt(t,!i,f),30):(Rt(t),t.scrollTo(a.left,a.top))}function h(n,r,i){var s=e.keyName(n);if(s=="Esc"||s=="Ctrl-C"||s=="Ctrl-[")_.searchHistoryController.pushInput(r),_.searchHistoryController.reset(),jt(t,u),Rt(t),t.scrollTo(a.left,a.top),e.e_stop(n),i(),t.focus()}if(!t.getSearchCursor)return;var i=r.searchArgs.forward,s=r.searchArgs.wholeWordOnly;Tt(t).setReversed(!i);var o=i?"/":"?",u=Tt(t).getQuery(),a=t.getScrollInfo();switch(r.searchArgs.querySrc){case"prompt":var p=_.macroModeState;if(p.isPlaying){var d=p.replaySearchQueries.shift();f(d,!0,!1)}else Ht(t,{onClose:l,prefix:o,desc:Pt,onKeyUp:c,onKeyDown:h});break;case"wordUnderCursor":var v=ft(t,!1,!0,!1,!0),m=!0;v||(v=ft(t,!1,!0,!1,!1),m=!1);if(!v)return;var d=t.getLine(v.start.line).substring(v.start.ch,v.end.ch);m&&s?d="\\b"+d+"\\b":d=nt(d),_.jumpList.cachedCursor=t.getCursor(),t.setCursor(v.start),f(d,!0,!1)}},processEx:function(t,n,r){function i(e){_.exCommandHistoryController.pushInput(e),_.exCommandHistoryController.reset(),$t.processCommand(t,e)}function s(n,r,i){var s=e.keyName(n),o;if(s=="Esc"||s=="Ctrl-C"||s=="Ctrl-[")_.exCommandHistoryController.pushInput(r),_.exCommandHistoryController.reset(),e.e_stop(n),i(),t.focus();s=="Up"||s=="Down"?(o=s=="Up"?!0:!1,r=_.exCommandHistoryController.nextMatch(r,o)||"",i(r)):s!="Left"&&s!="Right"&&s!="Ctrl"&&s!="Alt"&&s!="Shift"&&_.exCommandHistoryController.reset()}r.type=="keyToEx"?$t.processCommand(t,r.exArgs.input):n.visualMode?Ht(t,{onClose:i,prefix:":",value:"'<,'>",onKeyDown:s}):Ht(t,{onClose:i,prefix:":",onKeyDown:s})},evalInput:function(e,t){var r=t.inputState,i=r.motion,s=r.motionArgs||{},o=r.operator,u=r.operatorArgs||{},a=r.registerName,f=K(e.getCursor("head")),l=K(e.getCursor("anchor")),c=K(f),h=K(c),p,d;o&&this.recordLastEdit(t,r),r.repeatOverride!==undefined?d=r.repeatOverride:d=r.getRepeat();if(d>0&&s.explicitRepeat)s.repeatIsExplicit=!0;else if(s.noRepeat||!s.explicitRepeat&&d===0)d=1,s.repeatIsExplicit=!1;r.selectedCharacter&&(s.selectedCharacter=u.selectedCharacter=r.selectedCharacter),s.repeat=d,B(e);if(i){var v=R[i](e,s,t);t.lastMotion=R[i];if(!v)return;if(s.toJumplist){var m=_.jumpList,g=m.cachedCursor;g?(lt(e,g,v),delete m.cachedCursor):lt(e,h,v)}v instanceof Array?(c=v[0],p=v[1]):p=v,p||(p=n(c.line,c.ch));if(t.visualMode){G(l,f)&&(Q(l,p)||G(p,l))?l.ch+=1:G(f,l)&&(Q(l,p)||G(l,p))&&(l.ch-=1),f=p,l=v instanceof Array?c:l;if(t.visualLine)if(G(l,f)){l.ch=0;var y=e.lastLine();f.line>y&&(f.line=y),f.ch=Z(e,f.line)}else f.ch=0,l.ch=Z(e,l.line);e.setSelection(l,f),bt(e,t,"<",G(l,f)?l:f),bt(e,t,">",G(l,f)?f:l)}else o||(p=W(e,p),e.setCursor(p.line,p.ch))}if(o){var b=!1;t.lastMotion=null,u.repeat=d,t.visualMode&&(c=l,p=f,s.inclusive=!0);if(p&&G(p,c)){var w=c;c=p,p=w,b=!0}else p||(p=K(c));s.inclusive&&(!t.visualMode||!b)&&p.ch++;if(u.selOffset)p.line=c.line+u.selOffset.line,u.selOffset.line?p.ch=u.selOffset.ch:p.ch=c.ch+u.selOffset.ch;else if(t.visualMode){var E=n();E.line=p.line-c.line,E.line?E.ch=p.ch:E.ch=p.ch-c.ch,u.selOffset=E}var S=s.linewise||t.visualMode&&t.visualLine||u.linewise;S?ut(e,c,p):s.forward&&ot(e,c,p),u.registerName=a,u.linewise=S,U[o](e,u,t,c,p,h),t.visualMode&&st(e)}},recordLastEdit:function(e,t,n){var r=_.macroModeState;if(r.isPlaying)return;e.lastEditInputState=t,e.lastEditActionCommand=n,r.lastInsertModeChanges.changes=[],r.lastInsertModeChanges.expectCursorActivityForChange=!1}},R={moveToTopLine:function(e,t){var r=zt(e).top+t.repeat-1;return n(r,at(e.getLine(r)))},moveToMiddleLine:function(e){var t=zt(e),r=Math.floor((t.top+t.bottom)*.5);return n(r,at(e.getLine(r)))},moveToBottomLine:function(e,t){var r=zt(e).bottom-t.repeat+1;return n(r,at(e.getLine(r)))},expandToLine:function(e,t){var r=e.getCursor();return n(r.line+t.repeat-1,Infinity)},findNext:function(e,t){var n=Tt(e),r=n.getQuery();if(!r)return;var i=!t.forward;return i=n.isReversed()?!i:i,It(e,r),qt(e,i,r,t.repeat)},goToMark:function(e,t,n){var r=n.marks[t.selectedCharacter];if(r){var i=r.find();return t.linewise?{line:i.line,ch:at(e.getLine(i.line))}:i}return null},moveToOtherHighlightedEnd:function(e){var t=K(e.getCursor("head")),n=K(e.getCursor("anchor"));return G(n,t)?t.ch+=1:G(t,n)&&(n.ch-=1),[t,n]},jumpToMark:function(e,t,r){var i=e.getCursor();for(var s=0;s<t.repeat;s++){var o=i;for(var u in r.marks){if(!y(u))continue;var a=r.marks[u].find(),f=t.forward?G(a,o):G(o,a);if(f)continue;if(t.linewise&&a.line==o.line)continue;var l=Q(o,i),c=t.forward?Y(o,a,i):Y(i,a,o);if(l||c)i=a}}return t.linewise&&(i=n(i.line,at(e.getLine(i.line)))),i},moveByCharacters:function(e,t){var r=e.getCursor(),i=t.repeat,s=t.forward?r.ch+i:r.ch-i;return n(r.line,s)},moveByLines:function(e,t,r){var i=e.getCursor(),s=i.ch;switch(r.lastMotion){case this.moveByLines:case this.moveByDisplayLines:case this.moveByScroll:case this.moveToColumn:case this.moveToEol:s=r.lastHPos;break;default:r.lastHPos=s}var o=t.repeat+(t.repeatOffset||0),u=t.forward?i.line+o:i.line-o,a=e.firstLine(),f=e.lastLine();if(u<a&&i.line==a||u>f&&i.line==f)return;return t.toFirstChar&&(s=at(e.getLine(u)),r.lastHPos=s),r.lastHSPos=e.charCoords(n(u,s),"div").left,n(u,s)},moveByDisplayLines:function(e,t,r){var i=e.getCursor();switch(r.lastMotion){case this.moveByDisplayLines:case this.moveByScroll:case this.moveByLines:case this.moveToColumn:case this.moveToEol:break;default:r.lastHSPos=e.charCoords(i,"div").left}var s=t.repeat,o=e.findPosV(i,t.forward?s:-s,"line",r.lastHSPos);if(o.hitSide)if(t.forward)var u=e.charCoords(o,"div"),a={top:u.top+8,left:r.lastHSPos},o=e.coordsChar(a,"div");else{var f=e.charCoords(n(e.firstLine(),0),"div");f.left=r.lastHSPos,o=e.coordsChar(f,"div")}return r.lastHPos=o.ch,o},moveByPage:function(e,t){var n=e.getCursor(),r=t.repeat;return e.findPosV(n,t.forward?r:-r,"page")},moveByParagraph:function(e,t){var r=e.getCursor().line,i=t.repeat,s=t.forward?1:-1;for(var o=0;o<i;o++){if(!t.forward&&r===e.firstLine()||t.forward&&r==e.lastLine())break;r+=s;while(r!==e.firstLine()&&r!=e.lastLine()&&e.getLine(r))r+=s}return n(r,0)},moveByScroll:function(e,t,n){var r=e.getScrollInfo(),i=null,s=t.repeat;s||(s=r.clientHeight/(2*e.defaultTextHeight()));var o=e.charCoords(e.getCursor(),"local");t.repeat=s;var i=R.moveByDisplayLines(e,t,n);if(!i)return null;var u=e.charCoords(i,"local");return e.scrollTo(null,r.top+u.top-o.top),i},moveByWords:function(e,t){return mt(e,t.repeat,!!t.forward,!!t.wordEnd,!!t.bigWord)},moveTillCharacter:function(e,t){var n=t.repeat,r=gt(e,n,t.forward,t.selectedCharacter),i=t.forward?-1:1;return ct(i,t),r?(r.ch+=i,r):null},moveToCharacter:function(e,t){var n=t.repeat;return ct(0,t),gt(e,n,t.forward,t.selectedCharacter)||e.getCursor()},moveToSymbol:function(e,t){var n=t.repeat;return dt(e,n,t.forward,t.selectedCharacter)||e.getCursor()},moveToColumn:function(e,t,n){var r=t.repeat;return n.lastHPos=r-1,n.lastHSPos=e.charCoords(e.getCursor(),"div").left,yt(e,r)},moveToEol:function(e,t,r){var i=e.getCursor();r.lastHPos=Infinity;var s=n(i.line+t.repeat-1,Infinity),o=e.clipPos(s);return o.ch--,r.lastHSPos=e.charCoords(o,"div").left,s},moveToFirstNonWhiteSpaceCharacter:function(e){var t=e.getCursor();return n(t.line,at(e.getLine(t.line)))},moveToMatchedSymbol:function(e){var t=e.getCursor(),r=t.line,i=t.ch,s=e.getLine(r),o;do{o=s.charAt(i++);if(o&&b(o)){var u=e.getTokenTypeAt(n(r,i));if(u!=="string"&&u!=="comment")break}}while(o);if(o){var a=e.findMatchingBracket(n(r,i));return a.to}return t},moveToStartOfLine:function(e){var t=e.getCursor();return n(t.line,0)},moveToLineOrEdgeOfDocument:function(e,t){var r=t.forward?e.lastLine():e.firstLine();return t.repeatIsExplicit&&(r=t.repeat-e.getOption("firstLineNumber")),n(r,at(e.getLine(r)))},textObjectManipulation:function(e,t){var n={"(":")",")":"(","{":"}","}":"{","[":"]","]":"["},r={"'":!0,'"':!0},i=t.selectedCharacter;i=="b"?i="(":i=="B"&&(i="{");var s=!t.textObjectInner,o;if(n[i])o=Et(e,i,s);else if(r[i])o=St(e,i,s);else if(i==="W")o=ft(e,s,!0,!0);else{if(i!=="w")return null;o=ft(e,s,!0,!1)}return[o.start,o.end]},repeatLastCharacterSearch:function(e,t){var n=_.lastChararacterSearch,r=t.repeat,i=t.forward===n.forward,s=(n.increment?1:0)*(i?-1:1);e.moveH(-s,"char"),t.inclusive=i?!0:!1;var o=gt(e,r,i,n.selectedCharacter);return o?(o.ch+=s,o):(e.moveH(s,"char"),e.getCursor())}},U={change:function(e,t,n,r,i){_.registerController.pushText(t.registerName,"change",e.getRange(r,i),t.linewise);if(t.linewise){var s=i.line>e.lastLine()?"":"\n";e.replaceRange(s,r,i),e.indentLine(r.line,"smart"),r.ch=null}else{var o=e.getRange(r,i);if(!S(o)){var u=/\s+$/.exec(o);u&&(i=V(i,0,-u[0].length))}e.replaceRange("",r,i)}z.enterInsertMode(e,{},e.state.vim),e.setCursor(r)},"delete":function(e,t,n,r,i){t.linewise&&i.line>e.lastLine()&&r.line>e.firstLine()&&(r.line--,r.ch=Z(e,r.line)),_.registerController.pushText(t.registerName,"delete",e.getRange(r,i),t.linewise),e.replaceRange("",r,i),t.linewise?e.setCursor(R.moveToFirstNonWhiteSpaceCharacter(e)):e.setCursor(r)},indent:function(e,t,n,r,i){var s=r.line,o=i.line,u=n.visualMode?t.repeat:1;t.linewise&&o--;for(var a=s;a<=o;a++)for(var f=0;f<u;f++)e.indentLine(a,t.indentRight);e.setCursor(r),e.setCursor(R.moveToFirstNonWhiteSpaceCharacter(e))},swapcase:function(e,t,n,r,i,s){var o=e.getRange(r,i),u="";for(var a=0;a<o.length;a++){var f=o.charAt(a);u+=E(f)?f.toLowerCase():f.toUpperCase()}e.replaceRange(u,r,i),t.shouldMoveCursor||e.setCursor(s)},yank:function(e,t,n,r,i,s){_.registerController.pushText(t.registerName,"yank",e.getRange(r,i),t.linewise),e.setCursor(s)}},z={jumpListWalk:function(e,t,n){if(n.visualMode)return;var r=t.repeat,i=t.forward,s=_.jumpList,o=s.move(e,i?r:-r),u=o?o.find():undefined;u=u?u:e.getCursor(),e.setCursor(u)},scroll:function(e,t,n){if(n.visualMode)return;var r=t.repeat||1,i=e.defaultTextHeight(),s=e.getScrollInfo().top,o=i*r,u=t.forward?s+o:s-o,a=K(e.getCursor()),f=e.charCoords(a,"local");if(t.forward)u>f.top?(a.line+=(u-f.top)/i,a.line=Math.ceil(a.line),e.setCursor(a),f=e.charCoords(a,"local"),e.scrollTo(null,f.top)):e.scrollTo(null,u);else{var l=u+e.getScrollInfo().clientHeight;l<f.bottom?(a.line-=(f.bottom-l)/i,a.line=Math.floor(a.line),e.setCursor(a),f=e.charCoords(a,"local"),e.scrollTo(null,f.bottom-e.getScrollInfo().clientHeight)):e.scrollTo(null,u)}},scrollToCursor:function(e,t){var r=e.getCursor().line,i=e.charCoords(n(r,0),"local"),s=e.getScrollInfo().clientHeight,o=i.top,u=i.bottom-o;switch(t.position){case"center":o=o-s/2+u;break;case"bottom":o=o-s+u*1.4;break;case"top":o+=u*.4}e.scrollTo(null,o)},replayMacro:function(e,t,n){var r=t.selectedCharacter,i=t.repeat,s=_.macroModeState;r=="@"&&(r=s.latestRegister);while(i--)Gt(e,n,s,r)},enterMacroRecordMode:function(e,t){var n=_.macroModeState,r=t.selectedCharacter;n.enterMacroRecordMode(e,r)},enterInsertMode:function(t,r,i){if(t.getOption("readOnly"))return;i.insertMode=!0,i.insertModeRepeat=r&&r.repeat||1;var s=r?r.insertAt:null;if(s=="eol"){var o=t.getCursor();o=n(o.line,Z(t,o.line)),t.setCursor(o)}else if(s=="charAfter")t.setCursor(V(t.getCursor(),0,1));else if(s=="firstNonBlank")t.setCursor(R.moveToFirstNonWhiteSpaceCharacter(t));else if(s=="endOfSelectedArea"){var u=t.getCursor("head"),a=t.getCursor("anchor");u=G(a,u)?n(u.line,u.ch+1):u.line<a.line?n(a.line,0):u,t.setCursor(u),st(t)}t.setOption("keyMap","vim-insert"),t.setOption("disableInput",!1),r&&r.replace?(t.toggleOverwrite(!0),t.setOption("keyMap","vim-replace"),e.signal(t,"vim-mode-change",{mode:"replace"})):(t.setOption("keyMap","vim-insert"),e.signal(t,"vim-mode-change",{mode:"insert"})),_.macroModeState.isPlaying||(t.on("change",tn),e.on(t.getInputField(),"keydown",sn))},toggleVisualMode:function(t,r,i){var s=r.repeat,o=t.getCursor(),u;i.visualMode?(o=t.getCursor("anchor"),u=t.getCursor("head"),!i.visualLine&&r.linewise?(i.visualLine=!0,o.ch=G(o,u)?0:Z(t,o.line),u.ch=G(o,u)?Z(t,u.line):0,t.setSelection(o,u),e.signal(t,"vim-mode-change",{mode:"visual",subMode:"linewise"})):i.visualLine&&!r.linewise?(i.visualLine=!1,e.signal(t,"vim-mode-change",{mode:"visual"})):st(t)):(t.on("mousedown",st),i.visualMode=!0,i.visualLine=!!r.linewise,i.visualLine?(o.ch=0,u=W(t,n(o.line+s-1,Z(t,o.line)),!0)):u=W(t,n(o.line,o.ch+s),!0),!r.repeatIsExplicit&&!i.visualLine?(t.setCursor(u),t.setSelection(u,o)):t.setSelection(o,u),e.signal(t,"vim-mode-change",{mode:"visual",subMode:i.visualLine?"linewise":""})),bt(t,i,"<",G(o,u)?o:u),bt(t,i,">",G(o,u)?u:o)},reselectLastSelection:function(t,n,r){var i=r.lastSelection;if(i){var s=i.curStartMark.find(),o=i.curEndMark.find();t.setSelection(s,o);if(r.visualMode){it(t,r);var u=t.getCursor("anchor"),a=t.getCursor("head");bt(t,r,"<",G(u,a)?u:a),bt(t,r,">",G(u,a)?a:u)}i.visualLine?(r.visualMode=!0,r.visualLine=!0):(r.visualMode=!0,r.visualLine=!1),e.signal(t,"vim-mode-change",{mode:"visual",subMode:r.visualLine?"linewise":""})}},joinLines:function(e,t,r){var i,s;if(r.visualMode)i=e.getCursor("anchor"),s=e.getCursor("head"),s.ch=Z(e,s.line)-1;else{var o=Math.max(t.repeat,2);i=e.getCursor(),s=W(e,n(i.line+o-1,Infinity))}var u=0;e.operation(function(){for(var t=i.line;t<s.line;t++){u=Z(e,i.line);var r=n(i.line+1,Z(e,i.line+1)),o=e.getRange(i,r);o=o.replace(/\n\s*/g," "),e.replaceRange(o,i,r)}var a=n(i.line,u);e.setCursor(a)})},newLineAndEnterInsertMode:function(t,r,i){i.insertMode=!0;var s=K(t.getCursor());if(s.line===t.firstLine()&&!r.after)t.replaceRange("\n",n(t.firstLine(),0)),t.setCursor(t.firstLine(),0);else{s.line=r.after?s.line:s.line-1,s.ch=Z(t,s.line),t.setCursor(s);var o=e.commands.newlineAndIndentContinueComment||e.commands.newlineAndIndent;o(t)}this.enterInsertMode(t,{repeat:r.repeat},i)},paste:function(e,t,r){var i=K(e.getCursor()),s=_.registerController.getRegister(t.registerName),o=s.toString();if(!o)return;if(t.matchIndent){var u=function(t){var n=t.split("	").length-1,r=t.split(" ").length-1;return n*e.options.tabSize+r*1},a=e.getLine(e.getCursor().line),f=u(a.match(/^\s*/)[0]),l=o.replace(/\n$/,""),c=o!==l,h=u(o.match(/^\s*/)[0]),o=l.replace(/^\s*/gm,function(t){var n=f+(u(t)-h);if(n<0)return"";if(e.options.indentWithTabs){var r=Math.floor(n/e.options.tabSize);return Array(r+1).join("	")}return Array(n+1).join(" ")});o+=c?"\n":""}if(t.repeat>1)var o=Array(t.repeat+1).join(o);var p=s.linewise;p?r.visualMode?o=r.visualLine?o.slice(0,-1):"\n"+o.slice(0,o.length-1)+"\n":t.after?(o="\n"+o.slice(0,o.length-1),i.ch=Z(e,i.line)):i.ch=0:i.ch+=t.after?1:0;var d,v;if(r.visualMode){r.lastPastedText=o;var m,g=rt(e,r),y=g[0],b=g[1];r.lastSelection&&(m=r.lastSelection.curEndMark.find()),_.registerController.unnamedRegister.setText(e.getRange(y,b)),e.replaceRange(o,y,b),m&&(r.lastSelection.curEndMark=e.setBookmark(m)),d=e.posFromIndex(e.indexFromPos(y)+o.length-1),p&&(d.ch=0)}else e.replaceRange(o,i),p&&t.after?d=n(i.line+1,at(e.getLine(i.line+1))):p&&!t.after?d=n(i.line,at(e.getLine(i.line))):!p&&t.after?(v=e.indexFromPos(i),d=e.posFromIndex(v+o.length-1)):(v=e.indexFromPos(i),d=e.posFromIndex(v+o.length));e.setCursor(d)},undo:function(t,n){t.operation(function(){J(t,e.commands.undo,n.repeat)(),t.setCursor(t.getCursor("anchor"))})},redo:function(t,n){J(t,e.commands.redo,n.repeat)()},setRegister:function(e,t,n){n.inputState.registerName=t.selectedCharacter},setMark:function(e,t,n){var r=t.selectedCharacter;bt(e,n,r,e.getCursor())},replace:function(t,r,i){var s=r.selectedCharacter,o=t.getCursor(),u,a;if(i.visualMode)o=t.getCursor("start"),a=t.getCursor("end"),a=t.clipPos(n(a.line,a.ch+1));else{var f=t.getLine(o.line);u=o.ch+r.repeat,u>f.length&&(u=f.length),a=n(o.line,u)}if(s=="\n")i.visualMode||t.replaceRange("",o,a),(e.commands.newlineAndIndentContinueComment||e.commands.newlineAndIndent)(t);else{var l=t.getRange(o,a);l=l.replace(/[^\n]/g,s),t.replaceRange(l,o,a),i.visualMode?(t.setCursor(o),st(t)):t.setCursor(V(a,0,-1))}},incrementNumberToken:function(e,t){var r=e.getCursor(),i=e.getLine(r.line),s=/-?\d+/g,o,u,a,f,l;while((o=s.exec(i))!==null){l=o[0],u=o.index,a=u+l.length;if(r.ch<a)break}if(!t.backtrack&&a<=r.ch)return;if(!l)return;var c=t.increase?1:-1,h=parseInt(l)+c*t.repeat,p=n(r.line,u),d=n(r.line,a);f=h.toString(),e.replaceRange(f,p,d),e.setCursor(n(r.line,u+f.length-1))},repeatLastEdit:function(e,t,n){var r=n.lastEditInputState;if(!r)return;var i=t.repeat;i&&t.repeatIsExplicit?n.lastEditInputState.repeatOverride=i:i=n.lastEditInputState.repeatOverride||i,on(e,n,i,!1)},changeCase:function(e,t,n){var r=rt(e,n),i=r[0],s=r[1],o=n.lastSelection.curEndMark.find(),u=t.toLower,a=e.getRange(i,s);e.replaceRange(u?a.toLowerCase():a.toUpperCase(),i,s),n.lastSelection.curEndMark=e.setBookmark(o),e.setCursor(i)}},ht={"(":"bracket",")":"bracket","{":"bracket","}":"bracket","[":"section","]":"section","*":"comment","/":"comment",m:"method",M:"method","#":"preprocess"},pt={bracket:{isComplete:function(e){if(e.nextCh===e.symb){e.depth++;if(e.depth>=1)return!0}else e.nextCh===e.reverseSymb&&e.depth--;return!1}},section:{init:function(e){e.curMoveThrough=!0,e.symb=(e.forward?"]":"[")===e.symb?"{":"}"},isComplete:function(e){return e.index===0&&e.nextCh===e.symb}},comment:{isComplete:function(e){var t=e.lastCh==="*"&&e.nextCh==="/";return e.lastCh=e.nextCh,t}},method:{init:function(e){e.symb=e.symb==="m"?"{":"}",e.reverseSymb=e.symb==="{"?"}":"{"},isComplete:function(e){return e.nextCh===e.symb?!0:!1}},preprocess:{init:function(e){e.index=0},isComplete:function(e){if(e.nextCh==="#"){var t=e.lineText.match(/#(\w+)/)[1];if(t==="endif"){if(e.forward&&e.depth===0)return!0;e.depth++}else if(t==="if"){if(!e.forward&&e.depth===0)return!0;e.depth--}if(t==="else"&&e.depth===0)return!0}return!1}}};N("pcre",!0,"boolean"),xt.prototype={getQuery:function(){return _.query},setQuery:function(e){_.query=e},getOverlay:function(){return this.searchOverlay},setOverlay:function(e){this.searchOverlay=e},isReversed:function(){return _.isReversed},setReversed:function(e){_.isReversed=e}};var Pt="(Javascript regexp)",Wt=[{name:"map"},{name:"nmap",shortName:"nm"},{name:"vmap",shortName:"vm"},{name:"unmap"},{name:"write",shortName:"w"},{name:"undo",shortName:"u"},{name:"redo",shortName:"red"},{name:"set",shortName:"set"},{name:"sort",shortName:"sor"},{name:"substitute",shortName:"s"},{name:"nohlsearch",shortName:"noh"},{name:"delmarks",shortName:"delm"},{name:"registers",shortName:"reg",excludeFromCommandHistory:!0},{name:"global",shortName:"g"}];r.ExCommandDispatcher=function(){this.buildCommandMap_()},r.ExCommandDispatcher.prototype={processCommand:function(t,n){var r=t.state.vim,i=_.registerController.getRegister(":"),s=i.toString();r.visualMode&&st(t);var o=new e.StringStream(n);i.setText(n);var u={};u.input=n;try{this.parseInput_(t,o,u)}catch(a){throw _t(t,a),a}var f;if(!u.commandName)u.line!==undefined&&(f="move");else{var l=this.matchCommand_(u.commandName);if(l){f=l.name,l.excludeFromCommandHistory&&i.setText(s),this.parseCommandArgs_(o,u,l);if(l.type=="exToKey"){for(var c=0;c<l.toKeys.length;c++)e.Vim.handleKey(t,l.toKeys[c]);return}if(l.type=="exToEx"){this.processCommand(t,l.toInput);return}}}if(!f){_t(t,'Not an editor command ":'+n+'"');return}try{Vt[f](t,u)}catch(a){throw _t(t,a),a}},parseInput_:function(e,t,n){t.eatWhile(":"),t.eat("%")?(n.line=e.firstLine(),n.lineEnd=e.lastLine()):(n.line=this.parseLineSpec_(e,t),n.line!==undefined&&t.eat(",")&&(n.lineEnd=this.parseLineSpec_(e,t)));var r=t.match(/^(\w+)/);return r?n.commandName=r[1]:n.commandName=t.match(/.*/)[0],n},parseLineSpec_:function(e,t){var n=t.match(/^(\d+)/);if(n)return parseInt(n[1],10)-1;switch(t.next()){case".":return e.getCursor().line;case"$":return e.lastLine();case"'":var r=e.state.vim.marks[t.next()];if(r&&r.find())return r.find().line;throw new Error("Mark not set");default:return t.backUp(1),undefined}},parseCommandArgs_:function(e,t,n){if(e.eol())return;t.argString=e.match(/.*/)[0];var r=n.argDelimiter||/\s+/,i=tt(t.argString).split(r);i.length&&i[0]&&(t.args=i)},matchCommand_:function(e){for(var t=e.length;t>0;t--){var n=e.substring(0,t);if(this.commandMap_[n]){var r=this.commandMap_[n];if(r.name.indexOf(e)===0)return r}}return null},buildCommandMap_:function(){this.commandMap_={};for(var e=0;e<Wt.length;e++){var t=Wt[e],n=t.shortName||t.name;this.commandMap_[n]=t}},map:function(e,n,r){if(e!=":"&&e.charAt(0)==":"){if(r)throw Error("Mode not supported for ex mappings");var i=e.substring(1);n!=":"&&n.charAt(0)==":"?this.commandMap_[i]={name:i,type:"exToEx",toInput:n.substring(1),user:!0}:this.commandMap_[i]={name:i,type:"exToKey",toKeys:Xt(n),user:!0}}else if(n!=":"&&n.charAt(0)==":"){var s={keys:Xt(e),type:"keyToEx",exArgs:{input:n.substring(1)},user:!0};r&&(s.context=r),t.unshift(s)}else{var s={keys:Xt(e),type:"keyToKey",toKeys:Xt(n),user:!0};r&&(s.context=r),t.unshift(s)}},unmap:function(e,n){var r=function(e,t){if(e===t)return!0;if(e==null||t==null)return!0;if(e.length!=t.length)return!1;for(var n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0};if(e!=":"&&e.charAt(0)==":"){if(n)throw Error("Mode not supported for ex mappings");var i=e.substring(1);if(this.commandMap_[i]&&this.commandMap_[i].user){delete this.commandMap_[i];return}}else{var s=Xt(e);for(var o=0;o<t.length;o++)if(r(s,t[o].keys)&&t[o].context===n&&t[o].user){t.splice(o,1);return}}throw Error("No such mapping.")}};var Vt={map:function(e,t,n){var r=t.args;if(!r||r.length<2){e&&_t(e,"Invalid mapping: "+t.input);return}$t.map(r[0],r[1],n)},nmap:function(e,t){this.map(e,t,"normal")},vmap:function(e,t){this.map(e,t,"visual")},unmap:function(e,t,n){var r=t.args;if(!r||r.length<1){e&&_t(e,"No such mapping: "+t.input);return}$t.unmap(r[0],n)},move:function(e,t){q.processCommand(e,e.state.vim,{type:"motion",motion:"moveToLineOrEdgeOfDocument",motionArgs:{forward:!1,explicitRepeat:!0,linewise:!0},repeatOverride:t.line+1})},set:function(e,t){var n=t.args;if(!n||n.length<1){e&&_t(e,"Invalid mapping: "+t.input);return}var r=n[0].split("="),i=r[0],s=r[1],o=!1;if(i.charAt(i.length-1)=="?"){if(s)throw Error("Trailing characters: "+t.argString);i=i.substring(0,i.length-1),o=!0}s===undefined&&i.substring(0,2)=="no"&&(i=i.substring(2),s=!1);var u=T[i]&&T[i].type=="boolean";u&&s==undefined&&(s=!0);if(!u&&!s||o){var a=k(i);a===!0||a===!1?_t(e," "+(a?"":"no")+i):_t(e,"  "+i+"="+a)}else C(i,s)},registers:function(e,t){var n=t.args,r=_.registerController.registers,i="----------Registers----------<br><br>";if(!n)for(var s in r){var o=r[s].toString();o.length&&(i+='"'+s+"    "+o+"<br>")}else{var s;n=n.join("");for(var u=0;u<n.length;u++){s=n.charAt(u);if(!_.registerController.isValidRegister(s))continue;var a=r[s]||new j;i+='"'+s+"    "+a.toString()+"<br>"}}_t(e,i)},sort:function(t,r){function a(){if(r.argString){var t=new e.StringStream(r.argString);t.eat("!")&&(i=!0);if(t.eol())return;if(!t.eatSpace())return"Invalid arguments";var n=t.match(/[a-z]+/);if(n){n=n[0],s=n.indexOf("i")!=-1,o=n.indexOf("u")!=-1;var a=n.indexOf("d")!=-1&&1,f=n.indexOf("x")!=-1&&1,l=n.indexOf("o")!=-1&&1;if(a+f+l>1)return"Invalid arguments";u=a&&"decimal"||f&&"hex"||l&&"octal"}t.eatSpace()&&t.match(/\/.*\//)&&"patterns not supported"}}function w(e,t){if(i){var n;n=e,e=t,t=n}s&&(e=e.toLowerCase(),t=t.toLowerCase());var r=u&&v.exec(e),o=u&&v.exec(t);return r?(r=parseInt((r[1]+r[2]).toLowerCase(),m),o=parseInt((o[1]+o[2]).toLowerCase(),m),r-o):e<t?-1:1}var i,s,o,u,f=a();if(f){_t(t,f+": "+r.argString);return}var l=r.line||t.firstLine(),c=r.lineEnd||r.line||t.lastLine();if(l==c)return;var h=n(l,0),p=n(c,Z(t,c)),d=t.getRange(h,p).split("\n"),v=u=="decimal"?/(-?)([\d]+)/:u=="hex"?/(-?)(?:0x)?([0-9a-f]+)/i:u=="octal"?/([0-7]+)/:null,m=u=="decimal"?10:u=="hex"?16:u=="octal"?8:null,g=[],y=[];if(u)for(var b=0;b<d.length;b++)v.exec(d[b])?g.push(d[b]):y.push(d[b]);else y=d;g.sort(w),y.sort(w),d=i?g.concat(y):y.concat(g);if(o){var E=d,S;d=[];for(var b=0;b<E.length;b++)E[b]!=S&&d.push(E[b]),S=E[b]}t.replaceRange(d.join("\n"),h,p)},global:function(e,t){var n=t.argString;if(!n){_t(e,"Regular Expression missing from global");return}var r=t.line!==undefined?t.line:e.firstLine(),i=t.lineEnd||t.line||e.lastLine(),s=Ct(n),o=n,u;s.length&&(o=s[0],u=s.slice(1,s.length).join("/"));if(o)try{jt(e,o,!0,!0)}catch(a){_t(e,"Invalid regex: "+o);return}var f=Tt(e).getQuery(),l=[],c="";for(var h=r;h<=i;h++){var p=f.test(e.getLine(h));p&&(l.push(h+1),c+=e.getLine(h)+"<br>")}if(!u){_t(e,c);return}for(var h=0;h<l.length;h++){var d=l[h]+u;$t.processCommand(e,d)}},substitute:function(e,t){if(!e.getSearchCursor)throw new Error("Search feature not available. Requires searchcursor.js or any other getSearchCursor implementation.");var r=t.argString,i=r?Ct(r):[],s,o="",u,a,f,l=!1;if(i.length)s=i[0],o=i[1],o!==undefined&&(k("pcre")?o=Ot(o):o=At(o),_.lastSubstituteReplacePart=o),u=i[2]?i[2].split(" "):[];else if(r&&r.length){_t(e,"Substitutions should be of the form :s/pattern/replace/");return}u&&(a=u[0],f=parseInt(u[1]),a&&(a.indexOf("c")!=-1&&(l=!0,a.replace("c","")),s=s+"/"+a));if(s)try{jt(e,s,!0,!0)}catch(c){_t(e,"Invalid regex: "+s);return}o=o||_.lastSubstituteReplacePart;if(o===undefined){_t(e,"No previous substitute regular expression");return}var h=Tt(e),p=h.getQuery(),d=t.line!==undefined?t.line:e.getCursor().line,v=t.lineEnd||d;f&&(d=v,v=d+f-1);var m=W(e,n(d,0)),g=e.getSearchCursor(p,m);Jt(e,l,d,v,g,p,o)},redo:e.commands.redo,undo:e.commands.undo,write:function(t){e.commands.save?e.commands.save(t):t.save()},nohlsearch:function(e){Rt(e)},delmarks:function(t,n){if(!n.argString||!tt(n.argString)){_t(t,"Argument required");return}var r=t.state.vim,i=new e.StringStream(tt(n.argString));while(!i.eol()){i.eatSpace();var s=i.pos;if(!i.match(/[a-zA-Z]/,!1)){_t(t,"Invalid argument: "+n.argString.substring(s));return}var o=i.next();if(i.match("-",!0)){if(!i.match(/[a-zA-Z]/,!1)){_t(t,"Invalid argument: "+n.argString.substring(s));return}var u=o,a=i.next();if(!(y(u)&&y(a)||E(u)&&E(a))){_t(t,"Invalid argument: "+u+"-");return}var f=u.charCodeAt(0),l=a.charCodeAt(0);if(f>=l){_t(t,"Invalid argument: "+n.argString.substring(s));return}for(var c=0;c<=l-f;c++){var h=String.fromCharCode(f+c);delete r.marks[h]}}else delete r.marks[o]}}},$t=new r.ExCommandDispatcher;return e.keyMap.vim=Kt(),e.keyMap["vim-insert"]={Esc:Qt,"Ctrl-[":Qt,"Ctrl-C":Qt,"Ctrl-N":"autocomplete","Ctrl-P":"autocomplete",Enter:function(t){var n=e.commands.newlineAndIndentContinueComment||e.commands.newlineAndIndent;n(t)},fallthrough:["default"]},e.keyMap["vim-replace"]={Backspace:"goCharLeft",fallthrough:["vim-insert"]},D(),P};e.Vim=r()}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/apl/apl",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("apl",function(){var e={".":"innerProduct","\\":"scan","/":"reduce","⌿":"reduce1Axis","⍀":"scan1Axis","¨":"each","⍣":"power"},t={"+":["conjugate","add"],"−":["negate","subtract"],"×":["signOf","multiply"],"÷":["reciprocal","divide"],"⌈":["ceiling","greaterOf"],"⌊":["floor","lesserOf"],"∣":["absolute","residue"],"⍳":["indexGenerate","indexOf"],"?":["roll","deal"],"⋆":["exponentiate","toThePowerOf"],"⍟":["naturalLog","logToTheBase"],"○":["piTimes","circularFuncs"],"!":["factorial","binomial"],"⌹":["matrixInverse","matrixDivide"],"<":[null,"lessThan"],"≤":[null,"lessThanOrEqual"],"=":[null,"equals"],">":[null,"greaterThan"],"≥":[null,"greaterThanOrEqual"],"≠":[null,"notEqual"],"≡":["depth","match"],"≢":[null,"notMatch"],"∈":["enlist","membership"],"⍷":[null,"find"],"∪":["unique","union"],"∩":[null,"intersection"],"∼":["not","without"],"∨":[null,"or"],"∧":[null,"and"],"⍱":[null,"nor"],"⍲":[null,"nand"],"⍴":["shapeOf","reshape"],",":["ravel","catenate"],"⍪":[null,"firstAxisCatenate"],"⌽":["reverse","rotate"],"⊖":["axis1Reverse","axis1Rotate"],"⍉":["transpose",null],"↑":["first","take"],"↓":[null,"drop"],"⊂":["enclose","partitionWithAxis"],"⊃":["diclose","pick"],"⌷":[null,"index"],"⍋":["gradeUp",null],"⍒":["gradeDown",null],"⊤":["encode",null],"⊥":["decode",null],"⍕":["format","formatByExample"],"⍎":["execute",null],"⊣":["stop","left"],"⊢":["pass","right"]},n=/[\.\/⌿⍀¨⍣]/,r=/⍬/,i=/[\+−×÷⌈⌊∣⍳\?⋆⍟○!⌹<≤=>≥≠≡≢∈⍷∪∩∼∨∧⍱⍲⍴,⍪⌽⊖⍉↑↓⊂⊃⌷⍋⍒⊤⊥⍕⍎⊣⊢]/,s=/←/,o=/[⍝#].*$/,u=function(e){var t;return t=!1,function(n){return t=n,n===e?t==="\\":!0}};return{startState:function(){return{prev:!1,func:!1,op:!1,string:!1,escape:!1}},token:function(a,f){var l,c,h;return a.eatSpace()?null:(l=a.next(),l==='"'||l==="'"?(a.eatWhile(u(l)),a.next(),f.prev=!0,"string"):/[\[{\(]/.test(l)?(f.prev=!1,null):/[\]}\)]/.test(l)?(f.prev=!0,null):r.test(l)?(f.prev=!1,"niladic"):/[¯\d]/.test(l)?(f.func?(f.func=!1,f.prev=!1):f.prev=!0,a.eatWhile(/[\w\.]/),"number"):n.test(l)?"operator apl-"+e[l]:s.test(l)?"apl-arrow":i.test(l)?(c="apl-",t[l]!=null&&(f.prev?c+=t[l][1]:c+=t[l][0]),f.func=!0,f.prev=!1,"function "+c):o.test(l)?(a.skipToEnd(),"comment"):l==="∘"&&a.peek()==="."?(a.next(),"function jot-dot"):(a.eatWhile(/[\w\$_]/),h=a.current(),f.prev=!0,"keyword"))}}}),e.defineMIME("text/apl","apl")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/asterisk/asterisk",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("asterisk",function(){function r(n,r){var i="",s="";s=n.next();if(s==";")return n.skipToEnd(),"comment";if(s=="[")return n.skipTo("]"),n.eat("]"),"header";if(s=='"')return n.skipTo('"'),"string";if(s=="'")return n.skipTo("'"),"string-2";if(s=="#"){n.eatWhile(/\w/),i=n.current();if(t.indexOf(i)!==-1)return n.skipToEnd(),"strong"}if(s=="$"){var o=n.peek();if(o=="{")return n.skipTo("}"),n.eat("}"),"variable-3"}n.eatWhile(/\w/),i=n.current();if(e.indexOf(i)!==-1){r.extenStart=!0;switch(i){case"same":r.extenSame=!0;break;case"include":case"switch":case"ignorepat":r.extenInclude=!0;break;default:}return"atom"}}var e=["exten","same","include","ignorepat","switch"],t=["#include","#exec"],n=["addqueuemember","adsiprog","aelsub","agentlogin","agentmonitoroutgoing","agi","alarmreceiver","amd","answer","authenticate","background","backgrounddetect","bridge","busy","callcompletioncancel","callcompletionrequest","celgenuserevent","changemonitor","chanisavail","channelredirect","chanspy","clearhash","confbridge","congestion","continuewhile","controlplayback","dahdiacceptr2call","dahdibarge","dahdiras","dahdiscan","dahdisendcallreroutingfacility","dahdisendkeypadfacility","datetime","dbdel","dbdeltree","deadagi","dial","dictate","directory","disa","dumpchan","eagi","echo","endwhile","exec","execif","execiftime","exitwhile","extenspy","externalivr","festival","flash","followme","forkcdr","getcpeid","gosub","gosubif","goto","gotoif","gotoiftime","hangup","iax2provision","ices","importvar","incomplete","ivrdemo","jabberjoin","jabberleave","jabbersend","jabbersendgroup","jabberstatus","jack","log","macro","macroexclusive","macroexit","macroif","mailboxexists","meetme","meetmeadmin","meetmechanneladmin","meetmecount","milliwatt","minivmaccmess","minivmdelete","minivmgreet","minivmmwi","minivmnotify","minivmrecord","mixmonitor","monitor","morsecode","mp3player","mset","musiconhold","nbscat","nocdr","noop","odbc","odbc","odbcfinish","originate","ospauth","ospfinish","osplookup","ospnext","page","park","parkandannounce","parkedcall","pausemonitor","pausequeuemember","pickup","pickupchan","playback","playtones","privacymanager","proceeding","progress","queue","queuelog","raiseexception","read","readexten","readfile","receivefax","receivefax","receivefax","record","removequeuemember","resetcdr","retrydial","return","ringing","sayalpha","saycountedadj","saycountednoun","saycountpl","saydigits","saynumber","sayphonetic","sayunixtime","senddtmf","sendfax","sendfax","sendfax","sendimage","sendtext","sendurl","set","setamaflags","setcallerpres","setmusiconhold","sipaddheader","sipdtmfmode","sipremoveheader","skel","slastation","slatrunk","sms","softhangup","speechactivategrammar","speechbackground","speechcreate","speechdeactivategrammar","speechdestroy","speechloadgrammar","speechprocessingsound","speechstart","speechunloadgrammar","stackpop","startmusiconhold","stopmixmonitor","stopmonitor","stopmusiconhold","stopplaytones","system","testclient","testserver","transfer","tryexec","trysystem","unpausemonitor","unpausequeuemember","userevent","verbose","vmauthenticate","vmsayname","voicemail","voicemailmain","wait","waitexten","waitfornoise","waitforring","waitforsilence","waitmusiconhold","waituntil","while","zapateller"];return{startState:function(){return{extenStart:!1,extenSame:!1,extenInclude:!1,extenExten:!1,extenPriority:!1,extenApplication:!1}},token:function(e,t){var i="",s="";return e.eatSpace()?null:t.extenStart?(e.eatWhile(/[^\s]/),i=e.current(),/^=>?$/.test(i)?(t.extenExten=!0,t.extenStart=!1,"strong"):(t.extenStart=!1,e.skipToEnd(),"error")):t.extenExten?(t.extenExten=!1,t.extenPriority=!0,e.eatWhile(/[^,]/),t.extenInclude&&(e.skipToEnd(),t.extenPriority=!1,t.extenInclude=!1),t.extenSame&&(t.extenPriority=!1,t.extenSame=!1,t.extenApplication=!0),"tag"):t.extenPriority?(t.extenPriority=!1,t.extenApplication=!0,s=e.next(),t.extenSame?null:(e.eatWhile(/[^,]/),"number")):t.extenApplication?(e.eatWhile(/,/),i=e.current(),i===","?null:(e.eatWhile(/\w/),i=e.current().toLowerCase(),t.extenApplication=!1,n.indexOf(i)!==-1?"def strong":null)):r(e,t)}}}),e.defineMIME("text/x-asterisk","asterisk")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/clike/clike",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function r(e,t){if(!t.startOfLine)return!1;for(;;){if(!e.skipTo("\\")){e.skipToEnd(),t.tokenize=null;break}e.next();if(e.eol()){t.tokenize=r;break}}return"meta"}function i(e,t){e.backUp(1);if(e.match(/(R|u8R|uR|UR|LR)/)){var n=e.match(/"([^\s\\()]{0,16})\(/);return n?(t.cpp11RawStringDelim=n[1],t.tokenize=o,o(e,t)):!1}return e.match(/(u8|u|U|L)/)?e.match(/["']/,!1)?"string":!1:(e.next(),!1)}function s(e,t){var n;while((n=e.next())!=null)if(n=='"'&&!e.eat('"')){t.tokenize=null;break}return"string"}function o(e,t){var n=t.cpp11RawStringDelim.replace(/[^\w\s]/g,"\\$&"),r=e.match(new RegExp(".*?\\)"+n+'"'));return r?t.tokenize=null:e.skipToEnd(),"string"}function u(t,n){function i(e){if(e)for(var t in e)e.hasOwnProperty(t)&&r.push(t)}typeof t=="string"&&(t=[t]);var r=[];i(n.keywords),i(n.builtin),i(n.atoms),r.length&&(n.helperType=t[0],e.registerHelper("hintWords",t[0],r));for(var s=0;s<t.length;++s)e.defineMIME(t[s],n)}e.defineMode("clike",function(t,n){function d(e,t){var n=e.next();if(l[n]){var r=l[n](e,t);if(r!==!1)return r}if(n=='"'||n=="'")return t.tokenize=v(n),t.tokenize(e,t);if(/[\[\]{}\(\),;\:\.]/.test(n))return p=n,null;if(/\d/.test(n))return e.eatWhile(/[\w\.]/),"number";if(n=="/"){if(e.eat("*"))return t.tokenize=m,m(e,t);if(e.eat("/"))return e.skipToEnd(),"comment"}if(h.test(n))return e.eatWhile(h),"operator";e.eatWhile(/[\w\$_]/);var i=e.current();return o.propertyIsEnumerable(i)?(a.propertyIsEnumerable(i)&&(p="newstatement"),"keyword"):u.propertyIsEnumerable(i)?(a.propertyIsEnumerable(i)&&(p="newstatement"),"builtin"):f.propertyIsEnumerable(i)?"atom":"variable"}function v(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r&&!c)n.tokenize=null;return"string"}}function m(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=null;break}n=r=="*"}return"comment"}function g(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function y(e,t,n){var r=e.indented;return e.context&&e.context.type=="statement"&&(r=e.context.indented),e.context=new g(r,t,n,null,e.context)}function b(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}var r=t.indentUnit,i=n.statementIndentUnit||r,s=n.dontAlignCalls,o=n.keywords||{},u=n.builtin||{},a=n.blockKeywords||{},f=n.atoms||{},l=n.hooks||{},c=n.multiLineStrings,h=/[+\-*&%=<>!?|\/]/,p;return{startState:function(e){return{tokenize:null,context:new g((e||0)-r,0,"top",!1),indented:0,startOfLine:!0}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0);if(e.eatSpace())return null;p=null;var r=(t.tokenize||d)(e,t);if(r=="comment"||r=="meta")return r;n.align==null&&(n.align=!0);if(p!=";"&&p!=":"&&p!=","||n.type!="statement")if(p=="{")y(t,e.column(),"}");else if(p=="[")y(t,e.column(),"]");else if(p=="(")y(t,e.column(),")");else if(p=="}"){while(n.type=="statement")n=b(t);n.type=="}"&&(n=b(t));while(n.type=="statement")n=b(t)}else p==n.type?b(t):((n.type=="}"||n.type=="top")&&p!=";"||n.type=="statement"&&p=="newstatement")&&y(t,e.column(),"statement");else b(t);return t.startOfLine=!1,r},indent:function(t,n){if(t.tokenize!=d&&t.tokenize!=null)return e.Pass;var o=t.context,u=n&&n.charAt(0);o.type=="statement"&&u=="}"&&(o=o.prev);var a=u==o.type;return o.type=="statement"?o.indented+(u=="{"?0:i):o.align&&(!s||o.type!=")")?o.column+(a?0:1):o.type==")"&&!a?o.indented+i:o.indented+(a?0:r)},electricChars:"{}",blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//",fold:"brace"}});var n="auto if break int case long char register continue return default short do sizeof double static else struct entry switch extern typedef float union for unsigned goto while enum void const signed volatile";u(["text/x-csrc","text/x-c","text/x-chdr"],{name:"clike",keywords:t(n),blockKeywords:t("case do else for if switch while struct"),atoms:t("null"),hooks:{"#":r},modeProps:{fold:["brace","include"]}}),u(["text/x-c++src","text/x-c++hdr"],{name:"clike",keywords:t(n+" asm dynamic_cast namespace reinterpret_cast try bool explicit new "+"static_cast typeid catch operator template typename class friend private "+"this using const_cast inline public throw virtual delete mutable protected "+"wchar_t alignas alignof constexpr decltype nullptr noexcept thread_local final "+"static_assert override"),blockKeywords:t("catch class do else finally for if struct switch try while"),atoms:t("true false null"),hooks:{"#":r,u:i,U:i,L:i,R:i},modeProps:{fold:["brace","include"]}}),u("text/x-java",{name:"clike",keywords:t("abstract assert boolean break byte case catch char class const continue default do double else enum extends final finally float for goto if implements import instanceof int interface long native new package private protected public return short static strictfp super switch synchronized this throw throws transient try void volatile while"),blockKeywords:t("catch class do else finally for if switch try while"),atoms:t("true false null"),hooks:{"@":function(e){return e.eatWhile(/[\w\$_]/),"meta"}},modeProps:{fold:["brace","import"]}}),u("text/x-csharp",{name:"clike",keywords:t("abstract as base break case catch checked class const continue default delegate do else enum event explicit extern finally fixed for foreach goto if implicit in interface internal is lock namespace new operator out override params private protected public readonly ref return sealed sizeof stackalloc static struct switch this throw try typeof unchecked unsafe using virtual void volatile while add alias ascending descending dynamic from get global group into join let orderby partial remove select set value var yield"),blockKeywords:t("catch class do else finally for foreach if struct switch try while"),builtin:t("Boolean Byte Char DateTime DateTimeOffset Decimal Double Guid Int16 Int32 Int64 Object SByte Single String TimeSpan UInt16 UInt32 UInt64 bool byte char decimal double short int long object sbyte float string ushort uint ulong"),atoms:t("true false null"),hooks:{"@":function(e,t){return e.eat('"')?(t.tokenize=s,s(e,t)):(e.eatWhile(/[\w\$_]/),"meta")}}}),u("text/x-scala",{name:"clike",keywords:t("abstract case catch class def do else extends false final finally for forSome if implicit import lazy match new null object override package private protected return sealed super this throw trait try trye type val var while with yield _ : = => <- <: <% >: # @ assert assume require print println printf readLine readBoolean readByte readShort readChar readInt readLong readFloat readDouble AnyVal App Application Array BufferedIterator BigDecimal BigInt Char Console Either Enumeration Equiv Error Exception Fractional Function IndexedSeq Integral Iterable Iterator List Map Numeric Nil NotNull Option Ordered Ordering PartialFunction PartialOrdering Product Proxy Range Responder Seq Serializable Set Specializable Stream StringBuilder StringContext Symbol Throwable Traversable TraversableOnce Tuple Unit Vector :: #:: Boolean Byte Character CharSequence Class ClassLoader Cloneable Comparable Compiler Double Exception Float Integer Long Math Number Object Package Pair Process Runtime Runnable SecurityManager Short StackTraceElement StrictMath String StringBuffer System Thread ThreadGroup ThreadLocal Throwable Triple Void"),blockKeywords:t("catch class do else finally for forSome if match switch try while"),atoms:t("true false null"),hooks:{"@":function(e){return e.eatWhile(/[\w\$_]/),"meta"}}}),u(["x-shader/x-vertex","x-shader/x-fragment"],{name:"clike",keywords:t("float int bool void vec2 vec3 vec4 ivec2 ivec3 ivec4 bvec2 bvec3 bvec4 mat2 mat3 mat4 sampler1D sampler2D sampler3D samplerCube sampler1DShadow sampler2DShadowconst attribute uniform varying break continue discard return for while do if else struct in out inout"),blockKeywords:t("for while do if else struct"),builtin:t("radians degrees sin cos tan asin acos atan pow exp log exp2 sqrt inversesqrt abs sign floor ceil fract mod min max clamp mix step smootstep length distance dot cross normalize ftransform faceforward reflect refract matrixCompMult lessThan lessThanEqual greaterThan greaterThanEqual equal notEqual any all not texture1D texture1DProj texture1DLod texture1DProjLod texture2D texture2DProj texture2DLod texture2DProjLod texture3D texture3DProj texture3DLod texture3DProjLod textureCube textureCubeLod shadow1D shadow2D shadow1DProj shadow2DProj shadow1DLod shadow2DLod shadow1DProjLod shadow2DProjLod dFdx dFdy fwidth noise1 noise2 noise3 noise4"),atoms:t("true false gl_FragColor gl_SecondaryColor gl_Normal gl_Vertex gl_MultiTexCoord0 gl_MultiTexCoord1 gl_MultiTexCoord2 gl_MultiTexCoord3 gl_MultiTexCoord4 gl_MultiTexCoord5 gl_MultiTexCoord6 gl_MultiTexCoord7 gl_FogCoord gl_Position gl_PointSize gl_ClipVertex gl_FrontColor gl_BackColor gl_FrontSecondaryColor gl_BackSecondaryColor gl_TexCoord gl_FogFragCoord gl_FragCoord gl_FrontFacing gl_FragColor gl_FragData gl_FragDepth gl_ModelViewMatrix gl_ProjectionMatrix gl_ModelViewProjectionMatrix gl_TextureMatrix gl_NormalMatrix gl_ModelViewMatrixInverse gl_ProjectionMatrixInverse gl_ModelViewProjectionMatrixInverse gl_TexureMatrixTranspose gl_ModelViewMatrixInverseTranspose gl_ProjectionMatrixInverseTranspose gl_ModelViewProjectionMatrixInverseTranspose gl_TextureMatrixInverseTranspose gl_NormalScale gl_DepthRange gl_ClipPlane gl_Point gl_FrontMaterial gl_BackMaterial gl_LightSource gl_LightModel gl_FrontLightModelProduct gl_BackLightModelProduct gl_TextureColor gl_EyePlaneS gl_EyePlaneT gl_EyePlaneR gl_EyePlaneQ gl_FogParameters gl_MaxLights gl_MaxClipPlanes gl_MaxTextureUnits gl_MaxTextureCoords gl_MaxVertexAttribs gl_MaxVertexUniformComponents gl_MaxVaryingFloats gl_MaxVertexTextureImageUnits gl_MaxTextureImageUnits gl_MaxFragmentUniformComponents gl_MaxCombineTextureImageUnits gl_MaxDrawBuffers"),hooks:{"#":r},modeProps:{fold:["brace","include"]}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/clojure/clojure",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("clojure",function(e){function c(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function g(e,t,n){this.indent=e,this.type=t,this.prev=n}function y(e,t,n){e.indentStack=new g(t,n,e.indentStack)}function b(e){e.indentStack=e.indentStack.prev}function w(e,t){return e==="0"&&t.eat(/x/i)?(t.eatWhile(m.hex),!0):((e=="+"||e=="-")&&m.digit.test(t.peek())&&(t.eat(m.sign),e=t.next()),m.digit.test(e)?(t.eat(e),t.eatWhile(m.digit),"."==t.peek()&&(t.eat("."),t.eatWhile(m.digit)),t.eat(m.exponent)&&(t.eat(m.sign),t.eatWhile(m.digit)),!0):!1)}function E(e){var t=e.next();if(t.match(/[a-z]/)&&e.match(/[a-z]+/,!0))return;t==="u"&&e.match(/[0-9a-z]{4}/i,!0)}var t="builtin",n="comment",r="string",i="string-2",s="atom",o="number",u="bracket",a="keyword",f=e.indentUnit||2,l=e.indentUnit||2,h=c("true false nil"),p=c("defn defn- def def- defonce defmulti defmethod defmacro defstruct deftype defprotocol defrecord defproject deftest slice defalias defhinted defmacro- defn-memo defnk defnk defonce- defunbound defunbound- defvar defvar- let letfn do case cond condp for loop recur when when-not when-let when-first if if-let if-not . .. -> ->> doto and or dosync doseq dotimes dorun doall load import unimport ns in-ns refer try catch finally throw with-open with-local-vars binding gen-class gen-and-load-class gen-and-save-class handler-case handle"),d=c("* *' *1 *2 *3 *agent* *allow-unresolved-vars* *assert* *clojure-version* *command-line-args* *compile-files* *compile-path* *compiler-options* *data-readers* *e *err* *file* *flush-on-newline* *fn-loader* *in* *math-context* *ns* *out* *print-dup* *print-length* *print-level* *print-meta* *print-readably* *read-eval* *source-path* *unchecked-math* *use-context-classloader* *verbose-defrecords* *warn-on-reflection* + +' - -' -> ->> ->ArrayChunk ->Vec ->VecNode ->VecSeq -cache-protocol-fn -reset-methods .. / < <= = == > >= EMPTY-NODE accessor aclone add-classpath add-watch agent agent-error agent-errors aget alength alias all-ns alter alter-meta! alter-var-root amap ancestors and apply areduce array-map aset aset-boolean aset-byte aset-char aset-double aset-float aset-int aset-long aset-short assert assoc assoc! assoc-in associative? atom await await-for await1 bases bean bigdec bigint biginteger binding bit-and bit-and-not bit-clear bit-flip bit-not bit-or bit-set bit-shift-left bit-shift-right bit-test bit-xor boolean boolean-array booleans bound-fn bound-fn* bound? butlast byte byte-array bytes case cast char char-array char-escape-string char-name-string char? chars chunk chunk-append chunk-buffer chunk-cons chunk-first chunk-next chunk-rest chunked-seq? class class? clear-agent-errors clojure-version coll? comment commute comp comparator compare compare-and-set! compile complement concat cond condp conj conj! cons constantly construct-proxy contains? count counted? create-ns create-struct cycle dec dec' decimal? declare default-data-readers definline definterface defmacro defmethod defmulti defn defn- defonce defprotocol defrecord defstruct deftype delay delay? deliver denominator deref derive descendants destructure disj disj! dissoc dissoc! distinct distinct? doall dorun doseq dosync dotimes doto double double-array doubles drop drop-last drop-while empty empty? ensure enumeration-seq error-handler error-mode eval even? every-pred every? ex-data ex-info extend extend-protocol extend-type extenders extends? false? ffirst file-seq filter filterv find find-keyword find-ns find-protocol-impl find-protocol-method find-var first flatten float float-array float? floats flush fn fn? fnext fnil for force format frequencies future future-call future-cancel future-cancelled? future-done? future? gen-class gen-interface gensym get get-in get-method get-proxy-class get-thread-bindings get-validator group-by hash hash-combine hash-map hash-set identical? identity if-let if-not ifn? import in-ns inc inc' init-proxy instance? int int-array integer? interleave intern interpose into into-array ints io! isa? iterate iterator-seq juxt keep keep-indexed key keys keyword keyword? last lazy-cat lazy-seq let letfn line-seq list list* list? load load-file load-reader load-string loaded-libs locking long long-array longs loop macroexpand macroexpand-1 make-array make-hierarchy map map-indexed map? mapcat mapv max max-key memfn memoize merge merge-with meta method-sig methods min min-key mod munge name namespace namespace-munge neg? newline next nfirst nil? nnext not not-any? not-empty not-every? not= ns ns-aliases ns-imports ns-interns ns-map ns-name ns-publics ns-refers ns-resolve ns-unalias ns-unmap nth nthnext nthrest num number? numerator object-array odd? or parents partial partition partition-all partition-by pcalls peek persistent! pmap pop pop! pop-thread-bindings pos? pr pr-str prefer-method prefers primitives-classnames print print-ctor print-dup print-method print-simple print-str printf println println-str prn prn-str promise proxy proxy-call-with-super proxy-mappings proxy-name proxy-super push-thread-bindings pvalues quot rand rand-int rand-nth range ratio? rational? rationalize re-find re-groups re-matcher re-matches re-pattern re-seq read read-line read-string realized? reduce reduce-kv reductions ref ref-history-count ref-max-history ref-min-history ref-set refer refer-clojure reify release-pending-sends rem remove remove-all-methods remove-method remove-ns remove-watch repeat repeatedly replace replicate require reset! reset-meta! resolve rest restart-agent resultset-seq reverse reversible? rseq rsubseq satisfies? second select-keys send send-off seq seq? seque sequence sequential? set set-error-handler! set-error-mode! set-validator! set? short short-array shorts shuffle shutdown-agents slurp some some-fn sort sort-by sorted-map sorted-map-by sorted-set sorted-set-by sorted? special-symbol? spit split-at split-with str string? struct struct-map subs subseq subvec supers swap! symbol symbol? sync take take-last take-nth take-while test the-ns thread-bound? time to-array to-array-2d trampoline transient tree-seq true? type unchecked-add unchecked-add-int unchecked-byte unchecked-char unchecked-dec unchecked-dec-int unchecked-divide-int unchecked-double unchecked-float unchecked-inc unchecked-inc-int unchecked-int unchecked-long unchecked-multiply unchecked-multiply-int unchecked-negate unchecked-negate-int unchecked-remainder-int unchecked-short unchecked-subtract unchecked-subtract-int underive unquote unquote-splicing update-in update-proxy use val vals var-get var-set var? vary-meta vec vector vector-of vector? when when-first when-let when-not while with-bindings with-bindings* with-in-str with-loading-context with-local-vars with-meta with-open with-out-str with-precision with-redefs with-redefs-fn xml-seq zero? zipmap *default-data-reader-fn* as-> cond-> cond->> reduced reduced? send-via set-agent-send-executor! set-agent-send-off-executor! some-> some->>"),v=c("ns fn def defn defmethod bound-fn if if-not case condp when while when-not when-first do future comment doto locking proxy with-open with-precision reify deftype defrecord defprotocol extend extend-protocol extend-type try catch let letfn binding loop for doseq dotimes when-let if-let defstruct struct-map assoc testing deftest handler-case handle dotrace deftrace"),m={digit:/\d/,digit_or_colon:/[\d:]/,hex:/[0-9a-f]/i,sign:/[+-]/,exponent:/e/i,keyword_char:/[^\s\(\[\;\)\]]/,symbol:/[\w*+!\-\._?:<>\/]/};return{startState:function(){return{indentStack:null,indentation:0,mode:!1}},token:function(e,c){c.indentStack==null&&e.sol()&&(c.indentation=e.indentation());if(e.eatSpace())return null;var g=null;switch(c.mode){case"string":var S,x=!1;while((S=e.next())!=null){if(S=='"'&&!x){c.mode=!1;break}x=!x&&S=="\\"}g=r;break;default:var T=e.next();if(T=='"')c.mode="string",g=r;else if(T=="\\")E(e),g=i;else if(T=="'"&&!m.digit_or_colon.test(e.peek()))g=s;else if(T==";")e.skipToEnd(),g=n;else if(w(T,e))g=o;else if(T=="("||T=="["||T=="{"){var N="",C=e.column(),k;if(T=="(")while((k=e.eat(m.keyword_char))!=null)N+=k;N.length>0&&(v.propertyIsEnumerable(N)||/^(?:def|with)/.test(N))?y(c,C+f,T):(e.eatSpace(),e.eol()||e.peek()==";"?y(c,C+l,T):y(c,C+e.current().length,T)),e.backUp(e.current().length-1),g=u}else if(T==")"||T=="]"||T=="}")g=u,c.indentStack!=null&&c.indentStack.type==(T==")"?"(":T=="]"?"[":"{")&&b(c);else{if(T==":")return e.eatWhile(m.symbol),s;e.eatWhile(m.symbol),p&&p.propertyIsEnumerable(e.current())?g=a:d&&d.propertyIsEnumerable(e.current())?g=t:h&&h.propertyIsEnumerable(e.current())?g=s:g=null}}return g},indent:function(e){return e.indentStack==null?e.indentation:e.indentStack.indent},lineComment:";;"}}),e.defineMIME("text/x-clojure","clojure")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/cobol/cobol",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("cobol",function(){function f(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function d(e,t){return e==="0"&&t.eat(/x/i)?(t.eatWhile(p.hex),!0):((e=="+"||e=="-")&&p.digit.test(t.peek())&&(t.eat(p.sign),e=t.next()),p.digit.test(e)?(t.eat(e),t.eatWhile(p.digit),"."==t.peek()&&(t.eat("."),t.eatWhile(p.digit)),t.eat(p.exponent)&&(t.eat(p.sign),t.eatWhile(p.digit)),!0):!1)}var e="builtin",t="comment",n="string",r="atom",i="number",s="keyword",o="header",u="def",a="link",l=f("TRUE FALSE ZEROES ZEROS ZERO SPACES SPACE LOW-VALUE LOW-VALUES "),c=f("ACCEPT ACCESS ACQUIRE ADD ADDRESS ADVANCING AFTER ALIAS ALL ALPHABET ALPHABETIC ALPHABETIC-LOWER ALPHABETIC-UPPER ALPHANUMERIC ALPHANUMERIC-EDITED ALSO ALTER ALTERNATE AND ANY ARE AREA AREAS ARITHMETIC ASCENDING ASSIGN AT ATTRIBUTE AUTHOR AUTO AUTO-SKIP AUTOMATIC B-AND B-EXOR B-LESS B-NOT B-OR BACKGROUND-COLOR BACKGROUND-COLOUR BEEP BEFORE BELL BINARY BIT BITS BLANK BLINK BLOCK BOOLEAN BOTTOM BY CALL CANCEL CD CF CH CHARACTER CHARACTERS CLASS CLOCK-UNITS CLOSE COBOL CODE CODE-SET COL COLLATING COLUMN COMMA COMMIT COMMITMENT COMMON COMMUNICATION COMP COMP-0 COMP-1 COMP-2 COMP-3 COMP-4 COMP-5 COMP-6 COMP-7 COMP-8 COMP-9 COMPUTATIONAL COMPUTATIONAL-0 COMPUTATIONAL-1 COMPUTATIONAL-2 COMPUTATIONAL-3 COMPUTATIONAL-4 COMPUTATIONAL-5 COMPUTATIONAL-6 COMPUTATIONAL-7 COMPUTATIONAL-8 COMPUTATIONAL-9 COMPUTE CONFIGURATION CONNECT CONSOLE CONTAINED CONTAINS CONTENT CONTINUE CONTROL CONTROL-AREA CONTROLS CONVERTING COPY CORR CORRESPONDING COUNT CRT CRT-UNDER CURRENCY CURRENT CURSOR DATA DATE DATE-COMPILED DATE-WRITTEN DAY DAY-OF-WEEK DB DB-ACCESS-CONTROL-KEY DB-DATA-NAME DB-EXCEPTION DB-FORMAT-NAME DB-RECORD-NAME DB-SET-NAME DB-STATUS DBCS DBCS-EDITED DE DEBUG-CONTENTS DEBUG-ITEM DEBUG-LINE DEBUG-NAME DEBUG-SUB-1 DEBUG-SUB-2 DEBUG-SUB-3 DEBUGGING DECIMAL-POINT DECLARATIVES DEFAULT DELETE DELIMITED DELIMITER DEPENDING DESCENDING DESCRIBED DESTINATION DETAIL DISABLE DISCONNECT DISPLAY DISPLAY-1 DISPLAY-2 DISPLAY-3 DISPLAY-4 DISPLAY-5 DISPLAY-6 DISPLAY-7 DISPLAY-8 DISPLAY-9 DIVIDE DIVISION DOWN DROP DUPLICATE DUPLICATES DYNAMIC EBCDIC EGI EJECT ELSE EMI EMPTY EMPTY-CHECK ENABLE END END. END-ACCEPT END-ACCEPT. END-ADD END-CALL END-COMPUTE END-DELETE END-DISPLAY END-DIVIDE END-EVALUATE END-IF END-INVOKE END-MULTIPLY END-OF-PAGE END-PERFORM END-READ END-RECEIVE END-RETURN END-REWRITE END-SEARCH END-START END-STRING END-SUBTRACT END-UNSTRING END-WRITE END-XML ENTER ENTRY ENVIRONMENT EOP EQUAL EQUALS ERASE ERROR ESI EVALUATE EVERY EXCEEDS EXCEPTION EXCLUSIVE EXIT EXTEND EXTERNAL EXTERNALLY-DESCRIBED-KEY FD FETCH FILE FILE-CONTROL FILE-STREAM FILES FILLER FINAL FIND FINISH FIRST FOOTING FOR FOREGROUND-COLOR FOREGROUND-COLOUR FORMAT FREE FROM FULL FUNCTION GENERATE GET GIVING GLOBAL GO GOBACK GREATER GROUP HEADING HIGH-VALUE HIGH-VALUES HIGHLIGHT I-O I-O-CONTROL ID IDENTIFICATION IF IN INDEX INDEX-1 INDEX-2 INDEX-3 INDEX-4 INDEX-5 INDEX-6 INDEX-7 INDEX-8 INDEX-9 INDEXED INDIC INDICATE INDICATOR INDICATORS INITIAL INITIALIZE INITIATE INPUT INPUT-OUTPUT INSPECT INSTALLATION INTO INVALID INVOKE IS JUST JUSTIFIED KANJI KEEP KEY LABEL LAST LD LEADING LEFT LEFT-JUSTIFY LENGTH LENGTH-CHECK LESS LIBRARY LIKE LIMIT LIMITS LINAGE LINAGE-COUNTER LINE LINE-COUNTER LINES LINKAGE LOCAL-STORAGE LOCALE LOCALLY LOCK MEMBER MEMORY MERGE MESSAGE METACLASS MODE MODIFIED MODIFY MODULES MOVE MULTIPLE MULTIPLY NATIONAL NATIVE NEGATIVE NEXT NO NO-ECHO NONE NOT NULL NULL-KEY-MAP NULL-MAP NULLS NUMBER NUMERIC NUMERIC-EDITED OBJECT OBJECT-COMPUTER OCCURS OF OFF OMITTED ON ONLY OPEN OPTIONAL OR ORDER ORGANIZATION OTHER OUTPUT OVERFLOW OWNER PACKED-DECIMAL PADDING PAGE PAGE-COUNTER PARSE PERFORM PF PH PIC PICTURE PLUS POINTER POSITION POSITIVE PREFIX PRESENT PRINTING PRIOR PROCEDURE PROCEDURE-POINTER PROCEDURES PROCEED PROCESS PROCESSING PROGRAM PROGRAM-ID PROMPT PROTECTED PURGE QUEUE QUOTE QUOTES RANDOM RD READ READY REALM RECEIVE RECONNECT RECORD RECORD-NAME RECORDS RECURSIVE REDEFINES REEL REFERENCE REFERENCE-MONITOR REFERENCES RELATION RELATIVE RELEASE REMAINDER REMOVAL RENAMES REPEATED REPLACE REPLACING REPORT REPORTING REPORTS REPOSITORY REQUIRED RERUN RESERVE RESET RETAINING RETRIEVAL RETURN RETURN-CODE RETURNING REVERSE-VIDEO REVERSED REWIND REWRITE RF RH RIGHT RIGHT-JUSTIFY ROLLBACK ROLLING ROUNDED RUN SAME SCREEN SD SEARCH SECTION SECURE SECURITY SEGMENT SEGMENT-LIMIT SELECT SEND SENTENCE SEPARATE SEQUENCE SEQUENTIAL SET SHARED SIGN SIZE SKIP1 SKIP2 SKIP3 SORT SORT-MERGE SORT-RETURN SOURCE SOURCE-COMPUTER SPACE-FILL SPECIAL-NAMES STANDARD STANDARD-1 STANDARD-2 START STARTING STATUS STOP STORE STRING SUB-QUEUE-1 SUB-QUEUE-2 SUB-QUEUE-3 SUB-SCHEMA SUBFILE SUBSTITUTE SUBTRACT SUM SUPPRESS SYMBOLIC SYNC SYNCHRONIZED SYSIN SYSOUT TABLE TALLYING TAPE TENANT TERMINAL TERMINATE TEST TEXT THAN THEN THROUGH THRU TIME TIMES TITLE TO TOP TRAILING TRAILING-SIGN TRANSACTION TYPE TYPEDEF UNDERLINE UNEQUAL UNIT UNSTRING UNTIL UP UPDATE UPON USAGE USAGE-MODE USE USING VALID VALIDATE VALUE VALUES VARYING VLR WAIT WHEN WHEN-COMPILED WITH WITHIN WORDS WORKING-STORAGE WRITE XML XML-CODE XML-EVENT XML-NTEXT XML-TEXT ZERO ZERO-FILL "),h=f("- * ** / + < <= = > >= "),p={digit:/\d/,digit_or_colon:/[\d:]/,hex:/[0-9a-f]/i,sign:/[+-]/,exponent:/e/i,keyword_char:/[^\s\(\[\;\)\]]/,symbol:/[\w*+\-]/};return{startState:function(){return{indentStack:null,indentation:0,mode:!1}},token:function(f,v){v.indentStack==null&&f.sol()&&(v.indentation=6);if(f.eatSpace())return null;var m=null;switch(v.mode){case"string":var g=!1;while((g=f.next())!=null)if(g=='"'||g=="'"){v.mode=!1;break}m=n;break;default:var y=f.next(),b=f.column();if(b>=0&&b<=5)m=u;else if(b>=72&&b<=79)f.skipToEnd(),m=o;else if(y=="*"&&b==6)f.skipToEnd(),m=t;else if(y=='"'||y=="'")v.mode="string",m=n;else if(y=="'"&&!p.digit_or_colon.test(f.peek()))m=r;else if(y==".")m=a;else if(d(y,f))m=i;else{if(f.current().match(p.symbol))while(b<71){if(f.eat(p.symbol)===undefined)break;b++}c&&c.propertyIsEnumerable(f.current().toUpperCase())?m=s:h&&h.propertyIsEnumerable(f.current().toUpperCase())?m=e:l&&l.propertyIsEnumerable(f.current().toUpperCase())?m=r:m=null}}return m},indent:function(e){return e.indentStack==null?e.indentation:e.indentStack.indent}}}),e.defineMIME("text/x-cobol","cobol")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/coffeescript/coffeescript",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("coffeescript",function(e){function n(e){return new RegExp("^(("+e.join(")|(")+"))\\b")}function v(e,n){if(e.sol()){n.scope.align===null&&(n.scope.align=!1);var a=n.scope.offset;if(e.eatSpace()){var f=e.indentation();return f>a&&n.scope.type=="coffee"?"indent":f<a?"dedent":null}a>0&&b(e,n)}if(e.eatSpace())return null;var p=e.peek();if(e.match("####"))return e.skipToEnd(),"comment";if(e.match("###"))return n.tokenize=g,n.tokenize(e,n);if(p==="#")return e.skipToEnd(),"comment";if(e.match(/^-?[0-9\.]/,!1)){var v=!1;e.match(/^-?\d*\.\d+(e[\+\-]?\d+)?/i)&&(v=!0),e.match(/^-?\d+\.\d*/)&&(v=!0),e.match(/^-?\.\d+/)&&(v=!0);if(v)return e.peek()=="."&&e.backUp(1),"number";var y=!1;e.match(/^-?0x[0-9a-f]+/i)&&(y=!0),e.match(/^-?[1-9]\d*(e[\+\-]?\d+)?/)&&(y=!0),e.match(/^-?0(?![\dx])/i)&&(y=!0);if(y)return"number"}if(e.match(c))return n.tokenize=m(e.current(),!1,"string"),n.tokenize(e,n);if(e.match(h)){if(e.current()!="/"||e.match(/^.*\//,!1))return n.tokenize=m(e.current(),!0,"string-2"),n.tokenize(e,n);e.backUp(1)}return e.match(r)||e.match(u)?"operator":e.match(i)?"punctuation":e.match(d)?"atom":e.match(l)?"keyword":e.match(s)?"variable":e.match(o)?"property":(e.next(),t)}function m(n,r,i){return function(s,o){while(!s.eol()){s.eatWhile(/[^'"\/\\]/);if(s.eat("\\")){s.next();if(r&&s.eol())return i}else{if(s.match(n))return o.tokenize=v,i;s.eat(/['"\/]/)}}return r&&(e.mode.singleLineStringErrors?i=t:o.tokenize=v),i}}function g(e,t){while(!e.eol()){e.eatWhile(/[^#]/);if(e.match("###")){t.tokenize=v;break}e.eatWhile("#")}return"comment"}function y(t,n,r){r=r||"coffee";var i=0,s=!1,o=null;for(var u=n.scope;u;u=u.prev)if(u.type==="coffee"){i=u.offset+e.indentUnit;break}r!=="coffee"?(s=null,o=t.column()+t.current().length):n.scope.align&&(n.scope.align=!1),n.scope={offset:i,type:r,prev:n.scope,align:s,alignOffset:o}}function b(e,t){if(!t.scope.prev)return;if(t.scope.type==="coffee"){var n=e.indentation(),r=!1;for(var i=t.scope;i;i=i.prev)if(n===i.offset){r=!0;break}if(!r)return!0;while(t.scope.prev&&t.scope.offset!==n)t.scope=t.scope.prev;return!1}return t.scope=t.scope.prev,!1}function w(e,n){var r=n.tokenize(e,n),i=e.current();if(i===".")return r=n.tokenize(e,n),i=e.current(),/^\.[\w$]+$/.test(i)?"variable":t;i==="return"&&(n.dedent+=1),((i==="->"||i==="=>")&&!n.lambda&&!e.peek()||r==="indent")&&y(e,n);var s="[({".indexOf(i);s!==-1&&y(e,n,"])}".slice(s,s+1)),a.exec(i)&&y(e,n),i=="then"&&b(e,n);if(r==="dedent"&&b(e,n))return t;s="])}".indexOf(i);if(s!==-1){while(n.scope.type=="coffee"&&n.scope.prev)n.scope=n.scope.prev;n.scope.type==i&&(n.scope=n.scope.prev)}return n.dedent>0&&e.eol()&&n.scope.type=="coffee"&&(n.scope.prev&&(n.scope=n.scope.prev),n.dedent-=1),r}var t="error",r=/^(?:->|=>|\+[+=]?|-[\-=]?|\*[\*=]?|\/[\/=]?|[=!]=|<[><]?=?|>>?=?|%=?|&=?|\|=?|\^=?|\~|!|\?)/,i=/^(?:[()\[\]{},:`=;]|\.\.?\.?)/,s=/^[_A-Za-z$][_A-Za-z$0-9]*/,o=/^(@|this\.)[_A-Za-z$][_A-Za-z$0-9]*/,u=n(["and","or","not","is","isnt","in","instanceof","typeof"]),a=["for","while","loop","if","unless","else","switch","try","catch","finally","class"],f=["break","by","continue","debugger","delete","do","in","of","new","return","then","this","throw","when","until"],l=n(a.concat(f));a=n(a);var c=/^('{3}|\"{3}|['\"])/,h=/^(\/{3}|\/)/,p=["Infinity","NaN","undefined","null","true","false","on","off","yes","no"],d=n(p),E={startState:function(e){return{tokenize:v,scope:{offset:e||0,type:"coffee",prev:null,align:!1},lastToken:null,lambda:!1,dedent:0}},token:function(e,t){var n=t.scope.align===null&&t.scope;n&&e.sol()&&(n.align=!1);var r=w(e,t);return n&&r&&r!="comment"&&(n.align=!0),t.lastToken={style:r,content:e.current()},e.eol()&&e.lambda&&(t.lambda=!1),r},indent:function(e,t){if(e.tokenize!=v)return 0;var n=e.scope,r=t&&"])}".indexOf(t.charAt(0))>-1;if(r)while(n.type=="coffee"&&n.prev)n=n.prev;var i=r&&n.type===t.charAt(0);return n.align?n.alignOffset-(i?1:0):(i?n.prev:n).offset},lineComment:"#",fold:"indent"};return E}),e.defineMIME("text/x-coffeescript","coffeescript")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/commonlisp/commonlisp",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("commonlisp",function(e){function s(e){var t;while(t=e.next())if(t=="\\")e.next();else if(!r.test(t)){e.backUp(1);break}return e.current()}function o(e,t){if(e.eatSpace())return i="ws",null;if(e.match(n))return"number";var r=e.next();r=="\\"&&(r=e.next());if(r=='"')return(t.tokenize=u)(e,t);if(r=="(")return i="open","bracket";if(r==")"||r=="]")return i="close","bracket";if(r==";")return e.skipToEnd(),i="ws","comment";if(/['`,@]/.test(r))return null;if(r=="|")return e.skipTo("|")?(e.next(),"symbol"):(e.skipToEnd(),"error");if(r=="#"){var r=e.next();return r=="["?(i="open","bracket"):/[+\-=\.']/.test(r)?null:/\d/.test(r)&&e.match(/^\d*#/)?null:r=="|"?(t.tokenize=a)(e,t):r==":"?(s(e),"meta"):"error"}var o=s(e);return o=="."?null:(i="symbol",o=="nil"||o=="t"?"atom":o.charAt(0)==":"?"keyword":o.charAt(0)=="&"?"variable-2":"variable")}function u(e,t){var n=!1,r;while(r=e.next()){if(r=='"'&&!n){t.tokenize=o;break}n=!n&&r=="\\"}return"string"}function a(e,t){var n,r;while(n=e.next()){if(n=="#"&&r=="|"){t.tokenize=o;break}r=n}return i="ws","comment"}var t=/^with|^def|^do|^prog|case$|^cond$|bind$|when$|unless$/,n=/^(?:[+\-]?(?:\d+|\d*\.\d+)(?:[efd][+\-]?\d+)?|[+\-]?\d+(?:\/[+\-]?\d+)?|#b[+\-]?[01]+|#o[+\-]?[0-7]+|#x[+\-]?[\da-f]+)/,r=/[^\s'`,@()\[\]";]/,i;return{startState:function(){return{ctx:{prev:null,start:0,indentTo:0},tokenize:o}},token:function(n,r){n.sol()&&typeof r.ctx.indentTo!="number"&&(r.ctx.indentTo=r.ctx.start+1),i=null;var s=r.tokenize(n,r);return i!="ws"&&(r.ctx.indentTo==null?i=="symbol"&&t.test(n.current())?r.ctx.indentTo=r.ctx.start+e.indentUnit:r.ctx.indentTo="next":r.ctx.indentTo=="next"&&(r.ctx.indentTo=n.column())),i=="open"?r.ctx={prev:r.ctx,start:n.column(),indentTo:null}:i=="close"&&(r.ctx=r.ctx.prev||r.ctx),s},indent:function(e,t){var n=e.ctx.indentTo;return typeof n=="number"?n:e.ctx.start+1},lineComment:";;",blockCommentStart:"#|",blockCommentEnd:"|#"}}),e.defineMIME("text/x-common-lisp","commonlisp")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/css/css",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e){var t={};for(var n=0;n<e.length;++n)t[e[n]]=!0;return t}function m(e,t){var n=!1,r;while((r=e.next())!=null){if(n&&r=="/"){t.tokenize=null;break}n=r=="*"}return["comment","comment"]}function g(e,t){return e.skipTo("-->")?(e.match("-->"),t.tokenize=null):e.skipToEnd(),["comment","comment"]}e.defineMode("css",function(t,n){function v(e,t){return p=t,e}function m(e,t){var n=e.next();if(i[n]){var r=i[n](e,t);if(r!==!1)return r}if(n=="@")return e.eatWhile(/[\w\\\-]/),v("def",e.current());if(n=="="||(n=="~"||n=="|")&&e.eat("="))return v(null,"compare");if(n=='"'||n=="'")return t.tokenize=g(n),t.tokenize(e,t);if(n=="#")return e.eatWhile(/[\w\\\-]/),v("atom","hash");if(n=="!")return e.match(/^\s*\w*/),v("keyword","important");if(/\d/.test(n)||n=="."&&e.eat(/\d/))return e.eatWhile(/[\w.%]/),v("number","unit");if(n!=="-")return/[,+>*\/]/.test(n)?v(null,"select-op"):n=="."&&e.match(/^-?[_a-z][_a-z0-9-]*/i)?v("qualifier","qualifier"):/[:;{}\[\]\(\)]/.test(n)?v(null,n):n=="u"&&e.match("rl(")?(e.backUp(1),t.tokenize=y,v("property","word")):/[\w\\\-]/.test(n)?(e.eatWhile(/[\w\\\-]/),v("property","word")):v(null,null);if(/[\d.]/.test(e.peek()))return e.eatWhile(/[\w.%]/),v("number","unit");if(e.match(/^\w+-/))return v("meta","meta")}function g(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r){e==")"&&t.backUp(1);break}r=!r&&i=="\\"}if(i==e||!r&&e!=")")n.tokenize=null;return v("string","string")}}function y(e,t){return e.next(),e.match(/\s*[\"\')]/,!1)?t.tokenize=null:t.tokenize=g(")"),v(null,"(")}function b(e,t,n){this.type=e,this.indent=t,this.prev=n}function w(e,t,n){return e.context=new b(n,t.indentation()+r,e.context),n}function E(e){return e.context=e.context.prev,e.context.type}function S(e,t,n){return N[n.context.type](e,t,n)}function x(e,t,n,r){for(var i=r||1;i>0;i--)n.context=n.context.prev;return S(e,t,n)}function T(e){var t=e.current().toLowerCase();l.hasOwnProperty(t)?d="atom":f.hasOwnProperty(t)?d="keyword":d="variable"}n.propertyKeywords||(n=e.resolveMode("text/css"));var r=t.indentUnit,i=n.tokenHooks,s=n.mediaTypes||{},o=n.mediaFeatures||{},u=n.propertyKeywords||{},a=n.nonStandardPropertyKeywords||{},f=n.colorKeywords||{},l=n.valueKeywords||{},c=n.fontProperties||{},h=n.allowNested,p,d,N={};return N.top=function(e,t,n){if(e=="{")return w(n,t,"block");if(e=="}"&&n.context.prev)return E(n);if(e=="@media")return w(n,t,"media");if(e=="@font-face")return"font_face_before";if(/^@(-(moz|ms|o|webkit)-)?keyframes$/.test(e))return"keyframes";if(e&&e.charAt(0)=="@")return w(n,t,"at");if(e=="hash")d="builtin";else if(e=="word")d="tag";else{if(e=="variable-definition")return"maybeprop";if(e=="interpolation")return w(n,t,"interpolation");if(e==":")return"pseudo";if(h&&e=="(")return w(n,t,"parens")}return n.context.type},N.block=function(e,t,n){if(e=="word"){var r=t.current().toLowerCase();return u.hasOwnProperty(r)?(d="property","maybeprop"):a.hasOwnProperty(r)?(d="string-2","maybeprop"):h?(d=t.match(/^\s*:/,!1)?"property":"tag","block"):(d+=" error","maybeprop")}return e=="meta"?"block":!!h||e!="hash"&&e!="qualifier"?N.top(e,t,n):(d="error","block")},N.maybeprop=function(e,t,n){return e==":"?w(n,t,"prop"):S(e,t,n)},N.prop=function(e,t,n){if(e==";")return E(n);if(e=="{"&&h)return w(n,t,"propBlock");if(e=="}"||e=="{")return x(e,t,n);if(e=="(")return w(n,t,"parens");if(e=="hash"&&!/^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/.test(t.current()))d+=" error";else if(e=="word")T(t);else if(e=="interpolation")return w(n,t,"interpolation");return"prop"},N.propBlock=function(e,t,n){return e=="}"?E(n):e=="word"?(d="property","maybeprop"):n.context.type},N.parens=function(e,t,n){return e=="{"||e=="}"?x(e,t,n):e==")"?E(n):e=="("?w(n,t,"parens"):(e=="word"&&T(t),"parens")},N.pseudo=function(e,t,n){return e=="word"?(d="variable-3",n.context.type):S(e,t,n)},N.media=function(e,t,n){if(e=="(")return w(n,t,"media_parens");if(e=="}")return x(e,t,n);if(e=="{")return E(n)&&w(n,t,h?"block":"top");if(e=="word"){var r=t.current().toLowerCase();r=="only"||r=="not"||r=="and"?d="keyword":s.hasOwnProperty(r)?d="attribute":o.hasOwnProperty(r)?d="property":d="error"}return n.context.type},N.media_parens=function(e,t,n){return e==")"?E(n):e=="{"||e=="}"?x(e,t,n,2):N.media(e,t,n)},N.font_face_before=function(e,t,n){return e=="{"?w(n,t,"font_face"):S(e,t,n)},N.font_face=function(e,t,n){return e=="}"?E(n):e=="word"?(c.hasOwnProperty(t.current().toLowerCase())?d="property":d="error","maybeprop"):"font_face"},N.keyframes=function(e,t,n){return e=="word"?(d="variable","keyframes"):e=="{"?w(n,t,"top"):S(e,t,n)},N.at=function(e,t,n){return e==";"?E(n):e=="{"||e=="}"?x(e,t,n):(e=="word"?d="tag":e=="hash"&&(d="builtin"),"at")},N.interpolation=function(e,t,n){return e=="}"?E(n):e=="{"||e==";"?x(e,t,n):(e!="variable"&&(d="error"),"interpolation")},{startState:function(e){return{tokenize:null,state:"top",context:new b("top",e||0,null)}},token:function(e,t){if(!t.tokenize&&e.eatSpace())return null;var n=(t.tokenize||m)(e,t);return n&&typeof n=="object"&&(p=n[1],n=n[0]),d=n,t.state=N[t.state](p,e,t),d},indent:function(e,t){var n=e.context,i=t&&t.charAt(0),s=n.indent;return n.type=="prop"&&(i=="}"||i==")")&&(n=n.prev),n.prev&&(i=="}"&&(n.type=="block"||n.type=="top"||n.type=="interpolation"||n.type=="font_face")||i==")"&&(n.type=="parens"||n.type=="media_parens")||i=="{"&&(n.type=="at"||n.type=="media"))&&(s=n.indent-r,n=n.prev),s},electricChars:"}",blockCommentStart:"/*",blockCommentEnd:"*/",fold:"brace"}});var n=["all","aural","braille","handheld","print","projection","screen","tty","tv","embossed"],r=t(n),i=["width","min-width","max-width","height","min-height","max-height","device-width","min-device-width","max-device-width","device-height","min-device-height","max-device-height","aspect-ratio","min-aspect-ratio","max-aspect-ratio","device-aspect-ratio","min-device-aspect-ratio","max-device-aspect-ratio","color","min-color","max-color","color-index","min-color-index","max-color-index","monochrome","min-monochrome","max-monochrome","resolution","min-resolution","max-resolution","scan","grid"],s=t(i),o=["align-content","align-items","align-self","alignment-adjust","alignment-baseline","anchor-point","animation","animation-delay","animation-direction","animation-duration","animation-fill-mode","animation-iteration-count","animation-name","animation-play-state","animation-timing-function","appearance","azimuth","backface-visibility","background","background-attachment","background-clip","background-color","background-image","background-origin","background-position","background-repeat","background-size","baseline-shift","binding","bleed","bookmark-label","bookmark-level","bookmark-state","bookmark-target","border","border-bottom","border-bottom-color","border-bottom-left-radius","border-bottom-right-radius","border-bottom-style","border-bottom-width","border-collapse","border-color","border-image","border-image-outset","border-image-repeat","border-image-slice","border-image-source","border-image-width","border-left","border-left-color","border-left-style","border-left-width","border-radius","border-right","border-right-color","border-right-style","border-right-width","border-spacing","border-style","border-top","border-top-color","border-top-left-radius","border-top-right-radius","border-top-style","border-top-width","border-width","bottom","box-decoration-break","box-shadow","box-sizing","break-after","break-before","break-inside","caption-side","clear","clip","color","color-profile","column-count","column-fill","column-gap","column-rule","column-rule-color","column-rule-style","column-rule-width","column-span","column-width","columns","content","counter-increment","counter-reset","crop","cue","cue-after","cue-before","cursor","direction","display","dominant-baseline","drop-initial-after-adjust","drop-initial-after-align","drop-initial-before-adjust","drop-initial-before-align","drop-initial-size","drop-initial-value","elevation","empty-cells","fit","fit-position","flex","flex-basis","flex-direction","flex-flow","flex-grow","flex-shrink","flex-wrap","float","float-offset","flow-from","flow-into","font","font-feature-settings","font-family","font-kerning","font-language-override","font-size","font-size-adjust","font-stretch","font-style","font-synthesis","font-variant","font-variant-alternates","font-variant-caps","font-variant-east-asian","font-variant-ligatures","font-variant-numeric","font-variant-position","font-weight","grid","grid-area","grid-auto-columns","grid-auto-flow","grid-auto-position","grid-auto-rows","grid-column","grid-column-end","grid-column-start","grid-row","grid-row-end","grid-row-start","grid-template","grid-template-areas","grid-template-columns","grid-template-rows","hanging-punctuation","height","hyphens","icon","image-orientation","image-rendering","image-resolution","inline-box-align","justify-content","left","letter-spacing","line-break","line-height","line-stacking","line-stacking-ruby","line-stacking-shift","line-stacking-strategy","list-style","list-style-image","list-style-position","list-style-type","margin","margin-bottom","margin-left","margin-right","margin-top","marker-offset","marks","marquee-direction","marquee-loop","marquee-play-count","marquee-speed","marquee-style","max-height","max-width","min-height","min-width","move-to","nav-down","nav-index","nav-left","nav-right","nav-up","object-fit","object-position","opacity","order","orphans","outline","outline-color","outline-offset","outline-style","outline-width","overflow","overflow-style","overflow-wrap","overflow-x","overflow-y","padding","padding-bottom","padding-left","padding-right","padding-top","page","page-break-after","page-break-before","page-break-inside","page-policy","pause","pause-after","pause-before","perspective","perspective-origin","pitch","pitch-range","play-during","position","presentation-level","punctuation-trim","quotes","region-break-after","region-break-before","region-break-inside","region-fragment","rendering-intent","resize","rest","rest-after","rest-before","richness","right","rotation","rotation-point","ruby-align","ruby-overhang","ruby-position","ruby-span","shape-image-threshold","shape-inside","shape-margin","shape-outside","size","speak","speak-as","speak-header","speak-numeral","speak-punctuation","speech-rate","stress","string-set","tab-size","table-layout","target","target-name","target-new","target-position","text-align","text-align-last","text-decoration","text-decoration-color","text-decoration-line","text-decoration-skip","text-decoration-style","text-emphasis","text-emphasis-color","text-emphasis-position","text-emphasis-style","text-height","text-indent","text-justify","text-outline","text-overflow","text-shadow","text-size-adjust","text-space-collapse","text-transform","text-underline-position","text-wrap","top","transform","transform-origin","transform-style","transition","transition-delay","transition-duration","transition-property","transition-timing-function","unicode-bidi","vertical-align","visibility","voice-balance","voice-duration","voice-family","voice-pitch","voice-range","voice-rate","voice-stress","voice-volume","volume","white-space","widows","width","word-break","word-spacing","word-wrap","z-index","clip-path","clip-rule","mask","enable-background","filter","flood-color","flood-opacity","lighting-color","stop-color","stop-opacity","pointer-events","color-interpolation","color-interpolation-filters","color-rendering","fill","fill-opacity","fill-rule","image-rendering","marker","marker-end","marker-mid","marker-start","shape-rendering","stroke","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke-width","text-rendering","baseline-shift","dominant-baseline","glyph-orientation-horizontal","glyph-orientation-vertical","text-anchor","writing-mode"],u=t(o),a=["scrollbar-arrow-color","scrollbar-base-color","scrollbar-dark-shadow-color","scrollbar-face-color","scrollbar-highlight-color","scrollbar-shadow-color","scrollbar-3d-light-color","scrollbar-track-color","shape-inside","searchfield-cancel-button","searchfield-decoration","searchfield-results-button","searchfield-results-decoration","zoom"],a=t(a),f=["aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgreen","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","grey","green","greenyellow","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgray","lightgreen","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen"],l=t(f),c=["above","absolute","activeborder","activecaption","afar","after-white-space","ahead","alias","all","all-scroll","alternate","always","amharic","amharic-abegede","antialiased","appworkspace","arabic-indic","armenian","asterisks","auto","avoid","avoid-column","avoid-page","avoid-region","background","backwards","baseline","below","bidi-override","binary","bengali","blink","block","block-axis","bold","bolder","border","border-box","both","bottom","break","break-all","break-word","button","button-bevel","buttonface","buttonhighlight","buttonshadow","buttontext","cambodian","capitalize","caps-lock-indicator","caption","captiontext","caret","cell","center","checkbox","circle","cjk-earthly-branch","cjk-heavenly-stem","cjk-ideographic","clear","clip","close-quote","col-resize","collapse","column","compact","condensed","contain","content","content-box","context-menu","continuous","copy","cover","crop","cross","crosshair","currentcolor","cursive","dashed","decimal","decimal-leading-zero","default","default-button","destination-atop","destination-in","destination-out","destination-over","devanagari","disc","discard","document","dot-dash","dot-dot-dash","dotted","double","down","e-resize","ease","ease-in","ease-in-out","ease-out","element","ellipse","ellipsis","embed","end","ethiopic","ethiopic-abegede","ethiopic-abegede-am-et","ethiopic-abegede-gez","ethiopic-abegede-ti-er","ethiopic-abegede-ti-et","ethiopic-halehame-aa-er","ethiopic-halehame-aa-et","ethiopic-halehame-am-et","ethiopic-halehame-gez","ethiopic-halehame-om-et","ethiopic-halehame-sid-et","ethiopic-halehame-so-et","ethiopic-halehame-ti-er","ethiopic-halehame-ti-et","ethiopic-halehame-tig","ew-resize","expanded","extra-condensed","extra-expanded","fantasy","fast","fill","fixed","flat","footnotes","forwards","from","geometricPrecision","georgian","graytext","groove","gujarati","gurmukhi","hand","hangul","hangul-consonant","hebrew","help","hidden","hide","higher","highlight","highlighttext","hiragana","hiragana-iroha","horizontal","hsl","hsla","icon","ignore","inactiveborder","inactivecaption","inactivecaptiontext","infinite","infobackground","infotext","inherit","initial","inline","inline-axis","inline-block","inline-table","inset","inside","intrinsic","invert","italic","justify","kannada","katakana","katakana-iroha","keep-all","khmer","landscape","lao","large","larger","left","level","lighter","line-through","linear","lines","list-item","listbox","listitem","local","logical","loud","lower","lower-alpha","lower-armenian","lower-greek","lower-hexadecimal","lower-latin","lower-norwegian","lower-roman","lowercase","ltr","malayalam","match","media-controls-background","media-current-time-display","media-fullscreen-button","media-mute-button","media-play-button","media-return-to-realtime-button","media-rewind-button","media-seek-back-button","media-seek-forward-button","media-slider","media-sliderthumb","media-time-remaining-display","media-volume-slider","media-volume-slider-container","media-volume-sliderthumb","medium","menu","menulist","menulist-button","menulist-text","menulist-textfield","menutext","message-box","middle","min-intrinsic","mix","mongolian","monospace","move","multiple","myanmar","n-resize","narrower","ne-resize","nesw-resize","no-close-quote","no-drop","no-open-quote","no-repeat","none","normal","not-allowed","nowrap","ns-resize","nw-resize","nwse-resize","oblique","octal","open-quote","optimizeLegibility","optimizeSpeed","oriya","oromo","outset","outside","outside-shape","overlay","overline","padding","padding-box","painted","page","paused","persian","plus-darker","plus-lighter","pointer","polygon","portrait","pre","pre-line","pre-wrap","preserve-3d","progress","push-button","radio","read-only","read-write","read-write-plaintext-only","rectangle","region","relative","repeat","repeat-x","repeat-y","reset","reverse","rgb","rgba","ridge","right","round","row-resize","rtl","run-in","running","s-resize","sans-serif","scroll","scrollbar","se-resize","searchfield","searchfield-cancel-button","searchfield-decoration","searchfield-results-button","searchfield-results-decoration","semi-condensed","semi-expanded","separate","serif","show","sidama","single","skip-white-space","slide","slider-horizontal","slider-vertical","sliderthumb-horizontal","sliderthumb-vertical","slow","small","small-caps","small-caption","smaller","solid","somali","source-atop","source-in","source-out","source-over","space","square","square-button","start","static","status-bar","stretch","stroke","sub","subpixel-antialiased","super","sw-resize","table","table-caption","table-cell","table-column","table-column-group","table-footer-group","table-header-group","table-row","table-row-group","telugu","text","text-bottom","text-top","textarea","textfield","thai","thick","thin","threeddarkshadow","threedface","threedhighlight","threedlightshadow","threedshadow","tibetan","tigre","tigrinya-er","tigrinya-er-abegede","tigrinya-et","tigrinya-et-abegede","to","top","transparent","ultra-condensed","ultra-expanded","underline","up","upper-alpha","upper-armenian","upper-greek","upper-hexadecimal","upper-latin","upper-norwegian","upper-roman","uppercase","urdu","url","vertical","vertical-text","visible","visibleFill","visiblePainted","visibleStroke","visual","w-resize","wait","wave","wider","window","windowframe","windowtext","x-large","x-small","xor","xx-large","xx-small"],h=t(c),p=["font-family","src","unicode-range","font-variant","font-feature-settings","font-stretch","font-weight","font-style"],d=t(p),v=n.concat(i).concat(o).concat(a).concat(f).concat(c);e.registerHelper("hintWords","css",v),e.defineMIME("text/css",{mediaTypes:r,mediaFeatures:s,propertyKeywords:u,nonStandardPropertyKeywords:a,colorKeywords:l,valueKeywords:h,fontProperties:d,tokenHooks:{"<":function(e,t){return e.match("!--")?(t.tokenize=g,g(e,t)):!1},"/":function(e,t){return e.eat("*")?(t.tokenize=m,m(e,t)):!1}},name:"css"}),e.defineMIME("text/x-scss",{mediaTypes:r,mediaFeatures:s,propertyKeywords:u,nonStandardPropertyKeywords:a,colorKeywords:l,valueKeywords:h,fontProperties:d,allowNested:!0,tokenHooks:{"/":function(e,t){return e.eat("/")?(e.skipToEnd(),["comment","comment"]):e.eat("*")?(t.tokenize=m,m(e,t)):["operator","operator"]},":":function(e){return e.match(/\s*{/)?[null,"{"]:!1},$:function(e){return e.match(/^[\w-]+/),e.match(/^\s*:/,!1)?["variable-2","variable-definition"]:["variable-2","variable"]},"#":function(e){return e.eat("{")?[null,"interpolation"]:!1}},name:"css",helperType:"scss"}),e.defineMIME("text/x-less",{mediaTypes:r,mediaFeatures:s,propertyKeywords:u,nonStandardPropertyKeywords:a,colorKeywords:l,valueKeywords:h,fontProperties:d,allowNested:!0,tokenHooks:{"/":function(e,t){return e.eat("/")?(e.skipToEnd(),["comment","comment"]):e.eat("*")?(t.tokenize=m,m(e,t)):["operator","operator"]},"@":function(e){return e.match(/^(charset|document|font-face|import|(-(moz|ms|o|webkit)-)?keyframes|media|namespace|page|supports)\b/,!1)?!1:(e.eatWhile(/[\w\\\-]/),e.match(/^\s*:/,!1)?["variable-2","variable-definition"]:["variable-2","variable"])},"&":function(){return["atom","atom"]}},name:"css",helperType:"less"})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/d/d",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}e.defineMode("d",function(t,n){function p(e,t){var n=e.next();if(f[n]){var r=f[n](e,t);if(r!==!1)return r}if(n=='"'||n=="'"||n=="`")return t.tokenize=d(n),t.tokenize(e,t);if(/[\[\]{}\(\),;\:\.]/.test(n))return h=n,null;if(/\d/.test(n))return e.eatWhile(/[\w\.]/),"number";if(n=="/"){if(e.eat("+"))return t.tokenize=v,m(e,t);if(e.eat("*"))return t.tokenize=v,v(e,t);if(e.eat("/"))return e.skipToEnd(),"comment"}if(c.test(n))return e.eatWhile(c),"operator";e.eatWhile(/[\w\$_]/);var i=e.current();return s.propertyIsEnumerable(i)?(u.propertyIsEnumerable(i)&&(h="newstatement"),"keyword"):o.propertyIsEnumerable(i)?(u.propertyIsEnumerable(i)&&(h="newstatement"),"builtin"):a.propertyIsEnumerable(i)?"atom":"variable"}function d(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r&&!l)n.tokenize=null;return"string"}}function v(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=null;break}n=r=="*"}return"comment"}function m(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=null;break}n=r=="+"}return"comment"}function g(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function y(e,t,n){var r=e.indented;return e.context&&e.context.type=="statement"&&(r=e.context.indented),e.context=new g(r,t,n,null,e.context)}function b(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}var r=t.indentUnit,i=n.statementIndentUnit||r,s=n.keywords||{},o=n.builtin||{},u=n.blockKeywords||{},a=n.atoms||{},f=n.hooks||{},l=n.multiLineStrings,c=/[+\-*&%=<>!?|\/]/,h;return{startState:function(e){return{tokenize:null,context:new g((e||0)-r,0,"top",!1),indented:0,startOfLine:!0}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0);if(e.eatSpace())return null;h=null;var r=(t.tokenize||p)(e,t);if(r=="comment"||r=="meta")return r;n.align==null&&(n.align=!0);if(h!=";"&&h!=":"&&h!=","||n.type!="statement")if(h=="{")y(t,e.column(),"}");else if(h=="[")y(t,e.column(),"]");else if(h=="(")y(t,e.column(),")");else if(h=="}"){while(n.type=="statement")n=b(t);n.type=="}"&&(n=b(t));while(n.type=="statement")n=b(t)}else h==n.type?b(t):((n.type=="}"||n.type=="top")&&h!=";"||n.type=="statement"&&h=="newstatement")&&y(t,e.column(),"statement");else b(t);return t.startOfLine=!1,r},indent:function(t,n){if(t.tokenize!=p&&t.tokenize!=null)return e.Pass;var s=t.context,o=n&&n.charAt(0);s.type=="statement"&&o=="}"&&(s=s.prev);var u=o==s.type;return s.type=="statement"?s.indented+(o=="{"?0:i):s.align?s.column+(u?0:1):s.indented+(u?0:r)},electricChars:"{}"}});var n="body catch class do else enum for foreach foreach_reverse if in interface mixin out scope struct switch try union unittest version while with";e.defineMIME("text/x-d",{name:"d",keywords:t("abstract alias align asm assert auto break case cast cdouble cent cfloat const continue debug default delegate delete deprecated export extern final finally function goto immutable import inout invariant is lazy macro module new nothrow override package pragma private protected public pure ref return shared short static super synchronized template this throw typedef typeid typeof volatile __FILE__ __LINE__ __gshared __traits __vector __parameters "+n),blockKeywords:t(n),builtin:t("bool byte char creal dchar double float idouble ifloat int ireal long real short ubyte ucent uint ulong ushort wchar wstring void size_t sizediff_t"),atoms:t("exit failure success true false null"),hooks:{"@":function(e,t){return e.eatWhile(/[\w\$_]/),"meta"}}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/diff/diff",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("diff",function(){var e={"+":"positive","-":"negative","@":"meta"};return{token:function(t){var n=t.string.search(/[\t ]+?$/);if(!t.sol()||n===0)return t.skipToEnd(),("error "+(e[t.string.charAt(0)]||"")).replace(/ $/,"");var r=e[t.peek()]||t.skipToEnd();return n===-1?t.skipToEnd():t.pos=n,r}}}),e.defineMIME("text/x-diff","diff")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/dtd/dtd",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("dtd",function(e){function r(e,t){return n=t,e}function i(e,t){var n=e.next();if(n!="<"||!e.eat("!")){if(n=="<"&&e.eat("?"))return t.tokenize=u("meta","?>"),r("meta",n);if(n=="#"&&e.eatWhile(/[\w]/))return r("atom","tag");if(n=="|")return r("keyword","seperator");if(n.match(/[\(\)\[\]\-\.,\+\?>]/))return r(null,n);if(n.match(/[\[\]]/))return r("rule",n);if(n=='"'||n=="'")return t.tokenize=o(n),t.tokenize(e,t);if(e.eatWhile(/[a-zA-Z\?\+\d]/)){var i=e.current();return i.substr(i.length-1,i.length).match(/\?|\+/)!==null&&e.backUp(1),r("tag","tag")}return n=="%"||n=="*"?r("number","number"):(e.eatWhile(/[\w\\\-_%.{,]/),r(null,null))}if(e.eatWhile(/[\-]/))return t.tokenize=s,s(e,t);if(e.eatWhile(/[\w]/))return r("keyword","doindent")}function s(e,t){var n=0,s;while((s=e.next())!=null){if(n>=2&&s==">"){t.tokenize=i;break}n=s=="-"?n+1:0}return r("comment","comment")}function o(e){return function(t,n){var s=!1,o;while((o=t.next())!=null){if(o==e&&!s){n.tokenize=i;break}s=!s&&o=="\\"}return r("string","tag")}}function u(e,t){return function(n,r){while(!n.eol()){if(n.match(t)){r.tokenize=i;break}n.next()}return e}}var t=e.indentUnit,n;return{startState:function(e){return{tokenize:i,baseIndent:e||0,stack:[]}},token:function(e,t){if(e.eatSpace())return null;var r=t.tokenize(e,t),i=t.stack[t.stack.length-1];return e.current()=="["||n==="doindent"||n=="["?t.stack.push("rule"):n==="endtag"?t.stack[t.stack.length-1]="endtag":e.current()=="]"||n=="]"||n==">"&&i=="rule"?t.stack.pop():n=="["&&t.stack.push("["),r},indent:function(e,r){var i=e.stack.length;return r.match(/\]\s+|\]/)?i-=1:r.substr(r.length-1,r.length)===">"&&(r.substr(0,1)==="<"?i:n=="doindent"&&r.length>1?i:n=="doindent"?i--:n==">"&&r.length>1?i:n=="tag"&&r!==">"?i:n=="tag"&&e.stack[e.stack.length-1]=="rule"?i--:n=="tag"?i++:r===">"&&e.stack[e.stack.length-1]=="rule"&&n===">"?i--:r===">"&&e.stack[e.stack.length-1]=="rule"?i:r.substr(0,1)!=="<"&&r.substr(0,1)===">"?i-=1:r===">"?i:i-=1,(n==null||n=="]")&&i--),e.baseIndent+i*t},electricChars:"]>"}}),e.defineMIME("application/xml-dtd","dtd")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/ecl/ecl",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("ecl",function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function n(e,t){return t.startOfLine?(e.skipToEnd(),"meta"):!1}function v(e,t){var n=e.next();if(c[n]){var r=c[n](e,t);if(r!==!1)return r}if(n=='"'||n=="'")return t.tokenize=m(n),t.tokenize(e,t);if(/[\[\]{}\(\),;\:\.]/.test(n))return d=n,null;if(/\d/.test(n))return e.eatWhile(/[\w\.]/),"number";if(n=="/"){if(e.eat("*"))return t.tokenize=g,g(e,t);if(e.eat("/"))return e.skipToEnd(),"comment"}if(p.test(n))return e.eatWhile(p),"operator";e.eatWhile(/[\w\$_]/);var h=e.current().toLowerCase();if(i.propertyIsEnumerable(h))return f.propertyIsEnumerable(h)&&(d="newstatement"),"keyword";if(s.propertyIsEnumerable(h))return f.propertyIsEnumerable(h)&&(d="newstatement"),"variable";if(o.propertyIsEnumerable(h))return f.propertyIsEnumerable(h)&&(d="newstatement"),"variable-2";if(u.propertyIsEnumerable(h))return f.propertyIsEnumerable(h)&&(d="newstatement"),"variable-3";if(a.propertyIsEnumerable(h))return f.propertyIsEnumerable(h)&&(d="newstatement"),"builtin";var v=h.length-1;while(v>=0&&(!isNaN(h[v])||h[v]=="_"))--v;if(v>0){var y=h.substr(0,v+1);if(u.propertyIsEnumerable(y))return f.propertyIsEnumerable(y)&&(d="newstatement"),"variable-3"}return l.propertyIsEnumerable(h)?"atom":null}function m(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r&&!h)n.tokenize=v;return"string"}}function g(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=v;break}n=r=="*"}return"comment"}function y(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function b(e,t,n){return e.context=new y(e.indented,t,n,null,e.context)}function w(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}var r=e.indentUnit,i=t("abs acos allnodes ascii asin asstring atan atan2 ave case choose choosen choosesets clustersize combine correlation cos cosh count covariance cron dataset dedup define denormalize distribute distributed distribution ebcdic enth error evaluate event eventextra eventname exists exp failcode failmessage fetch fromunicode getisvalid global graph group hash hash32 hash64 hashcrc hashmd5 having if index intformat isvalid iterate join keyunicode length library limit ln local log loop map matched matchlength matchposition matchtext matchunicode max merge mergejoin min nolocal nonempty normalize parse pipe power preload process project pull random range rank ranked realformat recordof regexfind regexreplace regroup rejected rollup round roundup row rowdiff sample set sin sinh sizeof soapcall sort sorted sqrt stepped stored sum table tan tanh thisnode topn tounicode transfer trim truncate typeof ungroup unicodeorder variance which workunit xmldecode xmlencode xmltext xmlunicode"),s=t("apply assert build buildindex evaluate fail keydiff keypatch loadxml nothor notify output parallel sequential soapcall wait"),o=t("__compressed__ all and any as atmost before beginc++ best between case const counter csv descend encrypt end endc++ endmacro except exclusive expire export extend false few first flat from full function group header heading hole ifblock import in interface joined keep keyed last left limit load local locale lookup macro many maxcount maxlength min skew module named nocase noroot noscan nosort not of only opt or outer overwrite packed partition penalty physicallength pipe quote record relationship repeat return right scan self separator service shared skew skip sql store terminator thor threshold token transform trim true type unicodeorder unsorted validate virtual whole wild within xml xpath"),u=t("ascii big_endian boolean data decimal ebcdic integer pattern qstring real record rule set of string token udecimal unicode unsigned varstring varunicode"),a=t("checkpoint deprecated failcode failmessage failure global independent onwarning persist priority recovery stored success wait when"),f=t("catch class do else finally for if switch try while"),l=t("true false null"),c={"#":n},h,p=/[+\-*&%=<>!?|\/]/,d;return{startState:function(e){return{tokenize:null,context:new y((e||0)-r,0,"top",!1),indented:0,startOfLine:!0}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0);if(e.eatSpace())return null;d=null;var r=(t.tokenize||v)(e,t);if(r=="comment"||r=="meta")return r;n.align==null&&(n.align=!0);if(d!=";"&&d!=":"||n.type!="statement")if(d=="{")b(t,e.column(),"}");else if(d=="[")b(t,e.column(),"]");else if(d=="(")b(t,e.column(),")");else if(d=="}"){while(n.type=="statement")n=w(t);n.type=="}"&&(n=w(t));while(n.type=="statement")n=w(t)}else d==n.type?w(t):(n.type=="}"||n.type=="top"||n.type=="statement"&&d=="newstatement")&&b(t,e.column(),"statement");else w(t);return t.startOfLine=!1,r},indent:function(e,t){if(e.tokenize!=v&&e.tokenize!=null)return 0;var n=e.context,i=t&&t.charAt(0);n.type=="statement"&&i=="}"&&(n=n.prev);var s=i==n.type;return n.type=="statement"?n.indented+(i=="{"?0:r):n.align?n.column+(s?0:1):n.indented+(s?0:r)},electricChars:"{}"}}),e.defineMIME("text/x-ecl","ecl")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/eiffel/eiffel",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("eiffel",function(){function e(e){var t={};for(var n=0,r=e.length;n<r;++n)t[e[n]]=!0;return t}function i(e,t,n){return n.tokenize.push(e),e(t,n)}function s(e,t){r=null;if(e.eatSpace())return null;var n=e.next();return n=='"'||n=="'"?i(o(n,"string"),e,t):n=="-"&&e.eat("-")?(e.skipToEnd(),"comment"):n==":"&&e.eat("=")?"operator":/[0-9]/.test(n)?(e.eatWhile(/[xXbBCc0-9\.]/),e.eat(/[\?\!]/),"ident"):/[a-zA-Z_0-9]/.test(n)?(e.eatWhile(/[a-zA-Z_0-9]/),e.eat(/[\?\!]/),"ident"):/[=+\-\/*^%<>~]/.test(n)?(e.eatWhile(/[=+\-\/*^%<>~]/),"operator"):null}function o(e,t,n){return function(r,i){var s=!1,o;while((o=r.next())!=null){if(o==e&&(n||!s)){i.tokenize.pop();break}s=!s&&o=="%"}return t}}var t=e(["note","across","when","variant","until","unique","undefine","then","strip","select","retry","rescue","require","rename","reference","redefine","prefix","once","old","obsolete","loop","local","like","is","inspect","infix","include","if","frozen","from","external","export","ensure","end","elseif","else","do","creation","create","check","alias","agent","separate","invariant","inherit","indexing","feature","expanded","deferred","class","Void","True","Result","Precursor","False","Current","create","attached","detachable","as","and","implies","not","or"]),n=e([":=","and then","and","or","<<",">>"]),r;return{startState:function(){return{tokenize:[s]}},token:function(e,r){var i=r.tokenize[r.tokenize.length-1](e,r);if(i=="ident"){var s=e.current();i=t.propertyIsEnumerable(e.current())?"keyword":n.propertyIsEnumerable(e.current())?"operator":/^[A-Z][A-Z_0-9]*$/g.test(s)?"tag":/^0[bB][0-1]+$/g.test(s)?"number":/^0[cC][0-7]+$/g.test(s)?"number":/^0[xX][a-fA-F0-9]+$/g.test(s)?"number":/^([0-9]+\.[0-9]*)|([0-9]*\.[0-9]+)$/g.test(s)?"number":/^[0-9]+$/g.test(s)?"number":"variable"}return i},lineComment:"--"}}),e.defineMIME("text/x-eiffel","eiffel")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/erlang/erlang",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMIME("text/x-erlang","erlang"),e.defineMode("erlang",function(t){function g(e,t){if(t.in_string)return t.in_string=!w(e),N(t,e,"string");if(t.in_atom)return t.in_atom=!E(e),N(t,e,"atom");if(e.eatSpace())return N(t,e,"whitespace");if(!A(t)&&e.match(/-\s*[a-zß-öø-ÿ][\wØ-ÞÀ-Öß-öø-ÿ]*/))return T(e.current(),n)?N(t,e,"type"):N(t,e,"attribute");var g=e.next();if(g=="%")return e.skipToEnd(),N(t,e,"comment");if(g==":")return N(t,e,"colon");if(g=="?")return e.eatSpace(),e.eatWhile(v),N(t,e,"macro");if(g=="#")return e.eatSpace(),e.eatWhile(v),N(t,e,"record");if(g=="$")return e.next()=="\\"&&!e.match(m)?N(t,e,"error"):N(t,e,"number");if(g==".")return N(t,e,"dot");if(g=="'"){if(!(t.in_atom=!E(e))){if(e.match(/\s*\/\s*[0-9]/,!1))return e.match(/\s*\/\s*[0-9]/,!0),N(t,e,"fun");if(e.match(/\s*\(/,!1)||e.match(/\s*:/,!1))return N(t,e,"function")}return N(t,e,"atom")}if(g=='"')return t.in_string=!w(e),N(t,e,"string");if(/[A-Z_Ø-ÞÀ-Ö]/.test(g))return e.eatWhile(v),N(t,e,"variable");if(/[a-z_ß-öø-ÿ]/.test(g)){e.eatWhile(v);if(e.match(/\s*\/\s*[0-9]/,!1))return e.match(/\s*\/\s*[0-9]/,!0),N(t,e,"fun");var S=e.current();return T(S,r)?N(t,e,"keyword"):T(S,o)?N(t,e,"operator"):e.match(/\s*\(/,!1)?!T(S,d)||A(t).token==":"&&A(t,2).token!="erlang"?T(S,p)?N(t,e,"guard"):N(t,e,"function"):N(t,e,"builtin"):T(S,o)?N(t,e,"operator"):x(e)==":"?S=="erlang"?N(t,e,"builtin"):N(t,e,"function"):T(S,["true","false"])?N(t,e,"boolean"):T(S,["true","false"])?N(t,e,"boolean"):N(t,e,"atom")}var C=/[0-9]/,k=/[0-9a-zA-Z]/;return C.test(g)?(e.eatWhile(C),e.eat("#")?e.eatWhile(k)||e.backUp(1):e.eat(".")&&(e.eatWhile(C)?e.eat(/[eE]/)&&(e.eat(/[-+]/)?e.eatWhile(C)||e.backUp(2):e.eatWhile(C)||e.backUp(1)):e.backUp(1)),N(t,e,"number")):y(e,f,l)?N(t,e,"open_paren"):y(e,c,h)?N(t,e,"close_paren"):b(e,i,s)?N(t,e,"separator"):b(e,u,a)?N(t,e,"operator"):N(t,e,null)}function y(e,t,n){if(e.current().length==1&&t.test(e.current())){e.backUp(1);while(t.test(e.peek())){e.next();if(T(e.current(),n))return!0}e.backUp(e.current().length-1)}return!1}function b(e,t,n){if(e.current().length==1&&t.test(e.current())){while(t.test(e.peek()))e.next();while(0<e.current().length){if(T(e.current(),n))return!0;e.backUp(1)}e.next()}return!1}function w(e){return S(e,'"',"\\")}function E(e){return S(e,"'","\\")}function S(e,t,n){while(!e.eol()){var r=e.next();if(r==t)return!0;r==n&&e.next()}return!1}function x(e){var t=e.match(/([\n\s]+|%[^\n]*\n)*(.)/,!1);return t?t.pop():""}function T(e,t){return-1<t.indexOf(e)}function N(e,t,n){O(e,k(n,t));switch(n){case"atom":return"atom";case"attribute":return"attribute";case"boolean":return"atom";case"builtin":return"builtin";case"close_paren":return null;case"colon":return null;case"comment":return"comment";case"dot":return null;case"error":return"error";case"fun":return"meta";case"function":return"tag";case"guard":return"property";case"keyword":return"keyword";case"macro":return"variable-2";case"number":return"number";case"open_paren":return null;case"operator":return"operator";case"record":return"bracket";case"separator":return null;case"string":return"string";case"type":return"def";case"variable":return"variable";default:return null}}function C(e,t,n,r){return{token:e,column:t,indent:n,type:r}}function k(e,t){return C(t.current(),t.column(),t.indentation(),e)}function L(e){return C(e,0,0,e)}function A(e,t){var n=e.tokenStack.length,r=t?t:1;return n<r?!1:e.tokenStack[n-r]}function O(e,t){t.type!="comment"&&t.type!="whitespace"&&(e.tokenStack=M(e.tokenStack,t),e.tokenStack=_(e.tokenStack))}function M(e,t){var n=e.length-1;return 0<n&&e[n].type==="record"&&t.type==="dot"?e.pop():0<n&&e[n].type==="group"?(e.pop(),e.push(t)):e.push(t),e}function _(e){var t=e.length-1;if(e[t].type==="dot")return[];if(e[t].type==="fun"&&e[t-1].token==="fun")return e.slice(0,t-1);switch(e[e.length-1].token){case"}":return D(e,{g:["{"]});case"]":return D(e,{i:["["]});case")":return D(e,{i:["("]});case">>":return D(e,{i:["<<"]});case"end":return D(e,{i:["begin","case","fun","if","receive","try"]});case",":return D(e,{e:["begin","try","when","->",",","(","[","{","<<"]});case"->":return D(e,{r:["when"],m:["try","if","case","receive"]});case";":return D(e,{E:["case","fun","if","receive","try","when"]});case"catch":return D(e,{e:["try"]});case"of":return D(e,{e:["case"]});case"after":return D(e,{e:["receive","try"]});default:return e}}function D(e,t){for(var n in t){var r=e.length-1,i=t[n];for(var s=r-1;-1<s;s--)if(T(e[s].token,i)){var o=e.slice(0,s);switch(n){case"m":return o.concat(e[s]).concat(e[r]);case"r":return o.concat(e[r]);case"i":return o;case"g":return o.concat(L("group"));case"E":return o.concat(e[s]);case"e":return o.concat(e[s])}}}return n=="E"?[]:e}function P(n,r){var i,s=t.indentUnit,o=H(r),u=A(n,1),a=A(n,2);return n.in_string||n.in_atom?e.Pass:a?u.token=="when"?u.column+s:o==="when"&&a.type==="function"?a.indent+s:o==="("&&u.token==="fun"?u.column+3:o==="catch"&&(i=F(n,["try"]))?i.column:T(o,["end","after","of"])?(i=F(n,["begin","case","fun","if","receive","try"]),i?i.column:e.Pass):T(o,h)?(i=F(n,l),i?i.column:e.Pass):T(u.token,[",","|","||"])||T(o,[",","|","||"])?(i=B(n),i?i.column+i.token.length:s):u.token=="->"?T(a.token,["receive","case","if","try"])?a.column+s+s:a.column+s:T(u.token,l)?u.column+u.token.length:(i=j(n),q(i)?i.column+s:0):0}function H(e){var t=e.match(/,|[a-z]+|\}|\]|\)|>>|\|+|\(/);return q(t)&&t.index===0?t[0]:""}function B(e){var t=e.tokenStack.slice(0,-1),n=I(t,"type",["open_paren"]);return q(t[n])?t[n]:!1}function j(e){var t=e.tokenStack,n=I(t,"type",["open_paren","separator","keyword"]),r=I(t,"type",["operator"]);return q(n)&&q(r)&&n<r?t[n+1]:q(n)?t[n]:!1}function F(e,t){var n=e.tokenStack,r=I(n,"token",t);return q(n[r])?n[r]:!1}function I(e,t,n){for(var r=e.length-1;-1<r;r--)if(T(e[r][t],n))return r;return!1}function q(e){return e!==!1&&e!=null}var n=["-type","-spec","-export_type","-opaque"],r=["after","begin","catch","case","cond","end","fun","if","let","of","query","receive","try","when"],i=/[\->,;]/,s=["->",";",","],o=["and","andalso","band","bnot","bor","bsl","bsr","bxor","div","not","or","orelse","rem","xor"],u=/[\+\-\*\/<>=\|:!]/,a=["=","+","-","*","/",">",">=","<","=<","=:=","==","=/=","/=","||","<-","!"],f=/[<\(\[\{]/,l=["<<","(","[","{"],c=/[>\)\]\}]/,h=["}","]",")",">>"],p=["is_atom","is_binary","is_bitstring","is_boolean","is_float","is_function","is_integer","is_list","is_number","is_pid","is_port","is_record","is_reference","is_tuple","atom","binary","bitstring","boolean","function","integer","list","number","pid","port","record","reference","tuple"],d=["abs","adler32","adler32_combine","alive","apply","atom_to_binary","atom_to_list","binary_to_atom","binary_to_existing_atom","binary_to_list","binary_to_term","bit_size","bitstring_to_list","byte_size","check_process_code","contact_binary","crc32","crc32_combine","date","decode_packet","delete_module","disconnect_node","element","erase","exit","float","float_to_list","garbage_collect","get","get_keys","group_leader","halt","hd","integer_to_list","internal_bif","iolist_size","iolist_to_binary","is_alive","is_atom","is_binary","is_bitstring","is_boolean","is_float","is_function","is_integer","is_list","is_number","is_pid","is_port","is_process_alive","is_record","is_reference","is_tuple","length","link","list_to_atom","list_to_binary","list_to_bitstring","list_to_existing_atom","list_to_float","list_to_integer","list_to_pid","list_to_tuple","load_module","make_ref","module_loaded","monitor_node","node","node_link","node_unlink","nodes","notalive","now","open_port","pid_to_list","port_close","port_command","port_connect","port_control","pre_loaded","process_flag","process_info","processes","purge_module","put","register","registered","round","self","setelement","size","spawn","spawn_link","spawn_monitor","spawn_opt","split_binary","statistics","term_to_binary","time","throw","tl","trunc","tuple_size","tuple_to_list","unlink","unregister","whereis"],v=/[\w@Ø-ÞÀ-Öß-öø-ÿ]/,m=/[0-7]{1,3}|[bdefnrstv\\"']|\^[a-zA-Z]|x[0-9a-zA-Z]{2}|x{[0-9a-zA-Z]+}/;return{startState:function(){return{tokenStack:[],in_string:!1,in_atom:!1}},token:function(e,t){return g(e,t)},indent:function(e,t){return P(e,t)},lineComment:"%"}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/fortran/fortran",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("fortran",function(){function e(e){var t={};for(var n=0;n<e.length;++n)t[e[n]]=!0;return t}function o(e,o){if(e.match(s))return"operator";var a=e.next();if(a=="!")return e.skipToEnd(),"comment";if(a=='"'||a=="'")return o.tokenize=u(a),o.tokenize(e,o);if(/[\[\]\(\),]/.test(a))return null;if(/\d/.test(a))return e.eatWhile(/[\w\.]/),"number";if(i.test(a))return e.eatWhile(i),"operator";e.eatWhile(/[\w\$_]/);var f=e.current().toLowerCase();return t.hasOwnProperty(f)?"keyword":n.hasOwnProperty(f)||r.hasOwnProperty(f)?"builtin":"variable"}function u(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r)n.tokenize=null;return"string"}}var t=e(["abstract","accept","allocatable","allocate","array","assign","asynchronous","backspace","bind","block","byte","call","case","class","close","common","contains","continue","cycle","data","deallocate","decode","deferred","dimension","do","elemental","else","encode","end","endif","entry","enumerator","equivalence","exit","external","extrinsic","final","forall","format","function","generic","go","goto","if","implicit","import","include","inquire","intent","interface","intrinsic","module","namelist","non_intrinsic","non_overridable","none","nopass","nullify","open","optional","options","parameter","pass","pause","pointer","print","private","program","protected","public","pure","read","recursive","result","return","rewind","save","select","sequence","stop","subroutine","target","then","to","type","use","value","volatile","where","while","write"]),n=e(["abort","abs","access","achar","acos","adjustl","adjustr","aimag","aint","alarm","all","allocated","alog","amax","amin","amod","and","anint","any","asin","associated","atan","besj","besjn","besy","besyn","bit_size","btest","cabs","ccos","ceiling","cexp","char","chdir","chmod","clog","cmplx","command_argument_count","complex","conjg","cos","cosh","count","cpu_time","cshift","csin","csqrt","ctime","c_funloc","c_loc","c_associated","c_null_ptr","c_null_funptr","c_f_pointer","c_null_char","c_alert","c_backspace","c_form_feed","c_new_line","c_carriage_return","c_horizontal_tab","c_vertical_tab","dabs","dacos","dasin","datan","date_and_time","dbesj","dbesj","dbesjn","dbesy","dbesy","dbesyn","dble","dcos","dcosh","ddim","derf","derfc","dexp","digits","dim","dint","dlog","dlog","dmax","dmin","dmod","dnint","dot_product","dprod","dsign","dsinh","dsin","dsqrt","dtanh","dtan","dtime","eoshift","epsilon","erf","erfc","etime","exit","exp","exponent","extends_type_of","fdate","fget","fgetc","float","floor","flush","fnum","fputc","fput","fraction","fseek","fstat","ftell","gerror","getarg","get_command","get_command_argument","get_environment_variable","getcwd","getenv","getgid","getlog","getpid","getuid","gmtime","hostnm","huge","iabs","iachar","iand","iargc","ibclr","ibits","ibset","ichar","idate","idim","idint","idnint","ieor","ierrno","ifix","imag","imagpart","index","int","ior","irand","isatty","ishft","ishftc","isign","iso_c_binding","is_iostat_end","is_iostat_eor","itime","kill","kind","lbound","len","len_trim","lge","lgt","link","lle","llt","lnblnk","loc","log","logical","long","lshift","lstat","ltime","matmul","max","maxexponent","maxloc","maxval","mclock","merge","move_alloc","min","minexponent","minloc","minval","mod","modulo","mvbits","nearest","new_line","nint","not","or","pack","perror","precision","present","product","radix","rand","random_number","random_seed","range","real","realpart","rename","repeat","reshape","rrspacing","rshift","same_type_as","scale","scan","second","selected_int_kind","selected_real_kind","set_exponent","shape","short","sign","signal","sinh","sin","sleep","sngl","spacing","spread","sqrt","srand","stat","sum","symlnk","system","system_clock","tan","tanh","time","tiny","transfer","transpose","trim","ttynam","ubound","umask","unlink","unpack","verify","xor","zabs","zcos","zexp","zlog","zsin","zsqrt"]),r=e(["c_bool","c_char","c_double","c_double_complex","c_float","c_float_complex","c_funptr","c_int","c_int16_t","c_int32_t","c_int64_t","c_int8_t","c_int_fast16_t","c_int_fast32_t","c_int_fast64_t","c_int_fast8_t","c_int_least16_t","c_int_least32_t","c_int_least64_t","c_int_least8_t","c_intmax_t","c_intptr_t","c_long","c_long_double","c_long_double_complex","c_long_long","c_ptr","c_short","c_signed_char","c_size_t","character","complex","double","integer","logical","real"]),i=/[+\-*&=<>\/\:]/,s=new RegExp("(.and.|.or.|.eq.|.lt.|.le.|.gt.|.ge.|.ne.|.not.|.eqv.|.neqv.)","i");return{startState:function(){return{tokenize:null}},token:function(e,t){if(e.eatSpace())return null;var n=(t.tokenize||o)(e,t);return n=="comment"||n=="meta"?n:n}}}),e.defineMIME("text/x-fortran","fortran")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/gas/gas",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("gas",function(e,t){function o(e){r="#",s.ax="variable",s.eax="variable-2",s.rax="variable-3",s.bx="variable",s.ebx="variable-2",s.rbx="variable-3",s.cx="variable",s.ecx="variable-2",s.rcx="variable-3",s.dx="variable",s.edx="variable-2",s.rdx="variable-3",s.si="variable",s.esi="variable-2",s.rsi="variable-3",s.di="variable",s.edi="variable-2",s.rdi="variable-3",s.sp="variable",s.esp="variable-2",s.rsp="variable-3",s.bp="variable",s.ebp="variable-2",s.rbp="variable-3",s.ip="variable",s.eip="variable-2",s.rip="variable-3",s.cs="keyword",s.ds="keyword",s.ss="keyword",s.es="keyword",s.fs="keyword",s.gs="keyword"}function u(e){r="@",i.syntax="builtin",s.r0="variable",s.r1="variable",s.r2="variable",s.r3="variable",s.r4="variable",s.r5="variable",s.r6="variable",s.r7="variable",s.r8="variable",s.r9="variable",s.r10="variable",s.r11="variable",s.r12="variable",s.sp="variable-2",s.lr="variable-2",s.pc="variable-2",s.r13=s.sp,s.r14=s.lr,s.r15=s.pc,n.push(function(e,t){if(e==="#")return t.eatWhile(/\w/),"number"})}function f(e,t){var n=!1,r;while((r=e.next())!=null){if(r===t&&!n)return!1;n=!n&&r==="\\"}return n}function l(e,t){var n=!1,r;while((r=e.next())!=null){if(r==="/"&&n){t.tokenize=null;break}n=r==="*"}return"comment"}var n=[],r="",i={".abort":"builtin",".align":"builtin",".altmacro":"builtin",".ascii":"builtin",".asciz":"builtin",".balign":"builtin",".balignw":"builtin",".balignl":"builtin",".bundle_align_mode":"builtin",".bundle_lock":"builtin",".bundle_unlock":"builtin",".byte":"builtin",".cfi_startproc":"builtin",".comm":"builtin",".data":"builtin",".def":"builtin",".desc":"builtin",".dim":"builtin",".double":"builtin",".eject":"builtin",".else":"builtin",".elseif":"builtin",".end":"builtin",".endef":"builtin",".endfunc":"builtin",".endif":"builtin",".equ":"builtin",".equiv":"builtin",".eqv":"builtin",".err":"builtin",".error":"builtin",".exitm":"builtin",".extern":"builtin",".fail":"builtin",".file":"builtin",".fill":"builtin",".float":"builtin",".func":"builtin",".global":"builtin",".gnu_attribute":"builtin",".hidden":"builtin",".hword":"builtin",".ident":"builtin",".if":"builtin",".incbin":"builtin",".include":"builtin",".int":"builtin",".internal":"builtin",".irp":"builtin",".irpc":"builtin",".lcomm":"builtin",".lflags":"builtin",".line":"builtin",".linkonce":"builtin",".list":"builtin",".ln":"builtin",".loc":"builtin",".loc_mark_labels":"builtin",".local":"builtin",".long":"builtin",".macro":"builtin",".mri":"builtin",".noaltmacro":"builtin",".nolist":"builtin",".octa":"builtin",".offset":"builtin",".org":"builtin",".p2align":"builtin",".popsection":"builtin",".previous":"builtin",".print":"builtin",".protected":"builtin",".psize":"builtin",".purgem":"builtin",".pushsection":"builtin",".quad":"builtin",".reloc":"builtin",".rept":"builtin",".sbttl":"builtin",".scl":"builtin",".section":"builtin",".set":"builtin",".short":"builtin",".single":"builtin",".size":"builtin",".skip":"builtin",".sleb128":"builtin",".space":"builtin",".stab":"builtin",".string":"builtin",".struct":"builtin",".subsection":"builtin",".symver":"builtin",".tag":"builtin",".text":"builtin",".title":"builtin",".type":"builtin",".uleb128":"builtin",".val":"builtin",".version":"builtin",".vtable_entry":"builtin",".vtable_inherit":"builtin",".warning":"builtin",".weak":"builtin",".weakref":"builtin",".word":"builtin"},s={},a=(t.architecture||"x86").toLowerCase();return a==="x86"?o(t):(a==="arm"||a==="armv6")&&u(t),{startState:function(){return{tokenize:null}},token:function(e,t){if(t.tokenize)return t.tokenize(e,t);if(e.eatSpace())return null;var o,u,a=e.next();if(a==="/"&&e.eat("*"))return t.tokenize=l,l(e,t);if(a===r)return e.skipToEnd(),"comment";if(a==='"')return f(e,'"'),"string";if(a===".")return e.eatWhile(/\w/),u=e.current().toLowerCase(),o=i[u],o||null;if(a==="=")return e.eatWhile(/\w/),"tag";if(a==="{")return"braket";if(a==="}")return"braket";if(/\d/.test(a))return a==="0"&&e.eat("x")?(e.eatWhile(/[0-9a-fA-F]/),"number"):(e.eatWhile(/\d/),"number");if(/\w/.test(a))return e.eatWhile(/\w/),e.eat(":")?"tag":(u=e.current().toLowerCase(),o=s[u],o||null);for(var c=0;c<n.length;c++){o=n[c](a,e,t);if(o)return o}},lineComment:r,blockCommentStart:"/*",blockCommentEnd:"*/"}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/xml/xml",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("xml",function(t,n){function l(e,t){function n(n){return t.tokenize=n,n(e,t)}var r=e.next();if(r=="<")return e.eat("!")?e.eat("[")?e.match("CDATA[")?n(p("atom","]]>")):null:e.match("--")?n(p("comment","-->")):e.match("DOCTYPE",!0,!0)?(e.eatWhile(/[\w\._\-]/),n(d(1))):null:e.eat("?")?(e.eatWhile(/[\w\._\-]/),t.tokenize=p("meta","?>"),"meta"):(a=e.eat("/")?"closeTag":"openTag",t.tokenize=c,"tag bracket");if(r=="&"){var i;return e.eat("#")?e.eat("x")?i=e.eatWhile(/[a-fA-F\d]/)&&e.eat(";"):i=e.eatWhile(/[\d]/)&&e.eat(";"):i=e.eatWhile(/[\w\.\-:]/)&&e.eat(";"),i?"atom":"error"}return e.eatWhile(/[^&<]/),null}function c(e,t){var n=e.next();if(n==">"||n=="/"&&e.eat(">"))return t.tokenize=l,a=n==">"?"endTag":"selfcloseTag","tag bracket";if(n=="=")return a="equals",null;if(n=="<"){t.tokenize=l,t.state=y,t.tagName=t.tagStart=null;var r=t.tokenize(e,t);return r?r+" tag error":"tag error"}return/[\'\"]/.test(n)?(t.tokenize=h(n),t.stringStartCol=e.column(),t.tokenize(e,t)):(e.match(/^[^\s\u00a0=<>\"\']*[^\s\u00a0=<>\"\'\/]/),"word")}function h(e){var t=function(t,n){while(!t.eol())if(t.next()==e){n.tokenize=c;break}return"string"};return t.isInAttribute=!0,t}function p(e,t){return function(n,r){while(!n.eol()){if(n.match(t)){r.tokenize=l;break}n.next()}return e}}function d(e){return function(t,n){var r;while((r=t.next())!=null){if(r=="<")return n.tokenize=d(e+1),n.tokenize(t,n);if(r==">"){if(e==1){n.tokenize=l;break}return n.tokenize=d(e-1),n.tokenize(t,n)}}return"meta"}}function v(e,t,n){this.prev=e.context,this.tagName=t,this.indent=e.indented,this.startOfLine=n;if(o.doNotIndent.hasOwnProperty(t)||e.context&&e.context.noIndent)this.noIndent=!0}function m(e){e.context&&(e.context=e.context.prev)}function g(e,t){var n;for(;;){if(!e.context)return;n=e.context.tagName;if(!o.contextGrabbers.hasOwnProperty(n)||!o.contextGrabbers[n].hasOwnProperty(t))return;m(e)}}function y(e,t,n){return e=="openTag"?(n.tagStart=t.column(),b):e=="closeTag"?w:y}function b(e,t,n){return e=="word"?(n.tagName=t.current(),f="tag",x):(f="error",b)}function w(e,t,n){if(e=="word"){var r=t.current();return n.context&&n.context.tagName!=r&&o.implicitlyClosed.hasOwnProperty(n.context.tagName)&&m(n),n.context&&n.context.tagName==r?(f="tag",E):(f="tag error",S)}return f="error",S}function E(e,t,n){return e!="endTag"?(f="error",E):(m(n),y)}function S(e,t,n){return f="error",E(e,t,n)}function x(e,t,n){if(e=="word")return f="attribute",T;if(e=="endTag"||e=="selfcloseTag"){var r=n.tagName,i=n.tagStart;return n.tagName=n.tagStart=null,e=="selfcloseTag"||o.autoSelfClosers.hasOwnProperty(r)?g(n,r):(g(n,r),n.context=new v(n,r,i==n.indented)),y}return f="error",x}function T(e,t,n){return e=="equals"?N:(o.allowMissing||(f="error"),x(e,t,n))}function N(e,t,n){return e=="string"?C:e=="word"&&o.allowUnquoted?(f="string",x):(f="error",x(e,t,n))}function C(e,t,n){return e=="string"?C:x(e,t,n)}var r=t.indentUnit,i=n.multilineTagIndentFactor||1,s=n.multilineTagIndentPastTag;s==null&&(s=!0);var o=n.htmlMode?{autoSelfClosers:{area:!0,base:!0,br:!0,col:!0,command:!0,embed:!0,frame:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},implicitlyClosed:{dd:!0,li:!0,optgroup:!0,option:!0,p:!0,rp:!0,rt:!0,tbody:!0,td:!0,tfoot:!0,th:!0,tr:!0},contextGrabbers:{dd:{dd:!0,dt:!0},dt:{dd:!0,dt:!0},li:{li:!0},option:{option:!0,optgroup:!0},optgroup:{optgroup:!0},p:{address:!0,article:!0,aside:!0,blockquote:!0,dir:!0,div:!0,dl:!0,fieldset:!0,footer:!0,form:!0,h1:!0,h2:!0,h3:!0,h4:!0,h5:!0,h6:!0,header:!0,hgroup:!0,hr:!0,menu:!0,nav:!0,ol:!0,p:!0,pre:!0,section:!0,table:!0,ul:!0},rp:{rp:!0,rt:!0},rt:{rp:!0,rt:!0},tbody:{tbody:!0,tfoot:!0},td:{td:!0,th:!0},tfoot:{tbody:!0},th:{td:!0,th:!0},thead:{tbody:!0,tfoot:!0},tr:{tr:!0}},doNotIndent:{pre:!0},allowUnquoted:!0,allowMissing:!0,caseFold:!0}:{autoSelfClosers:{},implicitlyClosed:{},contextGrabbers:{},doNotIndent:{},allowUnquoted:!1,allowMissing:!1,caseFold:!1},u=n.alignCDATA,a,f;return{startState:function(){return{tokenize:l,state:y,indented:0,tagName:null,tagStart:null,context:null}},token:function(e,t){!t.tagName&&e.sol()&&(t.indented=e.indentation());if(e.eatSpace())return null;a=null;var n=t.tokenize(e,t);return(n||a)&&n!="comment"&&(f=null,t.state=t.state(a||n,e,t),f&&(n=f=="error"?n+" error":f)),n},indent:function(t,n,a){var f=t.context;if(t.tokenize.isInAttribute)return t.tagStart==t.indented?t.stringStartCol+1:t.indented+r;if(f&&f.noIndent)return e.Pass;if(t.tokenize!=c&&t.tokenize!=l)return a?a.match(/^(\s*)/)[0].length:0;if(t.tagName)return s?t.tagStart+t.tagName.length+2:t.tagStart+r*i;if(u&&/<!\[CDATA\[/.test(n))return 0;var h=n&&/^<(\/)?([\w_:\.-]*)/.exec(n);if(h&&h[1])while(f){if(f.tagName==h[2]){f=f.prev;break}if(!o.implicitlyClosed.hasOwnProperty(f.tagName))break;f=f.prev}else if(h)while(f){var p=o.contextGrabbers[f.tagName];if(!p||!p.hasOwnProperty(h[2]))break;f=f.prev}while(f&&!f.startOfLine)f=f.prev;return f?f.indent+r:0},electricInput:/<\/[\s\w:]+>$/,blockCommentStart:"<!--",blockCommentEnd:"-->",configuration:n.htmlMode?"html":"xml",helperType:n.htmlMode?"html":"xml"}}),e.defineMIME("text/xml","xml"),e.defineMIME("application/xml","xml"),e.mimeModes.hasOwnProperty("text/html")||e.defineMIME("text/html",{name:"xml",htmlMode:!0})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror",require("../xml/xml"))):typeof define=="function"&&define.amd?define("components/codemirror/mode/markdown/markdown",["../../lib/codemirror","../xml/xml"],e):e(CodeMirror)}(function(e){e.defineMode("markdown",function(t,n){function O(e,t,n){return t.f=t.inline=n,n(e,t)}function M(e,t,n){return t.f=t.block=n,n(e,t)}function _(e){return e.linkTitle=!1,e.em=!1,e.strong=!1,e.quote=0,!r&&e.f==P&&(e.f=F,e.block=D),e.trailingSpace=0,e.trailingSpaceNewLine=!1,e.thisLineHasContent=!1,null}function D(e,t){var r=e.sol(),i=t.list!==!1;t.list!==!1&&t.indentationDiff>=0?(t.indentationDiff<4&&(t.indentation-=t.indentationDiff),t.list=null):t.list!==!1&&t.indentation>0?(t.list=null,t.listDepth=Math.floor(t.indentation/4)):t.list!==!1&&(t.list=!1,t.listDepth=0);var s=null;if(t.indentationDiff>=4)return t.indentation-=4,e.skipToEnd(),f;if(e.eatSpace())return null;if(s=e.match(k))return t.header=s[0].length<=6?s[0].length:6,n.highlightFormatting&&(t.formatting="header"),t.f=t.inline,B(t);if(t.prevLineHasContent&&(s=e.match(L)))return t.header=s[0].charAt(0)=="="?1:2,n.highlightFormatting&&(t.formatting="header"),t.f=t.inline,B(t);if(e.eat(">"))return t.indentation++,t.quote=r?1:t.quote+1,n.highlightFormatting&&(t.formatting="quote"),e.eatSpace(),B(t);if(e.peek()==="[")return O(e,t,U);if(e.match(x,!0))return d;if((!t.prevLineHasContent||i)&&(e.match(T,!1)||e.match(N,!1))){var u=null;return e.match(T,!0)?u="ul":(e.match(N,!0),u="ol"),t.indentation+=4,t.list=!0,t.listDepth++,n.taskLists&&e.match(C,!1)&&(t.taskList=!0),t.f=t.inline,n.highlightFormatting&&(t.formatting=["list","list-"+u]),B(t)}return n.fencedCodeBlocks&&e.match(/^```([\w+#]*)/,!0)?(t.localMode=o(RegExp.$1),t.localMode&&(t.localState=t.localMode.startState()),M(e,t,H),n.highlightFormatting&&(t.formatting="code-block"),t.code=!0,B(t)):O(e,t,t.inline)}function P(e,t){var n=i.token(e,t.htmlState);if(r&&t.htmlState.tagStart===null&&!t.htmlState.context||t.md_inside&&e.current().indexOf(">")>-1)t.f=F,t.block=D,t.htmlState=null;return n}function H(e,t){if(e.sol()&&e.match(/^```/,!0)){t.localMode=t.localState=null,t.f=F,t.block=D,n.highlightFormatting&&(t.formatting="code-block"),t.code=!0;var r=B(t);return t.code=!1,r}return t.localMode?t.localMode.token(e,t.localState):(e.skipToEnd(),f)}function B(e){var t=[];if(e.formatting){t.push(m),typeof e.formatting=="string"&&(e.formatting=[e.formatting]);for(var r=0;r<e.formatting.length;r++)t.push(m+"-"+e.formatting[r]),e.formatting[r]==="header"&&t.push(m+"-"+e.formatting[r]+"-"+e.header),e.formatting[r]==="quote"&&(!n.maxBlockquoteDepth||n.maxBlockquoteDepth>=e.quote?t.push(m+"-"+e.formatting[r]+"-"+e.quote):t.push("error"))}if(e.taskOpen)return t.push("meta"),t.length?t.join(" "):null;if(e.taskClosed)return t.push("property"),t.length?t.join(" "):null;if(e.linkHref)return t.push(w),t.length?t.join(" "):null;e.strong&&t.push(S),e.em&&t.push(E),e.linkText&&t.push(b),e.code&&t.push(f),e.header&&(t.push(a),t.push(a+"-"+e.header)),e.quote&&(t.push(l),!n.maxBlockquoteDepth||n.maxBlockquoteDepth>=e.quote?t.push(l+"-"+e.quote):t.push(l+"-"+n.maxBlockquoteDepth));if(e.list!==!1){var i=(e.listDepth-1)%3;i?i===1?t.push(h):t.push(p):t.push(c)}return e.trailingSpaceNewLine?t.push("trailing-space-new-line"):e.trailingSpace&&t.push("trailing-space-"+(e.trailingSpace%2?"a":"b")),t.length?t.join(" "):null}function j(e,t){return e.match(A,!0)?B(t):undefined}function F(t,r){var s=r.text(t,r);if(typeof s!="undefined")return s;if(r.list)return r.list=null,B(r);if(r.taskList){var o=t.match(C,!0)[1]!=="x";return o?r.taskOpen=!0:r.taskClosed=!0,n.highlightFormatting&&(r.formatting="task"),r.taskList=!1,B(r)}r.taskOpen=!1,r.taskClosed=!1;if(r.header&&t.match(/^#+$/,!0))return n.highlightFormatting&&(r.formatting="header"),B(r);var a=t.sol(),f=t.next();if(r.escape)return r.escape=!1,B(r);if(f==="\\")return n.highlightFormatting&&(r.formatting="escape"),r.escape=!0,B(r);if(r.linkTitle){r.linkTitle=!1;var l=f;f==="("&&(l=")"),l=(l+"").replace(/([.?*+^$[\]\\(){}|-])/g,"\\$1");var c="^\\s*(?:[^"+l+"\\\\]+|\\\\\\\\|\\\\.)"+l;if(t.match(new RegExp(c),!0))return w}if(f==="`"){var h=r.formatting;n.highlightFormatting&&(r.formatting="code");var p=B(r),d=t.pos;t.eatWhile("`");var m=1+t.pos-d;return r.code?m===u?(r.code=!1,p):(r.formatting=h,B(r)):(u=m,r.code=!0,B(r))}if(r.code)return B(r);if(f==="!"&&t.match(/\[[^\]]*\] ?(?:\(|\[)/,!1))return t.match(/\[[^\]]*\]/),r.inline=r.f=q,v;if(f==="["&&t.match(/.*\](\(| ?\[)/,!1))return r.linkText=!0,n.highlightFormatting&&(r.formatting="link"),B(r);if(f==="]"&&r.linkText){n.highlightFormatting&&(r.formatting="link");var b=B(r);return r.linkText=!1,r.inline=r.f=q,b}if(f==="<"&&t.match(/^(https?|ftps?):\/\/(?:[^\\>]|\\.)+>/,!1)){r.f=r.inline=I,n.highlightFormatting&&(r.formatting="link");var b=B(r);return b?b+=" ":b="",b+g}if(f==="<"&&t.match(/^[^> \\]+@(?:[^\\>]|\\.)+>/,!1)){r.f=r.inline=I,n.highlightFormatting&&(r.formatting="link");var b=B(r);return b?b+=" ":b="",b+y}if(f==="<"&&t.match(/^\w/,!1)){if(t.string.indexOf(">")!=-1){var E=t.string.substring(1,t.string.indexOf(">"));/markdown\s*=\s*('|"){0,1}1('|"){0,1}/.test(E)&&(r.md_inside=!0)}return t.backUp(1),r.htmlState=e.startState(i),M(t,r,P)}if(f==="<"&&t.match(/^\/\w*?>/))return r.md_inside=!1,"tag";var S=!1;if(!n.underscoresBreakWords&&f==="_"&&t.peek()!=="_"&&t.match(/(\w)/,!1)){var x=t.pos-2;if(x>=0){var T=t.string.charAt(x);T!=="_"&&T.match(/(\w)/,!1)&&(S=!0)}}if(f==="*"||f==="_"&&!S){if(!a||t.peek()!==" "){if(r.strong===f&&t.eat(f)){n.highlightFormatting&&(r.formatting="strong");var p=B(r);return r.strong=!1,p}if(!r.strong&&t.eat(f))return r.strong=f,n.highlightFormatting&&(r.formatting="strong"),B(r);if(r.em===f){n.highlightFormatting&&(r.formatting="em");var p=B(r);return r.em=!1,p}if(!r.em)return r.em=f,n.highlightFormatting&&(r.formatting="em"),B(r)}}else if(f===" ")if(t.eat("*")||t.eat("_")){if(t.peek()===" ")return B(r);t.backUp(1)}return f===" "&&(t.match(/ +$/,!1)?r.trailingSpace++:r.trailingSpace&&(r.trailingSpaceNewLine=!0)),B(r)}function I(e,t){var r=e.next();if(r===">"){t.f=t.inline=F,n.highlightFormatting&&(t.formatting="link");var i=B(t);return i?i+=" ":i="",i+g}return e.match(/^[^>]+/,!0),g}function q(e,t){if(e.eatSpace())return null;var r=e.next();return r==="("||r==="["?(t.f=t.inline=R(r==="("?")":"]"),n.highlightFormatting&&(t.formatting="link-string"),t.linkHref=!0,B(t)):"error"}function R(e){return function(t,r){var i=t.next();if(i===e){r.f=r.inline=F,n.highlightFormatting&&(r.formatting="link-string");var s=B(r);return r.linkHref=!1,s}return t.match(V(e),!0)&&t.backUp(1),r.linkHref=!0,B(r)}}function U(e,t){return e.match(/^[^\]]*\]:/,!1)?(t.f=z,e.next(),n.highlightFormatting&&(t.formatting="link"),t.linkText=!0,B(t)):O(e,t,F)}function z(e,t){if(e.match(/^\]:/,!0)){t.f=t.inline=W,n.highlightFormatting&&(t.formatting="link");var r=B(t);return t.linkText=!1,r}return e.match(/^[^\]]+/,!0),b}function W(e,t){return e.eatSpace()?null:(e.match(/^[^\s]+/,!0),e.peek()===undefined?t.linkTitle=!0:e.match(/^(?:\s+(?:"(?:[^"\\]|\\\\|\\.)+"|'(?:[^'\\]|\\\\|\\.)+'|\((?:[^)\\]|\\\\|\\.)+\)))?/,!0),t.f=t.inline=F,w)}function V(e){return X[e]||(e=(e+"").replace(/([.?*+^$[\]\\(){}|-])/g,"\\$1"),X[e]=new RegExp("^(?:[^\\\\]|\\\\.)*?("+e+")")),X[e]}var r=e.modes.hasOwnProperty("xml"),i=e.getMode(t,r?{name:"xml",htmlMode:!0}:"text/plain"),s={html:"htmlmixed",js:"javascript",json:"application/json",c:"text/x-csrc","c++":"text/x-c++src",java:"text/x-java",csharp:"text/x-csharp","c#":"text/x-csharp",scala:"text/x-scala"},o=function(){var n,r={},i={},o,u=[];for(var a in e.modes)e.modes.propertyIsEnumerable(a)&&u.push(a);for(n=0;n<u.length;n++)r[u[n]]=u[n];var f=[];for(var a in e.mimeModes)e.mimeModes.propertyIsEnumerable(a)&&f.push({mime:a,mode:e.mimeModes[a]});for(n=0;n<f.length;n++)o=f[n].mime,i[o]=f[n].mime;for(var l in s)if(s[l]in r||s[l]in i)r[l]=s[l];return function(n){return r[n]?e.getMode(t,r[n]):null}}();n.highlightFormatting===undefined&&(n.highlightFormatting=!1),n.maxBlockquoteDepth===undefined&&(n.maxBlockquoteDepth=0),n.underscoresBreakWords===undefined&&(n.underscoresBreakWords=!0),n.fencedCodeBlocks===undefined&&(n.fencedCodeBlocks=!1),n.taskLists===undefined&&(n.taskLists=!1);var u=0,a="header",f="comment",l="quote",c="variable-2",h="variable-3",p="keyword",d="hr",v="tag",m="formatting",g="link",y="link",b="link",w="string",E="em",S="strong",x=/^([*\-=_])(?:\s*\1){2,}\s*$/,T=/^[*\-+]\s+/,N=/^[0-9]+\.\s+/,C=/^\[(x| )\](?=\s)/,k=/^#+/,L=/^(?:\={1,}|-{1,})$/,A=/^[^#!\[\]*_\\<>` "'(]+/,X=[],$={startState:function(){return{f:D,prevLineHasContent:!1,thisLineHasContent:!1,block:D,htmlState:null,indentation:0,inline:F,text:j,escape:!1,formatting:!1,linkText:!1,linkHref:!1,linkTitle:!1,em:!1,strong:!1,header:0,taskList:!1,list:!1,listDepth:0,quote:0,trailingSpace:0,trailingSpaceNewLine:!1}},copyState:function(t){return{f:t.f,prevLineHasContent:t.prevLineHasContent,thisLineHasContent:t.thisLineHasContent,block:t.block,htmlState:t.htmlState&&e.copyState(i,t.htmlState),indentation:t.indentation,localMode:t.localMode,localState:t.localMode?e.copyState(t.localMode,t.localState):null,inline:t.inline,text:t.text,escape:!1,formatting:!1,linkTitle:t.linkTitle,em:t.em,strong:t.strong,header:t.header,taskList:t.taskList,list:t.list,listDepth:t.listDepth,quote:t.quote,trailingSpace:t.trailingSpace,trailingSpaceNewLine:t.trailingSpaceNewLine,md_inside:t.md_inside}},token:function(e,t){t.formatting=!1;if(e.sol()){var n=e.match(/^\s*$/,!0)||t.header;t.header=0;if(n)return t.prevLineHasContent=!1,_(t);t.prevLineHasContent=t.thisLineHasContent,t.thisLineHasContent=!0,t.escape=!1,t.taskList=!1,t.code=!1,t.trailingSpace=0,t.trailingSpaceNewLine=!1,t.f=t.block;var r=e.match(/^\s*/,!0)[0].replace(/\t/g,"    ").length,i=Math.floor((r-t.indentation)/4)*4;i>4&&(i=4);var s=t.indentation+i;t.indentationDiff=s-t.indentation,t.indentation=s;if(r>0)return null}var o=t.f(e,t);return e.start==e.pos?this.token(e,t):o},innerMode:function(e){return e.block==P?{state:e.htmlState,mode:i}:e.localState?{state:e.localState,mode:e.localMode}:{state:e,mode:$}},blankLine:_,getType:B,fold:"markdown"};return $},"xml"),e.defineMIME("text/x-markdown","markdown")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/addon/mode/overlay",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.overlayMode=function(t,n,r){return{startState:function(){return{base:e.startState(t),overlay:e.startState(n),basePos:0,baseCur:null,overlayPos:0,overlayCur:null,lineSeen:null}},copyState:function(r){return{base:e.copyState(t,r.base),overlay:e.copyState(n,r.overlay),basePos:r.basePos,baseCur:null,overlayPos:r.overlayPos,overlayCur:null}},token:function(e,i){if(e.sol()||e.string!=i.lineSeen||Math.min(i.basePos,i.overlayPos)<e.start)i.lineSeen=e.string,i.basePos=i.overlayPos=e.start;return e.start==i.basePos&&(i.baseCur=t.token(e,i.base),i.basePos=e.pos),e.start==i.overlayPos&&(e.pos=e.start,i.overlayCur=n.token(e,i.overlay),i.overlayPos=e.pos),e.pos=Math.min(i.basePos,i.overlayPos),i.overlayCur==null?i.baseCur:i.baseCur!=null&&i.overlay.combineTokens||r&&i.overlay.combineTokens==null?i.baseCur+" "+i.overlayCur:i.overlayCur},indent:t.indent&&function(e,n){return t.indent(e.base,n)},electricChars:t.electricChars,innerMode:function(e){return{state:e.base,mode:t}},blankLine:function(e){t.blankLine&&t.blankLine(e.base),n.blankLine&&n.blankLine(e.overlay)}}}}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../markdown/markdown"),require("../../addon/mode/overlay")):typeof define=="function"&&define.amd?define("components/codemirror/mode/gfm/gfm",["../../lib/codemirror","../markdown/markdown","../../addon/mode/overlay"],e):e(CodeMirror)}(function(e){e.defineMode("gfm",function(t,n){function i(e){return e.code=!1,null}var r=0,s={startState:function(){return{code:!1,codeBlock:!1,ateSpace:!1}},copyState:function(e){return{code:e.code,codeBlock:e.codeBlock,ateSpace:e.ateSpace}},token:function(e,t){t.combineTokens=null;if(t.codeBlock)return e.match(/^```/)?(t.codeBlock=!1,null):(e.skipToEnd(),null);e.sol()&&(t.code=!1);if(e.sol()&&e.match(/^```/))return e.skipToEnd(),t.codeBlock=!0,null;if(e.peek()==="`"){e.next();var n=e.pos;e.eatWhile("`");var i=1+e.pos-n;return t.code?i===r&&(t.code=!1):(r=i,t.code=!0),null}if(t.code)return e.next(),null;if(e.eatSpace())return t.ateSpace=!0,null;if(e.sol()||t.ateSpace){t.ateSpace=!1;if(e.match(/^(?:[a-zA-Z0-9\-_]+\/)?(?:[a-zA-Z0-9\-_]+@)?(?:[a-f0-9]{7,40}\b)/))return t.combineTokens=!0,"link";if(e.match(/^(?:[a-zA-Z0-9\-_]+\/)?(?:[a-zA-Z0-9\-_]+)?#[0-9]+\b/))return t.combineTokens=!0,"link"}return e.match(/^((?:[a-z][\w-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]|\([^\s()<>]*\))+(?:\([^\s()<>]*\)|[^\s`*!()\[\]{};:'".,<>?«»“”‘’]))/i)&&e.string.slice(e.start-2,e.start)!="]("?(t.combineTokens=!0,"link"):(e.next(),null)},blankLine:i},o={underscoresBreakWords:!1,taskLists:!0,fencedCodeBlocks:!0};for(var u in n)o[u]=n[u];return o.name="markdown",e.defineMIME("gfmBase",o),e.overlayMode(e.getMode(t,"gfmBase"),s)},"markdown")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/gherkin/gherkin",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("gherkin",function(){return{startState:function(){return{lineNumber:0,tableHeaderLine:!1,allowFeature:!0,allowBackground:!1,allowScenario:!1,allowSteps:!1,allowPlaceholders:!1,allowMultilineArgument:!1,inMultilineString:!1,inMultilineTable:!1,inKeywordLine:!1}},token:function(e,t){e.sol()&&(t.lineNumber++,t.inKeywordLine=!1,t.inMultilineTable&&(t.tableHeaderLine=!1,e.match(/\s*\|/,!1)||(t.allowMultilineArgument=!1,t.inMultilineTable=!1))),e.eatSpace();if(t.allowMultilineArgument){if(t.inMultilineString)return e.match('"""')?(t.inMultilineString=!1,t.allowMultilineArgument=!1):e.match(/.*/),"string";if(t.inMultilineTable)return e.match(/\|\s*/)?"bracket":(e.match(/[^\|]*/),t.tableHeaderLine?"header":"string");if(e.match('"""'))return t.inMultilineString=!0,"string";if(e.match("|"))return t.inMultilineTable=!0,t.tableHeaderLine=!0,"bracket"}return e.match(/#.*/)?"comment":!t.inKeywordLine&&e.match(/@\S+/)?"tag":!t.inKeywordLine&&t.allowFeature&&e.match(/(機能|功能|フィーチャ|기능|โครงหลัก|ความสามารถ|ความต้องการทางธุรกิจ|ಹೆಚ್ಚಳ|గుణము|ਮੁਹਾਂਦਰਾ|ਨਕਸ਼ ਨੁਹਾਰ|ਖਾਸੀਅਤ|रूप लेख|وِیژگی|خاصية|תכונה|Функціонал|Функция|Функционалност|Функционал|Үзенчәлеклелек|Свойство|Особина|Мөмкинлек|Могућност|Λειτουργία|Δυνατότητα|Właściwość|Vlastnosť|Trajto|Tính năng|Savybė|Pretty much|Požiadavka|Požadavek|Potrzeba biznesowa|Özellik|Osobina|Ominaisuus|Omadus|OH HAI|Mogućnost|Mogucnost|Jellemző|Hwæt|Hwaet|Funzionalità|Funktionalitéit|Funktionalität|Funkcja|Funkcionalnost|Funkcionalitāte|Funkcia|Fungsi|Functionaliteit|Funcționalitate|Funcţionalitate|Functionalitate|Funcionalitat|Funcionalidade|Fonctionnalité|Fitur|Fīča|Feature|Eiginleiki|Egenskap|Egenskab|Característica|Caracteristica|Business Need|Aspekt|Arwedd|Ahoy matey!|Ability):/)?(t.allowScenario=!0,t.allowBackground=!0,t.allowPlaceholders=!1,t.allowSteps=!1,t.allowMultilineArgument=!1,t.inKeywordLine=!0,"keyword"):!t.inKeywordLine&&t.allowBackground&&e.match(/(背景|배경|แนวคิด|ಹಿನ್ನೆಲೆ|నేపథ్యం|ਪਿਛੋਕੜ|पृष्ठभूमि|زمینه|الخلفية|רקע|Тарих|Предыстория|Предистория|Позадина|Передумова|Основа|Контекст|Кереш|Υπόβαθρο|Założenia|Yo\-ho\-ho|Tausta|Taust|Situācija|Rerefons|Pozadina|Pozadie|Pozadí|Osnova|Latar Belakang|Kontext|Konteksts|Kontekstas|Kontekst|Háttér|Hannergrond|Grundlage|Geçmiş|Fundo|Fono|First off|Dis is what went down|Dasar|Contexto|Contexte|Context|Contesto|Cenário de Fundo|Cenario de Fundo|Cefndir|Bối cảnh|Bakgrunnur|Bakgrunn|Bakgrund|Baggrund|Background|B4|Antecedents|Antecedentes|Ær|Aer|Achtergrond):/)?(t.allowPlaceholders=!1,t.allowSteps=!0,t.allowBackground=!1,t.allowMultilineArgument=!1,t.inKeywordLine=!0,"keyword"):!t.inKeywordLine&&t.allowScenario&&e.match(/(場景大綱|场景大纲|劇本大綱|剧本大纲|テンプレ|シナリオテンプレート|シナリオテンプレ|シナリオアウトライン|시나리오 개요|สรุปเหตุการณ์|โครงสร้างของเหตุการณ์|ವಿವರಣೆ|కథనం|ਪਟਕਥਾ ਰੂਪ ਰੇਖਾ|ਪਟਕਥਾ ਢਾਂਚਾ|परिदृश्य रूपरेखा|سيناريو مخطط|الگوی سناریو|תבנית תרחיש|Сценарийның төзелеше|Сценарий структураси|Структура сценарію|Структура сценария|Структура сценарија|Скица|Рамка на сценарий|Концепт|Περιγραφή Σεναρίου|Wharrimean is|Template Situai|Template Senario|Template Keadaan|Tapausaihio|Szenariogrundriss|Szablon scenariusza|Swa hwær swa|Swa hwaer swa|Struktura scenarija|Structură scenariu|Structura scenariu|Skica|Skenario konsep|Shiver me timbers|Senaryo taslağı|Schema dello scenario|Scenariomall|Scenariomal|Scenario Template|Scenario Outline|Scenario Amlinellol|Scenārijs pēc parauga|Scenarijaus šablonas|Reckon it's like|Raamstsenaarium|Plang vum Szenario|Plan du Scénario|Plan du scénario|Osnova scénáře|Osnova Scenára|Náčrt Scenáru|Náčrt Scénáře|Náčrt Scenára|MISHUN SRSLY|Menggariskan Senario|Lýsing Dæma|Lýsing Atburðarásar|Konturo de la scenaro|Koncept|Khung tình huống|Khung kịch bản|Forgatókönyv vázlat|Esquema do Cenário|Esquema do Cenario|Esquema del escenario|Esquema de l'escenari|Esbozo do escenario|Delineação do Cenário|Delineacao do Cenario|All y'all|Abstrakt Scenario|Abstract Scenario):/)?(t.allowPlaceholders=!0,t.allowSteps=!0,t.allowMultilineArgument=!1,t.inKeywordLine=!0,"keyword"):t.allowScenario&&e.match(/(例子|例|サンプル|예|ชุดของเหตุการณ์|ชุดของตัวอย่าง|ಉದಾಹರಣೆಗಳು|ఉదాహరణలు|ਉਦਾਹਰਨਾਂ|उदाहरण|نمونه ها|امثلة|דוגמאות|Үрнәкләр|Сценарији|Примеры|Примери|Приклади|Мисоллар|Мисаллар|Σενάρια|Παραδείγματα|You'll wanna|Voorbeelden|Variantai|Tapaukset|Se þe|Se the|Se ðe|Scenarios|Scenariji|Scenarijai|Przykłady|Primjeri|Primeri|Příklady|Príklady|Piemēri|Példák|Pavyzdžiai|Paraugs|Örnekler|Juhtumid|Exemplos|Exemples|Exemple|Exempel|EXAMPLZ|Examples|Esempi|Enghreifftiau|Ekzemploj|Eksempler|Ejemplos|Dữ liệu|Dead men tell no tales|Dæmi|Contoh|Cenários|Cenarios|Beispiller|Beispiele|Atburðarásir):/)?(t.allowPlaceholders=!1,t.allowSteps=!0,t.allowBackground=!1,t.allowMultilineArgument=!0,"keyword"):!t.inKeywordLine&&t.allowScenario&&e.match(/(場景|场景|劇本|剧本|シナリオ|시나리오|เหตุการณ์|ಕಥಾಸಾರಾಂಶ|సన్నివేశం|ਪਟਕਥਾ|परिदृश्य|سيناريو|سناریو|תרחיש|Сценарій|Сценарио|Сценарий|Пример|Σενάριο|Tình huống|The thing of it is|Tapaus|Szenario|Swa|Stsenaarium|Skenario|Situai|Senaryo|Senario|Scenaro|Scenariusz|Scenariu|Scénario|Scenario|Scenarijus|Scenārijs|Scenarij|Scenarie|Scénář|Scenár|Primer|MISHUN|Kịch bản|Keadaan|Heave to|Forgatókönyv|Escenario|Escenari|Cenário|Cenario|Awww, look mate|Atburðarás):/)?(t.allowPlaceholders=!1,t.allowSteps=!0,t.allowBackground=!1,t.allowMultilineArgument=!1,t.inKeywordLine=!0,"keyword"):!t.inKeywordLine&&t.allowSteps&&e.match(/(那麼|那么|而且|當|当|并且|同時|同时|前提|假设|假設|假定|假如|但是|但し|並且|もし|ならば|ただし|しかし|かつ|하지만|조건|먼저|만일|만약|단|그리고|그러면|และ |เมื่อ |แต่ |ดังนั้น |กำหนดให้ |ಸ್ಥಿತಿಯನ್ನು |ಮತ್ತು |ನೀಡಿದ |ನಂತರ |ಆದರೆ |మరియు |చెప్పబడినది |కాని |ఈ పరిస్థితిలో |అప్పుడు |ਪਰ |ਤਦ |ਜੇਕਰ |ਜਿਵੇਂ ਕਿ |ਜਦੋਂ |ਅਤੇ |यदि |परन्तु |पर |तब |तदा |तथा |जब |चूंकि |किन्तु |कदा |और |अगर |و |هنگامی |متى |لكن |عندما |ثم |بفرض |با فرض |اما |اذاً |آنگاه |כאשר |וגם |בהינתן |אזי |אז |אבל |Якщо |Һәм |Унда |Тоді |Тогда |То |Также |Та |Пусть |Припустимо, що |Припустимо |Онда |Но |Нехай |Нәтиҗәдә |Лекин |Ләкин |Коли |Когда |Когато |Када |Кад |К тому же |І |И |Задато |Задати |Задате |Если |Допустим |Дано |Дадено |Вә |Ва |Бирок |Әмма |Әйтик |Әгәр |Аммо |Али |Але |Агар |А також |А |Τότε |Όταν |Και |Δεδομένου |Αλλά |Þurh |Þegar |Þa þe |Þá |Þa |Zatati |Zakładając |Zadato |Zadate |Zadano |Zadani |Zadan |Za předpokladu |Za predpokladu |Youse know when youse got |Youse know like when |Yna |Yeah nah |Y'know |Y |Wun |Wtedy |When y'all |When |Wenn |WEN |wann |Ve |Và |Und |Un |ugeholl |Too right |Thurh |Thì |Then y'all |Then |Tha the |Tha |Tetapi |Tapi |Tak |Tada |Tad |Stel |Soit |Siis |Și |Şi |Si |Sed |Se |Så |Quando |Quand |Quan |Pryd |Potom |Pokud |Pokiaľ |Però |Pero |Pak |Oraz |Onda |Ond |Oletetaan |Og |Och |O zaman |Niin |Nhưng |När |Når |Mutta |Men |Mas |Maka |Majd |Mając |Mais |Maar |mä |Ma |Lorsque |Lorsqu'|Logo |Let go and haul |Kun |Kuid |Kui |Kiedy |Khi |Ketika |Kemudian |Keď |Když |Kaj |Kai |Kada |Kad |Jeżeli |Jeśli |Ja |It's just unbelievable |Ir |I CAN HAZ |I |Ha |Givun |Givet |Given y'all |Given |Gitt |Gegeven |Gegeben seien |Gegeben sei |Gdy |Gangway! |Fakat |Étant donnés |Etant donnés |Étant données |Etant données |Étant donnée |Etant donnée |Étant donné |Etant donné |Et |És |Entonces |Entón |Então |Entao |En |Eğer ki |Ef |Eeldades |E |Ðurh |Duota |Dun |Donitaĵo |Donat |Donada |Do |Diyelim ki |Diberi |Dengan |Den youse gotta |DEN |De |Dato |Dați fiind |Daţi fiind |Dati fiind |Dati |Date fiind |Date |Data |Dat fiind |Dar |Dann |dann |Dan |Dados |Dado |Dadas |Dada |Ða ðe |Ða |Cuando |Cho |Cando |Când |Cand |Cal |But y'all |But at the end of the day I reckon |BUT |But |Buh |Blimey! |Biết |Bet |Bagi |Aye |awer |Avast! |Atunci |Atesa |Atès |Apabila |Anrhegedig a |Angenommen |And y'all |And |AN |An |an |Amikor |Amennyiben |Ama |Als |Alors |Allora |Ali |Aleshores |Ale |Akkor |Ak |Adott |Ac |Aber |A zároveň |A tiež |A taktiež |A také |A |a |7 |\* )/)?(t.inStep=!0,t.allowPlaceholders=!0,t.allowMultilineArgument=!0,t.inKeywordLine=!0,"keyword"):e.match(/"[^"]*"?/)?"string":t.allowPlaceholders&&e.match(/<[^>]*>?/)?"variable":(e.next(),e.eatWhile(/[^@"<#]/),null)}}}),e.defineMIME("text/x-feature","gherkin")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/go/go",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("go",function(e){function o(e,t){var o=e.next();if(o=='"'||o=="'"||o=="`")return t.tokenize=u(o),t.tokenize(e,t);if(/[\d\.]/.test(o))return o=="."?e.match(/^[0-9]+([eE][\-+]?[0-9]+)?/):o=="0"?e.match(/^[xX][0-9a-fA-F]+/)||e.match(/^0[0-7]+/):e.match(/^[0-9]*\.?[0-9]*([eE][\-+]?[0-9]+)?/),"number";if(/[\[\]{}\(\),;\:\.]/.test(o))return s=o,null;if(o=="/"){if(e.eat("*"))return t.tokenize=a,a(e,t);if(e.eat("/"))return e.skipToEnd(),"comment"}if(i.test(o))return e.eatWhile(i),"operator";e.eatWhile(/[\w\$_]/);var f=e.current();if(n.propertyIsEnumerable(f)){if(f=="case"||f=="default")s="case";return"keyword"}return r.propertyIsEnumerable(f)?"atom":"variable"}function u(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r&&e!="`")n.tokenize=o;return"string"}}function a(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=o;break}n=r=="*"}return"comment"}function f(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function l(e,t,n){return e.context=new f(e.indented,t,n,null,e.context)}function c(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}var t=e.indentUnit,n={"break":!0,"case":!0,chan:!0,"const":!0,"continue":!0,"default":!0,defer:!0,"else":!0,fallthrough:!0,"for":!0,func:!0,go:!0,"goto":!0,"if":!0,"import":!0,"interface":!0,map:!0,"package":!0,range:!0,"return":!0,select:!0,struct:!0,"switch":!0,type:!0,"var":!0,bool:!0,"byte":!0,complex64:!0,complex128:!0,float32:!0,float64:!0,int8:!0,int16:!0,int32:!0,int64:!0,string:!0,uint8:!0,uint16:!0,uint32:!0,uint64:!0,"int":!0,uint:!0,uintptr:!0},r={"true":!0,"false":!0,iota:!0,nil:!0,append:!0,cap:!0,close:!0,complex:!0,copy:!0,imag:!0,len:!0,make:!0,"new":!0,panic:!0,print:!0,println:!0,real:!0,recover:!0},i=/[+\-*&^%:=<>!|\/]/,s;return{startState:function(e){return{tokenize:null,context:new f((e||0)-t,0,"top",!1),indented:0,startOfLine:!0}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0,n.type=="case"&&(n.type="}"));if(e.eatSpace())return null;s=null;var r=(t.tokenize||o)(e,t);return r=="comment"?r:(n.align==null&&(n.align=!0),s=="{"?l(t,e.column(),"}"):s=="["?l(t,e.column(),"]"):s=="("?l(t,e.column(),")"):s=="case"?n.type="case":s=="}"&&n.type=="}"?n=c(t):s==n.type&&c(t),t.startOfLine=!1,r)},indent:function(e,n){if(e.tokenize!=o&&e.tokenize!=null)return 0;var r=e.context,i=n&&n.charAt(0);if(r.type=="case"&&/^(?:case|default)\b/.test(n))return e.context.type="}",r.indented;var s=i==r.type;return r.align?r.column+(s?0:1):r.indented+(s?0:t)},electricChars:"{}):",fold:"brace",blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//"}}),e.defineMIME("text/x-go","go")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/groovy/groovy",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("groovy",function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function o(e,t){var o=e.next();if(o=='"'||o=="'")return u(o,e,t);if(/[\[\]{}\(\),;\:\.]/.test(o))return s=o,null;if(/\d/.test(o))return e.eatWhile(/[\w\.]/),e.eat(/eE/)&&(e.eat(/\+\-/),e.eatWhile(/\d/)),"number";if(o=="/"){if(e.eat("*"))return t.tokenize.push(f),f(e,t);if(e.eat("/"))return e.skipToEnd(),"comment";if(l(t.lastToken))return u(o,e,t)}if(o=="-"&&e.eat(">"))return s="->",null;if(/[+\-*&%=<>!?|\/~]/.test(o))return e.eatWhile(/[+\-*&%=<>|~]/),"operator";e.eatWhile(/[\w\$_]/);if(o=="@")return e.eatWhile(/[\w\$_\.]/),"meta";if(t.lastToken==".")return"property";if(e.eat(":"))return s="proplabel","property";var a=e.current();return i.propertyIsEnumerable(a)?"atom":n.propertyIsEnumerable(a)?(r.propertyIsEnumerable(a)&&(s="newstatement"),"keyword"):"variable"}function u(e,t,n){function i(t,n){var i=!1,s,o=!r;while((s=t.next())!=null){if(s==e&&!i){if(!r)break;if(t.match(e+e)){o=!0;break}}if(e=='"'&&s=="$"&&!i&&t.eat("{"))return n.tokenize.push(a()),"string";i=!i&&s=="\\"}return o&&n.tokenize.pop(),"string"}var r=!1;if(e!="/"&&t.eat(e)){if(!t.eat(e))return"string";r=!0}return n.tokenize.push(i),i(t,n)}function a(){function t(t,n){if(t.peek()=="}"){e--;if(e==0)return n.tokenize.pop(),n.tokenize[n.tokenize.length-1](t,n)}else t.peek()=="{"&&e++;return o(t,n)}var e=1;return t.isBase=!0,t}function f(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize.pop();break}n=r=="*"}return"comment"}function l(e){return!e||e=="operator"||e=="->"||/[\.\[\{\(,;:]/.test(e)||e=="newstatement"||e=="keyword"||e=="proplabel"}function c(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function h(e,t,n){return e.context=new c(e.indented,t,n,null,e.context)}function p(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}var n=t("abstract as assert boolean break byte case catch char class const continue def default do double else enum extends final finally float for goto if implements import in instanceof int interface long native new package private protected public return short static strictfp super switch synchronized threadsafe throw throws transient try void volatile while"),r=t("catch class do else finally for if switch try while enum interface def"),i=t("null true false this"),s;return o.isBase=!0,{startState:function(t){return{tokenize:[o],context:new c((t||0)-e.indentUnit,0,"top",!1),indented:0,startOfLine:!0,lastToken:null}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0,n.type=="statement"&&!l(t.lastToken)&&(p(t),n=t.context));if(e.eatSpace())return null;s=null;var r=t.tokenize[t.tokenize.length-1](e,t);if(r=="comment")return r;n.align==null&&(n.align=!0);if(s!=";"&&s!=":"||n.type!="statement")if(s=="->"&&n.type=="statement"&&n.prev.type=="}")p(t),t.context.align=!1;else if(s=="{")h(t,e.column(),"}");else if(s=="[")h(t,e.column(),"]");else if(s=="(")h(t,e.column(),")");else if(s=="}"){while(n.type=="statement")n=p(t);n.type=="}"&&(n=p(t));while(n.type=="statement")n=p(t)}else s==n.type?p(t):(n.type=="}"||n.type=="top"||n.type=="statement"&&s=="newstatement")&&h(t,e.column(),"statement");else p(t);return t.startOfLine=!1,t.lastToken=s||r,r},indent:function(t,n){if(!t.tokenize[t.tokenize.length-1].isBase)return 0;var r=n&&n.charAt(0),i=t.context;i.type=="statement"&&!l(t.lastToken)&&(i=i.prev);var s=r==i.type;return i.type=="statement"?i.indented+(r=="{"?0:e.indentUnit):i.align?i.column+(s?0:1):i.indented+(s?0:e.indentUnit)},electricChars:"{}",fold:"brace"}}),e.defineMIME("text/x-groovy","groovy")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/javascript/javascript",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("javascript",function(t,n){function c(e){var t=!1,n,r=!1;while((n=e.next())!=null){if(!t){if(n=="/"&&!r)return;n=="["?r=!0:r&&n=="]"&&(r=!1)}t=!t&&n=="\\"}}function d(e,t,n){return h=e,p=n,t}function v(e,t){var n=e.next();if(n=='"'||n=="'")return t.tokenize=m(n),t.tokenize(e,t);if(n=="."&&e.match(/^\d+(?:[eE][+\-]?\d+)?/))return d("number","number");if(n=="."&&e.match(".."))return d("spread","meta");if(/[\[\]{}\(\),;\:\.]/.test(n))return d(n);if(n=="="&&e.eat(">"))return d("=>","operator");if(n=="0"&&e.eat(/x/i))return e.eatWhile(/[\da-f]/i),d("number","number");if(/\d/.test(n))return e.match(/^\d*(?:\.\d*)?(?:[eE][+\-]?\d+)?/),d("number","number");if(n=="/")return e.eat("*")?(t.tokenize=g,g(e,t)):e.eat("/")?(e.skipToEnd(),d("comment","comment")):t.lastType=="operator"||t.lastType=="keyword c"||t.lastType=="sof"||/^[\[{}\(,;:]$/.test(t.lastType)?(c(e),e.eatWhile(/[gimy]/),d("regexp","string-2")):(e.eatWhile(f),d("operator","operator",e.current()));if(n=="`")return t.tokenize=y,y(e,t);if(n=="#")return e.skipToEnd(),d("error","error");if(f.test(n))return e.eatWhile(f),d("operator","operator",e.current());e.eatWhile(/[\w\$_]/);var r=e.current(),i=a.propertyIsEnumerable(r)&&a[r];return i&&t.lastType!="."?d(i.type,i.style,r):d("variable","variable",r)}function m(e){return function(t,n){var r=!1,i;if(s&&t.peek()=="@"&&t.match(l))return n.tokenize=v,d("jsonld-keyword","meta");while((i=t.next())!=null){if(i==e&&!r)break;r=!r&&i=="\\"}return r||(n.tokenize=v),d("string","string")}}function g(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=v;break}n=r=="*"}return d("comment","comment")}function y(e,t){var n=!1,r;while((r=e.next())!=null){if(!n&&(r=="`"||r=="$"&&e.eat("{"))){t.tokenize=v;break}n=!n&&r=="\\"}return d("quasi","string-2",e.current())}function w(e,t){t.fatArrowAt&&(t.fatArrowAt=null);var n=e.string.indexOf("=>",e.start);if(n<0)return;var r=0,i=!1;for(var s=n-1;s>=0;--s){var o=e.string.charAt(s),u=b.indexOf(o);if(u>=0&&u<3){if(!r){++s;break}if(--r==0)break}else if(u>=3&&u<6)++r;else if(/[$\w]/.test(o))i=!0;else if(i&&!r){++s;break}}i&&!r&&(t.fatArrowAt=s)}function S(e,t,n,r,i,s){this.indented=e,this.column=t,this.type=n,this.prev=i,this.info=s,r!=null&&(this.align=r)}function x(e,t){for(var n=e.localVars;n;n=n.next)if(n.name==t)return!0;for(var r=e.context;r;r=r.prev)for(var n=r.vars;n;n=n.next)if(n.name==t)return!0}function T(e,t,n,r,i){var s=e.cc;N.state=e,N.stream=i,N.marked=null,N.cc=s,N.style=t,e.lexical.hasOwnProperty("align")||(e.lexical.align=!0);for(;;){var u=s.length?s.pop():o?B:H;if(u(n,r)){while(s.length&&s[s.length-1].lex)s.pop()();return N.marked?N.marked:n=="variable"&&x(e,r)?"variable-2":t}}}function C(){for(var e=arguments.length-1;e>=0;e--)N.cc.push(arguments[e])}function k(){return C.apply(null,arguments),!0}function L(e){function t(t){for(var n=t;n;n=n.next)if(n.name==e)return!0;return!1}var r=N.state;if(r.context){N.marked="def";if(t(r.localVars))return;r.localVars={name:e,next:r.localVars}}else{if(t(r.globalVars))return;n.globalVars&&(r.globalVars={name:e,next:r.globalVars})}}function O(){N.state.context={prev:N.state.context,vars:N.state.localVars},N.state.localVars=A}function M(){N.state.localVars=N.state.context.vars,N.state.context=N.state.context.prev}function _(e,t){var n=function(){var n=N.state,r=n.indented;n.lexical.type=="stat"&&(r=n.lexical.indented),n.lexical=new S(r,N.stream.column(),e,null,n.lexical,t)};return n.lex=!0,n}function D(){var e=N.state;e.lexical.prev&&(e.lexical.type==")"&&(e.indented=e.lexical.indented),e.lexical=e.lexical.prev)}function P(e){function t(n){return n==e?k():e==";"?C():k(t)}return t}function H(e,t){return e=="var"?k(_("vardef",t.length),rt,P(";"),D):e=="keyword a"?k(_("form"),B,H,D):e=="keyword b"?k(_("form"),H,D):e=="{"?k(_("}"),et,D):e==";"?k():e=="if"?(N.state.lexical.info=="else"&&N.state.cc[N.state.cc.length-1]==D&&N.state.cc.pop()(),k(_("form"),B,H,D,at)):e=="function"?k(dt):e=="for"?k(_("form"),ft,H,D):e=="variable"?k(_("stat"),$):e=="switch"?k(_("form"),B,_("}","switch"),P("{"),et,D,D):e=="case"?k(B,P(":")):e=="default"?k(P(":")):e=="catch"?k(_("form"),O,P("("),vt,P(")"),H,D,M):e=="module"?k(_("form"),O,wt,M,D):e=="class"?k(_("form"),mt,D):e=="export"?k(_("form"),Et,D):e=="import"?k(_("form"),St,D):C(_("stat"),B,P(";"),D)}function B(e){return F(e,!1)}function j(e){return F(e,!0)}function F(e,t){if(N.state.fatArrowAt==N.stream.start){var n=t?V:X;if(e=="(")return k(O,_(")"),Y(it,")"),D,P("=>"),n,M);if(e=="variable")return C(O,it,P("=>"),n,M)}var r=t?U:R;return E.hasOwnProperty(e)?k(r):e=="function"?k(dt,r):e=="keyword c"?k(t?q:I):e=="("?k(_(")"),I,kt,P(")"),D,r):e=="operator"||e=="spread"?k(t?j:B):e=="["?k(_("]"),Nt,D,r):e=="{"?Z(K,"}",null,r):e=="quasi"?C(z,r):k()}function I(e){return e.match(/[;\}\)\],]/)?C():C(B)}function q(e){return e.match(/[;\}\)\],]/)?C():C(j)}function R(e,t){return e==","?k(B):U(e,t,!1)}function U(e,t,n){var r=n==0?R:U,i=n==0?B:j;if(t=="=>")return k(O,n?V:X,M);if(e=="operator")return/\+\+|--/.test(t)?k(r):t=="?"?k(B,P(":"),i):k(i);if(e=="quasi")return C(z,r);if(e==";")return;if(e=="(")return Z(j,")","call",r);if(e==".")return k(J,r);if(e=="[")return k(_("]"),I,P("]"),D,r)}function z(e,t){return e!="quasi"?C():t.slice(t.length-2)!="${"?k(z):k(B,W)}function W(e){if(e=="}")return N.marked="string-2",N.state.tokenize=y,k(z)}function X(e){return w(N.stream,N.state),e=="{"?C(H):C(B)}function V(e){return w(N.stream,N.state),e=="{"?C(H):C(j)}function $(e){return e==":"?k(D,H):C(R,P(";"),D)}function J(e){if(e=="variable")return N.marked="property",k()}function K(e,t){if(e=="variable"||N.style=="keyword")return N.marked="property",t=="get"||t=="set"?k(Q):k(G);if(e=="number"||e=="string")return N.marked=s?"property":N.style+" property",k(G);if(e=="jsonld-keyword")return k(G);if(e=="[")return k(B,P("]"),G)}function Q(e){return e!="variable"?C(G):(N.marked="property",k(dt))}function G(e){if(e==":")return k(j);if(e=="(")return C(dt)}function Y(e,t){function n(r){if(r==","){var i=N.state.lexical;return i.info=="call"&&(i.pos=(i.pos||0)+1),k(e,n)}return r==t?k():k(P(t))}return function(r){return r==t?k():C(e,n)}}function Z(e,t,n){for(var r=3;r<arguments.length;r++)N.cc.push(arguments[r]);return k(_(t,n),Y(e,t),D)}function et(e){return e=="}"?k():C(H,et)}function tt(e){if(u&&e==":")return k(nt)}function nt(e){if(e=="variable")return N.marked="variable-3",k()}function rt(){return C(it,tt,ot,ut)}function it(e,t){if(e=="variable")return L(t),k();if(e=="[")return Z(it,"]");if(e=="{")return Z(st,"}")}function st(e,t){return e=="variable"&&!N.stream.match(/^\s*:/,!1)?(L(t),k(ot)):(e=="variable"&&(N.marked="property"),k(P(":"),it,ot))}function ot(e,t){if(t=="=")return k(j)}function ut(e){if(e==",")return k(rt)}function at(e,t){if(e=="keyword b"&&t=="else")return k(_("form","else"),H,D)}function ft(e){if(e=="(")return k(_(")"),lt,P(")"),D)}function lt(e){return e=="var"?k(rt,P(";"),ht):e==";"?k(ht):e=="variable"?k(ct):C(B,P(";"),ht)}function ct(e,t){return t=="in"||t=="of"?(N.marked="keyword",k(B)):k(R,ht)}function ht(e,t){return e==";"?k(pt):t=="in"||t=="of"?(N.marked="keyword",k(B)):C(B,P(";"),pt)}function pt(e){e!=")"&&k(B)}function dt(e,t){if(t=="*")return N.marked="keyword",k(dt);if(e=="variable")return L(t),k(dt);if(e=="(")return k(O,_(")"),Y(vt,")"),D,H,M)}function vt(e){return e=="spread"?k(vt):C(it,tt)}function mt(e,t){if(e=="variable")return L(t),k(gt)}function gt(e,t){if(t=="extends")return k(B,gt);if(e=="{")return k(_("}"),yt,D)}function yt(e,t){if(e=="variable"||N.style=="keyword")return N.marked="property",t=="get"||t=="set"?k(bt,dt,yt):k(dt,yt);if(t=="*")return N.marked="keyword",k(yt);if(e==";")return k(yt);if(e=="}")return k()}function bt(e){return e!="variable"?C():(N.marked="property",k())}function wt(e,t){if(e=="string")return k(H);if(e=="variable")return L(t),k(Tt)}function Et(e,t){return t=="*"?(N.marked="keyword",k(Tt,P(";"))):t=="default"?(N.marked="keyword",k(B,P(";"))):C(H)}function St(e){return e=="string"?k():C(xt,Tt)}function xt(e,t){return e=="{"?Z(xt,"}"):(e=="variable"&&L(t),k())}function Tt(e,t){if(t=="from")return N.marked="keyword",k(B)}function Nt(e){return e=="]"?k():C(j,Ct)}function Ct(e){return e=="for"?C(kt,P("]")):e==","?k(Y(j,"]")):C(Y(j,"]"))}function kt(e){if(e=="for")return k(ft,kt);if(e=="if")return k(B,kt)}var r=t.indentUnit,i=n.statementIndent,s=n.jsonld,o=n.json||s,u=n.typescript,a=function(){function e(e){return{type:e,style:"keyword"}}var t=e("keyword a"),n=e("keyword b"),r=e("keyword c"),i=e("operator"),s={type:"atom",style:"atom"},o={"if":e("if"),"while":t,"with":t,"else":n,"do":n,"try":n,"finally":n,"return":r,"break":r,"continue":r,"new":r,"delete":r,"throw":r,"debugger":r,"var":e("var"),"const":e("var"),let:e("var"),"function":e("function"),"catch":e("catch"),"for":e("for"),"switch":e("switch"),"case":e("case"),"default":e("default"),"in":i,"typeof":i,"instanceof":i,"true":s,"false":s,"null":s,"undefined":s,NaN:s,Infinity:s,"this":e("this"),module:e("module"),"class":e("class"),"super":e("atom"),yield:r,"export":e("export"),"import":e("import"),"extends":r};if(u){var a={type:"variable",style:"variable-3"},f={"interface":e("interface"),"extends":e("extends"),constructor:e("constructor"),"public":e("public"),"private":e("private"),"protected":e("protected"),"static":e("static"),string:a,number:a,bool:a,any:a};for(var l in f)o[l]=f[l]}return o}(),f=/[+\-*&%=<>!?|~^]/,l=/^@(context|id|value|language|type|container|list|set|reverse|index|base|vocab|graph)"/,h,p,b="([{}])",E={atom:!0,number:!0,variable:!0,string:!0,regexp:!0,"this":!0,"jsonld-keyword":!0},N={state:null,column:null,marked:null,cc:null},A={name:"this",next:{name:"arguments"}};return D.lex=!0,{startState:function(e){var t={tokenize:v,lastType:"sof",cc:[],lexical:new S((e||0)-r,0,"block",!1),localVars:n.localVars,context:n.localVars&&{vars:n.localVars},indented:0};return n.globalVars&&typeof n.globalVars=="object"&&(t.globalVars=n.globalVars),t},token:function(e,t){e.sol()&&(t.lexical.hasOwnProperty("align")||(t.lexical.align=!1),t.indented=e.indentation(),w(e,t));if(t.tokenize!=g&&e.eatSpace())return null;var n=t.tokenize(e,t);return h=="comment"?n:(t.lastType=h!="operator"||p!="++"&&p!="--"?h:"incdec",T(t,n,h,p,e))},indent:function(t,s){if(t.tokenize==g)return e.Pass;if(t.tokenize!=v)return 0;var o=s&&s.charAt(0),u=t.lexical;if(!/^\s*else\b/.test(s))for(var a=t.cc.length-1;a>=0;--a){var f=t.cc[a];if(f==D)u=u.prev;else if(f!=at)break}u.type=="stat"&&o=="}"&&(u=u.prev),i&&u.type==")"&&u.prev.type=="stat"&&(u=u.prev);var l=u.type,c=o==l;return l=="vardef"?u.indented+(t.lastType=="operator"||t.lastType==","?u.info+1:0):l=="form"&&o=="{"?u.indented:l=="form"?u.indented+r:l=="stat"?u.indented+(t.lastType=="operator"||t.lastType==","?i||r:0):u.info=="switch"&&!c&&n.doubleIndentSwitch!=0?u.indented+(/^(?:case|default)\b/.test(s)?r:2*r):u.align?u.column+(c?0:1):u.indented+(c?0:r)},electricChars:":{}",blockCommentStart:o?null:"/*",blockCommentEnd:o?null:"*/",lineComment:o?null:"//",fold:"brace",helperType:o?"json":"javascript",jsonldMode:s,jsonMode:o}}),e.registerHelper("wordChars","javascript",/[\\w$]/),e.defineMIME("text/javascript","javascript"),e.defineMIME("text/ecmascript","javascript"),e.defineMIME("application/javascript","javascript"),e.defineMIME("application/ecmascript","javascript"),e.defineMIME("application/json",{name:"javascript",json:!0}),e.defineMIME("application/x-json",{name:"javascript",json:!0}),e.defineMIME("application/ld+json",{name:"javascript",jsonld:!0}),e.defineMIME("text/typescript",{name:"javascript",typescript:!0}),e.defineMIME("application/typescript",{name:"javascript",typescript:!0})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../xml/xml"),require("../javascript/javascript"),require("../css/css")):typeof define=="function"&&define.amd?define("components/codemirror/mode/htmlmixed/htmlmixed",["../../lib/codemirror","../xml/xml","../javascript/javascript","../css/css"],e):e(CodeMirror)}(function(e){e.defineMode("htmlmixed",function(t,n){function f(e,t){var n=t.htmlState.tagName,o=r.token(e,t.htmlState);if(n=="script"&&/\btag\b/.test(o)&&e.current()==">"){var u=e.string.slice(Math.max(0,e.pos-100),e.pos).match(/\btype\s*=\s*("[^"]+"|'[^']+'|\S+)[^<]*$/i);u=u?u[1]:"",u&&/[\"\']/.test(u.charAt(0))&&(u=u.slice(1,u.length-1));for(var a=0;a<s.length;++a){var f=s[a];if(typeof f.matches=="string"?u==f.matches:f.matches.test(u)){f.mode&&(t.token=c,t.localMode=f.mode,t.localState=f.mode.startState&&f.mode.startState(r.indent(t.htmlState,"")));break}}}else n=="style"&&/\btag\b/.test(o)&&e.current()==">"&&(t.token=h,t.localMode=i,t.localState=i.startState(r.indent(t.htmlState,"")));return o}function l(e,t,n){var r=e.current(),i=r.search(t),s;if(i>-1)e.backUp(r.length-i);else if(s=r.match(/<\/?$/))e.backUp(r.length),e.match(t,!1)||e.match(r);return n}function c(e,t){return e.match(/^<\/\s*script\s*>/i,!1)?(t.token=f,t.localState=t.localMode=null,f(e,t)):l(e,/<\/\s*script\s*>/,t.localMode.token(e,t.localState))}function h(e,t){return e.match(/^<\/\s*style\s*>/i,!1)?(t.token=f,t.localState=t.localMode=null,f(e,t)):l(e,/<\/\s*style\s*>/,i.token(e,t.localState))}var r=e.getMode(t,{name:"xml",htmlMode:!0,multilineTagIndentFactor:n.multilineTagIndentFactor,multilineTagIndentPastTag:n.multilineTagIndentPastTag}),i=e.getMode(t,"css"),s=[],o=n&&n.scriptTypes;s.push({matches:/^(?:text|application)\/(?:x-)?(?:java|ecma)script$|^$/i,mode:e.getMode(t,"javascript")});if(o)for(var u=0;u<o.length;++u){var a=o[u];s.push({matches:a.matches,mode:a.mode&&e.getMode(t,a.mode)})}return s.push({matches:/./,mode:e.getMode(t,"text/plain")}),{startState:function(){var e=r.startState();return{token:f,localMode:null,localState:null,htmlState:e}},copyState:function(t){if(t.localState)var n=e.copyState(t.localMode,t.localState);return{token:t.token,localMode:t.localMode,localState:n,htmlState:e.copyState(r,t.htmlState)}},token:function(e,t){return t.token(e,t)},indent:function(t,n){return!t.localMode||/^\s*<\//.test(n)?r.indent(t.htmlState,n):t.localMode.indent?t.localMode.indent(t.localState,n):e.Pass},innerMode:function(e){return{state:e.localState||e.htmlState,mode:e.localMode||r}}}},"xml","javascript","css"),e.defineMIME("text/html","htmlmixed")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/ruby/ruby",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("ruby",function(e){function t(e){var t={};for(var n=0,r=e.length;n<r;++n)t[e[n]]=!0;return t}function u(e,t,n){return n.tokenize.push(e),e(t,n)}function a(e,t){o=null;if(e.sol()&&e.match("=begin")&&e.eol())return t.tokenize.push(p),"comment";if(e.eatSpace())return null;var n=e.next(),r;if(n=="`"||n=="'"||n=='"')return u(c(n,"string",n=='"'||n=="`"),e,t);if(n=="/"&&!e.eol()&&e.peek()!=" ")return e.eat("=")?"operator":u(c(n,"string-2",!0),e,t);if(n=="%"){var i="string",a=!0;e.eat("s")?i="atom":e.eat(/[WQ]/)?i="string":e.eat(/[r]/)?i="string-2":e.eat(/[wxq]/)&&(i="string",a=!1);var f=e.eat(/[^\w\s]/);return f?(s.propertyIsEnumerable(f)&&(f=s[f]),u(c(f,i,a,!0),e,t)):"operator"}if(n=="#")return e.skipToEnd(),"comment";if(n=="<"&&(r=e.match(/^<-?[\`\"\']?([a-zA-Z_?]\w*)[\`\"\']?(?:;|$)/)))return u(h(r[1]),e,t);if(n=="0")return e.eat("x")?e.eatWhile(/[\da-fA-F]/):e.eat("b")?e.eatWhile(/[01]/):e.eatWhile(/[0-7]/),"number";if(/\d/.test(n))return e.match(/^[\d_]*(?:\.[\d_]+)?(?:[eE][+\-]?[\d_]+)?/),"number";if(n=="?"){while(e.match(/^\\[CM]-/));return e.eat("\\")?e.eatWhile(/\w/):e.next(),"string"}return n==":"?e.eat("'")?u(c("'","atom",!1),e,t):e.eat('"')?u(c('"',"atom",!0),e,t):e.eat(/[\<\>]/)?(e.eat(/[\<\>]/),"atom"):e.eat(/[\+\-\*\/\&\|\:\!]/)?"atom":e.eat(/[a-zA-Z$@_]/)?(e.eatWhile(/[\w]/),e.eat(/[\?\!\=]/),"atom"):"operator":n=="@"&&e.match(/^@?[a-zA-Z_]/)?(e.eat("@"),e.eatWhile(/[\w]/),"variable-2"):n=="$"?(e.eat(/[a-zA-Z_]/)?e.eatWhile(/[\w]/):e.eat(/\d/)?e.eat(/\d/):e.next(),"variable-3"):/[a-zA-Z_]/.test(n)?(e.eatWhile(/[\w]/),e.eat(/[\?\!]/),e.eat(":")?"atom":"ident"):n!="|"||!t.varList&&t.lastTok!="{"&&t.lastTok!="do"?/[\(\)\[\]{}\\;]/.test(n)?(o=n,null):n=="-"&&e.eat(">")?"arrow":/[=+\-\/*:\.^%<>~|]/.test(n)?(e.eatWhile(/[=+\-\/*:\.^%<>~|]/),"operator"):null:(o="|",null)}function f(){var e=1;return function(t,n){if(t.peek()=="}"){e--;if(e==0)return n.tokenize.pop(),n.tokenize[n.tokenize.length-1](t,n)}else t.peek()=="{"&&e++;return a(t,n)}}function l(){var e=!1;return function(t,n){return e?(n.tokenize.pop(),n.tokenize[n.tokenize.length-1](t,n)):(e=!0,a(t,n))}}function c(e,t,n,r){return function(i,s){var o=!1,u;s.context.type==="read-quoted-paused"&&(s.context=s.context.prev,i.eat("}"));while((u=i.next())!=null){if(u==e&&(r||!o)){s.tokenize.pop();break}if(n&&u=="#"&&!o){if(i.eat("{")){e=="}"&&(s.context={prev:s.context,type:"read-quoted-paused"}),s.tokenize.push(f());break}if(/[@\$]/.test(i.peek())){s.tokenize.push(l());break}}o=!o&&u=="\\"}return t}}function h(e){return function(t,n){return t.match(e)?n.tokenize.pop():t.skipToEnd(),"string"}}function p(e,t){return e.sol()&&e.match("=end")&&e.eol()&&t.tokenize.pop(),e.skipToEnd(),"comment"}var n=t(["alias","and","BEGIN","begin","break","case","class","def","defined?","do","else","elsif","END","end","ensure","false","for","if","in","module","next","not","or","redo","rescue","retry","return","self","super","then","true","undef","unless","until","when","while","yield","nil","raise","throw","catch","fail","loop","callcc","caller","lambda","proc","public","protected","private","require","load","require_relative","extend","autoload","__END__","__FILE__","__LINE__","__dir__"]),r=t(["def","class","case","for","while","module","then","catch","loop","proc","begin"]),i=t(["end","until"]),s={"[":"]","{":"}","(":")"},o;return{startState:function(){return{tokenize:[a],indented:0,context:{type:"top",indented:-e.indentUnit},continuedLine:!1,lastTok:null,varList:!1}},token:function(e,t){e.sol()&&(t.indented=e.indentation());var s=t.tokenize[t.tokenize.length-1](e,t),u;if(s=="ident"){var a=e.current();s=n.propertyIsEnumerable(e.current())?"keyword":/^[A-Z]/.test(a)?"tag":t.lastTok=="def"||t.lastTok=="class"||t.varList?"def":"variable",r.propertyIsEnumerable(a)?u="indent":i.propertyIsEnumerable(a)?u="dedent":a!="if"&&a!="unless"||e.column()!=e.indentation()?a=="do"&&t.context.indented<t.indented&&(u="indent"):u="indent"}if(o||s&&s!="comment")t.lastTok=a||o||s;return o=="|"&&(t.varList=!t.varList),u=="indent"||/[\(\[\{]/.test(o)?t.context={prev:t.context,type:o||s,indented:t.indented}:(u=="dedent"||/[\)\]\}]/.test(o))&&t.context.prev&&(t.context=t.context.prev),e.eol()&&(t.continuedLine=o=="\\"||s=="operator"),s},indent:function(t,n){if(t.tokenize[t.tokenize.length-1]!=a)return 0;var r=n&&n.charAt(0),i=t.context,o=i.type==s[r]||i.type=="keyword"&&/^(?:end|until|else|elsif|when|rescue)\b/.test(n);return i.indented+(o?0:e.indentUnit)+(t.continuedLine?e.indentUnit:0)},electricChars:"}de",lineComment:"#"}}),e.defineMIME("text/x-ruby","ruby")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../htmlmixed/htmlmixed"),require("../ruby/ruby")):typeof define=="function"&&define.amd?define("components/codemirror/mode/haml/haml",["../../lib/codemirror","../htmlmixed/htmlmixed","../ruby/ruby"],e):e(CodeMirror)}(function(e){e.defineMode("haml",function(t){function i(e){return function(t,n){var r=t.peek();return r==e&&n.rubyState.tokenize.length==1?(t.next(),n.tokenize=o,"closeAttributeTag"):s(t,n)}}function s(e,t){return e.match("-#")?(e.skipToEnd(),"comment"):r.token(e,t.rubyState)}function o(e,t){var r=e.peek();if(t.previousToken.style=="comment"&&t.indented>t.previousToken.indented)return e.skipToEnd(),"commentLine";if(t.startOfLine){if(r=="!"&&e.match("!!"))return e.skipToEnd(),"tag";if(e.match(/^%[\w:#\.]+=/))return t.tokenize=s,"hamlTag";if(e.match(/^%[\w:]+/))return"hamlTag";if(r=="/")return e.skipToEnd(),"comment"}if(t.startOfLine||t.previousToken.style=="hamlTag")if(r=="#"||r==".")return e.match(/[\w-#\.]*/),"hamlAttribute";if(t.startOfLine&&!e.match("-->",!1)&&(r=="="||r=="-"))return t.tokenize=s,t.tokenize(e,t);if(t.previousToken.style=="hamlTag"||t.previousToken.style=="closeAttributeTag"||t.previousToken.style=="hamlAttribute"){if(r=="(")return t.tokenize=i(")"),t.tokenize(e,t);if(r=="{")return t.tokenize=i("}"),t.tokenize(e,t)}return n.token(e,t.htmlState)}var n=e.getMode(t,{name:"htmlmixed"}),r=e.getMode(t,"ruby");return{startState:function(){var e=n.startState(),t=r.startState();return{htmlState:e,rubyState:t,indented:0,previousToken:{style:null,indented:0},tokenize:o}},copyState:function(t){return{htmlState:e.copyState(n,t.htmlState),rubyState:e.copyState(r,t.rubyState),indented:t.indented,previousToken:t.previousToken,tokenize:t.tokenize}},token:function(e,t){e.sol()&&(t.indented=e.indentation(),t.startOfLine=!0);if(e.eatSpace())return null;var n=t.tokenize(e,t);t.startOfLine=!1,n&&n!="commentLine"&&(t.previousToken={style:n,indented:t.indented});if(e.eol()&&t.tokenize==s){e.backUp(1);var r=e.peek();e.next(),r&&r!=","&&(t.tokenize=o)}return n=="hamlTag"?n="tag":n=="commentLine"?n="comment":n=="hamlAttribute"?n="attribute":n=="closeAttributeTag"&&(n=null),n}}},"htmlmixed","ruby"),e.defineMIME("text/x-haml","haml")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/haskell/haskell",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("haskell",function(e,t){function n(e,t,n){return t(n),n(e,t)}function h(e,t){if(e.eatWhile(c))return null;var h=e.next();if(l.test(h)){if(h=="{"&&e.eat("-")){var v="comment";return e.eat("#")&&(v="meta"),n(e,t,p(v,1))}return null}if(h=="'")return e.eat("\\")?e.next():e.next(),e.eat("'")?"string":"error";if(h=='"')return n(e,t,d);if(i.test(h))return e.eatWhile(a),e.eat(".")?"qualifier":"variable-2";if(r.test(h))return e.eatWhile(a),"variable";if(s.test(h)){if(h=="0"){if(e.eat(/[xX]/))return e.eatWhile(o),"integer";if(e.eat(/[oO]/))return e.eatWhile(u),"number"}e.eatWhile(s);var v="number";return e.match(/^\.\d+/)&&(v="number"),e.eat(/[eE]/)&&(v="number",e.eat(/[-+]/),e.eatWhile(s)),v}if(h=="."&&e.eat("."))return"keyword";if(f.test(h)){if(h=="-"&&e.eat(/-/)){e.eatWhile(/-/);if(!e.eat(f))return e.skipToEnd(),"comment"}var v="variable";return h==":"&&(v="variable-2"),e.eatWhile(f),v}return"error"}function p(e,t){return t==0?h:function(n,r){var i=t;while(!n.eol()){var s=n.next();if(s=="{"&&n.eat("-"))++i;else if(s=="-"&&n.eat("}")){--i;if(i==0)return r(h),e}}return r(p(e,i)),e}}function d(e,t){while(!e.eol()){var n=e.next();if(n=='"')return t(h),"string";if(n=="\\"){if(e.eol()||e.eat(c))return t(v),"string";e.eat("&")||e.next()}}return t(h),"error"}function v(e,t){return e.eat("\\")?n(e,t,d):(e.next(),t(h),"error")}var r=/[a-z_]/,i=/[A-Z]/,s=/\d/,o=/[0-9A-Fa-f]/,u=/[0-7]/,a=/[a-z_A-Z0-9']/,f=/[-!#$%&*+.\/<=>?@\\^|~:]/,l=/[(),;[\]`{}]/,c=/[ \t\v\f]/,m=function(){function n(t){return function(){for(var n=0;n<arguments.length;n++)e[arguments[n]]=t}}var e={};n("keyword")("case","class","data","default","deriving","do","else","foreign","if","import","in","infix","infixl","infixr","instance","let","module","newtype","of","then","type","where","_"),n("keyword")("..",":","::","=","\\",'"',"<-","->","@","~","=>"),n("builtin")("!!","$!","$","&&","+","++","-",".","/","/=","<","<=","=<<","==",">",">=",">>",">>=","^","^^","||","*","**"),n("builtin")("Bool","Bounded","Char","Double","EQ","Either","Enum","Eq","False","FilePath","Float","Floating","Fractional","Functor","GT","IO","IOError","Int","Integer","Integral","Just","LT","Left","Maybe","Monad","Nothing","Num","Ord","Ordering","Rational","Read","ReadS","Real","RealFloat","RealFrac","Right","Show","ShowS","String","True"),n("builtin")("abs","acos","acosh","all","and","any","appendFile","asTypeOf","asin","asinh","atan","atan2","atanh","break","catch","ceiling","compare","concat","concatMap","const","cos","cosh","curry","cycle","decodeFloat","div","divMod","drop","dropWhile","either","elem","encodeFloat","enumFrom","enumFromThen","enumFromThenTo","enumFromTo","error","even","exp","exponent","fail","filter","flip","floatDigits","floatRadix","floatRange","floor","fmap","foldl","foldl1","foldr","foldr1","fromEnum","fromInteger","fromIntegral","fromRational","fst","gcd","getChar","getContents","getLine","head","id","init","interact","ioError","isDenormalized","isIEEE","isInfinite","isNaN","isNegativeZero","iterate","last","lcm","length","lex","lines","log","logBase","lookup","map","mapM","mapM_","max","maxBound","maximum","maybe","min","minBound","minimum","mod","negate","not","notElem","null","odd","or","otherwise","pi","pred","print","product","properFraction","putChar","putStr","putStrLn","quot","quotRem","read","readFile","readIO","readList","readLn","readParen","reads","readsPrec","realToFrac","recip","rem","repeat","replicate","return","reverse","round","scaleFloat","scanl","scanl1","scanr","scanr1","seq","sequence","sequence_","show","showChar","showList","showParen","showString","shows","showsPrec","significand","signum","sin","sinh","snd","span","splitAt","sqrt","subtract","succ","sum","tail","take","takeWhile","tan","tanh","toEnum","toInteger","toRational","truncate","uncurry","undefined","unlines","until","unwords","unzip","unzip3","userError","words","writeFile","zip","zip3","zipWith","zipWith3");var r=t.overrideKeywords;if(r)for(var i in r)r.hasOwnProperty(i)&&(e[i]=r[i]);return e}();return{startState:function(){return{f:h}},copyState:function(e){return{f:e.f}},token:function(e,t){var n=t.f(e,function(e){t.f=e}),r=e.current();return m.hasOwnProperty(r)?m[r]:n},blockCommentStart:"{-",blockCommentEnd:"-}",lineComment:"--"}}),e.defineMIME("text/x-haskell","haskell")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/haxe/haxe",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("haxe",function(e,t){function s(e,t,n){return t.tokenize=n,n(e,t)}function o(e,t){var n=!1,r;while((r=e.next())!=null){if(r==t&&!n)return!1;n=!n&&r=="\\"}return n}function f(e,t,n){return u=e,a=n,t}function l(e,t){var n=e.next();if(n=='"'||n=="'")return s(e,t,c(n));if(/[\[\]{}\(\),;\:\.]/.test(n))return f(n);if(n=="0"&&e.eat(/x/i))return e.eatWhile(/[\da-f]/i),f("number","number");if(/\d/.test(n)||n=="-"&&e.eat(/\d/))return e.match(/^\d*(?:\.\d*)?(?:[eE][+\-]?\d+)?/),f("number","number");if(t.reAllowed&&n=="~"&&e.eat(/\//))return o(e,"/"),e.eatWhile(/[gimsu]/),f("regexp","string-2");if(n=="/")return e.eat("*")?s(e,t,h):e.eat("/")?(e.skipToEnd(),f("comment","comment")):(e.eatWhile(i),f("operator",null,e.current()));if(n=="#")return e.skipToEnd(),f("conditional","meta");if(n=="@")return e.eat(/:/),e.eatWhile(/[\w_]/),f("metadata","meta");if(i.test(n))return e.eatWhile(i),f("operator",null,e.current());var u;if(/[A-Z]/.test(n))return e.eatWhile(/[\w_<>]/),u=e.current(),f("type","variable-3",u);e.eatWhile(/[\w_]/);var u=e.current(),a=r.propertyIsEnumerable(u)&&r[u];return a&&t.kwAllowed?f(a.type,a.style,u):f("variable","variable",u)}function c(e){return function(t,n){return o(t,e)||(n.tokenize=l),f("string","string")}}function h(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=l;break}n=r=="*"}return f("comment","comment")}function d(e,t,n,r,i,s){this.indented=e,this.column=t,this.type=n,this.prev=i,this.info=s,r!=null&&(this.align=r)}function v(e,t){for(var n=e.localVars;n;n=n.next)if(n.name==t)return!0}function m(e,t,n,r,i){var s=e.cc;b.state=e,b.stream=i,b.marked=null,b.cc=s,e.lexical.hasOwnProperty("align")||(e.lexical.align=!0);for(;;){var o=s.length?s.pop():A;if(o(n,r)){while(s.length&&s[s.length-1].lex)s.pop()();return b.marked?b.marked:n=="variable"&&v(e,r)?"variable-2":n=="variable"&&g(e,r)?"variable-3":t}}}function g(e,t){if(/[a-z]/.test(t.charAt(0)))return!1;var n=e.importedtypes.length;for(var r=0;r<n;r++)if(e.importedtypes[r]==t)return!0}function y(e){var t=b.state;for(var n=t.importedtypes;n;n=n.next)if(n.name==e)return;t.importedtypes={name:e,next:t.importedtypes}}function w(){for(var e=arguments.length-1;e>=0;e--)b.cc.push(arguments[e])}function E(){return w.apply(null,arguments),!0}function S(e){var t=b.state;if(t.context){b.marked="def";for(var n=t.localVars;n;n=n.next)if(n.name==e)return;t.localVars={name:e,next:t.localVars}}}function T(){b.state.context||(b.state.localVars=x),b.state.context={prev:b.state.context,vars:b.state.localVars}}function N(){b.state.localVars=b.state.context.vars,b.state.context=b.state.context.prev}function C(e,t){var n=function(){var n=b.state;n.lexical=new d(n.indented,b.stream.column(),e,null,n.lexical,t)};return n.lex=!0,n}function k(){var e=b.state;e.lexical.prev&&(e.lexical.type==")"&&(e.indented=e.lexical.indented),e.lexical=e.lexical.prev)}function L(e){function t(n){return n==e?E():e==";"?w():E(t)}return t}function A(e){return e=="@"?E(P):e=="var"?E(C("vardef"),z,L(";"),k):e=="keyword a"?E(C("form"),O,A,k):e=="keyword b"?E(C("form"),A,k):e=="{"?E(C("}"),T,U,k,N):e==";"?E():e=="attribute"?E(D):e=="function"?E($):e=="for"?E(C("form"),L("("),C(")"),X,L(")"),k,A,k):e=="variable"?E(C("stat"),F):e=="switch"?E(C("form"),O,C("}","switch"),L("{"),U,k,k):e=="case"?E(O,L(":")):e=="default"?E(L(":")):e=="catch"?E(C("form"),T,L("("),G,L(")"),A,k,N):e=="import"?E(B,L(";")):e=="typedef"?E(j):w(C("stat"),O,L(";"),k)}function O(e){return p.hasOwnProperty(e)?E(_):e=="function"?E($):e=="keyword c"?E(M):e=="("?E(C(")"),M,L(")"),k,_):e=="operator"?E(O):e=="["?E(C("]"),R(O,"]"),k,_):e=="{"?E(C("}"),R(q,"}"),k,_):E()}function M(e){return e.match(/[;\}\)\],]/)?w():w(O)}function _(e,t){if(e=="operator"&&/\+\+|--/.test(t))return E(_);if(e=="operator"||e==":")return E(O);if(e==";")return;if(e=="(")return E(C(")"),R(O,")"),k,_);if(e==".")return E(I,_);if(e=="[")return E(C("]"),O,L("]"),k,_)}function D(e){if(e=="attribute")return E(D);if(e=="function")return E($);if(e=="var")return E(z)}function P(e){if(e==":")return E(P);if(e=="variable")return E(P);if(e=="(")return E(C(")"),R(H,")"),k,A)}function H(e){if(e=="variable")return E()}function B(e,t){if(e=="variable"&&/[A-Z]/.test(t.charAt(0)))return y(t),E();if(e=="variable"||e=="property"||e=="."||t=="*")return E(B)}function j(e,t){if(e=="variable"&&/[A-Z]/.test(t.charAt(0)))return y(t),E();if(e=="type"&&/[A-Z]/.test(t.charAt(0)))return E()}function F(e){return e==":"?E(k,A):w(_,L(";"),k)}function I(e){if(e=="variable")return b.marked="property",E()}function q(e){e=="variable"&&(b.marked="property");if(p.hasOwnProperty(e))return E(L(":"),O)}function R(e,t){function n(r){return r==","?E(e,n):r==t?E():E(L(t))}return function(r){return r==t?E():w(e,n)}}function U(e){return e=="}"?E():w(A,U)}function z(e,t){return e=="variable"?(S(t),E(J,W)):E()}function W(e,t){if(t=="=")return E(O,W);if(e==",")return E(z)}function X(e,t){return e=="variable"&&S(t),E(C(")"),T,V,O,k,A,N)}function V(e,t){if(t=="in")return E()}function $(e,t){if(e=="variable")return S(t),E($);if(t=="new")return E($);if(e=="(")return E(C(")"),T,R(G,")"),k,J,A,N)}function J(e){if(e==":")return E(K)}function K(e){if(e=="type")return E();if(e=="variable")return E();if(e=="{")return E(C("}"),R(Q,"}"),k)}function Q(e){if(e=="variable")return E(J)}function G(e,t){if(e=="variable")return S(t),E(J)}var n=e.indentUnit,r=function(){function e(e){return{type:e,style:"keyword"}}var t=e("keyword a"),n=e("keyword b"),r=e("keyword c"),i=e("operator"),s={type:"atom",style:"atom"},o={type:"attribute",style:"attribute"},u=e("typedef");return{"if":t,"while":t,"else":n,"do":n,"try":n,"return":r,"break":r,"continue":r,"new":r,"throw":r,"var":e("var"),inline:o,"static":o,using:e("import"),"public":o,"private":o,cast:e("cast"),"import":e("import"),macro:e("macro"),"function":e("function"),"catch":e("catch"),untyped:e("untyped"),callback:e("cb"),"for":e("for"),"switch":e("switch"),"case":e("case"),"default":e("default"),"in":i,never:e("property_access"),trace:e("trace"),"class":u,"abstract":u,"enum":u,"interface":u,typedef:u,"extends":u,"implements":u,dynamic:u,"true":s,"false":s,"null":s}}(),i=/[+\-*&%=<>!?|]/,u,a,p={atom:!0,number:!0,variable:!0,string:!0,regexp:!0},b={state:null,column:null,marked:null,cc:null},x={name:"this",next:null};return k.lex=!0,{startState:function(e){var r=["Int","Float","String","Void","Std","Bool","Dynamic","Array"];return{tokenize:l,reAllowed:!0,kwAllowed:!0,cc:[],lexical:new d((e||0)-n,0,"block",!1),localVars:t.localVars,importedtypes:r,context:t.localVars&&{vars:t.localVars},indented:0}},token:function(e,t){e.sol()&&(t.lexical.hasOwnProperty("align")||(t.lexical.align=!1),t.indented=e.indentation());if(e.eatSpace())return null;var n=t.tokenize(e,t);return u=="comment"?n:(t.reAllowed=u=="operator"||u=="keyword c"||!!u.match(/^[\[{}\(,;:]$/),t.kwAllowed=u!=".",m(t,n,u,a,e))},indent:function(e,t){if(e.tokenize!=l)return 0;var r=t&&t.charAt(0),i=e.lexical;i.type=="stat"&&r=="}"&&(i=i.prev);var s=i.type,o=r==s;return s=="vardef"?i.indented+4:s=="form"&&r=="{"?i.indented:s=="stat"||s=="form"?i.indented+n:i.info=="switch"&&!o?i.indented+(/^(?:case|default)\b/.test(t)?n:2*n):i.align?i.column+(o?0:1):i.indented+(o?0:n)},electricChars:"{}",blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//"}}),e.defineMIME("text/x-haxe","haxe"),e.defineMode("hxml",function(){return{startState:function(){return{define:!1,inString:!1}},token:function(e,t){var n=e.peek(),r=e.sol();if(n=="#")return e.skipToEnd(),"comment";if(r&&n=="-"){var i="variable-2";return e.eat(/-/),e.peek()=="-"&&(e.eat(/-/),i="keyword a"),e.peek()=="D"&&(e.eat(/[D]/),i="keyword c",t.define=!0),e.eatWhile(/[A-Z]/i),i}var n=e.peek();return t.inString==0&&n=="'"&&(t.inString=!0,n=e.next()),t.inString==1?(e.skipTo("'")||e.skipToEnd(),e.peek()=="'"&&(e.next(),t.inString=!1),"string"):(e.next(),null)},lineComment:"#"}}),e.defineMIME("text/x-hxml","hxml")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../htmlmixed/htmlmixed")):typeof define=="function"&&define.amd?define("components/codemirror/mode/htmlembedded/htmlembedded",["../../lib/codemirror","../htmlmixed/htmlmixed"],e):e(CodeMirror)}(function(e){e.defineMode("htmlembedded",function(t,n){function u(e,t){return e.match(r,!1)?(t.token=a,s.token(e,t.scriptState)):o.token(e,t.htmlState)}function a(e,t){return e.match(i,!1)?(t.token=u,o.token(e,t.htmlState)):s.token(e,t.scriptState)}var r=n.scriptStartRegex||/^<%/i,i=n.scriptEndRegex||/^%>/i,s,o;return{startState:function(){return s=s||e.getMode(t,n.scriptingModeSpec),o=o||e.getMode(t,"htmlmixed"),{token:n.startOpen?a:u,htmlState:e.startState(o),scriptState:e.startState(s)}},token:function(e,t){return t.token(e,t)},indent:function(e,t){if(e.token==u)return o.indent(e.htmlState,t);if(s.indent)return s.indent(e.scriptState,t)},copyState:function(t){return{token:t.token,htmlState:e.copyState(o,t.htmlState),scriptState:e.copyState(s,t.scriptState)}},innerMode:function(e){return e.token==a?{state:e.scriptState,mode:s}:{state:e.htmlState,mode:o}}}},"htmlmixed"),e.defineMIME("application/x-ejs",{name:"htmlembedded",scriptingModeSpec:"javascript"}),e.defineMIME("application/x-aspx",{name:"htmlembedded",scriptingModeSpec:"text/x-csharp"}),e.defineMIME("application/x-jsp",{name:"htmlembedded",scriptingModeSpec:"text/x-java"}),e.defineMIME("application/x-erb",{name:"htmlembedded",scriptingModeSpec:"ruby"})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/http/http",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("http",function(){function e(e,t){return e.skipToEnd(),t.cur=o,"error"}function t(t,r){return t.match(/^HTTP\/\d\.\d/)?(r.cur=n,"keyword"):t.match(/^[A-Z]+/)&&/[ \t]/.test(t.peek())?(r.cur=i,"keyword"):e(t,r)}function n(t,n){var i=t.match(/^\d+/);if(!i)return e(t,n);n.cur=r;var s=Number(i[0]);return s>=100&&s<200?"positive informational":s>=200&&s<300?"positive success":s>=300&&s<400?"positive redirect":s>=400&&s<500?"negative client-error":s>=500&&s<600?"negative server-error":"error"}function r(e,t){return e.skipToEnd(),t.cur=o,null}function i(e,t){return e.eatWhile(/\S/),t.cur=s,"string-2"}function s(t,n){return t.match(/^HTTP\/\d\.\d$/)?(n.cur=o,"keyword"):e(t,n)}function o(e){return e.sol()&&!e.eat(/[ \t]/)?e.match(/^.*?:/)?"atom":(e.skipToEnd(),"error"):(e.skipToEnd(),"string")}function u(e){return e.skipToEnd(),null}return{token:function(e,t){var n=t.cur;return n!=o&&n!=u&&e.eatSpace()?null:n(e,t)},blankLine:function(e){e.cur=u},startState:function(){return{cur:t}}}}),e.defineMIME("message/http","http")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../javascript/javascript"),require("../css/css"),require("../htmlmixed/htmlmixed")):typeof define=="function"&&define.amd?define("components/codemirror/mode/jade/jade",["../../lib/codemirror","../javascript/javascript","../css/css","../htmlmixed/htmlmixed"],e):e(CodeMirror)}(function(e){e.defineMode("jade",function(t){function a(){this.javaScriptLine=!1,this.javaScriptLineExcludesColon=!1,this.javaScriptArguments=!1,this.javaScriptArgumentsDepth=0,this.isInterpolating=!1,this.interpolationNesting=0,this.jsState=u.startState(),this.restOfLine="",this.isIncludeFiltered=!1,this.isEach=!1,this.lastTag="",this.scriptType="",this.isAttrs=!1,this.attrsNest=[],this.inAttributeName=!0,this.attributeIsType=!1,this.attrValue="",this.indentOf=Infinity,this.indentToken="",this.innerMode=null,this.innerState=null,this.innerModeForLine=!1}function f(e,t){e.sol()&&(t.javaScriptLine=!1,t.javaScriptLineExcludesColon=!1);if(t.javaScriptLine){if(t.javaScriptLineExcludesColon&&e.peek()===":"){t.javaScriptLine=!1,t.javaScriptLineExcludesColon=!1;return}var n=u.token(e,t.jsState);return e.eol()&&(t.javaScriptLine=!1),n||!0}}function l(e,t){if(t.javaScriptArguments){if(t.javaScriptArgumentsDepth===0&&e.peek()!=="("){t.javaScriptArguments=!1;return}e.peek()==="("?t.javaScriptArgumentsDepth++:e.peek()===")"&&t.javaScriptArgumentsDepth--;if(t.javaScriptArgumentsDepth===0){t.javaScriptArguments=!1;return}var n=u.token(e,t.jsState);return n||!0}}function c(e){if(e.match(/^yield\b/))return"keyword"}function h(e){if(e.match(/^(?:doctype) *([^\n]+)?/))return r}function p(e,t){if(e.match("#{"))return t.isInterpolating=!0,t.interpolationNesting=0,"punctuation"}function d(e,t){if(t.isInterpolating){if(e.peek()==="}"){t.interpolationNesting--;if(t.interpolationNesting<0)return e.next(),t.isInterpolating=!1,"puncutation"}else e.peek()==="{"&&t.interpolationNesting++;return u.token(e,t.jsState)||!0}}function v(e,t){if(e.match(/^case\b/))return t.javaScriptLine=!0,n}function m(e,t){if(e.match(/^when\b/))return t.javaScriptLine=!0,t.javaScriptLineExcludesColon=!0,n}function g(e){if(e.match(/^default\b/))return n}function y(e,t){if(e.match(/^extends?\b/))return t.restOfLine="string",n}function b(e,t){if(e.match(/^append\b/))return t.restOfLine="variable",n}function w(e,t){if(e.match(/^prepend\b/))return t.restOfLine="variable",n}function E(e,t){if(e.match(/^block\b *(?:(prepend|append)\b)?/))return t.restOfLine="variable",n}function S(e,t){if(e.match(/^include\b/))return t.restOfLine="string",n}function x(e,t){if(e.match(/^include:([a-zA-Z0-9\-]+)/,!1)&&e.match("include"))return t.isIncludeFiltered=!0,n}function T(e,t){if(t.isIncludeFiltered){var n=D(e,t);return t.isIncludeFiltered=!1,t.restOfLine="string",n}}function N(e,t){if(e.match(/^mixin\b/))return t.javaScriptLine=!0,n}function C(e,t){if(e.match(/^\+([-\w]+)/))return e.match(/^\( *[-\w]+ *=/,!1)||(t.javaScriptArguments=!0,t.javaScriptArgumentsDepth=0),"variable";if(e.match(/^\+#{/,!1))return e.next(),t.mixinCallAfter=!0,p(e,t)}function k(e,t){if(t.mixinCallAfter)return t.mixinCallAfter=!1,e.match(/^\( *[-\w]+ *=/,!1)||(t.javaScriptArguments=!0,t.javaScriptArgumentsDepth=0),!0}function L(e,t){if(e.match(/^(if|unless|else if|else)\b/))return t.javaScriptLine=!0,n}function A(e,t){if(e.match(/^(- *)?(each|for)\b/))return t.isEach=!0,n}function O(e,t){if(t.isEach){if(e.match(/^ in\b/))return t.javaScriptLine=!0,t.isEach=!1,n;if(e.sol()||e.eol())t.isEach=!1;else if(e.next()){while(!e.match(/^ in\b/,!1)&&e.next());return"variable"}}}function M(e,t){if(e.match(/^while\b/))return t.javaScriptLine=!0,n}function _(e,t){var n;if(n=e.match(/^(\w(?:[-:\w]*\w)?)\/?/))return t.lastTag=n[1].toLowerCase(),t.lastTag==="script"&&(t.scriptType="application/javascript"),"tag"}function D(n,r){if(n.match(/^:([\w\-]+)/)){var i;return t&&t.innerModes&&(i=t.innerModes(n.current().substring(1))),i||(i=n.current().substring(1)),typeof i=="string"&&(i=e.getMode(t,i)),V(n,r,i),"atom"}}function P(e,t){if(e.match(/^(!?=|-)/))return t.javaScriptLine=!0,"punctuation"}function H(e){if(e.match(/^#([\w-]+)/))return i}function B(e){if(e.match(/^\.([\w-]+)/))return s}function j(e,t){if(e.peek()=="(")return e.next(),t.isAttrs=!0,t.attrsNest=[],t.inAttributeName=!0,t.attrValue="",t.attributeIsType=!1,"punctuation"}function F(e,t){if(t.isAttrs){o[e.peek()]&&t.attrsNest.push(o[e.peek()]);if(t.attrsNest[t.attrsNest.length-1]===e.peek())t.attrsNest.pop();else if(e.eat(")"))return t.isAttrs=!1,"punctuation";if(t.inAttributeName&&e.match(/^[^=,\)!]+/)){if(e.peek()==="="||e.peek()==="!")t.inAttributeName=!1,t.jsState=u.startState(),t.lastTag==="script"&&e.current().trim().toLowerCase()==="type"?t.attributeIsType=!0:t.attributeIsType=!1;return"attribute"}var n=u.token(e,t.jsState);t.attributeIsType&&n==="string"&&(t.scriptType=e.current().toString());if(t.attrsNest.length===0&&(n==="string"||n==="variable"||n==="keyword"))try{return Function("","var x "+t.attrValue.replace(/,\s*$/,"").replace(/^!/,"")),t.inAttributeName=!0,t.attrValue="",e.backUp(e.current().length),F(e,t)}catch(r){}return t.attrValue+=e.current(),n||!0}}function I(e,t){if(e.match(/^&attributes\b/))return t.javaScriptArguments=!0,t.javaScriptArgumentsDepth=0,"keyword"}function q(e){if(e.sol()&&e.eatSpace())return"indent"}function R(e,t){if(e.match(/^ *\/\/(-)?([^\n]*)/))return t.indentOf=e.indentation(),t.indentToken="comment","comment"}function U(e){if(e.match(/^: */))return"colon"}function z(e,t){if(e.match(/^(?:\| ?| )([^\n]+)/))return"string";if(e.match(/^(<[^\n]*)/,!1))return V(e,t,"htmlmixed"),t.innerModeForLine=!0,$(e,t,!0)}function W(e,t){if(e.eat(".")){var n=null;return t.lastTag==="script"&&t.scriptType.toLowerCase().indexOf("javascript")!=-1?n=t.scriptType.toLowerCase().replace(/"|'/g,""):t.lastTag==="style"&&(n="css"),V(e,t,n),"dot"}}function X(e){return e.next(),null}function V(n,r,i){i=e.mimeModes[i]||i,i=t.innerModes?t.innerModes(i)||i:i,i=e.mimeModes[i]||i,i=e.getMode(t,i),r.indentOf=n.indentation(),i&&i.name!=="null"?r.innerMode=i:r.indentToken="string"}function $(e,t,n){if(e.indentation()>t.indentOf||t.innerModeForLine&&!e.sol()||n)return t.innerMode?(t.innerState||(t.innerState=t.innerMode.startState?t.innerMode.startState(e.indentation()):{}),e.hideFirstChars(t.indentOf+2,function(){return t.innerMode.token(e,t.innerState)||!0})):(e.skipToEnd(),t.indentToken);e.sol()&&(t.indentOf=Infinity,t.indentToken=null,t.innerMode=null,t.innerState=null)}function J(e,t){e.sol()&&(t.restOfLine="");if(t.restOfLine){e.skipToEnd();var n=t.restOfLine;return t.restOfLine="",n}}function K(){return new a}function Q(e){return e.copy()}function G(e,t){var n=$(e,t)||J(e,t)||d(e,t)||T(e,t)||O(e,t)||F(e,t)||f(e,t)||l(e,t)||k(e,t)||c(e,t)||h(e,t)||p(e,t)||v(e,t)||m(e,t)||g(e,t)||y(e,t)||b(e,t)||w(e,t)||E(e,t)||S(e,t)||x(e,t)||N(e,t)||C(e,t)||L(e,t)||A(e,t)||M(e,t)||_(e,t)||D(e,t)||P(e,t)||H(e,t)||B(e,t)||j(e,t)||I(e,t)||q(e,t)||z(e,t)||R(e,t)||U(e,t)||W(e,t)||X(e,t);return n===!0?null:n}var n="keyword",r="meta",i="builtin",s="qualifier",o={"{":"}","(":")","[":"]"},u=e.getMode(t,"javascript");return a.prototype.copy=function(){var t=new a;return t.javaScriptLine=this.javaScriptLine,t.javaScriptLineExcludesColon=this.javaScriptLineExcludesColon,t.javaScriptArguments=this.javaScriptArguments,t.javaScriptArgumentsDepth=this.javaScriptArgumentsDepth,t.isInterpolating=this.isInterpolating,t.interpolationNesting=this.intpolationNesting,t.jsState=e.copyState(u,this.jsState),t.innerMode=this.innerMode,this.innerMode&&this.innerState&&(t.innerState=e.copyState(this.innerMode,this.innerState)),t.restOfLine=this.restOfLine,t.isIncludeFiltered=this.isIncludeFiltered,t.isEach=this.isEach,t.lastTag=this.lastTag,t.scriptType=this.scriptType,t.isAttrs=this.isAttrs,t.attrsNest=this.attrsNest.slice(),t.inAttributeName=this.inAttributeName,t.attributeIsType=this.attributeIsType,t.attrValue=this.attrValue,t.indentOf=this.indentOf,t.indentToken=this.indentToken,t.innerModeForLine=this.innerModeForLine,t},{startState:K,copyState:Q,token:G}}),e.defineMIME("text/x-jade","jade")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/jinja2/jinja2",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("jinja2",function(){function s(s,o){var u=s.peek();if(o.incomment)return s.skipTo("#}")?(s.eatWhile(/\#|}/),o.incomment=!1):s.skipToEnd(),"comment";if(o.intag){if(o.operator){o.operator=!1;if(s.match(r))return"atom";if(s.match(i))return"number"}if(o.sign){o.sign=!1;if(s.match(r))return"atom";if(s.match(i))return"number"}if(o.instring)return u==o.instring&&(o.instring=!1),s.next(),"string";if(u=="'"||u=='"')return o.instring=u,s.next(),"string";if(s.match(o.intag+"}")||s.eat("-")&&s.match(o.intag+"}"))return o.intag=!1,"tag";if(s.match(t))return o.operator=!0,"operator";if(s.match(n))o.sign=!0;else if(s.eat(" ")||s.sol()){if(s.match(e))return"keyword";if(s.match(r))return"atom";if(s.match(i))return"number";s.sol()&&s.next()}else s.next();return"variable"}if(s.eat("{")){if(u=s.eat("#"))return o.incomment=!0,s.skipTo("#}")?(s.eatWhile(/\#|}/),o.incomment=!1):s.skipToEnd(),"comment";if(u=s.eat(/\{|%/))return o.intag=u,u=="{"&&(o.intag="}"),s.eat("-"),"tag"}s.next()}var e=["and","as","block","endblock","by","cycle","debug","else","elif","extends","filter","endfilter","firstof","for","endfor","if","endif","ifchanged","endifchanged","ifequal","endifequal","ifnotequal","endifnotequal","in","include","load","not","now","or","parsed","regroup","reversed","spaceless","endspaceless","ssi","templatetag","openblock","closeblock","openvariable","closevariable","openbrace","closebrace","opencomment","closecomment","widthratio","url","with","endwith","get_current_language","trans","endtrans","noop","blocktrans","endblocktrans","get_available_languages","get_current_language_bidi","plural"],t=/^[+\-*&%=<>!?|~^]/,n=/^[:\[\(\{]/,r=["true","false"],i=/^(\d[+\-\*\/])?\d+(\.\d+)?/;return e=new RegExp("(("+e.join(")|(")+"))\\b"),r=new RegExp("(("+r.join(")|(")+"))\\b"),{startState:function(){return{tokenize:s}},token:function(e,t){return t.tokenize(e,t)}}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/julia/julia",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("julia",function(e,t){function r(e){return new RegExp("^(("+e.join(")|(")+"))\\b")}function b(e){var t=w(e);return t=="["||t=="{"?!0:!1}function w(e){return e.scopes.length==0?null:e.scopes[e.scopes.length-1]}function E(e,t){var r=t.leaving_expr;e.sol()&&(r=!1),t.leaving_expr=!1;if(r&&e.match(/^'+/))return"operator";if(e.match(/^\.{2,3}/))return"operator";if(e.eatSpace())return null;var u=e.peek();if(u==="#")return e.skipToEnd(),"comment";u==="["&&t.scopes.push("["),u==="{"&&t.scopes.push("{");var a=w(t);a==="["&&u==="]"&&(t.scopes.pop(),t.leaving_expr=!0),a==="{"&&u==="}"&&(t.scopes.pop(),t.leaving_expr=!0),u===")"&&(t.leaving_expr=!0);var f;!b(t)&&(f=e.match(d,!1))&&t.scopes.push(f),!b(t)&&e.match(v,!1)&&t.scopes.pop();if(b(t)&&e.match(/^end/))return"number";if(e.match(/^=>/))return"operator";if(e.match(/^[0-9\.]/,!1)){var l=RegExp(/^im\b/),y=!1;e.match(/^\d*\.(?!\.)\d+([ef][\+\-]?\d+)?/i)&&(y=!0),e.match(/^\d+\.(?!\.)\d*/)&&(y=!0),e.match(/^\.\d+/)&&(y=!0);if(y)return e.match(l),t.leaving_expr=!0,"number";var E=!1;e.match(/^0x[0-9a-f]+/i)&&(E=!0),e.match(/^0b[01]+/i)&&(E=!0),e.match(/^0o[0-7]+/i)&&(E=!0),e.match(/^[1-9]\d*(e[\+\-]?\d+)?/)&&(E=!0),e.match(/^0(?![\dx])/i)&&(E=!0);if(E)return e.match(l),t.leaving_expr=!0,"number"}return e.match(/^(::)|(<:)/)?"operator":!r&&e.match(g)?"string":e.match(i)?"operator":e.match(c)?(t.tokenize=S(e.current()),t.tokenize(e,t)):e.match(m)?"meta":e.match(s)?null:e.match(h)?"keyword":e.match(p)?"builtin":e.match(o)?(t.leaving_expr=!0,"variable"):(e.next(),n)}function S(e){function s(s,o){while(!s.eol()){s.eatWhile(/[^'"\\]/);if(s.eat("\\")){s.next();if(r&&s.eol())return i}else{if(s.match(e))return o.tokenize=E,i;s.eat(/['"]/)}}if(r){if(t.singleLineStringErrors)return n;o.tokenize=E}return i}while("rub".indexOf(e.charAt(0).toLowerCase())>=0)e=e.substr(1);var r=e.length==1,i="string";return s.isString=!0,s}function x(e,t){y=null;var r=t.tokenize(e,t),i=e.current();return i==="."?(r=e.match(o,!1)?null:n,r===null&&t.lastStyle==="meta"&&(r="meta"),r):r}var n="error",i=t.operators||/^\.?[|&^\\%*+\-<>!=\/]=?|\?|~|:|\$|\.[<>]|<<=?|>>>?=?|\.[<>=]=|->?|\/\/|\bin\b/,s=t.delimiters||/^[;,()[\]{}]/,o=t.identifiers||/^[_A-Za-z][_A-Za-z0-9]*!*/,u=["begin","function","type","immutable","let","macro","for","while","quote","if","else","elseif","try","finally","catch","do"],a=["end","else","elseif","catch","finally"],f=["if","else","elseif","while","for","begin","let","end","do","try","catch","finally","return","break","continue","global","local","const","export","import","importall","using","function","macro","module","baremodule","type","immutable","quote","typealias","abstract","bitstype","ccall"],l=["true","false","enumerate","open","close","nothing","NaN","Inf","print","println","Int","Int8","Uint8","Int16","Uint16","Int32","Uint32","Int64","Uint64","Int128","Uint128","Bool","Char","Float16","Float32","Float64","Array","Vector","Matrix","String","UTF8String","ASCIIString","error","warn","info","@printf"],c=/^(`|'|"{3}|([br]?"))/,h=r(f),p=r(l),d=r(u),v=r(a),m=/^@[_A-Za-z][_A-Za-z0-9]*/,g=/^:[_A-Za-z][_A-Za-z0-9]*/,y=null,T={startState:function(){return{tokenize:E,scopes:[],leaving_expr:!1}},token:function(e,t){var n=x(e,t);return t.lastStyle=n,n},indent:function(e,t){var n=0;if(t=="end"||t=="]"||t=="}"||t=="else"||t=="elseif"||t=="catch"||t=="finally")n=-1;return(e.scopes.length+n)*4},lineComment:"#",fold:"indent",electricChars:"edlsifyh]}"};return T}),e.defineMIME("text/x-julia","julia")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/livescript/livescript",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("livescript",function(){var e=function(e,t){var n=t.next||"start";if(n){t.next=t.next;var r=s[n];if(r.splice){for(var i=0;i<r.length;++i){var o=r[i],u;if(o.regex&&(u=e.match(o.regex)))return t.next=o.next||t.next,o.token}return e.next(),"error"}if(e.match(o=s[n]))return o.regex&&e.match(o.regex)?(t.next=o.next,o.token):(e.next(),"error")}return e.next(),"error"},t={startState:function(){return{next:"start",lastToken:null}},token:function(t,n){while(t.pos==t.start)var r=e(t,n);return n.lastToken={style:r,indent:t.indentation(),content:t.current()},r.replace(/\./g," ")},indent:function(e){var t=e.lastToken.indent;return e.lastToken.content.match(n)&&(t+=2),t}};return t});var t="(?![\\d\\s])[$\\w\\xAA-\\uFFDC](?:(?!\\s)[$\\w\\xAA-\\uFFDC]|-[A-Za-z])*",n=RegExp("(?:[({[=:]|[-~]>|\\b(?:e(?:lse|xport)|d(?:o|efault)|t(?:ry|hen)|finally|import(?:\\s*all)?|const|var|let|new|catch(?:\\s*"+t+")?))\\s*$"),r="(?![$\\w]|-[A-Za-z]|\\s*:(?![:=]))",i={token:"string",regex:".+"},s={start:[{token:"comment.doc",regex:"/\\*",next:"comment"},{token:"comment",regex:"#.*"},{token:"keyword",regex:"(?:t(?:h(?:is|row|en)|ry|ypeof!?)|c(?:on(?:tinue|st)|a(?:se|tch)|lass)|i(?:n(?:stanceof)?|mp(?:ort(?:\\s+all)?|lements)|[fs])|d(?:e(?:fault|lete|bugger)|o)|f(?:or(?:\\s+own)?|inally|unction)|s(?:uper|witch)|e(?:lse|x(?:tends|port)|val)|a(?:nd|rguments)|n(?:ew|ot)|un(?:less|til)|w(?:hile|ith)|o[fr]|return|break|let|var|loop)"+r},{token:"constant.language",regex:"(?:true|false|yes|no|on|off|null|void|undefined)"+r},{token:"invalid.illegal",regex:"(?:p(?:ackage|r(?:ivate|otected)|ublic)|i(?:mplements|nterface)|enum|static|yield)"+r},{token:"language.support.class",regex:"(?:R(?:e(?:gExp|ferenceError)|angeError)|S(?:tring|yntaxError)|E(?:rror|valError)|Array|Boolean|Date|Function|Number|Object|TypeError|URIError)"+r},{token:"language.support.function",regex:"(?:is(?:NaN|Finite)|parse(?:Int|Float)|Math|JSON|(?:en|de)codeURI(?:Component)?)"+r},{token:"variable.language",regex:"(?:t(?:hat|il|o)|f(?:rom|allthrough)|it|by|e)"+r},{token:"identifier",regex:t+"\\s*:(?![:=])"},{token:"variable",regex:t},{token:"keyword.operator",regex:"(?:\\.{3}|\\s+\\?)"},{token:"keyword.variable",regex:"(?:@+|::|\\.\\.)",next:"key"},{token:"keyword.operator",regex:"\\.\\s*",next:"key"},{token:"string",regex:"\\\\\\S[^\\s,;)}\\]]*"},{token:"string.doc",regex:"'''",next:"qdoc"},{token:"string.doc",regex:'"""',next:"qqdoc"},{token:"string",regex:"'",next:"qstring"},{token:"string",regex:'"',next:"qqstring"},{token:"string",regex:"`",next:"js"},{token:"string",regex:"<\\[",next:"words"},{token:"string.regex",regex:"//",next:"heregex"},{token:"string.regex",regex:"\\/(?:[^[\\/\\n\\\\]*(?:(?:\\\\.|\\[[^\\]\\n\\\\]*(?:\\\\.[^\\]\\n\\\\]*)*\\])[^[\\/\\n\\\\]*)*)\\/[gimy$]{0,4}",next:"key"},{token:"constant.numeric",regex:"(?:0x[\\da-fA-F][\\da-fA-F_]*|(?:[2-9]|[12]\\d|3[0-6])r[\\da-zA-Z][\\da-zA-Z_]*|(?:\\d[\\d_]*(?:\\.\\d[\\d_]*)?|\\.\\d[\\d_]*)(?:e[+-]?\\d[\\d_]*)?[\\w$]*)"},{token:"lparen",regex:"[({[]"},{token:"rparen",regex:"[)}\\]]",next:"key"},{token:"keyword.operator",regex:"\\S+"},{token:"text",regex:"\\s+"}],heregex:[{token:"string.regex",regex:".*?//[gimy$?]{0,4}",next:"start"},{token:"string.regex",regex:"\\s*#{"},{token:"comment.regex",regex:"\\s+(?:#.*)?"},{token:"string.regex",regex:"\\S+"}],key:[{token:"keyword.operator",regex:"[.?@!]+"},{token:"identifier",regex:t,next:"start"},{token:"text",regex:"",next:"start"}],comment:[{token:"comment.doc",regex:".*?\\*/",next:"start"},{token:"comment.doc",regex:".+"}],qdoc:[{token:"string",regex:".*?'''",next:"key"},i],qqdoc:[{token:"string",regex:'.*?"""',next:"key"},i],qstring:[{token:"string",regex:"[^\\\\']*(?:\\\\.[^\\\\']*)*'",next:"key"},i],qqstring:[{token:"string",regex:'[^\\\\"]*(?:\\\\.[^\\\\"]*)*"',next:"key"},i],js:[{token:"string",regex:"[^\\\\`]*(?:\\\\.[^\\\\`]*)*`",next:"key"},i],words:[{token:"string",regex:".*?\\]>",next:"key"},i]};for(var o in s){var u=s[o];if(u.splice)for(var a=0,f=u.length;a<f;++a){var l=u[a];typeof l.regex=="string"&&(s[o][a].regex=new RegExp("^"+l.regex))}else typeof l.regex=="string"&&(s[o].regex=new RegExp("^"+u.regex))}e.defineMIME("text/x-livescript","livescript")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/lua/lua",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("lua",function(e,t){function r(e){return new RegExp("^(?:"+e.join("|")+")","i")}function i(e){return new RegExp("^(?:"+e.join("|")+")$","i")}function c(e){var t=0;while(e.eat("="))++t;return e.eat("["),t}function h(e,t){var n=e.next();return n=="-"&&e.eat("-")?e.eat("[")&&e.eat("[")?(t.cur=p(c(e),"comment"))(e,t):(e.skipToEnd(),"comment"):n=='"'||n=="'"?(t.cur=d(n))(e,t):n=="["&&/[\[=]/.test(e.peek())?(t.cur=p(c(e),"string"))(e,t):/\d/.test(n)?(e.eatWhile(/[\w.%]/),"number"):/[\w_]/.test(n)?(e.eatWhile(/[\w\\\-_.]/),"variable"):null}function p(e,t){return function(n,r){var i=null,s;while((s=n.next())!=null)if(i==null)s=="]"&&(i=0);else if(s=="=")++i;else{if(s=="]"&&i==e){r.cur=h;break}i=null}return t}}function d(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r)break;r=!r&&i=="\\"}return r||(n.cur=h),"string"}}var n=e.indentUnit,s=i(t.specials||[]),o=i(["_G","_VERSION","assert","collectgarbage","dofile","error","getfenv","getmetatable","ipairs","load","loadfile","loadstring","module","next","pairs","pcall","print","rawequal","rawget","rawset","require","select","setfenv","setmetatable","tonumber","tostring","type","unpack","xpcall","coroutine.create","coroutine.resume","coroutine.running","coroutine.status","coroutine.wrap","coroutine.yield","debug.debug","debug.getfenv","debug.gethook","debug.getinfo","debug.getlocal","debug.getmetatable","debug.getregistry","debug.getupvalue","debug.setfenv","debug.sethook","debug.setlocal","debug.setmetatable","debug.setupvalue","debug.traceback","close","flush","lines","read","seek","setvbuf","write","io.close","io.flush","io.input","io.lines","io.open","io.output","io.popen","io.read","io.stderr","io.stdin","io.stdout","io.tmpfile","io.type","io.write","math.abs","math.acos","math.asin","math.atan","math.atan2","math.ceil","math.cos","math.cosh","math.deg","math.exp","math.floor","math.fmod","math.frexp","math.huge","math.ldexp","math.log","math.log10","math.max","math.min","math.modf","math.pi","math.pow","math.rad","math.random","math.randomseed","math.sin","math.sinh","math.sqrt","math.tan","math.tanh","os.clock","os.date","os.difftime","os.execute","os.exit","os.getenv","os.remove","os.rename","os.setlocale","os.time","os.tmpname","package.cpath","package.loaded","package.loaders","package.loadlib","package.path","package.preload","package.seeall","string.byte","string.char","string.dump","string.find","string.format","string.gmatch","string.gsub","string.len","string.lower","string.match","string.rep","string.reverse","string.sub","string.upper","table.concat","table.insert","table.maxn","table.remove","table.sort"]),u=i(["and","break","elseif","false","nil","not","or","return","true","function","end","if","then","else","do","while","repeat","until","for","in","local"]),a=i(["function","if","repeat","do","\\(","{"]),f=i(["end","until","\\)","}"]),l=r(["end","until","\\)","}","else","elseif"]);return{startState:function(e){return{basecol:e||0,indentDepth:0,cur:h}},token:function(e,t){if(e.eatSpace())return null;var n=t.cur(e,t),r=e.current();return n=="variable"&&(u.test(r)?n="keyword":o.test(r)?n="builtin":s.test(r)&&(n="variable-2")),n!="comment"&&n!="string"&&(a.test(r)?++t.indentDepth:f.test(r)&&--t.indentDepth),n},indent:function(e,t){var r=l.test(t);return e.basecol+n*(e.indentDepth-(r?1:0))},lineComment:"--",blockCommentStart:"--[[",blockCommentEnd:"]]"}}),e.defineMIME("text/x-lua","lua")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/mirc/mirc",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMIME("text/mirc","mirc"),e.defineMode("mirc",function(){function e(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function s(e,t,n){return t.tokenize=n,n(e,t)}function o(e,o){var f=o.beforeParams;o.beforeParams=!1;var l=e.next();if(/[\[\]{}\(\),\.]/.test(l))return l=="("&&f?o.inParams=!0:l==")"&&(o.inParams=!1),null;if(/\d/.test(l))return e.eatWhile(/[\w\.]/),"number";if(l=="\\")return e.eat("\\"),e.eat(/./),"number";if(l=="/"&&e.eat("*"))return s(e,o,u);if(l==";"&&e.match(/ *\( *\(/))return s(e,o,a);if(l==";"&&!o.inParams)return e.skipToEnd(),"comment";if(l=='"')return e.eat(/"/),"keyword";if(l=="$")return e.eatWhile(/[$_a-z0-9A-Z\.:]/),t&&t.propertyIsEnumerable(e.current().toLowerCase())?"keyword":(o.beforeParams=!0,"builtin");if(l=="%")return e.eatWhile(/[^,^\s^\(^\)]/),o.beforeParams=!0,"string";if(i.test(l))return e.eatWhile(i),"operator";e.eatWhile(/[\w\$_{}]/);var c=e.current().toLowerCase();return n&&n.propertyIsEnumerable(c)?"keyword":r&&r.propertyIsEnumerable(c)?(o.beforeParams=!0,"keyword"):null}function u(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=o;break}n=r=="*"}return"comment"}function a(e,t){var n=0,r;while(r=e.next()){if(r==";"&&n==2){t.tokenize=o;break}r==")"?n++:r!=" "&&(n=0)}return"meta"}var t=e("$! $$ $& $? $+ $abook $abs $active $activecid $activewid $address $addtok $agent $agentname $agentstat $agentver $alias $and $anick $ansi2mirc $aop $appactive $appstate $asc $asctime $asin $atan $avoice $away $awaymsg $awaytime $banmask $base $bfind $binoff $biton $bnick $bvar $bytes $calc $cb $cd $ceil $chan $chanmodes $chantypes $chat $chr $cid $clevel $click $cmdbox $cmdline $cnick $color $com $comcall $comchan $comerr $compact $compress $comval $cos $count $cr $crc $creq $crlf $ctime $ctimer $ctrlenter $date $day $daylight $dbuh $dbuw $dccignore $dccport $dde $ddename $debug $decode $decompress $deltok $devent $dialog $did $didreg $didtok $didwm $disk $dlevel $dll $dllcall $dname $dns $duration $ebeeps $editbox $emailaddr $encode $error $eval $event $exist $feof $ferr $fgetc $file $filename $filtered $finddir $finddirn $findfile $findfilen $findtok $fline $floor $fopen $fread $fserve $fulladdress $fulldate $fullname $fullscreen $get $getdir $getdot $gettok $gmt $group $halted $hash $height $hfind $hget $highlight $hnick $hotline $hotlinepos $ial $ialchan $ibl $idle $iel $ifmatch $ignore $iif $iil $inelipse $ini $inmidi $inpaste $inpoly $input $inrect $inroundrect $insong $instok $int $inwave $ip $isalias $isbit $isdde $isdir $isfile $isid $islower $istok $isupper $keychar $keyrpt $keyval $knick $lactive $lactivecid $lactivewid $left $len $level $lf $line $lines $link $lock $lock $locked $log $logstamp $logstampfmt $longfn $longip $lower $ltimer $maddress $mask $matchkey $matchtok $md5 $me $menu $menubar $menucontext $menutype $mid $middir $mircdir $mircexe $mircini $mklogfn $mnick $mode $modefirst $modelast $modespl $mouse $msfile $network $newnick $nick $nofile $nopath $noqt $not $notags $notify $null $numeric $numok $oline $onpoly $opnick $or $ord $os $passivedcc $pic $play $pnick $port $portable $portfree $pos $prefix $prop $protect $puttok $qt $query $rand $r $rawmsg $read $readomo $readn $regex $regml $regsub $regsubex $remove $remtok $replace $replacex $reptok $result $rgb $right $round $scid $scon $script $scriptdir $scriptline $sdir $send $server $serverip $sfile $sha1 $shortfn $show $signal $sin $site $sline $snick $snicks $snotify $sock $sockbr $sockerr $sockname $sorttok $sound $sqrt $ssl $sreq $sslready $status $strip $str $stripped $syle $submenu $switchbar $tan $target $ticks $time $timer $timestamp $timestampfmt $timezone $tip $titlebar $toolbar $treebar $trust $ulevel $ulist $upper $uptime $url $usermode $v1 $v2 $var $vcmd $vcmdstat $vcmdver $version $vnick $vol $wid $width $wildsite $wildtok $window $wrap $xor"),n=e("abook ajinvite alias aline ame amsg anick aop auser autojoin avoice away background ban bcopy beep bread break breplace bset btrunc bunset bwrite channel clear clearall cline clipboard close cnick color comclose comopen comreg continue copy creq ctcpreply ctcps dcc dccserver dde ddeserver debug dec describe dialog did didtok disable disconnect dlevel dline dll dns dqwindow drawcopy drawdot drawfill drawline drawpic drawrect drawreplace drawrot drawsave drawscroll drawtext ebeeps echo editbox emailaddr enable events exit fclose filter findtext finger firewall flash flist flood flush flushini font fopen fseek fsend fserve fullname fwrite ghide gload gmove gopts goto gplay gpoint gqreq groups gshow gsize gstop gtalk gunload hadd halt haltdef hdec hdel help hfree hinc hload hmake hop hsave ial ialclear ialmark identd if ignore iline inc invite iuser join kick linesep links list load loadbuf localinfo log mdi me menubar mkdir mnick mode msg nick noop notice notify omsg onotice part partall pdcc perform play playctrl pop protect pvoice qme qmsg query queryn quit raw reload remini remote remove rename renwin reseterror resetidle return rlevel rline rmdir run ruser save savebuf saveini say scid scon server set showmirc signam sline sockaccept sockclose socklist socklisten sockmark sockopen sockpause sockread sockrename sockudp sockwrite sound speak splay sreq strip switchbar timer timestamp titlebar tnick tokenize toolbar topic tray treebar ulist unload unset unsetall updatenl url uwho var vcadd vcmd vcrem vol while whois window winhelp write writeint if isalnum isalpha isaop isavoice isban ischan ishop isignore isin isincs isletter islower isnotify isnum ison isop isprotect isreg isupper isvoice iswm iswmcs elseif else goto menu nicklist status title icon size option text edit button check radio box scroll list combo link tab item"),r=e("if elseif else and not or eq ne in ni for foreach while switch"),i=/[+\-*&%=<>!?^\/\|]/;return{startState:function(){return{tokenize:o,beforeParams:!1,inParams:!1}},token:function(e,t){return e.eatSpace()?null:t.tokenize(e,t)}}})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/mllike/mllike",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("mllike",function(e,t){function s(e,r){var i=e.next();if(i==='"')return r.tokenize=o,r.tokenize(e,r);if(i==="("&&e.eat("*"))return r.commentLevel++,r.tokenize=u,r.tokenize(e,r);if(i==="~")return e.eatWhile(/\w/),"variable-2";if(i==="`")return e.eatWhile(/\w/),"quote";if(i==="/"&&t.slashComments&&e.eat("/"))return e.skipToEnd(),"comment";if(/\d/.test(i))return e.eatWhile(/[\d]/),e.eat(".")&&e.eatWhile(/[\d]/),"number";if(/[+\-*&%=<>!?|]/.test(i))return"operator";e.eatWhile(/\w/);var s=e.current();return n[s]||"variable"}function o(e,t){var n,r=!1,i=!1;while((n=e.next())!=null){if(n==='"'&&!i){r=!0;break}i=!i&&n==="\\"}return r&&!i&&(t.tokenize=s),"string"}function u(e,t){var n,r;while(t.commentLevel>0&&(r=e.next())!=null)n==="("&&r==="*"&&t.commentLevel++,n==="*"&&r===")"&&t.commentLevel--,n=r;return t.commentLevel<=0&&(t.tokenize=s),"comment"}var n={let:"keyword",rec:"keyword","in":"keyword",of:"keyword",and:"keyword","if":"keyword",then:"keyword","else":"keyword","for":"keyword",to:"keyword","while":"keyword","do":"keyword",done:"keyword",fun:"keyword","function":"keyword",val:"keyword",type:"keyword",mutable:"keyword",match:"keyword","with":"keyword","try":"keyword",open:"builtin",ignore:"builtin",begin:"keyword",end:"keyword"},r=t.extraWords||{};for(var i in r)r.hasOwnProperty(i)&&(n[i]=t.extraWords[i]);return{startState:function(){return{tokenize:s,commentLevel:0}},token:function(e,t){return e.eatSpace()?null:t.tokenize(e,t)},blockCommentStart:"(*",blockCommentEnd:"*)",lineComment:t.slashComments?"//":null}}),e.defineMIME("text/x-ocaml",{name:"mllike",extraWords:{succ:"keyword",trace:"builtin",exit:"builtin",print_string:"builtin",print_endline:"builtin","true":"atom","false":"atom",raise:"keyword"}}),e.defineMIME("text/x-fsharp",{name:"mllike",extraWords:{"abstract":"keyword",as:"keyword",assert:"keyword",base:"keyword","class":"keyword","default":"keyword",delegate:"keyword",downcast:"keyword",downto:"keyword",elif:"keyword",exception:"keyword",extern:"keyword","finally":"keyword",global:"keyword",inherit:"keyword",inline:"keyword","interface":"keyword",internal:"keyword",lazy:"keyword","let!":"keyword",member:"keyword",module:"keyword",namespace:"keyword","new":"keyword","null":"keyword",override:"keyword","private":"keyword","public":"keyword","return":"keyword","return!":"keyword",select:"keyword","static":"keyword",struct:"keyword",upcast:"keyword",use:"keyword","use!":"keyword",val:"keyword",when:"keyword",yield:"keyword","yield!":"keyword",List:"builtin",Seq:"builtin",Map:"builtin",Set:"builtin","int":"builtin",string:"builtin",raise:"builtin",failwith:"builtin",not:"builtin","true":"builtin","false":"builtin"},slashComments:!0})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/nginx/nginx",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("nginx",function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function u(e,t){return o=t,e}function a(e,t){e.eatWhile(/[\w\$_]/);var s=e.current();if(n.propertyIsEnumerable(s))return"keyword";if(r.propertyIsEnumerable(s))return"variable-2";if(i.propertyIsEnumerable(s))return"string-2";var o=e.next();if(o=="@")return e.eatWhile(/[\w\\\-]/),u("meta",e.current());if(o=="/"&&e.eat("*"))return t.tokenize=f,f(e,t);if(o=="<"&&e.eat("!"))return t.tokenize=l,l(e,t);if(o!="=")return o!="~"&&o!="|"||!e.eat("=")?o=='"'||o=="'"?(t.tokenize=c(o),t.tokenize(e,t)):o=="#"?(e.skipToEnd(),u("comment","comment")):o=="!"?(e.match(/^\s*\w*/),u("keyword","important")):/\d/.test(o)?(e.eatWhile(/[\w.%]/),u("number","unit")):/[,.+>*\/]/.test(o)?u(null,"select-op"):/[;{}:\[\]]/.test(o)?u(null,o):(e.eatWhile(/[\w\\\-]/),u("variable","variable")):u(null,"compare");u(null,"compare")}function f(e,t){var n=!1,r;while((r=e.next())!=null){if(n&&r=="/"){t.tokenize=a;break}n=r=="*"}return u("comment","comment")}function l(e,t){var n=0,r;while((r=e.next())!=null){if(n>=2&&r==">"){t.tokenize=a;break}n=r=="-"?n+1:0}return u("comment","comment")}function c(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r)break;r=!r&&i=="\\"}return r||(n.tokenize=a),u("string","string")}}var n=t("break return rewrite set accept_mutex accept_mutex_delay access_log add_after_body add_before_body add_header addition_types aio alias allow ancient_browser ancient_browser_value auth_basic auth_basic_user_file auth_http auth_http_header auth_http_timeout autoindex autoindex_exact_size autoindex_localtime charset charset_types client_body_buffer_size client_body_in_file_only client_body_in_single_buffer client_body_temp_path client_body_timeout client_header_buffer_size client_header_timeout client_max_body_size connection_pool_size create_full_put_path daemon dav_access dav_methods debug_connection debug_points default_type degradation degrade deny devpoll_changes devpoll_events directio directio_alignment empty_gif env epoll_events error_log eventport_events expires fastcgi_bind fastcgi_buffer_size fastcgi_buffers fastcgi_busy_buffers_size fastcgi_cache fastcgi_cache_key fastcgi_cache_methods fastcgi_cache_min_uses fastcgi_cache_path fastcgi_cache_use_stale fastcgi_cache_valid fastcgi_catch_stderr fastcgi_connect_timeout fastcgi_hide_header fastcgi_ignore_client_abort fastcgi_ignore_headers fastcgi_index fastcgi_intercept_errors fastcgi_max_temp_file_size fastcgi_next_upstream fastcgi_param fastcgi_pass_header fastcgi_pass_request_body fastcgi_pass_request_headers fastcgi_read_timeout fastcgi_send_lowat fastcgi_send_timeout fastcgi_split_path_info fastcgi_store fastcgi_store_access fastcgi_temp_file_write_size fastcgi_temp_path fastcgi_upstream_fail_timeout fastcgi_upstream_max_fails flv geoip_city geoip_country google_perftools_profiles gzip gzip_buffers gzip_comp_level gzip_disable gzip_hash gzip_http_version gzip_min_length gzip_no_buffer gzip_proxied gzip_static gzip_types gzip_vary gzip_window if_modified_since ignore_invalid_headers image_filter image_filter_buffer image_filter_jpeg_quality image_filter_transparency imap_auth imap_capabilities imap_client_buffer index ip_hash keepalive_requests keepalive_timeout kqueue_changes kqueue_events large_client_header_buffers limit_conn limit_conn_log_level limit_rate limit_rate_after limit_req limit_req_log_level limit_req_zone limit_zone lingering_time lingering_timeout lock_file log_format log_not_found log_subrequest map_hash_bucket_size map_hash_max_size master_process memcached_bind memcached_buffer_size memcached_connect_timeout memcached_next_upstream memcached_read_timeout memcached_send_timeout memcached_upstream_fail_timeout memcached_upstream_max_fails merge_slashes min_delete_depth modern_browser modern_browser_value msie_padding msie_refresh multi_accept open_file_cache open_file_cache_errors open_file_cache_events open_file_cache_min_uses open_file_cache_valid open_log_file_cache output_buffers override_charset perl perl_modules perl_require perl_set pid pop3_auth pop3_capabilities port_in_redirect postpone_gzipping postpone_output protocol proxy proxy_bind proxy_buffer proxy_buffer_size proxy_buffering proxy_buffers proxy_busy_buffers_size proxy_cache proxy_cache_key proxy_cache_methods proxy_cache_min_uses proxy_cache_path proxy_cache_use_stale proxy_cache_valid proxy_connect_timeout proxy_headers_hash_bucket_size proxy_headers_hash_max_size proxy_hide_header proxy_ignore_client_abort proxy_ignore_headers proxy_intercept_errors proxy_max_temp_file_size proxy_method proxy_next_upstream proxy_pass_error_message proxy_pass_header proxy_pass_request_body proxy_pass_request_headers proxy_read_timeout proxy_redirect proxy_send_lowat proxy_send_timeout proxy_set_body proxy_set_header proxy_ssl_session_reuse proxy_store proxy_store_access proxy_temp_file_write_size proxy_temp_path proxy_timeout proxy_upstream_fail_timeout proxy_upstream_max_fails random_index read_ahead real_ip_header recursive_error_pages request_pool_size reset_timedout_connection resolver resolver_timeout rewrite_log rtsig_overflow_events rtsig_overflow_test rtsig_overflow_threshold rtsig_signo satisfy secure_link_secret send_lowat send_timeout sendfile sendfile_max_chunk server_name_in_redirect server_names_hash_bucket_size server_names_hash_max_size server_tokens set_real_ip_from smtp_auth smtp_capabilities smtp_client_buffer smtp_greeting_delay so_keepalive source_charset ssi ssi_ignore_recycled_buffers ssi_min_file_chunk ssi_silent_errors ssi_types ssi_value_length ssl ssl_certificate ssl_certificate_key ssl_ciphers ssl_client_certificate ssl_crl ssl_dhparam ssl_engine ssl_prefer_server_ciphers ssl_protocols ssl_session_cache ssl_session_timeout ssl_verify_client ssl_verify_depth starttls stub_status sub_filter sub_filter_once sub_filter_types tcp_nodelay tcp_nopush thread_stack_size timeout timer_resolution types_hash_bucket_size types_hash_max_size underscores_in_headers uninitialized_variable_warn use user userid userid_domain userid_expires userid_mark userid_name userid_p3p userid_path userid_service valid_referers variables_hash_bucket_size variables_hash_max_size worker_connections worker_cpu_affinity worker_priority worker_processes worker_rlimit_core worker_rlimit_nofile worker_rlimit_sigpending worker_threads working_directory xclient xml_entities xslt_stylesheet xslt_typesdrew@li229-23"),r=t("http mail events server types location upstream charset_map limit_except if geo map"),i=t("include root server server_name listen internal proxy_pass memcached_pass fastcgi_pass try_files"),s=e.indentUnit,o;return{startState:function(e){return{tokenize:a,baseIndent:e||0,stack:[]}},token:function(e,t){if(e.eatSpace())return null;o=null;var n=t.tokenize(e,t),r=t.stack[t.stack.length-1];if(o=="hash"&&r=="rule")n="atom";else if(n=="variable")if(r=="rule")n="number";else if(!r||r=="@media{")n="tag";return r=="rule"&&/^[\{\};]$/.test(o)&&t.stack.pop(),o=="{"?r=="@media"?t.stack[t.stack.length-1]="@media{":t.stack.push("{"):o=="}"?t.stack.pop():o=="@media"?t.stack.push("@media"):r=="{"&&o!="comment"&&t.stack.push("rule"),n},indent:function(e,t){var n=e.stack.length;return/^\}/.test(t)&&(n-=e.stack[e.stack.length-1]=="rule"?2:1),e.baseIndent+n*s},electricChars:"}"}}),e.defineMIME("text/nginx","text/x-nginx-conf")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/ntriples/ntriples",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("ntriples",function(){function t(t,n){var r=t.location,i;r==e.PRE_SUBJECT&&n=="<"?i=e.WRITING_SUB_URI:r==e.PRE_SUBJECT&&n=="_"?i=e.WRITING_BNODE_URI:r==e.PRE_PRED&&n=="<"?i=e.WRITING_PRED_URI:r==e.PRE_OBJ&&n=="<"?i=e.WRITING_OBJ_URI:r==e.PRE_OBJ&&n=="_"?i=e.WRITING_OBJ_BNODE:r==e.PRE_OBJ&&n=='"'?i=e.WRITING_OBJ_LITERAL:r==e.WRITING_SUB_URI&&n==">"?i=e.PRE_PRED:r==e.WRITING_BNODE_URI&&n==" "?i=e.PRE_PRED:r==e.WRITING_PRED_URI&&n==">"?i=e.PRE_OBJ:r==e.WRITING_OBJ_URI&&n==">"?i=e.POST_OBJ:r==e.WRITING_OBJ_BNODE&&n==" "?i=e.POST_OBJ:r==e.WRITING_OBJ_LITERAL&&n=='"'?i=e.POST_OBJ:r==e.WRITING_LIT_LANG&&n==" "?i=e.POST_OBJ:r==e.WRITING_LIT_TYPE&&n==">"?i=e.POST_OBJ:r==e.WRITING_OBJ_LITERAL&&n=="@"?i=e.WRITING_LIT_LANG:r==e.WRITING_OBJ_LITERAL&&n=="^"?i=e.WRITING_LIT_TYPE:n!=" "||r!=e.PRE_SUBJECT&&r!=e.PRE_PRED&&r!=e.PRE_OBJ&&r!=e.POST_OBJ?r==e.POST_OBJ&&n=="."?i=e.PRE_SUBJECT:i=e.ERROR:i=r,t.location=i}var e={PRE_SUBJECT:0,WRITING_SUB_URI:1,WRITING_BNODE_URI:2,PRE_PRED:3,WRITING_PRED_URI:4,PRE_OBJ:5,WRITING_OBJ_URI:6,WRITING_OBJ_BNODE:7,WRITING_OBJ_LITERAL:8,WRITING_LIT_LANG:9,WRITING_LIT_TYPE:10,POST_OBJ:11,ERROR:12};return{startState:function(){return{location:e.PRE_SUBJECT,uris:[],anchors:[],bnodes:[],langs:[],types:[]}},token:function(e,n){var r=e.next();if(r=="<"){t(n,r);var i="";return e.eatWhile(function(e){return e!="#"&&e!=">"?(i+=e,!0):!1}),n.uris.push(i),e.match("#",!1)?"variable":(e.next(),t(n,">"),"variable")}if(r=="#"){var s="";return e.eatWhile(function(e){return e!=">"&&e!=" "?(s+=e,!0):!1}),n.anchors.push(s),"variable-2"}if(r==">")return t(n,">"),"variable";if(r=="_"){t(n,r);var o="";return e.eatWhile(function(e){return e!=" "?(o+=e,!0):!1}),n.bnodes.push(o),e.next(),t(n," "),"builtin"}if(r=='"')return t(n,r),e.eatWhile(function(e){return e!='"'}),e.next(),e.peek()!="@"&&e.peek()!="^"&&t(n,'"'),"string";if(r=="@"){t(n,"@");var u="";return e.eatWhile(function(e){return e!=" "?(u+=e,!0):!1}),n.langs.push(u),e.next(),t(n," "),"string-2"}if(r=="^"){e.next(),t(n,"^");var a="";return e.eatWhile(function(e){return e!=">"?(a+=e,!0):!1}),n.types.push(a),e.next(),t(n,">"),"variable"}r==" "&&t(n,r),r=="."&&t(n,r)}}}),e.defineMIME("text/n-triples","ntriples")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/octave/octave",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("octave",function(){function e(e){return new RegExp("^(("+e.join(")|(")+"))\\b")}function l(e,t){return!e.sol()&&e.peek()==="'"?(e.next(),t.tokenize=h,"operator"):(t.tokenize=h,h(e,t))}function c(e,t){return e.match(/^.*%}/)?(t.tokenize=h,"comment"):(e.skipToEnd(),"comment")}function h(p,d){if(p.eatSpace())return null;if(p.match("%{"))return d.tokenize=c,p.skipToEnd(),"comment";if(p.match(/^[%#]/))return p.skipToEnd(),"comment";if(p.match(/^[0-9\.+-]/,!1)){if(p.match(/^[+-]?0x[0-9a-fA-F]+[ij]?/))return p.tokenize=h,"number";if(p.match(/^[+-]?\d*\.\d+([EeDd][+-]?\d+)?[ij]?/))return"number";if(p.match(/^[+-]?\d+([EeDd][+-]?\d+)?[ij]?/))return"number"}return p.match(e(["nan","NaN","inf","Inf"]))?"number":p.match(/^"([^"]|(""))*"/)?"string":p.match(/^'([^']|(''))*'/)?"string":p.match(f)?"keyword":p.match(a)?"builtin":p.match(u)?"variable":p.match(t)||p.match(r)?"operator":p.match(n)||p.match(i)||p.match(s)?null:p.match(o)?(d.tokenize=l,null):(p.next(),"error")}var t=new RegExp("^[\\+\\-\\*/&|\\^~<>!@'\\\\]"),n=new RegExp("^[\\(\\[\\{\\},:=;]"),r=new RegExp("^((==)|(~=)|(<=)|(>=)|(<<)|(>>)|(\\.[\\+\\-\\*/\\^\\\\]))"),i=new RegExp("^((!=)|(\\+=)|(\\-=)|(\\*=)|(/=)|(&=)|(\\|=)|(\\^=))"),s=new RegExp("^((>>=)|(<<=))"),o=new RegExp("^[\\]\\)]"),u=new RegExp("^[_A-Za-z][_A-Za-z0-9]*"),a=e(["error","eval","function","abs","acos","atan","asin","cos","cosh","exp","log","prod","sum","log10","max","min","sign","sin","sinh","sqrt","tan","reshape","break","zeros","default","margin","round","ones","rand","syn","ceil","floor","size","clear","zeros","eye","mean","std","cov","det","eig","inv","norm","rank","trace","expm","logm","sqrtm","linspace","plot","title","xlabel","ylabel","legend","text","grid","meshgrid","mesh","num2str","fft","ifft","arrayfun","cellfun","input","fliplr","flipud","ismember"]),f=e(["return","case","switch","else","elseif","end","endif","endfunction","if","otherwise","do","for","while","try","catch","classdef","properties","events","methods","global","persistent","endfor","endwhile","printf","sprintf","disp","until","continue","pkg"]);return{startState:function(){return{tokenize:h}},token:function(e,t){var n=t.tokenize(e,t);if(n==="number"||n==="variable")t.tokenize=l;return n}}}),e.defineMIME("text/x-octave","octave")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/pascal/pascal",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("pascal",function(){function e(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function i(e,i){var u=e.next();if(u=="#"&&i.startOfLine)return e.skipToEnd(),"meta";if(u=='"'||u=="'")return i.tokenize=s(u),i.tokenize(e,i);if(u=="("&&e.eat("*"))return i.tokenize=o,o(e,i);if(/[\[\]{}\(\),;\:\.]/.test(u))return null;if(/\d/.test(u))return e.eatWhile(/[\w\.]/),"number";if(u=="/"&&e.eat("/"))return e.skipToEnd(),"comment";if(r.test(u))return e.eatWhile(r),"operator";e.eatWhile(/[\w\$_]/);var a=e.current();return t.propertyIsEnumerable(a)?"keyword":n.propertyIsEnumerable(a)?"atom":"variable"}function s(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r)n.tokenize=null;return"string"}}function o(e,t){var n=!1,r;while(r=e.next()){if(r==")"&&n){t.tokenize=null;break}n=r=="*"}return"comment"}var t=e("and array begin case const div do downto else end file for forward integer boolean char function goto if in label mod nil not of or packed procedure program record repeat set string then to type until var while with"),n={"null":!0},r=/[+\-*&%=<>!?|\/]/;return{startState:function(){return{tokenize:null}},token:function(e,t){if(e.eatSpace())return null;var n=(t.tokenize||i)(e,t);return n=="comment"||n=="meta"?n:n},electricChars:"{}"}}),e.defineMIME("text/x-pascal","pascal")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../javascript/javascript")):typeof define=="function"&&define.amd?define("components/codemirror/mode/pegjs/pegjs",["../../lib/codemirror","../javascript/javascript"],e):e(CodeMirror)}(function(e){e.defineMode("pegjs",function(t){function r(e){return e.match(/^[a-zA-Z_][a-zA-Z0-9_]*/)}var n=e.getMode(t,"javascript");return{startState:function(){return{inString:!1,stringType:null,inComment:!1,inChracterClass:!1,braced:0,lhs:!0,localState:null}},token:function(e,t){e&&!t.inString&&!t.inComment&&(e.peek()=='"'||e.peek()=="'")&&(t.stringType=e.peek(),e.next(),t.inString=!0),!t.inString&&!t.inComment&&e.match(/^\/\*/)&&(t.inComment=!0);if(t.inString){while(t.inString&&!e.eol())e.peek()===t.stringType?(e.next(),t.inString=!1):e.peek()==="\\"?(e.next(),e.next()):e.match(/^.[^\\\"\']*/);return t.lhs?"property string":"string"}if(t.inComment){while(t.inComment&&!e.eol())e.match(/\*\//)?t.inComment=!1:e.match(/^.[^\*]*/);return"comment"}if(t.inChracterClass)while(t.inChracterClass&&!e.eol())!e.match(/^[^\]\\]+/)&&!e.match(/^\\./)&&(t.inChracterClass=!1);else{if(e.peek()==="[")return e.next(),t.inChracterClass=!0,"bracket";if(e.match(/^\/\//))return e.skipToEnd(),"comment";if(t.braced||e.peek()==="{"){t.localState===null&&(t.localState=n.startState());var i=n.token(e,t.localState),s=e.current();if(!i)for(var o=0;o<s.length;o++)s[o]==="{"?t.braced++:s[o]==="}"&&t.braced--;return i}if(r(e))return e.peek()===":"?"variable":"variable-2";if(["[","]","(",")"].indexOf(e.peek())!=-1)return e.next(),"bracket";e.eatSpace()||e.next()}return null}}},"javascript")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/perl/perl",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e,t){return e.string.charAt(e.pos+(t||0))}function n(e,t){if(t){var n=e.pos-t;return e.string.substr(n>=0?n:0,t)}return e.string.substr(0,e.pos-1)}function r(e,t){var n=e.string.length,r=n-e.pos+1;return e.string.substr(e.pos,t&&t<n?t:r)}function i(e,t){var n=e.pos+t,r;n<=0?e.pos=0:n>=(r=e.string.length-1)?e.pos=r:e.pos=n}e.defineMode("perl",function(){function u(e,t,n,r,i){return t.chain=null,t.style=null,t.tail=null,t.tokenize=function(e,t){var s=!1,o,u=0;while(o=e.next()){if(o===n[u]&&!s)return n[++u]!==undefined?(t.chain=n[u],t.style=r,t.tail=i):i&&e.eatWhile(i),t.tokenize=f,r;s=!s&&o=="\\"}return r},t.tokenize(e,t)}function a(e,t,n){return t.tokenize=function(e,t){return e.string==n&&(t.tokenize=f),e.skipToEnd(),"string"},t.tokenize(e,t)}function f(f,l){if(f.eatSpace())return null;if(l.chain)return u(f,l,l.chain,l.style,l.tail);if(f.match(/^\-?[\d\.]/,!1)&&f.match(/^(\-?(\d*\.\d+(e[+-]?\d+)?|\d+\.\d*)|0x[\da-fA-F]+|0b[01]+|\d+(e[+-]?\d+)?)/))return"number";if(f.match(/^<<(?=\w)/))return f.eatWhile(/\w/),a(f,l,f.current().substr(2));if(f.sol()&&f.match(/^\=item(?!\w)/))return a(f,l,"=cut");var c=f.next();if(c=='"'||c=="'"){if(n(f,3)=="<<"+c){var h=f.pos;f.eatWhile(/\w/);var p=f.current().substr(1);if(p&&f.eat(c))return a(f,l,p);f.pos=h}return u(f,l,[c],"string")}if(c=="q"){var d=t(f,-2);if(!d||!/\w/.test(d)){d=t(f,0);if(d=="x"){d=t(f,1);if(d=="(")return i(f,2),u(f,l,[")"],s,o);if(d=="[")return i(f,2),u(f,l,["]"],s,o);if(d=="{")return i(f,2),u(f,l,["}"],s,o);if(d=="<")return i(f,2),u(f,l,[">"],s,o);if(/[\^'"!~\/]/.test(d))return i(f,1),u(f,l,[f.eat(d)],s,o)}else if(d=="q"){d=t(f,1);if(d=="(")return i(f,2),u(f,l,[")"],"string");if(d=="[")return i(f,2),u(f,l,["]"],"string");if(d=="{")return i(f,2),u(f,l,["}"],"string");if(d=="<")return i(f,2),u(f,l,[">"],"string");if(/[\^'"!~\/]/.test(d))return i(f,1),u(f,l,[f.eat(d)],"string")}else if(d=="w"){d=t(f,1);if(d=="(")return i(f,2),u(f,l,[")"],"bracket");if(d=="[")return i(f,2),u(f,l,["]"],"bracket");if(d=="{")return i(f,2),u(f,l,["}"],"bracket");if(d=="<")return i(f,2),u(f,l,[">"],"bracket");if(/[\^'"!~\/]/.test(d))return i(f,1),u(f,l,[f.eat(d)],"bracket")}else if(d=="r"){d=t(f,1);if(d=="(")return i(f,2),u(f,l,[")"],s,o);if(d=="[")return i(f,2),u(f,l,["]"],s,o);if(d=="{")return i(f,2),u(f,l,["}"],s,o);if(d=="<")return i(f,2),u(f,l,[">"],s,o);if(/[\^'"!~\/]/.test(d))return i(f,1),u(f,l,[f.eat(d)],s,o)}else if(/[\^'"!~\/(\[{<]/.test(d)){if(d=="(")return i(f,1),u(f,l,[")"],"string");if(d=="[")return i(f,1),u(f,l,["]"],"string");if(d=="{")return i(f,1),u(f,l,["}"],"string");if(d=="<")return i(f,1),u(f,l,[">"],"string");if(/[\^'"!~\/]/.test(d))return u(f,l,[f.eat(d)],"string")}}}if(c=="m"){var d=t(f,-2);if(!d||!/\w/.test(d)){d=f.eat(/[(\[{<\^'"!~\/]/);if(d){if(/[\^'"!~\/]/.test(d))return u(f,l,[d],s,o);if(d=="(")return u(f,l,[")"],s,o);if(d=="[")return u(f,l,["]"],s,o);if(d=="{")return u(f,l,["}"],s,o);if(d=="<")return u(f,l,[">"],s,o)}}}if(c=="s"){var d=/[\/>\]})\w]/.test(t(f,-2));if(!d){d=f.eat(/[(\[{<\^'"!~\/]/);if(d)return d=="["?u(f,l,["]","]"],s,o):d=="{"?u(f,l,["}","}"],s,o):d=="<"?u(f,l,[">",">"],s,o):d=="("?u(f,l,[")",")"],s,o):u(f,l,[d,d],s,o)}}if(c=="y"){var d=/[\/>\]})\w]/.test(t(f,-2));if(!d){d=f.eat(/[(\[{<\^'"!~\/]/);if(d)return d=="["?u(f,l,["]","]"],s,o):d=="{"?u(f,l,["}","}"],s,o):d=="<"?u(f,l,[">",">"],s,o):d=="("?u(f,l,[")",")"],s,o):u(f,l,[d,d],s,o)}}if(c=="t"){var d=/[\/>\]})\w]/.test(t(f,-2));if(!d){d=f.eat("r");if(d){d=f.eat(/[(\[{<\^'"!~\/]/);if(d)return d=="["?u(f,l,["]","]"],s,o):d=="{"?u(f,l,["}","}"],s,o):d=="<"?u(f,l,[">",">"],s,o):d=="("?u(f,l,[")",")"],s,o):u(f,l,[d,d],s,o)}}}if(c=="`")return u(f,l,[c],"variable-2");if(c=="/")return/~\s*$/.test(n(f))?u(f,l,[c],s,o):"operator";if(c=="$"){var h=f.pos;if(f.eatWhile(/\d/)||f.eat("{")&&f.eatWhile(/\d/)&&f.eat("}"))return"variable-2";f.pos=h}if(/[$@%]/.test(c)){var h=f.pos;if(f.eat("^")&&f.eat(/[A-Z]/)||!/[@$%&]/.test(t(f,-2))&&f.eat(/[=|\\\-#?@;:&`~\^!\[\]*'"$+.,\/<>()]/)){var d=f.current();if(e[d])return"variable-2"}f.pos=h}if(/[$@%&]/.test(c))if(f.eatWhile(/[\w$\[\]]/)||f.eat("{")&&f.eatWhile(/[\w$\[\]]/)&&f.eat("}")){var d=f.current();return e[d]?"variable-2":"variable"}if(c=="#"&&t(f,-2)!="$")return f.skipToEnd(),"comment";if(/[:+\-\^*$&%@=<>!?|\/~\.]/.test(c)){var h=f.pos;f.eatWhile(/[:+\-\^*$&%@=<>!?|\/~\.]/);if(e[f.current()])return"operator";f.pos=h}if(c=="_"&&f.pos==1){if(r(f,6)=="_END__")return u(f,l,["\0"],"comment");if(r(f,7)=="_DATA__")return u(f,l,["\0"],"variable-2");if(r(f,7)=="_C__")return u(f,l,["\0"],"string")}if(/\w/.test(c)){var h=f.pos;if(t(f,-2)=="{"&&(t(f,0)=="}"||f.eatWhile(/\w/)&&t(f,0)=="}"))return"string";f.pos=h}if(/[A-Z]/.test(c)){var v=t(f,-2),h=f.pos;f.eatWhile(/[A-Z_]/);if(!/[\da-z]/.test(t(f,0))){var d=e[f.current()];return d?(d[1]&&(d=d[0]),v!=":"?d==1?"keyword":d==2?"def":d==3?"atom":d==4?"operator":d==5?"variable-2":"meta":"meta"):"meta"}f.pos=h}if(/[a-zA-Z_]/.test(c)){var v=t(f,-2);f.eatWhile(/\w/);var d=e[f.current()];return d?(d[1]&&(d=d[0]),v!=":"?d==1?"keyword":d==2?"def":d==3?"atom":d==4?"operator":d==5?"variable-2":"meta":"meta"):"meta"}return null}var e={"->":4,"++":4,"--":4,"**":4,"=~":4,"!~":4,"*":4,"/":4,"%":4,x:4,"+":4,"-":4,".":4,"<<":4,">>":4,"<":4,">":4,"<=":4,">=":4,lt:4,gt:4,le:4,ge:4,"==":4,"!=":4,"<=>":4,eq:4,ne:4,cmp:4,"~~":4,"&":4,"|":4,"^":4,"&&":4,"||":4,"//":4,"..":4,"...":4,"?":4,":":4,"=":4,"+=":4,"-=":4,"*=":4,",":4,"=>":4,"::":4,not:4,and:4,or:4,xor:4,BEGIN:[5,1],END:[5,1],PRINT:[5,1],PRINTF:[5,1],GETC:[5,1],READ:[5,1],READLINE:[5,1],DESTROY:[5,1],TIE:[5,1],TIEHANDLE:[5,1],UNTIE:[5,1],STDIN:5,STDIN_TOP:5,STDOUT:5,STDOUT_TOP:5,STDERR:5,STDERR_TOP:5,$ARG:5,$_:5,"@ARG":5,"@_":5,$LIST_SEPARATOR:5,'$"':5,$PROCESS_ID:5,$PID:5,$$:5,$REAL_GROUP_ID:5,$GID:5,"$(":5,$EFFECTIVE_GROUP_ID:5,$EGID:5,"$)":5,$PROGRAM_NAME:5,$0:5,$SUBSCRIPT_SEPARATOR:5,$SUBSEP:5,"$;":5,$REAL_USER_ID:5,$UID:5,"$<":5,$EFFECTIVE_USER_ID:5,$EUID:5,"$>":5,$a:5,$b:5,$COMPILING:5,"$^C":5,$DEBUGGING:5,"$^D":5,"${^ENCODING}":5,$ENV:5,"%ENV":5,$SYSTEM_FD_MAX:5,"$^F":5,"@F":5,"${^GLOBAL_PHASE}":5,"$^H":5,"%^H":5,"@INC":5,"%INC":5,$INPLACE_EDIT:5,"$^I":5,"$^M":5,$OSNAME:5,"$^O":5,"${^OPEN}":5,$PERLDB:5,"$^P":5,$SIG:5,"%SIG":5,$BASETIME:5,"$^T":5,"${^TAINT}":5,"${^UNICODE}":5,"${^UTF8CACHE}":5,"${^UTF8LOCALE}":5,$PERL_VERSION:5,"$^V":5,"${^WIN32_SLOPPY_STAT}":5,$EXECUTABLE_NAME:5,"$^X":5,$1:5,$MATCH:5,"$&":5,"${^MATCH}":5,$PREMATCH:5,"$`":5,"${^PREMATCH}":5,$POSTMATCH:5,"$'":5,"${^POSTMATCH}":5,$LAST_PAREN_MATCH:5,"$+":5,$LAST_SUBMATCH_RESULT:5,"$^N":5,"@LAST_MATCH_END":5,"@+":5,"%LAST_PAREN_MATCH":5,"%+":5,"@LAST_MATCH_START":5,"@-":5,"%LAST_MATCH_START":5,"%-":5,$LAST_REGEXP_CODE_RESULT:5,"$^R":5,"${^RE_DEBUG_FLAGS}":5,"${^RE_TRIE_MAXBUF}":5,$ARGV:5,"@ARGV":5,ARGV:5,ARGVOUT:5,$OUTPUT_FIELD_SEPARATOR:5,$OFS:5,"$,":5,$INPUT_LINE_NUMBER:5,$NR:5,"$.":5,$INPUT_RECORD_SEPARATOR:5,$RS:5,"$/":5,$OUTPUT_RECORD_SEPARATOR:5,$ORS:5,"$\\":5,$OUTPUT_AUTOFLUSH:5,"$|":5,$ACCUMULATOR:5,"$^A":5,$FORMAT_FORMFEED:5,"$^L":5,$FORMAT_PAGE_NUMBER:5,"$%":5,$FORMAT_LINES_LEFT:5,"$-":5,$FORMAT_LINE_BREAK_CHARACTERS:5,"$:":5,$FORMAT_LINES_PER_PAGE:5,"$=":5,$FORMAT_TOP_NAME:5,"$^":5,$FORMAT_NAME:5,"$~":5,"${^CHILD_ERROR_NATIVE}":5,$EXTENDED_OS_ERROR:5,"$^E":5,$EXCEPTIONS_BEING_CAUGHT:5,"$^S":5,$WARNING:5,"$^W":5,"${^WARNING_BITS}":5,$OS_ERROR:5,$ERRNO:5,"$!":5,"%OS_ERROR":5,"%ERRNO":5,"%!":5,$CHILD_ERROR:5,"$?":5,$EVAL_ERROR:5,"$@":5,$OFMT:5,"$#":5,"$*":5,$ARRAY_BASE:5,"$[":5,$OLD_PERL_VERSION:5,"$]":5,"if":[1,1],elsif:[1,1],"else":[1,1],"while":[1,1],unless:[1,1],"for":[1,1],foreach:[1,1],abs:1,accept:1,alarm:1,atan2:1,bind:1,binmode:1,bless:1,bootstrap:1,"break":1,caller:1,chdir:1,chmod:1,chomp:1,chop:1,chown:1,chr:1,chroot:1,close:1,closedir:1,connect:1,"continue":[1,1],cos:1,crypt:1,dbmclose:1,dbmopen:1,"default":1,defined:1,"delete":1,die:1,"do":1,dump:1,each:1,endgrent:1,endhostent:1,endnetent:1,endprotoent:1,endpwent:1,endservent:1,eof:1,eval:1,exec:1,exists:1,exit:1,exp:1,fcntl:1,fileno:1,flock:1,fork:1,format:1,formline:1,getc:1,getgrent:1,getgrgid:1,getgrnam:1,gethostbyaddr:1,gethostbyname:1,gethostent:1,getlogin:1,getnetbyaddr:1,getnetbyname:1,getnetent:1,getpeername:1,getpgrp:1,getppid:1,getpriority:1,getprotobyname:1,getprotobynumber:1,getprotoent:1,getpwent:1,getpwnam:1,getpwuid:1,getservbyname:1,getservbyport:1,getservent:1,getsockname:1,getsockopt:1,given:1,glob:1,gmtime:1,"goto":1,grep:1,hex:1,"import":1,index:1,"int":1,ioctl:1,join:1,keys:1,kill:1,last:1,lc:1,lcfirst:1,length:1,link:1,listen:1,local:2,localtime:1,lock:1,log:1,lstat:1,m:null,map:1,mkdir:1,msgctl:1,msgget:1,msgrcv:1,msgsnd:1,my:2,"new":1,next:1,no:1,oct:1,open:1,opendir:1,ord:1,our:2,pack:1,"package":1,pipe:1,pop:1,pos:1,print:1,printf:1,prototype:1,push:1,q:null,qq:null,qr:null,quotemeta:null,qw:null,qx:null,rand:1,read:1,readdir:1,readline:1,readlink:1,readpipe:1,recv:1,redo:1,ref:1,rename:1,require:1,reset:1,"return":1,reverse:1,rewinddir:1,rindex:1,rmdir:1,s:null,say:1,scalar:1,seek:1,seekdir:1,select:1,semctl:1,semget:1,semop:1,send:1,setgrent:1,sethostent:1,setnetent:1,setpgrp:1,setpriority:1,setprotoent:1,setpwent:1,setservent:1,setsockopt:1,shift:1,shmctl:1,shmget:1,shmread:1,shmwrite:1,shutdown:1,sin:1,sleep:1,socket:1,socketpair:1,sort:1,splice:1,split:1,sprintf:1,sqrt:1,srand:1,stat:1,state:1,study:1,sub:1,substr:1,symlink:1,syscall:1,sysopen:1,sysread:1,sysseek:1,system:1,syswrite:1,tell:1,telldir:1,tie:1,tied:1,time:1,times:1,tr:null,truncate:1,uc:1,ucfirst:1,umask:1,undef:1,unlink:1,unpack:1,unshift:1,untie:1,use:1,utime:1,values:1,vec:1,wait:1,waitpid:1,wantarray:1,warn:1,when:1,write:1,y:null},s="string-2",o=/[goseximacplud]/;return{startState:function(){return{tokenize:f,chain:null,style:null,tail:null}},token:function(e,t){return(t.tokenize||f)(e,t)},electricChars:"{}"}}),e.registerHelper("wordChars","perl",/[\\w$]/),e.defineMIME("text/x-perl","perl")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../htmlmixed/htmlmixed"),require("../clike/clike")):typeof define=="function"&&define.amd?define("components/codemirror/mode/php/php",["../../lib/codemirror","../htmlmixed/htmlmixed","../clike/clike"],e):e(CodeMirror)}(function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function n(e){return function(t,n){return t.match(e)?n.tokenize=null:t.skipToEnd(),"string"}}function r(e){return e.length==0?i:function(t,n){var s=e[0];for(var o=0;o<s.length;o++)if(t.match(s[o][0]))return n.tokenize=r(e.slice(1)),s[o][1];return n.tokenize=i,"string"}}function i(e,t){var n=!1,i,s=!1;if(e.current()=='"')return"string";if(e.match("${",!1)||e.match("{$",!1))return t.tokenize=null,"string";if(e.match(/\$[a-zA-Z_][a-zA-Z0-9_]*/))return e.match("[",!1)&&(t.tokenize=r([[["[",null]],[[/\d[\w\.]*/,"number"],[/\$[a-zA-Z_][a-zA-Z0-9_]*/,"variable-2"],[/[\w\$]+/,"variable"]],[["]",null]]])),e.match(/\-\>\w/,!1)&&(t.tokenize=r([[["->",null]],[[/[\w]+/,"variable"]]])),"variable-2";while(!e.eol()&&!e.match("{$",!1)&&(!e.match(/(\$[a-zA-Z_][a-zA-Z0-9_]*|\$\{)/,!1)||n)){i=e.next();if(!n&&i=='"'){s=!0;break}n=!n&&i=="\\"}return s&&(t.tokenize=null,t.phpEncapsStack.pop()),"string"}var s="abstract and array as break case catch class clone const continue declare default do else elseif enddeclare endfor endforeach endif endswitch endwhile extends final for foreach function global goto if implements interface instanceof namespace new or private protected public static switch throw trait try use var while xor die echo empty exit eval include include_once isset list require require_once return print unset __halt_compiler self static parent yield insteadof finally",o="true false null TRUE FALSE NULL __CLASS__ __DIR__ __FILE__ __LINE__ __METHOD__ __FUNCTION__ __NAMESPACE__ __TRAIT__",u="func_num_args func_get_arg func_get_args strlen strcmp strncmp strcasecmp strncasecmp each error_reporting define defined trigger_error user_error set_error_handler restore_error_handler get_declared_classes get_loaded_extensions extension_loaded get_extension_funcs debug_backtrace constant bin2hex hex2bin sleep usleep time mktime gmmktime strftime gmstrftime strtotime date gmdate getdate localtime checkdate flush wordwrap htmlspecialchars htmlentities html_entity_decode md5 md5_file crc32 getimagesize image_type_to_mime_type phpinfo phpversion phpcredits strnatcmp strnatcasecmp substr_count strspn strcspn strtok strtoupper strtolower strpos strrpos strrev hebrev hebrevc nl2br basename dirname pathinfo stripslashes stripcslashes strstr stristr strrchr str_shuffle str_word_count strcoll substr substr_replace quotemeta ucfirst ucwords strtr addslashes addcslashes rtrim str_replace str_repeat count_chars chunk_split trim ltrim strip_tags similar_text explode implode setlocale localeconv parse_str str_pad chop strchr sprintf printf vprintf vsprintf sscanf fscanf parse_url urlencode urldecode rawurlencode rawurldecode readlink linkinfo link unlink exec system escapeshellcmd escapeshellarg passthru shell_exec proc_open proc_close rand srand getrandmax mt_rand mt_srand mt_getrandmax base64_decode base64_encode abs ceil floor round is_finite is_nan is_infinite bindec hexdec octdec decbin decoct dechex base_convert number_format fmod ip2long long2ip getenv putenv getopt microtime gettimeofday getrusage uniqid quoted_printable_decode set_time_limit get_cfg_var magic_quotes_runtime set_magic_quotes_runtime get_magic_quotes_gpc get_magic_quotes_runtime import_request_variables error_log serialize unserialize memory_get_usage var_dump var_export debug_zval_dump print_r highlight_file show_source highlight_string ini_get ini_get_all ini_set ini_alter ini_restore get_include_path set_include_path restore_include_path setcookie header headers_sent connection_aborted connection_status ignore_user_abort parse_ini_file is_uploaded_file move_uploaded_file intval floatval doubleval strval gettype settype is_null is_resource is_bool is_long is_float is_int is_integer is_double is_real is_numeric is_string is_array is_object is_scalar ereg ereg_replace eregi eregi_replace split spliti join sql_regcase dl pclose popen readfile rewind rmdir umask fclose feof fgetc fgets fgetss fread fopen fpassthru ftruncate fstat fseek ftell fflush fwrite fputs mkdir rename copy tempnam tmpfile file file_get_contents stream_select stream_context_create stream_context_set_params stream_context_set_option stream_context_get_options stream_filter_prepend stream_filter_append fgetcsv flock get_meta_tags stream_set_write_buffer set_file_buffer set_socket_blocking stream_set_blocking socket_set_blocking stream_get_meta_data stream_register_wrapper stream_wrapper_register stream_set_timeout socket_set_timeout socket_get_status realpath fnmatch fsockopen pfsockopen pack unpack get_browser crypt opendir closedir chdir getcwd rewinddir readdir dir glob fileatime filectime filegroup fileinode filemtime fileowner fileperms filesize filetype file_exists is_writable is_writeable is_readable is_executable is_file is_dir is_link stat lstat chown touch clearstatcache mail ob_start ob_flush ob_clean ob_end_flush ob_end_clean ob_get_flush ob_get_clean ob_get_length ob_get_level ob_get_status ob_get_contents ob_implicit_flush ob_list_handlers ksort krsort natsort natcasesort asort arsort sort rsort usort uasort uksort shuffle array_walk count end prev next reset current key min max in_array array_search extract compact array_fill range array_multisort array_push array_pop array_shift array_unshift array_splice array_slice array_merge array_merge_recursive array_keys array_values array_count_values array_reverse array_reduce array_pad array_flip array_change_key_case array_rand array_unique array_intersect array_intersect_assoc array_diff array_diff_assoc array_sum array_filter array_map array_chunk array_key_exists pos sizeof key_exists assert assert_options version_compare ftok str_rot13 aggregate session_name session_module_name session_save_path session_id session_regenerate_id session_decode session_register session_unregister session_is_registered session_encode session_start session_destroy session_unset session_set_save_handler session_cache_limiter session_cache_expire session_set_cookie_params session_get_cookie_params session_write_close preg_match preg_match_all preg_replace preg_replace_callback preg_split preg_quote preg_grep overload ctype_alnum ctype_alpha ctype_cntrl ctype_digit ctype_lower ctype_graph ctype_print ctype_punct ctype_space ctype_upper ctype_xdigit virtual apache_request_headers apache_note apache_lookup_uri apache_child_terminate apache_setenv apache_response_headers apache_get_version getallheaders mysql_connect mysql_pconnect mysql_close mysql_select_db mysql_create_db mysql_drop_db mysql_query mysql_unbuffered_query mysql_db_query mysql_list_dbs mysql_list_tables mysql_list_fields mysql_list_processes mysql_error mysql_errno mysql_affected_rows mysql_insert_id mysql_result mysql_num_rows mysql_num_fields mysql_fetch_row mysql_fetch_array mysql_fetch_assoc mysql_fetch_object mysql_data_seek mysql_fetch_lengths mysql_fetch_field mysql_field_seek mysql_free_result mysql_field_name mysql_field_table mysql_field_len mysql_field_type mysql_field_flags mysql_escape_string mysql_real_escape_string mysql_stat mysql_thread_id mysql_client_encoding mysql_get_client_info mysql_get_host_info mysql_get_proto_info mysql_get_server_info mysql_info mysql mysql_fieldname mysql_fieldtable mysql_fieldlen mysql_fieldtype mysql_fieldflags mysql_selectdb mysql_createdb mysql_dropdb mysql_freeresult mysql_numfields mysql_numrows mysql_listdbs mysql_listtables mysql_listfields mysql_db_name mysql_dbname mysql_tablename mysql_table_name pg_connect pg_pconnect pg_close pg_connection_status pg_connection_busy pg_connection_reset pg_host pg_dbname pg_port pg_tty pg_options pg_ping pg_query pg_send_query pg_cancel_query pg_fetch_result pg_fetch_row pg_fetch_assoc pg_fetch_array pg_fetch_object pg_fetch_all pg_affected_rows pg_get_result pg_result_seek pg_result_status pg_free_result pg_last_oid pg_num_rows pg_num_fields pg_field_name pg_field_num pg_field_size pg_field_type pg_field_prtlen pg_field_is_null pg_get_notify pg_get_pid pg_result_error pg_last_error pg_last_notice pg_put_line pg_end_copy pg_copy_to pg_copy_from pg_trace pg_untrace pg_lo_create pg_lo_unlink pg_lo_open pg_lo_close pg_lo_read pg_lo_write pg_lo_read_all pg_lo_import pg_lo_export pg_lo_seek pg_lo_tell pg_escape_string pg_escape_bytea pg_unescape_bytea pg_client_encoding pg_set_client_encoding pg_meta_data pg_convert pg_insert pg_update pg_delete pg_select pg_exec pg_getlastoid pg_cmdtuples pg_errormessage pg_numrows pg_numfields pg_fieldname pg_fieldsize pg_fieldtype pg_fieldnum pg_fieldprtlen pg_fieldisnull pg_freeresult pg_result pg_loreadall pg_locreate pg_lounlink pg_loopen pg_loclose pg_loread pg_lowrite pg_loimport pg_loexport http_response_code get_declared_traits getimagesizefromstring socket_import_stream stream_set_chunk_size trait_exists header_register_callback class_uses session_status session_register_shutdown echo print global static exit array empty eval isset unset die include require include_once require_once";e.registerHelper("hintWords","php",[s,o,u].join(" ").split(" ")),e.registerHelper("wordChars","php",/[\\w$]/);var a={name:"clike",helperType:"php",keywords:t(s),blockKeywords:t("catch do else elseif for foreach if switch try while finally"),atoms:t(o),builtin:t(u),multiLineStrings:!0,hooks:{$:function(e){return e.eatWhile(/[\w\$_]/),"variable-2"},"<":function(e,t){return e.match(/<</)?(e.eatWhile(/[\w\.]/),t.tokenize=n(e.current().slice(3)),t.tokenize(e,t)):!1},"#":function(e){while(!e.eol()&&!e.match("?>",!1))e.next();return"comment"},"/":function(e){if(e.eat("/")){while(!e.eol()&&!e.match("?>",!1))e.next();return"comment"}return!1},'"':function(e,t){return t.phpEncapsStack||(t.phpEncapsStack=[]),t.phpEncapsStack.push(0),t.tokenize=i,t.tokenize(e,t)},"{":function(e,t){return t.phpEncapsStack&&t.phpEncapsStack.length>0&&t.phpEncapsStack[t.phpEncapsStack.length-1]++,!1},"}":function(e,t){return t.phpEncapsStack&&t.phpEncapsStack.length>0&&--t.phpEncapsStack[t.phpEncapsStack.length-1]==0&&(t.tokenize=i),!1}}};e.defineMode("php",function(t,n){function s(e,t){var n=t.curMode==i;e.sol()&&t.pending&&t.pending!='"'&&t.pending!="'"&&(t.pending=null);if(!n){if(e.match(/^<\?\w*/))return t.curMode=i,t.curState=t.php,"meta";if(t.pending=='"'||t.pending=="'"){while(!e.eol()&&e.next()!=t.pending);var s="string"}else if(t.pending&&e.pos<t.pending.end){e.pos=t.pending.end;var s=t.pending.style}else var s=r.token(e,t.curState);t.pending&&(t.pending=null);var o=e.current(),u=o.search(/<\?/),a;return u!=-1&&(s=="string"&&(a=o.match(/[\'\"]$/))&&!/\?>/.test(o)?t.pending=a[0]:t.pending={end:e.pos,style:s},e.backUp(o.length-u)),s}return n&&t.php.tokenize==null&&e.match("?>")?(t.curMode=r,t.curState=t.html,"meta"):i.token(e,t.curState)}var r=e.getMode(t,"text/html"),i=e.getMode(t,a);return{startState:function(){var t=e.startState(r),s=e.startState(i);return{html:t,php:s,curMode:n.startOpen?i:r,curState:n.startOpen?s:t,pending:null}},copyState:function(t){var n=t.html,s=e.copyState(r,n),o=t.php,u=e.copyState(i,o),a;return t.curMode==r?a=s:a=u,{html:s,php:u,curMode:t.curMode,curState:a,pending:t.pending}},token:s,indent:function(e,t){return e.curMode!=i&&/^\s*<\//.test(t)||e.curMode==i&&/^\?>/.test(t)?r.indent(e.html,t):e.curMode.indent(e.curState,t)},blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//",innerMode:function(e){return{state:e.curState,mode:e.curMode}}}},"htmlmixed","clike"),e.defineMIME("application/x-httpd-php","php"),e.defineMIME("application/x-httpd-php-open",{name:"php",startOpen:!0}),e.defineMIME("text/x-php",a)}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/pig/pig",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("pig",function(e,t){function u(e,t,n){return t.tokenize=n,n(e,t)}function f(e,t){return a=e,t}function l(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=h;break}n=r=="*"}return f("comment","comment")}function c(e){return function(t,n){var r=!1,i,o=!1;while((i=t.next())!=null){if(i==e&&!r){o=!0;break}r=!r&&i=="\\"}if(o||!r&&!s)n.tokenize=h;return f("string","error")}}function h(e,t){var s=e.next();return s=='"'||s=="'"?u(e,t,c(s)):/[\[\]{}\(\),;\.]/.test(s)?f(s):/\d/.test(s)?(e.eatWhile(/[\w\.]/),f("number","number")):s=="/"?e.eat("*")?u(e,t,l):(e.eatWhile(o),f("operator","operator")):s=="-"?e.eat("-")?(e.skipToEnd(),f("comment","comment")):(e.eatWhile(o),f("operator","operator")):o.test(s)?(e.eatWhile(o),f("operator","operator")):(e.eatWhile(/[\w\$_]/),n&&n.propertyIsEnumerable(e.current().toUpperCase())&&!e.eat(")")&&!e.eat(".")?("keyword","keyword"):r&&r.propertyIsEnumerable(e.current().toUpperCase())?("keyword","variable-2"):i&&i.propertyIsEnumerable(e.current().toUpperCase())?("keyword","variable-3"):f("variable","pig-word"))}var n=t.keywords,r=t.builtins,i=t.types,s=t.multiLineStrings,o=/[*+\-%<>=&?:\/!|]/,a;return{startState:function(){return{tokenize:h,startOfLine:!0}},token:function(e,t){if(e.eatSpace())return null;var n=t.tokenize(e,t);return n}}}),function(){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}var n="ABS ACOS ARITY ASIN ATAN AVG BAGSIZE BINSTORAGE BLOOM BUILDBLOOM CBRT CEIL CONCAT COR COS COSH COUNT COUNT_STAR COV CONSTANTSIZE CUBEDIMENSIONS DIFF DISTINCT DOUBLEABS DOUBLEAVG DOUBLEBASE DOUBLEMAX DOUBLEMIN DOUBLEROUND DOUBLESUM EXP FLOOR FLOATABS FLOATAVG FLOATMAX FLOATMIN FLOATROUND FLOATSUM GENERICINVOKER INDEXOF INTABS INTAVG INTMAX INTMIN INTSUM INVOKEFORDOUBLE INVOKEFORFLOAT INVOKEFORINT INVOKEFORLONG INVOKEFORSTRING INVOKER ISEMPTY JSONLOADER JSONMETADATA JSONSTORAGE LAST_INDEX_OF LCFIRST LOG LOG10 LOWER LONGABS LONGAVG LONGMAX LONGMIN LONGSUM MAX MIN MAPSIZE MONITOREDUDF NONDETERMINISTIC OUTPUTSCHEMA  PIGSTORAGE PIGSTREAMING RANDOM REGEX_EXTRACT REGEX_EXTRACT_ALL REPLACE ROUND SIN SINH SIZE SQRT STRSPLIT SUBSTRING SUM STRINGCONCAT STRINGMAX STRINGMIN STRINGSIZE TAN TANH TOBAG TOKENIZE TOMAP TOP TOTUPLE TRIM TEXTLOADER TUPLESIZE UCFIRST UPPER UTF8STORAGECONVERTER ",r="VOID IMPORT RETURNS DEFINE LOAD FILTER FOREACH ORDER CUBE DISTINCT COGROUP JOIN CROSS UNION SPLIT INTO IF OTHERWISE ALL AS BY USING INNER OUTER ONSCHEMA PARALLEL PARTITION GROUP AND OR NOT GENERATE FLATTEN ASC DESC IS STREAM THROUGH STORE MAPREDUCE SHIP CACHE INPUT OUTPUT STDERROR STDIN STDOUT LIMIT SAMPLE LEFT RIGHT FULL EQ GT LT GTE LTE NEQ MATCHES TRUE FALSE DUMP",i="BOOLEAN INT LONG FLOAT DOUBLE CHARARRAY BYTEARRAY BAG TUPLE MAP ";e.defineMIME("text/x-pig",{name:"pig",builtins:t(n),keywords:t(r),types:t(i)}),e.registerHelper("hintWords","pig",(n+i+r).split(" "))}()}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/properties/properties",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("properties",function(){return{token:function(e,t){var n=e.sol()||t.afterSection,r=e.eol();t.afterSection=!1,n&&(t.nextMultiline?(t.inMultiline=!0,t.nextMultiline=!1):t.position="def"),r&&!t.nextMultiline&&(t.inMultiline=!1,t.position="def");if(n)while(e.eatSpace());var i=e.next();return!n||i!=="#"&&i!=="!"&&i!==";"?n&&i==="["?(t.afterSection=!0,e.skipTo("]"),e.eat("]"),"header"):i==="="||i===":"?(t.position="quote",null):(i==="\\"&&t.position==="quote"&&e.next()!=="u"&&(t.nextMultiline=!0),t.position):(t.position="comment",e.skipToEnd(),"comment")},startState:function(){return{position:"def",nextMultiline:!1,inMultiline:!1,afterSection:!1}}}}),e.defineMIME("text/x-properties","properties"),e.defineMIME("text/x-ini","properties")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/puppet/puppet",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("puppet",function(){function n(t,n){var r=n.split(" ");for(var i=0;i<r.length;i++)e[r[i]]=t}function r(e,t){var n,r,i=!1;while(!e.eol()&&(n=e.next())!=t.pending){if(n==="$"&&r!="\\"&&t.pending=='"'){i=!0;break}r=n}return i&&e.backUp(1),n==t.pending?t.continueString=!1:t.continueString=!0,"string"}function i(n,i){var s=n.match(/[\w]+/,!1),o=n.match(/(\s+)?\w+\s+=>.*/,!1),u=n.match(/(\s+)?[\w:_]+(\s+)?{/,!1),a=n.match(/(\s+)?[@]{1,2}[\w:_]+(\s+)?{/,!1),f=n.next();if(f==="$")return n.match(t)?i.continueString?"variable-2":"variable":"error";if(i.continueString)return n.backUp(1),r(n,i);if(i.inDefinition){if(n.match(/(\s+)?[\w:_]+(\s+)?/))return"def";n.match(/\s+{/),i.inDefinition=!1}return i.inInclude?(n.match(/(\s+)?\S+(\s+)?/),i.inInclude=!1,"def"):n.match(/(\s+)?\w+\(/)?(n.backUp(1),"def"):o?(n.match(/(\s+)?\w+/),"tag"):s&&e.hasOwnProperty(s)?(n.backUp(1),n.match(/[\w]+/),n.match(/\s+\S+\s+{/,!1)&&(i.inDefinition=!0),s=="include"&&(i.inInclude=!0),e[s]):/(\s+)?[A-Z]/.test(s)?(n.backUp(1),n.match(/(\s+)?[A-Z][\w:_]+/),"def"):u?(n.match(/(\s+)?[\w:_]+/),"def"):a?(n.match(/(\s+)?[@]{1,2}/),"special"):f=="#"?(n.skipToEnd(),"comment"):f=="'"||f=='"'?(i.pending=f,r(n,i)):f=="{"||f=="}"?"bracket":f=="/"?(n.match(/.*\//),"variable-3"):f.match(/[0-9]/)?(n.eatWhile(/[0-9]+/),"number"):f=="="?(n.peek()==">"&&n.next(),"operator"):(n.eatWhile(/[\w-]/),null)}var e={},t=/({)?([a-z][a-z0-9_]*)?((::[a-z][a-z0-9_]*)*::)?[a-zA-Z0-9_]+(})?/;return n("keyword","class define site node include import inherits"),n("keyword","case if else in and elsif default or"),n("atom","false true running present absent file directory undef"),n("builtin","action augeas burst chain computer cron destination dport exec file filebucket group host icmp iniface interface jump k5login limit log_level log_prefix macauthorization mailalias maillist mcx mount nagios_command nagios_contact nagios_contactgroup nagios_host nagios_hostdependency nagios_hostescalation nagios_hostextinfo nagios_hostgroup nagios_service nagios_servicedependency nagios_serviceescalation nagios_serviceextinfo nagios_servicegroup nagios_timeperiod name notify outiface package proto reject resources router schedule scheduled_task selboolean selmodule service source sport ssh_authorized_key sshkey stage state table tidy todest toports tosource user vlan yumrepo zfs zone zpool"),{startState:function(){var e={};return e.inDefinition=!1,e.inInclude=!1,e.continueString=!1,e.pending=!1,e},token:function(e,t){return e.eatSpace()?null:i(e,t)}}}),e.defineMIME("text/x-puppet","puppet")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/python/python",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){function t(e){return new RegExp("^(("+e.join(")|(")+"))\\b")}function u(e){return e.scopes[e.scopes.length-1]}var n=t(["and","or","not","is","in"]),r=["as","assert","break","class","continue","def","del","elif","else","except","finally","for","from","global","if","import","lambda","pass","raise","return","try","while","with","yield"],i=["abs","all","any","bin","bool","bytearray","callable","chr","classmethod","compile","complex","delattr","dict","dir","divmod","enumerate","eval","filter","float","format","frozenset","getattr","globals","hasattr","hash","help","hex","id","input","int","isinstance","issubclass","iter","len","list","locals","map","max","memoryview","min","next","object","oct","open","ord","pow","property","range","repr","reversed","round","set","setattr","slice","sorted","staticmethod","str","sum","super","tuple","type","vars","zip","__import__","NotImplemented","Ellipsis","__debug__"],s={builtins:["apply","basestring","buffer","cmp","coerce","execfile","file","intern","long","raw_input","reduce","reload","unichr","unicode","xrange","False","True","None"],keywords:["exec","print"]},o={builtins:["ascii","bytes","exec","print"],keywords:["nonlocal","False","True","None"]};e.registerHelper("hintWords","python",r.concat(i)),e.defineMode("python",function(a,f){function x(e,t){if(e.sol()&&u(t).type=="py"){var n=u(t).offset;if(e.eatSpace()){var r=e.indentation();return r>n?C(e,t,"py"):r<n&&k(e,t)&&(t.errorToken=!0),null}var i=T(e,t);return n>0&&k(e,t)&&(i+=" "+l),i}return T(e,t)}function T(e,t){if(e.eatSpace())return null;var r=e.peek();if(r=="#")return e.skipToEnd(),"comment";if(e.match(/^[0-9\.]/,!1)){var i=!1;e.match(/^\d*\.\d+(e[\+\-]?\d+)?/i)&&(i=!0),e.match(/^\d+\.\d*/)&&(i=!0),e.match(/^\.\d+/)&&(i=!0);if(i)return e.eat(/J/i),"number";var s=!1;e.match(/^0x[0-9a-f]+/i)&&(s=!0),e.match(/^0b[01]+/i)&&(s=!0),e.match(/^0o[0-7]+/i)&&(s=!0),e.match(/^[1-9]\d*(e[\+\-]?\d+)?/)&&(e.eat(/J/i),s=!0),e.match(/^0(?![\dx])/i)&&(s=!0);if(s)return e.eat(/L/i),"number"}return e.match(w)?(t.tokenize=N(e.current()),t.tokenize(e,t)):e.match(v)||e.match(d)?null:e.match(p)||e.match(c)||e.match(n)?"operator":e.match(h)?null:e.match(E)?"keyword":e.match(S)?"builtin":e.match(/^(self|cls)\b/)?"variable-2":e.match(m)?t.lastToken=="def"||t.lastToken=="class"?"def":"variable":(e.next(),l)}function N(e){function r(r,i){while(!r.eol()){r.eatWhile(/[^'"\\]/);if(r.eat("\\")){r.next();if(t&&r.eol())return n}else{if(r.match(e))return i.tokenize=x,n;r.eat(/['"]/)}}if(t){if(f.singleLineStringErrors)return l;i.tokenize=x}return n}while("rub".indexOf(e.charAt(0).toLowerCase())>=0)e=e.substr(1);var t=e.length==1,n="string";return r.isString=!0,r}function C(e,t,n){var r=0,i=null;if(n=="py")while(u(t).type!="py")t.scopes.pop();r=u(t).offset+(n=="py"?a.indentUnit:g),n!="py"&&!e.match(/^(\s|#.*)*$/,!1)&&(i=e.column()+1),t.scopes.push({offset:r,type:n,align:i})}function k(e,t){var n=e.indentation();while(u(t).offset>n){if(u(t).type!="py")return!0;t.scopes.pop()}return u(t).offset!=n}function L(e,t){var n=t.tokenize(e,t),r=e.current();if(r==".")return n=e.match(m,!1)?null:l,n==null&&t.lastStyle=="meta"&&(n="meta"),n;if(r=="@")return e.match(m,!1)?"meta":l;(n=="variable"||n=="builtin")&&t.lastStyle=="meta"&&(n="meta");if(r=="pass"||r=="return")t.dedent+=1;r=="lambda"&&(t.lambda=!0),r==":"&&!t.lambda&&u(t).type=="py"&&C(e,t,"py");var i=r.length==1?"[({".indexOf(r):-1;i!=-1&&C(e,t,"])}".slice(i,i+1)),i="])}".indexOf(r);if(i!=-1){if(u(t).type!=r)return l;t.scopes.pop()}return t.dedent>0&&e.eol()&&u(t).type=="py"&&(t.scopes.length>1&&t.scopes.pop(),t.dedent-=1),n}var l="error",c=f.singleOperators||new RegExp("^[\\+\\-\\*/%&|\\^~<>!]"),h=f.singleDelimiters||new RegExp("^[\\(\\)\\[\\]\\{\\}@,:`=;\\.]"),p=f.doubleOperators||new RegExp("^((==)|(!=)|(<=)|(>=)|(<>)|(<<)|(>>)|(//)|(\\*\\*))"),d=f.doubleDelimiters||new RegExp("^((\\+=)|(\\-=)|(\\*=)|(%=)|(/=)|(&=)|(\\|=)|(\\^=))"),v=f.tripleDelimiters||new RegExp("^((//=)|(>>=)|(<<=)|(\\*\\*=))"),m=f.identifiers||new RegExp("^[_A-Za-z][_A-Za-z0-9]*"),g=f.hangingIndent||a.indentUnit,y=r,b=i;f.extra_keywords!=undefined&&(y=y.concat(f.extra_keywords)),f.extra_builtins!=undefined&&(b=b.concat(f.extra_builtins));if(f.version&&parseInt(f.version,10)==3){y=y.concat(o.keywords),b=b.concat(o.builtins);var w=new RegExp("^(([rb]|(br))?('{3}|\"{3}|['\"]))","i")}else{y=y.concat(s.keywords),b=b.concat(s.builtins);var w=new RegExp("^(([rub]|(ur)|(br))?('{3}|\"{3}|['\"]))","i")}var E=t(y),S=t(b),A={startState:function(e){return{tokenize:x,scopes:[{offset:e||0,type:"py",align:null}],lastStyle:null,lastToken:null,lambda:!1,dedent:0}},token:function(e,t){var n=t.errorToken;n&&(t.errorToken=!1);var r=L(e,t);t.lastStyle=r;var i=e.current();return i&&r&&(t.lastToken=i),e.eol()&&t.lambda&&(t.lambda=!1),n?r+" "+l:r},indent:function(t,n){if(t.tokenize!=x)return t.tokenize.isString?e.Pass:0;var r=u(t),i=n&&n.charAt(0)==r.type;return r.align!=null?r.align-(i?1:0):r.offset-(i?a.indentUnit:0)},lineComment:"#",fold:"indent"};return A}),e.defineMIME("text/x-python","python");var a=function(e){return e.split(" ")};e.defineMIME("text/x-cython",{name:"python",extra_keywords:a("by cdef cimport cpdef ctypedef enum exceptextern gil include nogil property publicreadonly struct union DEF IF ELIF ELSE")})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/q/q",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("q",function(e){function s(e){return new RegExp("^("+e.join("|")+")$")}function o(e,t){var s=e.sol(),a=e.next();n=null;if(s){if(a=="/")return(t.tokenize=u)(e,t);if(a=="\\")return e.eol()||/\s/.test(e.peek())?(e.skipToEnd(),/^\\\s*$/.test(e.current())?(t.tokenize=f)(e,t):t.tokenize=o,"comment"):(t.tokenize=o,"builtin")}if(/\s/.test(a))return e.peek()=="/"?(e.skipToEnd(),"comment"):"whitespace";if(a=='"')return(t.tokenize=l)(e,t);if(a=="`")return e.eatWhile(/[A-Z|a-z|\d|_|:|\/|\.]/),"symbol";if("."==a&&/\d/.test(e.peek())||/\d/.test(a)){var c=null;e.backUp(1);if(e.match(/^\d{4}\.\d{2}(m|\.\d{2}([D|T](\d{2}(:\d{2}(:\d{2}(\.\d{1,9})?)?)?)?)?)/)||e.match(/^\d+D(\d{2}(:\d{2}(:\d{2}(\.\d{1,9})?)?)?)/)||e.match(/^\d{2}:\d{2}(:\d{2}(\.\d{1,9})?)?/)||e.match(/^\d+[ptuv]{1}/))c="temporal";else if(e.match(/^0[NwW]{1}/)||e.match(/^0x[\d|a-f|A-F]*/)||e.match(/^[0|1]+[b]{1}/)||e.match(/^\d+[chijn]{1}/)||e.match(/-?\d*(\.\d*)?(e[+\-]?\d+)?(e|f)?/))c="number";return c&&(!(a=e.peek())||i.test(a))?c:(e.next(),"error")}return/[A-Z|a-z]|\./.test(a)?(e.eatWhile(/[A-Z|a-z|\.|_|\d]/),r.test(e.current())?"keyword":"variable"):/[|/&^!+:\\\-*%$=~#;@><\.,?_\']/.test(a)?null:/[{}\(\[\]\)]/.test(a)?null:"error"}function u(e,t){return e.skipToEnd(),/\/\s*$/.test(e.current())?(t.tokenize=a)(e,t):t.tokenize=o,"comment"}function a(e,t){var n=e.sol()&&e.peek()=="\\";return e.skipToEnd(),n&&/^\\\s*$/.test(e.current())&&(t.tokenize=o),"comment"}function f(e){return e.skipToEnd(),"comment"}function l(e,t){var n=!1,r,i=!1;while(r=e.next()){if(r=='"'&&!n){i=!0;break}n=!n&&r=="\\"}return i&&(t.tokenize=o),"string"}function c(e,t,n){e.context={prev:e.context,indent:e.indent,col:n,type:t}}function h(e){e.indent=e.context.indent,e.context=e.context.prev}var t=e.indentUnit,n,r=s(["abs","acos","aj","aj0","all","and","any","asc","asin","asof","atan","attr","avg","avgs","bin","by","ceiling","cols","cor","cos","count","cov","cross","csv","cut","delete","deltas","desc","dev","differ","distinct","div","do","each","ej","enlist","eval","except","exec","exit","exp","fby","fills","first","fkeys","flip","floor","from","get","getenv","group","gtime","hclose","hcount","hdel","hopen","hsym","iasc","idesc","if","ij","in","insert","inter","inv","key","keys","last","like","list","lj","load","log","lower","lsq","ltime","ltrim","mavg","max","maxs","mcount","md5","mdev","med","meta","min","mins","mmax","mmin","mmu","mod","msum","neg","next","not","null","or","over","parse","peach","pj","plist","prd","prds","prev","prior","rand","rank","ratios","raze","read0","read1","reciprocal","reverse","rload","rotate","rsave","rtrim","save","scan","select","set","setenv","show","signum","sin","sqrt","ss","ssr","string","sublist","sum","sums","sv","system","tables","tan","til","trim","txf","type","uj","ungroup","union","update","upper","upsert","value","var","view","views","vs","wavg","where","where","while","within","wj","wj1","wsum","xasc","xbar","xcol","xcols","xdesc","xexp","xgroup","xkey","xlog","xprev","xrank"]),i=/[|/&^!+:\\\-*%$=~#;@><,?_\'\"\[\(\]\)\s{}]/;return{startState:function(){return{tokenize:o,context:null,indent:0,col:0}},token:function(e,t){e.sol()&&(t.context&&t.context.align==null&&(t.context.align=!1),t.indent=e.indentation());var r=t.tokenize(e,t);r!="comment"&&t.context&&t.context.align==null&&t.context.type!="pattern"&&(t.context.align=!0);if(n=="(")c(t,")",e.column());else if(n=="[")c(t,"]",e.column());else if(n=="{")c(t,"}",e.column());else if(/[\]\}\)]/.test(n)){while(t.context&&t.context.type=="pattern")h(t);t.context&&n==t.context.type&&h(t)}else n=="."&&t.context&&t.context.type=="pattern"?h(t):/atom|string|variable/.test(r)&&t.context&&(/[\}\]]/.test(t.context.type)?c(t,"pattern",e.column()):t.context.type=="pattern"&&!t.context.align&&(t.context.align=!0,t.context.col=e.column()));return r},indent:function(e,n){var r=n&&n.charAt(0),i=e.context;if(/[\]\}]/.test(r))while(i&&i.type=="pattern")i=i.prev;var s=i&&r==i.type;return i?i.type=="pattern"?i.col:i.align?i.col+(s?0:1):i.indent+(s?0:t):0}}}),e.defineMIME("text/x-q","q")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/r/r",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("r",function(e){function t(e){var t=e.split(" "),n={};for(var r=0;r<t.length;++r)n[t[r]]=!0;return n}function a(e,t){u=null;var a=e.next();if(a=="#")return e.skipToEnd(),"comment";if(a=="0"&&e.eat("x"))return e.eatWhile(/[\da-f]/i),"number";if(a=="."&&e.eat(/\d/))return e.match(/\d*(?:e[+\-]?\d+)?/),"number";if(/\d/.test(a))return e.match(/\d*(?:\.\d+)?(?:e[+\-]\d+)?L?/),"number";if(a=="'"||a=='"')return t.tokenize=f(a),"string";if(a=="."&&e.match(/.[.\d]+/))return"keyword";if(/[\w\.]/.test(a)&&a!="_"){e.eatWhile(/[\w\.]/);var l=e.current();return n.propertyIsEnumerable(l)?"atom":i.propertyIsEnumerable(l)?(s.propertyIsEnumerable(l)&&!e.match(/\s*if(\s+|$)/,!1)&&(u="block"),"keyword"):r.propertyIsEnumerable(l)?"builtin":"variable"}return a=="%"?(e.skipTo("%")&&e.next(),"variable-2"):a=="<"&&e.eat("-")?"arrow":a=="="&&t.ctx.argList?"arg-is":o.test(a)?a=="$"?"dollar":(e.eatWhile(o),"operator"):/[\(\){}\[\];]/.test(a)?(u=a,a==";"?"semi":null):null}function f(e){return function(t,n){if(t.eat("\\")){var r=t.next();return r=="x"?t.match(/^[a-f0-9]{2}/i):(r=="u"||r=="U")&&t.eat("{")&&t.skipTo("}")?t.next():r=="u"?t.match(/^[a-f0-9]{4}/i):r=="U"?t.match(/^[a-f0-9]{8}/i):/[0-7]/.test(r)&&t.match(/^[0-7]{1,2}/),"string-2"}var i;while((i=t.next())!=null){if(i==e){n.tokenize=a;break}if(i=="\\"){t.backUp(1);break}}return"string"}}function l(e,t,n){e.ctx={type:t,indent:e.indent,align:null,column:n.column(),prev:e.ctx}}function c(e){e.indent=e.ctx.indent,e.ctx=e.ctx.prev}var n=t("NULL NA Inf NaN NA_integer_ NA_real_ NA_complex_ NA_character_"),r=t("list quote bquote eval return call parse deparse"),i=t("if else repeat while function for in next break"),s=t("if else repeat while function for"),o=/[+\-*\/^<>=!&|~$:]/,u;return{startState:function(){return{tokenize:a,ctx:{type:"top",indent:-e.indentUnit,align:!1},indent:0,afterIdent:!1}},token:function(e,t){e.sol()&&(t.ctx.align==null&&(t.ctx.align=!1),t.indent=e.indentation());if(e.eatSpace())return null;var n=t.tokenize(e,t);n!="comment"&&t.ctx.align==null&&(t.ctx.align=!0);var r=t.ctx.type;return(u==";"||u=="{"||u=="}")&&r=="block"&&c(t),u=="{"?l(t,"}",e):u=="("?(l(t,")",e),t.afterIdent&&(t.ctx.argList=!0)):u=="["?l(t,"]",e):u=="block"?l(t,"block",e):u==r&&c(t),t.afterIdent=n=="variable"||n=="keyword",n},indent:function(t,n){if(t.tokenize!=a)return 0;var r=n&&n.charAt(0),i=t.ctx,s=r==i.type;return i.type=="block"?i.indent+(r=="{"?0:e.indentUnit):i.align?i.column+(s?0:1):i.indent+(s?0:e.indentUnit)},lineComment:"#"}}),e.defineMIME("text/x-rsrc","r")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/rpm/rpm",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("rpm-changes",function(){var e=/^-+$/,t=/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)  ?\d{1,2} \d{2}:\d{2}(:\d{2})? [A-Z]{3,4} \d{4} - /,n=/^[\w+.-]+@[\w.-]+/;return{token:function(r){if(r.sol()){if(r.match(e))return"tag";if(r.match(t))return"tag"}return r.match(n)?"string":(r.next(),null)}}}),e.defineMIME("text/x-rpm-changes","rpm-changes"),e.defineMode("rpm-spec",function(){var e=/^(i386|i586|i686|x86_64|ppc64|ppc|ia64|s390x|s390|sparc64|sparcv9|sparc|noarch|alphaev6|alpha|hppa|mipsel)/,t=/^(Name|Version|Release|License|Summary|Url|Group|Source|BuildArch|BuildRequires|BuildRoot|AutoReqProv|Provides|Requires(\(\w+\))?|Obsoletes|Conflicts|Recommends|Source\d*|Patch\d*|ExclusiveArch|NoSource|Supplements):/,n=/^%(debug_package|package|description|prep|build|install|files|clean|changelog|preinstall|preun|postinstall|postun|pre|post|triggerin|triggerun|pretrans|posttrans|verifyscript|check|triggerpostun|triggerprein|trigger)/,r=/^%(ifnarch|ifarch|if)/,i=/^%(else|endif)/,s=/^(\!|\?|\<\=|\<|\>\=|\>|\=\=|\&\&|\|\|)/;return{startState:function(){return{controlFlow:!1,macroParameters:!1,section:!1}},token:function(o,u){var a=o.peek();if(a=="#")return o.skipToEnd(),"comment";if(o.sol()){if(o.match(t))return"preamble";if(o.match(n))return"section"}if(o.match(/^\$\w+/))return"def";if(o.match(/^\$\{\w+\}/))return"def";if(o.match(i))return"keyword";if(o.match(r))return u.controlFlow=!0,"keyword";if(u.controlFlow){if(o.match(s))return"operator";if(o.match(/^(\d+)/))return"number";o.eol()&&(u.controlFlow=!1)}if(o.match(e))return"number";if(o.match(/^%[\w]+/))return o.match(/^\(/)&&(u.macroParameters=!0),"macro";if(u.macroParameters){if(o.match(/^\d+/))return"number";if(o.match(/^\)/))return u.macroParameters=!1,"macro"}return o.match(/^%\{\??[\w \-]+\}/)?"macro":(o.next(),null)}}}),e.defineMIME("text/x-rpm-spec","rpm-spec")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/stex/stex",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("stex",function(){function e(e,t){e.cmdState.push(t)}function t(e){return e.cmdState.length>0?e.cmdState[e.cmdState.length-1]:null}function n(e){var t=e.cmdState.pop();t&&t.closeBracket()}function r(e){var t=e.cmdState;for(var n=t.length-1;n>=0;n--){var r=t[n];if(r.name=="DEFAULT")continue;return r}return{styleIdentifier:function(){return null}}}function i(e,t,n){return function(){this.name=e,this.bracketNo=0,this.style=t,this.styles=n,this.argument=null,this.styleIdentifier=function(){return this.styles[this.bracketNo-1]||null},this.openBracket=function(){return this.bracketNo++,"bracket"},this.closeBracket=function(){}}}function o(e,t){e.f=t}function u(n,i){var u;if(n.match(/^\\[a-zA-Z@]+/)){var c=n.current().slice(1);return u=s[c]||s.DEFAULT,u=new u,e(i,u),o(i,l),u.style}if(n.match(/^\\[$&%#{}_]/))return"tag";if(n.match(/^\\[,;!\/\\]/))return"tag";if(n.match("\\["))return o(i,function(e,t){return f(e,t,"\\]")}),"keyword";if(n.match("$$"))return o(i,function(e,t){return f(e,t,"$$")}),"keyword";if(n.match("$"))return o(i,function(e,t){return f(e,t,"$")}),"keyword";var h=n.next();if(h=="%")return n.eol()||o(i,a),"comment";if(h=="}"||h=="]")return u=t(i),u?(u.closeBracket(h),o(i,l),"bracket"):"error";return h=="{"||h=="["?(u=s.DEFAULT,u=new u,e(i,u),"bracket"):/\d/.test(h)?(n.eatWhile(/[\w.%]/),"atom"):(n.eatWhile(/[\w\-_]/),u=r(i),u.name=="begin"&&(u.argument=n.current()),u.styleIdentifier())}function a(e,t){return e.skipToEnd(),o(t,u),"comment"}function f(e,t,n){if(e.eatSpace())return null;if(e.match(n))return o(t,u),"keyword";if(e.match(/^\\[a-zA-Z@]+/))return"tag";if(e.match(/^[a-zA-Z]+/))return"variable-2";if(e.match(/^\\[$&%#{}_]/))return"tag";if(e.match(/^\\[,;!\/]/))return"tag";if(e.match(/^[\^_&]/))return"tag";if(e.match(/^[+\-<>|=,\/@!*:;'"`~#?]/))return null;if(e.match(/^(\d+\.\d*|\d*\.\d+|\d+)/))return"number";var r=e.next();return r=="{"||r=="}"||r=="["||r=="]"||r=="("||r==")"?"bracket":r=="%"?(e.eol()||e.skipToEnd(),"comment"):"error"}function l(e,r){var i=e.peek(),s;return i=="{"||i=="["?(s=t(r),s.openBracket(i),e.eat(i),o(r,u),"bracket"):/[ \t\r]/.test(i)?(e.eat(i),null):(o(r,u),n(r),u(e,r))}var s={};return s.importmodule=i("importmodule","tag",["string","builtin"]),s.documentclass=i("documentclass","tag",["","atom"]),s.usepackage=i("usepackage","tag",["atom"]),s.begin=i("begin","tag",["atom"]),s.end=i("end","tag",["atom"]),s.DEFAULT=function(){this.name="DEFAULT",this.style="tag",this.styleIdentifier=this.openBracket=this.closeBracket=function(){}},{startState:function(){return{cmdState:[],f:u}},copyState:function(e){return{cmdState:e.cmdState.slice(),f:e.f}},token:function(e,t){return t.f(e,t)}}}),e.defineMIME("text/x-stex","stex"),e.defineMIME("text/x-latex","stex")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../python/python"),require("../stex/stex"),require("../../addon/mode/overlay")):typeof define=="function"&&define.amd?define("components/codemirror/mode/rst/rst",["../../lib/codemirror","../python/python","../stex/stex","../../addon/mode/overlay"],e):e(CodeMirror)}(function(e){e.defineMode("rst",function(t,n){var r=/^\*\*[^\*\s](?:[^\*]*[^\*\s])?\*\*/,i=/^\*[^\*\s](?:[^\*]*[^\*\s])?\*/,s=/^``[^`\s](?:[^`]*[^`\s])``/,o=/^(?:[\d]+(?:[\.,]\d+)*)/,u=/^(?:\s\+[\d]+(?:[\.,]\d+)*)/,a=/^(?:\s\-[\d]+(?:[\.,]\d+)*)/,f="[Hh][Tt][Tt][Pp][Ss]?://",l="(?:[\\d\\w.-]+)\\.(?:\\w{2,6})",c="(?:/[\\d\\w\\#\\%\\&\\-\\.\\,\\/\\:\\=\\?\\~]+)*",h=new RegExp("^"+f+l+c),p={token:function(e){if(e.match(r)&&e.match(/\W+|$/,!1))return"strong";if(e.match(i)&&e.match(/\W+|$/,!1))return"em";if(e.match(s)&&e.match(/\W+|$/,!1))return"string-2";if(e.match(o))return"number";if(e.match(u))return"positive";if(e.match(a))return"negative";if(e.match(h))return"link";while(e.next()!=null){if(e.match(r,!1))break;if(e.match(i,!1))break;if(e.match(s,!1))break;if(e.match(o,!1))break;if(e.match(u,!1))break;if(e.match(a,!1))break;if(e.match(h,!1))break}return null}},d=e.getMode(t,n.backdrop||"rst-base");return e.overlayMode(d,p,!0)},"python","stex"),e.defineMode("rst-base",function(t){function n(e){var t=Array.prototype.slice.call(arguments,1);return e.replace(/{(\d+)}/g,function(e,n){return typeof t[n]!="undefined"?t[n]:e})}function r(e){this.message=e}function i(e,t){if(!e)throw new r(t);return e}function z(t,n){var r=null;if(t.sol()&&t.match(U,!1))Q(n,J,{mode:s,local:e.startState(s)});else if(t.sol()&&t.match(y))Q(n,W),r="meta";else if(t.sol()&&t.match(g))Q(n,z),r="header";else if(Y(n)==A||t.match(A,!1))switch(G(n)){case 0:Q(n,z,K(A,1)),i(t.match(/^:/)),r="meta";break;case 1:Q(n,z,K(A,2)),i(t.match(c)),r="keyword",t.current().match(/^(?:math|latex)/)&&(n.tmp_stex=!0);break;case 2:Q(n,z,K(A,3)),i(t.match(/^:`/)),r="meta";break;case 3:n.tmp_stex&&(n.tmp_stex=undefined,n.tmp={mode:o,local:e.startState(o)});if(n.tmp){if(t.peek()=="`"){Q(n,z,K(A,4)),n.tmp=undefined;break}r=n.tmp.mode.token(t,n.tmp.local);break}Q(n,z,K(A,4)),i(t.match(m)),r="string";break;case 4:Q(n,z,K(A,5)),i(t.match(/^`/)),r="meta";break;case 5:Q(n,z,K(A,6)),i(t.match(f));break;default:Q(n,z),i(t.current()=="")}else if(Y(n)==O||t.match(O,!1))switch(G(n)){case 0:Q(n,z,K(O,1)),i(t.match(/^`/)),r="meta";break;case 1:Q(n,z,K(O,2)),i(t.match(m)),r="string";break;case 2:Q(n,z,K(O,3)),i(t.match(/^`:/)),r="meta";break;case 3:Q(n,z,K(O,4)),i(t.match(c)),r="keyword";break;case 4:Q(n,z,K(O,5)),i(t.match(/^:/)),r="meta";break;case 5:Q(n,z,K(O,6)),i(t.match(f));break;default:Q(n,z),i(t.current()=="")}else if(Y(n)==M||t.match(M,!1))switch(G(n)){case 0:Q(n,z,K(M,1)),i(t.match(/^:/)),r="meta";break;case 1:Q(n,z,K(M,2)),i(t.match(c)),r="keyword";break;case 2:Q(n,z,K(M,3)),i(t.match(/^:/)),r="meta";break;case 3:Q(n,z,K(M,4)),i(t.match(f));break;default:Q(n,z),i(t.current()=="")}else if(Y(n)==T||t.match(T,!1))switch(G(n)){case 0:Q(n,z,K(T,1)),i(t.match(P)),r="variable-2";break;case 1:Q(n,z,K(T,2)),t.match(/^_?_?/)&&(r="link");break;default:Q(n,z),i(t.current()=="")}else if(t.match(N))Q(n,z),r="quote";else if(t.match(C))Q(n,z),r="quote";else if(t.match(k)){Q(n,z);if(!t.peek()||t.peek().match(/^\W$/))r="link"}else if(Y(n)==L||t.match(L,!1))switch(G(n)){case 0:!t.peek()||t.peek().match(/^\W$/)?Q(n,z,K(L,1)):t.match(L);break;case 1:Q(n,z,K(L,2)),i(t.match(/^`/)),r="link";break;case 2:Q(n,z,K(L,3)),i(t.match(m));break;case 3:Q(n,z,K(L,4)),i(t.match(/^`_/)),r="link";break;default:Q(n,z),i(t.current()=="")}else t.match(R)?Q(n,V):t.next()&&Q(n,z);return r}function W(t,n){var r=null;if(Y(n)==E||t.match(E,!1))switch(G(n)){case 0:Q(n,W,K(E,1)),i(t.match(P)),r="variable-2";break;case 1:Q(n,W,K(E,2)),i(t.match(H));break;case 2:Q(n,W,K(E,3)),i(t.match(B)),r="keyword";break;case 3:Q(n,W,K(E,4)),i(t.match(j)),r="meta";break;default:Q(n,z),i(t.current()=="")}else if(Y(n)==w||t.match(w,!1))switch(G(n)){case 0:Q(n,W,K(w,1)),i(t.match(_)),r="keyword",t.current().match(/^(?:math|latex)/)?n.tmp_stex=!0:t.current().match(/^python/)&&(n.tmp_py=!0);break;case 1:Q(n,W,K(w,2)),i(t.match(D)),r="meta";if(t.match(/^latex\s*$/)||n.tmp_stex)n.tmp_stex=undefined,Q(n,J,{mode:o,local:e.startState(o)});break;case 2:Q(n,W,K(w,3));if(t.match(/^python\s*$/)||n.tmp_py)n.tmp_py=undefined,Q(n,J,{mode:s,local:e.startState(s)});break;default:Q(n,z),i(t.current()=="")}else if(Y(n)==b||t.match(b,!1))switch(G(n)){case 0:Q(n,W,K(b,1)),i(t.match(F)),i(t.match(I)),r="link";break;case 1:Q(n,W,K(b,2)),i(t.match(q)),r="meta";break;default:Q(n,z),i(t.current()=="")}else t.match(S)?(Q(n,z),r="quote"):t.match(x)?(Q(n,z),r="quote"):(t.eatSpace(),t.eol()?Q(n,z):(t.skipToEnd(),Q(n,X),r="comment"));return r}function X(e,t){return $(e,t,"comment")}function V(e,t){return $(e,t,"meta")}function $(e,t,n){return e.eol()||e.eatSpace()?(e.skipToEnd(),n):(Q(t,z),null)}function J(e,t){return t.ctx.mode&&t.ctx.local?e.sol()?(e.eatSpace()||Q(t,z),null):t.ctx.mode.token(e,t.ctx.local):(Q(t,z),null)}function K(e,t,n,r){return{phase:e,stage:t,mode:n,local:r}}function Q(e,t,n){e.tok=t,e.ctx=n||{}}function G(e){return e.ctx.stage||0}function Y(e){return e.ctx.phase}r.prototype.toString=function(){return"AssertException: "+this.message};var s=e.getMode(t,"python"),o=e.getMode(t,"stex"),u="\\s+",a="(?:\\s*|\\W|$)",f=new RegExp(n("^{0}",a)),l="(?:[^\\W\\d_](?:[\\w!\"#$%&'()\\*\\+,\\-\\./:;<=>\\?]*[^\\W_])?)",c=new RegExp(n("^{0}",l)),h="(?:[^\\W\\d_](?:[\\w\\s!\"#$%&'()\\*\\+,\\-\\./:;<=>\\?]*[^\\W_])?)",p=n("(?:{0}|`{1}`)",l,h),d="(?:[^\\s\\|](?:[^\\|]*[^\\s\\|])?)",v="(?:[^\\`]+)",m=new RegExp(n("^{0}",v)),g=new RegExp("^([!'#$%&\"()*+,-./:;<=>?@\\[\\\\\\]^_`{|}~])\\1{3,}\\s*$"),y=new RegExp(n("^\\.\\.{0}",u)),b=new RegExp(n("^_{0}:{1}|^__:{1}",p,a)),w=new RegExp(n("^{0}::{1}",p,a)),E=new RegExp(n("^\\|{0}\\|{1}{2}::{3}",d,u,p,a)),S=new RegExp(n("^\\[(?:\\d+|#{0}?|\\*)]{1}",p,a)),x=new RegExp(n("^\\[{0}\\]{1}",p,a)),T=new RegExp(n("^\\|{0}\\|",d)),N=new RegExp(n("^\\[(?:\\d+|#{0}?|\\*)]_",p)),C=new RegExp(n("^\\[{0}\\]_",p)),k=new RegExp(n("^{0}__?",p)),L=new RegExp(n("^`{0}`_",v)),A=new RegExp(n("^:{0}:`{1}`{2}",l,v,a)),O=new RegExp(n("^`{1}`:{0}:{2}",l,v,a)),M=new RegExp(n("^:{0}:{1}",l,a)),_=new RegExp(n("^{0}",p)),D=new RegExp(n("^::{0}",a)),P=new RegExp(n("^\\|{0}\\|",d)),H=new RegExp(n("^{0}",u)),B=new RegExp(n("^{0}",p)),j=new RegExp(n("^::{0}",a)),F=new RegExp("^_"),I=new RegExp(n("^{0}|_",p)),q=new RegExp(n("^:{0}",a)),R=new RegExp("^::\\s*$"),U=new RegExp("^\\s+(?:>>>|In \\[\\d+\\]:)\\s");return{startState:function(){return{tok:z,ctx:K(undefined,0)}},copyState:function(t){var n=t.ctx,r=t.tmp;return n.local&&(n={mode:n.mode,local:e.copyState(n.mode,n.local)}),r&&(r={mode:r.mode,local:e.copyState(r.mode,r.local)}),{tok:t.tok,ctx:n,tmp:r}},innerMode:function(e){return e.tmp?{state:e.tmp.local,mode:e.tmp.mode}:e.ctx.mode?{state:e.ctx.local,mode:e.ctx.mode}:null},token:function(e,t){return t.tok(e,t)}}},"python","stex"),e.defineMIME("text/x-rst","rst")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/rust/rust",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("rust",function(){function u(e,t){return s=e,t}function a(e,t){var n=e.next();if(n=='"')return t.tokenize=f,t.tokenize(e,t);if(n=="'")return s="atom",e.eat("\\")?e.skipTo("'")?(e.next(),"string"):"error":(e.next(),e.eat("'")?"string":"error");if(n=="/"){if(e.eat("/"))return e.skipToEnd(),"comment";if(e.eat("*"))return t.tokenize=l(1),t.tokenize(e,t)}if(n=="#")return e.eat("[")?(s="open-attr",null):(e.eatWhile(/\w/),u("macro","meta"));if(n==":"&&e.match(":<"))return u("op",null);if(n.match(/\d/)||n=="."&&e.eat(/\d/)){var r=!1;return!e.match(/^x[\da-f]+/i)&&!e.match(/^b[01]+/)&&(e.eatWhile(/\d/),e.eat(".")&&(r=!0,e.eatWhile(/\d/)),e.match(/^e[+\-]?\d+/i)&&(r=!0)),r?e.match(/^f(?:32|64)/):e.match(/^[ui](?:8|16|32|64)/),u("atom","number")}return n.match(/[()\[\]{}:;,]/)?u(n,null):n=="-"&&e.eat(">")?u("->",null):n.match(i)?(e.eatWhile(i),u("op",null)):(e.eatWhile(/\w/),o=e.current(),e.match(/^::\w/)?(e.backUp(1),u("prefix","variable-2")):t.keywords.propertyIsEnumerable(o)?u(t.keywords[o],o.match(/true|false/)?"atom":"keyword"):u("name","variable"))}function f(e,t){var n,r=!1;while(n=e.next()){if(n=='"'&&!r)return t.tokenize=a,u("atom","string");r=!r&&n=="\\"}return u("op","string")}function l(e){return function(t,n){var r=null,i;while(i=t.next()){if(i=="/"&&r=="*"){if(e==1){n.tokenize=a;break}return n.tokenize=l(e-1),n.tokenize(t,n)}if(i=="*"&&r=="/")return n.tokenize=l(e+1),n.tokenize(t,n);r=i}return"comment"}}function h(){for(var e=arguments.length-1;e>=0;e--)c.cc.push(arguments[e])}function p(){return h.apply(null,arguments),!0}function d(e,t){var n=function(){var n=c.state;n.lexical={indented:n.indented,column:c.stream.column(),type:e,prev:n.lexical,info:t}};return n.lex=!0,n}function v(){var e=c.state;e.lexical.prev&&(e.lexical.type==")"&&(e.indented=e.lexical.indented),e.lexical=e.lexical.prev)}function m(){c.state.keywords=r}function g(){c.state.keywords=n}function y(e,t){function n(r){return r==","?p(e,n):r==t?p():p(n)}return function(r){return r==t?p():h(e,n)}}function b(e,t){return p(d("stat",t),e,v,w)}function w(e){return e=="}"?p():e=="let"?b(L,"let"):e=="fn"?b(_):e=="type"?p(d("stat"),D,E,v,w):e=="enum"?b(P):e=="mod"?b(B):e=="iface"?b(j):e=="impl"?b(F):e=="open-attr"?p(d("]"),y(S,"]"),v):e=="ignore"||e.match(/[\]\);,]/)?p(w):h(d("stat"),S,v,E,w)}function E(e){return e==";"?p():h()}function S(e){return e=="atom"||e=="name"?p(x):e=="{"?p(d("}"),N,v):e.match(/[\[\(]/)?Q(e,S):e.match(/[\]\)\};,]/)?h():e=="if-style"?p(S,S):e=="else-style"||e=="op"?p(S):e=="for"?p(W,O,M,S,S):e=="alt"?p(S,V):e=="fn"?p(_):e=="macro"?p(K):p()}function x(e){return o=="."?p(T):o=="::<"?p(I,x):e=="op"||o==":"?p(S):e=="("||e=="["?Q(e,S):h()}function T(){return o.match(/^\w+$/)?(c.marked="variable",p(x)):h(S)}function N(e){if(e=="op"){if(o=="|")return p(k,v,d("}","block"),w);if(o=="||")return p(v,d("}","block"),w)}return o=="mutable"||o.match(/^\w+$/)&&c.stream.peek()==":"&&!c.stream.match("::",!1)?h(C(S)):h(w)}function C(e){function t(n){return o=="mutable"||o=="with"?(c.marked="keyword",p(t)):o.match(/^\w*$/)?(c.marked="variable",p(t)):n==":"?p(e,t):n=="}"?p():p(t)}return t}function k(e){return e=="name"?(c.marked="def",p(k)):e=="op"&&o=="|"?p():p(k)}function L(e){return e.match(/[\]\)\};]/)?p():o=="="?p(S,A):e==","?p(L):h(W,O,L)}function A(e){return e.match(/[\]\)\};,]/)?h(L):h(S,A)}function O(e){return e==":"?p(m,R,g):h()}function M(e){return e=="name"&&o=="in"?(c.marked="keyword",p()):h()}function _(e){return o=="@"||o=="~"?(c.marked="keyword",p(_)):e=="name"?(c.marked="def",p(_)):o=="<"?p(I,_):e=="{"?h(S):e=="("?p(d(")"),y(q,")"),v,_):e=="->"?p(m,R,g,_):e==";"?p():p(_)}function D(e){return e=="name"?(c.marked="def",p(D)):o=="<"?p(I,D):o=="="?p(m,R,g):p(D)}function P(e){return e=="name"?(c.marked="def",p(P)):o=="<"?p(I,P):o=="="?p(m,R,g,E):e=="{"?p(d("}"),m,H,g,v):p(P)}function H(e){return e=="}"?p():e=="("?p(d(")"),y(R,")"),v,H):(o.match(/^\w+$/)&&(c.marked="def"),p(H))}function B(e){return e=="name"?(c.marked="def",p(B)):e=="{"?p(d("}"),w,v):h()}function j(e){return e=="name"?(c.marked="def",p(j)):o=="<"?p(I,j):e=="{"?p(d("}"),w,v):h()}function F(e){return o=="<"?p(I,F):o=="of"||o=="for"?(c.marked="keyword",p(R,F)):e=="name"?(c.marked="def",p(F)):e=="{"?p(d("}"),w,v):h()}function I(){return o==">"?p():o==","?p(I):o==":"?p(R,I):h(R,I)}function q(e){return e=="name"?(c.marked="def",p(q)):e==":"?p(m,R,g):h()}function R(e){return e=="name"?(c.marked="variable-3",p(U)):o=="mutable"?(c.marked="keyword",p(R)):e=="atom"?p(U):e=="op"||e=="obj"?p(R):e=="fn"?p(z):e=="{"?p(d("{"),C(R),v):Q(e,R)}function U(){return o=="<"?p(I):h()}function z(e){return e=="("?p(d("("),y(R,")"),v,z):e=="->"?p(R):h()}function W(e){return e=="name"?(c.marked="def",p(X)):e=="atom"?p(X):e=="op"?p(W):e.match(/[\]\)\};,]/)?h():Q(e,W)}function X(e){return e=="op"&&o=="."?p():o=="to"?(c.marked="keyword",p(W)):h()}function V(e){return e=="{"?p(d("}","alt"),$,v):h()}function $(e){return e=="}"?p():e=="|"?p($):o=="when"?(c.marked="keyword",p(S,J)):e.match(/[\]\);,]/)?p($):h(W,J)}function J(e){return e=="{"?p(d("}","alt"),w,v,$):h($)}function K(e){return e.match(/[\[\(\{]/)?Q(e,S):h()}function Q(e,t){return e=="["?p(d("]"),y(t,"]"),v):e=="("?p(d(")"),y(t,")"),v):e=="{"?p(d("}"),y(t,"}"),v):p()}function G(e,t,n){var r=e.cc;c.state=e,c.stream=t,c.marked=null,c.cc=r;for(;;){var i=r.length?r.pop():w;if(i(s)){while(r.length&&r[r.length-1].lex)r.pop()();return c.marked||n}}}var e=4,t=2,n={"if":"if-style","while":"if-style","else":"else-style","do":"else-style",ret:"else-style",fail:"else-style","break":"atom",cont:"atom","const":"let",resource:"fn",let:"let",fn:"fn","for":"for",alt:"alt",iface:"iface",impl:"impl",type:"type","enum":"enum",mod:"mod",as:"op","true":"atom","false":"atom",assert:"op",check:"op",claim:"op","native":"ignore",unsafe:"ignore","import":"else-style","export":"else-style",copy:"op",log:"op",log_err:"op",use:"op",bind:"op",self:"atom"},r=function(){var e={fn:"fn",block:"fn",obj:"obj"},t="bool uint int i8 i16 i32 i64 u8 u16 u32 u64 float f32 f64 str char".split(" ");for(var n=0,r=t.length;n<r;++n)e[t[n]]="atom";return e}(),i=/[+\-*&%=<>!?|\.@]/,s,o,c={state:null,stream:null,marked:null,cc:null};return v.lex=m.lex=g.lex=!0,{startState:function(){return{tokenize:a,cc:[],lexical:{indented:-e,column:0,type:"top",align:!1},keywords:n,indented:0}},token:function(e,t){e.sol()&&(t.lexical.hasOwnProperty("align")||(t.lexical.align=!1),t.indented=e.indentation());if(e.eatSpace())return null;s=o=null;var n=t.tokenize(e,t);return n=="comment"?n:(t.lexical.hasOwnProperty("align")||(t.lexical.align=!0),s=="prefix"?n:(o||(o=e.current()),G(t,e,n)))},indent:function(n,r){if(n.tokenize!=a)return 0;var i=r&&r.charAt(0),s=n.lexical,o=s.type,u=i==o;return o=="stat"?s.indented+e:s.align?s.column+(u?0:1):s.indented+(u?0:s.info=="alt"?t:e)},electricChars:"{}",blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//",fold:"brace"}}),e.defineMIME("text/x-rustsrc","rust")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/sass/sass",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("sass",function(e){var t=function(e){return new RegExp("^"+e.join("|"))},n=["true","false","null","auto"],r=new RegExp("^"+n.join("|")),i=["\\(","\\)","=",">","<","==",">=","<=","\\+","-","\\!=","/","\\*","%","and","or","not"],s=t(i),o=/^::?[\w\-]+/,u=function(e,t){var n=e.peek();return n===")"?(e.next(),t.tokenizer=p,"operator"):n==="("?(e.next(),e.eatSpace(),"operator"):n==="'"||n==='"'?(t.tokenizer=f(e.next()),"string"):(t.tokenizer=f(")",!1),"string")},a=function(e,t){return e.skipTo("*/")?(e.next(),e.next(),t.tokenizer=p):e.next(),"comment"},f=function(e,t){function n(r,i){var s=r.next(),o=r.peek(),u=r.string.charAt(r.pos-2),a=s!=="\\"&&o===e||s===e&&u!=="\\";return a?(s!==e&&t&&r.next(),i.tokenizer=p,"string"):s==="#"&&o==="{"?(i.tokenizer=l(n),r.next(),"operator"):"string"}return t==null&&(t=!0),n},l=function(e){return function(t,n){return t.peek()==="}"?(t.next(),n.tokenizer=e,"operator"):p(t,n)}},c=function(t){if(t.indentCount==0){t.indentCount++;var n=t.scopes[0].offset,r=n+e.indentUnit;t.scopes.unshift({offset:r})}},h=function(e){if(e.scopes.length==1)return;e.scopes.shift()},p=function(e,t){var n=e.peek();if(e.match("//"))return e.skipToEnd(),"comment";if(e.match("/*"))return t.tokenizer=a,t.tokenizer(e,t);if(e.match("#{"))return t.tokenizer=l(p),"operator";if(n===".")return e.next(),e.match(/^[\w-]+/)?(c(t),"atom"):e.peek()==="#"?(c(t),"atom"):"operator";if(n==="#"){e.next();if(e.match(/[0-9a-fA-F]{6}|[0-9a-fA-F]{3}/))return"number";if(e.match(/^[\w-]+/))return c(t),"atom";if(e.peek()==="#")return c(t),"atom"}return e.match(/^-?[0-9\.]+/)?"number":e.match(/^(px|em|in)\b/)?"unit":e.match(r)?"keyword":e.match(/^url/)&&e.peek()==="("?(t.tokenizer=u,"atom"):n==="$"?(e.next(),e.eatWhile(/[\w-]/),e.peek()===":"?(e.next(),"variable-2"):"variable-3"):n==="!"?(e.next(),e.match(/^[\w]+/)?"keyword":"operator"):n==="="?(e.next(),e.match(/^[\w-]+/)?(c(t),"meta"):"operator"):n==="+"?(e.next(),e.match(/^[\w-]+/)?"variable-3":"operator"):e.match(/^@(else if|if|media|else|for|each|while|mixin|function)/)?(c(t),"meta"):n==="@"?(e.next(),e.eatWhile(/[\w-]/),"meta"):n==='"'||n==="'"?(e.next(),t.tokenizer=f(n),"string"):n==":"&&e.match(o)?"keyword":e.eatWhile(/[\w-&]/)?e.peek()===":"&&!e.match(o,!1)?"property":"atom":e.match(s)?"operator":(e.next(),null)},d=function(t,n){t.sol()&&(n.indentCount=0);var r=n.tokenizer(t,n),i=t.current();i==="@return"&&h(n),r==="atom"&&c(n);if(r!==null){var s=t.pos-i.length,o=s+e.indentUnit*n.indentCount,u=[];for(var a=0;a<n.scopes.length;a++){var f=n.scopes[a];f.offset<=o&&u.push(f)}n.scopes=u}return r};return{startState:function(){return{tokenizer:p,scopes:[{offset:0,type:"sass"}],definedVars:[],definedMixins:[]}},token:function(e,t){var n=d(e,t);return t.lastToken={style:n,content:e.current()},n},indent:function(e){return e.scopes[0].offset}}}),e.defineMIME("text/x-sass","sass")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/scheme/scheme",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("scheme",function(){function u(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function l(e,t,n){this.indent=e,this.type=t,this.prev=n}function c(e,t,n){e.indentStack=new l(t,n,e.indentStack)}function h(e){e.indentStack=e.indentStack.prev}function g(e){return e.match(p)}function y(e){return e.match(d)}function b(e,t){return t===!0&&e.backUp(1),e.match(m)}function w(e){return e.match(v)}var e="builtin",t="comment",n="string",r="atom",i="number",s="bracket",o=2,a=u("λ case-lambda call/cc class define-class exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt #f floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? #t tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?"),f=u("define let letrec let* lambda"),p=new RegExp(/^(?:[-+]i|[-+][01]+#*(?:\/[01]+#*)?i|[-+]?[01]+#*(?:\/[01]+#*)?@[-+]?[01]+#*(?:\/[01]+#*)?|[-+]?[01]+#*(?:\/[01]+#*)?[-+](?:[01]+#*(?:\/[01]+#*)?)?i|[-+]?[01]+#*(?:\/[01]+#*)?)(?=[()\s;"]|$)/i),d=new RegExp(/^(?:[-+]i|[-+][0-7]+#*(?:\/[0-7]+#*)?i|[-+]?[0-7]+#*(?:\/[0-7]+#*)?@[-+]?[0-7]+#*(?:\/[0-7]+#*)?|[-+]?[0-7]+#*(?:\/[0-7]+#*)?[-+](?:[0-7]+#*(?:\/[0-7]+#*)?)?i|[-+]?[0-7]+#*(?:\/[0-7]+#*)?)(?=[()\s;"]|$)/i),v=new RegExp(/^(?:[-+]i|[-+][\da-f]+#*(?:\/[\da-f]+#*)?i|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?@[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?[-+](?:[\da-f]+#*(?:\/[\da-f]+#*)?)?i|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?)(?=[()\s;"]|$)/i),m=new RegExp(/^(?:[-+]i|[-+](?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)i|[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)@[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)|[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)[-+](?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)?i|(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*))(?=[()\s;"]|$)/i);return{startState:function(){return{indentStack:null,indentation:0,mode:!1,sExprComment:!1}},token:function(u,l){l.indentStack==null&&u.sol()&&(l.indentation=u.indentation());if(u.eatSpace())return null;var p=null;switch(l.mode){case"string":var d,v=!1;while((d=u.next())!=null){if(d=='"'&&!v){l.mode=!1;break}v=!v&&d=="\\"}p=n;break;case"comment":var d,m=!1;while((d=u.next())!=null){if(d=="#"&&m){l.mode=!1;break}m=d=="|"}p=t;break;case"s-expr-comment":l.mode=!1;if(u.peek()!="("&&u.peek()!="["){u.eatWhile(/[^/s]/),p=t;break}l.sExprComment=0;default:var E=u.next();if(E=='"')l.mode="string",p=n;else if(E=="'")p=r;else if(E=="#")if(u.eat("|"))l.mode="comment",p=t;else if(u.eat(/[tf]/i))p=r;else if(u.eat(";"))l.mode="s-expr-comment",p=t;else{var S=null,x=!1,T=!0;u.eat(/[ei]/i)?x=!0:u.backUp(1),u.match(/^#b/i)?S=g:u.match(/^#o/i)?S=y:u.match(/^#x/i)?S=w:u.match(/^#d/i)?S=b:u.match(/^[-+0-9.]/,!1)?(T=!1,S=b):x||u.eat("#"),S!=null&&(T&&!x&&u.match(/^#[ei]/i),S(u)&&(p=i))}else if(/^[-+0-9.]/.test(E)&&b(u,!0))p=i;else if(E==";")u.skipToEnd(),p=t;else if(E=="("||E=="["){var N="",C=u.column(),k;while((k=u.eat(/[^\s\(\[\;\)\]]/))!=null)N+=k;N.length>0&&f.propertyIsEnumerable(N)?c(l,C+o,E):(u.eatSpace(),u.eol()||u.peek()==";"?c(l,C+1,E):c(l,C+u.current().length,E)),u.backUp(u.current().length-1),typeof l.sExprComment=="number"&&l.sExprComment++,p=s}else E==")"||E=="]"?(p=s,l.indentStack!=null&&l.indentStack.type==(E==")"?"(":"[")&&(h(l),typeof l.sExprComment=="number"&&--l.sExprComment==0&&(p=t,l.sExprComment=!1))):(u.eatWhile(/[\w\$_\-!$%&*+\.\/:<=>?@\^~]/),a&&a.propertyIsEnumerable(u.current())?p=e:p="variable")}return typeof l.sExprComment=="number"?t:p},indent:function(e){return e.indentStack==null?e.indentation:e.indentStack.indent},lineComment:";;"}}),e.defineMIME("text/x-scheme","scheme")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/shell/shell",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("shell",function(){function t(t,n){var r=n.split(" ");for(var i=0;i<r.length;i++)e[r[i]]=t}function n(t,n){if(t.eatSpace())return null;var o=t.sol(),u=t.next();if(u==="\\")return t.next(),null;if(u==="'"||u==='"'||u==="`")return n.tokens.unshift(r(u)),s(t,n);if(u==="#")return o&&t.eat("!")?(t.skipToEnd(),"meta"):(t.skipToEnd(),"comment");if(u==="$")return n.tokens.unshift(i),s(t,n);if(u==="+"||u==="=")return"operator";if(u==="-")return t.eat("-"),t.eatWhile(/\w/),"attribute";if(/\d/.test(u)){t.eatWhile(/\d/);if(t.eol()||!/\w/.test(t.peek()))return"number"}t.eatWhile(/[\w-]/);var a=t.current();return t.peek()==="="&&/\w+/.test(a)?"def":e.hasOwnProperty(a)?e[a]:null}function r(e){return function(t,n){var r,s=!1,o=!1;while((r=t.next())!=null){if(r===e&&!o){s=!0;break}if(r==="$"&&!o&&e!=="'"){o=!0,t.backUp(1),n.tokens.unshift(i);break}o=!o&&r==="\\"}return(s||!o)&&n.tokens.shift(),e==="`"||e===")"?"quote":"string"}}function s(e,t){return(t.tokens[0]||n)(e,t)}var e={};t("atom","true false"),t("keyword","if then do else elif while until for in esac fi fin fil done exit set unset export function"),t("builtin","ab awk bash beep cat cc cd chown chmod chroot clear cp curl cut diff echo find gawk gcc get git grep kill killall ln ls make mkdir openssl mv nc node npm ping ps restart rm rmdir sed service sh shopt shred source sort sleep ssh start stop su sudo tee telnet top touch vi vim wall wc wget who write yes zsh");var i=function(e,t){t.tokens.length>1&&e.eat("$");var n=e.next(),i=/\w/;return n==="{"&&(i=/[^}]/),n==="("?(t.tokens[0]=r(")"),s(e,t)):(/\d/.test(n)||(e.eatWhile(i),e.eat("}")),t.tokens.shift(),"def")};return{startState:function(){return{tokens:[]}},token:function(e,t){return s(e,t)}}}),e.defineMIME("text/x-sh","shell")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/sieve/sieve",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("sieve",function(e){function t(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function s(e,t){var i=e.next();if(i=="/"&&e.eat("*"))return t.tokenize=u,u(e,t);if(i==="#")return e.skipToEnd(),"comment";if(i=='"')return t.tokenize=a(i),t.tokenize(e,t);if(i=="(")return t._indent.push("("),t._indent.push("{"),null;if(i==="{")return t._indent.push("{"),null;i==")"&&(t._indent.pop(),t._indent.pop());if(i==="}")return t._indent.pop(),null;if(i==",")return null;if(i==";")return null;if(/[{}\(\),;]/.test(i))return null;if(/\d/.test(i))return e.eatWhile(/[\d]/),e.eat(/[KkMmGg]/),"number";if(i==":")return e.eatWhile(/[a-zA-Z_]/),e.eatWhile(/[a-zA-Z0-9_]/),"operator";e.eatWhile(/\w/);var s=e.current();return s=="text"&&e.eat(":")?(t.tokenize=o,"string"):n.propertyIsEnumerable(s)?"keyword":r.propertyIsEnumerable(s)?"atom":null}function o(e,t){return t._multiLineString=!0,e.sol()?(e.next()=="."&&e.eol()&&(t._multiLineString=!1,t.tokenize=s),"string"):(e.eatSpace(),e.peek()=="#"?(e.skipToEnd(),"comment"):(e.skipToEnd(),"string"))}function u(e,t){var n=!1,r;while((r=e.next())!=null){if(n&&r=="/"){t.tokenize=s;break}n=r=="*"}return"comment"}function a(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r)break;r=!r&&i=="\\"}return r||(n.tokenize=s),"string"}}var n=t("if elsif else stop require"),r=t("true false not"),i=e.indentUnit;return{startState:function(e){return{tokenize:s,baseIndent:e||0,_indent:[]}},token:function(e,t){return e.eatSpace()?null:(t.tokenize||s)(e,t)},indent:function(e,t){var n=e._indent.length;return t&&t[0]=="}"&&n--,n<0&&(n=0),n*i},electricChars:"}"}}),e.defineMIME("application/sieve","sieve")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/smalltalk/smalltalk",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("smalltalk",function(e){var t=/[+\-\/\\*~<>=@%|&?!.,:;^]/,n=/true|false|nil|self|super|thisContext/,r=function(e,t){this.next=e,this.parent=t},i=function(e,t,n){this.name=e,this.context=t,this.eos=n},s=function(){this.context=new r(o,null),this.expectVariable=!0,this.indentation=0,this.userIndentationDelta=0};s.prototype.userIndent=function(t){this.userIndentationDelta=t>0?t/e.indentUnit-this.indentation:0};var o=function(e,s,o){var c=new i(null,s,!1),h=e.next();return h==='"'?c=u(e,new r(u,s)):h==="'"?c=a(e,new r(a,s)):h==="#"?e.peek()==="'"?(e.next(),c=f(e,new r(f,s))):e.eatWhile(/[^ .{}\[\]()]/)?c.name="string-2":c.name="meta":h==="$"?(e.next()==="<"&&(e.eatWhile(/[^ >]/),e.next()),c.name="string-2"):h==="|"&&o.expectVariable?c.context=new r(l,s):/[\[\]{}()]/.test(h)?(c.name="bracket",c.eos=/[\[{(]/.test(h),h==="["?o.indentation++:h==="]"&&(o.indentation=Math.max(0,o.indentation-1))):t.test(h)?(e.eatWhile(t),c.name="operator",c.eos=h!==";"):/\d/.test(h)?(e.eatWhile(/[\w\d]/),c.name="number"):/[\w_]/.test(h)?(e.eatWhile(/[\w\d_]/),c.name=o.expectVariable?n.test(e.current())?"keyword":"variable":null):c.eos=o.expectVariable,c},u=function(e,t){return e.eatWhile(/[^"]/),new i("comment",e.eat('"')?t.parent:t,!0)},a=function(e,t){return e.eatWhile(/[^']/),new i("string",e.eat("'")?t.parent:t,!1)},f=function(e,t){return e.eatWhile(/[^']/),new i("string-2",e.eat("'")?t.parent:t,!1)},l=function(e,t){var n=new i(null,t,!1),r=e.next();return r==="|"?(n.context=t.parent,n.eos=!0):(e.eatWhile(/[^|]/),n.name="variable"),n};return{startState:function(){return new s},token:function(e,t){t.userIndent(e.indentation());if(e.eatSpace())return null;var n=t.context.next(e,t.context,t);return t.context=n.context,t.expectVariable=n.eos,n.name},blankLine:function(e){e.userIndent(0)},indent:function(t,n){var r=t.context.next===o&&n&&n.charAt(0)==="]"?-1:t.userIndentationDelta;return(t.indentation+r)*e.indentUnit},electricChars:"]"}}),e.defineMIME("text/x-stsrc",{name:"smalltalk"})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/smarty/smarty",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("smarty",function(e){var t={rightDelimiter:"}",leftDelimiter:"{",smartyVersion:2};e.hasOwnProperty("leftDelimiter")&&(t.leftDelimiter=e.leftDelimiter),e.hasOwnProperty("rightDelimiter")&&(t.rightDelimiter=e.rightDelimiter),e.hasOwnProperty("smartyVersion")&&e.smartyVersion===3&&(t.smartyVersion=3);var n=["debug","extends","function","include","literal"],r,i={operatorChars:/[+\-*&%=<>!?]/,validIdentifier:/[a-zA-Z0-9_]/,stringChar:/['"]/},s={cont:function(e,t){return r=t,e},chain:function(e,t,n){return t.tokenize=n,n(e,t)}},o={tokenizer:function(e,n){if(e.match(t.leftDelimiter,!0)){if(e.eat("*"))return s.chain(e,n,o.inBlock("comment","*"+t.rightDelimiter));n.depth++;var i=e.eol(),u=/\s/.test(e.peek());return t.smartyVersion===3&&t.leftDelimiter==="{"&&(i||u)?(n.depth--,null):(n.tokenize=o.smarty,r="startTag","tag")}return e.next(),null},smarty:function(e,u){if(e.match(t.rightDelimiter,!0))return t.smartyVersion===3?(u.depth--,u.depth<=0&&(u.tokenize=o.tokenizer)):u.tokenize=o.tokenizer,s.cont("tag",null);if(e.match(t.leftDelimiter,!0))return u.depth++,s.cont("tag","startTag");var a=e.next();if(a=="$")return e.eatWhile(i.validIdentifier),s.cont("variable-2","variable");if(a=="|")return s.cont("operator","pipe");if(a==".")return s.cont("operator","property");if(i.stringChar.test(a))return u.tokenize=o.inAttribute(a),s.cont("string","string");if(i.operatorChars.test(a))return e.eatWhile(i.operatorChars),s.cont("operator","operator");if(a=="["||a=="]")return s.cont("bracket","bracket");if(a=="("||a==")")return s.cont("bracket","operator");if(/\d/.test(a))return e.eatWhile(/\d/),s.cont("number","number");if(u.last=="variable"){if(a=="@")return e.eatWhile(i.validIdentifier),s.cont("property","property");if(a=="|")return e.eatWhile(i.validIdentifier),s.cont("qualifier","modifier")}else{if(u.last=="pipe")return e.eatWhile(i.validIdentifier),s.cont("qualifier","modifier");if(u.last=="whitespace")return e.eatWhile(i.validIdentifier),s.cont("attribute","modifier")}if(u.last=="property")return e.eatWhile(i.validIdentifier),s.cont("property",null);if(/\s/.test(a))return r="whitespace",null;var f="";a!="/"&&(f+=a);var l=null;while(l=e.eat(i.validIdentifier))f+=l;for(var c=0,h=n.length;c<h;c++)if(n[c]==f)return s.cont("keyword","keyword");return/\s/.test(a)?null:s.cont("tag","tag")},inAttribute:function(e){return function(t,n){var r=null,i=null;while(!t.eol()){i=t.peek();if(t.next()==e&&r!=="\\"){n.tokenize=o.smarty;break}r=i}return"string"}},inBlock:function(e,t){return function(n,r){while(!n.eol()){if(n.match(t)){r.tokenize=o.tokenizer;break}n.next()}return e}}};return{startState:function(){return{tokenize:o.tokenizer,mode:"smarty",last:null,depth:0}},token:function(e,t){var n=t.tokenize(e,t);return t.last=r,n},electricChars:""}}),e.defineMIME("text/x-smarty","smarty")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror"),require("../htmlmixed/htmlmixed"),require("../smarty/smarty")):typeof define=="function"&&define.amd?define("components/codemirror/mode/smartymixed/smartymixed",["../../lib/codemirror","../htmlmixed/htmlmixed","../smarty/smarty"],e):e(CodeMirror)}(function(e){e.defineMode("smartymixed",function(t){var n,r,i,s,o=e.getMode(t,"htmlmixed"),u=e.getMode(t,"smarty"),n={rightDelimiter:"}",leftDelimiter:"{"};return t.hasOwnProperty("leftDelimiter")&&(n.leftDelimiter=t.leftDelimiter),t.hasOwnProperty("rightDelimiter")&&(n.rightDelimiter=t.rightDelimiter),r={smartyComment:new RegExp("^"+n.leftDelimiter+"\\*"),literalOpen:new RegExp(n.leftDelimiter+"literal"+n.rightDelimiter),literalClose:new RegExp(n.leftDelimiter+"/literal"+n.rightDelimiter),hasLeftDelimeter:new RegExp(".*"+n.leftDelimiter),htmlHasLeftDelimeter:new RegExp("[^<>]*"+n.leftDelimiter)},i={chain:function(e,t,n){return t.tokenize=n,n(e,t)},cleanChain:function(e,t,n){return t.tokenize=null,t.localState=null,t.localMode=null,typeof n=="string"?n?n:null:n(e,t)},maybeBackup:function(e,t,n){var r=e.current(),i=r.search(t),s;if(i>-1)e.backUp(r.length-i);else if(s=r.match(/<\/?$/))e.backUp(r.length),e.match(t,!1)||e.match(r[0]);return n}},s={html:function(e,t){return!t.inLiteral&&e.match(r.htmlHasLeftDelimeter,!1)&&t.htmlMixedState.htmlState.tagName===null?(t.tokenize=s.smarty,t.localMode=u,t.localState=u.startState(o.indent(t.htmlMixedState,"")),i.maybeBackup(e,n.leftDelimiter,u.token(e,t.localState))):!t.inLiteral&&e.match(n.leftDelimiter,!1)?(t.tokenize=s.smarty,t.localMode=u,t.localState=u.startState(o.indent(t.htmlMixedState,"")),i.maybeBackup(e,n.leftDelimiter,u.token(e,t.localState))):o.token(e,t.htmlMixedState)},smarty:function(e,t){if(e.match(n.leftDelimiter,!1)){if(e.match(r.smartyComment,!1))return i.chain(e,t,s.inBlock("comment","*"+n.rightDelimiter))}else if(e.match(n.rightDelimiter,!1))return e.eat(n.rightDelimiter),t.tokenize=s.html,t.localMode=o,t.localState=t.htmlMixedState,"tag";return i.maybeBackup(e,n.rightDelimiter,u.token(e,t.localState))},inBlock:function(e,t){return function(n,r){while(!n.eol()){if(n.match(t)){i.cleanChain(n,r,"");break}n.next()}return e}}},{startState:function(){var e=o.startState();return{token:s.html,localMode:null,localState:null,htmlMixedState:e,tokenize:null,inLiteral:!1}},copyState:function(t){var n=null,r=t.tokenize||t.token;return t.localState&&(n=e.copyState(r!=s.html?u:o,t.localState)),{token:t.token,tokenize:t.tokenize,localMode:t.localMode,localState:n,htmlMixedState:e.copyState(o,t.htmlMixedState),inLiteral:t.inLiteral}},token:function(e,t){if(e.match(n.leftDelimiter,!1)){if(!t.inLiteral&&e.match(r.literalOpen,!0))return t.inLiteral=!0,"keyword";if(t.inLiteral&&e.match(r.literalClose,!0))return t.inLiteral=!1,"keyword"}t.inLiteral&&t.localState!=t.htmlMixedState&&(t.tokenize=s.html,t.localMode=o,t.localState=t.htmlMixedState);var i=(t.tokenize||t.token)(e,t);return i},indent:function(t,n){return t.localMode==u||t.inLiteral&&!t.localMode||r.hasLeftDelimeter.test(n)?e.Pass:o.indent(t.htmlMixedState,n)},innerMode:function(e){return{state:e.localState||e.htmlMixedState,mode:e.localMode||o}}}},"htmlmixed","smarty"),e.defineMIME("text/x-smarty","smartymixed")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/solr/solr",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("solr",function(){function r(e){return parseFloat(e,10).toString()===e}function i(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r)break;r=!r&&i=="\\"}return r||(n.tokenize=u),"string"}}function s(e){return function(t,n){var r="operator";return e=="+"?r+=" positive":e=="-"?r+=" negative":e=="|"?t.eat(/\|/):e=="&"?t.eat(/\&/):e=="^"&&(r+=" boost"),n.tokenize=u,r}}function o(t){return function(i,s){var o=t;while((t=i.peek())&&t.match(e)!=null)o+=i.next();return s.tokenize=u,n.test(o)?"operator":r(o)?"number":i.peek()==":"?"field":"string"}}function u(n,r){var a=n.next();return a=='"'?r.tokenize=i(a):t.test(a)?r.tokenize=s(a):e.test(a)&&(r.tokenize=o(a)),r.tokenize!=u?r.tokenize(n,r):null}var e=/[^\s\|\!\+\-\*\?\~\^\&\:\(\)\[\]\{\}\^\"\\]/,t=/[\|\!\+\-\*\?\~\^\&]/,n=/^(OR|AND|NOT|TO)$/i;return{startState:function(){return{tokenize:u}},token:function(e,t){return e.eatSpace()?null:t.tokenize(e,t)}}}),e.defineMIME("text/x-solr","solr")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/sparql/sparql",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("sparql",function(e){function r(e){return new RegExp("^(?:"+e.join("|")+")$","i")}function u(e,t){var r=e.next();n=null;if(r=="$"||r=="?")return e.match(/^[\w\d]*/),"variable-2";if(r=="<"&&!e.match(/^[\s\u00a0=]/,!1))return e.match(/^[^\s\u00a0>]*>?/),"atom";if(r=='"'||r=="'")return t.tokenize=a(r),t.tokenize(e,t);if(/[{}\(\),\.;\[\]]/.test(r))return n=r,null;if(r=="#")return e.skipToEnd(),"comment";if(o.test(r))return e.eatWhile(o),null;if(r==":")return e.eatWhile(/[\w\d\._\-]/),"atom";e.eatWhile(/[_\w\d]/);if(e.eat(":"))return e.eatWhile(/[\w\d_\-]/),"atom";var u=e.current();return i.test(u)?null:s.test(u)?"keyword":"variable"}function a(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r){n.tokenize=u;break}r=!r&&i=="\\"}return"string"}}function f(e,t,n){e.context={prev:e.context,indent:e.indent,col:n,type:t}}function l(e){e.indent=e.context.indent,e.context=e.context.prev}var t=e.indentUnit,n,i=r(["str","lang","langmatches","datatype","bound","sameterm","isiri","isuri","isblank","isliteral","a"]),s=r(["base","prefix","select","distinct","reduced","construct","describe","ask","from","named","where","order","limit","offset","filter","optional","graph","by","asc","desc","as","having","undef","values","group","minus","in","not","service","silent","using","insert","delete","union","data","copy","to","move","add","create","drop","clear","load"]),o=/[*+\-<>=&|]/;return{startState:function(){return{tokenize:u,context:null,indent:0,col:0}},token:function(e,t){e.sol()&&(t.context&&t.context.align==null&&(t.context.align=!1),t.indent=e.indentation());if(e.eatSpace())return null;var r=t.tokenize(e,t);r!="comment"&&t.context&&t.context.align==null&&t.context.type!="pattern"&&(t.context.align=!0);if(n=="(")f(t,")",e.column());else if(n=="[")f(t,"]",e.column());else if(n=="{")f(t,"}",e.column());else if(/[\]\}\)]/.test(n)){while(t.context&&t.context.type=="pattern")l(t);t.context&&n==t.context.type&&l(t)}else n=="."&&t.context&&t.context.type=="pattern"?l(t):/atom|string|variable/.test(r)&&t.context&&(/[\}\]]/.test(t.context.type)?f(t,"pattern",e.column()):t.context.type=="pattern"&&!t.context.align&&(t.context.align=!0,t.context.col=e.column()));return r},indent:function(e,n){var r=n&&n.charAt(0),i=e.context;if(/[\]\}]/.test(r))while(i&&i.type=="pattern")i=i.prev;var s=i&&r==i.type;return i?i.type=="pattern"?i.col:i.align?i.col+(s?0:1):i.indent+(s?0:t):0}}}),e.defineMIME("application/x-sparql-query","sparql")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/sql/sql",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("sql",function(e,t){function l(e,t){var l=e.next();if(a[l]){var p=a[l](e,t);if(p!==!1)return p}if(u.hexNumber==1&&(l=="0"&&e.match(/^[xX][0-9a-fA-F]+/)||(l=="x"||l=="X")&&e.match(/^'[0-9a-fA-F]+'/)))return"number";if(u.binaryNumber==1&&((l=="b"||l=="B")&&e.match(/^'[01]+'/)||l=="0"&&e.match(/^b[01]+/)))return"number";if(l.charCodeAt(0)>47&&l.charCodeAt(0)<58)return e.match(/^[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?/),u.decimallessFloat==1&&e.eat("."),"number";if(l=="?"&&(e.eatSpace()||e.eol()||e.eat(";")))return"variable-3";if(l=="'"||l=='"'&&u.doubleQuote)return t.tokenize=c(l),t.tokenize(e,t);if(!(!(u.nCharCast==1&&(l=="n"||l=="N")||u.charsetCast==1&&l=="_"&&e.match(/[a-z][a-z0-9]*/i))||e.peek()!="'"&&e.peek()!='"'))return"keyword";if(/^[\(\),\;\[\]]/.test(l))return null;if(u.commentSlashSlash&&l=="/"&&e.eat("/"))return e.skipToEnd(),"comment";if(u.commentHash&&l=="#"||l=="-"&&e.eat("-")&&(!u.commentSpaceRequired||e.eat(" ")))return e.skipToEnd(),"comment";if(l=="/"&&e.eat("*"))return t.tokenize=h,t.tokenize(e,t);if(l!="."){if(o.test(l))return e.eatWhile(o),null;if(l=="{"&&(e.match(/^( )*(d|D|t|T|ts|TS)( )*'[^']*'( )*}/)||e.match(/^( )*(d|D|t|T|ts|TS)( )*"[^"]*"( )*}/)))return"number";e.eatWhile(/^[_\w\d]/);var d=e.current().toLowerCase();return f.hasOwnProperty(d)&&(e.match(/^( )+'[^']*'/)||e.match(/^( )+"[^"]*"/))?"number":r.hasOwnProperty(d)?"atom":i.hasOwnProperty(d)?"builtin":s.hasOwnProperty(d)?"keyword":n.hasOwnProperty(d)?"string-2":null}if(u.zerolessFloat==1&&e.match(/^(?:\d+(?:e[+-]?\d+)?)/i))return"number";if(u.ODBCdotTable==1&&e.match(/^[a-zA-Z_]+/))return"variable-2"}function c(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r){n.tokenize=l;break}r=!r&&i=="\\"}return"string"}}function h(e,t){for(;;){if(!e.skipTo("*")){e.skipToEnd();break}e.next();if(e.eat("/")){t.tokenize=l;break}}return"comment"}function p(e,t,n){t.context={prev:t.context,indent:e.indentation(),col:e.column(),type:n}}function d(e){e.indent=e.context.indent,e.context=e.context.prev}var n=t.client||{},r=t.atoms||{"false":!0,"true":!0,"null":!0},i=t.builtin||{},s=t.keywords||{},o=t.operatorChars||/^[*+\-%<>!=&|~^]/,u=t.support||{},a=t.hooks||{},f=t.dateSQL||{date:!0,time:!0,timestamp:!0};return{startState:function(){return{tokenize:l,context:null}},token:function(e,t){e.sol()&&t.context&&t.context.align==null&&(t.context.align=!1);if(e.eatSpace())return null;var n=t.tokenize(e,t);if(n=="comment")return n;t.context&&t.context.align==null&&(t.context.align=!0);var r=e.current();return r=="("?p(e,t,")"):r=="["?p(e,t,"]"):t.context&&t.context.type==r&&d(t),n},indent:function(t,n){var r=t.context;if(!r)return 0;var i=n.charAt(0)==r.type;return r.align?r.col+(i?0:1):r.indent+(i?0:e.indentUnit)},blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:u.commentSlashSlash?"//":u.commentHash?"#":null}}),function(){function t(e){var t;while((t=e.next())!=null)if(t=="`"&&!e.eat("`"))return"variable-2";return null}function n(e){return e.eat("@")&&(e.match(/^session\./),e.match(/^local\./),e.match(/^global\./)),e.eat("'")?(e.match(/^.*'/),"variable-2"):e.eat('"')?(e.match(/^.*"/),"variable-2"):e.eat("`")?(e.match(/^.*`/),"variable-2"):e.match(/^[0-9a-zA-Z$\.\_]+/)?"variable-2":null}function r(e){return e.eat("N")?"atom":e.match(/^[a-zA-Z.#!?]/)?"variable-2":null}function s(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}var i="alter and as asc between by count create delete desc distinct drop from having in insert into is join like not on or order select set table union update values where ";e.defineMIME("text/x-sql",{name:"sql",keywords:s(i+"begin"),builtin:s("bool boolean bit blob enum long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision real date datetime year unsigned signed decimal numeric"),atoms:s("false true null unknown"),operatorChars:/^[*+\-%<>!=]/,dateSQL:s("date time timestamp"),support:s("ODBCdotTable doubleQuote binaryNumber hexNumber")}),e.defineMIME("text/x-mssql",{name:"sql",client:s("charset clear connect edit ego exit go help nopager notee nowarning pager print prompt quit rehash source status system tee"),keywords:s(i+"begin trigger proc view index for add constraint key primary foreign collate clustered nonclustered"),builtin:s("bigint numeric bit smallint decimal smallmoney int tinyint money float real char varchar text nchar nvarchar ntext binary varbinary image cursor timestamp hierarchyid uniqueidentifier sql_variant xml table "),atoms:s("false true null unknown"),operatorChars:/^[*+\-%<>!=]/,dateSQL:s("date datetimeoffset datetime2 smalldatetime datetime time"),hooks:{"@":n}}),e.defineMIME("text/x-mysql",{name:"sql",client:s("charset clear connect edit ego exit go help nopager notee nowarning pager print prompt quit rehash source status system tee"),keywords:s(i+"accessible action add after algorithm all analyze asensitive at authors auto_increment autocommit avg avg_row_length before binary binlog both btree cache call cascade cascaded case catalog_name chain change changed character check checkpoint checksum class_origin client_statistics close coalesce code collate collation collations column columns comment commit committed completion concurrent condition connection consistent constraint contains continue contributors convert cross current current_date current_time current_timestamp current_user cursor data database databases day_hour day_microsecond day_minute day_second deallocate dec declare default delay_key_write delayed delimiter des_key_file describe deterministic dev_pop dev_samp deviance diagnostics directory disable discard distinctrow div dual dumpfile each elseif enable enclosed end ends engine engines enum errors escape escaped even event events every execute exists exit explain extended fast fetch field fields first flush for force foreign found_rows full fulltext function general get global grant grants group groupby_concat handler hash help high_priority hosts hour_microsecond hour_minute hour_second if ignore ignore_server_ids import index index_statistics infile inner innodb inout insensitive insert_method install interval invoker isolation iterate key keys kill language last leading leave left level limit linear lines list load local localtime localtimestamp lock logs low_priority master master_heartbeat_period master_ssl_verify_server_cert masters match max max_rows maxvalue message_text middleint migrate min min_rows minute_microsecond minute_second mod mode modifies modify mutex mysql_errno natural next no no_write_to_binlog offline offset one online open optimize option optionally out outer outfile pack_keys parser partition partitions password phase plugin plugins prepare preserve prev primary privileges procedure processlist profile profiles purge query quick range read read_write reads real rebuild recover references regexp relaylog release remove rename reorganize repair repeatable replace require resignal restrict resume return returns revoke right rlike rollback rollup row row_format rtree savepoint schedule schema schema_name schemas second_microsecond security sensitive separator serializable server session share show signal slave slow smallint snapshot soname spatial specific sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_no_cache sql_small_result sqlexception sqlstate sqlwarning ssl start starting starts status std stddev stddev_pop stddev_samp storage straight_join subclass_origin sum suspend table_name table_statistics tables tablespace temporary terminated to trailing transaction trigger triggers truncate uncommitted undo uninstall unique unlock upgrade usage use use_frm user user_resources user_statistics using utc_date utc_time utc_timestamp value variables varying view views warnings when while with work write xa xor year_month zerofill begin do then else loop repeat"),builtin:s("bool boolean bit blob decimal double float long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision date datetime year unsigned signed numeric"),atoms:s("false true null unknown"),operatorChars:/^[*+\-%<>!=&|^]/,dateSQL:s("date time timestamp"),support:s("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber doubleQuote nCharCast charsetCast commentHash commentSpaceRequired"),hooks:{"@":n,"`":t,"\\":r}}),e.defineMIME("text/x-mariadb",{name:"sql",client:s("charset clear connect edit ego exit go help nopager notee nowarning pager print prompt quit rehash source status system tee"),keywords:s(i+"accessible action add after algorithm all always analyze asensitive at authors auto_increment autocommit avg avg_row_length before binary binlog both btree cache call cascade cascaded case catalog_name chain change changed character check checkpoint checksum class_origin client_statistics close coalesce code collate collation collations column columns comment commit committed completion concurrent condition connection consistent constraint contains continue contributors convert cross current current_date current_time current_timestamp current_user cursor data database databases day_hour day_microsecond day_minute day_second deallocate dec declare default delay_key_write delayed delimiter des_key_file describe deterministic dev_pop dev_samp deviance diagnostics directory disable discard distinctrow div dual dumpfile each elseif enable enclosed end ends engine engines enum errors escape escaped even event events every execute exists exit explain extended fast fetch field fields first flush for force foreign found_rows full fulltext function general generated get global grant grants group groupby_concat handler hard hash help high_priority hosts hour_microsecond hour_minute hour_second if ignore ignore_server_ids import index index_statistics infile inner innodb inout insensitive insert_method install interval invoker isolation iterate key keys kill language last leading leave left level limit linear lines list load local localtime localtimestamp lock logs low_priority master master_heartbeat_period master_ssl_verify_server_cert masters match max max_rows maxvalue message_text middleint migrate min min_rows minute_microsecond minute_second mod mode modifies modify mutex mysql_errno natural next no no_write_to_binlog offline offset one online open optimize option optionally out outer outfile pack_keys parser partition partitions password persistent phase plugin plugins prepare preserve prev primary privileges procedure processlist profile profiles purge query quick range read read_write reads real rebuild recover references regexp relaylog release remove rename reorganize repair repeatable replace require resignal restrict resume return returns revoke right rlike rollback rollup row row_format rtree savepoint schedule schema schema_name schemas second_microsecond security sensitive separator serializable server session share show shutdown signal slave slow smallint snapshot soft soname spatial specific sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_no_cache sql_small_result sqlexception sqlstate sqlwarning ssl start starting starts status std stddev stddev_pop stddev_samp storage straight_join subclass_origin sum suspend table_name table_statistics tables tablespace temporary terminated to trailing transaction trigger triggers truncate uncommitted undo uninstall unique unlock upgrade usage use use_frm user user_resources user_statistics using utc_date utc_time utc_timestamp value variables varying view views virtual warnings when while with work write xa xor year_month zerofill begin do then else loop repeat"),builtin:s("bool boolean bit blob decimal double float long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision date datetime year unsigned signed numeric"),atoms:s("false true null unknown"),operatorChars:/^[*+\-%<>!=&|^]/,dateSQL:s("date time timestamp"),support:s("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber doubleQuote nCharCast charsetCast commentHash commentSpaceRequired"),hooks:{"@":n,"`":t,"\\":r}}),e.defineMIME("text/x-cassandra",{name:"sql",client:{},keywords:s("use select from using consistency where limit first reversed first and in insert into values using consistency ttl update set delete truncate begin batch apply create keyspace with columnfamily primary key index on drop alter type add any one quorum all local_quorum each_quorum"),builtin:s("ascii bigint blob boolean counter decimal double float int text timestamp uuid varchar varint"),atoms:s("false true"),operatorChars:/^[<>=]/,dateSQL:{},support:s("commentSlashSlash decimallessFloat"),hooks:{}}),e.defineMIME("text/x-plsql",{name:"sql",client:s("appinfo arraysize autocommit autoprint autorecovery autotrace blockterminator break btitle cmdsep colsep compatibility compute concat copycommit copytypecheck define describe echo editfile embedded escape exec execute feedback flagger flush heading headsep instance linesize lno loboffset logsource long longchunksize markup native newpage numformat numwidth pagesize pause pno recsep recsepchar release repfooter repheader serveroutput shiftinout show showmode size spool sqlblanklines sqlcase sqlcode sqlcontinue sqlnumber sqlpluscompatibility sqlprefix sqlprompt sqlterminator suffix tab term termout time timing trimout trimspool ttitle underline verify version wrap"),keywords:s("abort accept access add all alter and any array arraylen as asc assert assign at attributes audit authorization avg base_table begin between binary_integer body boolean by case cast char char_base check close cluster clusters colauth column comment commit compress connect connected constant constraint crash create current currval cursor data_base database date dba deallocate debugoff debugon decimal declare default definition delay delete desc digits dispose distinct do drop else elseif elsif enable end entry escape exception exception_init exchange exclusive exists exit external fast fetch file for force form from function generic goto grant group having identified if immediate in increment index indexes indicator initial initrans insert interface intersect into is key level library like limited local lock log logging long loop master maxextents maxtrans member minextents minus mislabel mode modify multiset new next no noaudit nocompress nologging noparallel not nowait number_base object of off offline on online only open option or order out package parallel partition pctfree pctincrease pctused pls_integer positive positiven pragma primary prior private privileges procedure public raise range raw read rebuild record ref references refresh release rename replace resource restrict return returning returns reverse revoke rollback row rowid rowlabel rownum rows run savepoint schema segment select separate session set share snapshot some space split sql start statement storage subtype successful synonym tabauth table tables tablespace task terminate then to trigger truncate type union unique unlimited unrecoverable unusable update use using validate value values variable view views when whenever where while with work"),builtin:s("abs acos add_months ascii asin atan atan2 average bfile bfilename bigserial bit blob ceil character chartorowid chr clob concat convert cos cosh count dec decode deref dual dump dup_val_on_index empty error exp false float floor found glb greatest hextoraw initcap instr instrb int integer isopen last_day least lenght lenghtb ln lower lpad ltrim lub make_ref max min mlslabel mod months_between natural naturaln nchar nclob new_time next_day nextval nls_charset_decl_len nls_charset_id nls_charset_name nls_initcap nls_lower nls_sort nls_upper nlssort no_data_found notfound null number numeric nvarchar2 nvl others power rawtohex real reftohex round rowcount rowidtochar rowtype rpad rtrim serial sign signtype sin sinh smallint soundex sqlcode sqlerrm sqrt stddev string substr substrb sum sysdate tan tanh to_char text to_date to_label to_multi_byte to_number to_single_byte translate true trunc uid unlogged upper user userenv varchar varchar2 variance varying vsize xml"),operatorChars:/^[*+\-%<>!=~]/,dateSQL:s("date time timestamp"),support:s("doubleQuote nCharCast zerolessFloat binaryNumber hexNumber")}),e.defineMIME("text/x-hive",{name:"sql",keywords:s("select alter $elem$ $key$ $value$ add after all analyze and archive as asc before between binary both bucket buckets by cascade case cast change cluster clustered clusterstatus collection column columns comment compute concatenate continue create cross cursor data database databases dbproperties deferred delete delimited desc describe directory disable distinct distribute drop else enable end escaped exclusive exists explain export extended external false fetch fields fileformat first format formatted from full function functions grant group having hold_ddltime idxproperties if import in index indexes inpath inputdriver inputformat insert intersect into is items join keys lateral left like limit lines load local location lock locks mapjoin materialized minus msck no_drop nocompress not of offline on option or order out outer outputdriver outputformat overwrite partition partitioned partitions percent plus preserve procedure purge range rcfile read readonly reads rebuild recordreader recordwriter recover reduce regexp rename repair replace restrict revoke right rlike row schema schemas semi sequencefile serde serdeproperties set shared show show_database sort sorted ssl statistics stored streamtable table tables tablesample tblproperties temporary terminated textfile then tmp to touch transform trigger true unarchive undo union uniquejoin unlock update use using utc utc_tmestamp view when where while with"),builtin:s("bool boolean long timestamp tinyint smallint bigint int float double date datetime unsigned string array struct map uniontype"),atoms:s("false true null unknown"),operatorChars:/^[*+\-%<>!=]/,dateSQL:s("date timestamp"),support:s("ODBCdotTable doubleQuote binaryNumber hexNumber")})}()}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/tcl/tcl",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("tcl",function(){function e(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function i(e,t,n){return t.tokenize=n,n(e,t)}function s(e,s){var f=s.beforeParams;s.beforeParams=!1;var l=e.next();if(l!='"'&&l!="'"||!s.inParams){if(/[\[\]{}\(\),;\.]/.test(l))return l=="("&&f?s.inParams=!0:l==")"&&(s.inParams=!1),null;if(/\d/.test(l))return e.eatWhile(/[\w\.]/),"number";if(l=="#"&&e.eat("*"))return i(e,s,u);if(l=="#"&&e.match(/ *\[ *\[/))return i(e,s,a);if(l=="#"&&e.eat("#"))return e.skipToEnd(),"comment";if(l=='"')return e.skipTo(/"/),"comment";if(l=="$")return e.eatWhile(/[$_a-z0-9A-Z\.{:]/),e.eatWhile(/}/),s.beforeParams=!0,"builtin";if(r.test(l))return e.eatWhile(r),"comment";e.eatWhile(/[\w\$_{}]/);var c=e.current().toLowerCase();return t&&t.propertyIsEnumerable(c)?"keyword":n&&n.propertyIsEnumerable(c)?(s.beforeParams=!0,"keyword"):null}return i(e,s,o(l))}function o(e){return function(t,n){var r=!1,i,o=!1;while((i=t.next())!=null){if(i==e&&!r){o=!0;break}r=!r&&i=="\\"}return o&&(n.tokenize=s),"string"}}function u(e,t){var n=!1,r;while(r=e.next()){if(r=="#"&&n){t.tokenize=s;break}n=r=="*"}return"comment"}function a(e,t){var n=0,r;while(r=e.next()){if(r=="#"&&n==2){t.tokenize=s;break}r=="]"?n++:r!=" "&&(n=0)}return"meta"}var t=e("Tcl safe after append array auto_execok auto_import auto_load auto_mkindex auto_mkindex_old auto_qualify auto_reset bgerror binary break catch cd close concat continue dde eof encoding error eval exec exit expr fblocked fconfigure fcopy file fileevent filename filename flush for foreach format gets glob global history http if incr info interp join lappend lindex linsert list llength load lrange lreplace lsearch lset lsort memory msgcat namespace open package parray pid pkg::create pkg_mkIndex proc puts pwd re_syntax read regex regexp registry regsub rename resource return scan seek set socket source split string subst switch tcl_endOfWord tcl_findLibrary tcl_startOfNextWord tcl_wordBreakAfter tcl_startOfPreviousWord tcl_wordBreakBefore tcltest tclvars tell time trace unknown unset update uplevel upvar variable vwait"),n=e("if elseif else and not or eq ne in ni for foreach while switch"),r=/[+\-*&%=<>!?^\/\|]/;return{startState:function(){return{tokenize:s,beforeParams:!1,inParams:!1}},token:function(e,t){return e.eatSpace()?null:t.tokenize(e,t)}}}),e.defineMIME("text/x-tcl","tcl")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/tiddlywiki/tiddlywiki",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("tiddlywiki",function(){function d(e,t,n){return t.tokenize=n,n(e,t)}function g(e,t,n){return v=e,m=n,t}function y(t,h){var p=t.sol(),v;h.block=!1,v=t.peek();if(p&&/[<\/\*{}\-]/.test(v)){if(t.match(c))return h.block=!0,d(t,h,E);if(t.match(o))return g("quote","quote");if(t.match(i)||t.match(s))return g("code","comment");if(t.match(u)||t.match(a)||t.match(f)||t.match(l))return g("code","comment");if(t.match(r))return g("hr","hr")}v=t.next();if(p&&/[\/\*!#;:>|]/.test(v)){if(v=="!")return t.skipToEnd(),g("header","header");if(v=="*")return t.eatWhile("*"),g("list","comment");if(v=="#")return t.eatWhile("#"),g("list","comment");if(v==";")return t.eatWhile(";"),g("list","comment");if(v==":")return t.eatWhile(":"),g("list","comment");if(v==">")return t.eatWhile(">"),g("quote","quote");if(v=="|")return g("table","header")}if(v=="{"&&t.match(/\{\{/))return d(t,h,E);if(/[hf]/i.test(v)&&/[ti]/i.test(t.peek())&&t.match(/\b(ttps?|tp|ile):\/\/[\-A-Z0-9+&@#\/%?=~_|$!:,.;]*[A-Z0-9+&@#\/%=~_|$]/i))return g("link","link");if(v=='"')return g("string","string");if(v=="~")return g("text","brace");if(/[\[\]]/.test(v)&&t.peek()==v)return t.next(),g("brace","brace");if(v=="@")return t.eatWhile(n),g("link","link");if(/\d/.test(v))return t.eatWhile(/\d/),g("number","number");if(v=="/"){if(t.eat("%"))return d(t,h,b);if(t.eat("/"))return d(t,h,S)}if(v=="_"&&t.eat("_"))return d(t,h,x);if(v=="-"&&t.eat("-")){if(t.peek()!=" ")return d(t,h,T);if(t.peek()==" ")return g("text","brace")}if(v=="'"&&t.eat("'"))return d(t,h,w);if(v!="<")return g(v);if(t.eat("<"))return d(t,h,N);t.eatWhile(/[\w\$_]/);var m=t.current(),y=e.propertyIsEnumerable(m)&&e[m];return y?g(y.type,y.style,m):g("text",null,m)}function b(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=y;break}n=r=="%"}return g("comment","comment")}function w(e,t){var n=!1,r;while(r=e.next()){if(r=="'"&&n){t.tokenize=y;break}n=r=="'"}return g("text","strong")}function E(e,t){var n,r=t.block;return r&&e.current()?g("code","comment"):!r&&e.match(p)?(t.tokenize=y,g("code","comment")):r&&e.sol()&&e.match(h)?(t.tokenize=y,g("code","comment")):(n=e.next(),r?g("code","comment"):g("code","comment"))}function S(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=y;break}n=r=="/"}return g("text","em")}function x(e,t){var n=!1,r;while(r=e.next()){if(r=="_"&&n){t.tokenize=y;break}n=r=="_"}return g("text","underlined")}function T(e,t){var n=!1,r;while(r=e.next()){if(r=="-"&&n){t.tokenize=y;break}n=r=="-"}return g("text","strikethrough")}function N(e,n){var r,i,s;return e.current()=="<<"?g("brace","macro"):(r=e.next(),r?r==">"&&e.peek()==">"?(e.next(),n.tokenize=y,g("brace","macro")):(e.eatWhile(/[\w\$_]/),i=e.current(),s=t.propertyIsEnumerable(i)&&t[i],s?g(s.type,s.style,i):g("macro",null,i)):(n.tokenize=y,g(r)))}var e={},t=function(){function e(e){return{type:e,style:"macro"}}return{allTags:e("allTags"),closeAll:e("closeAll"),list:e("list"),newJournal:e("newJournal"),newTiddler:e("newTiddler"),permaview:e("permaview"),saveChanges:e("saveChanges"),search:e("search"),slider:e("slider"),tabs:e("tabs"),tag:e("tag"),tagging:e("tagging"),tags:e("tags"),tiddler:e("tiddler"),timeline:e("timeline"),today:e("today"),version:e("version"),option:e("option"),"with":e("with"),filter:e("filter")}}(),n=/[\w_\-]/i,r=/^\-\-\-\-+$/,i=/^\/\*\*\*$/,s=/^\*\*\*\/$/,o=/^<<<$/,u=/^\/\/\{\{\{$/,a=/^\/\/\}\}\}$/,f=/^<!--\{\{\{-->$/,l=/^<!--\}\}\}-->$/,c=/^\{\{\{$/,h=/^\}\}\}$/,p=/.*?\}\}\}/,v,m;return{startState:function(){return{tokenize:y,indented:0,level:0}},token:function(e,t){if(e.eatSpace())return null;var n=t.tokenize(e,t);return n},electricChars:""}}),e.defineMIME("text/x-tiddlywiki","tiddlywiki")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/tiki/tiki",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("tiki",function(e){function t(e,t,n){return function(i,s){while(!i.eol()){if(i.match(t)){s.tokenize=r;break}i.next()}return n&&(s.tokenize=n),e}}function n(e){return function(t,n){while(!t.eol())t.next();return n.tokenize=r,e}}function r(e,i){function s(t){return i.tokenize=t,t(e,i)}var o=e.sol(),a=e.next();switch(a){case"{":e.eat("/"),e.eatSpace();var f="",l;while(l=e.eat(/[^\s\u00a0=\"\'\/?(}]/))f+=l;return i.tokenize=u,"tag";case"_":if(e.eat("_"))return s(t("strong","__",r));break;case"'":if(e.eat("'"))return s(t("em","''",r));break;case"(":if(e.eat("("))return s(t("variable-2","))",r));break;case"[":return s(t("variable-3","]",r));case"|":if(e.eat("|"))return s(t("comment","||"));break;case"-":if(e.eat("="))return s(t("header string","=-",r));if(e.eat("-"))return s(t("error tw-deleted","--",r));break;case"=":if(e.match("=="))return s(t("tw-underline","===",r));break;case":":if(e.eat(":"))return s(t("comment","::"));break;case"^":return s(t("tw-box","^"));case"~":if(e.match("np~"))return s(t("meta","~/np~"))}if(o)switch(a){case"!":return e.match("!!!!!")?s(n("header string")):e.match("!!!!")?s(n("header string")):e.match("!!!")?s(n("header string")):e.match("!!")?s(n("header string")):s(n("header string"));case"*":case"#":case"+":return s(n("tw-listitem bracket"))}return null}function u(e,t){var n=e.next(),i=e.peek();return n=="}"?(t.tokenize=r,"tag"):n=="("||n==")"?"bracket":n=="="?(o="equals",i==">"&&(n=e.next(),i=e.peek()),/[\'\"]/.test(i)||(t.tokenize=f()),"operator"):/[\'\"]/.test(n)?(t.tokenize=a(n),t.tokenize(e,t)):(e.eatWhile(/[^\s\u00a0=\"\'\/?]/),"keyword")}function a(e){return function(t,n){while(!t.eol())if(t.next()==e){n.tokenize=u;break}return"string"}}function f(){return function(e,t){while(!e.eol()){var n=e.next(),r=e.peek();if(n==" "||n==","||/[ )}]/.test(r)){t.tokenize=u;break}}return"string"}}function h(){for(var e=arguments.length-1;e>=0;e--)l.cc.push(arguments[e])}function p(){return h.apply(null,arguments),!0}function d(e,t){var n=l.context&&l.context.noIndent;l.context={prev:l.context,pluginName:e,indent:l.indented,startOfLine:t,noIndent:n}}function v(){l.context&&(l.context=l.context.prev)}function m(e){if(e=="openPlugin")return l.pluginName=s,p(b,g(l.startOfLine));if(e=="closePlugin"){var t=!1;return l.context?(t=l.context.pluginName!=s,v()):t=!0,t&&(c="error"),p(y(t))}return e=="string"?((!l.context||l.context.name!="!cdata")&&d("!cdata"),l.tokenize==r&&v(),p()):p()}function g(e){return function(t){return t=="selfclosePlugin"||t=="endPlugin"?p():t=="endPlugin"?(d(l.pluginName,e),p()):p()}}function y(e){return function(t){return e&&(c="error"),t=="endPlugin"?p():h()}}function b(e){return e=="keyword"?(c="attribute",p(b)):e=="equals"?p(w,b):h()}function w(e){return e=="keyword"?(c="string",p()):e=="string"?p(E):h()}function E(e){return e=="string"?p(E):h()}var i=e.indentUnit,s,o,l,c;return{startState:function(){return{tokenize:r,cc:[],indented:0,startOfLine:!0,pluginName:null,context:null}},token:function(e,t){e.sol()&&(t.startOfLine=!0,t.indented=e.indentation());if(e.eatSpace())return null;c=o=s=null;var n=t.tokenize(e,t);if((n||o)&&n!="comment"){l=t;for(;;){var r=t.cc.pop()||m;if(r(o||n))break}}return t.startOfLine=!1,c||n},indent:function(e,t){var n=e.context;if(n&&n.noIndent)return 0;n&&/^{\//.test(t)&&(n=n.prev);while(n&&!n.startOfLine)n=n.prev;return n?n.indent+i:0},electricChars:"/"}}),e.defineMIME("text/tiki","tiki")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/toml/toml",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("toml",function(){return{startState:function(){return{inString:!1,stringType:"",lhs:!0,inArray:0}},token:function(e,t){!t.inString&&(e.peek()=='"'||e.peek()=="'")&&(t.stringType=e.peek(),e.next(),t.inString=!0),e.sol()&&t.inArray===0&&(t.lhs=!0);if(t.inString){while(t.inString&&!e.eol())e.peek()===t.stringType?(e.next(),t.inString=!1):e.peek()==="\\"?(e.next(),e.next()):e.match(/^.[^\\\"\']*/);return t.lhs?"property string":"string"}return t.inArray&&e.peek()==="]"?(e.next(),t.inArray--,"bracket"):t.lhs&&e.peek()==="["&&e.skipTo("]")?(e.next(),e.peek()==="]"&&e.next(),"atom"):e.peek()==="#"?(e.skipToEnd(),"comment"):e.eatSpace()?null:t.lhs&&e.eatWhile(function(e){return e!="="&&e!=" "})?"property":t.lhs&&e.peek()==="="?(e.next(),t.lhs=!1,null):!t.lhs&&e.match(/^\d\d\d\d[\d\-\:\.T]*Z/)?"atom":!t.lhs&&(e.match("true")||e.match("false"))?"atom":!t.lhs&&e.peek()==="["?(t.inArray++,e.next(),"bracket"):!t.lhs&&e.match(/^\-?\d+(?:\.\d+)?/)?"number":(e.eatSpace()||e.next(),null)}}}),e.defineMIME("text/x-toml","toml")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/turtle/turtle",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("turtle",function(e){function r(e){return new RegExp("^(?:"+e.join("|")+")$","i")}function u(e,t){var r=e.next();n=null;if(r=="<"&&!e.match(/^[\s\u00a0=]/,!1))return e.match(/^[^\s\u00a0>]*>?/),"atom";if(r=='"'||r=="'")return t.tokenize=a(r),t.tokenize(e,t);if(/[{}\(\),\.;\[\]]/.test(r))return n=r,null;if(r=="#")return e.skipToEnd(),"comment";if(o.test(r))return e.eatWhile(o),null;if(r==":")return"operator";e.eatWhile(/[_\w\d]/);if(e.peek()==":")return"variable-3";var u=e.current();return s.test(u)?"meta":r>="A"&&r<="Z"?"comment":"keyword";var u}function a(e){return function(t,n){var r=!1,i;while((i=t.next())!=null){if(i==e&&!r){n.tokenize=u;break}r=!r&&i=="\\"}return"string"}}function f(e,t,n){e.context={prev:e.context,indent:e.indent,col:n,type:t}}function l(e){e.indent=e.context.indent,e.context=e.context.prev}var t=e.indentUnit,n,i=r([]),s=r(["@prefix","@base","a"]),o=/[*+\-<>=&|]/;return{startState:function(){return{tokenize:u,context:null,indent:0,col:0}},token:function(e,t){e.sol()&&(t.context&&t.context.align==null&&(t.context.align=!1),t.indent=e.indentation());if(e.eatSpace())return null;var r=t.tokenize(e,t);r!="comment"&&t.context&&t.context.align==null&&t.context.type!="pattern"&&(t.context.align=!0);if(n=="(")f(t,")",e.column());else if(n=="[")f(t,"]",e.column());else if(n=="{")f(t,"}",e.column());else if(/[\]\}\)]/.test(n)){while(t.context&&t.context.type=="pattern")l(t);t.context&&n==t.context.type&&l(t)}else n=="."&&t.context&&t.context.type=="pattern"?l(t):/atom|string|variable/.test(r)&&t.context&&(/[\}\]]/.test(t.context.type)?f(t,"pattern",e.column()):t.context.type=="pattern"&&!t.context.align&&(t.context.align=!0,t.context.col=e.column()));return r},indent:function(e,n){var r=n&&n.charAt(0),i=e.context;if(/[\]\}]/.test(r))while(i&&i.type=="pattern")i=i.prev;var s=i&&r==i.type;return i?i.type=="pattern"?i.col:i.align?i.col+(s?0:1):i.indent+(s?0:t):0}}}),e.defineMIME("text/turtle","turtle")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/vb/vb",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("vb",function(e,t){function r(e){return new RegExp("^(("+e.join(")|(")+"))\\b","i")}function N(e,t){t.currentIndent++}function C(e,t){t.currentIndent--}function k(e,t){if(e.eatSpace())return null;var r=e.peek();if(r==="'")return e.skipToEnd(),"comment";if(e.match(/^((&H)|(&O))?[0-9\.a-f]/i,!1)){var l=!1;e.match(/^\d*\.\d+F?/i)?l=!0:e.match(/^\d+\.\d*F?/)?l=!0:e.match(/^\.\d+F?/)&&(l=!0);if(l)return e.eat(/J/i),"number";var c=!1;e.match(/^&H[0-9a-f]+/i)?c=!0:e.match(/^&O[0-7]+/i)?c=!0:e.match(/^[1-9]\d*F?/)?(e.eat(/J/i),c=!0):e.match(/^0(?![\dx])/i)&&(c=!0);if(c)return e.eat(/L/i),"number"}return e.match(y)?(t.tokenize=L(e.current()),t.tokenize(e,t)):e.match(a)||e.match(u)?null:e.match(o)||e.match(i)||e.match(p)?"operator":e.match(s)?null:e.match(x)?(N(e,t),t.doInCurrentLine=!0,"keyword"):e.match(b)?(t.doInCurrentLine?t.doInCurrentLine=!1:N(e,t),"keyword"):e.match(w)?"keyword":e.match(S)?(C(e,t),C(e,t),"keyword"):e.match(E)?(C(e,t),"keyword"):e.match(g)?"keyword":e.match(m)?"keyword":e.match(f)?"variable":(e.next(),n)}function L(e){var r=e.length==1,i="string";return function(s,o){while(!s.eol()){s.eatWhile(/[^'"]/);if(s.match(e))return o.tokenize=k,i;s.eat(/['"]/)}if(r){if(t.singleLineStringErrors)return n;o.tokenize=k}return i}}function A(e,t){var r=t.tokenize(e,t),i=e.current();if(i===".")return r=t.tokenize(e,t),i=e.current(),r==="variable"?"variable":n;var s="[({".indexOf(i);return s!==-1&&N(e,t),T==="dedent"&&C(e,t)?n:(s="])}".indexOf(i),s!==-1&&C(e,t)?n:r)}var n="error",i=new RegExp("^[\\+\\-\\*/%&\\\\|\\^~<>!]"),s=new RegExp("^[\\(\\)\\[\\]\\{\\}@,:`=;\\.]"),o=new RegExp("^((==)|(<>)|(<=)|(>=)|(<>)|(<<)|(>>)|(//)|(\\*\\*))"),u=new RegExp("^((\\+=)|(\\-=)|(\\*=)|(%=)|(/=)|(&=)|(\\|=)|(\\^=))"),a=new RegExp("^((//=)|(>>=)|(<<=)|(\\*\\*=))"),f=new RegExp("^[_A-Za-z][_A-Za-z0-9]*"),l=["class","module","sub","enum","select","while","if","function","get","set","property","try"],c=["else","elseif","case","catch"],h=["next","loop"],p=r(["and","or","not","xor","in"]),d=["as","dim","break","continue","optional","then","until","goto","byval","byref","new","handles","property","return","const","private","protected","friend","public","shared","static","true","false"],v=["integer","string","double","decimal","boolean","short","char","float","single"],m=r(d),g=r(v),y='"',b=r(l),w=r(c),E=r(h),S=r(["end"]),x=r(["do"]),T=null,O={electricChars:"dDpPtTfFeE ",startState:function(){return{tokenize:k,lastToken:null,currentIndent:0,nextLineIndent:0,doInCurrentLine:!1}},token:function(e,t){e.sol()&&(t.currentIndent+=t.nextLineIndent,t.nextLineIndent=0,t.doInCurrentLine=0);var n=A(e,t);return t.lastToken={style:n,content:e.current()},n},indent:function(t,n){var r=n.replace(/^\s+|\s+$/g,"");return r.match(E)||r.match(S)||r.match(w)?e.indentUnit*(t.currentIndent-1):t.currentIndent<0?0:t.currentIndent*e.indentUnit}};return O}),e.defineMIME("text/x-vb","vb")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/vbscript/vbscript",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("vbscript",function(e,t){function r(e){return new RegExp("^(("+e.join(")|(")+"))\\b","i")}function j(e,t){t.currentIndent++}function F(e,t){t.currentIndent--}function I(e,t){if(e.eatSpace())return"space";var r=e.peek();if(r==="'")return e.skipToEnd(),"comment";if(e.match(B))return e.skipToEnd(),"comment";if(e.match(/^((&H)|(&O))?[0-9\.]/i,!1)&&!e.match(/^((&H)|(&O))?[0-9\.]+[a-z_]/i,!1)){var f=!1;e.match(/^\d*\.\d+/i)?f=!0:e.match(/^\d+\.\d*/)?f=!0:e.match(/^\.\d+/)&&(f=!0);if(f)return e.eat(/J/i),"number";var l=!1;e.match(/^&H[0-9a-f]+/i)?l=!0:e.match(/^&O[0-7]+/i)?l=!0:e.match(/^[1-9]\d*F?/)?(e.eat(/J/i),l=!0):e.match(/^0(?![\dx])/i)&&(l=!0);if(l)return e.eat(/L/i),"number"}return e.match(A)?(t.tokenize=q(e.current()),t.tokenize(e,t)):e.match(s)||e.match(i)||e.match(h)?"operator":e.match(o)?null:e.match(u)?"bracket":e.match(H)?(t.doInCurrentLine=!0,"keyword"):e.match(P)?(j(e,t),t.doInCurrentLine=!0,"keyword"):e.match(O)?(t.doInCurrentLine?t.doInCurrentLine=!1:j(e,t),"keyword"):e.match(M)?"keyword":e.match(D)?(F(e,t),F(e,t),"keyword"):e.match(_)?(t.doInCurrentLine?t.doInCurrentLine=!1:F(e,t),"keyword"):e.match(T)?"keyword":e.match(N)?"atom":e.match(L)?"variable-2":e.match(C)?"builtin":e.match(k)?"variable-2":e.match(a)?"variable":(e.next(),n)}function q(e){var r=e.length==1,i="string";return function(s,o){while(!s.eol()){s.eatWhile(/[^'"]/);if(s.match(e))return o.tokenize=I,i;s.eat(/['"]/)}if(r){if(t.singleLineStringErrors)return n;o.tokenize=I}return i}}function R(e,t){var r=t.tokenize(e,t),i=e.current();if(i==="."){r=t.tokenize(e,t),i=e.current();if(r.substr(0,8)==="variable"||r==="builtin"||r==="keyword"){if(r==="builtin"||r==="keyword")r="variable";return x.indexOf(i.substr(1))>-1&&(r="variable-2"),r}return n}return r}var n="error",i=new RegExp("^[\\+\\-\\*/&\\\\\\^<>=]"),s=new RegExp("^((<>)|(<=)|(>=))"),o=new RegExp("^[\\.,]"),u=new RegExp("^[\\(\\)]"),a=new RegExp("^[A-Za-z][_A-Za-z0-9]*"),f=["class","sub","select","while","if","function","property","with","for"],l=["else","elseif","case"],c=["next","loop","wend"],h=r(["and","or","not","xor","is","mod","eqv","imp"]),p=["dim","redim","then","until","randomize","byval","byref","new","property","exit","in","const","private","public","get","set","let","stop","on error resume next","on error goto 0","option explicit","call","me"],d=["true","false","nothing","empty","null"],v=["abs","array","asc","atn","cbool","cbyte","ccur","cdate","cdbl","chr","cint","clng","cos","csng","cstr","date","dateadd","datediff","datepart","dateserial","datevalue","day","escape","eval","execute","exp","filter","formatcurrency","formatdatetime","formatnumber","formatpercent","getlocale","getobject","getref","hex","hour","inputbox","instr","instrrev","int","fix","isarray","isdate","isempty","isnull","isnumeric","isobject","join","lbound","lcase","left","len","loadpicture","log","ltrim","rtrim","trim","maths","mid","minute","month","monthname","msgbox","now","oct","replace","rgb","right","rnd","round","scriptengine","scriptenginebuildversion","scriptenginemajorversion","scriptengineminorversion","second","setlocale","sgn","sin","space","split","sqr","strcomp","string","strreverse","tan","time","timer","timeserial","timevalue","typename","ubound","ucase","unescape","vartype","weekday","weekdayname","year"],m=["vbBlack","vbRed","vbGreen","vbYellow","vbBlue","vbMagenta","vbCyan","vbWhite","vbBinaryCompare","vbTextCompare","vbSunday","vbMonday","vbTuesday","vbWednesday","vbThursday","vbFriday","vbSaturday","vbUseSystemDayOfWeek","vbFirstJan1","vbFirstFourDays","vbFirstFullWeek","vbGeneralDate","vbLongDate","vbShortDate","vbLongTime","vbShortTime","vbObjectError","vbOKOnly","vbOKCancel","vbAbortRetryIgnore","vbYesNoCancel","vbYesNo","vbRetryCancel","vbCritical","vbQuestion","vbExclamation","vbInformation","vbDefaultButton1","vbDefaultButton2","vbDefaultButton3","vbDefaultButton4","vbApplicationModal","vbSystemModal","vbOK","vbCancel","vbAbort","vbRetry","vbIgnore","vbYes","vbNo","vbCr","VbCrLf","vbFormFeed","vbLf","vbNewLine","vbNullChar","vbNullString","vbTab","vbVerticalTab","vbUseDefault","vbTrue","vbFalse","vbEmpty","vbNull","vbInteger","vbLong","vbSingle","vbDouble","vbCurrency","vbDate","vbString","vbObject","vbError","vbBoolean","vbVariant","vbDataObject","vbDecimal","vbByte","vbArray"],g=["WScript","err","debug","RegExp"],y=["description","firstindex","global","helpcontext","helpfile","ignorecase","length","number","pattern","source","value","count"],b=["clear","execute","raise","replace","test","write","writeline","close","open","state","eof","update","addnew","end","createobject","quit"],w=["server","response","request","session","application"],E=["buffer","cachecontrol","charset","contenttype","expires","expiresabsolute","isclientconnected","pics","status","clientcertificate","cookies","form","querystring","servervariables","totalbytes","contents","staticobjects","codepage","lcid","sessionid","timeout","scripttimeout"],S=["addheader","appendtolog","binarywrite","end","flush","redirect","binaryread","remove","removeall","lock","unlock","abandon","getlasterror","htmlencode","mappath","transfer","urlencode"],x=b.concat(y);g=g.concat(m),e.isASP&&(g=g.concat(w),x=x.concat(S,E));var T=r(p),N=r(d),C=r(v),k=r(g),L=r(x),A='"',O=r(f),M=r(l),_=r(c),D=r(["end"]),P=r(["do"]),H=r(["on error resume next","exit"]),B=r(["rem"]),U={electricChars:"dDpPtTfFeE ",startState:function(){return{tokenize:I,lastToken:null,currentIndent:0,nextLineIndent:0,doInCurrentLine:!1,ignoreKeyword:!1}},token:function(e,t){e.sol()&&(t.currentIndent+=t.nextLineIndent,t.nextLineIndent=0,t.doInCurrentLine=0);var n=R(e,t);return t.lastToken={style:n,content:e.current()},n==="space"&&(n=null),n},indent:function(t,n){var r=n.replace(/^\s+|\s+$/g,"");return r.match(_)||r.match(D)||r.match(M)?e.indentUnit*(t.currentIndent-1):t.currentIndent<0?0:t.currentIndent*e.indentUnit}};return U}),e.defineMIME("text/vbscript","vbscript")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/velocity/velocity",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("velocity",function(){function e(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function s(e,t,n){return t.tokenize=n,n(e,t)}function o(e,o){var l=o.beforeParams;o.beforeParams=!1;var c=e.next();if(c=="'"&&o.inParams)return o.lastTokenWasBuiltin=!1,s(e,o,u(c));if(c!='"'){if(/[\[\]{}\(\),;\.]/.test(c))return c=="("&&l?o.inParams=!0:c==")"&&(o.inParams=!1,o.lastTokenWasBuiltin=!0),null;if(/\d/.test(c))return o.lastTokenWasBuiltin=!1,e.eatWhile(/[\w\.]/),"number";if(c=="#"&&e.eat("*"))return o.lastTokenWasBuiltin=!1,s(e,o,a);if(c=="#"&&e.match(/ *\[ *\[/))return o.lastTokenWasBuiltin=!1,s(e,o,f);if(c=="#"&&e.eat("#"))return o.lastTokenWasBuiltin=!1,e.skipToEnd(),"comment";if(c=="$")return e.eatWhile(/[\w\d\$_\.{}]/),r&&r.propertyIsEnumerable(e.current())?"keyword":(o.lastTokenWasBuiltin=!0,o.beforeParams=!0,"builtin");if(i.test(c))return o.lastTokenWasBuiltin=!1,e.eatWhile(i),"operator";e.eatWhile(/[\w\$_{}@]/);var h=e.current();return t&&t.propertyIsEnumerable(h)?"keyword":n&&n.propertyIsEnumerable(h)||e.current().match(/^#@?[a-z0-9_]+ *$/i)&&e.peek()=="("&&(!n||!n.propertyIsEnumerable(h.toLowerCase()))?(o.beforeParams=!0,o.lastTokenWasBuiltin=!1,"keyword"):o.inString?(o.lastTokenWasBuiltin=!1,"string"):e.pos>h.length&&e.string.charAt(e.pos-h.length-1)=="."&&o.lastTokenWasBuiltin?"builtin":(o.lastTokenWasBuiltin=!1,null)}o.lastTokenWasBuiltin=!1;if(o.inString)return o.inString=!1,"string";if(o.inParams)return s(e,o,u(c))}function u(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}if(e=='"'&&t.peek()=="$"&&!r){n.inString=!0,s=!0;break}r=!r&&i=="\\"}return s&&(n.tokenize=o),"string"}}function a(e,t){var n=!1,r;while(r=e.next()){if(r=="#"&&n){t.tokenize=o;break}n=r=="*"}return"comment"}function f(e,t){var n=0,r;while(r=e.next()){if(r=="#"&&n==2){t.tokenize=o;break}r=="]"?n++:r!=" "&&(n=0)}return"meta"}var t=e("#end #else #break #stop #[[ #]] #{end} #{else} #{break} #{stop}"),n=e("#if #elseif #foreach #set #include #parse #macro #define #evaluate #{if} #{elseif} #{foreach} #{set} #{include} #{parse} #{macro} #{define} #{evaluate}"),r=e("$foreach.count $foreach.hasNext $foreach.first $foreach.last $foreach.topmost $foreach.parent.count $foreach.parent.hasNext $foreach.parent.first $foreach.parent.last $foreach.parent $velocityCount $!bodyContent $bodyContent"),i=/[+\-*&%=<>!?:\/|]/;return{startState:function(){return{tokenize:o,beforeParams:!1,inParams:!1,inString:!1,lastTokenWasBuiltin:!1}},token:function(e,t){return e.eatSpace()?null:t.tokenize(e,t)},blockCommentStart:"#*",blockCommentEnd:"*#",lineComment:"##",fold:"velocity"}}),e.defineMIME("text/velocity","velocity")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/verilog/verilog",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("verilog",function(t,n){function a(e){var t={},n=e.split(" ");for(var r=0;r<n.length;++r)t[n[r]]=!0;return t}function k(e,t){var n=e.peek();if(/[,;:\.]/.test(n))return w=e.next(),null;if(c.test(n))return w=e.next(),"bracket";if(n=="`")return e.next(),e.eatWhile(/[\w\$_]/)?"def":null;if(n=="$")return e.next(),e.eatWhile(/[\w\$_]/)?"meta":null;if(n=="#")return e.next(),e.eatWhile(/[\d_.]/),"def";if(n=='"')return e.next(),t.tokenize=L(n),t.tokenize(e,t);if(n=="/"){e.next();if(e.eat("*"))return t.tokenize=A,A(e,t);if(e.eat("/"))return e.skipToEnd(),"comment";e.backUp(1)}if(e.match(g)||e.match(p)||e.match(d)||e.match(v)||e.match(m)||e.match(h)||e.match(g))return"number";if(e.eatWhile(l))return"meta";if(e.eatWhile(/[\w\$_]/)){var r=e.current();return f[r]?(x[r]&&(w="newblock"),C[r]&&(w="newstatement"),E=r,"keyword"):"variable"}return e.next(),null}function L(e){return function(t,n){var r=!1,i,s=!1;while((i=t.next())!=null){if(i==e&&!r){s=!0;break}r=!r&&i=="\\"}if(s||!r&&!u)n.tokenize=k;return"string"}}function A(e,t){var n=!1,r;while(r=e.next()){if(r=="/"&&n){t.tokenize=k;break}n=r=="*"}return"comment"}function O(e,t,n,r,i){this.indented=e,this.column=t,this.type=n,this.align=r,this.prev=i}function M(e,t,n){var r=e.indented,i=new O(r,t,n,null,e.context);return e.context=i}function _(e){var t=e.context.type;if(t==")"||t=="]"||t=="}")e.indented=e.context.indented;return e.context=e.context.prev}function D(e,t){if(e==t)return!0;var n=t.split(";");for(var r in n)if(e==n[r])return!0;return!1}function P(){var e=[];for(var t in x)if(x[t]){var n=x[t].split(";");for(var r in n)e.push(n[r])}var i=new RegExp("[{}()\\[\\]]|("+e.join("|")+")$");return i}var r=t.indentUnit,i=n.statementIndentUnit||r,s=n.dontAlignCalls,o=n.noIndentKeywords||[],u=n.multiLineStrings,f=a("accept_on alias always always_comb always_ff always_latch and assert assign assume automatic before begin bind bins binsof bit break buf bufif0 bufif1 byte case casex casez cell chandle checker class clocking cmos config const constraint context continue cover covergroup coverpoint cross deassign default defparam design disable dist do edge else end endcase endchecker endclass endclocking endconfig endfunction endgenerate endgroup endinterface endmodule endpackage endprimitive endprogram endproperty endspecify endsequence endtable endtask enum event eventually expect export extends extern final first_match for force foreach forever fork forkjoin function generate genvar global highz0 highz1 if iff ifnone ignore_bins illegal_bins implements implies import incdir include initial inout input inside instance int integer interconnect interface intersect join join_any join_none large let liblist library local localparam logic longint macromodule matches medium modport module nand negedge nettype new nexttime nmos nor noshowcancelled not notif0 notif1 null or output package packed parameter pmos posedge primitive priority program property protected pull0 pull1 pulldown pullup pulsestyle_ondetect pulsestyle_onevent pure rand randc randcase randsequence rcmos real realtime ref reg reject_on release repeat restrict return rnmos rpmos rtran rtranif0 rtranif1 s_always s_eventually s_nexttime s_until s_until_with scalared sequence shortint shortreal showcancelled signed small soft solve specify specparam static string strong strong0 strong1 struct super supply0 supply1 sync_accept_on sync_reject_on table tagged task this throughout time timeprecision timeunit tran tranif0 tranif1 tri tri0 tri1 triand trior trireg type typedef union unique unique0 unsigned until until_with untyped use uwire var vectored virtual void wait wait_order wand weak weak0 weak1 while wildcard wire with within wor xnor xor"),l=/[\+\-\*\/!~&|^%=?:]/,c=/[\[\]{}()]/,h=/\d[0-9_]*/,p=/\d*\s*'s?d\s*\d[0-9_]*/i,d=/\d*\s*'s?b\s*[xz01][xz01_]*/i,v=/\d*\s*'s?o\s*[xz0-7][xz0-7_]*/i,m=/\d*\s*'s?h\s*[0-9a-fxz?][0-9a-fxz?_]*/i,g=/(\d[\d_]*(\.\d[\d_]*)?E-?[\d_]+)|(\d[\d_]*\.\d[\d_]*)/i,y=/^((\w+)|[)}\]])/,b=/[)}\]]/,w,E,S=a("case checker class clocking config function generate group interface module packageprimitive program property specify sequence table task"),x={};for(var T in S)x[T]="end"+T;x.begin="end",x.casex="endcase",x.casez="endcase",x["do"]="while",x.fork="join;join_any;join_none";for(var N in o){var T=o[N];x[T]&&(x[T]=undefined)}var C=a("always always_comb always_ff always_latch assert assign assume else for foreach forever if initial repeat while");return{electricInput:P(),startState:function(e){return{tokenize:null,context:new O((e||0)-r,0,"top",!1),indented:0,startOfLine:!0}},token:function(e,t){var n=t.context;e.sol()&&(n.align==null&&(n.align=!1),t.indented=e.indentation(),t.startOfLine=!0);if(e.eatSpace())return null;w=null,E=null;var r=(t.tokenize||k)(e,t);if(r=="comment"||r=="meta"||r=="variable")return r;n.align==null&&(n.align=!0);if(w==n.type)_(t);else if(w==";"&&n.type=="statement"||n.type&&D(E,n.type)){n=_(t);while(n&&n.type=="statement")n=_(t)}else if(w=="{")M(t,e.column(),"}");else if(w=="[")M(t,e.column(),"]");else if(w=="(")M(t,e.column(),")");else if(n&&n.type=="endcase"&&w==":")M(t,e.column(),"statement");else if(w=="newstatement")M(t,e.column(),"statement");else if(w=="newblock"){var i=x[E];M(t,e.column(),i)}return t.startOfLine=!1,r},indent:function(t,n){if(t.tokenize!=k&&t.tokenize!=null)return e.Pass;var o=t.context,u=n&&n.charAt(0);o.type=="statement"&&u=="}"&&(o=o.prev);var a=!1,f=n.match(y);return f&&(a=D(f[0],o.type)),o.type=="statement"?o.indented+(u=="{"?0:i):b.test(o.type)&&o.align&&!s?o.column+(a?0:1):o.type==")"&&!a?o.indented+i:o.indented+(a?0:r)},blockCommentStart:"/*",blockCommentEnd:"*/",lineComment:"//"}}),e.defineMIME("text/x-verilog",{name:"verilog"}),e.defineMIME("text/x-systemverilog",{name:"systemverilog"})}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/xquery/xquery",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("xquery",function(){function r(e,r,i){return t=e,n=i,r}function i(e,t,n){return t.tokenize=n,n(e,t)}function s(t,n){var s=t.next(),l=!1,v=y(t);if(s=="<"){if(t.match("!--",!0))return i(t,n,c);if(t.match("![CDATA",!1))return n.tokenize=h,r("tag","tag");if(t.match("?",!1))return i(t,n,p);var g=t.eat("/");t.eatSpace();var b="",S;while(S=t.eat(/[^\s\u00a0=<>\"\'\/?]/))b+=S;return i(t,n,f(b,g))}if(s=="{")return w(n,{type:"codeblock"}),r("",null);if(s=="}")return E(n),r("",null);if(d(n))return s==">"?r("tag","tag"):s=="/"&&t.eat(">")?(E(n),r("tag","tag")):r("word","variable");if(/\d/.test(s))return t.match(/^\d*(?:\.\d*)?(?:E[+\-]?\d+)?/),r("number","atom");if(s==="("&&t.eat(":"))return w(n,{type:"comment"}),i(t,n,o);if(!!v||s!=='"'&&s!=="'"){if(s==="$")return i(t,n,a);if(s===":"&&t.eat("="))return r("operator","keyword");if(s==="(")return w(n,{type:"paren"}),r("",null);if(s===")")return E(n),r("",null);if(s==="[")return w(n,{type:"bracket"}),r("",null);if(s==="]")return E(n),r("",null);var x=e.propertyIsEnumerable(s)&&e[s];if(v&&s==='"')while(t.next()!=='"');if(v&&s==="'")while(t.next()!=="'");x||t.eatWhile(/[\w\$_-]/);var T=t.eat(":");!t.eat(":")&&T&&t.eatWhile(/[\w\$_-]/),t.match(/^[ \t]*\(/,!1)&&(l=!0);var N=t.current();return x=e.propertyIsEnumerable(N)&&e[N],l&&!x&&(x={type:"function_call",style:"variable def"}),m(n)?(E(n),r("word","variable",N)):((N=="element"||N=="attribute"||x.type=="axis_specifier")&&w(n,{type:"xmlconstructor"}),x?r(x.type,x.style,N):r("word","variable",N))}return i(t,n,u(s))}function o(e,t){var n=!1,i=!1,s=0,o;while(o=e.next()){if(o==")"&&n){if(!(s>0)){E(t);break}s--}else o==":"&&i&&s++;n=o==":",i=o=="("}return r("comment","comment")}function u(e,t){return function(n,i){var o;if(g(i)&&n.current()==e)return E(i),t&&(i.tokenize=t),r("string","string");w(i,{type:"string",name:e,tokenize:u(e,t)});if(n.match("{",!1)&&v(i))return i.tokenize=s,r("string","string");while(o=n.next()){if(o==e){E(i),t&&(i.tokenize=t);break}if(n.match("{",!1)&&v(i))return i.tokenize=s,r("string","string")}return r("string","string")}}function a(e,t){var n=/[\w\$_-]/;if(e.eat('"')){while(e.next()!=='"');e.eat(":")}else e.eatWhile(n),e.match(":=",!1)||e.eat(":");return e.eatWhile(n),t.tokenize=s,r("variable","variable")}function f(e,t){return function(n,i){return n.eatSpace(),t&&n.eat(">")?(E(i),i.tokenize=s,r("tag","tag")):(n.eat("/")||w(i,{type:"tag",name:e,tokenize:s}),n.eat(">")?(i.tokenize=s,r("tag","tag")):(i.tokenize=l,r("tag","tag")))}}function l(e,t){var n=e.next();if(n=="/"&&e.eat(">"))return v(t)&&E(t),d(t)&&E(t),r("tag","tag");if(n==">")return v(t)&&E(t),r("tag","tag");if(n=="=")return r("",null);if(n=='"'||n=="'")return i(e,t,u(n,l));v(t)||w(t,{type:"attribute",tokenize:l}),e.eat(/[a-zA-Z_:]/),e.eatWhile(/[-a-zA-Z0-9_:.]/),e.eatSpace();if(e.match(">",!1)||e.match("/",!1))E(t),t.tokenize=s;return r("attribute","attribute")}function c(e,t){var n;while(n=e.next())if(n=="-"&&e.match("->",!0))return t.tokenize=s,r("comment","comment")}function h(e,t){var n;while(n=e.next())if(n=="]"&&e.match("]",!0))return t.tokenize=s,r("comment","comment")}function p(e,t){var n;while(n=e.next())if(n=="?"&&e.match(">",!0))return t.tokenize=s,r("comment","comment meta")}function d(e){return b(e,"tag")}function v(e){return b(e,"attribute")}function m(e){return b(e,"xmlconstructor")}function g(e){return b(e,"string")}function y(e){return e.current()==='"'?e.match(/^[^\"]+\"\:/,!1):e.current()==="'"?e.match(/^[^\"]+\'\:/,!1):!1}function b(e,t){return e.stack.length&&e.stack[e.stack.length-1].type==t}function w(e,t){e.stack.push(t)}function E(e){e.stack.pop();var t=e.stack.length&&e.stack[e.stack.length-1].tokenize;e.tokenize=t||s}var e=function(){function e(e){return{type:e,style:"keyword"}}var t=e("keyword a"),n=e("keyword b"),r=e("keyword c"),i=e("operator"),s={type:"atom",style:"atom"},o={type:"punctuation",style:null},u={type:"axis_specifier",style:"qualifier"},a={"if":t,"switch":t,"while":t,"for":t,"else":n,then:n,"try":n,"finally":n,"catch":n,element:r,attribute:r,let:r,"implements":r,"import":r,module:r,namespace:r,"return":r,"super":r,"this":r,"throws":r,where:r,"private":r,",":o,"null":s,"fn:false()":s,"fn:true()":s},f=["after","ancestor","ancestor-or-self","and","as","ascending","assert","attribute","before","by","case","cast","child","comment","declare","default","define","descendant","descendant-or-self","descending","document","document-node","element","else","eq","every","except","external","following","following-sibling","follows","for","function","if","import","in","instance","intersect","item","let","module","namespace","node","node","of","only","or","order","parent","precedes","preceding","preceding-sibling","processing-instruction","ref","return","returns","satisfies","schema","schema-element","self","some","sortby","stable","text","then","to","treat","typeswitch","union","variable","version","where","xquery","empty-sequence"];for(var l=0,c=f.length;l<c;l++)a[f[l]]=e(f[l]);var h=["xs:string","xs:float","xs:decimal","xs:double","xs:integer","xs:boolean","xs:date","xs:dateTime","xs:time","xs:duration","xs:dayTimeDuration","xs:time","xs:yearMonthDuration","numeric","xs:hexBinary","xs:base64Binary","xs:anyURI","xs:QName","xs:byte","xs:boolean","xs:anyURI","xf:yearMonthDuration"];for(var l=0,c=h.length;l<c;l++)a[h[l]]=s;var p=["eq","ne","lt","le","gt","ge",":=","=",">",">=","<","<=",".","|","?","and","or","div","idiv","mod","*","/","+","-"];for(var l=0,c=p.length;l<c;l++)a[p[l]]=i;var d=["self::","attribute::","child::","descendant::","descendant-or-self::","parent::","ancestor::","ancestor-or-self::","following::","preceding::","following-sibling::","preceding-sibling::"];for(var l=0,c=d.length;l<c;l++)a[d[l]]=u;return a}(),t,n;return{startState:function(){return{tokenize:s,cc:[],stack:[]}},token:function(e,t){if(e.eatSpace())return null;var n=t.tokenize(e,t);return n},blockCommentStart:"(:",blockCommentEnd:":)"}}),e.defineMIME("application/xquery","xquery")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/yaml/yaml",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("yaml",function(){var e=["true","false","on","off","yes","no"],t=new RegExp("\\b(("+e.join(")|(")+"))$","i");return{token:function(e,n){var r=e.peek(),i=n.escaped;n.escaped=!1;if(r!="#"||e.pos!=0&&!/\s/.test(e.string.charAt(e.pos-1))){if(n.literal&&e.indentation()>n.keyCol)return e.skipToEnd(),"string";n.literal&&(n.literal=!1);if(e.sol()){n.keyCol=0,n.pair=!1,n.pairStart=!1;if(e.match(/---/))return"def";if(e.match(/\.\.\./))return"def";if(e.match(/\s*-\s+/))return"meta"}if(e.match(/^(\{|\}|\[|\])/))return r=="{"?n.inlinePairs++:r=="}"?n.inlinePairs--:r=="["?n.inlineList++:n.inlineList--,"meta";if(n.inlineList>0&&!i&&r==",")return e.next(),"meta";if(n.inlinePairs>0&&!i&&r==",")return n.keyCol=0,n.pair=!1,n.pairStart=!1,e.next(),"meta";if(n.pairStart){if(e.match(/^\s*(\||\>)\s*/))return n.literal=!0,"meta";if(e.match(/^\s*(\&|\*)[a-z0-9\._-]+\b/i))return"variable-2";if(n.inlinePairs==0&&e.match(/^\s*-?[0-9\.\,]+\s?$/))return"number";if(n.inlinePairs>0&&e.match(/^\s*-?[0-9\.\,]+\s?(?=(,|}))/))return"number";if(e.match(t))return"keyword"}return!n.pair&&e.match(/^\s*\S+(?=\s*:($|\s))/i)?(n.pair=!0,n.keyCol=e.indentation(),"atom"):n.pair&&e.match(/^:\s*/)?(n.pairStart=!0,"meta"):(n.pairStart=!1,n.escaped=r=="\\",e.next(),null)}return e.skipToEnd(),"comment"},startState:function(){return{pair:!1,pairStart:!1,keyCol:0,inlinePairs:0,inlineList:0,literal:!1,escaped:!1}}}}),e.defineMIME("text/x-yaml","yaml")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/z80/z80",["../../lib/codemirror"],e):e(CodeMirror)}(function(e){e.defineMode("z80",function(){var e=/^(exx?|(ld|cp|in)([di]r?)?|pop|push|ad[cd]|cpl|daa|dec|inc|neg|sbc|sub|and|bit|[cs]cf|x?or|res|set|r[lr]c?a?|r[lr]d|s[lr]a|srl|djnz|nop|rst|[de]i|halt|im|ot[di]r|out[di]?)\b/i,t=/^(call|j[pr]|ret[in]?)\b/i,n=/^b_?(call|jump)\b/i,r=/^(af?|bc?|c|de?|e|hl?|l|i[xy]?|r|sp)\b/i,i=/^(n?[zc]|p[oe]?|m)\b/i,s=/^([hl][xy]|i[xy][hl]|slia|sll)\b/i,o=/^([\da-f]+h|[0-7]+o|[01]+b|\d+)\b/i;return{startState:function(){return{context:0}},token:function(u,a){u.column()||(a.context=0);if(u.eatSpace())return null;var f;if(u.eatWhile(/\w/)){f=u.current();if(!u.indentation())return o.test(f)?"number":null;if(a.context==1&&r.test(f))return"variable-2";if(a.context==2&&i.test(f))return"variable-3";if(e.test(f))return a.context=1,"keyword";if(t.test(f))return a.context=2,"keyword";if(n.test(f))return a.context=3,"keyword";if(s.test(f))return"error"}else{if(u.eat(";"))return u.skipToEnd(),"comment";if(u.eat('"')){while(f=u.next()){if(f=='"')break;f=="\\"&&u.next()}return"string"}if(u.eat("'")){if(u.match(/\\?.'/))return"number"}else if(u.eat(".")||u.sol()&&u.eat("#")){a.context=4;if(u.eatWhile(/\w/))return"def"}else if(u.eat("$")){if(u.eatWhile(/[\da-f]/i))return"number"}else if(u.eat("%")){if(u.eatWhile(/[01]/))return"number"}else u.next()}return null}}}),e.defineMIME("text/x-z80","z80")}),function(e){typeof exports=="object"&&typeof module=="object"?e(require("../lib/codemirror")):typeof define=="function"&&define.amd?define("components/codemirror/mode/meta",["../lib/codemirror"],e):e(CodeMirror)}(function(e){e.modeInfo=[{name:"APL",mime:"text/apl",mode:"apl"},{name:"Asterisk",mime:"text/x-asterisk",mode:"asterisk"},{name:"C",mime:"text/x-csrc",mode:"clike"},{name:"C++",mime:"text/x-c++src",mode:"clike"},{name:"Cobol",mime:"text/x-cobol",mode:"cobol"},{name:"Java",mime:"text/x-java",mode:"clike"},{name:"C#",mime:"text/x-csharp",mode:"clike"},{name:"Scala",mime:"text/x-scala",mode:"clike"},{name:"Clojure",mime:"text/x-clojure",mode:"clojure"},{name:"CoffeeScript",mime:"text/x-coffeescript",mode:"coffeescript"},{name:"Common Lisp",mime:"text/x-common-lisp",mode:"commonlisp"},{name:"Cypher",mime:"application/x-cypher-query",mode:"cypher"},{name:"CSS",mime:"text/css",mode:"css"},{name:"D",mime:"text/x-d",mode:"d"},{name:"diff",mime:"text/x-diff",mode:"diff"},{name:"DTD",mime:"application/xml-dtd",mode:"dtd"},{name:"Dylan",mime:"text/x-dylan",mode:"dylan"},{name:"ECL",mime:"text/x-ecl",mode:"ecl"},{name:"Eiffel",mime:"text/x-eiffel",mode:"eiffel"},{name:"Erlang",mime:"text/x-erlang",mode:"erlang"},{name:"Fortran",mime:"text/x-fortran",mode:"fortran"},{name:"F#",mime:"text/x-fsharp",mode:"mllike"},{name:"Gas",mime:"text/x-gas",mode:"gas"},{name:"Gherkin",mime:"text/x-feature",mode:"gherkin"},{name:"GitHub Flavored Markdown",mime:"text/x-gfm",mode:"gfm"},{name:"Go",mime:"text/x-go",mode:"go"},{name:"Groovy",mime:"text/x-groovy",mode:"groovy"},{name:"HAML",mime:"text/x-haml",mode:"haml"},{name:"Haskell",mime:"text/x-haskell",mode:"haskell"},{name:"Haxe",mime:"text/x-haxe",mode:"haxe"},{name:"ASP.NET",mime:"application/x-aspx",mode:"htmlembedded"},{name:"Embedded Javascript",mime:"application/x-ejs",mode:"htmlembedded"},{name:"JavaServer Pages",mime:"application/x-jsp",mode:"htmlembedded"},{name:"HTML",mime:"text/html",mode:"htmlmixed"},{name:"HTTP",mime:"message/http",mode:"http"},{name:"Jade",mime:"text/x-jade",mode:"jade"},{name:"JavaScript",mime:"text/javascript",mode:"javascript"},{name:"JSON",mime:"application/x-json",mode:"javascript"},{name:"JSON",mime:"application/json",mode:"javascript"},{name:"JSON-LD",mime:"application/ld+json",mode:"javascript"},{name:"TypeScript",mime:"application/typescript",mode:"javascript"},{name:"Jinja2",mime:null,mode:"jinja2"},{name:"Julia",mime:"text/x-julia",mode:"julia"},{name:"LESS",mime:"text/x-less",mode:"css"},{name:"LiveScript",mime:"text/x-livescript",mode:"livescript"},{name:"Lua",mime:"text/x-lua",mode:"lua"},{name:"Markdown (GitHub-flavour)",mime:"text/x-markdown",mode:"markdown"},{name:"mIRC",mime:"text/mirc",mode:"mirc"},{name:"Nginx",mime:"text/x-nginx-conf",mode:"nginx"},{name:"NTriples",mime:"text/n-triples",mode:"ntriples"},{name:"OCaml",mime:"text/x-ocaml",mode:"mllike"},{name:"Octave",mime:"text/x-octave",mode:"octave"},{name:"Pascal",mime:"text/x-pascal",mode:"pascal"},{name:"PEG.js",mime:null,mode:"pegjs"},{name:"Perl",mime:"text/x-perl",mode:"perl"},{name:"PHP",mime:"text/x-php",mode:"php"},{name:"PHP(HTML)",mime:"application/x-httpd-php",mode:"php"},{name:"Pig",mime:"text/x-pig",mode:"pig"},{name:"Plain Text",mime:"text/plain",mode:"null"},{name:"Properties files",mime:"text/x-properties",mode:"properties"},{name:"Python",mime:"text/x-python",mode:"python"},{name:"Puppet",mime:"text/x-puppet",mode:"puppet"},{name:"Cython",mime:"text/x-cython",mode:"python"},{name:"R",mime:"text/x-rsrc",mode:"r"},{name:"reStructuredText",mime:"text/x-rst",mode:"rst"},{name:"Ruby",mime:"text/x-ruby",mode:"ruby"},{name:"Rust",mime:"text/x-rustsrc",mode:"rust"},{name:"Sass",mime:"text/x-sass",mode:"sass"},{name:"Scheme",mime:"text/x-scheme",mode:"scheme"},{name:"SCSS",mime:"text/x-scss",mode:"css"},{name:"Shell",mime:"text/x-sh",mode:"shell"},{name:"Sieve",mime:"application/sieve",mode:"sieve"},{name:"Smalltalk",mime:"text/x-stsrc",mode:"smalltalk"},{name:"Smarty",mime:"text/x-smarty",mode:"smarty"},{name:"SmartyMixed",mime:"text/x-smarty",mode:"smartymixed"},{name:"Solr",mime:"text/x-solr",mode:"solr"},{name:"SPARQL",mime:"application/x-sparql-query",mode:"sparql"},{name:"SQL",mime:"text/x-sql",mode:"sql"},{name:"MariaDB",mime:"text/x-mariadb",mode:"sql"},{name:"sTeX",mime:"text/x-stex",mode:"stex"},{name:"LaTeX",mime:"text/x-latex",mode:"stex"},{name:"SystemVerilog",mime:"text/x-systemverilog",mode:"verilog"},{name:"Tcl",mime:"text/x-tcl",mode:"tcl"},{name:"TiddlyWiki ",mime:"text/x-tiddlywiki",mode:"tiddlywiki"},{name:"Tiki wiki",mime:"text/tiki",mode:"tiki"},{name:"TOML",mime:"text/x-toml",mode:"toml"},{name:"Turtle",mime:"text/turtle",mode:"turtle"},{name:"VB.NET",mime:"text/x-vb",mode:"vb"},{name:"VBScript",mime:"text/vbscript",mode:"vbscript"},{name:"Velocity",mime:"text/velocity",mode:"velocity"},{name:"Verilog",mime:"text/x-verilog",mode:"verilog"},{name:"XML",mime:"application/xml",mode:"xml"},{name:"XQuery",mime:"application/xquery",mode:"xquery"},{name:"YAML",mime:"text/x-yaml",mode:"yaml"},{name:"Z80",mime:"text/x-z80",mode:"z80"}]}),define("components/text/text",["module"],function(e){var t,n,r,i,s,o=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"],u=/^\s*<\?xml(\s)+version=[\'\"](\d)*.(\d)*[\'\"](\s)*\?>/im,a=/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im,f=typeof location!="undefined"&&location.href,l=f&&location.protocol&&location.protocol.replace(/\:/,""),c=f&&location.hostname,h=f&&(location.port||undefined),p={},d=e.config&&e.config()||{};t={version:"2.0.12",strip:function(e){if(e){e=e.replace(u,"");var t=e.match(a);t&&(e=t[1])}else e="";return e},jsEscape:function(e){return e.replace(/(['\\])/g,"\\$1").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r").replace(/[\u2028]/g,"\\u2028").replace(/[\u2029]/g,"\\u2029")},createXhr:d.createXhr||function(){var e,t,n;if(typeof XMLHttpRequest!="undefined")return new XMLHttpRequest;if(typeof ActiveXObject!="undefined")for(t=0;t<3;t+=1){n=o[t];try{e=new ActiveXObject(n)}catch(r){}if(e){o=[n];break}}return e},parseName:function(e){var t,n,r,i=!1,s=e.indexOf("."),o=e.indexOf("./")===0||e.indexOf("../")===0;return s!==-1&&(!o||s>1)?(t=e.substring(0,s),n=e.substring(s+1,e.length)):t=e,r=n||t,s=r.indexOf("!"),s!==-1&&(i=r.substring(s+1)==="strip",r=r.substring(0,s),n?n=r:t=r),{moduleName:t,ext:n,strip:i}},xdRegExp:/^((\w+)\:)?\/\/([^\/\\]+)/,useXhr:function(e,n,r,i){var s,o,u,a=t.xdRegExp.exec(e);return a?(s=a[2],o=a[3],o=o.split(":"),u=o[1],o=o[0],(!s||s===n)&&(!o||o.toLowerCase()===r.toLowerCase())&&(!u&&!o||u===i)):!0},finishLoad:function(e,n,r,i){r=n?t.strip(r):r,d.isBuild&&(p[e]=r),i(r)},load:function(e,n,r,i){if(i&&i.isBuild&&!i.inlineText){r();return}d.isBuild=i&&i.isBuild;var s=t.parseName(e),o=s.moduleName+(s.ext?"."+s.ext:""),u=n.toUrl(o),a=d.useXhr||t.useXhr;if(u.indexOf("empty:")===0){r();return}!f||a(u,l,c,h)?t.get(u,function(n){t.finishLoad(e,s.strip,n,r)},function(e){r.error&&r.error(e)}):n([o],function(e){t.finishLoad(s.moduleName+"."+s.ext,s.strip,e,r)})},write:function(e,n,r,i){if(p.hasOwnProperty(n)){var s=t.jsEscape(p[n]);r.asModule(e+"!"+n,"define(function () { return '"+s+"';});\n")}},writeFile:function(e,n,r,i,s){var o=t.parseName(n),u=o.ext?"."+o.ext:"",a=o.moduleName+u,f=r.toUrl(o.moduleName+u)+".js";t.load(a,r,function(n){var r=function(e){return i(f,e)};r.asModule=function(e,t){return i.asModule(e,f,t)},t.write(e,a,r,s)},s)}};if(d.env==="node"||!d.env&&typeof process!="undefined"&&process.versions&&!!process.versions.node&&!process.versions["node-webkit"])n=require.nodeRequire("fs"),t.get=function(e,t,r){try{var i=n.readFileSync(e,"utf8");i.indexOf("﻿")===0&&(i=i.substring(1)),t(i)}catch(s){r&&r(s)}};else if(d.env==="xhr"||!d.env&&t.createXhr())t.get=function(e,n,r,i){var s=t.createXhr(),o;s.open("GET",e,!0);if(i)for(o in i)i.hasOwnProperty(o)&&s.setRequestHeader(o.toLowerCase(),i[o]);d.onXhr&&d.onXhr(s,e),s.onreadystatechange=function(t){var i,o;s.readyState===4&&(i=s.status||0,i>399&&i<600?(o=new Error(e+" HTTP status: "+i),o.xhr=s,r&&r(o)):n(s.responseText),d.onXhrComplete&&d.onXhrComplete(s,e))},s.send(null)};else if(d.env==="rhino"||!d.env&&typeof Packages!="undefined"&&typeof java!="undefined")t.get=function(e,t){var n,r,i="utf-8",s=new java.io.File(e),o=java.lang.System.getProperty("line.separator"),u=new java.io.BufferedReader(new java.io.InputStreamReader(new java.io.FileInputStream(s),i)),a="";try{n=new java.lang.StringBuffer,r=u.readLine(),r&&r.length()&&r.charAt(0)===65279&&(r=r.substring(1)),r!==null&&n.append(r);while((r=u.readLine())!==null)n.append(o),n.append(r);a=String(n.toString())}finally{u.close()}t(a)};else if(d.env==="xpconnect"||!d.env&&typeof Components!="undefined"&&Components.classes&&Components.interfaces)r=Components.classes,i=Components.interfaces,Components.utils["import"]("resource://gre/modules/FileUtils.jsm"),s="@mozilla.org/windows-registry-key;1"in r,t.get=function(e,t){var n,o,u,a={};s&&(e=e.replace(/\//g,"\\")),u=new FileUtils.File(e);try{n=r["@mozilla.org/network/file-input-stream;1"].createInstance(i.nsIFileInputStream),n.init(u,1,0,!1),o=r["@mozilla.org/intl/converter-input-stream;1"].createInstance(i.nsIConverterInputStream),o.init(n,"utf-8",n.available(),i.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER),o.readString(n.available(),a),o.close(),n.close(),t(a.value)}catch(f){throw new Error((u&&u.path||"")+": "+f)}};return t}),define("components/text/text!components/codemirror/lib/codemirror.css",[],function(){return"/* BASICS */\n\n.CodeMirror {\n  /* Set height, width, borders, and global font properties here */\n  font-family: monospace;\n  height: 300px;\n}\n.CodeMirror-scroll {\n  /* Set scrolling behaviour here */\n  overflow: auto;\n}\n\n/* PADDING */\n\n.CodeMirror-lines {\n  padding: 4px 0; /* Vertical padding around content */\n}\n.CodeMirror pre {\n  padding: 0 4px; /* Horizontal padding of content */\n}\n\n.CodeMirror-scrollbar-filler, .CodeMirror-gutter-filler {\n  background-color: white; /* The little square between H and V scrollbars */\n}\n\n/* GUTTER */\n\n.CodeMirror-gutters {\n  border-right: 1px solid #ddd;\n  background-color: #f7f7f7;\n  white-space: nowrap;\n}\n.CodeMirror-linenumbers {}\n.CodeMirror-linenumber {\n  padding: 0 3px 0 5px;\n  min-width: 20px;\n  text-align: right;\n  color: #999;\n  -moz-box-sizing: content-box;\n  box-sizing: content-box;\n}\n\n/* CURSOR */\n\n.CodeMirror div.CodeMirror-cursor {\n  border-left: 1px solid black;\n}\n/* Shown when moving in bi-directional text */\n.CodeMirror div.CodeMirror-secondarycursor {\n  border-left: 1px solid silver;\n}\n.CodeMirror.cm-keymap-fat-cursor div.CodeMirror-cursor {\n  width: auto;\n  border: 0;\n  background: #7e7;\n}\n\n/* Can style cursor different in overwrite (non-insert) mode */\ndiv.CodeMirror-overwrite div.CodeMirror-cursor {}\n\n.cm-tab { display: inline-block; }\n\n.CodeMirror-ruler {\n  border-left: 1px solid #ccc;\n  position: absolute;\n}\n\n/* DEFAULT THEME */\n\n.cm-s-default .cm-keyword {color: #708;}\n.cm-s-default .cm-atom {color: #219;}\n.cm-s-default .cm-number {color: #164;}\n.cm-s-default .cm-def {color: #00f;}\n.cm-s-default .cm-variable,\n.cm-s-default .cm-punctuation,\n.cm-s-default .cm-property,\n.cm-s-default .cm-operator {}\n.cm-s-default .cm-variable-2 {color: #05a;}\n.cm-s-default .cm-variable-3 {color: #085;}\n.cm-s-default .cm-comment {color: #a50;}\n.cm-s-default .cm-string {color: #a11;}\n.cm-s-default .cm-string-2 {color: #f50;}\n.cm-s-default .cm-meta {color: #555;}\n.cm-s-default .cm-qualifier {color: #555;}\n.cm-s-default .cm-builtin {color: #30a;}\n.cm-s-default .cm-bracket {color: #997;}\n.cm-s-default .cm-tag {color: #170;}\n.cm-s-default .cm-attribute {color: #00c;}\n.cm-s-default .cm-header {color: blue;}\n.cm-s-default .cm-quote {color: #090;}\n.cm-s-default .cm-hr {color: #999;}\n.cm-s-default .cm-link {color: #00c;}\n\n.cm-negative {color: #d44;}\n.cm-positive {color: #292;}\n.cm-header, .cm-strong {font-weight: bold;}\n.cm-em {font-style: italic;}\n.cm-link {text-decoration: underline;}\n\n.cm-s-default .cm-error {color: #f00;}\n.cm-invalidchar {color: #f00;}\n\ndiv.CodeMirror span.CodeMirror-matchingbracket {color: #0f0;}\ndiv.CodeMirror span.CodeMirror-nonmatchingbracket {color: #f22;}\n.CodeMirror-activeline-background {background: #e8f2ff;}\n\n/* STOP */\n\n/* The rest of this file contains styles related to the mechanics of\n   the editor. You probably shouldn't touch them. */\n\n.CodeMirror {\n  line-height: 1;\n  position: relative;\n  overflow: hidden;\n  background: white;\n  color: black;\n}\n\n.CodeMirror-scroll {\n  /* 30px is the magic margin used to hide the element's real scrollbars */\n  /* See overflow: hidden in .CodeMirror */\n  margin-bottom: -30px; margin-right: -30px;\n  padding-bottom: 30px;\n  height: 100%;\n  outline: none; /* Prevent dragging from highlighting the element */\n  position: relative;\n  -moz-box-sizing: content-box;\n  box-sizing: content-box;\n}\n.CodeMirror-sizer {\n  position: relative;\n  border-right: 30px solid transparent;\n  -moz-box-sizing: content-box;\n  box-sizing: content-box;\n}\n\n/* The fake, visible scrollbars. Used to force redraw during scrolling\n   before actuall scrolling happens, thus preventing shaking and\n   flickering artifacts. */\n.CodeMirror-vscrollbar, .CodeMirror-hscrollbar, .CodeMirror-scrollbar-filler, .CodeMirror-gutter-filler {\n  position: absolute;\n  z-index: 6;\n  display: none;\n}\n.CodeMirror-vscrollbar {\n  right: 0; top: 0;\n  overflow-x: hidden;\n  overflow-y: scroll;\n}\n.CodeMirror-hscrollbar {\n  bottom: 0; left: 0;\n  overflow-y: hidden;\n  overflow-x: scroll;\n}\n.CodeMirror-scrollbar-filler {\n  right: 0; bottom: 0;\n}\n.CodeMirror-gutter-filler {\n  left: 0; bottom: 0;\n}\n\n.CodeMirror-gutters {\n  position: absolute; left: 0; top: 0;\n  padding-bottom: 30px;\n  z-index: 3;\n}\n.CodeMirror-gutter {\n  white-space: normal;\n  height: 100%;\n  -moz-box-sizing: content-box;\n  box-sizing: content-box;\n  padding-bottom: 30px;\n  margin-bottom: -32px;\n  display: inline-block;\n  /* Hack to make IE7 behave */\n  *zoom:1;\n  *display:inline;\n}\n.CodeMirror-gutter-elt {\n  position: absolute;\n  cursor: default;\n  z-index: 4;\n}\n\n.CodeMirror-lines {\n  cursor: text;\n}\n.CodeMirror pre {\n  /* Reset some styles that the rest of the page might have set */\n  -moz-border-radius: 0; -webkit-border-radius: 0; border-radius: 0;\n  border-width: 0;\n  background: transparent;\n  font-family: inherit;\n  font-size: inherit;\n  margin: 0;\n  white-space: pre;\n  word-wrap: normal;\n  line-height: inherit;\n  color: inherit;\n  z-index: 2;\n  position: relative;\n  overflow: visible;\n}\n.CodeMirror-wrap pre {\n  word-wrap: break-word;\n  white-space: pre-wrap;\n  word-break: normal;\n}\n\n.CodeMirror-linebackground {\n  position: absolute;\n  left: 0; right: 0; top: 0; bottom: 0;\n  z-index: 0;\n}\n\n.CodeMirror-linewidget {\n  position: relative;\n  z-index: 2;\n  overflow: auto;\n}\n\n.CodeMirror-widget {}\n\n.CodeMirror-wrap .CodeMirror-scroll {\n  overflow-x: hidden;\n}\n\n.CodeMirror-measure {\n  position: absolute;\n  width: 100%;\n  height: 0;\n  overflow: hidden;\n  visibility: hidden;\n}\n.CodeMirror-measure pre { position: static; }\n\n.CodeMirror div.CodeMirror-cursor {\n  position: absolute;\n  border-right: none;\n  width: 0;\n}\n\ndiv.CodeMirror-cursors {\n  visibility: hidden;\n  position: relative;\n  z-index: 1;\n}\n.CodeMirror-focused div.CodeMirror-cursors {\n  visibility: visible;\n}\n\n.CodeMirror-selected { background: #d9d9d9; }\n.CodeMirror-focused .CodeMirror-selected { background: #d7d4f0; }\n.CodeMirror-crosshair { cursor: crosshair; }\n\n.cm-searching {\n  background: #ffa;\n  background: rgba(255, 255, 0, .4);\n}\n\n/* IE7 hack to prevent it from returning funny offsetTops on the spans */\n.CodeMirror span { *vertical-align: text-bottom; }\n\n/* Used to force a border model for a node */\n.cm-force-border { padding-right: .1px; }\n\n@media print {\n  /* Hide the cursor when printing */\n  .CodeMirror div.CodeMirror-cursors {\n    visibility: hidden;\n  }\n}\n"}),define("components/text/text!components/codemirror/addon/dialog/dialog.css",[],function(){return".CodeMirror-dialog {\n  position: absolute;\n  left: 0; right: 0;\n  background: white;\n  z-index: 15;\n  padding: .1em .8em;\n  overflow: hidden;\n  color: #333;\n}\n\n.CodeMirror-dialog-top {\n  border-bottom: 1px solid #eee;\n  top: 0;\n}\n\n.CodeMirror-dialog-bottom {\n  border-top: 1px solid #eee;\n  bottom: 0;\n}\n\n.CodeMirror-dialog input {\n  border: none;\n  outline: none;\n  background: transparent;\n  width: 20em;\n  color: inherit;\n  font-family: monospace;\n}\n\n.CodeMirror-dialog button {\n  font-size: 70%;\n}\n"}),"undefined"==typeof window&&(window={}),define("codemirror",["require","exports","module","components/codemirror/lib/codemirror","components/codemirror/addon/dialog/dialog","components/codemirror/addon/display/rulers","components/codemirror/addon/selection/active-line","components/codemirror/addon/search/match-highlighter","components/codemirror/addon/search/search","components/codemirror/addon/search/searchcursor","components/codemirror/keymap/emacs","components/codemirror/keymap/sublime","components/codemirror/keymap/vim","components/codemirror/mode/apl/apl","components/codemirror/mode/asterisk/asterisk","components/codemirror/mode/clike/clike","components/codemirror/mode/clojure/clojure","components/codemirror/mode/cobol/cobol","components/codemirror/mode/coffeescript/coffeescript","components/codemirror/mode/commonlisp/commonlisp","components/codemirror/mode/css/css","components/codemirror/mode/d/d","components/codemirror/mode/diff/diff","components/codemirror/mode/dtd/dtd","components/codemirror/mode/ecl/ecl","components/codemirror/mode/eiffel/eiffel","components/codemirror/mode/erlang/erlang","components/codemirror/mode/fortran/fortran","components/codemirror/mode/gas/gas","components/codemirror/mode/gfm/gfm","components/codemirror/mode/gherkin/gherkin","components/codemirror/mode/go/go","components/codemirror/mode/groovy/groovy","components/codemirror/mode/haml/haml","components/codemirror/mode/haskell/haskell","components/codemirror/mode/haxe/haxe","components/codemirror/mode/htmlembedded/htmlembedded","components/codemirror/mode/htmlmixed/htmlmixed","components/codemirror/mode/http/http","components/codemirror/mode/jade/jade","components/codemirror/mode/javascript/javascript","components/codemirror/mode/jinja2/jinja2","components/codemirror/mode/julia/julia","components/codemirror/mode/livescript/livescript","components/codemirror/mode/lua/lua","components/codemirror/mode/markdown/markdown","components/codemirror/mode/mirc/mirc","components/codemirror/mode/mllike/mllike","components/codemirror/mode/nginx/nginx","components/codemirror/mode/ntriples/ntriples","components/codemirror/mode/octave/octave","components/codemirror/mode/pascal/pascal","components/codemirror/mode/pegjs/pegjs","components/codemirror/mode/perl/perl","components/codemirror/mode/php/php","components/codemirror/mode/pig/pig","components/codemirror/mode/properties/properties","components/codemirror/mode/puppet/puppet","components/codemirror/mode/python/python","components/codemirror/mode/q/q","components/codemirror/mode/r/r","components/codemirror/mode/rpm/rpm","components/codemirror/mode/rst/rst","components/codemirror/mode/ruby/ruby","components/codemirror/mode/rust/rust","components/codemirror/mode/sass/sass","components/codemirror/mode/scheme/scheme","components/codemirror/mode/shell/shell","components/codemirror/mode/sieve/sieve","components/codemirror/mode/smalltalk/smalltalk","components/codemirror/mode/smarty/smarty","components/codemirror/mode/smartymixed/smartymixed","components/codemirror/mode/solr/solr","components/codemirror/mode/sparql/sparql","components/codemirror/mode/sql/sql","components/codemirror/mode/stex/stex","components/codemirror/mode/tcl/tcl","components/codemirror/mode/tiddlywiki/tiddlywiki","components/codemirror/mode/tiki/tiki","components/codemirror/mode/toml/toml","components/codemirror/mode/turtle/turtle","components/codemirror/mode/vb/vb","components/codemirror/mode/vbscript/vbscript","components/codemirror/mode/velocity/velocity","components/codemirror/mode/verilog/verilog","components/codemirror/mode/xml/xml","components/codemirror/mode/xquery/xquery","components/codemirror/mode/yaml/yaml","components/codemirror/mode/z80/z80","components/codemirror/mode/meta","components/text/text!components/codemirror/lib/codemirror.css","components/text/text!components/codemirror/addon/dialog/dialog.css"],function(e,t,n){var r=e("components/codemirror/lib/codemirror");e("components/codemirror/addon/dialog/dialog"),e("components/codemirror/addon/display/rulers"),e("components/codemirror/addon/selection/active-line"),e("components/codemirror/addon/search/match-highlighter"),e("components/codemirror/addon/search/search"),e("components/codemirror/addon/search/searchcursor"),e("components/codemirror/keymap/emacs"),e("components/codemirror/keymap/sublime"),e("components/codemirror/keymap/vim"),e("components/codemirror/mode/apl/apl"),e("components/codemirror/mode/asterisk/asterisk"),e("components/codemirror/mode/clike/clike"),e("components/codemirror/mode/clojure/clojure"),e("components/codemirror/mode/cobol/cobol"),e("components/codemirror/mode/coffeescript/coffeescript"),e("components/codemirror/mode/commonlisp/commonlisp"),e("components/codemirror/mode/css/css"),e("components/codemirror/mode/d/d"),e("components/codemirror/mode/diff/diff"),e("components/codemirror/mode/dtd/dtd"),e("components/codemirror/mode/ecl/ecl"),e("components/codemirror/mode/eiffel/eiffel"),e("components/codemirror/mode/erlang/erlang"),e("components/codemirror/mode/fortran/fortran"),e("components/codemirror/mode/gas/gas"),e("components/codemirror/mode/gfm/gfm"),e("components/codemirror/mode/gherkin/gherkin"),e("components/codemirror/mode/go/go"),e("components/codemirror/mode/groovy/groovy"),e("components/codemirror/mode/haml/haml"),e("components/codemirror/mode/haskell/haskell"),e("components/codemirror/mode/haxe/haxe"),e("components/codemirror/mode/htmlembedded/htmlembedded"),e("components/codemirror/mode/htmlmixed/htmlmixed"),e("components/codemirror/mode/http/http"),e("components/codemirror/mode/jade/jade"),e("components/codemirror/mode/javascript/javascript"),e("components/codemirror/mode/jinja2/jinja2"),e("components/codemirror/mode/julia/julia"),e("components/codemirror/mode/livescript/livescript"),e("components/codemirror/mode/lua/lua"),e("components/codemirror/mode/markdown/markdown"),e("components/codemirror/mode/mirc/mirc"),e("components/codemirror/mode/mllike/mllike"),e("components/codemirror/mode/nginx/nginx"),e("components/codemirror/mode/ntriples/ntriples"),e("components/codemirror/mode/octave/octave"),e("components/codemirror/mode/pascal/pascal"),e("components/codemirror/mode/pegjs/pegjs"),e("components/codemirror/mode/perl/perl"),e("components/codemirror/mode/php/php"),e("components/codemirror/mode/pig/pig"),e("components/codemirror/mode/properties/properties"),e("components/codemirror/mode/puppet/puppet"),e("components/codemirror/mode/python/python"),e("components/codemirror/mode/q/q"),e("components/codemirror/mode/r/r"),e("components/codemirror/mode/rpm/rpm"),e("components/codemirror/mode/rst/rst"),e("components/codemirror/mode/ruby/ruby"),e("components/codemirror/mode/rust/rust"),e("components/codemirror/mode/sass/sass"),e("components/codemirror/mode/scheme/scheme"),e("components/codemirror/mode/shell/shell"),e("components/codemirror/mode/sieve/sieve"),e("components/codemirror/mode/smalltalk/smalltalk"),e("components/codemirror/mode/smarty/smarty"),e("components/codemirror/mode/smartymixed/smartymixed"),e("components/codemirror/mode/solr/solr"),e("components/codemirror/mode/sparql/sparql"),e("components/codemirror/mode/sql/sql"),e("components/codemirror/mode/stex/stex"),e("components/codemirror/mode/tcl/tcl"),e("components/codemirror/mode/tiddlywiki/tiddlywiki"),e("components/codemirror/mode/tiki/tiki"),e("components/codemirror/mode/toml/toml"),e("components/codemirror/mode/turtle/turtle"),e("components/codemirror/mode/vb/vb"),e("components/codemirror/mode/vbscript/vbscript"),e("components/codemirror/mode/velocity/velocity"),e("components/codemirror/mode/verilog/verilog"),e("components/codemirror/mode/xml/xml"),e("components/codemirror/mode/xquery/xquery"),e("components/codemirror/mode/yaml/yaml"),e("components/codemirror/mode/z80/z80"),e("components/codemirror/mode/meta");var i=e("components/text/text!components/codemirror/lib/codemirror.css");i+="\n\n\n"+e("components/text/text!components/codemirror/addon/dialog/dialog.css"),t.CodeMirrorCSS=i,t.CodeMirror=r});