// Released under MIT license
// Copyright (c) 2009-2010 Dominic Baggott
// Copyright (c) 2009-2010 Ash Berlin
// Copyright (c) 2011 Christoph Dorn <christoph@christophdorn.com> (http://www.christophdorn.com)
// Date: 2013-09-15T16:12Z

//
// Copyright (c) 2014 Jesse Grosjean. All rights reserved.
//
// Permission is given for you to use this software ONLY while creating themes
// and plugins for the "FoldingText" software platform. Permission is NOT
// given for any other purpose.
//

/*
	 * Date Format 1.2.3
	 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
	 * MIT license
	 *
	 * Includes enhancements by Scott Trenda <scott.trenda.net>
	 * and Kris Kowal <cixar.com/~kris.kowal/>
	 *
	 * Accepts a date, a mask, or a date and a mask.
	 * Returns a formatted version of the given date.
	 * The date defaults to the current date/time.
	 * The mask defaults to dateFormat.masks.default.
	 */

// fixed replacements, such as copyright symbol for (c)

requirejs.config({baseUrl:"./",skipDirOptimize:!0,optimizeCss:"none",useStrict:!1,dir:"../dist",paths:{tests:"../tests"},onBuildWrite:function(e,t,n){return n=n.replace(/Environment\.debug/g,"false"),n},modules:[{name:"./codemirror"},{name:"./core",include:["./ft/core/tree","./ft/core/taxonomies","./ft/core/taxonomy","./ft/taxonomy/outlinetaxonomy","./ft/taxonomy/markdowntaxonomy","./ft/taxonomy/taskpapertaxonomy"],exclude:["./codemirror"]},{name:"./editor",include:["./ft/editor/editor"],exclude:["./core","./codemirror"]},{name:"./foldingtext",include:["apps/foldingtextmain"],exclude:["./core","./editor","./codemirror"]},{name:"./taskpaper",include:["apps/taskpapermain"],exclude:["./core","./editor","./codemirror"]},{name:"./writeroom",include:["apps/writeroommain"],exclude:["./core","./editor","./codemirror"]}]}),define("require.config",function(){}),require(["require.config","codemirror"],function(){require(["core","editor"],function(){require(["apps/foldingtextmain"])})}),define("foldingtext",function(){}),function(){function o(e,t){t||(t={});for(var n in e)t[n]===undefined&&(t[n]=e[n]);return t}function u(){this._callbacks=[],this._errCallbacks=[],this._resolved=0,this._result=null}function f(e,t){this.data=e,this.options=o(a,t),this.operation=new u,this.operation.resolve(null,this.data),this.requiredScripts=[],this.requiredFunctions=[]}var e=typeof module!="undefined"&&module.exports,t=typeof global!="undefined"&&{}.toString.call(global)=="[object global]",n=n||function(e){setTimeout(e,0)},r=t?require(__dirname+"/Worker.js"):self.Worker,i=typeof self!="undefined"?self.URL?self.URL:self.webkitURL:null,s=t||self.Worker?!0:!1;u.prototype.resolve=function(e,t){if(!e){this._resolved=1,this._result=t;for(var n=0;n<this._callbacks.length;++n)this._callbacks[n](t)}else{this._resolved=2,this._result=e;for(var r=0;r<this._errCallbacks.length;++r)this._errCallbacks[r](t)}this._callbacks=[],this._errCallbacks=[]},u.prototype.then=function(e,t){if(this._resolved===1){e&&e(this._result);return}if(this._resolved===2){t&&t(this._result);return}return e&&(this._callbacks[this._callbacks.length]=e),t&&(this._errCallbacks[this._errCallbacks.length]=t),this};var a={evalPath:t?__dirname+"/eval.js":null,maxWorkers:t?require("os").cpus().length:4,synchronous:!0};f.isSupported=function(){return s},f.prototype.getWorkerSource=function(e){var n="",r=0;!t&&this.requiredScripts.length!==0&&(n+='importScripts("'+this.requiredScripts.join('","')+'");\r\n');for(r=0;r<this.requiredFunctions.length;++r)this.requiredFunctions[r].name?n+="var "+this.requiredFunctions[r].name+" = "+this.requiredFunctions[r].fn.toString()+";":n+=this.requiredFunctions[r].fn.toString();return t?n+'process.on("message", function(e) {process.send(JSON.stringify(('+e.toString()+")(JSON.parse(e).data)))})":n+"self.onmessage = function(e) {self.postMessage(("+e.toString()+")(e.data))}"},f.prototype.require=function(){var e=Array.prototype.slice.call(arguments,0),t;for(var n=0;n<e.length;n++)t=e[n],typeof t=="string"?this.requiredScripts.push(t):typeof t=="function"?this.requiredFunctions.push({fn:t}):typeof t=="object"&&this.requiredFunctions.push(t);return this},f.prototype._spawnWorker=function(e){var n,s=this.getWorkerSource(e);if(t)n=new r(this.options.evalPath),n.postMessage(s);else{if(r===undefined)return undefined;try{if(this.requiredScripts.length!==0){if(this.options.evalPath===null)throw new Error("Can't use required scripts without eval.js!");n=new r(this.options.evalPath),n.postMessage(s)}else{if(!i)throw new Error("Can't create a blob URL in this browser!");var o=new Blob([s],{type:"text/javascript"}),u=i.createObjectURL(o);n=new r(u)}}catch(a){if(this.options.evalPath===null)throw a;n=new r(this.options.evalPath),n.postMessage(s)}}return n},f.prototype.spawn=function(e){var t=this,r=new u;return this.operation.then(function(){var i=t._spawnWorker(e);if(i!==undefined)i.onmessage=function(e){i.terminate(),t.data=e.data,r.resolve(null,t.data)},i.postMessage(t.data);else{if(!t.options.synchronous)throw new Error("Workers do not exist and synchronous operation not allowed!");n(function(){t.data=e(t.data),r.resolve(null,t.data)})}}),this.operation=r,this},f.prototype._spawnMapWorker=function(e,t,r){var i=this,s=i._spawnWorker(t);if(s!==undefined)s.onmessage=function(t){s.terminate(),i.data[e]=t.data,r()},s.postMessage(i.data[e]);else{if(!i.options.synchronous)throw new Error("Workers do not exist and synchronous operation not allowed!");n(function(){i.data[e]=t(i.data[e]),r()})}},f.prototype.map=function(e){function i(){++r===t.data.length?s.resolve(null,t.data):n<t.data.length&&t._spawnMapWorker(n++,e,i)}if(!this.data.length)return this.spawn(e);var t=this,n=0,r=0,s=new u;return this.operation.then(function(){for(;n-r<t.options.maxWorkers&&n<t.data.length;++n)t._spawnMapWorker(n,e,i)}),this.operation=s,this},f.prototype._spawnReduceWorker=function(e,t,r){var i=this,s=i._spawnWorker(t);if(s!==undefined)s.onmessage=function(e){s.terminate(),i.data[i.data.length]=e.data,r()},s.postMessage(e);else{if(!i.options.synchronous)throw new Error("Workers do not exist and synchronous operation not allowed!");n(function(){i.data[i.data.length]=t(e),r()})}},f.prototype.reduce=function(e){function r(s){--t,n.data.length===1&&t===0?(n.data=n.data[0],i.resolve(null,n.data)):n.data.length>1&&(++t,n._spawnReduceWorker([n.data[0],n.data[1]],e,r),n.data.splice(0,2))}if(!this.data.length)throw new Error("Can't reduce non-array data");var t=0,n=this,i=new u;return this.operation.then(function(){if(n.data.length===1)i.resolve(null,n.data[0]);else{for(var s=0;s<n.options.maxWorkers&&s<Math.floor(n.data.length/2);++s)++t,n._spawnReduceWorker([n.data[s*2],n.data[s*2+1]],e,r);n.data.splice(0,s*2)}}),this.operation=i,this},f.prototype.then=function(e,t){var n=this,r=new u;return this.operation.then(function(){var t=e(n.data);t!==undefined&&(n.data=t),r.resolve(null,n.data)},t),this.operation=r,this},e?module.exports=f:self.Parallel=f}(),define("ft/util/parallel",function(){}),define("ft/extensions/wordcount",["require","exports","module","ft/util/parallel","ft/core/extensions"],function(e,t,n){function f(e){return e.toString().replace(/\B(?=(\d{3})+(?!\d))/g,",")}function l(e){if(e.option("wordCount")){a||(a=document.createElement("div"),document.body.appendChild(a));var t=e.selectedRange(),n;if(t.isCollapsed())a.className="wordCount",n=f(o)+" Words<br/>";else{var r=t.textInRange(),i=h({insertedText:r,replacedText:""});a.className="wordCount wordCountSelected",n=f(i)+" Words<br/>"}n!==a.innerHTML&&(a.innerHTML=n)}else a&&(a.parentNode.removeChild(a),a=null)}function c(e,t){var n=e+t,r=u.length-1,i;while(e>0){e--,i=u[e];if(i===" "||i==="\n")break}while(n<r){n++,i=u[n];if(i===" "||i==="\n")break}return u.substr(e,n-e)}function h(e){function n(e){var n=e.match(t);return n?n.length:0}var t=new RegExp("[A-Za-z0-9_'À-ſ]+|[぀-ゟ]+|[゠-ヿ]+|[一-鿿豈-﫿㐀-䶿]","g"),r=n(e.replacedText),i=n(e.insertedText);return i-r}function p(e){s[0].spawn(h).then(function(t){s.shift(),o+=t,s.length===0?l(e):p(e)})}function d(e,t,n,r){var o=c(t,n.length);u=u.replaceRange(t,t+n.length,r);var a=c(t,r.length);s.push(new i({replacedText:o,insertedText:a})),s.length===1&&p(e)}e("ft/util/parallel");var r=e("ft/core/extensions").Extensions,i=window.Parallel,s=[],o=0,u="",a;r.addInit(function(e){d(e,0,0,e.textContent())}),r.addTreeChanged(function(e,t){var n=t.deltas,r=n.length;for(var i=0;i<r;i++){var s=n[i];s.textChanged()&&d(e,s.location,s.replacedText,s.insertedText)}}),r.addSelectionDidChange(function(e){l(e)}),r.add("com.foldingtext.editor.styles",".wordCount {			pointer-events: none;			position: fixed;			bottom: 0.5rem;			right: 1.5rem;			color: @secondaryTextColor;		}		.wordCountSelected {			color: @secondaryTextColor;		}"),r.add("com.foldingtext.editor.options",{name:"wordCount",defaultValue:!0,onChange:function(e,t,n){l(e)}}),r.addCommand({name:"toggleWordCount",validate:function(e,t){return t.interfaceItemState=e.option("wordCount"),!0},performCommand:function(e){e.setOption("wordCount",!e.option("wordCount"))}})}),define("ft/extensions/typewriter",["require","exports","module","ft/core/extensions"],function(e,t,n){function i(e,t){if(e.getSelection().length===0)for(var n=0;n<t.length;n++){var r=t[n];if(r.origin==="+input"||r.origin==="+delete"){e.getOption("ftEditor").performCommand("centerSelectionInVisibleArea");return}}}var r=e("ft/core/extensions").Extensions;r.add("com.foldingtext.editor.options",{name:"typewriterMode",defaultValue:!1,onChange:function(e,t,n){var r=e.cm();n||r.off("changes",i),n&&r.on("changes",i),e.invalidateRestorableState()}}),r.addCommand({name:"toggleTypewriterMode",validate:function(e,t){return t.interfaceItemState=e.option("typewriterMode"),!0},performCommand:function(e){e.setOption("typewriterMode",!e.option("typewriterMode"))}})}),define("ft/extensions/showlistbullets",["require","exports","module","ft/core/extensions","codemirror","ft/core/node"],function(e,t,n){function a(e,t){e&&(u=e),t&&(createArchiveNode=t)}var r=e("ft/core/extensions").Extensions,i=e("codemirror").CodeMirror,s=e("ft/core/node").Node,o=/[\-+*]/,u=function(t){return t.type()==="unordered"};return r.add("com.foldingtext.editor.options",{name:"showListBullets",defaultValue:!0,onChange:function(e,t,n){if(t===n)return;e.operation(function(){var t=e.tree().firstLineNode();while(t)u(t)&&e.setNeedsRender(t),t=t.nextLineNode();e.refresh()})}}),r.addCommand({name:"toggleShowListBullets",validate:function(e,t){return t.interfaceItemState=e.option("showListBullets"),!0},performCommand:function(e){e.setOption("showListBullets",!e.option("showListBullets"))}}),r.addRenderNode(function(e,t,n){if(e.option("showListBullets")&&u(t)){var r=o.exec(t.line());if(r){var i=document.createElement("span");i.className="cm-list-bullet",i.textContent="•",n.renderInlineWidget(r.index,1,i)}}}),a}),function(e){function n(){return"Markdown.mk_block( "+uneval(this.toString())+", "+uneval(this.trailing)+", "+uneval(this.lineNumber)+" )"}function r(){var e=require("util");return"Markdown.mk_block( "+e.inspect(this.toString())+", "+e.inspect(this.trailing)+", "+e.inspect(this.lineNumber)+" )"}function u(e){var t=0,n=-1;while((n=e.indexOf("\n",n+1))!==-1)t++;return t}function f(e){return e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function l(e){if(typeof e=="string")return f(e);var t=e.shift(),n={},r=[];e.length&&typeof e[0]=="object"&&!(e[0]instanceof Array)&&(n=e.shift());while(e.length)r.push(l(e.shift()));var i="";for(var s in n)i+=" "+s+'="'+f(n[s])+'"';return t==="img"||t==="br"||t==="hr"?"<"+t+i+"/>":"<"+t+i+">"+r.join("")+"</"+t+">"}function c(e,t,n){var r;n=n||{};var i=e.slice(0);typeof n.preprocessTreeNode=="function"&&(i=n.preprocessTreeNode(i,t));var s=a(i);if(s){i[1]={};for(r in s)i[1][r]=s[r];s=i[1]}if(typeof i=="string")return i;switch(i[0]){case"header":i[0]="h"+i[1].level,delete i[1].level;break;case"bulletlist":i[0]="ul";break;case"numberlist":i[0]="ol";break;case"listitem":i[0]="li";break;case"para":i[0]="p";break;case"markdown":i[0]="html",s&&delete s.references;break;case"code_block":i[0]="pre",r=s?2:1;var o=["code"];o.push.apply(o,i.splice(r,i.length-r)),i[r]=o;break;case"inlinecode":i[0]="code";break;case"img":i[1].src=i[1].href,delete i[1].href;break;case"linebreak":i[0]="br";break;case"link":i[0]="a";break;case"link_ref":i[0]="a";var u=t[s.ref];if(!u)return s.original;delete s.ref,s.href=u.href,u.title&&(s.title=u.title),delete s.original;break;case"img_ref":i[0]="img";var u=t[s.ref];if(!u)return s.original;delete s.ref,s.src=u.href,u.title&&(s.title=u.title),delete s.original}r=1;if(s){for(var f in i[1]){r=2;break}r===1&&i.splice(r,1)}for(;r<i.length;++r)i[r]=c(i[r],t,n);return i}function h(e){var t=a(e)?2:1;while(t<e.length)typeof e[t]=="string"?t+1<e.length&&typeof e[t+1]=="string"?e[t]+=e.splice(t+1,1)[0]:++t:(h(e[t]),++t)}function y(e,t){function i(e){this.len_after=e,this.name="close_"+t}var n=e+"_state",r=e==="strong"?"em_state":"strong_state";return function(s){if(this[n][0]===t)return this[n].shift(),[s.length,new i(s.length-t.length)];var o=this[r].slice(),u=this[n].slice();this[n].unshift(t);var a=this.processInline(s.substr(t.length)),f=a[a.length-1],l=this[n].shift();if(f instanceof i){a.pop();var c=s.length-f.len_after;return[c,[e].concat(a)]}return this[r]=o,this[n]=u,[t.length,t]}}function w(e){var t=e.split(""),n=[""],r=!1;while(t.length){var i=t.shift();switch(i){case" ":r?n[n.length-1]+=i:n.push("");break;case"'":case'"':r=!r;break;case"\\":i=t.shift();default:n[n.length-1]+=i}}return n}var t={};t.mk_block=function(e,t,i){arguments.length===1&&(t="\n\n");var s=new String(e);return s.trailing=t,s.inspect=r,s.toSource=n,i!==undefined&&(s.lineNumber=i),s};var i=t.isArray=Array.isArray||function(e){return Object.prototype.toString.call(e)==="[object Array]"};Array.prototype.forEach?t.forEach=function(t,n,r){return t.forEach(n,r)}:t.forEach=function(t,n,r){for(var i=0;i<t.length;i++)n.call(r||t,t[i],i,t)},t.isEmpty=function(t){for(var n in t)if(hasOwnProperty.call(t,n))return!1;return!0},t.extract_attr=function(t){return i(t)&&t.length>1&&typeof t[1]=="object"&&!i(t[1])?t[1]:undefined};var s=function(e){switch(typeof e){case"undefined":this.dialect=s.dialects.Gruber;break;case"object":this.dialect=e;break;default:if(!(e in s.dialects))throw new Error("Unknown Markdown dialect '"+String(e)+"'");this.dialect=s.dialects[e]}this.em_state=[],this.strong_state=[],this.debug_indent=""};s.dialects={};var o=s.mk_block=t.mk_block,i=t.isArray;s.parse=function(e,t){var n=new s(t);return n.toTree(e)},s.prototype.split_blocks=function(t){t=t.replace(/(\r\n|\n|\r)/g,"\n");var n=/([\s\S]+?)($|\n#|\n(?:\s*\n|$)+)/g,r=[],i,s=1;(i=/^(\s*\n)/.exec(t))!==null&&(s+=u(i[0]),n.lastIndex=i[0].length);while((i=n.exec(t))!==null)i[2]==="\n#"&&(i[2]="\n",n.lastIndex--),r.push(o(i[1],i[2],s)),s+=u(i[0]);return r},s.prototype.processBlock=function(t,n){var r=this.dialect.block,s=r.__order__;if("__call__"in r)return r.__call__.call(this,t,n);for(var o=0;o<s.length;o++){var u=r[s[o]].call(this,t,n);if(u)return(!i(u)||u.length>0&&!i(u[0]))&&this.debug(s[o],"didn't return a proper array"),u}return[]},s.prototype.processInline=function(t){return this.dialect.inline.__call__.call(this,String(t))},s.prototype.toTree=function(t,n){var r=t instanceof Array?t:this.split_blocks(t),i=this.tree;try{this.tree=n||this.tree||["markdown"];e:while(r.length){var s=this.processBlock(r.shift(),r);if(!s.length)continue e;this.tree.push.apply(this.tree,s)}return this.tree}finally{n&&(this.tree=i)}},s.prototype.debug=function(){var e=Array.prototype.slice.call(arguments);e.unshift(this.debug_indent),typeof print!="undefined"&&print.apply(print,e),typeof console!="undefined"&&typeof console.log!="undefined"&&console.log.apply(null,e)},s.prototype.loop_re_over_block=function(e,t,n){var r,i=t.valueOf();while(i.length&&(r=e.exec(i))!==null)i=i.substr(r[0].length),n.call(this,r);return i},s.buildBlockOrder=function(e){var t=[];for(var n in e){if(n==="__order__"||n==="__call__")continue;t.push(n)}e.__order__=t},s.buildInlinePatterns=function(e){var t=[];for(var n in e){if(n.match(/^__.*__$/))continue;var r=n.replace(/([\\.*+?|()\[\]{}])/g,"\\$1").replace(/\n/,"\\n");t.push(n.length===1?r:"(?:"+r+")")}t=t.join("|"),e.__patterns__=t;var i=e.__call__;e.__call__=function(e,n){return n!==undefined?i.call(this,e,n):i.call(this,e,t)}};var a=t.extract_attr;s.renderJsonML=function(e,t){t=t||{},t.root=t.root||!1;var n=[];if(t.root)n.push(l(e));else{e.shift(),e.length&&typeof e[0]=="object"&&!(e[0]instanceof Array)&&e.shift();while(e.length)n.push(l(e.shift()))}return n.join("\n\n")},s.toHTMLTree=function(t,n,r){typeof t=="string"&&(t=this.parse(t,n));var i=a(t),s={};i&&i.references&&(s=i.references);var o=c(t,s,r);return h(o),o},s.toHTML=function(t,n,r){var i=this.toHTMLTree(t,n,r);return this.renderJsonML(i)};var p={};p.inline_until_char=function(e,t){var n=0,r=[];for(;;){if(e.charAt(n)===t)return n++,[n,r];if(n>=e.length)return null;var i=this.dialect.inline.__oneElement__.call(this,e.substr(n));n+=i[0],r.push.apply(r,i.slice(1))}},p.subclassDialect=function(e){function t(){}function n(){}return t.prototype=e.block,n.prototype=e.inline,{block:new t,inline:new n}};var d=t.forEach,a=t.extract_attr,o=t.mk_block,v=t.isEmpty,m=p.inline_until_char,g={block:{atxHeader:function(t,n){var r=t.match(/^(#{1,6})\s*(.*?)\s*#*\s*(?:\n|$)/);if(!r)return undefined;var i=["header",{level:r[1].length}];return Array.prototype.push.apply(i,this.processInline(r[2])),r[0].length<t.length&&n.unshift(o(t.substr(r[0].length),t.trailing,t.lineNumber+2)),[i]},setextHeader:function(t,n){var r=t.match(/^(.*)\n([-=])\2\2+(?:\n|$)/);if(!r)return undefined;var i=r[2]==="="?1:2,s=["header",{level:i},r[1]];return r[0].length<t.length&&n.unshift(o(t.substr(r[0].length),t.trailing,t.lineNumber+2)),[s]},code:function(t,n){var r=[],i=/^(?: {0,3}\t| {4})(.*)\n?/;if(!t.match(i))return undefined;e:do{var s=this.loop_re_over_block(i,t.valueOf(),function(e){r.push(e[1])});if(s.length){n.unshift(o(s,t.trailing));break e}if(!n.length)break e;if(!n[0].match(i))break e;r.push(t.trailing.replace(/[^\n]/g,"").substring(2)),t=n.shift()}while(!0);return[["code_block",r.join("\n")]]},horizRule:function(t,n){var r=t.match(/^(?:([\s\S]*?)\n)?[ \t]*([-_*])(?:[ \t]*\2){2,}[ \t]*(?:\n([\s\S]*))?$/);if(!r)return undefined;var i=[["hr"]];if(r[1]){var s=o(r[1],"",t.lineNumber);i.unshift.apply(i,this.toTree(s,[]))}return r[3]&&n.unshift(o(r[3],t.trailing,t.lineNumber+1)),i},lists:function(){function i(t){return new RegExp("(?:^("+r+"{0,"+t+"} {0,3})("+e+")\\s+)|"+"(^"+r+"{0,"+(t-1)+"}[ ]{0,4})")}function s(e){return e.replace(/ {0,3}\t/g,"    ")}function u(e,t,n,r){if(t){e.push(["para"].concat(n));return}var i=e[e.length-1]instanceof Array&&e[e.length-1][0]==="para"?e[e.length-1]:e;r&&e.length>1&&n.unshift(r);for(var s=0;s<n.length;s++){var o=n[s],u=typeof o=="string";u&&i.length>1&&typeof i[i.length-1]=="string"?i[i.length-1]+=o:i.push(o)}}function a(e,t){var n=new RegExp("^("+r+"{"+e+"}.*?\\n?)*$"),i=new RegExp("^"+r+"{"+e+"}","gm"),s=[];while(t.length>0){if(!n.exec(t[0]))break;var u=t.shift(),a=u.replace(i,"");s.push(o(a,u.trailing,u.lineNumber))}return s}function f(e,t,n){var r=e.list,i=r[r.length-1];if(i[1]instanceof Array&&i[1][0]==="para")return;if(t+1===n.length)i.push(["para"].concat(i.splice(1,i.length-1)));else{var s=i.pop();i.push(["para"].concat(i.splice(1,i.length-1)),s)}}var e="[*+-]|\\d+\\.",t=/[*+-]/,n=new RegExp("^( {0,3})("+e+")[ 	]+"),r="(?: {0,3}\\t| {4})";return function(e,r){function l(e){var n=t.exec(e[2])?["bulletlist"]:["numberlist"];return c.push({list:n,indent:e[1]}),n}var o=e.match(n);if(!o)return undefined;var c=[],h=l(o),p,v=!1,m=[c[0].list],g;e:for(;;){var y=e.split(/(?=\n)/),b="",w="";for(var E=0;E<y.length;E++){w="";var S=y[E].replace(/^\n/,function(e){return w=e,""}),x=i(c.length);o=S.match(x);if(o[1]!==undefined){b.length&&(u(p,v,this.processInline(b),w),v=!1,b=""),o[1]=s(o[1]);var T=Math.floor(o[1].length/4)+1;if(T>c.length)h=l(o),p.push(h),p=h[1]=["listitem"];else{var N=!1;for(g=0;g<c.length;g++){if(c[g].indent!==o[1])continue;h=c[g].list,c.splice(g+1,c.length-(g+1)),N=!0;break}N||(T++,T<=c.length?(c.splice(T,c.length-T),h=c[T-1].list):(h=l(o),p.push(h))),p=["listitem"],h.push(p)}w=""}S.length>o[0].length&&(b+=w+S.substr(o[0].length))}b.length&&(u(p,v,this.processInline(b),w),v=!1,b="");var C=a(c.length,r);C.length>0&&(d(c,f,this),p.push.apply(p,this.toTree(C,[])));var k=r[0]&&r[0].valueOf()||"";if(k.match(n)||k.match(/^ /)){e=r.shift();var L=this.dialect.block.horizRule(e,r);if(L){m.push.apply(m,L);break}d(c,f,this),v=!0;continue e}break}return m}}(),blockquote:function(t,n){if(!t.match(/^>/m))return undefined;var r=[];if(t[0]!==">"){var i=t.split(/\n/),s=[],u=t.lineNumber;while(i.length&&i[0][0]!==">")s.push(i.shift()),u++;var f=o(s.join("\n"),"\n",t.lineNumber);r.push.apply(r,this.processBlock(f,[])),t=o(i.join("\n"),t.trailing,u)}while(n.length&&n[0][0]===">"){var l=n.shift();t=o(t+t.trailing+l,l.trailing,t.lineNumber)}var c=t.replace(/^> ?/gm,""),h=this.tree,p=this.toTree(c,["blockquote"]),d=a(p);return d&&d.references&&(delete d.references,v(d)&&p.splice(1,1)),r.push(p),r},referenceDefn:function(t,n){var r=/^\s*\[(.*?)\]:\s*(\S+)(?:\s+(?:(['"])(.*?)\3|\((.*?)\)))?\n?/;if(!t.match(r))return undefined;a(this.tree)||this.tree.splice(1,0,{});var i=a(this.tree);i.references===undefined&&(i.references={});var s=this.loop_re_over_block(r,t,function(e){e[2]&&e[2][0]==="<"&&e[2][e[2].length-1]===">"&&(e[2]=e[2].substring(1,e[2].length-1));var t=i.references[e[1].toLowerCase()]={href:e[2]};e[4]!==undefined?t.title=e[4]:e[5]!==undefined&&(t.title=e[5])});return s.length&&n.unshift(o(s,t.trailing)),[]},para:function(t){return[["para"].concat(this.processInline(t))]}},inline:{__oneElement__:function(t,n,r){var i,s;n=n||this.dialect.inline.__patterns__;var o=new RegExp("([\\s\\S]*?)("+(n.source||n)+")");i=o.exec(t);if(!i)return[t.length,t];if(i[1])return[i[1].length,i[1]];var s;return i[2]in this.dialect.inline&&(s=this.dialect.inline[i[2]].call(this,t.substr(i.index),i,r||[])),s=s||[i[2].length,i[2]],s},__call__:function(t,n){function s(e){typeof e=="string"&&typeof r[r.length-1]=="string"?r[r.length-1]+=e:r.push(e)}var r=[],i;while(t.length>0)i=this.dialect.inline.__oneElement__.call(this,t,n,r),t=t.substr(i.shift()),d(i,s);return r},"]":function(){},"}":function(){},__escape__:/^\\[\\`\*_{}\[\]()#\+.!\-]/,"\\":function(t){return this.dialect.inline.__escape__.exec(t)?[2,t.charAt(1)]:[1,"\\"]},"![":function(t){var n=t.match(/^!\[(.*?)\][ \t]*\([ \t]*([^")]*?)(?:[ \t]+(["'])(.*?)\3)?[ \t]*\)/);if(n){n[2]&&n[2][0]==="<"&&n[2][n[2].length-1]===">"&&(n[2]=n[2].substring(1,n[2].length-1)),n[2]=this.dialect.inline.__call__.call(this,n[2],/\\/)[0];var r={alt:n[1],href:n[2]||""};return n[4]!==undefined&&(r.title=n[4]),[n[0].length,["img",r]]}return n=t.match(/^!\[(.*?)\][ \t]*\[(.*?)\]/),n?[n[0].length,["img_ref",{alt:n[1],ref:n[2].toLowerCase(),original:n[0]}]]:[2,"!["]},"[":function E(e){var t=String(e),n=m.call(this,e.substr(1),"]");if(!n)return[1,"["];var r=1+n[0],i=n[1],E,s;e=e.substr(r);var o=e.match(/^\s*\([ \t]*([^"']*)(?:[ \t]+(["'])(.*?)\2)?[ \t]*\)/);if(o){var u=o[1];r+=o[0].length,u&&u[0]==="<"&&u[u.length-1]===">"&&(u=u.substring(1,u.length-1));if(!o[3]){var a=1;for(var f=0;f<u.length;f++)switch(u[f]){case"(":a++;break;case")":--a===0&&(r-=u.length-f,u=u.substring(0,f))}}return u=this.dialect.inline.__call__.call(this,u,/\\/)[0],s={href:u||""},o[3]!==undefined&&(s.title=o[3]),E=["link",s].concat(i),[r,E]}return o=e.match(/^\s*\[(.*?)\]/),o?(r+=o[0].length,s={ref:(o[1]||String(i)).toLowerCase(),original:t.substr(0,r)},E=["link_ref",s].concat(i),[r,E]):i.length===1&&typeof i[0]=="string"?(s={ref:i[0].toLowerCase(),original:t.substr(0,r)},E=["link_ref",s,i[0]],[r,E]):[1,"["]},"<":function(t){var n;return(n=t.match(/^<(?:((https?|ftp|mailto):[^>]+)|(.*?@.*?\.[a-zA-Z]+))>/))!==null?n[3]?[n[0].length,["link",{href:"mailto:"+n[3]},n[3]]]:n[2]==="mailto"?[n[0].length,["link",{href:n[1]},n[1].substr("mailto:".length)]]:[n[0].length,["link",{href:n[1]},n[1]]]:[1,"<"]},"`":function(t){var n=t.match(/(`+)(([\s\S]*?)\1)/);return n&&n[2]?[n[1].length+n[2].length,["inlinecode",n[3]]]:[1,"`"]},"  \n":function(){return[3,["linebreak"]]}}};g.inline["**"]=y("strong","**"),g.inline.__=y("strong","__"),g.inline["*"]=y("em","*"),g.inline._=y("em","_"),s.dialects.Gruber=g,s.buildBlockOrder(s.dialects.Gruber.block),s.buildInlinePatterns(s.dialects.Gruber.inline);var b=p.subclassDialect(g),a=t.extract_attr,d=t.forEach;b.processMetaHash=function(t){var n=w(t),r={};for(var i=0;i<n.length;++i)if(/^#/.test(n[i]))r.id=n[i].substring(1);else if(/^\./.test(n[i]))r["class"]?r["class"]=r["class"]+n[i].replace(/./," "):r["class"]=n[i].substring(1);else if(/\=/.test(n[i])){var s=n[i].split(/\=/);r[s[0]]=s[1]}return r},b.block.document_meta=function(t){if(t.lineNumber>1)return undefined;if(!t.match(/^(?:\w+:.*\n)*\w+:.*$/))return undefined;a(this.tree)||this.tree.splice(1,0,{});var n=t.split(/\n/);for(var r in n){var i=n[r].match(/(\w+):\s*(.*)$/),s=i[1].toLowerCase(),o=i[2];this.tree[1][s]=o}return[]},b.block.block_meta=function(t){var n=t.match(/(^|\n) {0,3}\{:\s*((?:\\\}|[^\}])*)\s*\}$/);if(!n)return undefined;var r=this.dialect.processMetaHash(n[2]),i;if(n[1]===""){var s=this.tree[this.tree.length-1];i=a(s);if(typeof s=="string")return undefined;i||(i={},s.splice(1,0,i));for(var o in r)i[o]=r[o];return[]}var u=t.replace(/\n.*$/,""),f=this.processBlock(u,[]);i=a(f[0]),i||(i={},f[0].splice(1,0,i));for(var o in r)i[o]=r[o];return f},b.block.definition_list=function(t,n){var r=/^((?:[^\s:].*\n)+):\s+([\s\S]+)$/,i=["dl"],s,o;if(!(o=t.match(r)))return undefined;var u=[t];while(n.length&&r.exec(n[0]))u.push(n.shift());for(var a=0;a<u.length;++a){var o=u[a].match(r),f=o[1].replace(/\n$/,"").split(/\n/),l=o[2].split(/\n:\s+/);for(s=0;s<f.length;++s)i.push(["dt",f[s]]);for(s=0;s<l.length;++s)i.push(["dd"].concat(this.processInline(l[s].replace(/(\n)\s+/,"$1"))))}return[i]},b.block.table=function S(e){var t=function(e,t){t=t||"\\s",t.match(/^[\\|\[\]{}?*.+^$]$/)&&(t="\\"+t);var n=[],r=new RegExp("^((?:\\\\.|[^\\\\"+t+"])*)"+t+"(.*)"),i;while(i=e.match(r))n.push(i[1]),e=i[2];return n.push(e),n},n=/^ {0,3}\|(.+)\n {0,3}\|\s*([\-:]+[\-| :]*)\n((?:\s*\|.*(?:\n|$))*)(?=\n|$)/,r=/^ {0,3}(\S(?:\\.|[^\\|])*\|.*)\n {0,3}([\-:]+\s*\|[\-| :]*)\n((?:(?:\\.|[^\\|])*\|.*(?:\n|$))*)(?=\n|$)/,i,s;if(s=e.match(n))s[3]=s[3].replace(/^\s*\|/gm,"");else if(!(s=e.match(r)))return undefined;var S=["table",["thead",["tr"]],["tbody"]];s[2]=s[2].replace(/\|\s*$/,"").split("|");var o=[];d(s[2],function(e){e.match(/^\s*-+:\s*$/)?o.push({align:"right"}):e.match(/^\s*:-+\s*$/)?o.push({align:"left"}):e.match(/^\s*:-+:\s*$/)?o.push({align:"center"}):o.push({})}),s[1]=t(s[1].replace(/\|\s*$/,""),"|");for(i=0;i<s[1].length;i++)S[1][1].push(["th",o[i]||{}].concat(this.processInline(s[1][i].trim())));return d(s[3].replace(/\|\s*$/mg,"").split("\n"),function(e){var n=["tr"];e=t(e,"|");for(i=0;i<e.length;i++)n.push(["td",o[i]||{}].concat(this.processInline(e[i].trim())));S[2].push(n)},this),[S]},b.inline["{:"]=function(t,n,r){if(!r.length)return[2,"{:"];var i=r[r.length-1];if(typeof i=="string")return[2,"{:"];var s=t.match(/^\{:\s*((?:\\\}|[^\}])*)\s*\}/);if(!s)return[2,"{:"];var o=this.dialect.processMetaHash(s[1]),u=a(i);u||(u={},i.splice(1,0,u));for(var f in o)u[f]=o[f];return[s[0].length,""]},s.dialects.Maruku=b,s.dialects.Maruku.inline.__escape__=/^\\[\\`\*_{}\[\]()#\+.!\-|:]/,s.buildBlockOrder(s.dialects.Maruku.block),s.buildInlinePatterns(s.dialects.Maruku.inline),e.Markdown=s,e.parse=s.parse,e.toHTML=s.toHTML,e.toHTMLTree=s.toHTMLTree,e.renderJsonML=s.renderJsonML}(function(){return window.markdown={},window.markdown}()),define("ft/taxonomy/markdown",function(){}),define("ft/extensions/foldingnodes",["require","exports","module","ft/extensions/folding","ft/core/extensions","ft/core/node"],function(e,t,n){function s(e,t){var n=e.tree(),r=t.line().length,i=e.foldsInRange(n.createRangeFromNodes(t,r)),s=i.length,o;for(o=0;o<s;o++){var u=i[o],a=u.range();if(a.startNode===t&&a.startOffset===r)return u}return null}function o(e,t){if(s(this,e)!==null)return!1;if(t){var n=e.firstChild;while(n){if(this.nodeIsHiddenInFold(n))return!1;n=n.nextSibling}}return!0}function u(e,t){return!this.isExpanded(e,t)}function a(e,t){this.expandNodes([e],t)}function f(e,t){var n=this,r=this.tree();this.operation(function(){var r=[],i=e.length,o;for(o=0;o<i;o++){var u=e[o],a=s(n,u);a&&a.clear();var f=u.firstChild,l;while(f)n.nodeIsHiddenInFold(f)&&n.expandToRevealNode(f),r.push(f),f=f.nextSibling;t&&n.expandNodes(r,!0)}})}function l(e){var t=e,n=0,r=e,i=e.line().length,s;e.previousLineNode()&&(t=e.previousLineNode(),n=t.line().length),e.nextLineNode()&&!e.firstChild&&(r=e.nextLineNode(),i=0),this.splitAndRemoveFoldsInRange(this.tree().createRangeFromNodes(t,n,r,i))}function c(e,t,n){return this.collapseNodes([e],t,n)}function h(e,t,n){n||(n=[]);var r=this.tree(),i=this,s=e.length,o,u;return this.operation(function(){for(u=0;u<s;u++){o=e[u];if(o.firstChild){var a=o.lastDescendantOrSelf(),f=r.createRangeFromNodes(o,o.line().length,a,a.line().length);if(t){var l=o.firstChild;while(l)i.collapseNode(l,!0,n),l=l.nextSibling}n.push(i.createFoldInRange(f,!0))}}}),n}function p(e,t){function l(e,i){if(t){while(e.type()==="empty"&&e!==i)e=e.nextLineNode();while(i.type()==="empty"&&i!==e)i=i.previousLineNode()}if(e===i&&e.type()==="empty")return;n.createFoldInRange(r.createRangeFromNodes(e,0,i,-1),!1)}var n=this,r=n.tree(),i=e.length,s,o,u,a,f;n.operation(function(){for(f=0;f<i;f++)a=e[f],!u||a.previousLineNode()===u?(s||(s=a),o=a):s&&(l(s,o),s=undefined,o=undefined),u=a;s&&l(s,o)})}function d(e){var t=e.length,n=e[0],r=n.range().length(),i,s,o;for(o=1;o<t;o++)i=e[o],s=i.range().length(),s>r&&(n=i,r=s);return n}function v(e,t){var n=e.selectedRange(),r=e.foldsInRange(n);if(r.length>0){n.isCollapsed()?e.removeFold(d(r)):e.removeFolds(r);return}var s=i.commonAncestorsForNodes(n.rangeByAdjustingToEffectedNodesInEditor(e).nodesInRange()),o=s.nodesInLineOrder(),u=n.startNode;e.isCollapsed(u)?e.expandNodes(o,t):e.nodeIsHiddenInFold(u)?e.expandToRevealNode(u):u.firstChild?e.collapseNodes(o,t):u.parent.isRoot()||(e.collapseNode(u.parent,t),e.setSelectedRange(e.tree().createRangeFromNodes(u.parent,u.parent.line().length)))}function m(e){var t=e.folds(),n=t.length,r;n?e.removeFolds(t):e.operation(function(){var t=e.tree().root.firstChild;while(t)e.collapseNode(t,!0),t=t.nextSibling})}function g(e){var t=[];return e.forEach(function(e){t.push(e.structureLevel())}),t.sort(),t.sortedUniquify(),t}function y(e){var t=this.tree(),n=this;e||(e=t.root.descendants());if(e instanceof i){var r=e;e=r.descendants(),e.unshift(r)}t.ensureClassified();var s=g(e),o=Number.MAX_VALUE,u;return e.forEach(function(e){n.nodeIsHiddenInFold(e)&&e.structureLevel()<o&&(o=e.structureLevel(),u=e)}),o===Number.MAX_VALUE?s.length:s.indexOf(o)}function b(e,t){var n=this.tree(),r=this;t||(t=n.root.descendants());if(t instanceof i){var s=t;t=s.descendants(),t.unshift(s)}r.operation(function(){var i=n.createRangeFromNodes(t[0],0,t.lastObject(),-1),s=g(t),o=s[e-1],u=s[e];r.removeFolds(r.foldsInRange(i));if(e<0)return;r.collapseNodes(t.filter(function(e){return e.structureLevel()===o}),!1),r.hideNodes(t.filter(function(e){return e.structureLevel()>=u&&!r.nodeIsHiddenInFold(e)}),!0)})}e("ft/extensions/folding");var r=e("ft/core/extensions").Extensions,i=e("ft/core/node").Node;r.addCommand({name:"toggleNodeFold",performCommand:function(e,t){v(e,!1)}}),r.addCommand({name:"toggleNodeFoldNodeAndDescendants",performCommand:function(e,t){v(e,!0)}}),r.addCommand({name:"toggleAllFolds",performCommand:m}),r.addCommand({name:"foldingLevel",performCommand:function(e,t){var n=e.selectedRange(),r=n.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(e),i=r.nodesInRange(),s=e.foldingLevel(i);e.setFoldingLevel(t.interfaceItemTag,i)}}),r.addCommand({name:"expandFoldingLevel",performCommand:function(e,t){var n=e.selectedRange(),r=n.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(e),i=r.nodesInRange(),s=e.foldingLevel(i);e.setFoldingLevel(s+1,i)}}),r.addCommand({name:"contractFoldingLevel",performCommand:function(e,t){var n=e.selectedRange(),r=n.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(e),i=r.nodesInRange(),s=e.foldingLevel(i);s>1&&e.setFoldingLevel(s-1,i)}}),r.addCommand({name:"hideSelection",performCommand:function(e,t){var n=e.selectedRange(),r=n.rangeByAdjustingToEffectedNodesInEditor(e),i=r.nodesInRange();e.hideNodes(i,!1)}}),r.add("com.foldingtext.editor.methods",{foldingLevel:y,setFoldingLevel:b,isExpanded:o,isCollapsed:u,collapseNode:c,collapseNodes:h,hideNodes:p,expandNode:a,expandNodes:f,expandToRevealNode:l})}),define("ft/extensions/nodepath",["require","exports","module","ft/extensions/folding","ft/core/extensions","ft/extensions/foldingnodes","ft/core/nodepath","ft/core/nodeset","ft/core/node","ft/util/dom","ft/util/environment"],function(e,t,n){function l(){return this._nodePath||(this._nodePath=new o(o.SHOW_ALL_PATH,this.tree().taxonomy.types())),this._nodePath}function c(){return this._nodePathMatches||(this._nodePathMatches=this.tree().evaluateNodePath(this._nodePath)),this._nodePathMatches}function h(){return this._nodePathMatchesNodeSet||(this._nodePathMatchesNodeSet=u.setFromArray(this.nodePathMatches())),this._nodePathMatchesNodeSet}function p(){return this._nodePathEditedNodeSet||(this._nodePathEditedNodeSet=new u),this._nodePathEditedNodeSet}function d(e){var t=e.tree(),n=t.firstLineNode(),r=t.lastLineNode(),i=e.nodePathMatches().slice(0),s=i.shift(),o=t.firstLineNode(),u,a,f,l=[];s&&s.isRoot()&&(s=i.shift());while(o)o===s?(u&&(a=o.previousLineNode(),f=t.createRangeFromNodes(u,0,a,a.line().length),l.push(e.createFoldInRange(f,!1)),u=null),s=i.shift()):u||(u=o),o=o.nextLineNode();u&&(a=t.lastLineNode(),f=t.createRangeFromNodes(u,0,a,a.line().length),l.push(e.createFoldInRange(f,!1))),l.forEach(function(t){if(t){var i=t.range();e._nodePathTopBoundaryFold||i.startNode===n&&i.startOffset===0&&(e._nodePathTopBoundaryFold=t,t.setIsBoundary(!0)),e._nodePathBottomBoundaryFold||i.endNode===r&&i.endOffset===i.endNode.line().length&&(e._nodePathBottomBoundaryFold=t,t.setIsBoundary(!0))}})}function v(e){var t=e.tree(),n=e.nodePathMatches(),r=a.ancestorsForNodes(n),i=[t.root],s;while(s=i.pop()){var o=s.firstChild;while(o)r.containsNode(o)?(e.isCollapsed(o),i.push(o)):o.firstChild&&(e.isCollapsed(o)||e.collapseNode(o)[0].setIsManual(!1)),o=o.nextSibling}}function m(e,t){var n=this,r=this._nodePathMatches,s=typeof e=="string"||e instanceof String;s?this._nodePath=new o(e,n.tree().taxonomy.types()):this._nodePath=e,this._nodePathMatches=null,this._nodePathMatchesNodeSet=null,this._nodePathEditedNodeSet=null,this._nodePathTopBoundaryFold=null,this._nodePathBottomBoundaryFold=null,t?n.folds().forEach(function(e){e.isBoundary()&&(e.range().location()===0?n._nodePathTopBoundaryFold=e:n._nodePathBottomBoundaryFold=e)}):n.operation(function(){var e=n.viewport();n.removeFolds(n.folds().filter(function(e){return!e.isManual()})),n.refresh(),n.nodePath().isShowAllPath()||d(n),n.scrollToLine(e.firstVisibleLine,e.firstVisibleLineOffset)}),(n._nodePathTopBoundaryFold||n._nodePathBottomBoundaryFold)&&n.setSelectedRange(n.selectedRange());var u=this;i.processExtensions("com.foldingtext.editor.nodePathDidChange",function(e){e(u)}),n.invalidateRestorableState()}function g(){return this.nodePath().locationPathString()}function y(e){this.nodePath().setLocationPathString(e),this.setNodePath(this.nodePath())}function b(){return this.nodePath().filterStepString()}function w(e){this.nodePath().setFilterStepString(e),this.setNodePath(this.nodePath())}function E(e,t){if(!e.nodePath().isShowAllPath()){var n=t.deltas,r=e.nodePathEditedNodeSet(),i,s;for(s=0;s<n.length;s++)i=n[s],i.textChanged()&&(r.addNodeIgnoringNull(i.updatedNode),r.addNodesFromArray(i.insertedNodes))}}var r=e("ft/extensions/folding"),i=e("ft/core/extensions").Extensions,s=e("ft/extensions/foldingnodes"),o=e("ft/core/nodepath").NodePath,u=e("ft/core/nodeset").NodeSet,a=e("ft/core/node").Node,f=e("ft/util/dom");i.addState({readState:function(e,t){t.nodePath&&t.nodePath!==o.SHOW_ALL_PATH&&(e.tree().ensureClassified(),e.setNodePath(new o(t.nodePath,e.tree().taxonomy.types()),!0))},writeState:function(e,t){t.nodePath=e.nodePath().nodePathString}},i.PriorityLast),i.add("com.foldingtext.editor.methods",{nodePath:l,nodePathMatches:c,nodePathMatchesNodeSet:h,nodePathEditedNodeSet:p,setNodePath:m,nodePathLocation:g,setNodePathLocation:y,nodePathFilter:b,setNodePathFilter:w}),i.addRenderNodeElementStyles(function(e,t,n){e.nodePath().isShowAllPath()||(e.nodePathMatchesNodeSet().containsNode(t)?n.addBackgroundClass("cm-match"):e.nodePathEditedNodeSet().containsNode(t)?n.addBackgroundClass("cm-notMatchEdited"):n.addBackgroundClass("cm-notMatch"))}),i.addTreeChanged(E),i.addCommand({name:"home",performCommand:function(e,t){e.operation(function(){var t=e.viewport();e.removeFolds(e.folds()),e.setNodePath(o.SHOW_ALL_PATH),e.scrollToLine(t.firstVisibleLine,t.firstVisibleLineOffset)})}}),i.addCommand({name:"link node path",description:"Encode the selected node path text as clickable link.",performCommand:function(t,n){var r=t.selectedText(),i=encodeURIComponent(r),s=e("ft/util/environment").applicationName.toLowerCase();t.replaceSelection("[label](x-"+s+"://documents/current?nodepath="+i+")","start"),t.setSelectedRange(t.selectedRange().rangeByOffsetting(1,5))}})}),define("ft/taxonomy/helpers/headingfoldhelper",["require","exports","module","ft/extensions/nodepath","ft/core/extensions"],function(e,t,n){function i(e,t){var n=e.targetsAt(t.clientX,t.clientY),r=n.attributes,i=n.node;return i.type()==="heading"&&r.lead?!0:!1}function s(e,t){if(t.button===2||t.button===0&&t.ctrlKey)return!1;var n=e.targetsAt(t.clientX,t.clientY),r=n.attributes,i=n.lineCh,s=n.node,o=t.metaKey,u;return s.type()==="heading"&&r.lead?(o?e.focusNode(s):e.isCollapsed(s)?e.expandNode(s):e.collapseNode(s),!0):!1}e("ft/extensions/nodepath");var r=e("ft/core/extensions").Extensions;r.add("com.foldingtext.editor.mouse",{mouseDown:i,mouseUp:s})}),define("ft/util/date",["require","exports","module"],function(e,t,n){t.toTimeString=function(t){var n=t.getHours(),r=t.getMinutes(),i=t.getSeconds(),s="";return n>12?(s="PM",n-=12):s="AM",n<10&&(n="0"+n),r<10&&(r="0"+r),i<10&&(i="0"+i),[n,r,i].join(":")+" "+s};var r=function(){var e=/d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,t=/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[\-+]\d{4})?)\b/g,n=/[^\-+\dA-Z]/g,i=function(e,t){e=String(e),t=t||2;while(e.length<t)e="0"+e;return e};return function(s,o,u){var a=r;arguments.length===1&&Object.prototype.toString.call(s)==="[object String]"&&!/\d/.test(s)&&(o=s,s=undefined),s=s?new Date(s):new Date;if(isNaN(s))throw new SyntaxError("invalid date");o=String(a.masks[o]||o||a.masks["default"]),o.slice(0,4)==="UTC:"&&(o=o.slice(4),u=!0);var f=u?"getUTC":"get",l=s[f+"Date"](),c=s[f+"Day"](),h=s[f+"Month"](),p=s[f+"FullYear"](),d=s[f+"Hours"](),v=s[f+"Minutes"](),m=s[f+"Seconds"](),g=s[f+"Milliseconds"](),y=u?0:s.getTimezoneOffset(),b={d:l,dd:i(l),ddd:a.i18n.dayNames[c],dddd:a.i18n.dayNames[c+7],m:h+1,mm:i(h+1),mmm:a.i18n.monthNames[h],mmmm:a.i18n.monthNames[h+12],yy:String(p).slice(2),yyyy:p,h:d%12||12,hh:i(d%12||12),H:d,HH:i(d),M:v,MM:i(v),s:m,ss:i(m),l:i(g,3),L:i(g>99?Math.round(g/10):g),t:d<12?"a":"p",tt:d<12?"am":"pm",T:d<12?"A":"P",TT:d<12?"AM":"PM",Z:u?"UTC":(String(s).match(t)||[""]).pop().replace(n,""),o:(y>0?"-":"+")+i(Math.floor(Math.abs(y)/60)*100+Math.abs(y)%60,4),S:["th","st","nd","rd"][l%10>3?0:(l%100-l%10!==10)*l%10]};return o.replace(e,function(e){return e in b?b[e]:e.slice(1,e.length-1)})}}();r.masks={"default":"ddd mmm dd yyyy HH:MM:ss",shortDate:"m/d/yy",mediumDate:"mmm d, yyyy",longDate:"mmmm d, yyyy",fullDate:"dddd, mmmm d, yyyy",shortTime:"h:MM TT",mediumTime:"h:MM:ss TT",longTime:"h:MM:ss TT Z",isoDate:"yyyy-mm-dd",isoTime:"HH:MM:ss",isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",isoUtcDateTime:"UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"},r.i18n={dayNames:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],monthNames:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec","January","February","March","April","May","June","July","August","September","October","November","December"]},Date.prototype.format=function(e,t){return r(this,e,t)},Date.prototype.formatDifference=function(e){var t=!0,n=!0,r="";e&&this.getMonth()===e.getMonth()&&this.getDate()===e.getDate()&&(t=!1,this.getHours()<12==e.getHours()<12&&(n=!1));var i=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];t&&(r+=i[this.getMonth()]+" "+this.getDate()+", ");var s=this.getHours(),o=s>12?s-12:s===0?12:s,u=this.getMinutes(),a=u<10?"0"+u:""+u;return r+=o+":"+a,n&&(r+=s>=12?" PM":" AM"),r}}),define("ft/modes/todo/todomode",["require","exports","module","ft/core/extensions","codemirror","ft/util/date","ft/core/node"],function(e,t,n){function l(e,t){e&&(a=e),t&&(f=t)}var r=e("ft/core/extensions").Extensions,i=e("codemirror").CodeMirror,s=e("ft/util/date"),o=e("ft/core/node").Node,u=/[\-+*]/,a=function(t){return t.modeContext()==="todo"&&t.type()==="unordered"},f=function(t){return t.createNode("# Archive")};return r.addMode({name:"todo"}),r.addCommand({name:"done",description:"Toggle @done tag for selected lines.",performCommand:function(e,t){var n=t?t.node:null,r=n?n.tree.createRangeFromNodes(n,0):null;e.toggleTag("done",(new Date).format("isoDate"),r)}}),r.addCommand({name:"archive @done",description:"Move @done items to the archive section.",performCommand:function(e,t){var n=e.tree();n.beginUpdates(),n.ensureClassified();var r=n.evaluateNodePath("//@line:text = Archive")[0];r||(r=f(n),n.appendNode(r)),o.commonAncestorsForNodes(n.evaluateNodePath("//@done except //@line:text = Archive//@done")).forEachNodeInSet(function(e){r.insertChildBefore(e,r.firstChild)}),n.endUpdates()}}),r.addRenderNode(function(e,t,n){if(a(t)){var r=u.exec(t.line());if(r){var s=document.createElement("span"),o=document.createElement("input"),f=document.createElement("label"),l=t.id+"-todocheckbox";o.id=l,o.setAttribute("type","checkbox"),o.checked=t.hasTag("done"),f.setAttribute("for",l),i.on(o,"mousedown",function(n){e.performCommand("done",{node:t}),n.preventDefault()}),s.appendChild(o),s.appendChild(f),s.className="cm-checkbox-renderwidget",n.renderInlineWidget(r.index,1,s)}}}),l}),define("ft/modes/clock/clockmode",["require","exports","module","ft/core/nodeset","ft/core/extensions","ft/util/date"],function(e,t,n){function a(e){var t=e.propertyNode("format"),n;return t?n=t.tag("value"):n="shortTime",u.format(n)}var r=e("ft/core/nodeset").NodeSet,i=e("ft/core/extensions").Extensions,s=e("ft/util/date"),o=new r,u=new Date;i.addMode({name:"clock"}),i.addRenderNode(function(e,t,n){if(t.mode()==="clock"){var r=document.createElement("span");r.textContent=a(t),n.renderLineWidget(r,{overlay:!0,positionWidget:function(n,r){var i=t.lineNumber(),s=t.line().match(/\s*/)[0],o=e.cursorCoords({line:i,ch:s.length},"div");return{left:Math.round(o.left-(n+e.defaultSpaceWidth()))+"px"}}})}}),i.add("com.foldingtext.editor.viewportNodesChanged",function(e,t,n,r){o.minusSet(n),r.forEachNodeInSet(function(e){e.mode()==="clock"&&o.addNode(e)})}),i.add("com.foldingtext.editor.clockTick",function(e,t){u=t,o.forEachNodeInSet(function(t){t.mode()!=="clock"?o.removeNode(t):e.setNeedsRender(t)})})}),define("ft/taxonomy/helpers/amounthelper",["require","exports","module"],function(e,t,n){function i(e,t,n){var i=e.escapedText(),s=0,o,u=0;while(o=r.exec(i)){var a=o[0],f=o[1],l=o[2],c=parseFloat(f);e.addAttributeInRange("amount",a,u+o.index,a.length),e.addAttributeInRange("quantity",f,u+o.index,f.length),e.addAttributeInRange("unit",l,u+o.index+a.length-l.length,l.length);switch(l){case"second":case"seconds":case"sec":case"secs":s+=c;break;case"minute":case"minutes":case"min":case"mins":s+=c*60;break;case"hour":case"hours":s+=c*60*60;break;case"day":case"days":s+=c*60*60*24;break;case"week":case"weeks":s+=c*60*60*24*7;break;case"year":case"years":s+=c*60*60*24*360}}return s}var r=/\b(\d+(?:.?\d+)?)\s?((?:second|sec|minute|min|hour|day|week|year)s?)\b/g;return{parseDuration:i,attributesToClear:["amount","quantity","unit"]}}),define("ft/system/notificationcenter",["require","exports","module"],function(e,t,n){var r=function(){};r.deliverNotification=function(t,n,r){if(window.nativeViewController)window.nativeViewController.javascriptDeliverNotification_(JSON.stringify({title:t,subtitle:n,informativeText:r}));else{var i=window.Notification;if(i)if(i.permission==="default")i.requestPermission(function(){});else if(i.permission==="granted"){n=n?n+"\n":"",r=r?r:"";var s=new i(t,{body:n+r})}}},t.NotificationCenter=r}),define("ft/modes/timer/timermode",["require","exports","module","ft/taxonomy/helpers/amounthelper","ft/system/notificationcenter","ft/core/extensions","ft/core/nodeset","ft/util/date","ft/util/dom"],function(e,t,n){function v(e){var t;if(e.mode()==="timer"){t=l[e.id];if(t)return t;var n=e.propertyNode("Start");if(n){var r=Date.parse(n.tag("value"));isNaN(r)===!1&&(t=new Date(r))}t||(t=a[e.id],t||(t=p)),l[e.id]=t}else if(e.modeContext()==="timer"&&e.parent.mode()==="timer"){var i=0,s=e.previousSibling;while(s){var o=s.tag("duration");o&&(i+=o),s=s.previousSibling}t=new Date(v(e.parent).getTime()+i*1e3)}return t}function m(e){var t=e,n;while(t){n=t.tag("duration");if(n){var r=v(t);return new Date(r.getTime()+n*1e3)}t=t.previousSibling}return v(e)}function g(e,t){var n=v(t);if(n){var r=t.tag("duration");if(r){r*=1e3;var i=e.getTime(),s=n.getTime();return i>=s&&i<s+r}}return!1}function y(e,t,n){var r=c[t.id];if(r&&r.parent){if(g(p,r))return;e.setNeedsRender(r)}var s=t.firstChild,o;while(s){if(g(p,s)){o=s,o&&e.setNeedsRender(o);break}s=s.nextSibling}n&&o!==r&&(o?i.deliverNotification(o.text(),t.line()):i.deliverNotification(t.line()+" ended")),c[t.id]=o}function b(e,t){var n=h[t.id],r=t.lastChild;n!==r&&(n&&e.setNeedsRender(n),r&&e.setNeedsRender(r),h[t.id]=r)}function w(e){var t=document.createElement("span");return t.className="cm-"+e+"-renderwidget",t.addEventListener("mousedown",function(e){e.preventDefault()}),t.addEventListener("mouseup",function(e){e.preventDefault();var n=t.ftNode,r=n.parent,i=v(r).getTime(),s=v(n).getTime(),o=s-i,u=new Date(p.getTime()-o);r.setPropertyNodeValue("Start",u.format("mmm d, yyyy h:MM:ss TT"))}),t}var r=e("ft/taxonomy/helpers/amounthelper"),i=e("ft/system/notificationcenter").NotificationCenter,s=e("ft/core/extensions").Extensions,o=e("ft/core/nodeset").NodeSet,u=e("ft/util/date"),a={},f=e("ft/util/dom"),l={},c={},h={},p=new Date,d=new o;s.addMode({name:"timer"}),s.addInit(function(e){d=o.setFromArray(e.tree().evaluateNodePath("//@mode = timer"))}),s.add("com.foldingtext.taxonomy.classifier",{classify:function(e,t,n){switch(t.type){case"empty":case"codeblock":case"fencedcode":return}var i=t.modeStack;if(!i)return;var s=i.lastObject();if(!s||s.mode!=="timer")return;var o=r.parseDuration(e,t,n);o&&(t.tags.duration=o)},attributesToClear:[].concat(r.attributesToClear)}),s.add("com.foldingtext.editor.clockTick",function(e,t){p=t,d.forEachNodeInSet(function(t){t.mode()!=="timer"?d.removeNode(t):y(e,t,!0)})}),s.addTreeChanged(function(e,t){var n=t.deltas,r=new o;for(var i=0;i<n.length;i++){var s=n[i].insertedNodes,u=n[i].removedNodes,f=n[i].updatedNode,c,h,p,v;h=u.length;for(v=0;v<h;v++){p=u[v];if(d.containsNode(p))d.removeNode(p);else{var m=t.previousParent(p);if(m&&m.mode()==="timer"){c=m.firstChild;while(c)e.setNeedsRender(c),c=c.nextSibling;r.addNode(m)}}}h=s.length;for(v=0;v<h;v++){p=s[v];if(p.mode()==="timer")d.addNode(p);else if(p.modeContext()==="timer"){c=p.nextSibling;while(c)e.setNeedsRender(c),c=c.nextSibling;r.addNode(p.parent)}}if(f)if(f.mode()==="timer"){d.addNode(f);var g=f.firstChild;while(g)e.setNeedsRender(g),g=g.nextSibling}else if(f.modeContext()==="timer"){c=f.nextSibling;while(c)e.setNeedsRender(c),c=c.nextSibling;r.addNode(f.parent)}}r.count>0&&r.forEachNodeInSet(function(t){t.mode()==="timer"&&(a[t.id]=l[t.id],l[t.id]=undefined,y(e,t,!1),b(e,t,!1))})}),s.addRenderNode(function(e,t,n){if(t.modeContext()==="timer"){var r=t.tag("duration"),i;if(r){var s=v(t);if(s){var o=t.previousSibling?v(t.previousSibling):v(t.parent);i=w("timerstartdate"),i.textContent=s.formatDifference(o),i.ftNode=t,n.renderLineWidget(i,{overlay:!0,positionWidget:function(n,r){var i=t.lineNumber(),s=t.line().match(/\s*/)[0],o=e.cursorCoords({line:i,ch:s.length},"div");return{left:Math.round(o.left-(n+e.defaultSpaceWidth()))+"px"}}})}}if(h[t.parent.id]===t){var u=t,a;while(u&&!u.tag("duration"))u=u.previousSibling;u||(u=t.parent),a=u.line().match(/\s*/)[0];var f=m(t),l=v(t.parent);p>f?(i=w("timerendedfinishline"),i.textContent="Ended: "+f.formatDifference(l)):(i=w("timerfinishline"),i.textContent="Ends: "+f.formatDifference(l)),n.renderLineWidget(i,{showIfHidden:!1,handleMouseEvents:!0,positionWidget:function(t,n){return{marginLeft:Math.round(e.charCoords({line:u.lineNumber(),ch:a.length},"local").left)+"px"}}})}}}),s.addRenderNodeElementStyles(function(e,t,n){c[t.parent.id]===t&&n.addWrapClass("cm-timercurrentstep")})}),define("components/text/text!apps/foldingtext.less",[],function(){return'////////////////////////////////\n// Varriables\n////////////////////////////////\n\n@fontFamily: "TheSansMono Office", "Menlo";\n@fontSize: 0.95rem;\n@paperColor: mix(white, black, 97%);\n@textColor: mix(@paperColor, @inkColor, 20%);\n\n// nice blue\n//@deskColor: #9fd5df;\n//@paperColor: #d9eef2;\n\n////////////////////////////////\n// Inlines\n////////////////////////////////\n\n.cm-amount {\n	font-style: italic;\n}\n\n.cm-mode {\n	font-style: italic;\n}\n\n////////////////////////////////\n// Properties\n////////////////////////////////\n\n.cm-propertyname {\n	font-style: italic;\n}\n\n.cm-propertyvalue {\n}\n\n////////////////////////////////\n// Modes\n////////////////////////////////\n\n@import (less) "./ft/modes/clock/clock.less";\n@import (less) "./ft/modes/timer/timer.less";\n@import (less) "./ft/modes/todo/todo.less";'}),define("ft/extensions/undo",["require","exports","module","ft/core/extensions"],function(e,t,n){var r=e("ft/core/extensions").Extensions;r.addCommand({name:"undo",validate:function(e,t){return e.cm().doc.getHistory().done.length>0},performCommand:function(e){e.cm().undo()}}),r.addCommand({name:"undoSelection",validate:function(e,t){return e.cm().doc.getHistory().done.length>0},performCommand:function(e){e.cm().undoSelection()}}),r.addCommand({name:"redo",validate:function(e,t){return e.cm().doc.getHistory().undone.length>0},performCommand:function(e){e.cm().redo()}}),r.addCommand({name:"redoSelection",validate:function(e,t){return e.cm().doc.getHistory().undone.length>0},performCommand:function(e){e.cm().redoSelection()}}),r.addCommand({name:"clearUndoHistory",performCommand:function(e){return e.cm().clearHistory()}})}),define("ft/extensions/mouse",["require","exports","module","ft/extensions/nodepath","codemirror","ft/core/extensions"],function(e,t,n){function s(e,t){var n=e.targetsAt(t.clientX,t.clientY).attributes;return n.linklabel||n.linktarget||n.tagname||n.tagvalue?!0:!1}function o(e,t){function a(e){while(o){var t=o.type();if(t==="linkdefinition"||t==="footnotelinkdefinition")if(o.lineAttributedString().findAttributeValue("linkid")===e)return o;o=o.nextLineNode()}return null}function f(e){var t=a(e);if(t){var n=t.lineAttributedString().findAttributeValue("linktarget");if(n)return n;t=t.nextLineNode();while(t){type=t.type();if(type==="linkdefinitionurl")return t.lineAttributedString().findAttributeValue("linktarget");if(type==="empty")continue;return null}}return null}if(t.button===2||t.button===0&&t.ctrlKey)return!1;var n=e.targetsAt(t.clientX,t.clientY),i=n.attributes,s=n.lineCh,o=n.node,u,l=!1;r.mac?l=t.metaKey:l=t.ctrlKey;if(i.linktarget)return u=i.linktarget,i=o.lineAttributesAtIndex(s.ch),i.referencelink?e.openLink(f(u),l):e.openLink(u,l),!0;if(i.linklabel){var c=i.linklabel;u=o.lineAttributedString().findAttributeValue("linktarget",s.ch),i=o.lineAttributesAtIndex(s.ch);if(i.referencelink){if(!u||!u.trim())u=c;return e.openLink(f(u),l),!0}if(i.footnotelink){u=c;var h=a(u);return h&&e.scrollRangeToVisible(e.tree().createRangeFromNodes(h,0)),!0}if(i.inlinelink)return e.openLink(u,l),!0}else{if(i.tagname)return e.setNodePathFilter("@"+i.tagname),!0;if(i.tagvalue){var p=i.tagvalue,d=n.lineCh.ch,v={};o=n.node;while(d>=0){i=o.lineAttributesAtIndex(d,v);if(i.tagname)return e.setNodePathFilter("@"+i.tagname+' = "'+p+'"'),!0;d=v.location-1}return!0}}return!1}e("ft/extensions/nodepath");var r=e("codemirror").CodeMirror,i=e("ft/core/extensions").Extensions;i.add("com.foldingtext.editor.mouse",{mouseDown:s,mouseUp:o})}),define("ft/extensions/moveparagraph",["require","exports","module","ft/extensions/folding","ft/extensions/foldingnodes","ft/core/extensions","ft/extensions/selection"],function(e,t,n){function s(e,t){var n=e.selectedRange(),r=n.rangeByAdjustingToEffectedNodesInEditor(e),s=r.nodesInRange(),o=s.length,u=e.tree(),a=e.cm(),f;if(t==="right"){i.performNodeOperationWhileMaintainingEditorStateInRange(e,n,r,function(){u.beginUpdates();for(f=0;f<o;f++)s[f].replaceLineInRange("	",0,0);u.endUpdates()});return}if(t==="left"){i.performNodeOperationWhileMaintainingEditorStateInRange(e,n,r,function(){u.beginUpdates();for(f=0;f<o;f++){var e=s[f];e.line()[0]==="	"&&s[f].replaceLineInRange("",0,1)}u.endUpdates()});return}var l;if(t==="up"){l=s[0].previousLineNode();if(!l)return;if(e.nodeIsHiddenInFold(l)){while(l&&e.nodeIsHiddenInFold(l))l=l.previousLineNode();l&&!e.isCollapsed(l)&&(l=l.nextLineNode())}l||(l=u.firstLineNode())}if(t==="down"){var c=s[s.length-1].nextLineNode();if(!c)return;l=c.nextLineNode();if(e.isCollapsed(c)||e.nodeIsHiddenInFold(c))while(l&&e.nodeIsHiddenInFold(l))l=l.nextLineNode()}i.performNodeOperationWhileMaintainingEditorStateInRange(e,n,r,function(){u.beginUpdates(),u.removeNodes(s),u.insertNodesBefore(s,l),u.endUpdates()})}function o(e){var t=e.tree(),n=e.selectedRange(),r=n.rangeByAdjustingToEffectedNodesInEditor(e),i=r.nodesInRange();if(!n.isCollapsed()){e.replaceSelection("");return}i.length===t.nodeCount()?t.setText(""):t.removeNodes(r.nodesInRange())}e("ft/extensions/folding"),e("ft/extensions/foldingnodes");var r=e("ft/core/extensions").Extensions,i=e("ft/extensions/selection");r.addCommand({name:"moveParagraphsUp",performCommand:function(e){s(e,"up")}}),r.addCommand({name:"moveParagraphsDown",performCommand:function(e){s(e,"down")}}),r.addCommand({name:"moveParagraphsRight",performCommand:function(e){s(e,"right")}}),r.addCommand({name:"moveParagraphsLeft",performCommand:function(e){s(e,"left")}}),r.addCommand({name:"deleteParagraphs",performCommand:o})}),define("ft/extensions/indent",["require","exports","module","ft/extensions/moveparagraph","ft/core/extensions","ft/extensions/folding"],function(e,t,n){function s(e){var t=e.tree(),n=e.selectedRange(),r=n.isCollapsed(),i=n.startNode,s=i.tree.taxonomy.matchLeadForNode(i)[0];if(e.performCommand("replaceTextSnippet"))return;!r||n.startOffset<=s.length?e.performCommand("moveParagraphsRight"):e.replaceSelection("	","end","+input")}e("ft/extensions/moveparagraph");var r=e("ft/core/extensions").Extensions,i=e("ft/extensions/folding");r.addCommand({name:"smartInsertTab",performCommand:s})}),define("ft/extensions/current",["require","exports","module","ft/core/extensions","ft/extensions/selection","ft/util/objectutils"],function(e,t,n){function o(e){var t=s.arrayOfKeys(e.attributes);return t.length===1&&t[0]==="text"||t.length===0?!1:!0}function u(e,t,n,i,s){var o=t+"Text",u=t+"Offset",a=e[t],f=e[o],l=e[u],c=n&&!n.isCollapsed(),h=c?n.startLineCh():null,p=c?n.endLineCh():null,d=c?n.textInRange():null,v=c?n.startOffset:null;if(!a&&!n)return;if(a){if(c){var m=a.find();if(m){var g=m.from,y=m.to;if(g.line===h.line&&g.ch===h.ch&&y.line===p.line&&y.ch===p.ch&&f===d&&l===v)return}}a.clear(),e[t]=null,e[o]=null,e[u]=null}c&&(e[t]=e.cm().markText(h,p,{className:i}),e[o]=d,e[u]=v),s&&r.processExtensions(s,function(t){t(e,n)})}function a(e){var t=e.tree(),n=e.selectedRange(),r=n.headNode(),i=n.headOffset(),s=t.createRangeFromNodes(r,i),a=r.lineAttributedString(),f=a.attributeRangeCalculatedByFunction(i,o),l=null,c=null;(!f||f.length===0)&&i>0&&(f=a.attributeRangeCalculatedByFunction(i-1,o));var h=null;f&&f.length>0&&(h=t.createRangeFromNodes(r,f.location,r,f.location+f.length)),u(e,"_currentSyntaxMark",h,"cm-currentsyntax",null),l=s.rangeByExtendingToWord(),c=s.rangeByExtendingToSentence(),u(e,"_currentWordMark",l,"cm-currentword","com.foldingtext.editor.currentWordDidChange"),u(e,"_currentSentenceMark",c,"cm-currentsentence","com.foldingtext.editor.currentSentenceDidChange")}function f(e,t){var n=e.targetsAt(t.clientX,t.clientY),r=n.attributes,i=n.lineCh,s=n.node,o}var r=e("ft/core/extensions").Extensions,i=e("ft/extensions/selection"),s=e("ft/util/objectutils");r.add("com.foldingtext.editor.willEndOperation",function(e){e.operation(function(){a(e)})}),r.add("com.foldingtext.editor.mouseover",function(e,t){}),r.add("com.foldingtext.editor.methods",{currentWordRange:function(){var e=this._currentWordMark;if(e){var t=e.find();if(t)return this.tree().createRangeFromLineChs(t.from,t.to)}return null},currentSentenceRange:function(){var e=this._currentSentenceMark;if(e){var t=e.find();if(t)return this.tree().createRangeFromLineChs(t.from,t.to)}return null}})}),define("ft/extensions/complete",["require","exports","module","codemirror","ft/core/extensions","ft/util/dom"],function(e,t,n){function u(e,t){e.replaceSelection(t.substring(e._completePrefixLength),"around")}var r=e("codemirror").CodeMirror,i=e("ft/core/extensions").Extensions,s=e("ft/util/dom"),o=function(t,n,i){var s=document.createElement("ul");s.className="completionPopup",this.isOpen=!1,this._popupElement=s,this._completions=n,this._delegate=i,this._isUpdating=!1;var o=n.length;for(var u=0;u<o;u++){var a=document.createElement("li");a.textContent=n[u],s.appendChild(a)}s.style.top="0px",s.style.left="-1000px";var f=this;r.on(s,"mousedown",function(e){var n=Array.prototype.indexOf.call(s.childNodes,e.target);return n>=0&&f.updateSelectedIndex(n),window.setTimeout(function(){t.focus()},0),!0}),r.on(s,"dblclick",function(e){return f.close(!1,!1),window.setTimeout(function(){t.focus()},0),!0}),document.body.appendChild(s)};(function(){this.open=function(t,n){var r=t.cursorCoords(n,"local"),i=this._popupElement,s=this._delegate,o=i.offsetHeight,u=this;t.scrollRectToVisible({top:r.top,left:0,right:0,bottom:r.bottom+o}),window.setTimeout(function(){var e=t.cursorCoords(n,"page"),r=e.bottom,o=e.left;i.style.top=r+"px",i.style.left=o+"px",s.willOpen(u),u.updateSelectedIndex(0),window.setTimeout(function(){u.isOpen=!0},0)},0)},this.selectedText=function(){return this._completions[this._selectedIndex]},this.selectUp=function(){var t=this._selectedIndex;t>0&&this.updateSelectedIndex(t-1)},this.selectDown=function(){var t=this._selectedIndex;t<this._completions.length-1&&this.updateSelectedIndex(t+1)},this.updateSelectedIndex=function(t){var n=this._selectedIndex,r=this._popupElement.children;if(n!==t){var i=r[n],o=r[t];i&&s.removeClass(i,"selected"),o&&(s.addClass(o,"selected"),o.scrollIntoViewIfNeeded()),this._selectedIndex=t,this._isUpdating=!0,this._delegate.updateChoice(this),this._isUpdating=!1}},this.isUpdating=function(){return this._isUpdating},this.close=function(t,n){if(this._closing)return;this._closing=!0;var r=this._popupElement,i=r.parentElement;i&&i.removeChild(r),this._isUpdating=!0,this._delegate.didClose(this,t,n),this._isUpdating=!1}}).call(o.prototype),i.add("com.foldingtext.editor.methods",{complete:function(){var e=this,t=e.prefixWordRangeForComplete(),n=t.length();if(e._completePopup){e._completePopup.close();return}if(n===0){e.beep();return}e._completePrefixLength=n;var r=e.completionsForPrefixWordRange(t);if(!r||r.length===0){e.beep();return}var i=new o(e,r,{willOpen:function(t){e._completePopup=t,e._completeSavedUndoHistory=e.cm().getHistory(),e._completeOriginalSelection=e.selectedRange().textInRange()},updateChoice:function(t){u(e,t.selectedText())},didClose:function(t,n,r){e.replaceSelection(e._completeOriginalSelection),e.cm().setHistory(e._completeSavedUndoHistory),n||(u(e,t.selectedText()),r?e.performCommand("moveLeft"):e.performCommand("moveRight")),e.removeKeyMap("completePopup"),e._completeSavedUndoHistory=null,e._completeOriginalSelection=null,e._completePopup=null}});i.open(e,t.startLineCh()),e.addKeyMap({name:"completePopup",Up:function(e){e._completePopup.selectUp()},Down:function(e){e._completePopup.selectDown()},Left:function(e){e._completePopup.close(!1,!0)},Right:function(e){e._completePopup.close(!1,!1)},Enter:function(e){e._completePopup.close(!1,!1)},Esc:function(e){e._completePopup.close(!0)},Backspace:function(e){e._completePopup.close(!0)},Delete:function(e){e._completePopup.close(!0)},F5:function(e){e._completePopup.close(!0)}})},prefixWordRangeForComplete:function(){var e=this,t=e.tree(),n=e.selectedRange(),r=n.location(),s=n.rangeByExtendingToWord(),o=s.location(),u=t.createRangeFromLocation(o,r-o);return u=i.processExtensions("com.foldingtext.editor.prefixWordRangeForComplete",function(e){return e(u)},!0),u},completionsForPrefixWordRange:function(e){var t=i.processExtensions("com.foldingtext.editor.completionsForPrefixWordRange",function(t){return t(e)},!0);if(t===null){if(window.nativeViewController){var n=e.startNode.line(),r=e.startOffset,s=e.endOffset-r;return window.nativeViewController.javascriptCompletionsForPartialWordStart_length_inString_(r,s,n)}return["testing","one","two","three"]}return t}}),i.add("com.foldingtext.editor.beforeChange",function(e,t){e._completePopup&&!e._completePopup.isUpdating()&&e._completePopup.close()}),i.add("com.foldingtext.editor.mouse",{mouseDown:function(e,t){e._completePopup&&e._completePopup.close()}}),i.add("com.foldingtext.editor.viewportDidScroll",function(e){e._completePopup&&e._completePopup.isOpen&&e._completePopup.close()}),i.add("com.foldingtext.editor.willPerformCommand",function(e){e._completePopup&&e._completePopup.close()})}),define("ft/extensions/movebranch",["require","exports","module","ft/extensions/folding","ft/extensions/foldingnodes","ft/core/extensions","ft/extensions/selection","ft/core/node"],function(e,t,n){function o(e,t){e.tree().ensureClassified();var n=e.selectedRange(),r=s.commonAncestorsForNodes(n.rangeByAdjustingToEffectedNodesInEditor(e).nodesInRange()).nodesInLineOrder(),o=r[0],u=r.lastObject(),a=u.lastDescendantOrSelf(),f=e.tree(),l=null,c=null;if(t==="up"){c=o.parent,l=o.previousSibling;if(!l)return}else if(t==="down"){c=u.parent,l=u.nextSibling;if(!l){var h=a.nextLineNode();h&&h.type()==="empty"&&(f.beginUpdates(),f.insertNodeBefore(h,o),f.endUpdates());return}l=l.nextSibling}else if(t==="left")c=o.parent.parent,l=o.parent.nextSibling;else if(t==="right"){var p=o.previousLineNode();while(p&&p.type()==="empty")r.unshift(p),p=p.previousLineNode();o=r[0],c=o.previousSibling}if(!c)return;var d=!0;r.forEach(function(e){c.validateInsertChildBefore(e,l)||(d=!1)});if(!d)return;var v=f.createRangeFromNodes(o,0,a,a.line().length);i.performNodeOperationWhileMaintainingEditorStateInRange(e,n,v,function(){c.insertChildrenBefore(r,l)})}function u(e){o(e,"left")}function a(e){o(e,"right")}function f(e){o(e,"up")}function l(e){o(e,"down")}function c(e){var t=e.selectedRange(),n=t.startNode;if(n.firstChild){var r=e.tree(),s=n.children(),o=s.lastObject().lastDescendantOrSelf(),u=r.createRangeFromNodes(s[0],0,o,o.line().length);i.performNodeOperationWhileMaintainingEditorStateInRange(e,t,u,function(){n.parent.insertChildrenBefore(s,n.nextSibling)})}}function h(e){var t=e.selectedRange(),n=t.startNode,r=n.nextSibling,s=[];while(r)s.push(r),r=r.nextSibling;if(s.length){var o=e.tree(),u=s.lastObject().lastDescendantOrSelf(),a=o.createRangeFromNodes(s[0],0,u,u.line().length);i.performNodeOperationWhileMaintainingEditorStateInRange(e,t,a,function(){n.insertChildrenBefore(s,null)})}}function p(e){var t=e.tree(),n=e.selectedRange(),r=s.commonAncestorsForNodes(n.rangeByAdjustingToEffectedNodesInEditor(e).nodesInRange()).nodesInLineOrder();if(!n.isCollapsed()){e.replaceSelection("");return}t.firstLineNode()===r[0]&&t.lastLineNode()===r[r.length-1].lastDescendantOrSelf()?t.setText(""):(t.beginUpdates(),r.forEach(function(e){e.removeFromParent()}),t.endUpdates())}e("ft/extensions/folding"),e("ft/extensions/foldingnodes");var r=e("ft/core/extensions").Extensions,i=e("ft/extensions/selection"),s=e("ft/core/node").Node;r.addCommand({name:"moveBranchesUp",performCommand:f}),r.addCommand({name:"moveBranchesDown",performCommand:l}),r.addCommand({name:"moveBranchesLeft",performCommand:u}),r.addCommand({name:"moveBranchesRight",performCommand:a}),r.addCommand({name:"promoteChildBranches",performCommand:c}),r.addCommand({name:"demoteTrailingSiblingBranches",performCommand:h}),r.addCommand({name:"deleteBranches",performCommand:p})}),define("ft/extensions/smartnewline",["require","exports","module","ft/extensions/indent","ft/extensions/folding","ft/extensions/foldingnodes","ft/editor/commands","ft/core/extensions"],function(e,t,n){function i(e){var t=e.tree(),n=e.selectedRange(),r=n.startNode,i=r.tree.taxonomy.matchLeadForNode(r),s=i[0],o="",u=!0;if(n.isCollapsed()){if(s.length!==0&&n.startOffset===s.length&&s===r.line()){e.operation(function(){e.setSelectedRange(t.createRangeFromNodes(r,0,r,r.line().length)),e.replaceSelection("","end","+input"),e.scrollRangeToVisible(e.selectedRange())});return}var a=e.tree().nodeToLineNumber(r),f;if(e.lineIsHiddenInFold(a)){while(a>0&&e.lineIsHiddenInFold(a))a--;f=t.lineNumberToNode(a)}else{if(n.startOffset<=i[0].length){n.startOffset=0,n.endOffset=0,e.operation(function(){e.replaceTextInRange(n,"\n","+input"),e.scrollRangeToVisible(e.selectedRange())});return}e.operation(function(){e.expandToRevealNode(r),e.expandNode(r),e.setSelectedRange(n)}),r.firstChild?(f=r.firstChild,u=!1):f=r}o=f.tree.taxonomy.nextLeadFromNode(f,u)}e.operation(function(){e.replaceSelection("\n"+o,"end","+input"),e.scrollRangeToVisible(e.selectedRange())})}e("ft/extensions/indent"),e("ft/extensions/folding"),e("ft/extensions/foldingnodes"),e("ft/editor/commands");var r=e("ft/core/extensions").Extensions;r.addCommand({name:"smartInsertNewline",performCommand:i}),r.addCommand({name:"smartInsertNewlineAbove",performCommand:function(e){e.performCommand("moveToBeginningOfParagraph"),e.performCommand("smartInsertNewline"),e.performCommand("moveLeft")}}),r.addCommand({name:"smartInsertNewlineAfter",performCommand:function(e){e.performCommand("moveToEndOfParagraph"),e.performCommand("smartInsertNewline")}})}),define("ft/extensions/snippets",["require","exports","module","ft/util/string","ft/core/extensions"],function(e,t,n){function s(e,t){for(var n in t)if(e.endsWith(n)){var r=e[e.length-(n.length+1)],s=n[0];if(r&&i.test(r)&&i.test(s))return;return{shortcut:n,expansion:t[n]}}}e("ft/util/string");var r=e("ft/core/extensions").Extensions,i=/\w/;r.addCommand({name:"replaceTextSnippet",performCommand:function(e){var t=e.selectedRange();if(t.isCollapsed()){var n=t.startNode,i=n.line(),o=t.startOffset,u=o;while(u>0&&i[u-1]!==" ")u--;var a=e.tree(),f=a.createRangeFromNodes(n,u,n,o),l=f.textInRange();if(l){var c=r.processExtensions("com.foldingtext.editor.snippets",function(e){return s(l,e)},!0);c||window.nativeViewController&&(c=s(l,JSON.parse(window.nativeViewController.javascriptUserReplacementsDictionary())));if(c){var h=c.shortcut,p=c.expansion;return typeof p=="function"&&(p=p(h)),e.replaceTextInRange(t.rangeByOffsetting(-h.length,h.length),p),!0}}}return!1}})}),define("components/text/text!ft/extensions/print.html.template",[],function(){return'<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">\n<html>\n	<head>\n		<meta charset="utf-8">\n		<style type="text/css">\n			STYLE\n		</style>\n	</head>\n	<body>\n		BODY\n	</body>\n</html>'}),define("ft/extensions/print",["require","exports","module","components/text/text!./print.html.template","ft/core/extensions","ft/editor/theme","ft/util/dom"],function(e,t,n){function u(e){var t=e.option("viewportMargin"),n=e.option("padBottom"),i=e.tree(),o,u;i.ensureClassified(),o=s.readCSS(),e.cm().setOption("viewportMargin",Infinity),e.setOption("padBottom",!1),u=e.cm().getWrapperElement().outerHTML,e.cm().setOption("viewportMargin",t),e.setOption("padBottom",n);var a=r;return a=a.replace("STYLE",o),a=a.replace("BODY",u),a}var r=e("components/text/text!./print.html.template"),i=e("ft/core/extensions").Extensions,s=e("ft/editor/theme"),o=e("ft/util/dom");i.addInit(function(e){window.getHTMLForPrint=function(){return u(e)}})}),define("ft/extensions/focus",["require","exports","module","ft/extensions/folding","ft/extensions/nodepath","codemirror","ft/core/extensions","ft/core/nodepath","ft/core/range"],function(e,t,n){function u(e){var t=this,n=t.tree(),r=e.location(),i=r+e.length(),s=n.createRangeFromLocation(0,r),o=n.createRangeFromLocation(i,n.textLength()-i);t.operation(function(){t.removeFolds(t.folds()),t.createFoldInRange(s,!1),t.createFoldInRange(o,!1)})}function a(e){e.firstChild||e.type()==="heading"?(this.setNodePath(s.calculateMinNodePath(e,!0)),this.scrollToTop()):(e=e.parent,e.isRoot()?this.setNodePath(null):this.setNodePath(s.calculateMinNodePath(e,!0)))}function f(e){var t=e.selectedRange().rangeByAdjustingToEffectedNodesInEditor(e);t.startNode===t.endNode?e.focusNode(t.startNode):(t=t.rangeByExtendingToParagraph(),t.location()>0&&(t=t.rangeByOffsetting(-1,1)),e.focusRange(t))}function l(e){var t=e.nodePath();if(t.isShowAllPath()){var n=e.viewport();e.removeFolds(e.folds()),e.scrollToLine(n.firstVisibleLine,n.firstVisibleLineOffset)}else e.setNodePath(s.SHOW_ALL_PATH)}e("ft/extensions/folding"),e("ft/extensions/nodepath");var r=e("codemirror").CodeMirror,i=e("ft/core/extensions").Extensions,s=e("ft/core/nodepath").NodePath,o=e("ft/core/range").Range;i.addCommand({name:"focusIn",performCommand:f}),i.addCommand({name:"focusOut",validate:function(e){return!e.nodePath().isShowAllPath()||e.folds().length>0},performCommand:l}),i.add("com.foldingtext.editor.willEndOperation",function(e){window.setTimeout(function(){e._editorTopFold&&(!e.nodePath().isShowAllPath()||e.folds().length>0?e._editorTopFold.style.display="":e._editorTopFold.style.display="none")},0)}),i.addInit(function(e){var t=e.wrapperElement(),n=document.createElement("div");n.className="cm-editorTopFold",n.style.display="none",n.title="Focus Out",e._editorTopFold=n,r.on(n,"mousedown",function(t){e.performCommand("focusOut"),t.preventDefault()}),t.appendChild(n)}),i.add("com.foldingtext.editor.methods",{focusRange:u,focusNode:a})}),define("ft/extensions/dragdrop",["require","exports","module","ft/core/extensions"],function(e,t,n){var r=e("ft/core/extensions").Extensions;r.addInit(function(e){function i(){t.parentNode||r.display.lineSpace.appendChild(t)}function s(){t.parentNode&&t.parentNode.removeChild(t)}var t=document.createElement("div"),n,r=e.cm();t.className="CodeMirror-dropIndicator",r.on("dragstart",function(e,t){t.dataTransfer.effectAllowed="copyMove",n=[],e.operation(function(){e.listSelections().forEach(function(t){n.push(e.markText(t.anchor,t.head))})})}),r.on("dragend",function(e,t){e.operation(function(){n.forEach(function(n){if(t.dataTransfer.dropEffect==="move"){var r=n.find();r&&e.replaceRange("",r.from,r.to,"+paste")}n.clear()}),n=undefined})}),r.on("dragenter",function(e,t){i(t)}),r.on("dragover",function(n,r){var o=e.targetsAt(r.clientX,r.clientY).lineCh,u=e.cursorCoords(o,"div");n.state.draggingText&&n.doc.sel.contains(o)>-1?(r.dataTransfer.dropEffect="none",s(r)):(t.style.left=u.left+"px",t.style.top=u.top+"px",t.style.height=Math.max(0,u.bottom-u.top)*n.options.cursorHeight+"px",i(r))}),r.on("dragleave",function(e,t){s(t)}),r.on("drop",function(e,t){s(t)})})}),define("ft/extensions/cutcopypaste",["require","exports","module","ft/core/extensions","ft/core/tree"],function(e,t,n){function s(e){this.copy(e),this.replaceSelections("","end","cut")}function o(e){var t=this.selectedRanges(),n=[],r=[];for(var i=0;i<t.length;i++){var s=t[i],o=s.textInRange(),u=this.foldsInRange(s),a=this.foldsToJSON(u);this.normalizeFoldsJSON(a,s.startLineCh()),r.push(o),n.push({text:o,folds:a})}e.setData("text/plain",r.join("\n")),e.setData("com.foldingtext.FoldingText",JSON.stringify(n))}function u(e){var t=this.selectedRanges(),n=e.getData("text/plain"),r=e.getData("com.foldingtext.FoldingText");if(r){var s=JSON.parse(r),o=s.length,u={line:0,ch:0},a,f,l,c;if(s.length!==t.length){var h=[],p=[];for(c=0;c<o;c++)a=s[c],l=i.stringByNormalizingLineEndings(a.text).split("\n"),f=a.folds,h=h.concat(l),this.perpareNormalizedFoldsJSONForDestination(f,u),p=p.concat(f),u.line+=l.length;s=[];for(c=0;c<t.length;c++)s.push({text:h.join("\n"),folds:JSON.parse(JSON.stringify(p))})}u.line=0,u.ch=0;var d=[],v=[];for(c=0;c<s.length;c++){var m=t[c],g=m.startLineCh(),y=s[c],b=i.stringByNormalizingLineEndings(y.text).split("\n"),w=y.folds;g.line+=u.line,w=this.perpareNormalizedFoldsJSONForDestination(w,g),v.push(y.text),d=d.concat(w),u.line+=b.length-1}this.replaceSelections(v,"end","paste"),this.restoreJSONFolds(d)}else n!==null&&this.replaceSelections(i.stringByNormalizingLineEndings(n).split("\n"),"end","paste")}var r=e("ft/core/extensions").Extensions,i=e("ft/core/tree").Tree;r.add("com.foldingtext.editor.methods",{cut:s,copy:o,paste:u}),r.addInit(function(e){var t=e.cm();t.on("cut",function(t,n){n.preventDefault(),e.cut(n.clipboardData)}),t.on("copy",function(t,n){n.preventDefault(),e.copy(n.clipboardData)}),t.on("paste",function(t,n){n.preventDefault(),e.paste(n.clipboardData)})})}),define("ft/extensions/textchecking",["require","exports","module","ft/extensions/current","ft/core/extensions","ft/core/taxonomy","ft/core/nodeset"],function(e,t,n){function b(e){switch(e){case o:return"language";case u:return"spelling";case a:return"grammar";case f:return"date";case l:return"address";case c:return"smartlink";case h:return"quote";case p:return"dash";case d:return"replacement";case v:return"correction";case m:return"expression";case g:return"phonenumber";case y:return"transitinformation"}}function w(e,t){function o(){window.nativeViewController&&window.nativeViewController.javascriptUpdateSpellingPanelWithMisspelledWord_(e.selectedText())}var n=e.textContent(),r=e.cursorRange(),i=E(n,r.location()+r.length(),!0),s=i?e.tree().createRangeFromString(i):null;s?(e.removeFolds(e.foldsInRange(s)),e.setSelectedRange(s),o(e.selectedText())):(o(e.selectedText()),e.beep())}function E(e,t,n){if(window.nativeViewController){var r=window.nativeViewController.javascriptCheckSpellingOfString_startingAt_wrap_(e,t,n);return r}return null}e("ft/extensions/current");var r=e("ft/core/extensions").Extensions,i=e("ft/core/taxonomy").Taxonomy,s=e("ft/core/nodeset").NodeSet,o=1,u=2,a=4,f=8,l=16,c=32,h=64,p=128,d=256,v=512,m=1024,g=2048,y=4096;r.addInit(function(e){e._textCheckingNodes=s.setFromArray(e.viewportRange().nodesInRange()),e._textCheckingPendingNodes=new s,window.handleTextCheckingResults=function(t,n,r){e.handleTextCheckingResults(t,n,r)},window.selectionHasSpellingError=function(){var t=e.selectedRange(),n=t.length();if(n===0)return!1;if(t.startNode!==t.endNode)return!1;var r={},i={};return t.startNode.lineAttributeAtIndex("spelling",t.startOffset,r,i)&&i.location===t.startOffset&&i.length===n?!0:!1}}),r.add("com.foldingtext.editor.viewportNodesChanged",function(e,t,n,r){n.forEachNodeInSet(function(t){e.endTextChecking(t)}),r.forEachNodeInSet(function(t){e.beginTextChecking(t)})}),r.addTreeChanged(function(e,t){if(e._isApplyingTextCheckingChanges)return;var n=t.deltas,r=n.length,i=e._textCheckingNodes,s,o;for(o=0;o<r;o++){s=n[o];if(!s.textChanged())continue;var u=s.updatedNode,a;if(u)if(u===e._textCheckingCurrentNode){var f={},l={},c=u.lineAttributeAtIndex("spelling",s.fromLineCh.ch,f,l);if(c){var h=l.location,p=l.length,d=u.lineInRange(h,p);if(c!==d){var v=/(\s*)(\S+)(\s*)/,m=d.match(v),g=m[1],y=m[2],b=m[3];c!==y?u.removeLineAttributeInRange("spelling",h,p):(g&&u.removeLineAttributeInRange("spelling",h,g.length),b&&u.removeLineAttributeInRange("spelling",h+g.length+y.length,b.length))}}e._textCheckingPendingNodes.addNode(u)}else i.containsNode(u)&&e.scheduleCheckTextInNode(u)}}),r.add("com.foldingtext.editor.currentWordDidChange",function(e,t){var n=e._textCheckingCurrentNode,r=t?t.startNode:undefined,i=!1;if(r!==n)e._textCheckingCurrentNode=r,e.scheduleCheckPendingNodes();else{var s=e._textCheckingCurrentWordStart,o=e._textCheckingCurrentWordEditedText,u=t?t.startOffset:undefined,a=t?t.textInRange():undefined;u!==s?(e._textCheckingCurrentWordStart=u,e._textCheckingCurrentWordEditedText=undefined,e.scheduleCheckPendingNodes()):a!==o&&(e._textCheckingCurrentWordEditedText=a,t&&r.removeLineAttributesInRange(e._textCheckingAttributes,t.startOffset,a.length))}}),r.add("com.foldingtext.editor.methods",{beginTextChecking:function(e){this._textCheckingNodes.addNode(e),this.scheduleCheckTextInNode(e)},scheduleCheckPendingNodes:function(){var e=this._textCheckingNodes,t=this._textCheckingPendingNodes,n=this;t.forEachNodeInSet(function(t){e.containsNode(t)&&n.scheduleCheckTextInNode(t)}),t.removeAllNodes()},scheduleCheckTextInNode:function(e){if(this._textCheckingTypes===0)return;if(window.nativeViewController)window.nativeViewController.javascriptScheduleCheckNodeString_nodeID_string_(this._textCheckingTypes,e.id,e.line());else{var t=this,n=e.id,r=e.line();window.setTimeout(function(){var e=r.indexOf("teh"),i=[];e!==-1?i=[u,"",e,3]:(e=r.indexOf("Затеивать"),e!==-1&&(i=[u,"",e,9])),t.handleTextCheckingResults(n,r,JSON.stringify(i))},100)}},handleTextCheckingResults:function(e,t,n){var r=this._textCheckingNodes.nodeForID(e);if(r){var i=JSON.parse(n),s=i.length,o=this.tree(),u;if(r.line()!==t){this.scheduleCheckTextInNode(r);return}this._isApplyingTextCheckingChanges=!0,o.beginUpdates(),r.removeLineAttributesInRange(this._textCheckingAttributes,0,r.line().length);for(u=0;u<s;u+=4){var a=i[u],f=i[u+1],l=i[u+2],c=i[u+3];f||(f=r.lineInRange(l,c));if(r===this._textCheckingCurrentNode){var h=l+c,p=this._textCheckingCurrentWordStart,d=this._textCheckingCurrentWordEditedText;if(l===p&&!!d&&d===this._textCheckingCurrentWordEditedText){this._textCheckingPendingNodes.addNode(r);continue}}r.addLineAttributeInRange(b(a),f,l,c)}o.endUpdates(),this._isApplyingTextCheckingChanges=!1}},endTextChecking:function(e){e.removeLineAttributesInRange(this._textCheckingAttributes,0,e.line().length),this._textCheckingNodes.removeNode(e)},textCheckingTypes:function(){return this._textCheckingTypes},redoTextChecking:function(){var e=this.tree(),t=this;e.beginUpdates(),this._textCheckingNodes.forEachNodeInSet(function(e){t.scheduleCheckTextInNode(e)}),e.endUpdates()},setTextCheckingTypes:function(e){if(this._textCheckingTypes!==e){var t=this.tree(),n=this._textCheckingAttributes,r=[],i=this;this._textCheckingTypes=e,this._textCheckingAttributes=r,e&o&&r.push("language"),e&u&&r.push("spelling"),e&a&&r.push("grammar"),e&f&&r.push("date"),e&l&&r.push("address"),e&c&&r.push("smartlink"),e&h&&r.push("quote"),e&p&&r.push("dash"),e&d&&r.push("replacement"),e&v&&r.push("correction"),e&m&&r.push("expression"),e&g&&r.push("phonenumber"),e&y&&r.push("transitinformation"),this.initialized&&(t.beginUpdates(),this._textCheckingNodes.forEachNodeInSet(function(e){e.removeLineAttributesInRange(n,0,e.line().length)}),this.redoTextChecking(),t.endUpdates())}}}),r.add("com.foldingtext.editor.options",{name:"continuousSpellChecking",defaultValue:!0,onChange:function(e,t,n){n?e.setTextCheckingTypes(e.textCheckingTypes()|u):e.setTextCheckingTypes(e.textCheckingTypes()&~u),e.invalidateRestorableState()}}),r.addCommand({name:"toggleContinuousSpellChecking",validate:function(e,t){return t.interfaceItemState=e.option("continuousSpellChecking"),!0},performCommand:function(e){e.setOption("continuousSpellChecking",!e.option("continuousSpellChecking"))}}),r.addCommand({name:"checkSpelling",performCommand:w}),r.addCommand({name:"redoTextChecking",performCommand:function(e){e.redoTextChecking()}})}),define("ft/extensions/localstorage",["require","exports","module","ft/core/extensions","ft/util/environment","ft/util/delay","ft/extensions/undo"],function(e,t,n){function u(e){e.autosaveDelay.clear(),e.autosaveDelay.set(1e3,function(){a(e)})}function a(e,t){e.isClean()||(window.localStorage.setItem("text",e.getValue()),e.markClean(),window._gaq&&window._gaq.push(["_trackEvent","localStorage","saveText"])),t&&(window.localStorage.setItem("state",e.getOption("ftEditor").restorableStateJSON()),window._gaq&&window._gaq.push(["_trackEvent","localStorage","saveState"]))}function f(){try{return"localStorage"in window&&window.localStorage!==null}catch(e){return!1}}function l(e){window.onbeforeunload=function(){return a(e.cm(),!0),null};var t=window.localStorage.getItem("text"),n=window.localStorage.getItem("state"),r=e.cm();t&&(e.setTextContent(t),e.performCommand("clearUndoHistory")),n&&e.setRestorableStateJSON(n),r.autosaveDelay=new s,r.on("change",u)}function c(e){var t=e.cm();t.autosaveDelay&&t.autosaveDelay.clear(),t.off("change",u)}var r=e("ft/core/extensions").Extensions,i=e("ft/util/environment"),s=e("ft/util/delay").Delay,o=e("ft/extensions/undo");r.addInit(function(e){i.disableLocalStorage||(f()?window.setTimeout(function(){l(e)},0):window.onbeforeunload=function(){return"Local storage is not supported in your browser. You must copy and paste you text to some other place to save it."})})}),define("apps/app",["require","exports","module","ft/extensions/undo","ft/extensions/mouse","ft/extensions/indent","ft/extensions/current","ft/extensions/complete","ft/extensions/movebranch","ft/extensions/moveparagraph","ft/extensions/smartnewline","ft/extensions/folding","ft/extensions/snippets","ft/extensions/print","ft/extensions/focus","ft/extensions/foldingnodes","ft/extensions/selection","ft/extensions/dragdrop","ft/extensions/cutcopypaste","ft/extensions/textchecking","ft/extensions/formatting","ft/extensions/localstorage","ft/editor/theme","ft/util/date","ft/core/extensions","ft/util/queryparameter","ft/util/environment","ft/editor/editor"],function(e,t,n){function f(t,n){a||(e("ft/util/environment").disableLocalStorage=!0),r.loadLESS(t.styles(),n,function(){var n="",i=r.readNumberStyleVariable("@tabSize",4),s=e("ft/editor/editor").Editor,u={tabIndex:1,autofocus:!0,lineNumbers:!1,lineWrapping:!0,indentWithTabs:!0,flattenSpans:!0,tabSize:i,indentUnit:i,enableCompositionMod:!0,viewportMargin:5,historyEventDelay:1250,undoDepth:Infinity,moveInputWithCursor:!1,mode:null,theme:"",value:""},a=JSON.parse(o("options","{}"));for(var f in a)u[f]=a[f];new s(n,t,u)}),s.addInit(function(e){e.addKeyMap({name:"smartNewLine",Enter:"smartInsertNewline",Tab:"smartInsertTab","Shift-Cmd-Enter":"smartInsertNewlineAbove","Cmd-Enter":"smartInsertNewlineAfter"}),a&&e.addKeyMap({name:"webbindings","Cmd-Z":"undo","Shift-Cmd-Z":"redo","Cmd-A":"selectAll","Shift-Tab":"moveParagraphsLeft",Tab:"smartInsertTab","Cmd-[":"moveParagraphsLeft","Cmd-]":"moveParagraphsRight","Cmd-Alt-[":"moveParagraphsUp","Cmd-Alt-]":"moveParagraphsDown","Ctrl-Alt-Left":"moveBranchesLeft","Ctrl-Alt-Right":"moveBranchesRight","Ctrl-Alt-Up":"moveBranchesUp","Ctrl-Alt-Down":"moveBranchesDown","Cmd-Alt-Up":"expandSelection","Cmd-Alt-Down":"contractSelection","Cmd-B":"toggleBold","Cmd-I":"toggleItalic","Cmd-L":"formatUnorderedList","Shift-Cmd-L":"formatOrderedList","Cmd-/":"toggleNodeFold","Cmd-Alt-/":"toggleNodeFoldNodeAndDescendants","Cmd-Alt-1":function(e){e.performCommand("foldingLevel",{interfaceItemTag:1})},"Cmd-Alt-2":function(e){e.performCommand("foldingLevel",{interfaceItemTag:2})},"Cmd-Alt-3":function(e){e.performCommand("foldingLevel",{interfaceItemTag:3})},"Cmd-Alt-4":function(e){e.performCommand("foldingLevel",{interfaceItemTag:4})},"Cmd-U":"focusIn","Cmd-Alt-Right":"expandFoldingLevel","Cmd-Alt-Left":"contractFoldingLevel","Shift-Cmd-A":"home"})})}e("ft/extensions/undo"),e("ft/extensions/mouse"),e("ft/extensions/indent"),e("ft/extensions/current"),e("ft/extensions/complete"),e("ft/extensions/movebranch"),e("ft/extensions/moveparagraph"),e("ft/extensions/smartnewline"),e("ft/extensions/folding"),e("ft/extensions/snippets"),e("ft/extensions/print"),e("ft/extensions/focus"),e("ft/extensions/foldingnodes"),e("ft/extensions/selection"),e("ft/extensions/dragdrop"),e("ft/extensions/cutcopypaste"),e("ft/extensions/textchecking"),e("ft/extensions/formatting"),e("ft/extensions/localstorage");var r=e("ft/editor/theme"),i=e("ft/util/date"),s=e("ft/core/extensions").Extensions,o=e("ft/util/queryparameter").QueryParameter,u=o("pluginPaths","").split(":"),a=!window.nativeViewController;return{app:function(t,n){e(u,function(){f(t,n)},function(e){window.nativeViewController&&window.nativeViewController.javascriptReportPluginError_(JSON.stringify({line:e.line,message:e.message,sourceURL:e.sourceURL})),console.log("Error requiring plugin paths",e),f(t,n)})}}}),define("apps/foldingtextmain",["require","exports","module","ft/util/environment","ft/extensions/wordcount","ft/extensions/typewriter","ft/extensions/showlistbullets","ft/taxonomy/markdown","ft/taxonomy/markdowntaxonomy","ft/taxonomy/helpers/headingfoldhelper","ft/extensions/showlistbullets","ft/modes/todo/todomode","ft/modes/clock/clockmode","ft/modes/timer/timermode","components/text/text!./foldingtext.less","ft/core/extensions","ft/core/taxonomies","./app"],function(e,t,n){e("ft/util/environment").applicationName="FoldingText",e("ft/extensions/wordcount"),e("ft/extensions/typewriter"),e("ft/extensions/showlistbullets"),e("ft/taxonomy/markdown"),e("ft/taxonomy/markdowntaxonomy"),e("ft/taxonomy/helpers/headingfoldhelper"),e("ft/extensions/showlistbullets")(function(e){return e.type()==="unordered"&&e.modeContext()!=="todo"}),e("ft/modes/todo/todomode"),e("ft/modes/clock/clockmode"),e("ft/modes/timer/timermode");var r=e("components/text/text!./foldingtext.less"),i=e("ft/core/extensions").Extensions,s=e("ft/core/taxonomies"),o=s.taxonomy({foldingtext:!0,multimarkdown:!0,gitmarkdown:!0,criticMarkup:!0},"markdown");e("./app").app(o,r)});